/* DUPLICATOR-LITE (PHP BUILD MODE) MYSQL SCRIPT CREATED ON : 2020-04-03 10:11:25 */

/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;

SET FOREIGN_KEY_CHECKS = 0;

CREATE TABLE `wp_commentmeta` (
  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `comment_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8mb4_unicode_520_ci,
  PRIMARY KEY (`meta_id`),
  KEY `comment_id` (`comment_id`),
  KEY `meta_key` (`meta_key`(191))
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_comments` (
  `comment_ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `comment_post_ID` bigint(20) unsigned NOT NULL DEFAULT '0',
  `comment_author` tinytext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `comment_author_email` varchar(100) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `comment_author_url` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `comment_author_IP` varchar(100) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `comment_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `comment_date_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `comment_content` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `comment_karma` int(11) NOT NULL DEFAULT '0',
  `comment_approved` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '1',
  `comment_agent` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `comment_type` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `comment_parent` bigint(20) unsigned NOT NULL DEFAULT '0',
  `user_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`comment_ID`),
  KEY `comment_post_ID` (`comment_post_ID`),
  KEY `comment_approved_date_gmt` (`comment_approved`,`comment_date_gmt`),
  KEY `comment_date_gmt` (`comment_date_gmt`),
  KEY `comment_parent` (`comment_parent`),
  KEY `comment_author_email` (`comment_author_email`(10))
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_duplicator_packages` (
  `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(250) NOT NULL,
  `hash` varchar(50) NOT NULL,
  `status` int(11) NOT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `owner` varchar(60) NOT NULL,
  `package` longtext NOT NULL,
  PRIMARY KEY (`id`),
  KEY `hash` (`hash`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=latin1;

CREATE TABLE `wp_et_social_stats` (
  `id` mediumint(9) NOT NULL AUTO_INCREMENT,
  `sharing_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `network` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `action` varchar(10) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `post_id` bigint(20) NOT NULL,
  `ip_address` varchar(45) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `media_url` varchar(2083) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `location` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  UNIQUE KEY `id` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_links` (
  `link_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `link_url` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `link_name` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `link_image` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `link_target` varchar(25) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `link_description` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `link_visible` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'Y',
  `link_owner` bigint(20) unsigned NOT NULL DEFAULT '1',
  `link_rating` int(11) NOT NULL DEFAULT '0',
  `link_updated` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `link_rel` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `link_notes` mediumtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `link_rss` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  PRIMARY KEY (`link_id`),
  KEY `link_visible` (`link_visible`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_options` (
  `option_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `option_name` varchar(191) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `option_value` longtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `autoload` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'yes',
  PRIMARY KEY (`option_id`),
  UNIQUE KEY `option_name` (`option_name`),
  KEY `autoload` (`autoload`)
) ENGINE=InnoDB AUTO_INCREMENT=1438 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_postmeta` (
  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `post_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8mb4_unicode_520_ci,
  PRIMARY KEY (`meta_id`),
  KEY `post_id` (`post_id`),
  KEY `meta_key` (`meta_key`(191))
) ENGINE=InnoDB AUTO_INCREMENT=3497 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_posts` (
  `ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `post_author` bigint(20) unsigned NOT NULL DEFAULT '0',
  `post_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_date_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_content` longtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `post_title` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `post_excerpt` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `post_status` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'publish',
  `comment_status` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'open',
  `ping_status` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'open',
  `post_password` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `post_name` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `to_ping` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `pinged` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `post_modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_modified_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_content_filtered` longtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `post_parent` bigint(20) unsigned NOT NULL DEFAULT '0',
  `guid` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `menu_order` int(11) NOT NULL DEFAULT '0',
  `post_type` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'post',
  `post_mime_type` varchar(100) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `comment_count` bigint(20) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`),
  KEY `post_name` (`post_name`(191)),
  KEY `type_status_date` (`post_type`,`post_status`,`post_date`,`ID`),
  KEY `post_parent` (`post_parent`),
  KEY `post_author` (`post_author`)
) ENGINE=InnoDB AUTO_INCREMENT=2995 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_term_relationships` (
  `object_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `term_taxonomy_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `term_order` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`object_id`,`term_taxonomy_id`),
  KEY `term_taxonomy_id` (`term_taxonomy_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_term_taxonomy` (
  `term_taxonomy_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `term_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `taxonomy` varchar(32) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `description` longtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `parent` bigint(20) unsigned NOT NULL DEFAULT '0',
  `count` bigint(20) NOT NULL DEFAULT '0',
  PRIMARY KEY (`term_taxonomy_id`),
  UNIQUE KEY `term_id_taxonomy` (`term_id`,`taxonomy`),
  KEY `taxonomy` (`taxonomy`)
) ENGINE=InnoDB AUTO_INCREMENT=10 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_termmeta` (
  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `term_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8mb4_unicode_520_ci,
  PRIMARY KEY (`meta_id`),
  KEY `term_id` (`term_id`),
  KEY `meta_key` (`meta_key`(191))
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_terms` (
  `term_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `slug` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `term_group` bigint(10) NOT NULL DEFAULT '0',
  PRIMARY KEY (`term_id`),
  KEY `slug` (`slug`(191)),
  KEY `name` (`name`(191))
) ENGINE=InnoDB AUTO_INCREMENT=10 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_tm_taskmeta` (
  `meta_id` bigint(20) NOT NULL AUTO_INCREMENT,
  `task_id` bigint(20) NOT NULL DEFAULT '0',
  `meta_key` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8mb4_unicode_520_ci,
  PRIMARY KEY (`meta_id`),
  KEY `meta_key` (`meta_key`(191)),
  KEY `task_id` (`task_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_tm_tasks` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` bigint(20) NOT NULL,
  `type` varchar(300) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `class_identifier` varchar(300) COLLATE utf8mb4_unicode_520_ci DEFAULT '0',
  `attempts` int(11) DEFAULT '0',
  `description` varchar(300) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `time_created` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `last_locked_at` bigint(20) DEFAULT '0',
  `status` varchar(300) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `user_id` (`user_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_usermeta` (
  `umeta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8mb4_unicode_520_ci,
  PRIMARY KEY (`umeta_id`),
  KEY `user_id` (`user_id`),
  KEY `meta_key` (`meta_key`(191))
) ENGINE=InnoDB AUTO_INCREMENT=27 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_users` (
  `ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `user_login` varchar(60) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `user_pass` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `user_nicename` varchar(50) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `user_email` varchar(100) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `user_url` varchar(100) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `user_registered` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `user_activation_key` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `user_status` int(11) NOT NULL DEFAULT '0',
  `display_name` varchar(250) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  PRIMARY KEY (`ID`),
  KEY `user_login_key` (`user_login`),
  KEY `user_nicename` (`user_nicename`),
  KEY `user_email` (`user_email`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;


/* INSERT TABLE DATA: wp_comments */
INSERT INTO `wp_comments` VALUES("2", "8", "یک نویسندهٔ دیدگاه در وردپرس", "wapuu@wordpress.example", "https://wordpress.org/", "", "2020-02-24 18:54:38", "2020-02-24 15:24:38", "سلام، این یک دیدگاه است.\nبرای شروع مدیریت، ویرایش و پاک کردن دیدگاه‌ها، لطفا بخش دیدگاه‌ها در پیشخوان را ببینید.\nتصاویر نویسندگان دیدگاه از <a href=\"https://gravatar.com\" rel=\"nofollow ugc\">Gravatar</a> گرفته می‌شود.", "0", "1", "", "", "0", "0");

/* INSERT TABLE DATA: wp_duplicator_packages */
INSERT INTO `wp_duplicator_packages` VALUES("2", "internet_modelsite", "3c46d65490e8f5566271_20200403101106", "21", "2020-04-03 10:11:24", "unknown", "O:11:\"DUP_Package\":25:{s:7:\"Created\";s:19:\"2020-04-03 10:11:06\";s:7:\"Version\";s:6:\"1.3.28\";s:9:\"VersionWP\";s:5:\"5.3.2\";s:9:\"VersionDB\";s:6:\"5.7.24\";s:10:\"VersionPHP\";s:6:\"7.2.19\";s:9:\"VersionOS\";s:5:\"WINNT\";s:2:\"ID\";i:2;s:4:\"Name\";s:18:\"internet_modelsite\";s:4:\"Hash\";s:35:\"3c46d65490e8f5566271_20200403101106\";s:8:\"NameHash\";s:54:\"internet_modelsite_3c46d65490e8f5566271_20200403101106\";s:4:\"Type\";i:0;s:5:\"Notes\";s:0:\"\";s:9:\"StorePath\";s:41:\"C:/laragon/www/modelsite/wp-snapshots/tmp\";s:8:\"StoreURL\";s:35:\"http://modelsite.test/wp-snapshots/\";s:8:\"ScanFile\";s:64:\"internet_modelsite_3c46d65490e8f5566271_20200403101106_scan.json\";s:10:\"TimerStart\";i:-1;s:7:\"Runtime\";N;s:7:\"ExeSize\";N;s:7:\"ZipSize\";N;s:6:\"Status\";s:4:\"21.3\";s:6:\"WPUser\";s:7:\"unknown\";s:7:\"Archive\";O:11:\"DUP_Archive\":21:{s:10:\"FilterDirs\";s:0:\"\";s:11:\"FilterFiles\";s:0:\"\";s:10:\"FilterExts\";s:0:\"\";s:13:\"FilterDirsAll\";a:0:{}s:14:\"FilterFilesAll\";a:0:{}s:13:\"FilterExtsAll\";a:0:{}s:8:\"FilterOn\";i:0;s:12:\"ExportOnlyDB\";i:0;s:4:\"File\";s:66:\"internet_modelsite_3c46d65490e8f5566271_20200403101106_archive.zip\";s:6:\"Format\";s:3:\"ZIP\";s:7:\"PackDir\";s:24:\"C:/laragon/www/modelsite\";s:4:\"Size\";i:0;s:4:\"Dirs\";a:0:{}s:5:\"Files\";a:0:{}s:10:\"FilterInfo\";O:23:\"DUP_Archive_Filter_Info\":8:{s:4:\"Dirs\";O:34:\"DUP_Archive_Filter_Scope_Directory\":5:{s:7:\"Warning\";a:0:{}s:10:\"Unreadable\";a:0:{}s:4:\"Core\";a:0:{}s:6:\"Global\";a:0:{}s:8:\"Instance\";a:0:{}}s:5:\"Files\";O:29:\"DUP_Archive_Filter_Scope_File\":6:{s:4:\"Size\";a:0:{}s:7:\"Warning\";a:0:{}s:10:\"Unreadable\";a:0:{}s:4:\"Core\";a:0:{}s:6:\"Global\";a:0:{}s:8:\"Instance\";a:0:{}}s:4:\"Exts\";O:29:\"DUP_Archive_Filter_Scope_Base\":3:{s:4:\"Core\";a:0:{}s:6:\"Global\";a:0:{}s:8:\"Instance\";a:0:{}}s:9:\"UDirCount\";i:0;s:10:\"UFileCount\";i:0;s:9:\"UExtCount\";i:0;s:8:\"TreeSize\";a:0:{}s:11:\"TreeWarning\";a:0:{}}s:14:\"RecursiveLinks\";a:0:{}s:10:\"file_count\";i:-1;s:10:\"\0*\0Package\";O:11:\"DUP_Package\":25:{s:7:\"Created\";s:19:\"2020-04-03 10:11:06\";s:7:\"Version\";s:6:\"1.3.28\";s:9:\"VersionWP\";s:5:\"5.3.2\";s:9:\"VersionDB\";s:6:\"5.7.24\";s:10:\"VersionPHP\";s:6:\"7.2.19\";s:9:\"VersionOS\";s:5:\"WINNT\";s:2:\"ID\";N;s:4:\"Name\";s:18:\"internet_modelsite\";s:4:\"Hash\";s:35:\"3c46d65490e8f5566271_20200403101106\";s:8:\"NameHash\";s:54:\"internet_modelsite_3c46d65490e8f5566271_20200403101106\";s:4:\"Type\";i:0;s:5:\"Notes\";s:0:\"\";s:9:\"StorePath\";s:41:\"C:/laragon/www/modelsite/wp-snapshots/tmp\";s:8:\"StoreURL\";s:35:\"http://modelsite.test/wp-snapshots/\";s:8:\"ScanFile\";N;s:10:\"TimerStart\";i:-1;s:7:\"Runtime\";N;s:7:\"ExeSize\";N;s:7:\"ZipSize\";N;s:6:\"Status\";i:0;s:6:\"WPUser\";N;s:7:\"Archive\";r:23;s:9:\"Installer\";O:13:\"DUP_Installer\":11:{s:4:\"File\";s:68:\"internet_modelsite_3c46d65490e8f5566271_20200403101106_installer.php\";s:4:\"Size\";i:0;s:10:\"OptsDBHost\";s:0:\"\";s:10:\"OptsDBPort\";s:0:\"\";s:10:\"OptsDBName\";s:0:\"\";s:10:\"OptsDBUser\";s:0:\"\";s:12:\"OptsSecureOn\";i:0;s:14:\"OptsSecurePass\";s:0:\"\";s:13:\"numFilesAdded\";i:0;s:12:\"numDirsAdded\";i:0;s:10:\"\0*\0Package\";r:63;}s:8:\"Database\";O:12:\"DUP_Database\":15:{s:4:\"Type\";s:5:\"MySQL\";s:4:\"Size\";N;s:4:\"File\";s:67:\"internet_modelsite_3c46d65490e8f5566271_20200403101106_database.sql\";s:4:\"Path\";N;s:12:\"FilterTables\";s:0:\"\";s:8:\"FilterOn\";i:0;s:4:\"Name\";N;s:10:\"Compatible\";s:0:\"\";s:8:\"Comments\";s:28:\"MySQL Community Server (GPL)\";s:4:\"info\";O:16:\"DUP_DatabaseInfo\":15:{s:9:\"buildMode\";N;s:13:\"collationList\";a:0:{}s:17:\"isTablesUpperCase\";N;s:15:\"isNameUpperCase\";N;s:4:\"name\";N;s:15:\"tablesBaseCount\";N;s:16:\"tablesFinalCount\";N;s:14:\"tablesRowCount\";N;s:16:\"tablesSizeOnDisk\";N;s:18:\"varLowerCaseTables\";i:1;s:7:\"version\";N;s:14:\"versionComment\";N;s:18:\"tableWiseRowCounts\";a:1:{s:14:\"wp_commentmeta\";s:1:\"0\";}s:33:\"\0DUP_DatabaseInfo\0intFieldsStruct\";a:0:{}s:42:\"\0DUP_DatabaseInfo\0indexProcessedSchemaSize\";a:0:{}}s:10:\"\0*\0Package\";r:1;s:25:\"\0DUP_Database\0dbStorePath\";s:109:\"C:/laragon/www/modelsite/wp-snapshots/tmp/internet_modelsite_3c46d65490e8f5566271_20200403101106_database.sql\";s:23:\"\0DUP_Database\0EOFMarker\";s:0:\"\";s:26:\"\0DUP_Database\0networkFlush\";b:0;s:19:\"sameNameTableExists\";b:0;}s:13:\"BuildProgress\";O:18:\"DUP_Build_Progress\":12:{s:17:\"thread_start_time\";N;s:11:\"initialized\";b:0;s:15:\"installer_built\";b:0;s:15:\"archive_started\";b:0;s:20:\"archive_has_database\";b:0;s:13:\"archive_built\";b:0;s:21:\"database_script_built\";b:0;s:6:\"failed\";b:0;s:7:\"retries\";i:0;s:14:\"build_failures\";a:0:{}s:19:\"validation_failures\";a:0:{}s:27:\"\0DUP_Build_Progress\0package\";r:63;}}s:29:\"\0DUP_Archive\0tmpFilterDirsAll\";a:0:{}s:24:\"\0DUP_Archive\0wpCorePaths\";a:5:{i:0;s:33:\"C:/laragon/www/modelsite/wp-admin\";i:1;s:43:\"C:/laragon/www/modelsite/wp-content/uploads\";i:2;s:45:\"C:/laragon/www/modelsite/wp-content/languages\";i:3;s:42:\"C:/laragon/www/modelsite/wp-content/themes\";i:4;s:36:\"C:/laragon/www/modelsite/wp-includes\";}s:29:\"\0DUP_Archive\0wpCoreExactPaths\";a:2:{i:0;s:24:\"C:/laragon/www/modelsite\";i:1;s:35:\"C:/laragon/www/modelsite/wp-content\";}}s:9:\"Installer\";r:86;s:8:\"Database\";r:98;s:13:\"BuildProgress\";r:130;}");

/* INSERT TABLE DATA: wp_options */
INSERT INTO `wp_options` VALUES("1", "siteurl", "http://modelsite.test", "yes");
INSERT INTO `wp_options` VALUES("2", "home", "http://modelsite.test", "yes");
INSERT INTO `wp_options` VALUES("3", "blogname", "مدل سایت", "yes");
INSERT INTO `wp_options` VALUES("4", "blogdescription", "یک سایت دیگر با وردپرس فارسی", "yes");
INSERT INTO `wp_options` VALUES("5", "users_can_register", "0", "yes");
INSERT INTO `wp_options` VALUES("6", "admin_email", "motekef@gmail.com", "yes");
INSERT INTO `wp_options` VALUES("7", "start_of_week", "6", "yes");
INSERT INTO `wp_options` VALUES("8", "use_balanceTags", "0", "yes");
INSERT INTO `wp_options` VALUES("9", "use_smilies", "1", "yes");
INSERT INTO `wp_options` VALUES("10", "require_name_email", "1", "yes");
INSERT INTO `wp_options` VALUES("11", "comments_notify", "1", "yes");
INSERT INTO `wp_options` VALUES("12", "posts_per_rss", "10", "yes");
INSERT INTO `wp_options` VALUES("13", "rss_use_excerpt", "0", "yes");
INSERT INTO `wp_options` VALUES("14", "mailserver_url", "mail.example.com", "yes");
INSERT INTO `wp_options` VALUES("15", "mailserver_login", "login@example.com", "yes");
INSERT INTO `wp_options` VALUES("16", "mailserver_pass", "password", "yes");
INSERT INTO `wp_options` VALUES("17", "mailserver_port", "110", "yes");
INSERT INTO `wp_options` VALUES("18", "default_category", "1", "yes");
INSERT INTO `wp_options` VALUES("19", "default_comment_status", "open", "yes");
INSERT INTO `wp_options` VALUES("20", "default_ping_status", "open", "yes");
INSERT INTO `wp_options` VALUES("21", "default_pingback_flag", "1", "yes");
INSERT INTO `wp_options` VALUES("22", "posts_per_page", "10", "yes");
INSERT INTO `wp_options` VALUES("23", "date_format", "F j, Y", "yes");
INSERT INTO `wp_options` VALUES("24", "time_format", "g:i a", "yes");
INSERT INTO `wp_options` VALUES("25", "links_updated_date_format", "F j, Y g:i a", "yes");
INSERT INTO `wp_options` VALUES("26", "comment_moderation", "0", "yes");
INSERT INTO `wp_options` VALUES("27", "moderation_notify", "1", "yes");
INSERT INTO `wp_options` VALUES("28", "permalink_structure", "/%postname%/", "yes");
INSERT INTO `wp_options` VALUES("29", "rewrite_rules", "a:248:{s:10:\"project/?$\";s:27:\"index.php?post_type=project\";s:40:\"project/feed/(feed|rdf|rss|rss2|atom)/?$\";s:44:\"index.php?post_type=project&feed=$matches[1]\";s:35:\"project/(feed|rdf|rss|rss2|atom)/?$\";s:44:\"index.php?post_type=project&feed=$matches[1]\";s:27:\"project/page/([0-9]{1,})/?$\";s:45:\"index.php?post_type=project&paged=$matches[1]\";s:11:\"^wp-json/?$\";s:22:\"index.php?rest_route=/\";s:14:\"^wp-json/(.*)?\";s:33:\"index.php?rest_route=/$matches[1]\";s:21:\"^index.php/wp-json/?$\";s:22:\"index.php?rest_route=/\";s:24:\"^index.php/wp-json/(.*)?\";s:33:\"index.php?rest_route=/$matches[1]\";s:47:\"category/(.+?)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:52:\"index.php?category_name=$matches[1]&feed=$matches[2]\";s:42:\"category/(.+?)/(feed|rdf|rss|rss2|atom)/?$\";s:52:\"index.php?category_name=$matches[1]&feed=$matches[2]\";s:23:\"category/(.+?)/embed/?$\";s:46:\"index.php?category_name=$matches[1]&embed=true\";s:35:\"category/(.+?)/page/?([0-9]{1,})/?$\";s:53:\"index.php?category_name=$matches[1]&paged=$matches[2]\";s:17:\"category/(.+?)/?$\";s:35:\"index.php?category_name=$matches[1]\";s:44:\"tag/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?tag=$matches[1]&feed=$matches[2]\";s:39:\"tag/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?tag=$matches[1]&feed=$matches[2]\";s:20:\"tag/([^/]+)/embed/?$\";s:36:\"index.php?tag=$matches[1]&embed=true\";s:32:\"tag/([^/]+)/page/?([0-9]{1,})/?$\";s:43:\"index.php?tag=$matches[1]&paged=$matches[2]\";s:14:\"tag/([^/]+)/?$\";s:25:\"index.php?tag=$matches[1]\";s:45:\"type/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?post_format=$matches[1]&feed=$matches[2]\";s:40:\"type/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?post_format=$matches[1]&feed=$matches[2]\";s:21:\"type/([^/]+)/embed/?$\";s:44:\"index.php?post_format=$matches[1]&embed=true\";s:33:\"type/([^/]+)/page/?([0-9]{1,})/?$\";s:51:\"index.php?post_format=$matches[1]&paged=$matches[2]\";s:15:\"type/([^/]+)/?$\";s:33:\"index.php?post_format=$matches[1]\";s:56:\"layout_category/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:54:\"index.php?layout_category=$matches[1]&feed=$matches[2]\";s:51:\"layout_category/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:54:\"index.php?layout_category=$matches[1]&feed=$matches[2]\";s:32:\"layout_category/([^/]+)/embed/?$\";s:48:\"index.php?layout_category=$matches[1]&embed=true\";s:44:\"layout_category/([^/]+)/page/?([0-9]{1,})/?$\";s:55:\"index.php?layout_category=$matches[1]&paged=$matches[2]\";s:26:\"layout_category/([^/]+)/?$\";s:37:\"index.php?layout_category=$matches[1]\";s:52:\"layout_pack/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?layout_pack=$matches[1]&feed=$matches[2]\";s:47:\"layout_pack/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?layout_pack=$matches[1]&feed=$matches[2]\";s:28:\"layout_pack/([^/]+)/embed/?$\";s:44:\"index.php?layout_pack=$matches[1]&embed=true\";s:40:\"layout_pack/([^/]+)/page/?([0-9]{1,})/?$\";s:51:\"index.php?layout_pack=$matches[1]&paged=$matches[2]\";s:22:\"layout_pack/([^/]+)/?$\";s:33:\"index.php?layout_pack=$matches[1]\";s:52:\"layout_type/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?layout_type=$matches[1]&feed=$matches[2]\";s:47:\"layout_type/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?layout_type=$matches[1]&feed=$matches[2]\";s:28:\"layout_type/([^/]+)/embed/?$\";s:44:\"index.php?layout_type=$matches[1]&embed=true\";s:40:\"layout_type/([^/]+)/page/?([0-9]{1,})/?$\";s:51:\"index.php?layout_type=$matches[1]&paged=$matches[2]\";s:22:\"layout_type/([^/]+)/?$\";s:33:\"index.php?layout_type=$matches[1]\";s:46:\"scope/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:44:\"index.php?scope=$matches[1]&feed=$matches[2]\";s:41:\"scope/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:44:\"index.php?scope=$matches[1]&feed=$matches[2]\";s:22:\"scope/([^/]+)/embed/?$\";s:38:\"index.php?scope=$matches[1]&embed=true\";s:34:\"scope/([^/]+)/page/?([0-9]{1,})/?$\";s:45:\"index.php?scope=$matches[1]&paged=$matches[2]\";s:16:\"scope/([^/]+)/?$\";s:27:\"index.php?scope=$matches[1]\";s:53:\"module_width/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:51:\"index.php?module_width=$matches[1]&feed=$matches[2]\";s:48:\"module_width/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:51:\"index.php?module_width=$matches[1]&feed=$matches[2]\";s:29:\"module_width/([^/]+)/embed/?$\";s:45:\"index.php?module_width=$matches[1]&embed=true\";s:41:\"module_width/([^/]+)/page/?([0-9]{1,})/?$\";s:52:\"index.php?module_width=$matches[1]&paged=$matches[2]\";s:23:\"module_width/([^/]+)/?$\";s:34:\"index.php?module_width=$matches[1]\";s:40:\"et_pb_layout/[^/]+/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:50:\"et_pb_layout/[^/]+/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:70:\"et_pb_layout/[^/]+/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:65:\"et_pb_layout/[^/]+/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:65:\"et_pb_layout/[^/]+/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:46:\"et_pb_layout/[^/]+/attachment/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:29:\"et_pb_layout/([^/]+)/embed/?$\";s:60:\"index.php?post_type=et_pb_layout&name=$matches[1]&embed=true\";s:33:\"et_pb_layout/([^/]+)/trackback/?$\";s:54:\"index.php?post_type=et_pb_layout&name=$matches[1]&tb=1\";s:41:\"et_pb_layout/([^/]+)/page/?([0-9]{1,})/?$\";s:67:\"index.php?post_type=et_pb_layout&name=$matches[1]&paged=$matches[2]\";s:48:\"et_pb_layout/([^/]+)/comment-page-([0-9]{1,})/?$\";s:67:\"index.php?post_type=et_pb_layout&name=$matches[1]&cpage=$matches[2]\";s:37:\"et_pb_layout/([^/]+)(?:/([0-9]+))?/?$\";s:66:\"index.php?post_type=et_pb_layout&name=$matches[1]&page=$matches[2]\";s:29:\"et_pb_layout/[^/]+/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:39:\"et_pb_layout/[^/]+/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:59:\"et_pb_layout/[^/]+/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:54:\"et_pb_layout/[^/]+/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:54:\"et_pb_layout/[^/]+/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:35:\"et_pb_layout/[^/]+/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:35:\"project/[^/]+/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:45:\"project/[^/]+/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:65:\"project/[^/]+/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:60:\"project/[^/]+/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:60:\"project/[^/]+/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:41:\"project/[^/]+/attachment/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:24:\"project/([^/]+)/embed/?$\";s:40:\"index.php?project=$matches[1]&embed=true\";s:28:\"project/([^/]+)/trackback/?$\";s:34:\"index.php?project=$matches[1]&tb=1\";s:48:\"project/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:46:\"index.php?project=$matches[1]&feed=$matches[2]\";s:43:\"project/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:46:\"index.php?project=$matches[1]&feed=$matches[2]\";s:36:\"project/([^/]+)/page/?([0-9]{1,})/?$\";s:47:\"index.php?project=$matches[1]&paged=$matches[2]\";s:43:\"project/([^/]+)/comment-page-([0-9]{1,})/?$\";s:47:\"index.php?project=$matches[1]&cpage=$matches[2]\";s:32:\"project/([^/]+)(?:/([0-9]+))?/?$\";s:46:\"index.php?project=$matches[1]&page=$matches[2]\";s:24:\"project/[^/]+/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:34:\"project/[^/]+/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:54:\"project/[^/]+/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:49:\"project/[^/]+/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:49:\"project/[^/]+/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:30:\"project/[^/]+/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:57:\"project_category/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:55:\"index.php?project_category=$matches[1]&feed=$matches[2]\";s:52:\"project_category/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:55:\"index.php?project_category=$matches[1]&feed=$matches[2]\";s:33:\"project_category/([^/]+)/embed/?$\";s:49:\"index.php?project_category=$matches[1]&embed=true\";s:45:\"project_category/([^/]+)/page/?([0-9]{1,})/?$\";s:56:\"index.php?project_category=$matches[1]&paged=$matches[2]\";s:27:\"project_category/([^/]+)/?$\";s:38:\"index.php?project_category=$matches[1]\";s:52:\"project_tag/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?project_tag=$matches[1]&feed=$matches[2]\";s:47:\"project_tag/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?project_tag=$matches[1]&feed=$matches[2]\";s:28:\"project_tag/([^/]+)/embed/?$\";s:44:\"index.php?project_tag=$matches[1]&embed=true\";s:40:\"project_tag/([^/]+)/page/?([0-9]{1,})/?$\";s:51:\"index.php?project_tag=$matches[1]&paged=$matches[2]\";s:22:\"project_tag/([^/]+)/?$\";s:33:\"index.php?project_tag=$matches[1]\";s:44:\"et_theme_builder/[^/]+/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:54:\"et_theme_builder/[^/]+/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:74:\"et_theme_builder/[^/]+/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:69:\"et_theme_builder/[^/]+/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:69:\"et_theme_builder/[^/]+/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:50:\"et_theme_builder/[^/]+/attachment/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:33:\"et_theme_builder/([^/]+)/embed/?$\";s:64:\"index.php?post_type=et_theme_builder&name=$matches[1]&embed=true\";s:37:\"et_theme_builder/([^/]+)/trackback/?$\";s:58:\"index.php?post_type=et_theme_builder&name=$matches[1]&tb=1\";s:45:\"et_theme_builder/([^/]+)/page/?([0-9]{1,})/?$\";s:71:\"index.php?post_type=et_theme_builder&name=$matches[1]&paged=$matches[2]\";s:52:\"et_theme_builder/([^/]+)/comment-page-([0-9]{1,})/?$\";s:71:\"index.php?post_type=et_theme_builder&name=$matches[1]&cpage=$matches[2]\";s:41:\"et_theme_builder/([^/]+)(?:/([0-9]+))?/?$\";s:70:\"index.php?post_type=et_theme_builder&name=$matches[1]&page=$matches[2]\";s:33:\"et_theme_builder/[^/]+/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:43:\"et_theme_builder/[^/]+/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:63:\"et_theme_builder/[^/]+/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:58:\"et_theme_builder/[^/]+/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:58:\"et_theme_builder/[^/]+/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:39:\"et_theme_builder/[^/]+/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:39:\"et_template/[^/]+/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:49:\"et_template/[^/]+/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:69:\"et_template/[^/]+/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:64:\"et_template/[^/]+/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:64:\"et_template/[^/]+/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:45:\"et_template/[^/]+/attachment/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:28:\"et_template/([^/]+)/embed/?$\";s:59:\"index.php?post_type=et_template&name=$matches[1]&embed=true\";s:32:\"et_template/([^/]+)/trackback/?$\";s:53:\"index.php?post_type=et_template&name=$matches[1]&tb=1\";s:40:\"et_template/([^/]+)/page/?([0-9]{1,})/?$\";s:66:\"index.php?post_type=et_template&name=$matches[1]&paged=$matches[2]\";s:47:\"et_template/([^/]+)/comment-page-([0-9]{1,})/?$\";s:66:\"index.php?post_type=et_template&name=$matches[1]&cpage=$matches[2]\";s:36:\"et_template/([^/]+)(?:/([0-9]+))?/?$\";s:65:\"index.php?post_type=et_template&name=$matches[1]&page=$matches[2]\";s:28:\"et_template/[^/]+/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:38:\"et_template/[^/]+/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:58:\"et_template/[^/]+/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:53:\"et_template/[^/]+/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:53:\"et_template/[^/]+/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:34:\"et_template/[^/]+/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:44:\"et_header_layout/[^/]+/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:54:\"et_header_layout/[^/]+/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:74:\"et_header_layout/[^/]+/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:69:\"et_header_layout/[^/]+/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:69:\"et_header_layout/[^/]+/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:50:\"et_header_layout/[^/]+/attachment/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:33:\"et_header_layout/([^/]+)/embed/?$\";s:64:\"index.php?post_type=et_header_layout&name=$matches[1]&embed=true\";s:37:\"et_header_layout/([^/]+)/trackback/?$\";s:58:\"index.php?post_type=et_header_layout&name=$matches[1]&tb=1\";s:45:\"et_header_layout/([^/]+)/page/?([0-9]{1,})/?$\";s:71:\"index.php?post_type=et_header_layout&name=$matches[1]&paged=$matches[2]\";s:52:\"et_header_layout/([^/]+)/comment-page-([0-9]{1,})/?$\";s:71:\"index.php?post_type=et_header_layout&name=$matches[1]&cpage=$matches[2]\";s:41:\"et_header_layout/([^/]+)(?:/([0-9]+))?/?$\";s:70:\"index.php?post_type=et_header_layout&name=$matches[1]&page=$matches[2]\";s:33:\"et_header_layout/[^/]+/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:43:\"et_header_layout/[^/]+/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:63:\"et_header_layout/[^/]+/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:58:\"et_header_layout/[^/]+/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:58:\"et_header_layout/[^/]+/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:39:\"et_header_layout/[^/]+/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:42:\"et_body_layout/[^/]+/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:52:\"et_body_layout/[^/]+/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:72:\"et_body_layout/[^/]+/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:67:\"et_body_layout/[^/]+/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:67:\"et_body_layout/[^/]+/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:48:\"et_body_layout/[^/]+/attachment/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:31:\"et_body_layout/([^/]+)/embed/?$\";s:62:\"index.php?post_type=et_body_layout&name=$matches[1]&embed=true\";s:35:\"et_body_layout/([^/]+)/trackback/?$\";s:56:\"index.php?post_type=et_body_layout&name=$matches[1]&tb=1\";s:43:\"et_body_layout/([^/]+)/page/?([0-9]{1,})/?$\";s:69:\"index.php?post_type=et_body_layout&name=$matches[1]&paged=$matches[2]\";s:50:\"et_body_layout/([^/]+)/comment-page-([0-9]{1,})/?$\";s:69:\"index.php?post_type=et_body_layout&name=$matches[1]&cpage=$matches[2]\";s:39:\"et_body_layout/([^/]+)(?:/([0-9]+))?/?$\";s:68:\"index.php?post_type=et_body_layout&name=$matches[1]&page=$matches[2]\";s:31:\"et_body_layout/[^/]+/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:41:\"et_body_layout/[^/]+/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:61:\"et_body_layout/[^/]+/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:56:\"et_body_layout/[^/]+/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:56:\"et_body_layout/[^/]+/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:37:\"et_body_layout/[^/]+/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:44:\"et_footer_layout/[^/]+/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:54:\"et_footer_layout/[^/]+/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:74:\"et_footer_layout/[^/]+/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:69:\"et_footer_layout/[^/]+/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:69:\"et_footer_layout/[^/]+/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:50:\"et_footer_layout/[^/]+/attachment/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:33:\"et_footer_layout/([^/]+)/embed/?$\";s:64:\"index.php?post_type=et_footer_layout&name=$matches[1]&embed=true\";s:37:\"et_footer_layout/([^/]+)/trackback/?$\";s:58:\"index.php?post_type=et_footer_layout&name=$matches[1]&tb=1\";s:45:\"et_footer_layout/([^/]+)/page/?([0-9]{1,})/?$\";s:71:\"index.php?post_type=et_footer_layout&name=$matches[1]&paged=$matches[2]\";s:52:\"et_footer_layout/([^/]+)/comment-page-([0-9]{1,})/?$\";s:71:\"index.php?post_type=et_footer_layout&name=$matches[1]&cpage=$matches[2]\";s:41:\"et_footer_layout/([^/]+)(?:/([0-9]+))?/?$\";s:70:\"index.php?post_type=et_footer_layout&name=$matches[1]&page=$matches[2]\";s:33:\"et_footer_layout/[^/]+/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:43:\"et_footer_layout/[^/]+/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:63:\"et_footer_layout/[^/]+/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:58:\"et_footer_layout/[^/]+/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:58:\"et_footer_layout/[^/]+/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:39:\"et_footer_layout/[^/]+/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:12:\"robots\\.txt$\";s:18:\"index.php?robots=1\";s:48:\".*wp-(atom|rdf|rss|rss2|feed|commentsrss2)\\.php$\";s:18:\"index.php?feed=old\";s:20:\".*wp-app\\.php(/.*)?$\";s:19:\"index.php?error=403\";s:18:\".*wp-register.php$\";s:23:\"index.php?register=true\";s:32:\"feed/(feed|rdf|rss|rss2|atom)/?$\";s:27:\"index.php?&feed=$matches[1]\";s:27:\"(feed|rdf|rss|rss2|atom)/?$\";s:27:\"index.php?&feed=$matches[1]\";s:8:\"embed/?$\";s:21:\"index.php?&embed=true\";s:20:\"page/?([0-9]{1,})/?$\";s:28:\"index.php?&paged=$matches[1]\";s:27:\"comment-page-([0-9]{1,})/?$\";s:38:\"index.php?&page_id=2&cpage=$matches[1]\";s:41:\"comments/feed/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?&feed=$matches[1]&withcomments=1\";s:36:\"comments/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?&feed=$matches[1]&withcomments=1\";s:17:\"comments/embed/?$\";s:21:\"index.php?&embed=true\";s:44:\"search/(.+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:40:\"index.php?s=$matches[1]&feed=$matches[2]\";s:39:\"search/(.+)/(feed|rdf|rss|rss2|atom)/?$\";s:40:\"index.php?s=$matches[1]&feed=$matches[2]\";s:20:\"search/(.+)/embed/?$\";s:34:\"index.php?s=$matches[1]&embed=true\";s:32:\"search/(.+)/page/?([0-9]{1,})/?$\";s:41:\"index.php?s=$matches[1]&paged=$matches[2]\";s:14:\"search/(.+)/?$\";s:23:\"index.php?s=$matches[1]\";s:47:\"author/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?author_name=$matches[1]&feed=$matches[2]\";s:42:\"author/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?author_name=$matches[1]&feed=$matches[2]\";s:23:\"author/([^/]+)/embed/?$\";s:44:\"index.php?author_name=$matches[1]&embed=true\";s:35:\"author/([^/]+)/page/?([0-9]{1,})/?$\";s:51:\"index.php?author_name=$matches[1]&paged=$matches[2]\";s:17:\"author/([^/]+)/?$\";s:33:\"index.php?author_name=$matches[1]\";s:69:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:80:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&feed=$matches[4]\";s:64:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/(feed|rdf|rss|rss2|atom)/?$\";s:80:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&feed=$matches[4]\";s:45:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/embed/?$\";s:74:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&embed=true\";s:57:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/page/?([0-9]{1,})/?$\";s:81:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&paged=$matches[4]\";s:39:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/?$\";s:63:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]\";s:56:\"([0-9]{4})/([0-9]{1,2})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:64:\"index.php?year=$matches[1]&monthnum=$matches[2]&feed=$matches[3]\";s:51:\"([0-9]{4})/([0-9]{1,2})/(feed|rdf|rss|rss2|atom)/?$\";s:64:\"index.php?year=$matches[1]&monthnum=$matches[2]&feed=$matches[3]\";s:32:\"([0-9]{4})/([0-9]{1,2})/embed/?$\";s:58:\"index.php?year=$matches[1]&monthnum=$matches[2]&embed=true\";s:44:\"([0-9]{4})/([0-9]{1,2})/page/?([0-9]{1,})/?$\";s:65:\"index.php?year=$matches[1]&monthnum=$matches[2]&paged=$matches[3]\";s:26:\"([0-9]{4})/([0-9]{1,2})/?$\";s:47:\"index.php?year=$matches[1]&monthnum=$matches[2]\";s:43:\"([0-9]{4})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?year=$matches[1]&feed=$matches[2]\";s:38:\"([0-9]{4})/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?year=$matches[1]&feed=$matches[2]\";s:19:\"([0-9]{4})/embed/?$\";s:37:\"index.php?year=$matches[1]&embed=true\";s:31:\"([0-9]{4})/page/?([0-9]{1,})/?$\";s:44:\"index.php?year=$matches[1]&paged=$matches[2]\";s:13:\"([0-9]{4})/?$\";s:26:\"index.php?year=$matches[1]\";s:27:\".?.+?/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:37:\".?.+?/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:57:\".?.+?/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\".?.+?/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\".?.+?/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:33:\".?.+?/attachment/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:16:\"(.?.+?)/embed/?$\";s:41:\"index.php?pagename=$matches[1]&embed=true\";s:20:\"(.?.+?)/trackback/?$\";s:35:\"index.php?pagename=$matches[1]&tb=1\";s:40:\"(.?.+?)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:47:\"index.php?pagename=$matches[1]&feed=$matches[2]\";s:35:\"(.?.+?)/(feed|rdf|rss|rss2|atom)/?$\";s:47:\"index.php?pagename=$matches[1]&feed=$matches[2]\";s:28:\"(.?.+?)/page/?([0-9]{1,})/?$\";s:48:\"index.php?pagename=$matches[1]&paged=$matches[2]\";s:35:\"(.?.+?)/comment-page-([0-9]{1,})/?$\";s:48:\"index.php?pagename=$matches[1]&cpage=$matches[2]\";s:24:\"(.?.+?)(?:/([0-9]+))?/?$\";s:47:\"index.php?pagename=$matches[1]&page=$matches[2]\";s:27:\"[^/]+/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:37:\"[^/]+/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:57:\"[^/]+/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\"[^/]+/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\"[^/]+/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:33:\"[^/]+/attachment/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:16:\"([^/]+)/embed/?$\";s:37:\"index.php?name=$matches[1]&embed=true\";s:20:\"([^/]+)/trackback/?$\";s:31:\"index.php?name=$matches[1]&tb=1\";s:40:\"([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?name=$matches[1]&feed=$matches[2]\";s:35:\"([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?name=$matches[1]&feed=$matches[2]\";s:28:\"([^/]+)/page/?([0-9]{1,})/?$\";s:44:\"index.php?name=$matches[1]&paged=$matches[2]\";s:35:\"([^/]+)/comment-page-([0-9]{1,})/?$\";s:44:\"index.php?name=$matches[1]&cpage=$matches[2]\";s:24:\"([^/]+)(?:/([0-9]+))?/?$\";s:43:\"index.php?name=$matches[1]&page=$matches[2]\";s:16:\"[^/]+/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:26:\"[^/]+/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:46:\"[^/]+/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:41:\"[^/]+/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:41:\"[^/]+/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:22:\"[^/]+/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";}", "yes");
INSERT INTO `wp_options` VALUES("30", "hack_file", "0", "yes");
INSERT INTO `wp_options` VALUES("31", "blog_charset", "UTF-8", "yes");
INSERT INTO `wp_options` VALUES("32", "moderation_keys", "", "no");
INSERT INTO `wp_options` VALUES("33", "active_plugins", "a:6:{i:0;s:25:\"duplicator/duplicator.php\";i:1;s:25:\"menu-icons/menu-icons.php\";i:2;s:19:\"monarch/monarch.php\";i:3;s:53:\"supreme-modules-for-divi/supreme-modules-for-divi.php\";i:4;s:41:\"wordpress-importer/wordpress-importer.php\";i:6;s:29:\"wp-parsidate/wp-parsidate.php\";}", "yes");
INSERT INTO `wp_options` VALUES("34", "category_base", "", "yes");
INSERT INTO `wp_options` VALUES("35", "ping_sites", "http://rpc.pingomatic.com/", "yes");
INSERT INTO `wp_options` VALUES("36", "comment_max_links", "2", "yes");
INSERT INTO `wp_options` VALUES("37", "gmt_offset", "+3.5", "yes");
INSERT INTO `wp_options` VALUES("38", "default_email_category", "1", "yes");
INSERT INTO `wp_options` VALUES("39", "recently_edited", "", "no");
INSERT INTO `wp_options` VALUES("40", "template", "Divi", "yes");
INSERT INTO `wp_options` VALUES("41", "stylesheet", "Divi-Child-Theme-master", "yes");
INSERT INTO `wp_options` VALUES("42", "comment_whitelist", "1", "yes");
INSERT INTO `wp_options` VALUES("43", "blacklist_keys", "", "no");
INSERT INTO `wp_options` VALUES("44", "comment_registration", "0", "yes");
INSERT INTO `wp_options` VALUES("45", "html_type", "text/html", "yes");
INSERT INTO `wp_options` VALUES("46", "use_trackback", "0", "yes");
INSERT INTO `wp_options` VALUES("47", "default_role", "subscriber", "yes");
INSERT INTO `wp_options` VALUES("48", "db_version", "45805", "yes");
INSERT INTO `wp_options` VALUES("49", "uploads_use_yearmonth_folders", "1", "yes");
INSERT INTO `wp_options` VALUES("50", "upload_path", "", "yes");
INSERT INTO `wp_options` VALUES("51", "blog_public", "1", "yes");
INSERT INTO `wp_options` VALUES("52", "default_link_category", "2", "yes");
INSERT INTO `wp_options` VALUES("53", "show_on_front", "page", "yes");
INSERT INTO `wp_options` VALUES("54", "tag_base", "", "yes");
INSERT INTO `wp_options` VALUES("55", "show_avatars", "1", "yes");
INSERT INTO `wp_options` VALUES("56", "avatar_rating", "G", "yes");
INSERT INTO `wp_options` VALUES("57", "upload_url_path", "", "yes");
INSERT INTO `wp_options` VALUES("58", "thumbnail_size_w", "150", "yes");
INSERT INTO `wp_options` VALUES("59", "thumbnail_size_h", "150", "yes");
INSERT INTO `wp_options` VALUES("60", "thumbnail_crop", "1", "yes");
INSERT INTO `wp_options` VALUES("61", "medium_size_w", "300", "yes");
INSERT INTO `wp_options` VALUES("62", "medium_size_h", "300", "yes");
INSERT INTO `wp_options` VALUES("63", "avatar_default", "mystery", "yes");
INSERT INTO `wp_options` VALUES("64", "large_size_w", "1024", "yes");
INSERT INTO `wp_options` VALUES("65", "large_size_h", "1024", "yes");
INSERT INTO `wp_options` VALUES("66", "image_default_link_type", "none", "yes");
INSERT INTO `wp_options` VALUES("67", "image_default_size", "", "yes");
INSERT INTO `wp_options` VALUES("68", "image_default_align", "", "yes");
INSERT INTO `wp_options` VALUES("69", "close_comments_for_old_posts", "0", "yes");
INSERT INTO `wp_options` VALUES("70", "close_comments_days_old", "14", "yes");
INSERT INTO `wp_options` VALUES("71", "thread_comments", "1", "yes");
INSERT INTO `wp_options` VALUES("72", "thread_comments_depth", "5", "yes");
INSERT INTO `wp_options` VALUES("73", "page_comments", "0", "yes");
INSERT INTO `wp_options` VALUES("74", "comments_per_page", "50", "yes");
INSERT INTO `wp_options` VALUES("75", "default_comments_page", "newest", "yes");
INSERT INTO `wp_options` VALUES("76", "comment_order", "asc", "yes");
INSERT INTO `wp_options` VALUES("77", "sticky_posts", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("78", "widget_categories", "a:2:{i:2;a:4:{s:5:\"title\";s:0:\"\";s:5:\"count\";i:0;s:12:\"hierarchical\";i:0;s:8:\"dropdown\";i:0;}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("79", "widget_text", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("80", "widget_rss", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("81", "uninstall_plugins", "a:1:{s:27:\"wp-optimize/wp-optimize.php\";s:21:\"wpo_uninstall_actions\";}", "no");
INSERT INTO `wp_options` VALUES("82", "timezone_string", "", "yes");
INSERT INTO `wp_options` VALUES("83", "page_for_posts", "0", "yes");
INSERT INTO `wp_options` VALUES("84", "page_on_front", "2", "yes");
INSERT INTO `wp_options` VALUES("85", "default_post_format", "0", "yes");
INSERT INTO `wp_options` VALUES("86", "link_manager_enabled", "0", "yes");
INSERT INTO `wp_options` VALUES("87", "finished_splitting_shared_terms", "1", "yes");
INSERT INTO `wp_options` VALUES("88", "site_icon", "2818", "yes");
INSERT INTO `wp_options` VALUES("89", "medium_large_size_w", "768", "yes");
INSERT INTO `wp_options` VALUES("90", "medium_large_size_h", "0", "yes");
INSERT INTO `wp_options` VALUES("91", "wp_page_for_privacy_policy", "3", "yes");
INSERT INTO `wp_options` VALUES("92", "show_comments_cookies_opt_in", "1", "yes");
INSERT INTO `wp_options` VALUES("93", "admin_email_lifespan", "1598953975", "yes");
INSERT INTO `wp_options` VALUES("94", "initial_db_version", "45805", "yes");
INSERT INTO `wp_options` VALUES("95", "wp_user_roles", "a:5:{s:13:\"administrator\";a:2:{s:4:\"name\";s:13:\"Administrator\";s:12:\"capabilities\";a:67:{s:13:\"switch_themes\";b:1;s:11:\"edit_themes\";b:1;s:16:\"activate_plugins\";b:1;s:12:\"edit_plugins\";b:1;s:10:\"edit_users\";b:1;s:10:\"edit_files\";b:1;s:14:\"manage_options\";b:1;s:17:\"moderate_comments\";b:1;s:17:\"manage_categories\";b:1;s:12:\"manage_links\";b:1;s:12:\"upload_files\";b:1;s:6:\"import\";b:1;s:15:\"unfiltered_html\";b:1;s:10:\"edit_posts\";b:1;s:17:\"edit_others_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:10:\"edit_pages\";b:1;s:4:\"read\";b:1;s:8:\"level_10\";b:1;s:7:\"level_9\";b:1;s:7:\"level_8\";b:1;s:7:\"level_7\";b:1;s:7:\"level_6\";b:1;s:7:\"level_5\";b:1;s:7:\"level_4\";b:1;s:7:\"level_3\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:17:\"edit_others_pages\";b:1;s:20:\"edit_published_pages\";b:1;s:13:\"publish_pages\";b:1;s:12:\"delete_pages\";b:1;s:19:\"delete_others_pages\";b:1;s:22:\"delete_published_pages\";b:1;s:12:\"delete_posts\";b:1;s:19:\"delete_others_posts\";b:1;s:22:\"delete_published_posts\";b:1;s:20:\"delete_private_posts\";b:1;s:18:\"edit_private_posts\";b:1;s:18:\"read_private_posts\";b:1;s:20:\"delete_private_pages\";b:1;s:18:\"edit_private_pages\";b:1;s:18:\"read_private_pages\";b:1;s:12:\"delete_users\";b:1;s:12:\"create_users\";b:1;s:17:\"unfiltered_upload\";b:1;s:14:\"edit_dashboard\";b:1;s:14:\"update_plugins\";b:1;s:14:\"delete_plugins\";b:1;s:15:\"install_plugins\";b:1;s:13:\"update_themes\";b:1;s:14:\"install_themes\";b:1;s:11:\"update_core\";b:1;s:10:\"list_users\";b:1;s:12:\"remove_users\";b:1;s:13:\"promote_users\";b:1;s:18:\"edit_theme_options\";b:1;s:13:\"delete_themes\";b:1;s:6:\"export\";b:1;s:17:\"et_support_center\";b:1;s:24:\"et_support_center_system\";b:1;s:31:\"et_support_center_remote_access\";b:1;s:31:\"et_support_center_documentation\";b:1;s:27:\"et_support_center_safe_mode\";b:1;s:22:\"et_support_center_logs\";b:1;}}s:6:\"editor\";a:2:{s:4:\"name\";s:6:\"Editor\";s:12:\"capabilities\";a:34:{s:17:\"moderate_comments\";b:1;s:17:\"manage_categories\";b:1;s:12:\"manage_links\";b:1;s:12:\"upload_files\";b:1;s:15:\"unfiltered_html\";b:1;s:10:\"edit_posts\";b:1;s:17:\"edit_others_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:10:\"edit_pages\";b:1;s:4:\"read\";b:1;s:7:\"level_7\";b:1;s:7:\"level_6\";b:1;s:7:\"level_5\";b:1;s:7:\"level_4\";b:1;s:7:\"level_3\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:17:\"edit_others_pages\";b:1;s:20:\"edit_published_pages\";b:1;s:13:\"publish_pages\";b:1;s:12:\"delete_pages\";b:1;s:19:\"delete_others_pages\";b:1;s:22:\"delete_published_pages\";b:1;s:12:\"delete_posts\";b:1;s:19:\"delete_others_posts\";b:1;s:22:\"delete_published_posts\";b:1;s:20:\"delete_private_posts\";b:1;s:18:\"edit_private_posts\";b:1;s:18:\"read_private_posts\";b:1;s:20:\"delete_private_pages\";b:1;s:18:\"edit_private_pages\";b:1;s:18:\"read_private_pages\";b:1;}}s:6:\"author\";a:2:{s:4:\"name\";s:6:\"Author\";s:12:\"capabilities\";a:10:{s:12:\"upload_files\";b:1;s:10:\"edit_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:4:\"read\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:12:\"delete_posts\";b:1;s:22:\"delete_published_posts\";b:1;}}s:11:\"contributor\";a:2:{s:4:\"name\";s:11:\"Contributor\";s:12:\"capabilities\";a:5:{s:10:\"edit_posts\";b:1;s:4:\"read\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:12:\"delete_posts\";b:1;}}s:10:\"subscriber\";a:2:{s:4:\"name\";s:10:\"Subscriber\";s:12:\"capabilities\";a:2:{s:4:\"read\";b:1;s:7:\"level_0\";b:1;}}}", "yes");
INSERT INTO `wp_options` VALUES("96", "fresh_site", "0", "yes");
INSERT INTO `wp_options` VALUES("97", "WPLANG", "fa_IR", "yes");
INSERT INTO `wp_options` VALUES("98", "widget_search", "a:2:{i:2;a:1:{s:5:\"title\";s:0:\"\";}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("99", "widget_recent-posts", "a:2:{i:2;a:2:{s:5:\"title\";s:0:\"\";s:6:\"number\";i:5;}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("100", "widget_recent-comments", "a:2:{i:2;a:2:{s:5:\"title\";s:0:\"\";s:6:\"number\";i:5;}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("101", "widget_archives", "a:2:{i:2;a:3:{s:5:\"title\";s:0:\"\";s:5:\"count\";i:0;s:8:\"dropdown\";i:0;}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("102", "widget_meta", "a:2:{i:2;a:1:{s:5:\"title\";s:0:\"\";}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("103", "sidebars_widgets", "a:9:{s:19:\"wp_inactive_widgets\";a:3:{i:0;s:10:\"archives-2\";i:1;s:6:\"meta-2\";i:2;s:12:\"categories-2\";}s:9:\"sidebar-1\";a:3:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:17:\"recent-comments-2\";}s:9:\"sidebar-2\";a:0:{}s:9:\"sidebar-3\";a:0:{}s:9:\"sidebar-4\";a:0:{}s:9:\"sidebar-5\";a:0:{}s:9:\"sidebar-6\";a:0:{}s:9:\"sidebar-7\";a:0:{}s:13:\"array_version\";i:3;}", "yes");
INSERT INTO `wp_options` VALUES("104", "cron", "a:9:{i:1585909655;a:1:{s:30:\"wp_scheduled_auto_draft_delete\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1585911183;a:1:{s:34:\"wp_privacy_delete_old_export_files\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:6:\"hourly\";s:4:\"args\";a:0:{}s:8:\"interval\";i:3600;}}}i:1585936028;a:1:{s:29:\"wpo_smush_clear_backup_images\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1585948623;a:1:{s:21:\"wpo_plugin_cron_tasks\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}}i:1585950783;a:3:{s:16:\"wp_version_check\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}s:17:\"wp_update_plugins\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}s:16:\"wp_update_themes\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}}i:1585993981;a:1:{s:32:\"recovery_mode_clean_expired_keys\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1585994372;a:1:{s:32:\"et_core_page_resource_auto_clear\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:7:\"monthly\";s:4:\"args\";a:0:{}s:8:\"interval\";i:2592000;}}}i:1585994374;a:2:{s:19:\"wp_scheduled_delete\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}s:25:\"delete_expired_transients\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}s:7:\"version\";i:2;}", "yes");
INSERT INTO `wp_options` VALUES("105", "widget_pages", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("106", "widget_calendar", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("107", "widget_media_audio", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("108", "widget_media_image", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("109", "widget_media_gallery", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("110", "widget_media_video", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("111", "widget_tag_cloud", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("112", "widget_nav_menu", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("113", "widget_custom_html", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("115", "recovery_keys", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("127", "can_compress_scripts", "1", "no");
INSERT INTO `wp_options` VALUES("136", "theme_mods_twentytwenty", "a:1:{s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1583402045;s:4:\"data\";a:3:{s:19:\"wp_inactive_widgets\";a:0:{}s:9:\"sidebar-1\";a:3:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:17:\"recent-comments-2\";}s:9:\"sidebar-2\";a:3:{i:0;s:10:\"archives-2\";i:1;s:12:\"categories-2\";i:2;s:6:\"meta-2\";}}}}", "yes");
INSERT INTO `wp_options` VALUES("137", "current_theme", "modelsite", "yes");
INSERT INTO `wp_options` VALUES("138", "theme_mods_Divi-Child-Theme-master", "a:7:{i:0;b:0;s:18:\"custom_css_post_id\";i:5;s:16:\"et_pb_css_synced\";s:3:\"yes\";s:18:\"nav_menu_locations\";a:2:{s:12:\"primary-menu\";i:5;s:14:\"secondary-menu\";i:6;}s:39:\"et_updated_layouts_built_for_post_types\";s:3:\"yes\";s:16:\"background_color\";s:0:\"\";s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1583931877;s:4:\"data\";a:8:{s:19:\"wp_inactive_widgets\";a:0:{}s:9:\"sidebar-1\";a:3:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:17:\"recent-comments-2\";}s:9:\"sidebar-2\";a:0:{}s:9:\"sidebar-3\";a:0:{}s:9:\"sidebar-4\";a:0:{}s:9:\"sidebar-5\";a:0:{}s:9:\"sidebar-6\";a:0:{}s:9:\"sidebar-7\";a:0:{}}}}", "yes");
INSERT INTO `wp_options` VALUES("139", "theme_switched", "", "yes");
INSERT INTO `wp_options` VALUES("140", "et_pb_cache_notice", "a:1:{s:5:\"4.4.0\";s:6:\"ignore\";}", "yes");
INSERT INTO `wp_options` VALUES("145", "et_core_version", "4.4.2", "yes");
INSERT INTO `wp_options` VALUES("147", "et_divi", "a:195:{s:39:\"static_css_custom_css_safety_check_done\";b:1;s:23:\"2_5_flush_rewrite_rules\";s:4:\"done\";s:30:\"et_flush_rewrite_rules_library\";s:5:\"4.4.2\";s:31:\"divi_previous_installed_version\";s:5:\"4.4.1\";s:29:\"divi_latest_installed_version\";s:5:\"4.4.2\";s:27:\"divi_skip_font_subset_force\";b:1;s:27:\"et_pb_clear_templates_cache\";b:1;s:23:\"builder_custom_defaults\";O:8:\"stdClass\":0:{}s:33:\"customizer_settings_migrated_flag\";b:1;s:34:\"builder_custom_defaults_unmigrated\";b:0;s:40:\"divi_email_provider_credentials_migrated\";b:1;s:15:\"divi_1_3_images\";s:7:\"checked\";s:21:\"et_pb_layouts_updated\";b:1;s:30:\"library_removed_legacy_layouts\";b:1;s:30:\"divi_2_4_documentation_message\";s:9:\"triggered\";s:9:\"divi_logo\";s:75:\"http://modelsite.test/wp-content/uploads/2020/04/Internet-provider-logo.png\";s:14:\"divi_fixed_nav\";s:2:\"on\";s:26:\"divi_gallery_layout_enable\";s:5:\"false\";s:18:\"divi_color_palette\";s:63:\"#dfab82|#dadada|#ff8675|#680000|#edf000|#a0cf00|#004fe8|#946ef4\";s:15:\"divi_grab_image\";s:5:\"false\";s:15:\"divi_blog_style\";s:5:\"false\";s:12:\"divi_sidebar\";s:15:\"et_left_sidebar\";s:22:\"divi_shop_page_sidebar\";s:15:\"et_left_sidebar\";s:23:\"divi_show_facebook_icon\";s:2:\"on\";s:22:\"divi_show_twitter_icon\";s:2:\"on\";s:21:\"divi_show_google_icon\";s:2:\"on\";s:24:\"divi_show_instagram_icon\";s:2:\"on\";s:18:\"divi_show_rss_icon\";s:2:\"on\";s:17:\"divi_facebook_url\";s:1:\"#\";s:16:\"divi_twitter_url\";s:1:\"#\";s:15:\"divi_google_url\";s:1:\"#\";s:18:\"divi_instagram_url\";s:1:\"#\";s:12:\"divi_rss_url\";s:0:\"\";s:34:\"divi_woocommerce_archive_num_posts\";i:9;s:17:\"divi_catnum_posts\";i:6;s:21:\"divi_archivenum_posts\";i:5;s:20:\"divi_searchnum_posts\";i:5;s:17:\"divi_tagnum_posts\";i:5;s:16:\"divi_date_format\";s:6:\"M j, Y\";s:16:\"divi_use_excerpt\";s:5:\"false\";s:26:\"divi_responsive_shortcodes\";s:2:\"on\";s:33:\"divi_gf_enable_all_character_sets\";s:5:\"false\";s:16:\"divi_back_to_top\";s:2:\"on\";s:18:\"divi_smooth_scroll\";s:5:\"false\";s:25:\"divi_disable_translations\";s:5:\"false\";s:29:\"divi_enable_responsive_images\";s:2:\"on\";s:27:\"divi_minify_combine_scripts\";s:2:\"on\";s:26:\"divi_minify_combine_styles\";s:2:\"on\";s:15:\"divi_custom_css\";s:0:\"\";s:21:\"divi_enable_dropdowns\";s:2:\"on\";s:14:\"divi_home_link\";s:2:\"on\";s:15:\"divi_sort_pages\";s:10:\"post_title\";s:15:\"divi_order_page\";s:3:\"asc\";s:22:\"divi_tiers_shown_pages\";i:3;s:32:\"divi_enable_dropdowns_categories\";s:2:\"on\";s:21:\"divi_categories_empty\";s:2:\"on\";s:27:\"divi_tiers_shown_categories\";i:3;s:13:\"divi_sort_cat\";s:4:\"name\";s:14:\"divi_order_cat\";s:3:\"asc\";s:20:\"divi_disable_toptier\";s:5:\"false\";s:25:\"divi_scroll_to_anchor_fix\";s:5:\"false\";s:27:\"et_pb_post_type_integration\";a:3:{s:4:\"post\";s:2:\"on\";s:4:\"page\";s:2:\"on\";s:7:\"project\";s:2:\"on\";}s:21:\"et_pb_static_css_file\";s:3:\"off\";s:19:\"et_pb_css_in_footer\";s:3:\"off\";s:25:\"et_pb_product_tour_global\";s:3:\"off\";s:24:\"et_enable_classic_editor\";s:3:\"off\";s:14:\"divi_postinfo2\";a:4:{i:0;s:6:\"author\";i:1;s:4:\"date\";i:2;s:10:\"categories\";i:3;s:8:\"comments\";}s:22:\"divi_show_postcomments\";s:2:\"on\";s:15:\"divi_thumbnails\";s:2:\"on\";s:20:\"divi_page_thumbnails\";s:5:\"false\";s:23:\"divi_show_pagescomments\";s:5:\"false\";s:14:\"divi_postinfo1\";a:3:{i:0;s:6:\"author\";i:1;s:4:\"date\";i:2;s:10:\"categories\";}s:21:\"divi_thumbnails_index\";s:2:\"on\";s:19:\"divi_seo_home_title\";s:5:\"false\";s:25:\"divi_seo_home_description\";s:5:\"false\";s:22:\"divi_seo_home_keywords\";s:5:\"false\";s:23:\"divi_seo_home_canonical\";s:5:\"false\";s:23:\"divi_seo_home_titletext\";s:0:\"\";s:29:\"divi_seo_home_descriptiontext\";s:0:\"\";s:26:\"divi_seo_home_keywordstext\";s:0:\"\";s:18:\"divi_seo_home_type\";s:27:\"BlogName | Blog description\";s:22:\"divi_seo_home_separate\";s:3:\" | \";s:21:\"divi_seo_single_title\";s:5:\"false\";s:27:\"divi_seo_single_description\";s:5:\"false\";s:24:\"divi_seo_single_keywords\";s:5:\"false\";s:25:\"divi_seo_single_canonical\";s:5:\"false\";s:27:\"divi_seo_single_field_title\";s:9:\"seo_title\";s:33:\"divi_seo_single_field_description\";s:15:\"seo_description\";s:30:\"divi_seo_single_field_keywords\";s:12:\"seo_keywords\";s:20:\"divi_seo_single_type\";s:21:\"Post title | BlogName\";s:24:\"divi_seo_single_separate\";s:3:\" | \";s:24:\"divi_seo_index_canonical\";s:5:\"false\";s:26:\"divi_seo_index_description\";s:5:\"false\";s:19:\"divi_seo_index_type\";s:24:\"Category name | BlogName\";s:23:\"divi_seo_index_separate\";s:3:\" | \";s:28:\"divi_integrate_header_enable\";s:2:\"on\";s:26:\"divi_integrate_body_enable\";s:2:\"on\";s:31:\"divi_integrate_singletop_enable\";s:2:\"on\";s:34:\"divi_integrate_singlebottom_enable\";s:2:\"on\";s:21:\"divi_integration_head\";s:0:\"\";s:21:\"divi_integration_body\";s:0:\"\";s:27:\"divi_integration_single_top\";s:0:\"\";s:30:\"divi_integration_single_bottom\";s:0:\"\";s:15:\"divi_468_enable\";s:5:\"false\";s:14:\"divi_468_image\";s:0:\"\";s:12:\"divi_468_url\";s:0:\"\";s:16:\"divi_468_adsense\";s:0:\"\";s:19:\"product_tour_status\";a:1:{i:1;s:3:\"off\";}s:32:\"et_fb_pref_settings_bar_location\";s:6:\"bottom\";s:28:\"et_fb_pref_builder_animation\";s:4:\"true\";s:41:\"et_fb_pref_builder_display_modal_settings\";s:5:\"false\";s:39:\"et_fb_pref_builder_enable_dummy_content\";s:4:\"true\";s:21:\"et_fb_pref_event_mode\";s:5:\"hover\";s:20:\"et_fb_pref_view_mode\";s:7:\"desktop\";s:32:\"et_fb_pref_hide_disabled_modules\";s:5:\"false\";s:28:\"et_fb_pref_history_intervals\";i:1;s:29:\"et_fb_pref_page_creation_flow\";s:7:\"default\";s:42:\"et_fb_pref_quick_actions_always_start_with\";s:7:\"nothing\";s:44:\"et_fb_pref_quick_actions_show_recent_queries\";s:3:\"off\";s:39:\"et_fb_pref_quick_actions_recent_queries\";s:0:\"\";s:40:\"et_fb_pref_quick_actions_recent_category\";s:4:\"page\";s:27:\"et_fb_pref_modal_preference\";s:7:\"default\";s:30:\"et_fb_pref_modal_snap_location\";s:0:\"\";s:21:\"et_fb_pref_modal_snap\";s:5:\"false\";s:27:\"et_fb_pref_modal_fullscreen\";s:5:\"false\";s:32:\"et_fb_pref_modal_dimension_width\";i:400;s:33:\"et_fb_pref_modal_dimension_height\";i:429;s:27:\"et_fb_pref_modal_position_x\";i:289;s:27:\"et_fb_pref_modal_position_y\";i:51;s:24:\"et_fb_pref_toolbar_click\";s:5:\"false\";s:26:\"et_fb_pref_toolbar_desktop\";s:4:\"true\";s:23:\"et_fb_pref_toolbar_grid\";s:5:\"false\";s:24:\"et_fb_pref_toolbar_hover\";s:5:\"false\";s:24:\"et_fb_pref_toolbar_phone\";s:4:\"true\";s:25:\"et_fb_pref_toolbar_tablet\";s:4:\"true\";s:28:\"et_fb_pref_toolbar_wireframe\";s:4:\"true\";s:23:\"et_fb_pref_toolbar_zoom\";s:4:\"true\";s:12:\"heading_font\";s:11:\"VAZIR FARSI\";s:9:\"body_font\";s:11:\"VAZIR FARSI\";s:24:\"footer_widget_text_color\";s:7:\"#ffffff\";s:24:\"footer_widget_link_color\";s:7:\"#ffffff\";s:16:\"primary_nav_font\";s:11:\"VAZIR FARSI\";s:18:\"secondary_nav_font\";s:11:\"VAZIR FARSI\";s:21:\"custom_footer_credits\";s:35:\"طراحی توسط مدل سایت\";s:12:\"phone_number\";s:12:\"091312345678\";s:12:\"header_email\";s:17:\"info@modelsite.ir\";s:21:\"bottom_bar_text_color\";s:7:\"#ffffff\";s:28:\"bottom_bar_social_icon_color\";s:7:\"#ffffff\";s:12:\"header_style\";s:5:\"split\";s:12:\"vertical_nav\";b:0;s:24:\"vertical_nav_orientation\";s:5:\"right\";s:12:\"divi_favicon\";s:0:\"\";s:11:\"logo_height\";i:100;s:14:\"footer_columns\";s:1:\"3\";s:9:\"footer_bg\";s:7:\"#222222\";s:26:\"footer_widget_header_color\";s:7:\"#b5b5b5\";s:26:\"footer_widget_bullet_color\";s:7:\"#b5b5b5\";s:16:\"secondary_nav_bg\";s:7:\"#a0cf00\";s:16:\"menu_link_active\";s:7:\"#2fc900\";s:31:\"primary_nav_dropdown_line_color\";s:7:\"#a0cf00\";s:14:\"slide_nav_font\";s:11:\"VAZIR FARSI\";s:27:\"bottom_bar_background_color\";s:7:\"#a0cf00\";s:9:\"menu_link\";s:7:\"#a0cf00\";s:13:\"nav_fullwidth\";b:0;s:22:\"slide_nav_show_top_bar\";b:1;s:14:\"primary_nav_bg\";s:7:\"#ffffff\";s:12:\"accent_color\";s:7:\"#a0cf00\";s:12:\"slide_nav_bg\";s:7:\"#af8447\";s:13:\"color_schemes\";s:4:\"none\";s:31:\"primary_nav_dropdown_link_color\";s:7:\"#a0cf00\";s:25:\"secondary_nav_dropdown_bg\";s:7:\"#a0cf00\";s:15:\"fixed_menu_link\";s:7:\"#a0cf00\";s:23:\"secondary_nav_fullwidth\";b:0;s:28:\"secondary_nav_text_color_new\";s:7:\"#ffffff\";s:24:\"show_header_social_icons\";b:0;s:16:\"show_search_icon\";b:1;s:16:\"hide_mobile_logo\";b:0;s:32:\"secondary_nav_dropdown_animation\";s:6:\"expand\";s:21:\"slide_nav_links_color\";s:7:\"#ffffff\";s:10:\"link_color\";s:7:\"#680000\";s:22:\"fixed_secondary_nav_bg\";s:7:\"#a0cf00\";s:22:\"fixed_menu_link_active\";s:7:\"#24d800\";s:14:\"body_font_size\";i:16;s:21:\"primary_nav_font_size\";i:16;s:23:\"secondary_nav_font_size\";i:14;s:27:\"fixed_primary_nav_font_size\";i:18;s:20:\"bottom_bar_font_size\";i:14;s:27:\"bottom_bar_social_icon_size\";i:22;s:29:\"disable_custom_footer_credits\";b:0;s:20:\"phone_section_height\";i:62;s:16:\"phone_row_height\";i:32;s:20:\"phone_body_font_size\";i:14;s:22:\"phone_header_font_size\";i:34;s:16:\"mobile_menu_link\";s:7:\"#a0cf00\";s:21:\"mobile_primary_nav_bg\";s:7:\"#ffffff\";}", "yes");
INSERT INTO `wp_options` VALUES("148", "widget_aboutmewidget", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("149", "widget_adsensewidget", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("150", "widget_advwidget", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("151", "shop_catalog_image_size", "a:3:{s:5:\"width\";s:3:\"400\";s:6:\"height\";s:3:\"400\";s:4:\"crop\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("152", "shop_single_image_size", "a:3:{s:5:\"width\";s:3:\"510\";s:6:\"height\";s:4:\"9999\";s:4:\"crop\";i:0;}", "yes");
INSERT INTO `wp_options` VALUES("153", "shop_thumbnail_image_size", "a:3:{s:5:\"width\";s:3:\"157\";s:6:\"height\";s:3:\"157\";s:4:\"crop\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("154", "et_support_site_id", "TH*^y-5F0P4Dp#3oBhmt", "yes");
INSERT INTO `wp_options` VALUES("155", "et_safe_mode_plugins_whitelist", "a:8:{i:0;s:15:\"etdev/etdev.php\";i:1;s:15:\"bloom/bloom.php\";i:2;s:19:\"monarch/monarch.php\";i:3;s:29:\"divi-builder/divi-builder.php\";i:4;s:27:\"ari-adminer/ari-adminer.php\";i:5;s:31:\"query-monitor/query-monitor.php\";i:6;s:27:\"woocommerce/woocommerce.php\";i:7;s:47:\"really-simple-ssl/rlrsssl-really-simple-ssl.php\";}", "yes");
INSERT INTO `wp_options` VALUES("156", "et_support_center_installed", "true", "yes");
INSERT INTO `wp_options` VALUES("157", "et_images_temp_folder", "C:\\laragon\\www\\modelsite/wp-content/uploads/et_temp", "yes");
INSERT INTO `wp_options` VALUES("158", "et_schedule_clean_images_last_time", "1585831423", "yes");
INSERT INTO `wp_options` VALUES("159", "et_bfb_settings", "a:2:{s:10:\"enable_bfb\";s:2:\"on\";s:10:\"toggle_bfb\";s:2:\"on\";}", "yes");
INSERT INTO `wp_options` VALUES("161", "et_pb_builder_options", "a:2:{i:0;b:0;s:35:\"email_provider_credentials_migrated\";b:1;}", "yes");
INSERT INTO `wp_options` VALUES("162", "et_support_center_setup_done", "processed", "yes");
INSERT INTO `wp_options` VALUES("165", "recently_activated", "a:2:{s:27:\"wp-optimize/wp-optimize.php\";i:1585584306;s:61:\"before-after-images-for-divi/before-after-image-extension.php\";i:1584982082;}", "yes");
INSERT INTO `wp_options` VALUES("166", "wpp_settings", "a:15:{s:10:\"admin_lang\";s:7:\"disable\";s:9:\"user_lang\";s:7:\"disable\";s:12:\"submenu_move\";s:7:\"disable\";s:12:\"persian_date\";s:6:\"enable\";s:10:\"conv_title\";s:6:\"enable\";s:13:\"conv_contents\";s:6:\"enable\";s:12:\"conv_excerpt\";s:6:\"enable\";s:13:\"conv_comments\";s:6:\"enable\";s:18:\"conv_comment_count\";s:6:\"enable\";s:10:\"conv_dates\";s:6:\"enable\";s:9:\"conv_cats\";s:7:\"disable\";s:11:\"conv_arabic\";s:6:\"enable\";s:15:\"conv_permalinks\";s:7:\"disable\";s:11:\"news_source\";s:5:\"parsi\";s:15:\"conv_page_title\";s:6:\"enable\";}", "yes");
INSERT INTO `wp_options` VALUES("171", "widget_parsidate_archive", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("172", "widget_parsidate_calendar", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("173", "widget_monarchwidget", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("174", "menu_icons_install", "1583402076", "yes");
INSERT INTO `wp_options` VALUES("179", "et_monarch_options", "a:170:{s:34:\"sharing_locations_manage_locations\";a:1:{i:0;s:7:\"sidebar\";}s:33:\"sharing_networks_networks_sorting\";a:3:{s:5:\"label\";a:5:{i:0;s:8:\"Facebook\";i:1;s:7:\"Twitter\";i:2;s:7:\"Google+\";i:3;s:9:\"Pinterest\";i:4;s:5:\"Gmail\";}s:5:\"class\";a:5:{i:0;s:8:\"facebook\";i:1;s:7:\"twitter\";i:2;s:10:\"googleplus\";i:3;s:9:\"pinterest\";i:4;s:5:\"gmail\";}s:8:\"username\";a:1:{i:1;s:0:\"\";}}s:26:\"sharing_sidebar_icon_style\";s:4:\"flip\";s:26:\"sharing_sidebar_icon_shape\";s:9:\"rectangle\";s:35:\"sharing_sidebar_sidebar_orientation\";s:4:\"left\";s:25:\"sharing_sidebar_animation\";s:10:\"slideright\";s:22:\"sharing_sidebar_counts\";s:0:\"\";s:26:\"sharing_sidebar_counts_num\";i:0;s:21:\"sharing_sidebar_total\";s:0:\"\";s:27:\"sharing_sidebar_total_color\";s:4:\"dark\";s:27:\"sharing_sidebar_display_all\";s:0:\"\";s:23:\"sharing_sidebar_spacing\";s:0:\"\";s:22:\"sharing_sidebar_mobile\";s:0:\"\";s:29:\"sharing_sidebar_custom_colors\";s:0:\"\";s:24:\"sharing_sidebar_bg_color\";s:0:\"\";s:30:\"sharing_sidebar_bg_color_hover\";s:0:\"\";s:26:\"sharing_sidebar_icon_color\";s:0:\"\";s:32:\"sharing_sidebar_icon_color_hover\";s:0:\"\";s:26:\"sharing_sidebar_post_types\";a:1:{i:0;s:4:\"post\";}s:25:\"sharing_inline_icon_style\";s:5:\"slide\";s:25:\"sharing_inline_icon_shape\";s:7:\"rounded\";s:29:\"sharing_inline_icons_location\";s:5:\"above\";s:30:\"sharing_inline_icons_alignment\";s:4:\"left\";s:25:\"sharing_inline_col_number\";s:1:\"4\";s:21:\"sharing_inline_counts\";s:1:\"1\";s:25:\"sharing_inline_counts_num\";i:0;s:20:\"sharing_inline_total\";s:0:\"\";s:28:\"sharing_inline_network_names\";s:1:\"1\";s:26:\"sharing_inline_display_all\";s:0:\"\";s:26:\"sharing_inline_outer_color\";s:4:\"dark\";s:22:\"sharing_inline_spacing\";s:0:\"\";s:21:\"sharing_inline_mobile\";s:0:\"\";s:28:\"sharing_inline_custom_colors\";s:0:\"\";s:23:\"sharing_inline_bg_color\";s:0:\"\";s:29:\"sharing_inline_bg_color_hover\";s:0:\"\";s:25:\"sharing_inline_icon_color\";s:0:\"\";s:31:\"sharing_inline_icon_color_hover\";s:0:\"\";s:25:\"sharing_inline_post_types\";a:1:{i:0;s:4:\"post\";}s:24:\"sharing_popup_icon_style\";s:5:\"slide\";s:24:\"sharing_popup_icon_shape\";s:7:\"rounded\";s:24:\"sharing_popup_title_text\";s:10:\"Share This\";s:26:\"sharing_popup_message_text\";s:34:\"Share this post with your friends!\";s:29:\"sharing_popup_icons_alignment\";s:4:\"left\";s:24:\"sharing_popup_col_number\";s:1:\"3\";s:23:\"sharing_popup_animation\";s:6:\"fadein\";s:24:\"sharing_popup_auto_popup\";s:1:\"1\";s:25:\"sharing_popup_popup_delay\";i:20;s:26:\"sharing_popup_trigger_idle\";s:0:\"\";s:26:\"sharing_popup_idle_timeout\";i:15;s:28:\"sharing_popup_trigger_bottom\";s:0:\"\";s:29:\"sharing_popup_trigger_comment\";s:0:\"\";s:28:\"sharing_popup_scroll_trigger\";s:0:\"\";s:24:\"sharing_popup_scroll_pos\";i:50;s:30:\"sharing_popup_trigger_purchase\";s:0:\"\";s:21:\"sharing_popup_cookies\";s:0:\"\";s:29:\"sharing_popup_cookie_duration\";i:1;s:20:\"sharing_popup_counts\";s:1:\"1\";s:24:\"sharing_popup_counts_num\";i:0;s:19:\"sharing_popup_total\";s:0:\"\";s:27:\"sharing_popup_network_names\";s:1:\"1\";s:25:\"sharing_popup_display_all\";s:0:\"\";s:21:\"sharing_popup_spacing\";s:0:\"\";s:20:\"sharing_popup_mobile\";s:0:\"\";s:27:\"sharing_popup_custom_colors\";s:0:\"\";s:22:\"sharing_popup_bg_color\";s:0:\"\";s:28:\"sharing_popup_bg_color_hover\";s:0:\"\";s:24:\"sharing_popup_icon_color\";s:0:\"\";s:30:\"sharing_popup_icon_color_hover\";s:0:\"\";s:24:\"sharing_popup_post_types\";a:1:{i:0;s:4:\"post\";}s:24:\"sharing_flyin_icon_style\";s:5:\"slide\";s:24:\"sharing_flyin_icon_shape\";s:7:\"rounded\";s:24:\"sharing_flyin_title_text\";s:10:\"Share This\";s:26:\"sharing_flyin_message_text\";s:34:\"Share this post with your friends!\";s:28:\"sharing_flyin_icons_location\";s:12:\"bottom_right\";s:29:\"sharing_flyin_icons_alignment\";s:4:\"left\";s:24:\"sharing_flyin_col_number\";s:1:\"2\";s:23:\"sharing_flyin_animation\";s:7:\"slideup\";s:24:\"sharing_flyin_auto_popup\";s:0:\"\";s:25:\"sharing_flyin_popup_delay\";i:20;s:26:\"sharing_flyin_trigger_idle\";s:0:\"\";s:26:\"sharing_flyin_idle_timeout\";i:15;s:28:\"sharing_flyin_trigger_bottom\";s:1:\"1\";s:29:\"sharing_flyin_trigger_comment\";s:0:\"\";s:28:\"sharing_flyin_scroll_trigger\";s:0:\"\";s:24:\"sharing_flyin_scroll_pos\";i:50;s:30:\"sharing_flyin_trigger_purchase\";s:0:\"\";s:21:\"sharing_flyin_cookies\";s:0:\"\";s:29:\"sharing_flyin_cookie_duration\";i:1;s:20:\"sharing_flyin_counts\";s:0:\"\";s:24:\"sharing_flyin_counts_num\";i:0;s:19:\"sharing_flyin_total\";s:0:\"\";s:27:\"sharing_flyin_network_names\";s:1:\"1\";s:25:\"sharing_flyin_display_all\";s:0:\"\";s:21:\"sharing_flyin_spacing\";s:0:\"\";s:20:\"sharing_flyin_mobile\";s:0:\"\";s:27:\"sharing_flyin_custom_colors\";s:0:\"\";s:22:\"sharing_flyin_bg_color\";s:0:\"\";s:28:\"sharing_flyin_bg_color_hover\";s:0:\"\";s:24:\"sharing_flyin_icon_color\";s:0:\"\";s:30:\"sharing_flyin_icon_color_hover\";s:0:\"\";s:24:\"sharing_flyin_post_types\";a:1:{i:0;s:4:\"post\";}s:24:\"sharing_media_icon_style\";s:6:\"simple\";s:24:\"sharing_media_icon_shape\";s:7:\"rounded\";s:29:\"sharing_media_icons_alignment\";s:4:\"left\";s:24:\"sharing_media_col_number\";s:4:\"auto\";s:20:\"sharing_media_counts\";s:0:\"\";s:24:\"sharing_media_counts_num\";i:0;s:19:\"sharing_media_total\";s:0:\"\";s:27:\"sharing_media_network_names\";s:1:\"1\";s:25:\"sharing_media_display_all\";s:0:\"\";s:25:\"sharing_media_outer_color\";s:4:\"dark\";s:21:\"sharing_media_spacing\";s:0:\"\";s:20:\"sharing_media_mobile\";s:0:\"\";s:27:\"sharing_media_custom_colors\";s:0:\"\";s:22:\"sharing_media_bg_color\";s:0:\"\";s:28:\"sharing_media_bg_color_hover\";s:0:\"\";s:24:\"sharing_media_icon_color\";s:0:\"\";s:30:\"sharing_media_icon_color_hover\";s:0:\"\";s:24:\"sharing_media_post_types\";a:1:{i:0;s:4:\"post\";}s:32:\"follow_networks_networks_sorting\";a:4:{s:5:\"label\";a:1:{i:0;s:9:\"Instagram\";}s:8:\"username\";a:1:{i:0;s:0:\"\";}s:5:\"count\";a:1:{i:0;s:0:\"\";}s:5:\"class\";a:1:{i:0;s:9:\"instagram\";}}s:26:\"follow_networks_new_window\";s:1:\"1\";s:23:\"follow_networks_use_api\";s:0:\"\";s:24:\"follow_networks_vimeo_id\";s:0:\"\";s:28:\"follow_networks_vimeo_secret\";s:0:\"\";s:28:\"follow_networks_instagram_id\";s:0:\"\";s:32:\"follow_networks_instagram_secret\";s:0:\"\";s:27:\"follow_networks_linkedin_id\";s:0:\"\";s:31:\"follow_networks_linkedin_secret\";s:0:\"\";s:31:\"follow_networks_twitter_api_key\";s:0:\"\";s:34:\"follow_networks_twitter_api_secret\";s:0:\"\";s:29:\"follow_networks_twitter_token\";s:0:\"\";s:36:\"follow_networks_twitter_token_secret\";s:0:\"\";s:31:\"follow_networks_youtube_api_key\";s:0:\"\";s:24:\"follow_widget_icon_style\";s:5:\"slide\";s:24:\"follow_widget_icon_shape\";s:7:\"rounded\";s:28:\"follow_widget_icons_location\";s:3:\"top\";s:24:\"follow_widget_col_number\";s:1:\"2\";s:20:\"follow_widget_counts\";s:1:\"1\";s:24:\"follow_widget_counts_num\";i:0;s:19:\"follow_widget_total\";s:1:\"1\";s:27:\"follow_widget_network_names\";s:1:\"1\";s:25:\"follow_widget_outer_color\";s:4:\"dark\";s:21:\"follow_widget_spacing\";s:0:\"\";s:20:\"follow_widget_mobile\";s:0:\"\";s:27:\"follow_widget_custom_colors\";s:0:\"\";s:22:\"follow_widget_bg_color\";s:0:\"\";s:28:\"follow_widget_bg_color_hover\";s:0:\"\";s:24:\"follow_widget_icon_color\";s:0:\"\";s:30:\"follow_widget_icon_color_hover\";s:0:\"\";s:27:\"follow_shortcode_icon_style\";s:5:\"slide\";s:27:\"follow_shortcode_icon_shape\";s:7:\"rounded\";s:31:\"follow_shortcode_icons_location\";s:3:\"top\";s:27:\"follow_shortcode_col_number\";s:4:\"auto\";s:23:\"follow_shortcode_counts\";s:1:\"1\";s:27:\"follow_shortcode_counts_num\";i:0;s:22:\"follow_shortcode_total\";s:1:\"1\";s:30:\"follow_shortcode_network_names\";s:1:\"1\";s:28:\"follow_shortcode_outer_color\";s:4:\"dark\";s:24:\"follow_shortcode_spacing\";s:0:\"\";s:23:\"follow_shortcode_mobile\";s:0:\"\";s:30:\"follow_shortcode_custom_colors\";s:0:\"\";s:25:\"follow_shortcode_bg_color\";s:0:\"\";s:31:\"follow_shortcode_bg_color_hover\";s:0:\"\";s:27:\"follow_shortcode_icon_color\";s:0:\"\";s:33:\"follow_shortcode_icon_color_hover\";s:0:\"\";s:24:\"general_main_update_freq\";i:3;s:27:\"general_main_reset_postdata\";s:0:\"\";s:24:\"general_main_facebook_id\";s:0:\"\";s:28:\"general_main_facebook_secret\";s:0:\"\";s:23:\"general_main_custom_css\";s:0:\"\";}", "yes");
INSERT INTO `wp_options` VALUES("184", "et_google_api_settings", "a:3:{s:7:\"api_key\";s:0:\"\";s:26:\"enqueue_google_maps_script\";s:5:\"false\";s:16:\"use_google_fonts\";s:5:\"false\";}", "yes");
INSERT INTO `wp_options` VALUES("185", "et_automatic_updates_options", "a:2:{s:8:\"username\";s:10:\"design1231\";s:7:\"api_key\";s:40:\"30e6e66b6180a9caf32d4f127bb89d540db255c0\";}", "no");
INSERT INTO `wp_options` VALUES("189", "_site_transient_et_update_themes", "O:8:\"stdClass\":1:{s:12:\"last_checked\";i:1585579129;}", "no");
INSERT INTO `wp_options` VALUES("206", "category_children", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("207", "layout_category_children", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("208", "project_category_children", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("232", "auto_core_update_notified", "a:4:{s:4:\"type\";s:7:\"success\";s:5:\"email\";s:17:\"motekef@gmail.com\";s:7:\"version\";s:5:\"5.3.2\";s:9:\"timestamp\";i:1583406074;}", "no");
INSERT INTO `wp_options` VALUES("233", "et_uploaded_fonts", "a:2:{s:11:\"VAZIR FARSI\";a:4:{s:9:\"font_file\";a:1:{s:3:\"ttf\";s:0:\"\";}s:8:\"font_url\";a:1:{s:3:\"ttf\";s:62:\"http://modelsite.test/wp-content/uploads/et-fonts/Vazir-FD.ttf\";}s:6:\"styles\";s:35:\"100,200,300,400,500,600,700,800,900\";s:4:\"type\";s:10:\"sans-serif\";}s:5:\"sahel\";a:4:{s:9:\"font_file\";a:1:{s:3:\"ttf\";s:0:\"\";}s:8:\"font_url\";a:1:{s:3:\"ttf\";s:59:\"http://modelsite.test/wp-content/uploads/et-fonts/sahel.ttf\";}s:6:\"styles\";s:35:\"100,200,300,400,500,600,700,800,900\";s:4:\"type\";s:10:\"sans-serif\";}}", "yes");
INSERT INTO `wp_options` VALUES("247", "nav_menu_options", "a:2:{i:0;b:0;s:8:\"auto_add\";a:0:{}}", "yes");
INSERT INTO `wp_options` VALUES("267", "et_account_status", "active", "no");
INSERT INTO `wp_options` VALUES("268", "et_account_status_last_checked", "1585568266", "no");
INSERT INTO `wp_options` VALUES("269", "_site_transient_et_update_all_plugins", "O:8:\"stdClass\":1:{s:12:\"last_checked\";i:1585584321;}", "no");
INSERT INTO `wp_options` VALUES("270", "duplicator_settings", "a:15:{s:7:\"version\";s:6:\"1.3.28\";s:18:\"uninstall_settings\";b:1;s:15:\"uninstall_files\";b:1;s:16:\"uninstall_tables\";b:1;s:13:\"package_debug\";b:0;s:17:\"package_mysqldump\";b:1;s:22:\"package_mysqldump_path\";s:0:\"\";s:24:\"package_phpdump_qrylimit\";s:3:\"100\";s:17:\"package_zip_flush\";b:0;s:20:\"storage_htaccess_off\";b:0;s:18:\"archive_build_mode\";i:2;s:17:\"skip_archive_scan\";b:0;s:21:\"unhook_third_party_js\";b:0;s:22:\"unhook_third_party_css\";b:0;s:17:\"active_package_id\";i:2;}", "yes");
INSERT INTO `wp_options` VALUES("271", "duplicator_version_plugin", "1.3.28", "yes");
INSERT INTO `wp_options` VALUES("276", "duplicator_package_active", "O:11:\"DUP_Package\":25:{s:7:\"Created\";s:19:\"2020-04-03 10:11:06\";s:7:\"Version\";s:6:\"1.3.28\";s:9:\"VersionWP\";s:5:\"5.3.2\";s:9:\"VersionDB\";s:6:\"5.7.24\";s:10:\"VersionPHP\";s:6:\"7.2.19\";s:9:\"VersionOS\";s:5:\"WINNT\";s:2:\"ID\";N;s:4:\"Name\";s:18:\"internet_modelsite\";s:4:\"Hash\";s:35:\"3c46d65490e8f5566271_20200403101106\";s:8:\"NameHash\";s:54:\"internet_modelsite_3c46d65490e8f5566271_20200403101106\";s:4:\"Type\";i:0;s:5:\"Notes\";s:0:\"\";s:9:\"StorePath\";s:41:\"C:/laragon/www/modelsite/wp-snapshots/tmp\";s:8:\"StoreURL\";s:35:\"http://modelsite.test/wp-snapshots/\";s:8:\"ScanFile\";s:64:\"internet_modelsite_3c46d65490e8f5566271_20200403101106_scan.json\";s:10:\"TimerStart\";i:-1;s:7:\"Runtime\";N;s:7:\"ExeSize\";N;s:7:\"ZipSize\";N;s:6:\"Status\";i:0;s:6:\"WPUser\";N;s:7:\"Archive\";O:11:\"DUP_Archive\":21:{s:10:\"FilterDirs\";s:0:\"\";s:11:\"FilterFiles\";s:0:\"\";s:10:\"FilterExts\";s:0:\"\";s:13:\"FilterDirsAll\";a:0:{}s:14:\"FilterFilesAll\";a:0:{}s:13:\"FilterExtsAll\";a:0:{}s:8:\"FilterOn\";i:0;s:12:\"ExportOnlyDB\";i:0;s:4:\"File\";N;s:6:\"Format\";s:3:\"ZIP\";s:7:\"PackDir\";s:24:\"C:/laragon/www/modelsite\";s:4:\"Size\";i:0;s:4:\"Dirs\";a:0:{}s:5:\"Files\";a:0:{}s:10:\"FilterInfo\";O:23:\"DUP_Archive_Filter_Info\":8:{s:4:\"Dirs\";O:34:\"DUP_Archive_Filter_Scope_Directory\":5:{s:7:\"Warning\";a:0:{}s:10:\"Unreadable\";a:0:{}s:4:\"Core\";a:0:{}s:6:\"Global\";a:0:{}s:8:\"Instance\";a:0:{}}s:5:\"Files\";O:29:\"DUP_Archive_Filter_Scope_File\":6:{s:4:\"Size\";a:0:{}s:7:\"Warning\";a:0:{}s:10:\"Unreadable\";a:0:{}s:4:\"Core\";a:0:{}s:6:\"Global\";a:0:{}s:8:\"Instance\";a:0:{}}s:4:\"Exts\";O:29:\"DUP_Archive_Filter_Scope_Base\":3:{s:4:\"Core\";a:0:{}s:6:\"Global\";a:0:{}s:8:\"Instance\";a:0:{}}s:9:\"UDirCount\";i:0;s:10:\"UFileCount\";i:0;s:9:\"UExtCount\";i:0;s:8:\"TreeSize\";a:0:{}s:11:\"TreeWarning\";a:0:{}}s:14:\"RecursiveLinks\";a:0:{}s:10:\"file_count\";i:-1;s:10:\"\0*\0Package\";O:11:\"DUP_Package\":25:{s:7:\"Created\";s:19:\"2020-04-03 10:11:06\";s:7:\"Version\";s:6:\"1.3.28\";s:9:\"VersionWP\";s:5:\"5.3.2\";s:9:\"VersionDB\";s:6:\"5.7.24\";s:10:\"VersionPHP\";s:6:\"7.2.19\";s:9:\"VersionOS\";s:5:\"WINNT\";s:2:\"ID\";N;s:4:\"Name\";s:18:\"internet_modelsite\";s:4:\"Hash\";s:35:\"3c46d65490e8f5566271_20200403101106\";s:8:\"NameHash\";s:54:\"internet_modelsite_3c46d65490e8f5566271_20200403101106\";s:4:\"Type\";i:0;s:5:\"Notes\";s:0:\"\";s:9:\"StorePath\";s:41:\"C:/laragon/www/modelsite/wp-snapshots/tmp\";s:8:\"StoreURL\";s:35:\"http://modelsite.test/wp-snapshots/\";s:8:\"ScanFile\";N;s:10:\"TimerStart\";i:-1;s:7:\"Runtime\";N;s:7:\"ExeSize\";N;s:7:\"ZipSize\";N;s:6:\"Status\";i:0;s:6:\"WPUser\";N;s:7:\"Archive\";r:23;s:9:\"Installer\";O:13:\"DUP_Installer\":11:{s:4:\"File\";N;s:4:\"Size\";i:0;s:10:\"OptsDBHost\";s:0:\"\";s:10:\"OptsDBPort\";s:0:\"\";s:10:\"OptsDBName\";s:0:\"\";s:10:\"OptsDBUser\";s:0:\"\";s:12:\"OptsSecureOn\";i:0;s:14:\"OptsSecurePass\";s:0:\"\";s:13:\"numFilesAdded\";i:0;s:12:\"numDirsAdded\";i:0;s:10:\"\0*\0Package\";r:63;}s:8:\"Database\";O:12:\"DUP_Database\":14:{s:4:\"Type\";s:5:\"MySQL\";s:4:\"Size\";N;s:4:\"File\";N;s:4:\"Path\";N;s:12:\"FilterTables\";s:0:\"\";s:8:\"FilterOn\";i:0;s:4:\"Name\";N;s:10:\"Compatible\";s:0:\"\";s:8:\"Comments\";s:28:\"MySQL Community Server (GPL)\";s:4:\"info\";O:16:\"DUP_DatabaseInfo\":15:{s:9:\"buildMode\";N;s:13:\"collationList\";a:0:{}s:17:\"isTablesUpperCase\";N;s:15:\"isNameUpperCase\";N;s:4:\"name\";N;s:15:\"tablesBaseCount\";N;s:16:\"tablesFinalCount\";N;s:14:\"tablesRowCount\";N;s:16:\"tablesSizeOnDisk\";N;s:18:\"varLowerCaseTables\";i:1;s:7:\"version\";N;s:14:\"versionComment\";N;s:18:\"tableWiseRowCounts\";a:0:{}s:33:\"\0DUP_DatabaseInfo\0intFieldsStruct\";a:0:{}s:42:\"\0DUP_DatabaseInfo\0indexProcessedSchemaSize\";a:0:{}}s:10:\"\0*\0Package\";r:63;s:25:\"\0DUP_Database\0dbStorePath\";N;s:23:\"\0DUP_Database\0EOFMarker\";s:0:\"\";s:26:\"\0DUP_Database\0networkFlush\";b:0;}s:13:\"BuildProgress\";O:18:\"DUP_Build_Progress\":12:{s:17:\"thread_start_time\";N;s:11:\"initialized\";b:0;s:15:\"installer_built\";b:0;s:15:\"archive_started\";b:0;s:20:\"archive_has_database\";b:0;s:13:\"archive_built\";b:0;s:21:\"database_script_built\";b:0;s:6:\"failed\";b:0;s:7:\"retries\";i:0;s:14:\"build_failures\";a:0:{}s:19:\"validation_failures\";a:0:{}s:27:\"\0DUP_Build_Progress\0package\";r:63;}}s:29:\"\0DUP_Archive\0tmpFilterDirsAll\";a:0:{}s:24:\"\0DUP_Archive\0wpCorePaths\";a:5:{i:0;s:33:\"C:/laragon/www/modelsite/wp-admin\";i:1;s:43:\"C:/laragon/www/modelsite/wp-content/uploads\";i:2;s:45:\"C:/laragon/www/modelsite/wp-content/languages\";i:3;s:42:\"C:/laragon/www/modelsite/wp-content/themes\";i:4;s:36:\"C:/laragon/www/modelsite/wp-includes\";}s:29:\"\0DUP_Archive\0wpCoreExactPaths\";a:2:{i:0;s:24:\"C:/laragon/www/modelsite\";i:1;s:35:\"C:/laragon/www/modelsite/wp-content\";}}s:9:\"Installer\";r:86;s:8:\"Database\";r:98;s:13:\"BuildProgress\";r:128;}", "yes");
INSERT INTO `wp_options` VALUES("369", "menu-icons", "a:2:{s:6:\"global\";a:1:{s:10:\"icon_types\";a:2:{i:0;s:9:\"dashicons\";i:1;s:5:\"image\";}}s:6:\"menu_6\";a:6:{s:10:\"hide_label\";s:0:\"\";s:8:\"position\";s:6:\"before\";s:14:\"vertical_align\";s:6:\"middle\";s:9:\"font_size\";s:3:\"1.2\";s:9:\"svg_width\";s:1:\"1\";s:10:\"image_size\";s:9:\"thumbnail\";}}", "yes");
INSERT INTO `wp_options` VALUES("408", "themeisle_sdk_notifications", "a:2:{s:17:\"last_notification\";a:2:{s:2:\"id\";s:22:\"menu_icons_logger_flag\";s:10:\"display_at\";i:1585140716;}s:24:\"last_notification_active\";i:1585495836;}", "yes");
INSERT INTO `wp_options` VALUES("438", "fs_active_plugins", "O:8:\"stdClass\":3:{s:7:\"plugins\";a:1:{s:16:\"ds-suit/freemius\";O:8:\"stdClass\":4:{s:7:\"version\";s:5:\"2.3.0\";s:4:\"type\";s:6:\"plugin\";s:9:\"timestamp\";i:1583840282;s:11:\"plugin_path\";s:19:\"ds-suit/ds-suit.php\";}}s:7:\"abspath\";s:25:\"C:\\laragon\\www\\modelsite/\";s:6:\"newest\";O:8:\"stdClass\":5:{s:11:\"plugin_path\";s:19:\"ds-suit/ds-suit.php\";s:8:\"sdk_path\";s:16:\"ds-suit/freemius\";s:7:\"version\";s:5:\"2.3.0\";s:13:\"in_activation\";b:1;s:9:\"timestamp\";i:1583840282;}}", "yes");
INSERT INTO `wp_options` VALUES("439", "fs_debug_mode", "", "yes");
INSERT INTO `wp_options` VALUES("440", "fs_accounts", "a:7:{s:21:\"id_slug_type_path_map\";a:2:{i:5280;a:3:{s:4:\"slug\";s:15:\"divi-pre-loader\";s:4:\"type\";s:6:\"plugin\";s:4:\"path\";s:37:\"preloader-for-divi/divi_preloader.php\";}i:1997;a:3:{s:4:\"slug\";s:7:\"ds-suit\";s:4:\"type\";s:6:\"plugin\";s:4:\"path\";s:19:\"ds-suit/ds-suit.php\";}}s:11:\"plugin_data\";a:2:{s:15:\"divi-pre-loader\";a:17:{s:16:\"plugin_main_file\";O:8:\"stdClass\":1:{s:4:\"path\";s:37:\"preloader-for-divi/divi_preloader.php\";}s:20:\"is_network_activated\";b:0;s:17:\"install_timestamp\";i:1583839772;s:17:\"was_plugin_loaded\";b:1;s:21:\"is_plugin_new_install\";b:0;s:16:\"sdk_last_version\";N;s:11:\"sdk_version\";s:5:\"2.3.2\";s:16:\"sdk_upgrade_mode\";b:1;s:18:\"sdk_downgrade_mode\";b:0;s:19:\"plugin_last_version\";N;s:14:\"plugin_version\";s:3:\"1.1\";s:19:\"plugin_upgrade_mode\";b:1;s:21:\"plugin_downgrade_mode\";b:0;s:17:\"connectivity_test\";a:6:{s:12:\"is_connected\";b:1;s:4:\"host\";s:14:\"modelsite.test\";s:9:\"server_ip\";s:9:\"127.0.0.1\";s:9:\"is_active\";b:1;s:9:\"timestamp\";i:1583839772;s:7:\"version\";s:3:\"1.1\";}s:15:\"prev_is_premium\";b:0;s:21:\"is_pending_activation\";b:1;s:16:\"uninstall_reason\";O:8:\"stdClass\":3:{s:2:\"id\";s:1:\"2\";s:4:\"info\";s:0:\"\";s:12:\"is_anonymous\";b:0;}}s:7:\"ds-suit\";a:17:{s:16:\"plugin_main_file\";O:8:\"stdClass\":1:{s:4:\"path\";s:19:\"ds-suit/ds-suit.php\";}s:20:\"is_network_activated\";b:0;s:17:\"install_timestamp\";i:1583840173;s:16:\"sdk_last_version\";N;s:11:\"sdk_version\";s:5:\"2.3.0\";s:16:\"sdk_upgrade_mode\";b:1;s:18:\"sdk_downgrade_mode\";b:0;s:19:\"plugin_last_version\";N;s:14:\"plugin_version\";s:6:\"1.15.9\";s:19:\"plugin_upgrade_mode\";b:1;s:21:\"plugin_downgrade_mode\";b:0;s:21:\"is_plugin_new_install\";b:1;s:17:\"connectivity_test\";a:6:{s:12:\"is_connected\";b:1;s:4:\"host\";s:14:\"modelsite.test\";s:9:\"server_ip\";s:9:\"127.0.0.1\";s:9:\"is_active\";b:1;s:9:\"timestamp\";i:1583840173;s:7:\"version\";s:6:\"1.15.9\";}s:17:\"was_plugin_loaded\";b:1;s:15:\"prev_is_premium\";b:0;s:21:\"is_pending_activation\";b:1;s:16:\"uninstall_reason\";O:8:\"stdClass\":3:{s:2:\"id\";s:2:\"15\";s:4:\"info\";s:0:\"\";s:12:\"is_anonymous\";b:0;}}}s:13:\"file_slug_map\";a:2:{s:37:\"preloader-for-divi/divi_preloader.php\";s:15:\"divi-pre-loader\";s:19:\"ds-suit/ds-suit.php\";s:7:\"ds-suit\";}s:7:\"plugins\";a:2:{s:15:\"divi-pre-loader\";O:9:\"FS_Plugin\":23:{s:16:\"parent_plugin_id\";N;s:5:\"title\";s:18:\"Preloader for Divi\";s:4:\"slug\";s:15:\"divi-pre-loader\";s:12:\"premium_slug\";s:23:\"divi-pre-loader-premium\";s:4:\"type\";s:6:\"plugin\";s:20:\"affiliate_moderation\";b:0;s:19:\"is_wp_org_compliant\";b:1;s:22:\"premium_releases_count\";N;s:4:\"file\";s:37:\"preloader-for-divi/divi_preloader.php\";s:7:\"version\";s:3:\"1.1\";s:11:\"auto_update\";N;s:4:\"info\";N;s:10:\"is_premium\";b:0;s:14:\"premium_suffix\";s:18:\"Divi Preloader Pro\";s:7:\"is_live\";b:1;s:9:\"bundle_id\";N;s:10:\"public_key\";s:32:\"pk_431d2051979a7095ba11bd7625b68\";s:10:\"secret_key\";N;s:2:\"id\";s:4:\"5280\";s:7:\"updated\";N;s:7:\"created\";N;s:22:\"\0FS_Entity\0_is_updated\";b:0;s:17:\"bundle_public_key\";N;}s:7:\"ds-suit\";O:9:\"FS_Plugin\":22:{s:16:\"parent_plugin_id\";N;s:5:\"title\";s:20:\"Battle Suit for Divi\";s:4:\"slug\";s:7:\"ds-suit\";s:12:\"premium_slug\";s:15:\"ds-suit-premium\";s:4:\"type\";s:6:\"plugin\";s:20:\"affiliate_moderation\";b:0;s:19:\"is_wp_org_compliant\";b:1;s:22:\"premium_releases_count\";N;s:4:\"file\";s:19:\"ds-suit/ds-suit.php\";s:7:\"version\";s:6:\"1.15.9\";s:11:\"auto_update\";N;s:4:\"info\";N;s:10:\"is_premium\";b:0;s:14:\"premium_suffix\";s:9:\"(Premium)\";s:7:\"is_live\";b:1;s:9:\"bundle_id\";N;s:10:\"public_key\";s:32:\"pk_9aaec4277e65e9b3a8d13ecdba08e\";s:10:\"secret_key\";N;s:2:\"id\";s:4:\"1997\";s:7:\"updated\";N;s:7:\"created\";N;s:22:\"\0FS_Entity\0_is_updated\";b:0;}}s:9:\"unique_id\";s:32:\"b56316bdc303473520cef40329d2a9ce\";s:13:\"admin_notices\";a:2:{s:15:\"divi-pre-loader\";a:0:{}s:7:\"ds-suit\";a:0:{}}s:6:\"addons\";a:1:{i:1997;a:3:{i:0;O:9:\"FS_Plugin\":22:{s:16:\"parent_plugin_id\";s:4:\"1997\";s:5:\"title\";s:37:\"Battle Suit for Divi - Toolset Add-On\";s:4:\"slug\";s:15:\"ds-suit-toolset\";s:12:\"premium_slug\";s:23:\"ds-suit-toolset-premium\";s:4:\"type\";s:6:\"plugin\";s:20:\"affiliate_moderation\";N;s:19:\"is_wp_org_compliant\";b:0;s:22:\"premium_releases_count\";i:10;s:4:\"file\";N;s:7:\"version\";N;s:11:\"auto_update\";N;s:4:\"info\";O:14:\"FS_Plugin_Info\":13:{s:9:\"plugin_id\";s:4:\"1998\";s:11:\"description\";s:1465:\"<h2>What is Toolset for Divi?</h2>\n<p>Toolset is one of the best plugins - if not the best - when it comes to adding custom post fields and creating custom archives and blog pages. But let\'s be honest, Toolset is not the most userfriendly plugin.</p>\n<p>Adding fields and views to your posts is done with shortcodes and to style them, you need to write CSS. In the age of superb page builders like Divi, that is just not adequate anymore. Luckily we have the perfect solution.</p>\n<p>Meet <b>Toolset for Divi</b>. This practical add-on for the Divi Sensei Battle Suit adds a whole bunch of useful modules which lets you easily add and style Toolset fields and views using the Divi Builder. Each module has its own purpose and comes with appropriate settings to configure and style the Toolset data. Forget about using shortcodes in Divis Code or Text module and never write CSS again. Use the Visual Builder to style your Toolset fields and immediately get a live preview.</p>\n<h2>What modules does this add-on contain?</h2>\n<p>Toolset for Divi adds the following modules to the Divi Builder:</p>\n<ul>\n<li>Toolset Button</li>\n<li>Toolset Counter</li>\n<li>Toolset Gallery</li>\n<li>Toolset Image</li>\n<li>Toolset Table</li>\n<li>Toolset Textfield</li>\n<li>Toolset View</li>\n</ul>\n<p>And many more modules are under development. Currently we are working on:</p>\n<ul>\n<li>Toolset Blurb</li>\n<li>Toolset Map</li>\n<li>Toolset Barchart</li>\n<li>Toolset Countdown</li>\n</ul>\";s:17:\"short_description\";s:119:\"Using Toolset was never easier. Use and style Toolset fields and views from within the Divi Backend and Visual Builder.\";s:10:\"banner_url\";s:61:\"//s3-us-west-2.amazonaws.com/freemius/plugins/1998/banner.png\";s:15:\"card_banner_url\";s:66:\"//s3-us-west-2.amazonaws.com/freemius/plugins/1998/card_banner.png\";s:15:\"selling_point_0\";s:70:\"Add Toolset fields and views without shortcodes using the Divi Builder\";s:15:\"selling_point_1\";s:36:\"Style Toolset using the Divi Builder\";s:15:\"selling_point_2\";s:42:\"Works with Toolset free & premium versions\";s:11:\"screenshots\";N;s:2:\"id\";s:3:\"224\";s:7:\"updated\";s:19:\"2018-08-23 18:45:08\";s:7:\"created\";s:19:\"2018-04-20 12:21:33\";s:22:\"\0FS_Entity\0_is_updated\";b:0;}s:10:\"is_premium\";b:0;s:14:\"premium_suffix\";s:9:\"(Premium)\";s:7:\"is_live\";b:1;s:9:\"bundle_id\";N;s:10:\"public_key\";s:32:\"pk_fa1d9a21326c48c815b2aad622c6c\";s:10:\"secret_key\";N;s:2:\"id\";s:4:\"1998\";s:7:\"updated\";s:19:\"2020-03-10 10:31:57\";s:7:\"created\";s:19:\"2018-04-19 18:30:33\";s:22:\"\0FS_Entity\0_is_updated\";b:0;}i:1;O:9:\"FS_Plugin\":22:{s:16:\"parent_plugin_id\";s:4:\"1997\";s:5:\"title\";s:45:\"Battle Suit for Divi - Material Design Add-On\";s:4:\"slug\";s:16:\"ds-suit-material\";s:12:\"premium_slug\";s:24:\"ds-suit-material-premium\";s:4:\"type\";s:6:\"plugin\";s:20:\"affiliate_moderation\";N;s:19:\"is_wp_org_compliant\";b:0;s:22:\"premium_releases_count\";i:10;s:4:\"file\";N;s:7:\"version\";N;s:11:\"auto_update\";N;s:4:\"info\";O:14:\"FS_Plugin_Info\":13:{s:9:\"plugin_id\";s:4:\"2266\";s:11:\"description\";s:878:\"<h2>What is Material Design?</h2>\n<p>Material Design is a design language developed by Google. The core of the material design is the use of \"cards\", grid-based layouts and depth effects. With the Material Design Add-On you can easily apply the card look to any element on your website, whether it be a single module, a column, a row or even a whole section.</p>\n<p>This add-on consists of two parts:</p>\n<ul>\n<li>Material Blurb: A incredible versatile and powerful Blurb module with tons of configuration possibilities, which go way beyond the Divi Blurb. It\'s like the Divi Blurb on steroids.</li>\n<li>Material Design CSS Classes: The add-on adds a whole bunch of CSS classes which you can use on every element - even non-Divi-element. Simply add the classes you like to any module or element and like magic the Material Design effects get applied to those element.</li>\n</ul>\";s:17:\"short_description\";s:113:\"Give your page the slick material design look without the need to write custom CSS - simply by flipping switches.\";s:10:\"banner_url\";s:61:\"//s3-us-west-2.amazonaws.com/freemius/plugins/2266/banner.png\";s:15:\"card_banner_url\";s:66:\"//s3-us-west-2.amazonaws.com/freemius/plugins/2266/card_banner.png\";s:15:\"selling_point_0\";s:38:\"Material Design by a press of a button\";s:15:\"selling_point_1\";s:33:\"Most powerful Blurb on the market\";s:15:\"selling_point_2\";s:42:\"Easy to use CSS classes for every occasion\";s:11:\"screenshots\";N;s:2:\"id\";s:3:\"318\";s:7:\"updated\";s:19:\"2018-11-03 15:41:21\";s:7:\"created\";s:19:\"2018-07-01 07:39:28\";s:22:\"\0FS_Entity\0_is_updated\";b:0;}s:10:\"is_premium\";b:0;s:14:\"premium_suffix\";s:9:\"(Premium)\";s:7:\"is_live\";b:1;s:9:\"bundle_id\";N;s:10:\"public_key\";s:32:\"pk_c825707da198b407e1cdd35cec693\";s:10:\"secret_key\";N;s:2:\"id\";s:4:\"2266\";s:7:\"updated\";s:19:\"2020-03-10 10:31:57\";s:7:\"created\";s:19:\"2018-06-30 20:54:09\";s:22:\"\0FS_Entity\0_is_updated\";b:0;}i:2;O:9:\"FS_Plugin\":22:{s:16:\"parent_plugin_id\";s:4:\"1997\";s:5:\"title\";s:39:\"Battle Suit for Divi - Countdown Add-On\";s:4:\"slug\";s:17:\"ds-suit-countdown\";s:12:\"premium_slug\";s:25:\"ds-suit-countdown-premium\";s:4:\"type\";s:6:\"plugin\";s:20:\"affiliate_moderation\";N;s:19:\"is_wp_org_compliant\";b:0;s:22:\"premium_releases_count\";i:5;s:4:\"file\";N;s:7:\"version\";N;s:11:\"auto_update\";N;s:4:\"info\";O:14:\"FS_Plugin_Info\":13:{s:9:\"plugin_id\";s:4:\"2778\";s:11:\"description\";s:1565:\"<h2>Another Countdown? Why?</h2>\n<p>While Divi has a countdown module in its core, we found that the functionality and customise options are very limited. Thats why we came up with our own implementation of a countdown module. Check out our demo page and let us convince you that our module is the better choice.</p>\n<p>Things our module can, which the Divi countdown module can\'t:</p>\n<ul>\n    <li><b>Predefined Styles:</b> Our module comes with multiple predefined styles, which let the Divi countdown look old. For example, we have a super fancy flip clock style, which is impossible to re-create using the Divi module</li>\n    <li><b>Custom Format:</b> Want to use your very own format? No problem. You can build your countdown exactly the way you like, including custom HTML structure and time formatting (e. g. zero-padding and singular/plural labels)</li>\n    <li><b>Events:</b> With our countdown module you can choose what shall happen when the clock strikes zero. Stop counting, continue counting, forward to another URL, replace the countdown with your own HTML or run a JavaScript script? No problem!</li>\n    <li><b>Labels:</b> With our module you can define your own labels for our predefined styles. If you use custom formatting, you can even habe different singular and plural labels (e. g. 2 days vs. 1 day)</li>\n</ul>\n<p>Once you start using our countdown module, you will never go back to the Divi countdown. And because we are 100% convinced of this, we offer you a free 7-day trial so you can check it out for yourself before purchasing it.</p>\";s:17:\"short_description\";s:48:\"Display stunning, fully customisable countdowns.\";s:10:\"banner_url\";s:61:\"//s3-us-west-2.amazonaws.com/freemius/plugins/2778/banner.png\";s:15:\"card_banner_url\";s:66:\"//s3-us-west-2.amazonaws.com/freemius/plugins/2778/card_banner.png\";s:15:\"selling_point_0\";s:17:\"Predefined Styles\";s:15:\"selling_point_1\";s:14:\"Custom Formats\";s:15:\"selling_point_2\";s:23:\"Completely Customisable\";s:11:\"screenshots\";O:8:\"stdClass\":4:{s:12:\"screenshot_0\";s:68:\"//s3-us-west-2.amazonaws.com/freemius/plugins/2778/screenshots/0.png\";s:12:\"screenshot_1\";s:68:\"//s3-us-west-2.amazonaws.com/freemius/plugins/2778/screenshots/1.png\";s:12:\"screenshot_2\";s:68:\"//s3-us-west-2.amazonaws.com/freemius/plugins/2778/screenshots/2.png\";s:12:\"screenshot_3\";s:68:\"//s3-us-west-2.amazonaws.com/freemius/plugins/2778/screenshots/3.png\";}s:2:\"id\";s:3:\"461\";s:7:\"updated\";s:19:\"2018-11-04 14:51:57\";s:7:\"created\";s:19:\"2018-10-27 18:51:17\";s:22:\"\0FS_Entity\0_is_updated\";b:0;}s:10:\"is_premium\";b:0;s:14:\"premium_suffix\";s:9:\"(Premium)\";s:7:\"is_live\";b:1;s:9:\"bundle_id\";N;s:10:\"public_key\";s:32:\"pk_51a377c83c983c2a2ee03bf0d3c70\";s:10:\"secret_key\";N;s:2:\"id\";s:4:\"2778\";s:7:\"updated\";s:19:\"2020-03-10 10:31:57\";s:7:\"created\";s:19:\"2018-10-27 15:59:32\";s:22:\"\0FS_Entity\0_is_updated\";b:0;}}}}", "yes");
INSERT INTO `wp_options` VALUES("441", "fs_gdpr", "a:1:{s:2:\"u1\";a:1:{s:8:\"required\";b:0;}}", "yes");
INSERT INTO `wp_options` VALUES("442", "fs_api_cache", "a:0:{}", "no");
INSERT INTO `wp_options` VALUES("449", "redux_version_upgraded_from", "3.6.16", "yes");
INSERT INTO `wp_options` VALUES("450", "divipreloader_opts", "a:9:{s:8:\"last_tab\";s:0:\"\";s:26:\"opt-site-display-preloader\";s:1:\"1\";s:34:\"opt-site-home-pg-display-preloader\";s:1:\"1\";s:27:\"opt-select-animation-effect\";s:7:\"fade_in\";s:26:\"opt-select-animation-speed\";s:4:\"slow\";s:24:\"opt-preloader-delay-time\";s:0:\"\";s:26:\"opt-preloader-body-opacity\";s:0:\"\";s:28:\"opt-divipreloader-css-editor\";s:0:\"\";s:25:\"opt-site-select-preloader\";s:1:\"1\";}", "yes");
INSERT INTO `wp_options` VALUES("451", "divipreloader_opts-transients", "a:2:{s:14:\"changed_values\";a:0:{}s:9:\"last_save\";i:1583839899;}", "yes");
INSERT INTO `wp_options` VALUES("460", "et_divi_100_custom_hamburger_menu", "s:114:\"a:4:{s:4:\"type\";s:1:\"3\";s:5:\"style\";s:1:\"3\";s:13:\"default-color\";s:7:\"#1e73be\";s:12:\"active-color\";s:7:\"#8224e3\";}\";", "yes");
INSERT INTO `wp_options` VALUES("471", "widget_ds_suit_blurb", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("489", "external_updates-divi-module-mate", "O:8:\"stdClass\":3:{s:9:\"lastCheck\";i:1583840348;s:14:\"checkedVersion\";s:3:\"1.0\";s:6:\"update\";O:8:\"stdClass\":6:{s:2:\"id\";i:0;s:4:\"slug\";s:16:\"divi-module-mate\";s:7:\"version\";s:5:\"1.0.5\";s:8:\"homepage\";N;s:12:\"download_url\";s:62:\"https://dansupdates.com/?action=download&slug=divi-module-mate\";s:14:\"upgrade_notice\";N;}}", "no");
INSERT INTO `wp_options` VALUES("505", "dsm-supreme-modules-for-divi-activation-date", "1583841441", "no");
INSERT INTO `wp_options` VALUES("510", "dsm_general", "a:3:{s:25:\"dsm_use_scheduled_content\";s:3:\"off\";s:21:\"dsm_use_header_footer\";s:3:\"off\";s:17:\"dsm_use_shortcode\";s:3:\"off\";}", "yes");
INSERT INTO `wp_options` VALUES("511", "dsm_settings_social_media", "", "yes");
INSERT INTO `wp_options` VALUES("512", "dsm_settings_misc", "a:1:{s:23:\"dsm_uninstall_on_delete\";s:3:\"off\";}", "yes");
INSERT INTO `wp_options` VALUES("560", "theme_mods_Divi", "a:6:{i:0;b:0;s:18:\"nav_menu_locations\";a:2:{s:12:\"primary-menu\";i:5;s:14:\"secondary-menu\";i:6;}s:16:\"et_pb_css_synced\";s:3:\"yes\";s:39:\"et_updated_layouts_built_for_post_types\";s:3:\"yes\";s:18:\"custom_css_post_id\";i:-1;s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1583931906;s:4:\"data\";a:8:{s:19:\"wp_inactive_widgets\";a:3:{i:0;s:10:\"archives-2\";i:1;s:6:\"meta-2\";i:2;s:12:\"categories-2\";}s:9:\"sidebar-1\";a:3:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:17:\"recent-comments-2\";}s:9:\"sidebar-2\";a:0:{}s:9:\"sidebar-3\";a:0:{}s:9:\"sidebar-4\";a:0:{}s:9:\"sidebar-5\";a:0:{}s:9:\"sidebar-6\";a:0:{}s:9:\"sidebar-7\";a:0:{}}}}", "yes");
INSERT INTO `wp_options` VALUES("570", "menu_icons_review_flag", "no", "yes");
INSERT INTO `wp_options` VALUES("866", "_transient_themeisle_sdk_feed_items", "a:5:{i:0;a:3:{s:5:\"title\";s:63:\"000webhost Review for WordPress: Does Free Hosting Really Work?\";s:4:\"date\";i:1584530400;s:4:\"link\";s:45:\"https://themeisle.com/blog/000webhost-review/\";}i:1;a:3:{s:5:\"title\";s:57:\"What Are HTTP Error Codes? Common Codes + How to Fix Them\";s:4:\"date\";i:1584439752;s:4:\"link\";s:53:\"https://themeisle.com/blog/what-are-http-error-codes/\";}i:2;a:3:{s:5:\"title\";s:63:\"How to Use the Google Site Kit WordPress Plugin (Full Tutorial)\";s:4:\"date\";i:1584352740;s:4:\"link\";s:60:\"https://themeisle.com/blog/google-site-kit-wordpress-plugin/\";}i:3;a:3:{s:5:\"title\";s:70:\"10 Best Business WordPress Themes in 2020 (Tested &amp; Expert-Picked)\";s:4:\"date\";i:1584007140;s:4:\"link\";s:58:\"https://themeisle.com/blog/best-business-wordpress-themes/\";}i:4;a:3:{s:5:\"title\";s:62:\"3 Best WordPress Maintenance Services, Plus Are They Worth It?\";s:4:\"date\";i:1583920740;s:4:\"link\";s:58:\"https://themeisle.com/blog/wordpress-maintenance-services/\";}}", "no");
INSERT INTO `wp_options` VALUES("937", "menu_icons_translate_flag", "no", "yes");
INSERT INTO `wp_options` VALUES("978", "widget_t20_slider_widget", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("1081", "wp-optimize-newly-activated", "1", "yes");
INSERT INTO `wp_options` VALUES("1091", "wpo_update_version", "3.0.18", "yes");
INSERT INTO `wp_options` VALUES("1092", "updraft_task_manager_dbversion", "1.1", "yes");
INSERT INTO `wp_options` VALUES("1098", "wp-optimize-install-or-update-notice-show-time", "1584985630", "yes");
INSERT INTO `wp_options` VALUES("1099", "wp-optimize-corrupted-tables-count", "0", "yes");
INSERT INTO `wp_options` VALUES("1101", "wp-optimize-enable-auto-backup", "false", "yes");
INSERT INTO `wp_options` VALUES("1103", "wpo_cache_config", "a:16:{s:19:\"enable_page_caching\";b:0;s:23:\"page_cache_length_value\";i:24;s:22:\"page_cache_length_unit\";s:5:\"hours\";s:17:\"page_cache_length\";i:86400;s:20:\"cache_exception_urls\";a:0:{}s:23:\"cache_exception_cookies\";a:0:{}s:30:\"cache_exception_browser_agents\";a:0:{}s:22:\"enable_sitemap_preload\";b:0;s:23:\"enable_schedule_preload\";b:0;s:21:\"preload_schedule_type\";s:0:\"\";s:21:\"enable_mobile_caching\";b:0;s:19:\"enable_user_caching\";b:0;s:8:\"site_url\";s:22:\"http://modelsite.test/\";s:24:\"enable_cache_per_country\";b:0;s:17:\"wpo_cache_cookies\";a:0:{}s:25:\"wpo_cache_query_variables\";a:0:{}}", "yes");
INSERT INTO `wp_options` VALUES("1217", "_site_transient_timeout_browser_b4046c447614dcbe06d949fe3062a42a", "1586001424", "no");
INSERT INTO `wp_options` VALUES("1218", "_site_transient_browser_b4046c447614dcbe06d949fe3062a42a", "a:10:{s:4:\"name\";s:6:\"Chrome\";s:7:\"version\";s:13:\"80.0.3987.149\";s:8:\"platform\";s:7:\"Windows\";s:10:\"update_url\";s:29:\"https://www.google.com/chrome\";s:7:\"img_src\";s:43:\"http://s.w.org/images/browsers/chrome.png?1\";s:11:\"img_src_ssl\";s:44:\"https://s.w.org/images/browsers/chrome.png?1\";s:15:\"current_version\";s:2:\"18\";s:7:\"upgrade\";b:0;s:8:\"insecure\";b:0;s:6:\"mobile\";b:0;}", "no");
INSERT INTO `wp_options` VALUES("1269", "menu_icons_logger_flag", "no", "yes");
INSERT INTO `wp_options` VALUES("1315", "_site_transient_update_core", "O:8:\"stdClass\":4:{s:7:\"updates\";a:3:{i:0;O:8:\"stdClass\":10:{s:8:\"response\";s:7:\"upgrade\";s:8:\"download\";s:63:\"https://downloads.wordpress.org/release/fa_IR/wordpress-5.4.zip\";s:6:\"locale\";s:5:\"fa_IR\";s:8:\"packages\";O:8:\"stdClass\":5:{s:4:\"full\";s:63:\"https://downloads.wordpress.org/release/fa_IR/wordpress-5.4.zip\";s:10:\"no_content\";b:0;s:11:\"new_bundled\";b:0;s:7:\"partial\";b:0;s:8:\"rollback\";b:0;}s:7:\"current\";s:3:\"5.4\";s:7:\"version\";s:3:\"5.4\";s:11:\"php_version\";s:6:\"5.6.20\";s:13:\"mysql_version\";s:3:\"5.0\";s:11:\"new_bundled\";s:3:\"5.3\";s:15:\"partial_version\";s:0:\"\";}i:1;O:8:\"stdClass\":10:{s:8:\"response\";s:7:\"upgrade\";s:8:\"download\";s:57:\"https://downloads.wordpress.org/release/wordpress-5.4.zip\";s:6:\"locale\";s:5:\"en_US\";s:8:\"packages\";O:8:\"stdClass\":5:{s:4:\"full\";s:57:\"https://downloads.wordpress.org/release/wordpress-5.4.zip\";s:10:\"no_content\";s:68:\"https://downloads.wordpress.org/release/wordpress-5.4-no-content.zip\";s:11:\"new_bundled\";s:69:\"https://downloads.wordpress.org/release/wordpress-5.4-new-bundled.zip\";s:7:\"partial\";b:0;s:8:\"rollback\";b:0;}s:7:\"current\";s:3:\"5.4\";s:7:\"version\";s:3:\"5.4\";s:11:\"php_version\";s:6:\"5.6.20\";s:13:\"mysql_version\";s:3:\"5.0\";s:11:\"new_bundled\";s:3:\"5.3\";s:15:\"partial_version\";s:0:\"\";}i:2;O:8:\"stdClass\":11:{s:8:\"response\";s:10:\"autoupdate\";s:8:\"download\";s:57:\"https://downloads.wordpress.org/release/wordpress-5.4.zip\";s:6:\"locale\";s:5:\"en_US\";s:8:\"packages\";O:8:\"stdClass\":5:{s:4:\"full\";s:57:\"https://downloads.wordpress.org/release/wordpress-5.4.zip\";s:10:\"no_content\";s:68:\"https://downloads.wordpress.org/release/wordpress-5.4-no-content.zip\";s:11:\"new_bundled\";s:69:\"https://downloads.wordpress.org/release/wordpress-5.4-new-bundled.zip\";s:7:\"partial\";b:0;s:8:\"rollback\";b:0;}s:7:\"current\";s:3:\"5.4\";s:7:\"version\";s:3:\"5.4\";s:11:\"php_version\";s:6:\"5.6.20\";s:13:\"mysql_version\";s:3:\"5.0\";s:11:\"new_bundled\";s:3:\"5.3\";s:15:\"partial_version\";s:0:\"\";s:9:\"new_files\";s:1:\"1\";}}s:12:\"last_checked\";i:1585907647;s:15:\"version_checked\";s:5:\"5.3.2\";s:12:\"translations\";a:0:{}}", "no");
INSERT INTO `wp_options` VALUES("1316", "_site_transient_update_plugins", "O:8:\"stdClass\":5:{s:12:\"last_checked\";i:1585907651;s:7:\"checked\";a:6:{s:25:\"duplicator/duplicator.php\";s:6:\"1.3.28\";s:25:\"menu-icons/menu-icons.php\";s:6:\"0.12.2\";s:19:\"monarch/monarch.php\";s:6:\"1.4.12\";s:53:\"supreme-modules-for-divi/supreme-modules-for-divi.php\";s:5:\"1.9.6\";s:41:\"wordpress-importer/wordpress-importer.php\";s:3:\"0.7\";s:29:\"wp-parsidate/wp-parsidate.php\";s:5:\"3.0.3\";}s:8:\"response\";a:0:{}s:12:\"translations\";a:0:{}s:9:\"no_update\";a:5:{s:25:\"duplicator/duplicator.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:24:\"w.org/plugins/duplicator\";s:4:\"slug\";s:10:\"duplicator\";s:6:\"plugin\";s:25:\"duplicator/duplicator.php\";s:11:\"new_version\";s:6:\"1.3.28\";s:3:\"url\";s:41:\"https://wordpress.org/plugins/duplicator/\";s:7:\"package\";s:60:\"https://downloads.wordpress.org/plugin/duplicator.1.3.28.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:63:\"https://ps.w.org/duplicator/assets/icon-256x256.png?rev=2083921\";s:2:\"1x\";s:63:\"https://ps.w.org/duplicator/assets/icon-128x128.png?rev=2083921\";}s:7:\"banners\";a:1:{s:2:\"1x\";s:65:\"https://ps.w.org/duplicator/assets/banner-772x250.png?rev=2085472\";}s:11:\"banners_rtl\";a:0:{}}s:25:\"menu-icons/menu-icons.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:24:\"w.org/plugins/menu-icons\";s:4:\"slug\";s:10:\"menu-icons\";s:6:\"plugin\";s:25:\"menu-icons/menu-icons.php\";s:11:\"new_version\";s:6:\"0.12.2\";s:3:\"url\";s:41:\"https://wordpress.org/plugins/menu-icons/\";s:7:\"package\";s:53:\"https://downloads.wordpress.org/plugin/menu-icons.zip\";s:5:\"icons\";a:1:{s:2:\"1x\";s:63:\"https://ps.w.org/menu-icons/assets/icon-128x128.png?rev=1797515\";}s:7:\"banners\";a:1:{s:2:\"1x\";s:65:\"https://ps.w.org/menu-icons/assets/banner-772x250.png?rev=1797515\";}s:11:\"banners_rtl\";a:0:{}}s:53:\"supreme-modules-for-divi/supreme-modules-for-divi.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:38:\"w.org/plugins/supreme-modules-for-divi\";s:4:\"slug\";s:24:\"supreme-modules-for-divi\";s:6:\"plugin\";s:53:\"supreme-modules-for-divi/supreme-modules-for-divi.php\";s:11:\"new_version\";s:5:\"1.9.6\";s:3:\"url\";s:55:\"https://wordpress.org/plugins/supreme-modules-for-divi/\";s:7:\"package\";s:73:\"https://downloads.wordpress.org/plugin/supreme-modules-for-divi.1.9.6.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:77:\"https://ps.w.org/supreme-modules-for-divi/assets/icon-256x256.png?rev=1952630\";s:2:\"1x\";s:77:\"https://ps.w.org/supreme-modules-for-divi/assets/icon-128x128.png?rev=1952630\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:80:\"https://ps.w.org/supreme-modules-for-divi/assets/banner-1544x500.png?rev=2247885\";s:2:\"1x\";s:79:\"https://ps.w.org/supreme-modules-for-divi/assets/banner-772x250.png?rev=2247885\";}s:11:\"banners_rtl\";a:0:{}}s:41:\"wordpress-importer/wordpress-importer.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:32:\"w.org/plugins/wordpress-importer\";s:4:\"slug\";s:18:\"wordpress-importer\";s:6:\"plugin\";s:41:\"wordpress-importer/wordpress-importer.php\";s:11:\"new_version\";s:3:\"0.7\";s:3:\"url\";s:49:\"https://wordpress.org/plugins/wordpress-importer/\";s:7:\"package\";s:65:\"https://downloads.wordpress.org/plugin/wordpress-importer.0.7.zip\";s:5:\"icons\";a:3:{s:2:\"2x\";s:71:\"https://ps.w.org/wordpress-importer/assets/icon-256x256.png?rev=1908375\";s:2:\"1x\";s:63:\"https://ps.w.org/wordpress-importer/assets/icon.svg?rev=1908375\";s:3:\"svg\";s:63:\"https://ps.w.org/wordpress-importer/assets/icon.svg?rev=1908375\";}s:7:\"banners\";a:1:{s:2:\"1x\";s:72:\"https://ps.w.org/wordpress-importer/assets/banner-772x250.png?rev=547654\";}s:11:\"banners_rtl\";a:0:{}}s:29:\"wp-parsidate/wp-parsidate.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:26:\"w.org/plugins/wp-parsidate\";s:4:\"slug\";s:12:\"wp-parsidate\";s:6:\"plugin\";s:29:\"wp-parsidate/wp-parsidate.php\";s:11:\"new_version\";s:5:\"3.0.3\";s:3:\"url\";s:43:\"https://wordpress.org/plugins/wp-parsidate/\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/plugin/wp-parsidate.3.0.3.zip\";s:5:\"icons\";a:2:{s:2:\"1x\";s:57:\"https://ps.w.org/wp-parsidate/assets/icon.svg?rev=1036248\";s:3:\"svg\";s:57:\"https://ps.w.org/wp-parsidate/assets/icon.svg?rev=1036248\";}s:7:\"banners\";a:1:{s:2:\"1x\";s:67:\"https://ps.w.org/wp-parsidate/assets/banner-772x250.jpg?rev=2044005\";}s:11:\"banners_rtl\";a:0:{}}}}", "no");
INSERT INTO `wp_options` VALUES("1317", "_site_transient_update_themes", "O:8:\"stdClass\":4:{s:12:\"last_checked\";i:1585907651;s:7:\"checked\";a:2:{s:23:\"Divi-Child-Theme-master\";s:1:\"1\";s:4:\"Divi\";s:5:\"4.4.2\";}s:8:\"response\";a:0:{}s:12:\"translations\";a:0:{}}", "no");
INSERT INTO `wp_options` VALUES("1333", "_transient_timeout_menu_icons_0122versions", "1586011135", "no");
INSERT INTO `wp_options` VALUES("1334", "_transient_menu_icons_0122versions", "a:34:{i:0;a:2:{s:7:\"version\";s:5:\"0.1.0\";s:3:\"url\";s:59:\"https://downloads.wordpress.org/plugin/menu-icons.0.1.0.zip\";}i:1;a:2:{s:7:\"version\";s:5:\"0.1.1\";s:3:\"url\";s:59:\"https://downloads.wordpress.org/plugin/menu-icons.0.1.1.zip\";}i:2;a:2:{s:7:\"version\";s:5:\"0.1.2\";s:3:\"url\";s:59:\"https://downloads.wordpress.org/plugin/menu-icons.0.1.2.zip\";}i:3;a:2:{s:7:\"version\";s:5:\"0.1.3\";s:3:\"url\";s:59:\"https://downloads.wordpress.org/plugin/menu-icons.0.1.3.zip\";}i:4;a:2:{s:7:\"version\";s:5:\"0.1.4\";s:3:\"url\";s:59:\"https://downloads.wordpress.org/plugin/menu-icons.0.1.4.zip\";}i:5;a:2:{s:7:\"version\";s:5:\"0.1.5\";s:3:\"url\";s:59:\"https://downloads.wordpress.org/plugin/menu-icons.0.1.5.zip\";}i:6;a:2:{s:7:\"version\";s:6:\"0.10.0\";s:3:\"url\";s:60:\"https://downloads.wordpress.org/plugin/menu-icons.0.10.0.zip\";}i:7;a:2:{s:7:\"version\";s:6:\"0.10.1\";s:3:\"url\";s:60:\"https://downloads.wordpress.org/plugin/menu-icons.0.10.1.zip\";}i:8;a:2:{s:7:\"version\";s:6:\"0.10.2\";s:3:\"url\";s:60:\"https://downloads.wordpress.org/plugin/menu-icons.0.10.2.zip\";}i:9;a:2:{s:7:\"version\";s:6:\"0.11.0\";s:3:\"url\";s:60:\"https://downloads.wordpress.org/plugin/menu-icons.0.11.0.zip\";}i:10;a:2:{s:7:\"version\";s:6:\"0.11.1\";s:3:\"url\";s:60:\"https://downloads.wordpress.org/plugin/menu-icons.0.11.1.zip\";}i:11;a:2:{s:7:\"version\";s:6:\"0.11.2\";s:3:\"url\";s:60:\"https://downloads.wordpress.org/plugin/menu-icons.0.11.2.zip\";}i:12;a:2:{s:7:\"version\";s:6:\"0.11.3\";s:3:\"url\";s:60:\"https://downloads.wordpress.org/plugin/menu-icons.0.11.3.zip\";}i:13;a:2:{s:7:\"version\";s:6:\"0.11.4\";s:3:\"url\";s:60:\"https://downloads.wordpress.org/plugin/menu-icons.0.11.4.zip\";}i:14;a:2:{s:7:\"version\";s:6:\"0.11.5\";s:3:\"url\";s:60:\"https://downloads.wordpress.org/plugin/menu-icons.0.11.5.zip\";}i:15;a:2:{s:7:\"version\";s:6:\"0.12.0\";s:3:\"url\";s:60:\"https://downloads.wordpress.org/plugin/menu-icons.0.12.0.zip\";}i:16;a:2:{s:7:\"version\";s:6:\"0.12.1\";s:3:\"url\";s:60:\"https://downloads.wordpress.org/plugin/menu-icons.0.12.1.zip\";}i:17;a:2:{s:7:\"version\";s:6:\"0.12.2\";s:3:\"url\";s:60:\"https://downloads.wordpress.org/plugin/menu-icons.0.12.2.zip\";}i:18;a:2:{s:7:\"version\";s:5:\"0.2.0\";s:3:\"url\";s:59:\"https://downloads.wordpress.org/plugin/menu-icons.0.2.0.zip\";}i:19;a:2:{s:7:\"version\";s:5:\"0.2.1\";s:3:\"url\";s:59:\"https://downloads.wordpress.org/plugin/menu-icons.0.2.1.zip\";}i:20;a:2:{s:7:\"version\";s:5:\"0.2.2\";s:3:\"url\";s:59:\"https://downloads.wordpress.org/plugin/menu-icons.0.2.2.zip\";}i:21;a:2:{s:7:\"version\";s:5:\"0.2.3\";s:3:\"url\";s:59:\"https://downloads.wordpress.org/plugin/menu-icons.0.2.3.zip\";}i:22;a:2:{s:7:\"version\";s:5:\"0.3.0\";s:3:\"url\";s:59:\"https://downloads.wordpress.org/plugin/menu-icons.0.3.0.zip\";}i:23;a:2:{s:7:\"version\";s:5:\"0.3.1\";s:3:\"url\";s:59:\"https://downloads.wordpress.org/plugin/menu-icons.0.3.1.zip\";}i:24;a:2:{s:7:\"version\";s:5:\"0.3.2\";s:3:\"url\";s:59:\"https://downloads.wordpress.org/plugin/menu-icons.0.3.2.zip\";}i:25;a:2:{s:7:\"version\";s:5:\"0.4.0\";s:3:\"url\";s:59:\"https://downloads.wordpress.org/plugin/menu-icons.0.4.0.zip\";}i:26;a:2:{s:7:\"version\";s:5:\"0.5.0\";s:3:\"url\";s:59:\"https://downloads.wordpress.org/plugin/menu-icons.0.5.0.zip\";}i:27;a:2:{s:7:\"version\";s:5:\"0.5.1\";s:3:\"url\";s:59:\"https://downloads.wordpress.org/plugin/menu-icons.0.5.1.zip\";}i:28;a:2:{s:7:\"version\";s:5:\"0.6.0\";s:3:\"url\";s:59:\"https://downloads.wordpress.org/plugin/menu-icons.0.6.0.zip\";}i:29;a:2:{s:7:\"version\";s:5:\"0.7.0\";s:3:\"url\";s:59:\"https://downloads.wordpress.org/plugin/menu-icons.0.7.0.zip\";}i:30;a:2:{s:7:\"version\";s:5:\"0.8.0\";s:3:\"url\";s:59:\"https://downloads.wordpress.org/plugin/menu-icons.0.8.0.zip\";}i:31;a:2:{s:7:\"version\";s:5:\"0.8.1\";s:3:\"url\";s:59:\"https://downloads.wordpress.org/plugin/menu-icons.0.8.1.zip\";}i:32;a:2:{s:7:\"version\";s:5:\"0.9.0\";s:3:\"url\";s:59:\"https://downloads.wordpress.org/plugin/menu-icons.0.9.0.zip\";}i:33;a:2:{s:7:\"version\";s:5:\"0.9.2\";s:3:\"url\";s:59:\"https://downloads.wordpress.org/plugin/menu-icons.0.9.2.zip\";}}", "no");
INSERT INTO `wp_options` VALUES("1342", "_transient_timeout_et_core_version", "1585993755", "no");
INSERT INTO `wp_options` VALUES("1343", "_transient_et_core_version", "4.4.2", "no");
INSERT INTO `wp_options` VALUES("1373", "_site_transient_timeout_browser_6383500a15e638e5fbbff985e45be4aa", "1586415164", "no");
INSERT INTO `wp_options` VALUES("1374", "_site_transient_browser_6383500a15e638e5fbbff985e45be4aa", "a:10:{s:4:\"name\";s:6:\"Chrome\";s:7:\"version\";s:13:\"80.0.3987.162\";s:8:\"platform\";s:7:\"Windows\";s:10:\"update_url\";s:29:\"https://www.google.com/chrome\";s:7:\"img_src\";s:43:\"http://s.w.org/images/browsers/chrome.png?1\";s:11:\"img_src_ssl\";s:44:\"https://s.w.org/images/browsers/chrome.png?1\";s:15:\"current_version\";s:2:\"18\";s:7:\"upgrade\";b:0;s:8:\"insecure\";b:0;s:6:\"mobile\";b:0;}", "no");
INSERT INTO `wp_options` VALUES("1398", "_transient_timeout_et_divi_customizer_option_set", "1585994988", "no");
INSERT INTO `wp_options` VALUES("1399", "_transient_et_divi_customizer_option_set", "theme", "no");
INSERT INTO `wp_options` VALUES("1407", "_transient_timeout_menu_icons_all_languages", "1586436223", "no");
INSERT INTO `wp_options` VALUES("1408", "_transient_menu_icons_all_languages", "a:1:{s:12:\"translations\";a:12:{i:0;a:7:{s:8:\"language\";s:5:\"cs_CZ\";s:7:\"version\";s:6:\"0.12.2\";s:7:\"updated\";s:19:\"2018-12-21 13:24:58\";s:12:\"english_name\";s:5:\"Czech\";s:11:\"native_name\";s:9:\"Čeština\";s:7:\"package\";s:78:\"https://downloads.wordpress.org/translation/plugin/menu-icons/0.12.2/cs_CZ.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"cs\";i:2;s:3:\"ces\";}}i:1;a:7:{s:8:\"language\";s:2:\"el\";s:7:\"version\";s:6:\"0.12.2\";s:7:\"updated\";s:19:\"2019-11-25 09:48:10\";s:12:\"english_name\";s:5:\"Greek\";s:11:\"native_name\";s:16:\"Ελληνικά\";s:7:\"package\";s:75:\"https://downloads.wordpress.org/translation/plugin/menu-icons/0.12.2/el.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"el\";i:2;s:3:\"ell\";}}i:2;a:7:{s:8:\"language\";s:5:\"en_GB\";s:7:\"version\";s:6:\"0.12.2\";s:7:\"updated\";s:19:\"2019-01-22 19:36:06\";s:12:\"english_name\";s:12:\"English (UK)\";s:11:\"native_name\";s:12:\"English (UK)\";s:7:\"package\";s:78:\"https://downloads.wordpress.org/translation/plugin/menu-icons/0.12.2/en_GB.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"en\";i:2;s:3:\"eng\";i:3;s:3:\"eng\";}}i:3;a:7:{s:8:\"language\";s:5:\"en_AU\";s:7:\"version\";s:6:\"0.12.2\";s:7:\"updated\";s:19:\"2019-07-02 22:43:48\";s:12:\"english_name\";s:19:\"English (Australia)\";s:11:\"native_name\";s:19:\"English (Australia)\";s:7:\"package\";s:78:\"https://downloads.wordpress.org/translation/plugin/menu-icons/0.12.2/en_AU.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"en\";i:2;s:3:\"eng\";i:3;s:3:\"eng\";}}i:4;a:7:{s:8:\"language\";s:5:\"en_CA\";s:7:\"version\";s:6:\"0.12.2\";s:7:\"updated\";s:19:\"2019-03-15 15:26:07\";s:12:\"english_name\";s:16:\"English (Canada)\";s:11:\"native_name\";s:16:\"English (Canada)\";s:7:\"package\";s:78:\"https://downloads.wordpress.org/translation/plugin/menu-icons/0.12.2/en_CA.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"en\";i:2;s:3:\"eng\";i:3;s:3:\"eng\";}}i:5;a:7:{s:8:\"language\";s:5:\"en_NZ\";s:7:\"version\";s:6:\"0.12.2\";s:7:\"updated\";s:19:\"2019-07-02 22:44:46\";s:12:\"english_name\";s:21:\"English (New Zealand)\";s:11:\"native_name\";s:21:\"English (New Zealand)\";s:7:\"package\";s:78:\"https://downloads.wordpress.org/translation/plugin/menu-icons/0.12.2/en_NZ.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"en\";i:2;s:3:\"eng\";i:3;s:3:\"eng\";}}i:6;a:7:{s:8:\"language\";s:5:\"es_VE\";s:7:\"version\";s:6:\"0.12.2\";s:7:\"updated\";s:19:\"2020-03-11 04:34:18\";s:12:\"english_name\";s:19:\"Spanish (Venezuela)\";s:11:\"native_name\";s:21:\"Español de Venezuela\";s:7:\"package\";s:78:\"https://downloads.wordpress.org/translation/plugin/menu-icons/0.12.2/es_VE.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"es\";i:2;s:3:\"spa\";i:3;s:3:\"spa\";}}i:7;a:7:{s:8:\"language\";s:5:\"es_ES\";s:7:\"version\";s:6:\"0.12.2\";s:7:\"updated\";s:19:\"2018-03-05 15:56:25\";s:12:\"english_name\";s:15:\"Spanish (Spain)\";s:11:\"native_name\";s:8:\"Español\";s:7:\"package\";s:78:\"https://downloads.wordpress.org/translation/plugin/menu-icons/0.12.2/es_ES.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"es\";i:2;s:3:\"spa\";i:3;s:3:\"spa\";}}i:8;a:7:{s:8:\"language\";s:5:\"ro_RO\";s:7:\"version\";s:6:\"0.12.2\";s:7:\"updated\";s:19:\"2019-02-07 18:19:47\";s:12:\"english_name\";s:8:\"Romanian\";s:11:\"native_name\";s:8:\"Română\";s:7:\"package\";s:78:\"https://downloads.wordpress.org/translation/plugin/menu-icons/0.12.2/ro_RO.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ro\";i:2;s:3:\"ron\";}}i:9;a:7:{s:8:\"language\";s:5:\"ru_RU\";s:7:\"version\";s:6:\"0.11.2\";s:7:\"updated\";s:19:\"2016-06-10 02:31:27\";s:12:\"english_name\";s:7:\"Russian\";s:11:\"native_name\";s:14:\"Русский\";s:7:\"package\";s:78:\"https://downloads.wordpress.org/translation/plugin/menu-icons/0.11.2/ru_RU.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ru\";i:2;s:3:\"rus\";}}i:10;a:7:{s:8:\"language\";s:5:\"sk_SK\";s:7:\"version\";s:6:\"0.12.2\";s:7:\"updated\";s:19:\"2019-06-20 17:06:02\";s:12:\"english_name\";s:6:\"Slovak\";s:11:\"native_name\";s:11:\"Slovenčina\";s:7:\"package\";s:78:\"https://downloads.wordpress.org/translation/plugin/menu-icons/0.12.2/sk_SK.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"sk\";i:2;s:3:\"slk\";}}i:11;a:7:{s:8:\"language\";s:5:\"sv_SE\";s:7:\"version\";s:6:\"0.12.2\";s:7:\"updated\";s:19:\"2019-10-25 16:12:02\";s:12:\"english_name\";s:7:\"Swedish\";s:11:\"native_name\";s:7:\"Svenska\";s:7:\"package\";s:78:\"https://downloads.wordpress.org/translation/plugin/menu-icons/0.12.2/sv_SE.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"sv\";i:2;s:3:\"swe\";}}}}", "no");
INSERT INTO `wp_options` VALUES("1414", "_transient_timeout_et_core_path", "1585993754", "no");
INSERT INTO `wp_options` VALUES("1415", "_transient_et_core_path", "C:/laragon/www/modelsite/wp-content/themes/Divi/core", "no");
INSERT INTO `wp_options` VALUES("1417", "_site_transient_timeout_php_check_73ecd64509db505b6046b20394d377da", "1586512258", "no");
INSERT INTO `wp_options` VALUES("1418", "_site_transient_php_check_73ecd64509db505b6046b20394d377da", "a:5:{s:19:\"recommended_version\";s:3:\"7.3\";s:15:\"minimum_version\";s:6:\"5.6.20\";s:12:\"is_supported\";b:1;s:9:\"is_secure\";b:1;s:13:\"is_acceptable\";b:1;}", "no");
INSERT INTO `wp_options` VALUES("1419", "_transient_timeout_themeisle_sdk_products", "1585929062", "no");
INSERT INTO `wp_options` VALUES("1420", "_transient_themeisle_sdk_products", "a:7:{i:0;a:4:{s:4:\"name\";s:4:\"Neve\";s:4:\"type\";s:5:\"theme\";s:4:\"slug\";s:4:\"neve\";s:8:\"installs\";i:100000;}i:1;a:4:{s:4:\"name\";s:6:\"Hestia\";s:4:\"type\";s:5:\"theme\";s:4:\"slug\";s:6:\"hestia\";s:8:\"installs\";i:100000;}i:2;a:4:{s:4:\"name\";s:46:\"Gutenberg Blocks and Template Library by Otter\";s:4:\"type\";s:6:\"plugin\";s:4:\"slug\";s:12:\"otter-blocks\";s:8:\"installs\";i:50000;}i:3;a:4:{s:4:\"name\";s:22:\"Orbit Fox by ThemeIsle\";s:4:\"type\";s:6:\"plugin\";s:4:\"slug\";s:19:\"themeisle-companion\";s:8:\"installs\";i:400000;}i:4;a:4:{s:4:\"name\";s:77:\"RSS Aggregator by Feedzy &#8211; Powerful WP Autoblogging and News Aggregator\";s:4:\"type\";s:6:\"plugin\";s:4:\"slug\";s:16:\"feedzy-rss-feeds\";s:8:\"installs\";i:40000;}i:5;a:4:{s:4:\"name\";s:51:\"Visualizer: Tables and Charts Manager for WordPress\";s:4:\"type\";s:6:\"plugin\";s:4:\"slug\";s:10:\"visualizer\";s:8:\"installs\";i:40000;}i:6;a:4:{s:4:\"name\";s:22:\"WP Product Review Lite\";s:4:\"type\";s:6:\"plugin\";s:4:\"slug\";s:17:\"wp-product-review\";s:8:\"installs\";i:40000;}}", "no");
INSERT INTO `wp_options` VALUES("1421", "_site_transient_timeout_community-events-1aecf33ab8525ff212ebdffbb438372e", "1585950666", "no");
INSERT INTO `wp_options` VALUES("1422", "_site_transient_community-events-1aecf33ab8525ff212ebdffbb438372e", "a:3:{s:9:\"sandboxed\";b:0;s:8:\"location\";a:1:{s:2:\"ip\";s:9:\"127.0.0.0\";}s:6:\"events\";a:0:{}}", "no");
INSERT INTO `wp_options` VALUES("1423", "_transient_timeout_feed_1a35a986d21ecac6e67e45f5050a2d43", "1585950667", "no");
INSERT INTO `wp_options` VALUES("1424", "_transient_feed_1a35a986d21ecac6e67e45f5050a2d43", "a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n\n\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:49:\"\n	\n	\n	\n	\n	\n	\n	\n	\n	\n	\n		\n		\n		\n		\n		\n		\n		\n		\n		\n	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:3:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:23:\"وردپرس پارسی\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:20:\"https://wp-parsi.com\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:13:\"lastBuildDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 07 Feb 2020 17:49:32 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"fa-IR\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:9:\"generator\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://wordpress.org/?v=5.3.2\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:10:{i:0;a:6:{s:4:\"data\";s:54:\"\n		\n		\n				\n				\n		\n				\n		\n\n		\n				\n						\n		\n							\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:72:\"برگزاری پنجمین رویداد آینده وب و موبایل\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:220:\"https://wp-parsi.com/%d8%a8%d8%b1%da%af%d8%b2%d8%a7%d8%b1%db%8c-%d9%be%d9%86%d8%ac%d9%85%db%8c%d9%86-%d8%b1%d9%88%db%8c%d8%af%d8%a7%d8%af-%d8%a2%db%8c%d9%86%d8%af%d9%87-%d9%88%d8%a8-%d9%88-%d9%85%d9%88%d8%a8%d8%a7%db%8c/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:228:\"https://wp-parsi.com/%d8%a8%d8%b1%da%af%d8%b2%d8%a7%d8%b1%db%8c-%d9%be%d9%86%d8%ac%d9%85%db%8c%d9%86-%d8%b1%d9%88%db%8c%d8%af%d8%a7%d8%af-%d8%a2%db%8c%d9%86%d8%af%d9%87-%d9%88%d8%a8-%d9%88-%d9%85%d9%88%d8%a8%d8%a7%db%8c/#respond\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 07 Feb 2020 17:40:45 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:30:\"خبرها و رویدادها\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:16:\"رویدادها\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:27:\"https://wp-parsi.com/?p=700\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:956:\"<p>روﯾﺪاد آﯾﻨﺪه وب و ﻣﻮﺑﺎﯾﻞ ﯾﮏ روﯾﺪاد ﺳﺎﻻﻧﻪ است که در روزهای ۸ و ۹ اسفند سال ۹۸، پنجمین دوره آن به مدت دو روز در مجموعه فرهنگی حجاب واقع در خیابان فاطمی تهران برگزار خواهد شد. این رویداد از دو بخش همایش و نمایشگاه تشکیل می‌شود که در دو روز پایانی هفته (پنج شنبه [&#8230;]</p>\n<p>نوشته <a rel=\"nofollow\" href=\"https://wp-parsi.com/%d8%a8%d8%b1%da%af%d8%b2%d8%a7%d8%b1%db%8c-%d9%be%d9%86%d8%ac%d9%85%db%8c%d9%86-%d8%b1%d9%88%db%8c%d8%af%d8%a7%d8%af-%d8%a2%db%8c%d9%86%d8%af%d9%87-%d9%88%d8%a8-%d9%88-%d9%85%d9%88%d8%a8%d8%a7%db%8c/\">برگزاری پنجمین رویداد آینده وب و موبایل</a> اولین بار در <a rel=\"nofollow\" href=\"https://wp-parsi.com\">وردپرس پارسی</a> پدیدار شد.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"سعید فرد\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:225:\"https://wp-parsi.com/%d8%a8%d8%b1%da%af%d8%b2%d8%a7%d8%b1%db%8c-%d9%be%d9%86%d8%ac%d9%85%db%8c%d9%86-%d8%b1%d9%88%db%8c%d8%af%d8%a7%d8%af-%d8%a2%db%8c%d9%86%d8%af%d9%87-%d9%88%d8%a8-%d9%88-%d9%85%d9%88%d8%a8%d8%a7%db%8c/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:54:\"\n		\n		\n				\n				\n		\n				\n		\n\n		\n				\n						\n		\n							\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:49:\"برگزاری دومین همایش فریلند\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"https://wp-parsi.com/freelanday/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:40:\"https://wp-parsi.com/freelanday/#respond\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 22 Aug 2019 14:26:35 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:30:\"خبرها و رویدادها\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:16:\"رویدادها\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:27:\"https://wp-parsi.com/?p=681\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:791:\"<p>دومین همایش فریلند با رویکرد آموزش اصول فریلنسینگ، ۲۸ و ۲۹ شهریور در منطقه آزاد انزلی برگزار می‌شود. در این همایش افراد علاقه‌مند یاد می‌گیرند چطور کار کردن به شیوه فریلنسینگ به عنوان یک کار تمام وقت و حرفه‌ای را شروع کنند، مشتریان خود را بیابند، خودشان را معرفی کنند و بدون استخدام شدن در [&#8230;]</p>\n<p>نوشته <a rel=\"nofollow\" href=\"https://wp-parsi.com/freelanday/\">برگزاری دومین همایش فریلند</a> اولین بار در <a rel=\"nofollow\" href=\"https://wp-parsi.com\">وردپرس پارسی</a> پدیدار شد.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"سعید فرد\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:37:\"https://wp-parsi.com/freelanday/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:60:\"\n		\n		\n				\n				\n		\n				\n		\n		\n		\n\n		\n				\n						\n		\n							\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:38:\"افزونه تلگرام وردپرس\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:37:\"https://wp-parsi.com/wp-telegram-pro/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:46:\"https://wp-parsi.com/wp-telegram-pro/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 11 Apr 2019 07:07:50 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:4:{i:0;a:5:{s:4:\"data\";s:19:\"افزونه‌ها\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:15:\"WP Telegram Pro\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:19:\"بات تلگرام\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:3;a:5:{s:4:\"data\";s:12:\"تلگرام\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:27:\"https://wp-parsi.com/?p=672\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:784:\"<p>وردپرس/WordPress سیستم مدیریت محتوای محبوبی است که اکنون ۳۳٪ از دنیای وب را به خود اختصاص داده و امکانات خوبی برای توسعه بیشتر به عنوان یک برنامه تحت وب را در اختیار کاربران قرار می‌دهد. شما می‌توانید با افزونه WP Telegram Pro امکان مرور نوشته‌ها، دسته‌ها، محصولات (ووکامرس / Woocommerce) و امکان خرید را به [&#8230;]</p>\n<p>نوشته <a rel=\"nofollow\" href=\"https://wp-parsi.com/wp-telegram-pro/\">افزونه تلگرام وردپرس</a> اولین بار در <a rel=\"nofollow\" href=\"https://wp-parsi.com\">وردپرس پارسی</a> پدیدار شد.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:19:\"پارسا کافی\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:42:\"https://wp-parsi.com/wp-telegram-pro/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:2:\"24\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:54:\"\n		\n		\n				\n				\n		\n				\n		\n\n		\n				\n						\n		\n							\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:94:\"آموزش پلاگین نویسی در وردپرس از صفر تا صد – قسمت دوم\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:222:\"https://wp-parsi.com/%d8%a2%d9%85%d9%88%d8%b2%d8%b4-%d9%be%d9%84%d8%a7%da%af%db%8c%d9%86-%d9%86%d9%88%db%8c%d8%b3%db%8c-%d8%af%d8%b1-%d9%88%d8%b1%d8%af%d9%be%d8%b1%d8%b3-%d8%a7%d8%b2-%d8%b5%d9%81%d8%b1-%d8%aa%d8%a7-%d8%b5/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:231:\"https://wp-parsi.com/%d8%a2%d9%85%d9%88%d8%b2%d8%b4-%d9%be%d9%84%d8%a7%da%af%db%8c%d9%86-%d9%86%d9%88%db%8c%d8%b3%db%8c-%d8%af%d8%b1-%d9%88%d8%b1%d8%af%d9%be%d8%b1%d8%b3-%d8%a7%d8%b2-%d8%b5%d9%81%d8%b1-%d8%aa%d8%a7-%d8%b5/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 19 Aug 2018 07:31:13 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:23:\"افزونه نویسی\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:33:\"مقالات و آموزش‌ها\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:27:\"https://wp-parsi.com/?p=584\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1073:\"<p>بخش دوم ایجاد صفحه در بخش مدیریت: برای افزودن صفحه به منوی ادمین وردپرس از هوک admin_menu استفاده میکنیم.هر منو دارای یک منوی اصلی وتعدادی زیر منو میباشد. برای ایجاد منوی اصلی از تابع add_menu_page استفاده میشود.توجه داشته باشید منوها به صورت پیشفرض در انتهای لیست منوهای بخش مدیریت وردپرس قرار خواهد گرفت. add_menu_page(page_title, menu_title, [&#8230;]</p>\n<p>نوشته <a rel=\"nofollow\" href=\"https://wp-parsi.com/%d8%a2%d9%85%d9%88%d8%b2%d8%b4-%d9%be%d9%84%d8%a7%da%af%db%8c%d9%86-%d9%86%d9%88%db%8c%d8%b3%db%8c-%d8%af%d8%b1-%d9%88%d8%b1%d8%af%d9%be%d8%b1%d8%b3-%d8%a7%d8%b2-%d8%b5%d9%81%d8%b1-%d8%aa%d8%a7-%d8%b5/\">آموزش پلاگین نویسی در وردپرس از صفر تا صد &#8211; قسمت دوم</a> اولین بار در <a rel=\"nofollow\" href=\"https://wp-parsi.com\">وردپرس پارسی</a> پدیدار شد.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:23:\"مبین قاسمپور\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:227:\"https://wp-parsi.com/%d8%a2%d9%85%d9%88%d8%b2%d8%b4-%d9%be%d9%84%d8%a7%da%af%db%8c%d9%86-%d9%86%d9%88%db%8c%d8%b3%db%8c-%d8%af%d8%b1-%d9%88%d8%b1%d8%af%d9%be%d8%b1%d8%b3-%d8%a7%d8%b2-%d8%b5%d9%81%d8%b1-%d8%aa%d8%a7-%d8%b5/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"3\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:54:\"\n		\n		\n				\n				\n		\n				\n		\n\n		\n				\n						\n		\n							\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:51:\"برگزاری چهارمین همایش Coder Conf\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"https://wp-parsi.com/coder-conf/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:40:\"https://wp-parsi.com/coder-conf/#respond\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 12 Jul 2018 15:00:54 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:30:\"خبرها و رویدادها\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:16:\"رویدادها\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:27:\"https://wp-parsi.com/?p=659\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:832:\"<p>کدرکانف هر سال در آخرین پنجشنبه مرداد با بورد‌های مختلفی برگزار می‌گردد،امسال نیز کدرکانف در همین تاریخ با حضور برنامه نویسان مطرح کشور در بورد تخصصی جاوااسکریپت برگزار خواهد شد، یک گردهمایی متفاوت با طعم Javascript. Coderconf هر سال نسبت به سال‌های گذشته با حضور برنامه‌نویسان پر رنگتر می‌شود. ما سعی کردیم هر ساله به [&#8230;]</p>\n<p>نوشته <a rel=\"nofollow\" href=\"https://wp-parsi.com/coder-conf/\">برگزاری چهارمین همایش Coder Conf</a> اولین بار در <a rel=\"nofollow\" href=\"https://wp-parsi.com\">وردپرس پارسی</a> پدیدار شد.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"سعید فرد\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:37:\"https://wp-parsi.com/coder-conf/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:75:\"\n		\n		\n				\n				\n		\n				\n		\n		\n		\n		\n		\n		\n		\n		\n\n		\n				\n						\n		\n							\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:69:\"پوشش زنده وردکمپ ۲۰۱۸ اروپا – صربستان\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:36:\"https://wp-parsi.com/wceu-2018-live/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:44:\"https://wp-parsi.com/wceu-2018-live/#respond\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 14 Jun 2018 22:52:40 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:9:{i:0;a:5:{s:4:\"data\";s:30:\"خبرها و رویدادها\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:16:\"رویدادها\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:10:\"irwprdcamp\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:3;a:5:{s:4:\"data\";s:8:\"wordcamp\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:4;a:5:{s:4:\"data\";s:13:\"wordcamp 2018\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:5;a:5:{s:4:\"data\";s:27:\"برگزاری وردکمپ\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:6;a:5:{s:4:\"data\";s:12:\"وردکمپ\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:7;a:5:{s:4:\"data\";s:23:\"وردکمپ ایران\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:8;a:5:{s:4:\"data\";s:21:\"وردکمپ چیست\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:27:\"https://wp-parsi.com/?p=619\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:819:\"<p>اگر کاربر وردپرس هستید حتما تا به حال اسم وردکمپ رو شنیدید، کمپ و دورهمی بزرگ توسعه‌دهنده‌ها و کاربران وردپرس که سالانه در کشورهای مختلف برگزار میشه تحت عنوان وردکمپ هستش که از سمت مراجع اصلی وردپرس حمایت و برگزار می‌شه. &#160; &#160; این‌ بار در سال ۲۰۱۸ وردکمپ اروپا در شهر بلگراد کشور صربستان [&#8230;]</p>\n<p>نوشته <a rel=\"nofollow\" href=\"https://wp-parsi.com/wceu-2018-live/\">پوشش زنده وردکمپ ۲۰۱۸ اروپا &#8211; صربستان</a> اولین بار در <a rel=\"nofollow\" href=\"https://wp-parsi.com\">وردپرس پارسی</a> پدیدار شد.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"سعید فرد\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:41:\"https://wp-parsi.com/wceu-2018-live/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:54:\"\n		\n		\n				\n				\n		\n				\n		\n\n		\n				\n						\n		\n							\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:50:\"پوشش زنده وردکمپ ۲۰۱۸ اروپا\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"https://wp-parsi.com/wceu-2018/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:40:\"https://wp-parsi.com/wceu-2018/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 11 Jun 2018 18:45:28 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:30:\"خبرها و رویدادها\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:16:\"رویدادها\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:27:\"https://wp-parsi.com/?p=589\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:434:\"<p>پوشش زنده وردکمپ 2018 اروپا، پوشش زنده و لحظه ای از برگزاری وردکمپ 2018 اروپا برای همه علاقمندان وردپرس</p>\n<p>نوشته <a rel=\"nofollow\" href=\"https://wp-parsi.com/wceu-2018/\">پوشش زنده وردکمپ ۲۰۱۸ اروپا</a> اولین بار در <a rel=\"nofollow\" href=\"https://wp-parsi.com\">وردپرس پارسی</a> پدیدار شد.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:19:\"مصطفی صوفی\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:36:\"https://wp-parsi.com/wceu-2018/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:63:\"\n		\n		\n				\n				\n		\n				\n		\n		\n		\n		\n\n		\n				\n						\n		\n							\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:39:\"لذت Deploy وردپرس با Bedrock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:51:\"https://wp-parsi.com/deploy-wordpress-with-bedrock/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"https://wp-parsi.com/deploy-wordpress-with-bedrock/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 08 May 2018 11:09:43 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:5:{i:0;a:5:{s:4:\"data\";s:33:\"مقالات و آموزش‌ها\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:7:\"Bedrock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:8:\"Composer\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:3;a:5:{s:4:\"data\";s:6:\"Deploy\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:4;a:5:{s:4:\"data\";s:3:\"Git\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:27:\"https://wp-parsi.com/?p=578\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:743:\"<p>Bedrock یکی از بهترین محصولات تیم Roots هست، با استفاده از این پلتفورم میتونید به راحتی یه دستی به ساختار ساده وردپرس بکشید و اون رو از حالت سنتی به یک ساختار مدرن تبدیل کنید. Bedrock از گیت و Composer پشتیبانی میکنه و دسترسی های نصب افزونه و ویرایش فایل رو از وردپرس میگیره و [&#8230;]</p>\n<p>نوشته <a rel=\"nofollow\" href=\"https://wp-parsi.com/deploy-wordpress-with-bedrock/\">لذت Deploy وردپرس با Bedrock</a> اولین بار در <a rel=\"nofollow\" href=\"https://wp-parsi.com\">وردپرس پارسی</a> پدیدار شد.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:19:\"مصطفی صوفی\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"https://wp-parsi.com/deploy-wordpress-with-bedrock/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"3\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:54:\"\n		\n		\n				\n				\n		\n				\n		\n\n		\n				\n						\n		\n							\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:94:\"آموزش پلاگین نویسی در وردپرس از صفر تا صد – قسمت اول\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:157:\"https://wp-parsi.com/%d8%a7%d9%85%d9%88%d8%b2%d8%b4-%d9%be%d9%84%d8%a7%da%af%db%8c%d9%86-%d9%86%d9%88%db%8c%d8%b3%db%8c-%d9%88%d8%b1%d8%af%d9%be%d8%b1%d8%b3/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:166:\"https://wp-parsi.com/%d8%a7%d9%85%d9%88%d8%b2%d8%b4-%d9%be%d9%84%d8%a7%da%af%db%8c%d9%86-%d9%86%d9%88%db%8c%d8%b3%db%8c-%d9%88%d8%b1%d8%af%d9%be%d8%b1%d8%b3/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 04 Feb 2018 09:25:27 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:23:\"افزونه نویسی\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:33:\"مقالات و آموزش‌ها\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:27:\"https://wp-parsi.com/?p=558\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1025:\"<p>پلاگین چیست؟ قطعه کدهای کوچک یا بزرگی میباشد که در برنامه اصلی نصب میشوند و قابلیت یا قابلیتهایی را به آن اضافه میکنند. از مهمترین عوامل معروفیت و کاربرد وردپرس داشتن پلاگینهای متعدد و کاربردی میباشد.علت تعدد پلاگینها در وردپرس نسبت به سایر سیستمهای مدیریت محتوی سادگی فرایند نوشتن پلاگین در وردپرس میباشد.وقتی شما پلاگینی [&#8230;]</p>\n<p>نوشته <a rel=\"nofollow\" href=\"https://wp-parsi.com/%d8%a7%d9%85%d9%88%d8%b2%d8%b4-%d9%be%d9%84%d8%a7%da%af%db%8c%d9%86-%d9%86%d9%88%db%8c%d8%b3%db%8c-%d9%88%d8%b1%d8%af%d9%be%d8%b1%d8%b3/\">آموزش پلاگین نویسی در وردپرس از صفر تا صد &#8211; قسمت اول</a> اولین بار در <a rel=\"nofollow\" href=\"https://wp-parsi.com\">وردپرس پارسی</a> پدیدار شد.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:23:\"مبین قاسمپور\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:162:\"https://wp-parsi.com/%d8%a7%d9%85%d9%88%d8%b2%d8%b4-%d9%be%d9%84%d8%a7%da%af%db%8c%d9%86-%d9%86%d9%88%db%8c%d8%b3%db%8c-%d9%88%d8%b1%d8%af%d9%be%d8%b1%d8%b3/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:2:\"12\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:51:\"\n		\n		\n				\n				\n		\n				\n\n		\n				\n						\n		\n							\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:86:\"کاهش ایندکس وبسایت‌ها و راهکارهای مقابله با آن\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:151:\"https://wp-parsi.com/%d8%af%d9%84%d8%a7%db%8c%d9%84-%da%a9%d8%a7%d9%87%d8%b4-%d8%a7%db%8c%d9%86%d8%af%da%a9%d8%b3-%d9%88%d8%a8%d8%b3%d8%a7%db%8c%d8%aa/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:160:\"https://wp-parsi.com/%d8%af%d9%84%d8%a7%db%8c%d9%84-%da%a9%d8%a7%d9%87%d8%b4-%d8%a7%db%8c%d9%86%d8%af%da%a9%d8%b3-%d9%88%d8%a8%d8%b3%d8%a7%db%8c%d8%aa/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 25 Dec 2017 20:35:36 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:19:\"سئو وردپرس\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:26:\"http://wp-parsi.com/?p=541\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:983:\"<p>چرا وبسایت‌ها دچار کاهش ایندکس می‌شوند و چه کاری باید درمورد آن انجام داد؟ یکی از ناامید کننده‌ترین اتفاقاتی که برای مالکان سایت ممکن است بیفتد این است که تعداد ایندکس‌شان توسط گوگل کم بشود. این موضوع را شرکت‌های کوچک زودتر متوجه شدند وقتی که در خروجی‌های جستجو براساس نام واقعی‌شان مشاهده نشدند. این موضوع [&#8230;]</p>\n<p>نوشته <a rel=\"nofollow\" href=\"https://wp-parsi.com/%d8%af%d9%84%d8%a7%db%8c%d9%84-%da%a9%d8%a7%d9%87%d8%b4-%d8%a7%db%8c%d9%86%d8%af%da%a9%d8%b3-%d9%88%d8%a8%d8%b3%d8%a7%db%8c%d8%aa/\">کاهش ایندکس وبسایت‌ها و راهکارهای مقابله با آن</a> اولین بار در <a rel=\"nofollow\" href=\"https://wp-parsi.com\">وردپرس پارسی</a> پدیدار شد.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"سعید فرد\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:156:\"https://wp-parsi.com/%d8%af%d9%84%d8%a7%db%8c%d9%84-%da%a9%d8%a7%d9%87%d8%b4-%d8%a7%db%8c%d9%86%d8%af%da%a9%d8%b3-%d9%88%d8%a8%d8%b3%d8%a7%db%8c%d8%aa/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"4\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}s:27:\"http://www.w3.org/2005/Atom\";a:1:{s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:3:{s:4:\"href\";s:26:\"https://wp-parsi.com/feed/\";s:3:\"rel\";s:4:\"self\";s:4:\"type\";s:19:\"application/rss+xml\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:44:\"http://purl.org/rss/1.0/modules/syndication/\";a:2:{s:12:\"updatePeriod\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"\n	hourly	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:15:\"updateFrequency\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"\n	1	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";O:42:\"Requests_Utility_CaseInsensitiveDictionary\":1:{s:7:\"\0*\0data\";a:11:{s:4:\"date\";s:29:\"Fri, 03 Apr 2020 09:51:07 GMT\";s:6:\"server\";s:6:\"Apache\";s:4:\"link\";s:57:\"<https://wp-parsi.com/wp-json/>; rel=\"https://api.w.org/\"\";s:13:\"last-modified\";s:29:\"Sun, 08 Mar 2020 19:00:42 GMT\";s:4:\"etag\";s:39:\"\"195112237cab621a1882826d93f77b12-gzip\"\";s:13:\"cache-control\";s:14:\"max-age=172800\";s:7:\"expires\";s:29:\"Sun, 05 Apr 2020 09:51:07 GMT\";s:4:\"vary\";s:26:\"Accept-Encoding,User-Agent\";s:16:\"content-encoding\";s:4:\"gzip\";s:14:\"content-length\";s:4:\"3850\";s:12:\"content-type\";s:34:\"application/rss+xml; charset=UTF-8\";}}s:5:\"build\";s:14:\"20130911040210\";}", "no");
INSERT INTO `wp_options` VALUES("1425", "_transient_timeout_feed_mod_1a35a986d21ecac6e67e45f5050a2d43", "1585950667", "no");
INSERT INTO `wp_options` VALUES("1426", "_transient_feed_mod_1a35a986d21ecac6e67e45f5050a2d43", "1585907467", "no");
INSERT INTO `wp_options` VALUES("1427", "_transient_timeout_feed_9bb54f090b06ea0b52a1a293dcf1b99e", "1585950669", "no");
INSERT INTO `wp_options` VALUES("1428", "_transient_feed_9bb54f090b06ea0b52a1a293dcf1b99e", "a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n\n\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:49:\"\n	\n	\n	\n	\n	\n	\n	\n	\n	\n	\n		\n		\n		\n		\n		\n		\n		\n		\n		\n	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:3:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"سیاره وردپرس ایران\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:19:\"http://wp-planet.ir\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:13:\"lastBuildDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 28 Mar 2020 02:49:14 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"fa-IR\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:9:\"generator\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://wordpress.org/?v=5.2.5\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:10:{i:0;a:6:{s:4:\"data\";s:48:\"\n		\n		\n				\n		\n				\n\n		\n				\n								\n										\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:3:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:62:\"آشنایی با صفحه ساز های برتر وردپرس\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:195:\"http://wp-planet.ir/%d8%a2%d8%b4%d9%86%d8%a7%db%8c%db%8c-%d8%a8%d8%a7-%d8%b5%d9%81%d8%ad%d9%87-%d8%b3%d8%a7%d8%b2-%d9%87%d8%a7%db%8c-%d8%a8%d8%b1%d8%aa%d8%b1-%d9%88%d8%b1%d8%af%d9%be%d8%b1%d8%b3/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 28 Mar 2020 02:49:14 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"دسته‌بندی نشده\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:195:\"http://wp-planet.ir/%d8%a2%d8%b4%d9%86%d8%a7%db%8c%db%8c-%d8%a8%d8%a7-%d8%b5%d9%81%d8%ad%d9%87-%d8%b3%d8%a7%d8%b2-%d9%87%d8%a7%db%8c-%d8%a8%d8%b1%d8%aa%d8%b1-%d9%88%d8%b1%d8%af%d9%be%d8%b1%d8%b3/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1563:\"&#1575;&#1711;&#1585; &#1589;&#1575;&#1581;&#1576; &#1740;&#1705; &#1608;&#1576;&#1587;&#1575;&#1740;&#1578; &#1608;&#1585;&#1583;&#1662;&#1585;&#1587;&#1740; &#1576;&#1575;&#1588;&#1740;&#1583;&#1548; &#1575;&#1581;&#1578;&#1605;&#1575;&#1604; &#1575;&#1740;&#1606;&#1705;&#1607; &#1578;&#1575; &#1575;&#1605;&#1585;&#1608;&#1586; &#1576;&#1575; &#1740;&#1705;&#1740; &#1575;&#1586; &#1589;&#1601;&#1581;&#1607; &#1587;&#1575;&#1586; &#1607;&#1575;&#1740; &#1608;&#1585;&#1583;&#1662;&#1585;&#1587; &#1705;&#1575;&#1585; &#1705;&#1585;&#1583;&#1607; &#1576;&#1575;&#1588;&#1740;&#1583; &#1576;&#1587;&#1740;&#1575;&#1585; &#1586;&#1740;&#1575;&#1583; &#1575;&#1587;&#1578;. &#1589;&#1601;&#1581;&#1607; &#1587;&#1575;&#1586; &#1607;&#1575;&#1740; &#1608;&#1585;&#1583;&#1662;&#1585;&#1587; &#1576;&#1575; &#1575;&#1585;&#1575;&#1574;&#1607; &#1585;&#1575;&#1576;&#1591; &#1711;&#1585;&#1575;&#1601;&#1740;&#1705;&#1740; &#1583;&#1585;&#1711; &#1575;&#1606;&#1583; &#1583;&#1585;&#1575;&#1662; &#1608; &#1606;&#1605;&#1575;&#1740;&#1588; &#1593;&#1606;&#1575;&#1589;&#1585; &#1605;&#1608;&#1585;&#1583; &#1606;&#1740;&#1575;&#1586; &#1605;&#1575; &#1576;&#1607; &#1589;&#1608;&#1585;&#1578; &#1576;&#1589;&#1585;&#1740;&#1548; &#1605;&#1575; &#1585;&#1575; &#1575;&#1586; &#1705;&#1583;&#1606;&#1608;&#1740;&#1587;&#1740; &#1608; &#1575;&#1606;&#1580;&#1575;&#1605; &#1705;&#1575;&#1585; &#1607;&#1575;&#1740; &#1662;&#1740;&#1670;&#1740;&#1583;&#1607; &#1576;&#1585;&#1575;&#1740; &#1587;&#1575;&#1582;&#1578;&#1606; &#1589;&#1601;&#1581;&#1575;&#1578; [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:2589:\"<div><img width=\"900\" height=\"450\" src=\"https://mrcode.ir/wp-content/uploads/2020/03/wordpress-page-builders-3.png\" alt=\"&#1570;&#1588;&#1606;&#1575;&#1740;&#1740; &#1576;&#1575; &#1589;&#1601;&#1581;&#1607; &#1587;&#1575;&#1586; &#1607;&#1575;&#1740; &#1576;&#1585;&#1578;&#1585; &#1608;&#1585;&#1583;&#1662;&#1585;&#1587;\"></div>\n<p>&#1575;&#1711;&#1585; &#1589;&#1575;&#1581;&#1576; &#1740;&#1705; &#1608;&#1576;&#1587;&#1575;&#1740;&#1578; &#1608;&#1585;&#1583;&#1662;&#1585;&#1587;&#1740; &#1576;&#1575;&#1588;&#1740;&#1583;&#1548; &#1575;&#1581;&#1578;&#1605;&#1575;&#1604; &#1575;&#1740;&#1606;&#1705;&#1607; &#1578;&#1575; &#1575;&#1605;&#1585;&#1608;&#1586; &#1576;&#1575; &#1740;&#1705;&#1740; &#1575;&#1586; &#1589;&#1601;&#1581;&#1607; &#1587;&#1575;&#1586; &#1607;&#1575;&#1740; &#1608;&#1585;&#1583;&#1662;&#1585;&#1587; &#1705;&#1575;&#1585; &#1705;&#1585;&#1583;&#1607; &#1576;&#1575;&#1588;&#1740;&#1583; &#1576;&#1587;&#1740;&#1575;&#1585; &#1586;&#1740;&#1575;&#1583; &#1575;&#1587;&#1578;. &#1589;&#1601;&#1581;&#1607; &#1587;&#1575;&#1586; &#1607;&#1575;&#1740; &#1608;&#1585;&#1583;&#1662;&#1585;&#1587; &#1576;&#1575; &#1575;&#1585;&#1575;&#1574;&#1607; &#1585;&#1575;&#1576;&#1591; &#1711;&#1585;&#1575;&#1601;&#1740;&#1705;&#1740; &#1583;&#1585;&#1711; &#1575;&#1606;&#1583; &#1583;&#1585;&#1575;&#1662; &#1608; &#1606;&#1605;&#1575;&#1740;&#1588; &#1593;&#1606;&#1575;&#1589;&#1585; &#1605;&#1608;&#1585;&#1583; &#1606;&#1740;&#1575;&#1586; &#1605;&#1575; &#1576;&#1607; &#1589;&#1608;&#1585;&#1578; &#1576;&#1589;&#1585;&#1740;&#1548; &#1605;&#1575; &#1585;&#1575; &#1575;&#1586; &#1705;&#1583;&#1606;&#1608;&#1740;&#1587;&#1740; &#1608; &#1575;&#1606;&#1580;&#1575;&#1605; &#1705;&#1575;&#1585; &#1607;&#1575;&#1740; &#1662;&#1740;&#1670;&#1740;&#1583;&#1607; &#1576;&#1585;&#1575;&#1740; &#1587;&#1575;&#1582;&#1578;&#1606; &#1589;&#1601;&#1581;&#1575;&#1578; [&hellip;]</p>\n<p>&#1606;&#1608;&#1588;&#1578;&#1607; <a rel=\"nofollow\" href=\"https://mrcode.ir/%D8%A7%D9%81%D8%B2%D9%88%D9%86%D9%87-%D8%B5%D9%81%D8%AD%D9%87-%D8%B3%D8%A7%D8%B2-%D9%BE%DB%8C%D8%AC-%D8%A8%DB%8C%D9%84%D8%AF%D8%B1-%D9%88%D8%B1%D8%AF%D9%BE%D8%B1%D8%B3\">&#1570;&#1588;&#1606;&#1575;&#1740;&#1740; &#1576;&#1575; &#1589;&#1601;&#1581;&#1607; &#1587;&#1575;&#1586; &#1607;&#1575;&#1740; &#1576;&#1585;&#1578;&#1585; &#1608;&#1585;&#1583;&#1662;&#1585;&#1587;</a> &#1575;&#1608;&#1604;&#1740;&#1606; &#1576;&#1575;&#1585; &#1583;&#1585; <a rel=\"nofollow\" href=\"https://mrcode.ir/\">&#1605;&#1587;&#1578;&#1585;&#1705;&#1583;</a>. &#1662;&#1583;&#1740;&#1583;&#1575;&#1585; &#1588;&#1583;.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:48:\"\n		\n		\n				\n		\n				\n\n		\n				\n								\n										\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:3:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"Just how Do You Compose Science Content Articles For Kids?\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:78:\"http://wp-planet.ir/just-how-do-you-compose-science-content-articles-for-kids/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 26 Mar 2020 11:30:06 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"دسته‌بندی نشده\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:78:\"http://wp-planet.ir/just-how-do-you-compose-science-content-articles-for-kids/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:376:\"Just how would you compose science articles? Children are naturally interested science is something they love to learn about. This means that they&#8217;ll be interested in knowing a lot much more therefore it&#8217;s important that you compose the articles children know about its particular own problems and also science. It&#8217;s given benefits to people across [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:858:\"<p>Just how would you compose science articles? Children are naturally interested science is something they love to learn about. This means that they&rsquo;ll be interested in knowing a lot much more therefore it&rsquo;s important that you compose the articles children know about its particular own problems and also science. It&rsquo;s given benefits to people across [&hellip;]</p>\n<p>&#1606;&#1608;&#1588;&#1578;&#1607; <a rel=\"nofollow\" href=\"https://wp-parsi.com/just-how-do-you-compose-science-content-articles-for-kids/\">Just how Do You Compose Science Content Articles For Kids?</a> &#1575;&#1608;&#1604;&#1740;&#1606; &#1576;&#1575;&#1585; &#1583;&#1585; <a rel=\"nofollow\" href=\"https://wp-parsi.com/\">&#1608;&#1585;&#1583;&#1662;&#1585;&#1587; &#1662;&#1575;&#1585;&#1587;&#1740;</a> &#1662;&#1583;&#1740;&#1583;&#1575;&#1585; &#1588;&#1583;.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:48:\"\n		\n		\n				\n		\n				\n\n		\n				\n								\n										\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:3:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"A Rally and Also a Conference\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:50:\"http://wp-planet.ir/a-rally-and-also-a-conference/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 26 Mar 2020 11:27:28 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"دسته‌بندی نشده\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:50:\"http://wp-planet.ir/a-rally-and-also-a-conference/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:331:\"The san-diego March for Science can be. It&#8217;s supposed to become a more nonpartisan presentation, plus it&#8217;s intended to draw awareness of a number of issues that are essential to those men and women who live in the region. These functions are kept over a Friday or Saturday and could persist for a handful days [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:756:\"<p>The san-diego March for Science can be. It&rsquo;s supposed to become a more nonpartisan presentation, plus it&rsquo;s intended to draw awareness of a number of issues that are essential to those men and women who live in the region. These functions are kept over a Friday or Saturday and could persist for a handful days [&hellip;]</p>\n<p>&#1606;&#1608;&#1588;&#1578;&#1607; <a rel=\"nofollow\" href=\"https://wp-parsi.com/a-rally-and-also-a-conference/\">A Rally and Also a Conference</a> &#1575;&#1608;&#1604;&#1740;&#1606; &#1576;&#1575;&#1585; &#1583;&#1585; <a rel=\"nofollow\" href=\"https://wp-parsi.com/\">&#1608;&#1585;&#1583;&#1662;&#1585;&#1587; &#1662;&#1575;&#1585;&#1587;&#1740;</a> &#1662;&#1583;&#1740;&#1583;&#1575;&#1585; &#1588;&#1583;.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:48:\"\n		\n		\n				\n		\n				\n\n		\n				\n								\n										\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:3:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:45:\"Finding out in Osceola Science Charter-school\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"http://wp-planet.ir/finding-out-in-osceola-science-charter-school/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 26 Mar 2020 11:21:18 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"دسته‌بندی نشده\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"http://wp-planet.ir/finding-out-in-osceola-science-charter-school/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:377:\"Osceola Science Charter School has made the hope of their parents it and functions a great educational experience for its own students. Its curriculum follows the globally recognized ISEA (Institute of Science in education and learning ) system of teaching. The faculty&#8217;s educators are educators who&#8217;ve been educated in either the united states of america [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:834:\"<p>Osceola Science Charter School has made the hope of their parents it and functions a great educational experience for its own students. Its curriculum follows the globally recognized ISEA (Institute of Science in education and learning ) system of teaching. The faculty&rsquo;s educators are educators who&rsquo;ve been educated in either the united states of america [&hellip;]</p>\n<p>&#1606;&#1608;&#1588;&#1578;&#1607; <a rel=\"nofollow\" href=\"https://wp-parsi.com/finding-out-in-osceola-science-charter-school/\">Finding out in Osceola Science Charter-school</a> &#1575;&#1608;&#1604;&#1740;&#1606; &#1576;&#1575;&#1585; &#1583;&#1585; <a rel=\"nofollow\" href=\"https://wp-parsi.com/\">&#1608;&#1585;&#1583;&#1662;&#1585;&#1587; &#1662;&#1575;&#1585;&#1587;&#1740;</a> &#1662;&#1583;&#1740;&#1583;&#1575;&#1585; &#1588;&#1583;.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:48:\"\n		\n		\n				\n		\n				\n\n		\n				\n								\n										\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:3:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:42:\"Nuclear Chemistry Programs from the Future\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:63:\"http://wp-planet.ir/nuclear-chemistry-programs-from-the-future/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 26 Mar 2020 06:50:36 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"دسته‌بندی نشده\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:63:\"http://wp-planet.ir/nuclear-chemistry-programs-from-the-future/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:336:\"The United states is experiencing an explosion of interest in advanced nuclear chemistry and it is incredibly higher tech applications. The quick source of this enthusiasm may be the power needs of a future and more advanced society, but the future of nuclear chemistry is much more far reaching. pay someone to write my paper [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:787:\"<p>The United states is experiencing an explosion of interest in advanced nuclear chemistry and it is incredibly higher tech applications. The quick source of this enthusiasm may be the power needs of a future and more advanced society, but the future of nuclear chemistry is much more far reaching. pay someone to write my paper [&hellip;]</p>\n<p>&#1606;&#1608;&#1588;&#1578;&#1607; <a rel=\"nofollow\" href=\"https://wp-parsi.com/nuclear-chemistry-programs-from-the-future/\">Nuclear Chemistry Programs from the Future</a> &#1575;&#1608;&#1604;&#1740;&#1606; &#1576;&#1575;&#1585; &#1583;&#1585; <a rel=\"nofollow\" href=\"https://wp-parsi.com/\">&#1608;&#1585;&#1583;&#1662;&#1585;&#1587; &#1662;&#1575;&#1585;&#1587;&#1740;</a> &#1662;&#1583;&#1740;&#1583;&#1575;&#1585; &#1588;&#1583;.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:48:\"\n		\n		\n				\n		\n				\n\n		\n				\n								\n										\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:3:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:68:\"The Function of Science All-natural Supplements in Treating Diseases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:89:\"http://wp-planet.ir/the-function-of-science-all-natural-supplements-in-treating-diseases/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 26 Mar 2020 02:10:28 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"دسته‌بندی نشده\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:89:\"http://wp-planet.ir/the-function-of-science-all-natural-supplements-in-treating-diseases/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:364:\"While many of the education technique these days emphasizes the study of mathematical and scientific concepts, there&#8217;s nonetheless area for the humanities and also other perspectives that relate to the life sciences and organic supplements. Although the study of logic and also other places of philosophy have come to become a lot more prominent in [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:867:\"<p>While many of the education technique these days emphasizes the study of mathematical and scientific concepts, there&rsquo;s nonetheless area for the humanities and also other perspectives that relate to the life sciences and organic supplements. Although the study of logic and also other places of philosophy have come to become a lot more prominent in [&hellip;]</p>\n<p>&#1606;&#1608;&#1588;&#1578;&#1607; <a rel=\"nofollow\" href=\"https://wp-parsi.com/the-function-of-science-all-natural-supplements-in-treating-diseases/\">The Function of Science All-natural Supplements in Treating Diseases</a> &#1575;&#1608;&#1604;&#1740;&#1606; &#1576;&#1575;&#1585; &#1583;&#1585; <a rel=\"nofollow\" href=\"https://wp-parsi.com/\">&#1608;&#1585;&#1583;&#1662;&#1585;&#1587; &#1662;&#1575;&#1585;&#1587;&#1740;</a> &#1662;&#1583;&#1740;&#1583;&#1575;&#1585; &#1588;&#1583;.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:48:\"\n		\n		\n				\n		\n				\n\n		\n				\n								\n										\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:3:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"The Complications With Ethical Theory in Nursing\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:69:\"http://wp-planet.ir/the-complications-with-ethical-theory-in-nursing/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 25 Mar 2020 14:11:54 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"دسته‌بندی نشده\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:69:\"http://wp-planet.ir/the-complications-with-ethical-theory-in-nursing/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:347:\"In the field of overall health care, you can find many theories and practices that have been formed to resolve troubles and assistance sufferers. There are numerous philosophical and ethical theories that have been created to assist clarify how items perform. It really is tough to locate any overarching theory that relates all of those [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:810:\"<p>In the field of overall health care, you can find many theories and practices that have been formed to resolve troubles and assistance sufferers. There are numerous philosophical and ethical theories that have been created to assist clarify how items perform. It really is tough to locate any overarching theory that relates all of those [&hellip;]</p>\n<p>&#1606;&#1608;&#1588;&#1578;&#1607; <a rel=\"nofollow\" href=\"https://wp-parsi.com/the-complications-with-ethical-theory-in-nursing/\">The Complications With Ethical Theory in Nursing</a> &#1575;&#1608;&#1604;&#1740;&#1606; &#1576;&#1575;&#1585; &#1583;&#1585; <a rel=\"nofollow\" href=\"https://wp-parsi.com/\">&#1608;&#1585;&#1583;&#1662;&#1585;&#1587; &#1662;&#1575;&#1585;&#1587;&#1740;</a> &#1662;&#1583;&#1740;&#1583;&#1575;&#1585; &#1588;&#1583;.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:48:\"\n		\n		\n				\n		\n				\n\n		\n				\n								\n										\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:3:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:76:\"برای فروشگاه اینترنتی چه هاستی مناسب است؟\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:219:\"http://wp-planet.ir/%d8%a8%d8%b1%d8%a7%db%8c-%d9%81%d8%b1%d9%88%d8%b4%da%af%d8%a7%d9%87-%d8%a7%db%8c%d9%86%d8%aa%d8%b1%d9%86%d8%aa%db%8c-%da%86%d9%87-%d9%87%d8%a7%d8%b3%d8%aa%db%8c-%d9%85%d9%86%d8%a7%d8%b3%d8%a8-%d8%a7/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 16 Mar 2020 08:30:26 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"دسته‌بندی نشده\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:219:\"http://wp-planet.ir/%d8%a8%d8%b1%d8%a7%db%8c-%d9%81%d8%b1%d9%88%d8%b4%da%af%d8%a7%d9%87-%d8%a7%db%8c%d9%86%d8%aa%d8%b1%d9%86%d8%aa%db%8c-%da%86%d9%87-%d9%87%d8%a7%d8%b3%d8%aa%db%8c-%d9%85%d9%86%d8%a7%d8%b3%d8%a8-%d8%a7/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1563:\"&#1583;&#1585; &#1580;&#1604;&#1587;&#1607; &#1602;&#1576;&#1604;&#1740; &#1583;&#1585; &#1582;&#1589;&#1608;&#1589; &#1662;&#1740;&#1588; &#1606;&#1740;&#1575;&#1586;&#1607;&#1575;&#1740; &#1604;&#1575;&#1586;&#1605; &#1580;&#1607;&#1578; &#1585;&#1575;&#1607; &#1575;&#1606;&#1583;&#1575;&#1586;&#1740; &#1601;&#1585;&#1608;&#1588;&#1711;&#1575;&#1607; &#1575;&#1740;&#1606;&#1578;&#1585;&#1606;&#1578;&#1740; &#1585;&#1575; &#1576;&#1575; &#1607;&#1605; &#1605;&#1608;&#1585;&#1583; &#1576;&#1581;&#1579; &#1608; &#1576;&#1585;&#1585;&#1587;&#1740; &#1602;&#1585;&#1575;&#1585; &#1583;&#1575;&#1583;&#1740;&#1605; &#1705;&#1607; &#1740;&#1705;&#1740; &#1575;&#1586; &#1711;&#1586;&#1740;&#1606;&#1607; &#1607;&#1575;&#1740; &#1570;&#1606; &#1575;&#1606;&#1578;&#1582;&#1575;&#1576; &#1740;&#1705; &#1607;&#1575;&#1587;&#1578; &#1605;&#1606;&#1575;&#1587;&#1576; &#1576;&#1585;&#1575;&#1740; &#1578;&#1575;&#1587;&#1740;&#1587; &#1608;&#1576;&#1587;&#1575;&#1740;&#1578; &#1601;&#1585;&#1608;&#1588;&#1711;&#1575;&#1607;&#1740; &#1576;&#1608;&#1583;. &#1575;&#1605;&#1575; &#1608;&#1740;&#1688;&#1711;&#1740; &#1607;&#1575;&#1587;&#1578; &#1582;&#1608;&#1576; &#1670;&#1740;&#1587;&#1578;&#1567; &#1583;&#1585; &#1575;&#1740;&#1606; &#1580;&#1604;&#1587;&#1607; &#1575;&#1586; &#1662;&#1575;&#1740;&#1711;&#1575;&#1607; &#1583;&#1575;&#1606;&#1588; &#1605;&#1740;&#1586;&#1576;&#1575;&#1606; &#1601;&#1575; &#1578;&#1589;&#1605;&#1740;&#1605; &#1583;&#1575;&#1585;&#1740;&#1605; &#1583;&#1585; &#1582;&#1589;&#1608;&#1589; &#1607;&#1575;&#1587;&#1578; [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:2357:\"<p>&#1583;&#1585; &#1580;&#1604;&#1587;&#1607; &#1602;&#1576;&#1604;&#1740; &#1583;&#1585; &#1582;&#1589;&#1608;&#1589; &#1662;&#1740;&#1588; &#1606;&#1740;&#1575;&#1586;&#1607;&#1575;&#1740; &#1604;&#1575;&#1586;&#1605; &#1580;&#1607;&#1578; &#1585;&#1575;&#1607; &#1575;&#1606;&#1583;&#1575;&#1586;&#1740; &#1601;&#1585;&#1608;&#1588;&#1711;&#1575;&#1607; &#1575;&#1740;&#1606;&#1578;&#1585;&#1606;&#1578;&#1740; &#1585;&#1575; &#1576;&#1575; &#1607;&#1605; &#1605;&#1608;&#1585;&#1583; &#1576;&#1581;&#1579; &#1608; &#1576;&#1585;&#1585;&#1587;&#1740; &#1602;&#1585;&#1575;&#1585; &#1583;&#1575;&#1583;&#1740;&#1605; &#1705;&#1607; &#1740;&#1705;&#1740; &#1575;&#1586; &#1711;&#1586;&#1740;&#1606;&#1607; &#1607;&#1575;&#1740; &#1570;&#1606; &#1575;&#1606;&#1578;&#1582;&#1575;&#1576; &#1740;&#1705; &#1607;&#1575;&#1587;&#1578; &#1605;&#1606;&#1575;&#1587;&#1576; &#1576;&#1585;&#1575;&#1740; &#1578;&#1575;&#1587;&#1740;&#1587; &#1608;&#1576;&#1587;&#1575;&#1740;&#1578; &#1601;&#1585;&#1608;&#1588;&#1711;&#1575;&#1607;&#1740; &#1576;&#1608;&#1583;. &#1575;&#1605;&#1575; &#1608;&#1740;&#1688;&#1711;&#1740; &#1607;&#1575;&#1587;&#1578; &#1582;&#1608;&#1576; &#1670;&#1740;&#1587;&#1578;&#1567; &#1583;&#1585; &#1575;&#1740;&#1606; &#1580;&#1604;&#1587;&#1607; &#1575;&#1586; &#1662;&#1575;&#1740;&#1711;&#1575;&#1607; &#1583;&#1575;&#1606;&#1588; &#1605;&#1740;&#1586;&#1576;&#1575;&#1606; &#1601;&#1575; &#1578;&#1589;&#1605;&#1740;&#1605; &#1583;&#1575;&#1585;&#1740;&#1605; &#1583;&#1585; &#1582;&#1589;&#1608;&#1589; &#1607;&#1575;&#1587;&#1578; &hellip;</p>\n<p>&#1606;&#1608;&#1588;&#1578;&#1607; <a rel=\"nofollow\" href=\"https://mizbanfa.net/blog/cms/wordpress/basic-features-every-good-web-host-should-offer/\" data-wpel-link=\"internal\">&#1576;&#1585;&#1575;&#1740; &#1601;&#1585;&#1608;&#1588;&#1711;&#1575;&#1607; &#1575;&#1740;&#1606;&#1578;&#1585;&#1606;&#1578;&#1740; &#1670;&#1607; &#1607;&#1575;&#1587;&#1578;&#1740; &#1605;&#1606;&#1575;&#1587;&#1576; &#1575;&#1587;&#1578;&#1567;</a> &#1575;&#1608;&#1604;&#1740;&#1606; &#1576;&#1575;&#1585; &#1583;&#1585; <a rel=\"nofollow\" href=\"https://mizbanfa.net/blog\" data-wpel-link=\"internal\">&#1662;&#1575;&#1740;&#1711;&#1575;&#1607; &#1583;&#1575;&#1606;&#1588; &#1605;&#1740;&#1586;&#1576;&#1575;&#1606;&zwnj;&#1601;&#1575;</a> &#1662;&#1583;&#1740;&#1583;&#1575;&#1585; &#1588;&#1583;.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:48:\"\n		\n		\n				\n		\n				\n\n		\n				\n								\n										\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:3:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:78:\"راه های پیشرفت سریع فروشگاه اینترنتی چیست؟\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:219:\"http://wp-planet.ir/%d8%b1%d8%a7%d9%87-%d9%87%d8%a7%db%8c-%d9%be%db%8c%d8%b4%d8%b1%d9%81%d8%aa-%d8%b3%d8%b1%db%8c%d8%b9-%d9%81%d8%b1%d9%88%d8%b4%da%af%d8%a7%d9%87-%d8%a7%db%8c%d9%86%d8%aa%d8%b1%d9%86%d8%aa%db%8c-%da%86/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 14 Mar 2020 06:28:49 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"دسته‌بندی نشده\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:219:\"http://wp-planet.ir/%d8%b1%d8%a7%d9%87-%d9%87%d8%a7%db%8c-%d9%be%db%8c%d8%b4%d8%b1%d9%81%d8%aa-%d8%b3%d8%b1%db%8c%d8%b9-%d9%81%d8%b1%d9%88%d8%b4%da%af%d8%a7%d9%87-%d8%a7%db%8c%d9%86%d8%aa%d8%b1%d9%86%d8%aa%db%8c-%da%86/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1563:\"&#1583;&#1585; &#1575;&#1740;&#1606; &#1605;&#1602;&#1575;&#1604;&#1607; &#1575;&#1586; &#1587;&#1585;&#1740; &#1570;&#1605;&#1608;&#1586;&#1588; &#1607;&#1575;&#1740; &#1589;&#1601;&#1585; &#1578;&#1575; &#1589;&#1583; &#1585;&#1575;&#1607; &#1575;&#1606;&#1583;&#1575;&#1586;&#1740; &#1601;&#1585;&#1608;&#1588;&#1711;&#1575;&#1607; &#1575;&#1740;&#1606;&#1578;&#1585;&#1606;&#1578;&#1740; &#1578;&#1589;&#1605;&#1740;&#1605; &#1583;&#1575;&#1585;&#1740;&#1605; &#1576;&#1607; &#1576;&#1585;&#1585;&#1587;&#1740; &#1740;&#1705; &#1605;&#1608;&#1590;&#1608;&#1593; &#1605;&#1607;&#1605; &#1576;&#1662;&#1585;&#1583;&#1575;&#1586;&#1740;&#1605;. &#1575;&#1740;&#1606;&#1705;&#1607; &#1601;&#1585;&#1608;&#1588;&#1711;&#1575;&#1607; &#1575;&#1740;&#1606;&#1578;&#1585;&#1606;&#1578;&#1740; &#1578;&#1575; &#1670;&#1607; &#1581;&#1583; &#1605;&#1740; &#1578;&#1608;&#1575;&#1606;&#1583; &#1662;&#1740;&#1588;&#1585;&#1601;&#1578; &#1705;&#1606;&#1583; &#1608; &#1576;&#1575;&#1593;&#1579; &#1662;&#1740;&#1588;&#1585;&#1601;&#1578; &#1705;&#1587;&#1576; &#1608; &#1705;&#1575;&#1585; &#1605;&#1575; &#1588;&#1608;&#1583;&#1567; &#1583;&#1585; &#1608;&#1575;&#1602;&#1593; &#1602;&#1589;&#1583; &#1583;&#1575;&#1585;&#1740;&#1605; &#1576;&#1607; &#1588;&#1605;&#1575; &#1576;&#1711;&#1608;&#1740;&#1740;&#1605; &#1705;&#1607; &#1585;&#1575;&#1607; &#1607;&#1575;&#1740; &#1662;&#1740;&#1588;&#1585;&#1601;&#1578; &#1601;&#1585;&#1608;&#1588;&#1711;&#1575;&#1607; &#1575;&#1740;&#1606;&#1578;&#1585;&#1606;&#1578;&#1740; &#1670;&#1740;&#1587;&#1578; &#1608; [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:2342:\"<p>&#1583;&#1585; &#1575;&#1740;&#1606; &#1605;&#1602;&#1575;&#1604;&#1607; &#1575;&#1586; &#1587;&#1585;&#1740; &#1570;&#1605;&#1608;&#1586;&#1588; &#1607;&#1575;&#1740; &#1589;&#1601;&#1585; &#1578;&#1575; &#1589;&#1583; &#1585;&#1575;&#1607; &#1575;&#1606;&#1583;&#1575;&#1586;&#1740; &#1601;&#1585;&#1608;&#1588;&#1711;&#1575;&#1607; &#1575;&#1740;&#1606;&#1578;&#1585;&#1606;&#1578;&#1740; &#1578;&#1589;&#1605;&#1740;&#1605; &#1583;&#1575;&#1585;&#1740;&#1605; &#1576;&#1607; &#1576;&#1585;&#1585;&#1587;&#1740; &#1740;&#1705; &#1605;&#1608;&#1590;&#1608;&#1593; &#1605;&#1607;&#1605; &#1576;&#1662;&#1585;&#1583;&#1575;&#1586;&#1740;&#1605;. &#1575;&#1740;&#1606;&#1705;&#1607; &#1601;&#1585;&#1608;&#1588;&#1711;&#1575;&#1607; &#1575;&#1740;&#1606;&#1578;&#1585;&#1606;&#1578;&#1740; &#1578;&#1575; &#1670;&#1607; &#1581;&#1583; &#1605;&#1740; &#1578;&#1608;&#1575;&#1606;&#1583; &#1662;&#1740;&#1588;&#1585;&#1601;&#1578; &#1705;&#1606;&#1583; &#1608; &#1576;&#1575;&#1593;&#1579; &#1662;&#1740;&#1588;&#1585;&#1601;&#1578; &#1705;&#1587;&#1576; &#1608; &#1705;&#1575;&#1585; &#1605;&#1575; &#1588;&#1608;&#1583;&#1567; &#1583;&#1585; &#1608;&#1575;&#1602;&#1593; &#1602;&#1589;&#1583; &#1583;&#1575;&#1585;&#1740;&#1605; &#1576;&#1607; &#1588;&#1605;&#1575; &#1576;&#1711;&#1608;&#1740;&#1740;&#1605; &#1705;&#1607; &#1585;&#1575;&#1607; &#1607;&#1575;&#1740; &#1662;&#1740;&#1588;&#1585;&#1601;&#1578; &#1601;&#1585;&#1608;&#1588;&#1711;&#1575;&#1607; &#1575;&#1740;&#1606;&#1578;&#1585;&#1606;&#1578;&#1740; &#1670;&#1740;&#1587;&#1578; &#1608; &hellip;</p>\n<p>&#1606;&#1608;&#1588;&#1578;&#1607; <a rel=\"nofollow\" href=\"https://mizbanfa.net/blog/cms/wordpress/ways-to-grow-online-store/\" data-wpel-link=\"internal\">&#1585;&#1575;&#1607; &#1607;&#1575;&#1740; &#1662;&#1740;&#1588;&#1585;&#1601;&#1578; &#1587;&#1585;&#1740;&#1593; &#1601;&#1585;&#1608;&#1588;&#1711;&#1575;&#1607; &#1575;&#1740;&#1606;&#1578;&#1585;&#1606;&#1578;&#1740; &#1670;&#1740;&#1587;&#1578;&#1567;</a> &#1575;&#1608;&#1604;&#1740;&#1606; &#1576;&#1575;&#1585; &#1583;&#1585; <a rel=\"nofollow\" href=\"https://mizbanfa.net/blog\" data-wpel-link=\"internal\">&#1662;&#1575;&#1740;&#1711;&#1575;&#1607; &#1583;&#1575;&#1606;&#1588; &#1605;&#1740;&#1586;&#1576;&#1575;&#1606;&zwnj;&#1601;&#1575;</a> &#1662;&#1583;&#1740;&#1583;&#1575;&#1585; &#1588;&#1583;.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:48:\"\n		\n		\n				\n		\n				\n\n		\n				\n								\n										\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:3:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:102:\"پیش نیازهای لازم برای راه اندازی فروشگاه اینترنتی چیست؟\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:219:\"http://wp-planet.ir/%d9%be%db%8c%d8%b4-%d9%86%db%8c%d8%a7%d8%b2%d9%87%d8%a7%db%8c-%d9%84%d8%a7%d8%b2%d9%85-%d8%a8%d8%b1%d8%a7%db%8c-%d8%b1%d8%a7%d9%87-%d8%a7%d9%86%d8%af%d8%a7%d8%b2%db%8c-%d9%81%d8%b1%d9%88%d8%b4%da%af/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 14 Mar 2020 03:54:14 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"دسته‌بندی نشده\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:219:\"http://wp-planet.ir/%d9%be%db%8c%d8%b4-%d9%86%db%8c%d8%a7%d8%b2%d9%87%d8%a7%db%8c-%d9%84%d8%a7%d8%b2%d9%85-%d8%a8%d8%b1%d8%a7%db%8c-%d8%b1%d8%a7%d9%87-%d8%a7%d9%86%d8%af%d8%a7%d8%b2%db%8c-%d9%81%d8%b1%d9%88%d8%b4%da%af/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1716:\"&#1705;&#1575;&#1585;&#1576;&#1585;&#1575;&#1606; &#1575;&#1594;&#1604;&#1576; &#1587;&#1608;&#1575;&#1604; &#1605;&#1740; &#1705;&#1606;&#1606;&#1583; &#1705;&#1607; &#1576;&#1585;&#1575;&#1740; &#1588;&#1585;&#1608;&#1593; &#1705;&#1575;&#1585; &#1608; &#1585;&#1575;&#1607; &#1575;&#1606;&#1583;&#1575;&#1586;&#1740; &#1608;&#1576;&#1587;&#1575;&#1740;&#1578; &#1601;&#1585;&#1608;&#1588;&#1711;&#1575;&#1607;&#1740; &#1576;&#1607; &#1670;&#1607; &#1605;&#1608;&#1575;&#1585;&#1583;&#1740; &#1606;&#1740;&#1575;&#1586; &#1582;&#1608;&#1575;&#1607;&#1740;&#1605; &#1583;&#1575;&#1588;&#1578; &#1608; &#1705;&#1604;&#1575; &#1607;&#1586;&#1740;&#1606;&#1607; &#1585;&#1575;&#1607; &#1575;&#1606;&#1583;&#1575;&#1586;&#1740; &#1601;&#1585;&#1608;&#1588;&#1711;&#1575;&#1607; &#1575;&#1740;&#1606;&#1578;&#1585;&#1606;&#1578;&#1740; &#1576;&#1607; &#1591;&#1608;&#1585; &#1578;&#1602;&#1585;&#1740;&#1576;&#1740; &#1670;&#1607; &#1605;&#1740;&#1586;&#1575;&#1606; &#1582;&#1608;&#1575;&#1607;&#1583; &#1576;&#1608;&#1583;&#1567; &#1576;&#1585;&#1575;&#1740; &#1662;&#1575;&#1587;&#1582; &#1576;&#1607; &#1576;&#1585;&#1575;&#1608;&#1585;&#1583; &#1607;&#1586;&#1740;&#1606;&#1607; &#1607;&#1575;&#1740; &#1601;&#1585;&#1608;&#1588;&#1711;&#1575;&#1607; &#1570;&#1606;&#1604;&#1575;&#1740;&#1606; &#1575;&#1576;&#1578;&#1583;&#1575; &#1605;&#1740; &#1576;&#1575;&#1740;&#1587;&#1578; &#1662;&#1740;&#1588; &#1606;&#1740;&#1575;&#1586;&#1607;&#1575;&#1740; &#1604;&#1575;&#1586;&#1605; &#1576;&#1585;&#1575;&#1740; &#1585;&#1575;&#1607; &#1575;&#1606;&#1583;&#1575;&#1586;&#1740; &#1587;&#1575;&#1740;&#1578; &#1601;&#1585;&#1608;&#1588;&#1711;&#1575;&#1607;&#1740; &#1585;&#1575; &#1576;&#1585;&#1585;&#1587; [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:2579:\"<p>&#1705;&#1575;&#1585;&#1576;&#1585;&#1575;&#1606; &#1575;&#1594;&#1604;&#1576; &#1587;&#1608;&#1575;&#1604; &#1605;&#1740; &#1705;&#1606;&#1606;&#1583; &#1705;&#1607; &#1576;&#1585;&#1575;&#1740; &#1588;&#1585;&#1608;&#1593; &#1705;&#1575;&#1585; &#1608; &#1585;&#1575;&#1607; &#1575;&#1606;&#1583;&#1575;&#1586;&#1740; &#1608;&#1576;&#1587;&#1575;&#1740;&#1578; &#1601;&#1585;&#1608;&#1588;&#1711;&#1575;&#1607;&#1740; &#1576;&#1607; &#1670;&#1607; &#1605;&#1608;&#1575;&#1585;&#1583;&#1740; &#1606;&#1740;&#1575;&#1586; &#1582;&#1608;&#1575;&#1607;&#1740;&#1605; &#1583;&#1575;&#1588;&#1578; &#1608; &#1705;&#1604;&#1575; &#1607;&#1586;&#1740;&#1606;&#1607; &#1585;&#1575;&#1607; &#1575;&#1606;&#1583;&#1575;&#1586;&#1740; &#1601;&#1585;&#1608;&#1588;&#1711;&#1575;&#1607; &#1575;&#1740;&#1606;&#1578;&#1585;&#1606;&#1578;&#1740; &#1576;&#1607; &#1591;&#1608;&#1585; &#1578;&#1602;&#1585;&#1740;&#1576;&#1740; &#1670;&#1607; &#1605;&#1740;&#1586;&#1575;&#1606; &#1582;&#1608;&#1575;&#1607;&#1583; &#1576;&#1608;&#1583;&#1567; &#1576;&#1585;&#1575;&#1740; &#1662;&#1575;&#1587;&#1582; &#1576;&#1607; &#1576;&#1585;&#1575;&#1608;&#1585;&#1583; &#1607;&#1586;&#1740;&#1606;&#1607; &#1607;&#1575;&#1740; &#1601;&#1585;&#1608;&#1588;&#1711;&#1575;&#1607; &#1570;&#1606;&#1604;&#1575;&#1740;&#1606; &#1575;&#1576;&#1578;&#1583;&#1575; &#1605;&#1740; &#1576;&#1575;&#1740;&#1587;&#1578; &#1662;&#1740;&#1588; &#1606;&#1740;&#1575;&#1586;&#1607;&#1575;&#1740; &#1604;&#1575;&#1586;&#1605; &#1576;&#1585;&#1575;&#1740; &#1585;&#1575;&#1607; &#1575;&#1606;&#1583;&#1575;&#1586;&#1740; &#1587;&#1575;&#1740;&#1578; &#1601;&#1585;&#1608;&#1588;&#1711;&#1575;&#1607;&#1740; &#1585;&#1575; &#1576;&#1585;&#1585;&#1587; &hellip;</p>\n<p>&#1606;&#1608;&#1588;&#1578;&#1607; <a rel=\"nofollow\" href=\"https://mizbanfa.net/blog/cms/wordpress/ecommerce-website-requirements/\" data-wpel-link=\"internal\">&#1662;&#1740;&#1588; &#1606;&#1740;&#1575;&#1586;&#1607;&#1575;&#1740; &#1604;&#1575;&#1586;&#1605; &#1576;&#1585;&#1575;&#1740; &#1585;&#1575;&#1607; &#1575;&#1606;&#1583;&#1575;&#1586;&#1740; &#1601;&#1585;&#1608;&#1588;&#1711;&#1575;&#1607; &#1575;&#1740;&#1606;&#1578;&#1585;&#1606;&#1578;&#1740; &#1670;&#1740;&#1587;&#1578;&#1567;</a> &#1575;&#1608;&#1604;&#1740;&#1606; &#1576;&#1575;&#1585; &#1583;&#1585; <a rel=\"nofollow\" href=\"https://mizbanfa.net/blog\" data-wpel-link=\"internal\">&#1662;&#1575;&#1740;&#1711;&#1575;&#1607; &#1583;&#1575;&#1606;&#1588; &#1605;&#1740;&#1586;&#1576;&#1575;&#1606;&zwnj;&#1601;&#1575;</a> &#1662;&#1583;&#1740;&#1583;&#1575;&#1585; &#1588;&#1583;.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}s:27:\"http://www.w3.org/2005/Atom\";a:1:{s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:3:{s:4:\"href\";s:25:\"http://wp-planet.ir/feed/\";s:3:\"rel\";s:4:\"self\";s:4:\"type\";s:19:\"application/rss+xml\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:44:\"http://purl.org/rss/1.0/modules/syndication/\";a:2:{s:12:\"updatePeriod\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"\n	hourly	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:15:\"updateFrequency\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"\n	1	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";O:42:\"Requests_Utility_CaseInsensitiveDictionary\":1:{s:7:\"\0*\0data\";a:8:{s:4:\"date\";s:29:\"Fri, 03 Apr 2020 09:51:09 GMT\";s:6:\"server\";s:6:\"Apache\";s:12:\"x-robots-tag\";s:15:\"noindex, follow\";s:4:\"link\";s:56:\"<http://wp-planet.ir/wp-json/>; rel=\"https://api.w.org/\"\";s:13:\"last-modified\";s:29:\"Mon, 30 Mar 2020 09:14:35 GMT\";s:4:\"etag\";s:34:\"\"e7dffa709ef874e564945f2d92f65262\"\";s:12:\"content-type\";s:34:\"application/rss+xml; charset=UTF-8\";s:3:\"age\";s:5:\"12328\";}}s:5:\"build\";s:14:\"20130911040210\";}", "no");
INSERT INTO `wp_options` VALUES("1429", "_transient_timeout_feed_mod_9bb54f090b06ea0b52a1a293dcf1b99e", "1585950669", "no");
INSERT INTO `wp_options` VALUES("1430", "_transient_feed_mod_9bb54f090b06ea0b52a1a293dcf1b99e", "1585907469", "no");
INSERT INTO `wp_options` VALUES("1431", "_transient_timeout_dash_v2_ccb55a4e4b351a220e50ef4117d7dc27", "1585950669", "no");
INSERT INTO `wp_options` VALUES("1432", "_transient_dash_v2_ccb55a4e4b351a220e50ef4117d7dc27", "<div class=\"rss-widget\"><ul><li><a class=\'rsswidget\' href=\'https://wp-parsi.com/%D8%A8%D8%B1%DA%AF%D8%B2%D8%A7%D8%B1%DB%8C-%D9%BE%D9%86%D8%AC%D9%85%DB%8C%D9%86-%D8%B1%D9%88%DB%8C%D8%AF%D8%A7%D8%AF-%D8%A2%DB%8C%D9%86%D8%AF%D9%87-%D9%88%D8%A8-%D9%88-%D9%85%D9%88%D8%A8%D8%A7%DB%8C/\'>برگزاری پنجمین رویداد آینده وب و موبایل</a></li></ul></div><div class=\"rss-widget\"><ul><li><a class=\'rsswidget\' href=\'http://wp-planet.ir/%D8%A2%D8%B4%D9%86%D8%A7%DB%8C%DB%8C-%D8%A8%D8%A7-%D8%B5%D9%81%D8%AD%D9%87-%D8%B3%D8%A7%D8%B2-%D9%87%D8%A7%DB%8C-%D8%A8%D8%B1%D8%AA%D8%B1-%D9%88%D8%B1%D8%AF%D9%BE%D8%B1%D8%B3/\'>آشنایی با صفحه ساز های برتر وردپرس</a></li><li><a class=\'rsswidget\' href=\'http://wp-planet.ir/just-how-do-you-compose-science-content-articles-for-kids/\'>Just how Do You Compose Science Content Articles For Kids?</a></li><li><a class=\'rsswidget\' href=\'http://wp-planet.ir/a-rally-and-also-a-conference/\'>A Rally and Also a Conference</a></li></ul></div>", "no");
INSERT INTO `wp_options` VALUES("1435", "_site_transient_timeout_theme_roots", "1585909450", "no");
INSERT INTO `wp_options` VALUES("1436", "_site_transient_theme_roots", "a:2:{s:23:\"Divi-Child-Theme-master\";s:7:\"/themes\";s:4:\"Divi\";s:7:\"/themes\";}", "no");

/* INSERT TABLE DATA: wp_postmeta */
INSERT INTO `wp_postmeta` VALUES("1", "2", "_wp_page_template", "default");
INSERT INTO `wp_postmeta` VALUES("2", "3", "_wp_page_template", "default");
INSERT INTO `wp_postmeta` VALUES("5", "8", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("6", "8", "_et_post_bg_color", "#ffffff");
INSERT INTO `wp_postmeta` VALUES("7", "8", "_et_post_bg_layout", "light");
INSERT INTO `wp_postmeta` VALUES("8", "8", "_et_pb_show_title", "on");
INSERT INTO `wp_postmeta` VALUES("9", "8", "_et_pb_post_hide_nav", "default");
INSERT INTO `wp_postmeta` VALUES("10", "8", "_et_pb_page_layout", "et_left_sidebar");
INSERT INTO `wp_postmeta` VALUES("11", "8", "_et_pb_side_nav", "off");
INSERT INTO `wp_postmeta` VALUES("12", "8", "_wp_old_slug", "%d8%b3%d9%84%d8%a7%d9%85-%d8%af%d9%86%db%8c%d8%a7");
INSERT INTO `wp_postmeta` VALUES("14", "8", "_et_monarch_override", "");
INSERT INTO `wp_postmeta` VALUES("15", "167", "_et_pb_use_builder", "off");
INSERT INTO `wp_postmeta` VALUES("16", "167", "_et_pb_old_content", "");
INSERT INTO `wp_postmeta` VALUES("17", "167", "_et_gb_content_width", "");
INSERT INTO `wp_postmeta` VALUES("18", "167", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("19", "167", "_et_post_bg_color", "#ffffff");
INSERT INTO `wp_postmeta` VALUES("20", "167", "_et_post_bg_layout", "light");
INSERT INTO `wp_postmeta` VALUES("21", "167", "_et_pb_show_title", "on");
INSERT INTO `wp_postmeta` VALUES("22", "167", "_et_pb_post_hide_nav", "default");
INSERT INTO `wp_postmeta` VALUES("23", "167", "_et_pb_page_layout", "et_left_sidebar");
INSERT INTO `wp_postmeta` VALUES("24", "167", "_et_pb_side_nav", "off");
INSERT INTO `wp_postmeta` VALUES("26", "167", "_et_monarch_override", "");
INSERT INTO `wp_postmeta` VALUES("27", "169", "_et_pb_use_builder", "off");
INSERT INTO `wp_postmeta` VALUES("28", "169", "_et_pb_old_content", "");
INSERT INTO `wp_postmeta` VALUES("29", "169", "_et_gb_content_width", "");
INSERT INTO `wp_postmeta` VALUES("30", "169", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("31", "169", "_et_post_bg_color", "#ffffff");
INSERT INTO `wp_postmeta` VALUES("32", "169", "_et_post_bg_layout", "light");
INSERT INTO `wp_postmeta` VALUES("33", "169", "_et_pb_show_title", "on");
INSERT INTO `wp_postmeta` VALUES("34", "169", "_et_pb_post_hide_nav", "default");
INSERT INTO `wp_postmeta` VALUES("35", "169", "_et_pb_page_layout", "et_left_sidebar");
INSERT INTO `wp_postmeta` VALUES("36", "169", "_et_pb_side_nav", "off");
INSERT INTO `wp_postmeta` VALUES("38", "169", "_et_monarch_override", "");
INSERT INTO `wp_postmeta` VALUES("39", "171", "_et_pb_use_builder", "off");
INSERT INTO `wp_postmeta` VALUES("40", "171", "_et_pb_old_content", "");
INSERT INTO `wp_postmeta` VALUES("41", "171", "_et_gb_content_width", "");
INSERT INTO `wp_postmeta` VALUES("42", "171", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("43", "171", "_et_post_bg_color", "#ffffff");
INSERT INTO `wp_postmeta` VALUES("44", "171", "_et_post_bg_layout", "light");
INSERT INTO `wp_postmeta` VALUES("45", "171", "_et_pb_show_title", "on");
INSERT INTO `wp_postmeta` VALUES("46", "171", "_et_pb_post_hide_nav", "default");
INSERT INTO `wp_postmeta` VALUES("47", "171", "_et_pb_page_layout", "et_left_sidebar");
INSERT INTO `wp_postmeta` VALUES("48", "171", "_et_pb_side_nav", "off");
INSERT INTO `wp_postmeta` VALUES("50", "171", "_et_monarch_override", "");
INSERT INTO `wp_postmeta` VALUES("51", "173", "_et_pb_use_builder", "off");
INSERT INTO `wp_postmeta` VALUES("52", "173", "_et_pb_old_content", "");
INSERT INTO `wp_postmeta` VALUES("53", "173", "_et_gb_content_width", "");
INSERT INTO `wp_postmeta` VALUES("54", "173", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("55", "173", "_et_post_bg_color", "#ffffff");
INSERT INTO `wp_postmeta` VALUES("56", "173", "_et_post_bg_layout", "light");
INSERT INTO `wp_postmeta` VALUES("57", "173", "_et_pb_show_title", "on");
INSERT INTO `wp_postmeta` VALUES("58", "173", "_et_pb_post_hide_nav", "default");
INSERT INTO `wp_postmeta` VALUES("59", "173", "_et_pb_page_layout", "et_left_sidebar");
INSERT INTO `wp_postmeta` VALUES("60", "173", "_et_pb_side_nav", "off");
INSERT INTO `wp_postmeta` VALUES("62", "173", "_et_monarch_override", "");
INSERT INTO `wp_postmeta` VALUES("63", "175", "_et_pb_use_builder", "off");
INSERT INTO `wp_postmeta` VALUES("64", "175", "_et_pb_old_content", "");
INSERT INTO `wp_postmeta` VALUES("65", "175", "_et_gb_content_width", "");
INSERT INTO `wp_postmeta` VALUES("66", "175", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("67", "175", "_et_post_bg_color", "#ffffff");
INSERT INTO `wp_postmeta` VALUES("68", "175", "_et_post_bg_layout", "light");
INSERT INTO `wp_postmeta` VALUES("69", "175", "_et_pb_show_title", "on");
INSERT INTO `wp_postmeta` VALUES("70", "175", "_et_pb_post_hide_nav", "default");
INSERT INTO `wp_postmeta` VALUES("71", "175", "_et_pb_page_layout", "et_left_sidebar");
INSERT INTO `wp_postmeta` VALUES("72", "175", "_et_pb_side_nav", "off");
INSERT INTO `wp_postmeta` VALUES("74", "175", "_et_monarch_override", "");
INSERT INTO `wp_postmeta` VALUES("79", "2", "_edit_lock", "1583402585:1");
INSERT INTO `wp_postmeta` VALUES("80", "2", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("81", "2", "_et_monarch_override", "");
INSERT INTO `wp_postmeta` VALUES("82", "2", "_et_pb_post_hide_nav", "default");
INSERT INTO `wp_postmeta` VALUES("83", "2", "_et_pb_page_layout", "et_left_sidebar");
INSERT INTO `wp_postmeta` VALUES("84", "2", "_et_pb_side_nav", "off");
INSERT INTO `wp_postmeta` VALUES("85", "2", "_et_pb_use_builder", "on");
INSERT INTO `wp_postmeta` VALUES("86", "2", "_et_pb_show_page_creation", "off");
INSERT INTO `wp_postmeta` VALUES("87", "2", "_et_pb_old_content", "");
INSERT INTO `wp_postmeta` VALUES("100", "2", "_et_pb_built_for_post_type", "page");
INSERT INTO `wp_postmeta` VALUES("101", "2", "_et_pb_ab_subjects", "");
INSERT INTO `wp_postmeta` VALUES("102", "2", "_et_pb_enable_shortcode_tracking", "");
INSERT INTO `wp_postmeta` VALUES("103", "2", "_et_pb_ab_current_shortcode", "[et_pb_split_track id=\"2\" /]");
INSERT INTO `wp_postmeta` VALUES("104", "2", "_et_pb_custom_css", "");
INSERT INTO `wp_postmeta` VALUES("105", "2", "_et_pb_gutter_width", "3");
INSERT INTO `wp_postmeta` VALUES("106", "2", "_thumbnail_id", "");
INSERT INTO `wp_postmeta` VALUES("107", "2", "_et_pb_first_image", "");
INSERT INTO `wp_postmeta` VALUES("108", "2", "_et_pb_truncate_post", "");
INSERT INTO `wp_postmeta` VALUES("109", "2", "_et_pb_truncate_post_date", "");
INSERT INTO `wp_postmeta` VALUES("110", "2", "_et_builder_version", "VB|Divi|4.4.2");
INSERT INTO `wp_postmeta` VALUES("111", "187", "_edit_lock", "1583404119:1");
INSERT INTO `wp_postmeta` VALUES("112", "187", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("113", "187", "_et_monarch_override", "");
INSERT INTO `wp_postmeta` VALUES("114", "187", "_et_pb_post_hide_nav", "default");
INSERT INTO `wp_postmeta` VALUES("115", "187", "_et_pb_page_layout", "et_left_sidebar");
INSERT INTO `wp_postmeta` VALUES("116", "187", "_et_pb_side_nav", "off");
INSERT INTO `wp_postmeta` VALUES("117", "187", "_et_pb_use_builder", "on");
INSERT INTO `wp_postmeta` VALUES("118", "187", "_et_gb_content_width", "");
INSERT INTO `wp_postmeta` VALUES("129", "187", "_et_pb_built_for_post_type", "page");
INSERT INTO `wp_postmeta` VALUES("130", "187", "_et_pb_ab_subjects", "");
INSERT INTO `wp_postmeta` VALUES("131", "187", "_et_pb_enable_shortcode_tracking", "");
INSERT INTO `wp_postmeta` VALUES("132", "187", "_et_pb_ab_current_shortcode", "[et_pb_split_track id=\"187\" /]");
INSERT INTO `wp_postmeta` VALUES("133", "187", "_et_pb_custom_css", "");
INSERT INTO `wp_postmeta` VALUES("134", "187", "_et_pb_gutter_width", "3");
INSERT INTO `wp_postmeta` VALUES("135", "187", "_thumbnail_id", "");
INSERT INTO `wp_postmeta` VALUES("136", "187", "_et_pb_first_image", "");
INSERT INTO `wp_postmeta` VALUES("137", "187", "_et_pb_truncate_post", "");
INSERT INTO `wp_postmeta` VALUES("138", "187", "_et_pb_truncate_post_date", "");
INSERT INTO `wp_postmeta` VALUES("139", "187", "_et_builder_version", "VB|Divi|4.4.2");
INSERT INTO `wp_postmeta` VALUES("140", "187", "_et_pb_show_page_creation", "off");
INSERT INTO `wp_postmeta` VALUES("141", "195", "_edit_lock", "1583404385:1");
INSERT INTO `wp_postmeta` VALUES("142", "195", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("143", "195", "_et_monarch_override", "");
INSERT INTO `wp_postmeta` VALUES("144", "195", "_et_pb_post_hide_nav", "default");
INSERT INTO `wp_postmeta` VALUES("145", "195", "_et_pb_page_layout", "et_left_sidebar");
INSERT INTO `wp_postmeta` VALUES("146", "195", "_et_pb_side_nav", "off");
INSERT INTO `wp_postmeta` VALUES("147", "195", "_et_pb_use_builder", "on");
INSERT INTO `wp_postmeta` VALUES("148", "195", "_et_gb_content_width", "");
INSERT INTO `wp_postmeta` VALUES("151", "195", "_et_pb_built_for_post_type", "page");
INSERT INTO `wp_postmeta` VALUES("152", "195", "_et_pb_ab_subjects", "");
INSERT INTO `wp_postmeta` VALUES("153", "195", "_et_pb_enable_shortcode_tracking", "");
INSERT INTO `wp_postmeta` VALUES("154", "195", "_et_pb_ab_current_shortcode", "[et_pb_split_track id=\"195\" /]");
INSERT INTO `wp_postmeta` VALUES("155", "195", "_et_pb_custom_css", "");
INSERT INTO `wp_postmeta` VALUES("156", "195", "_et_pb_gutter_width", "3");
INSERT INTO `wp_postmeta` VALUES("157", "195", "_thumbnail_id", "");
INSERT INTO `wp_postmeta` VALUES("158", "195", "_et_pb_first_image", "");
INSERT INTO `wp_postmeta` VALUES("159", "195", "_et_pb_truncate_post", "");
INSERT INTO `wp_postmeta` VALUES("160", "195", "_et_pb_truncate_post_date", "");
INSERT INTO `wp_postmeta` VALUES("161", "195", "_et_builder_version", "VB|Divi|4.4.2");
INSERT INTO `wp_postmeta` VALUES("162", "195", "_et_pb_show_page_creation", "off");
INSERT INTO `wp_postmeta` VALUES("220", "256", "_menu_item_type", "custom");
INSERT INTO `wp_postmeta` VALUES("221", "256", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("222", "256", "_menu_item_object_id", "256");
INSERT INTO `wp_postmeta` VALUES("223", "256", "_menu_item_object", "custom");
INSERT INTO `wp_postmeta` VALUES("224", "256", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("225", "256", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("226", "256", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("227", "256", "_menu_item_url", "http://modelsite.test/");
INSERT INTO `wp_postmeta` VALUES("228", "256", "_menu_item_orphaned", "1583411577");
INSERT INTO `wp_postmeta` VALUES("229", "257", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("230", "257", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("231", "257", "_menu_item_object_id", "195");
INSERT INTO `wp_postmeta` VALUES("232", "257", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("233", "257", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("234", "257", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("235", "257", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("236", "257", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("238", "258", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("239", "258", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("240", "258", "_menu_item_object_id", "2");
INSERT INTO `wp_postmeta` VALUES("241", "258", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("242", "258", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("243", "258", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("244", "258", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("245", "258", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("256", "260", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("257", "260", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("258", "260", "_menu_item_object_id", "187");
INSERT INTO `wp_postmeta` VALUES("259", "260", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("260", "260", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("261", "260", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("262", "260", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("263", "260", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("298", "267", "_edit_lock", "1584019307:1");
INSERT INTO `wp_postmeta` VALUES("299", "267", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("300", "267", "_et_monarch_override", "");
INSERT INTO `wp_postmeta` VALUES("301", "267", "_et_pb_post_hide_nav", "default");
INSERT INTO `wp_postmeta` VALUES("302", "267", "_et_pb_page_layout", "et_left_sidebar");
INSERT INTO `wp_postmeta` VALUES("303", "267", "_et_pb_side_nav", "off");
INSERT INTO `wp_postmeta` VALUES("304", "267", "_et_pb_use_builder", "on");
INSERT INTO `wp_postmeta` VALUES("305", "267", "_et_gb_content_width", "");
INSERT INTO `wp_postmeta` VALUES("314", "267", "_et_pb_built_for_post_type", "page");
INSERT INTO `wp_postmeta` VALUES("315", "267", "_et_pb_ab_subjects", "");
INSERT INTO `wp_postmeta` VALUES("316", "267", "_et_pb_enable_shortcode_tracking", "");
INSERT INTO `wp_postmeta` VALUES("317", "267", "_et_pb_ab_current_shortcode", "[et_pb_split_track id=\"267\" /]");
INSERT INTO `wp_postmeta` VALUES("318", "267", "_et_pb_custom_css", "");
INSERT INTO `wp_postmeta` VALUES("319", "267", "_et_pb_gutter_width", "3");
INSERT INTO `wp_postmeta` VALUES("320", "267", "_thumbnail_id", "");
INSERT INTO `wp_postmeta` VALUES("321", "267", "_et_pb_first_image", "");
INSERT INTO `wp_postmeta` VALUES("322", "267", "_et_pb_truncate_post", "");
INSERT INTO `wp_postmeta` VALUES("323", "267", "_et_pb_truncate_post_date", "");
INSERT INTO `wp_postmeta` VALUES("324", "267", "_et_builder_version", "VB|Divi|4.4.2");
INSERT INTO `wp_postmeta` VALUES("325", "267", "_et_pb_show_page_creation", "off");
INSERT INTO `wp_postmeta` VALUES("326", "8", "_edit_lock", "1585821610:1");
INSERT INTO `wp_postmeta` VALUES("331", "167", "_edit_lock", "1585821754:1");
INSERT INTO `wp_postmeta` VALUES("336", "169", "_edit_lock", "1585821753:1");
INSERT INTO `wp_postmeta` VALUES("341", "171", "_edit_lock", "1585821609:1");
INSERT INTO `wp_postmeta` VALUES("346", "173", "_edit_lock", "1585821608:1");
INSERT INTO `wp_postmeta` VALUES("351", "175", "_edit_lock", "1585821607:1");
INSERT INTO `wp_postmeta` VALUES("356", "281", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("357", "281", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("358", "281", "_menu_item_object_id", "267");
INSERT INTO `wp_postmeta` VALUES("359", "281", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("360", "281", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("361", "281", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("362", "281", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("363", "281", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("365", "282", "_wp_attached_file", "2020/03/cropped-cleaning-services-06.jpg");
INSERT INTO `wp_postmeta` VALUES("366", "282", "_wp_attachment_context", "site-icon");
INSERT INTO `wp_postmeta` VALUES("367", "282", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:512;s:6:\"height\";i:512;s:4:\"file\";s:40:\"2020/03/cropped-cleaning-services-06.jpg\";s:5:\"sizes\";a:11:{s:6:\"medium\";a:4:{s:4:\"file\";s:40:\"cropped-cleaning-services-06-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:40:\"cropped-cleaning-services-06-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:21:\"et-pb-post-main-image\";a:4:{s:4:\"file\";s:40:\"cropped-cleaning-services-06-400x250.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:21:\"et-pb-portfolio-image\";a:4:{s:4:\"file\";s:40:\"cropped-cleaning-services-06-400x284.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:284;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:28:\"et-pb-portfolio-module-image\";a:4:{s:4:\"file\";s:40:\"cropped-cleaning-services-06-510x382.jpg\";s:5:\"width\";i:510;s:6:\"height\";i:382;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:35:\"et-pb-gallery-module-image-portrait\";a:4:{s:4:\"file\";s:40:\"cropped-cleaning-services-06-400x512.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:512;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:30:\"et-pb-image--responsive--phone\";a:4:{s:4:\"file\";s:40:\"cropped-cleaning-services-06-480x480.jpg\";s:5:\"width\";i:480;s:6:\"height\";i:480;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:13:\"site_icon-270\";a:4:{s:4:\"file\";s:40:\"cropped-cleaning-services-06-270x270.jpg\";s:5:\"width\";i:270;s:6:\"height\";i:270;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:13:\"site_icon-192\";a:4:{s:4:\"file\";s:40:\"cropped-cleaning-services-06-192x192.jpg\";s:5:\"width\";i:192;s:6:\"height\";i:192;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:13:\"site_icon-180\";a:4:{s:4:\"file\";s:40:\"cropped-cleaning-services-06-180x180.jpg\";s:5:\"width\";i:180;s:6:\"height\";i:180;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"site_icon-32\";a:4:{s:4:\"file\";s:38:\"cropped-cleaning-services-06-32x32.jpg\";s:5:\"width\";i:32;s:6:\"height\";i:32;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("379", "258", "menu-icons", "a:8:{s:4:\"type\";s:9:\"dashicons\";s:4:\"icon\";s:20:\"dashicons-admin-site\";s:10:\"hide_label\";s:0:\"\";s:8:\"position\";s:6:\"before\";s:14:\"vertical_align\";s:6:\"middle\";s:9:\"font_size\";s:3:\"1.2\";s:9:\"svg_width\";s:1:\"1\";s:10:\"image_size\";s:9:\"thumbnail\";}");
INSERT INTO `wp_postmeta` VALUES("382", "281", "menu-icons", "a:8:{s:4:\"type\";s:9:\"dashicons\";s:4:\"icon\";s:28:\"dashicons-welcome-learn-more\";s:10:\"hide_label\";s:0:\"\";s:8:\"position\";s:6:\"before\";s:14:\"vertical_align\";s:6:\"middle\";s:9:\"font_size\";s:3:\"1.2\";s:9:\"svg_width\";s:1:\"1\";s:10:\"image_size\";s:9:\"thumbnail\";}");
INSERT INTO `wp_postmeta` VALUES("383", "260", "menu-icons", "a:8:{s:4:\"type\";s:9:\"dashicons\";s:4:\"icon\";s:12:\"dashicons-id\";s:10:\"hide_label\";s:0:\"\";s:8:\"position\";s:6:\"before\";s:14:\"vertical_align\";s:6:\"middle\";s:9:\"font_size\";s:3:\"1.2\";s:9:\"svg_width\";s:1:\"1\";s:10:\"image_size\";s:9:\"thumbnail\";}");
INSERT INTO `wp_postmeta` VALUES("384", "257", "menu-icons", "a:8:{s:4:\"type\";s:9:\"dashicons\";s:4:\"icon\";s:15:\"dashicons-phone\";s:10:\"hide_label\";s:0:\"\";s:8:\"position\";s:6:\"before\";s:14:\"vertical_align\";s:6:\"middle\";s:9:\"font_size\";s:3:\"1.2\";s:9:\"svg_width\";s:1:\"1\";s:10:\"image_size\";s:9:\"thumbnail\";}");
INSERT INTO `wp_postmeta` VALUES("465", "338", "_wp_attached_file", "2020/03/cropped-icon-dry.png");
INSERT INTO `wp_postmeta` VALUES("466", "338", "_wp_attachment_context", "site-icon");
INSERT INTO `wp_postmeta` VALUES("467", "338", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:512;s:6:\"height\";i:512;s:4:\"file\";s:28:\"2020/03/cropped-icon-dry.png\";s:5:\"sizes\";a:11:{s:6:\"medium\";a:4:{s:4:\"file\";s:28:\"cropped-icon-dry-300x300.png\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:9:\"image/png\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:28:\"cropped-icon-dry-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-post-main-image\";a:4:{s:4:\"file\";s:28:\"cropped-icon-dry-400x250.png\";s:5:\"width\";i:400;s:6:\"height\";i:250;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-portfolio-image\";a:4:{s:4:\"file\";s:28:\"cropped-icon-dry-400x284.png\";s:5:\"width\";i:400;s:6:\"height\";i:284;s:9:\"mime-type\";s:9:\"image/png\";}s:28:\"et-pb-portfolio-module-image\";a:4:{s:4:\"file\";s:28:\"cropped-icon-dry-510x382.png\";s:5:\"width\";i:510;s:6:\"height\";i:382;s:9:\"mime-type\";s:9:\"image/png\";}s:35:\"et-pb-gallery-module-image-portrait\";a:4:{s:4:\"file\";s:28:\"cropped-icon-dry-400x512.png\";s:5:\"width\";i:400;s:6:\"height\";i:512;s:9:\"mime-type\";s:9:\"image/png\";}s:30:\"et-pb-image--responsive--phone\";a:4:{s:4:\"file\";s:28:\"cropped-icon-dry-480x480.png\";s:5:\"width\";i:480;s:6:\"height\";i:480;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-270\";a:4:{s:4:\"file\";s:28:\"cropped-icon-dry-270x270.png\";s:5:\"width\";i:270;s:6:\"height\";i:270;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-192\";a:4:{s:4:\"file\";s:28:\"cropped-icon-dry-192x192.png\";s:5:\"width\";i:192;s:6:\"height\";i:192;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-180\";a:4:{s:4:\"file\";s:28:\"cropped-icon-dry-180x180.png\";s:5:\"width\";i:180;s:6:\"height\";i:180;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"site_icon-32\";a:4:{s:4:\"file\";s:26:\"cropped-icon-dry-32x32.png\";s:5:\"width\";i:32;s:6:\"height\";i:32;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("579", "446", "_wp_attached_file", "2020/03/cropped-Car-wash-logo.png");
INSERT INTO `wp_postmeta` VALUES("580", "446", "_wp_attachment_context", "site-icon");
INSERT INTO `wp_postmeta` VALUES("581", "446", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:512;s:6:\"height\";i:512;s:4:\"file\";s:33:\"2020/03/cropped-Car-wash-logo.png\";s:5:\"sizes\";a:11:{s:6:\"medium\";a:4:{s:4:\"file\";s:33:\"cropped-Car-wash-logo-300x300.png\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:9:\"image/png\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:33:\"cropped-Car-wash-logo-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-post-main-image\";a:4:{s:4:\"file\";s:33:\"cropped-Car-wash-logo-400x250.png\";s:5:\"width\";i:400;s:6:\"height\";i:250;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-portfolio-image\";a:4:{s:4:\"file\";s:33:\"cropped-Car-wash-logo-400x284.png\";s:5:\"width\";i:400;s:6:\"height\";i:284;s:9:\"mime-type\";s:9:\"image/png\";}s:28:\"et-pb-portfolio-module-image\";a:4:{s:4:\"file\";s:33:\"cropped-Car-wash-logo-510x382.png\";s:5:\"width\";i:510;s:6:\"height\";i:382;s:9:\"mime-type\";s:9:\"image/png\";}s:35:\"et-pb-gallery-module-image-portrait\";a:4:{s:4:\"file\";s:33:\"cropped-Car-wash-logo-400x512.png\";s:5:\"width\";i:400;s:6:\"height\";i:512;s:9:\"mime-type\";s:9:\"image/png\";}s:30:\"et-pb-image--responsive--phone\";a:4:{s:4:\"file\";s:33:\"cropped-Car-wash-logo-480x480.png\";s:5:\"width\";i:480;s:6:\"height\";i:480;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-270\";a:4:{s:4:\"file\";s:33:\"cropped-Car-wash-logo-270x270.png\";s:5:\"width\";i:270;s:6:\"height\";i:270;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-192\";a:4:{s:4:\"file\";s:33:\"cropped-Car-wash-logo-192x192.png\";s:5:\"width\";i:192;s:6:\"height\";i:192;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-180\";a:4:{s:4:\"file\";s:33:\"cropped-Car-wash-logo-180x180.png\";s:5:\"width\";i:180;s:6:\"height\";i:180;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"site_icon-32\";a:4:{s:4:\"file\";s:31:\"cropped-Car-wash-logo-32x32.png\";s:5:\"width\";i:32;s:6:\"height\";i:32;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("753", "570", "_wp_attached_file", "2020/03/cropped-startup-logo.png");
INSERT INTO `wp_postmeta` VALUES("754", "570", "_wp_attachment_context", "site-icon");
INSERT INTO `wp_postmeta` VALUES("755", "570", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:512;s:6:\"height\";i:512;s:4:\"file\";s:32:\"2020/03/cropped-startup-logo.png\";s:5:\"sizes\";a:11:{s:6:\"medium\";a:4:{s:4:\"file\";s:32:\"cropped-startup-logo-300x300.png\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:9:\"image/png\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:32:\"cropped-startup-logo-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-post-main-image\";a:4:{s:4:\"file\";s:32:\"cropped-startup-logo-400x250.png\";s:5:\"width\";i:400;s:6:\"height\";i:250;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-portfolio-image\";a:4:{s:4:\"file\";s:32:\"cropped-startup-logo-400x284.png\";s:5:\"width\";i:400;s:6:\"height\";i:284;s:9:\"mime-type\";s:9:\"image/png\";}s:28:\"et-pb-portfolio-module-image\";a:4:{s:4:\"file\";s:32:\"cropped-startup-logo-510x382.png\";s:5:\"width\";i:510;s:6:\"height\";i:382;s:9:\"mime-type\";s:9:\"image/png\";}s:35:\"et-pb-gallery-module-image-portrait\";a:4:{s:4:\"file\";s:32:\"cropped-startup-logo-400x512.png\";s:5:\"width\";i:400;s:6:\"height\";i:512;s:9:\"mime-type\";s:9:\"image/png\";}s:30:\"et-pb-image--responsive--phone\";a:4:{s:4:\"file\";s:32:\"cropped-startup-logo-480x480.png\";s:5:\"width\";i:480;s:6:\"height\";i:480;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-270\";a:4:{s:4:\"file\";s:32:\"cropped-startup-logo-270x270.png\";s:5:\"width\";i:270;s:6:\"height\";i:270;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-192\";a:4:{s:4:\"file\";s:32:\"cropped-startup-logo-192x192.png\";s:5:\"width\";i:192;s:6:\"height\";i:192;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-180\";a:4:{s:4:\"file\";s:32:\"cropped-startup-logo-180x180.png\";s:5:\"width\";i:180;s:6:\"height\";i:180;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"site_icon-32\";a:4:{s:4:\"file\";s:30:\"cropped-startup-logo-32x32.png\";s:5:\"width\";i:32;s:6:\"height\";i:32;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("759", "572", "_menu_item_type", "custom");
INSERT INTO `wp_postmeta` VALUES("760", "572", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("761", "572", "_menu_item_object_id", "572");
INSERT INTO `wp_postmeta` VALUES("762", "572", "_menu_item_object", "custom");
INSERT INTO `wp_postmeta` VALUES("763", "572", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("764", "572", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("765", "572", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("766", "572", "_menu_item_url", "#");
INSERT INTO `wp_postmeta` VALUES("768", "573", "_menu_item_type", "custom");
INSERT INTO `wp_postmeta` VALUES("769", "573", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("770", "573", "_menu_item_object_id", "573");
INSERT INTO `wp_postmeta` VALUES("771", "573", "_menu_item_object", "custom");
INSERT INTO `wp_postmeta` VALUES("772", "573", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("773", "573", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("774", "573", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("775", "573", "_menu_item_url", "#");
INSERT INTO `wp_postmeta` VALUES("777", "574", "_menu_item_type", "custom");
INSERT INTO `wp_postmeta` VALUES("778", "574", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("779", "574", "_menu_item_object_id", "574");
INSERT INTO `wp_postmeta` VALUES("780", "574", "_menu_item_object", "custom");
INSERT INTO `wp_postmeta` VALUES("781", "574", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("782", "574", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("783", "574", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("784", "574", "_menu_item_url", "#");
INSERT INTO `wp_postmeta` VALUES("792", "572", "menu-icons", "a:8:{s:4:\"type\";s:5:\"image\";s:4:\"icon\";s:3:\"869\";s:10:\"hide_label\";s:0:\"\";s:8:\"position\";s:6:\"before\";s:14:\"vertical_align\";s:6:\"middle\";s:9:\"font_size\";s:3:\"1.2\";s:9:\"svg_width\";s:1:\"1\";s:10:\"image_size\";s:9:\"thumbnail\";}");
INSERT INTO `wp_postmeta` VALUES("793", "573", "menu-icons", "a:8:{s:4:\"type\";s:5:\"image\";s:4:\"icon\";s:3:\"867\";s:10:\"hide_label\";s:0:\"\";s:8:\"position\";s:6:\"before\";s:14:\"vertical_align\";s:6:\"middle\";s:9:\"font_size\";s:3:\"1.2\";s:9:\"svg_width\";s:1:\"1\";s:10:\"image_size\";s:9:\"thumbnail\";}");
INSERT INTO `wp_postmeta` VALUES("794", "574", "menu-icons", "a:8:{s:4:\"type\";s:5:\"image\";s:4:\"icon\";s:3:\"868\";s:10:\"hide_label\";s:0:\"\";s:8:\"position\";s:6:\"before\";s:14:\"vertical_align\";s:6:\"middle\";s:9:\"font_size\";s:3:\"1.2\";s:9:\"svg_width\";s:1:\"1\";s:10:\"image_size\";s:9:\"thumbnail\";}");
INSERT INTO `wp_postmeta` VALUES("930", "700", "_wp_attached_file", "2020/03/cropped-app-logo.png");
INSERT INTO `wp_postmeta` VALUES("931", "700", "_wp_attachment_context", "site-icon");
INSERT INTO `wp_postmeta` VALUES("932", "700", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:512;s:6:\"height\";i:512;s:4:\"file\";s:28:\"2020/03/cropped-app-logo.png\";s:5:\"sizes\";a:11:{s:6:\"medium\";a:4:{s:4:\"file\";s:28:\"cropped-app-logo-300x300.png\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:9:\"image/png\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:28:\"cropped-app-logo-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-post-main-image\";a:4:{s:4:\"file\";s:28:\"cropped-app-logo-400x250.png\";s:5:\"width\";i:400;s:6:\"height\";i:250;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-portfolio-image\";a:4:{s:4:\"file\";s:28:\"cropped-app-logo-400x284.png\";s:5:\"width\";i:400;s:6:\"height\";i:284;s:9:\"mime-type\";s:9:\"image/png\";}s:28:\"et-pb-portfolio-module-image\";a:4:{s:4:\"file\";s:28:\"cropped-app-logo-510x382.png\";s:5:\"width\";i:510;s:6:\"height\";i:382;s:9:\"mime-type\";s:9:\"image/png\";}s:35:\"et-pb-gallery-module-image-portrait\";a:4:{s:4:\"file\";s:28:\"cropped-app-logo-400x512.png\";s:5:\"width\";i:400;s:6:\"height\";i:512;s:9:\"mime-type\";s:9:\"image/png\";}s:30:\"et-pb-image--responsive--phone\";a:4:{s:4:\"file\";s:28:\"cropped-app-logo-480x480.png\";s:5:\"width\";i:480;s:6:\"height\";i:480;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-270\";a:4:{s:4:\"file\";s:28:\"cropped-app-logo-270x270.png\";s:5:\"width\";i:270;s:6:\"height\";i:270;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-192\";a:4:{s:4:\"file\";s:28:\"cropped-app-logo-192x192.png\";s:5:\"width\";i:192;s:6:\"height\";i:192;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-180\";a:4:{s:4:\"file\";s:28:\"cropped-app-logo-180x180.png\";s:5:\"width\";i:180;s:6:\"height\";i:180;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"site_icon-32\";a:4:{s:4:\"file\";s:26:\"cropped-app-logo-32x32.png\";s:5:\"width\";i:32;s:6:\"height\";i:32;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("1053", "187", "_et_pb_color_palette", "#510e00|#ffffff|#e02b20|#e09900|#edf000|#7cda24|#0c71c3|#8300e9");
INSERT INTO `wp_postmeta` VALUES("1059", "830", "_wp_attached_file", "2020/03/cropped-barber-icon-1-1.png");
INSERT INTO `wp_postmeta` VALUES("1060", "830", "_wp_attachment_context", "site-icon");
INSERT INTO `wp_postmeta` VALUES("1061", "830", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:512;s:6:\"height\";i:512;s:4:\"file\";s:35:\"2020/03/cropped-barber-icon-1-1.png\";s:5:\"sizes\";a:11:{s:6:\"medium\";a:4:{s:4:\"file\";s:35:\"cropped-barber-icon-1-1-300x300.png\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:9:\"image/png\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:35:\"cropped-barber-icon-1-1-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-post-main-image\";a:4:{s:4:\"file\";s:35:\"cropped-barber-icon-1-1-400x250.png\";s:5:\"width\";i:400;s:6:\"height\";i:250;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-portfolio-image\";a:4:{s:4:\"file\";s:35:\"cropped-barber-icon-1-1-400x284.png\";s:5:\"width\";i:400;s:6:\"height\";i:284;s:9:\"mime-type\";s:9:\"image/png\";}s:28:\"et-pb-portfolio-module-image\";a:4:{s:4:\"file\";s:35:\"cropped-barber-icon-1-1-510x382.png\";s:5:\"width\";i:510;s:6:\"height\";i:382;s:9:\"mime-type\";s:9:\"image/png\";}s:35:\"et-pb-gallery-module-image-portrait\";a:4:{s:4:\"file\";s:35:\"cropped-barber-icon-1-1-400x512.png\";s:5:\"width\";i:400;s:6:\"height\";i:512;s:9:\"mime-type\";s:9:\"image/png\";}s:30:\"et-pb-image--responsive--phone\";a:4:{s:4:\"file\";s:35:\"cropped-barber-icon-1-1-480x480.png\";s:5:\"width\";i:480;s:6:\"height\";i:480;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-270\";a:4:{s:4:\"file\";s:35:\"cropped-barber-icon-1-1-270x270.png\";s:5:\"width\";i:270;s:6:\"height\";i:270;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-192\";a:4:{s:4:\"file\";s:35:\"cropped-barber-icon-1-1-192x192.png\";s:5:\"width\";i:192;s:6:\"height\";i:192;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-180\";a:4:{s:4:\"file\";s:35:\"cropped-barber-icon-1-1-180x180.png\";s:5:\"width\";i:180;s:6:\"height\";i:180;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"site_icon-32\";a:4:{s:4:\"file\";s:33:\"cropped-barber-icon-1-1-32x32.png\";s:5:\"width\";i:32;s:6:\"height\";i:32;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("1127", "867", "_wp_attached_file", "2020/03/icon-aparat.png");
INSERT INTO `wp_postmeta` VALUES("1128", "867", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:16;s:6:\"height\";i:16;s:4:\"file\";s:23:\"2020/03/icon-aparat.png\";s:5:\"sizes\";a:0:{}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("1129", "868", "_wp_attached_file", "2020/03/icon-insta.png");
INSERT INTO `wp_postmeta` VALUES("1130", "868", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:16;s:6:\"height\";i:16;s:4:\"file\";s:22:\"2020/03/icon-insta.png\";s:5:\"sizes\";a:0:{}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("1131", "869", "_wp_attached_file", "2020/03/icon-tel.png");
INSERT INTO `wp_postmeta` VALUES("1132", "869", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:16;s:6:\"height\";i:16;s:4:\"file\";s:20:\"2020/03/icon-tel.png\";s:5:\"sizes\";a:0:{}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("1169", "267", "_wp_page_template", "default");
INSERT INTO `wp_postmeta` VALUES("1170", "899", "_edit_lock", "1585575400:1");
INSERT INTO `wp_postmeta` VALUES("1171", "899", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("1172", "899", "_et_monarch_override", "");
INSERT INTO `wp_postmeta` VALUES("1173", "899", "_et_pb_post_hide_nav", "default");
INSERT INTO `wp_postmeta` VALUES("1174", "899", "_et_pb_page_layout", "et_left_sidebar");
INSERT INTO `wp_postmeta` VALUES("1175", "899", "_et_pb_side_nav", "off");
INSERT INTO `wp_postmeta` VALUES("1176", "899", "_et_pb_use_builder", "on");
INSERT INTO `wp_postmeta` VALUES("1177", "899", "_et_gb_content_width", "");
INSERT INTO `wp_postmeta` VALUES("1180", "899", "_et_pb_built_for_post_type", "page");
INSERT INTO `wp_postmeta` VALUES("1181", "899", "_et_pb_ab_subjects", "");
INSERT INTO `wp_postmeta` VALUES("1182", "899", "_et_pb_enable_shortcode_tracking", "");
INSERT INTO `wp_postmeta` VALUES("1183", "899", "_et_pb_ab_current_shortcode", "[et_pb_split_track id=\"899\" /]");
INSERT INTO `wp_postmeta` VALUES("1184", "899", "_et_pb_custom_css", "");
INSERT INTO `wp_postmeta` VALUES("1185", "899", "_et_pb_gutter_width", "3");
INSERT INTO `wp_postmeta` VALUES("1186", "899", "_thumbnail_id", "");
INSERT INTO `wp_postmeta` VALUES("1187", "899", "_et_pb_first_image", "");
INSERT INTO `wp_postmeta` VALUES("1188", "899", "_et_pb_truncate_post", "");
INSERT INTO `wp_postmeta` VALUES("1189", "899", "_et_pb_truncate_post_date", "");
INSERT INTO `wp_postmeta` VALUES("1190", "899", "_et_builder_version", "VB|Divi|4.4.2");
INSERT INTO `wp_postmeta` VALUES("1191", "899", "_et_pb_show_page_creation", "off");
INSERT INTO `wp_postmeta` VALUES("1240", "923", "_wp_attached_file", "2020/03/cropped-theater-icon.png");
INSERT INTO `wp_postmeta` VALUES("1241", "923", "_wp_attachment_context", "site-icon");
INSERT INTO `wp_postmeta` VALUES("1242", "923", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:512;s:6:\"height\";i:512;s:4:\"file\";s:32:\"2020/03/cropped-theater-icon.png\";s:5:\"sizes\";a:11:{s:6:\"medium\";a:4:{s:4:\"file\";s:32:\"cropped-theater-icon-300x300.png\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:9:\"image/png\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:32:\"cropped-theater-icon-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-post-main-image\";a:4:{s:4:\"file\";s:32:\"cropped-theater-icon-400x250.png\";s:5:\"width\";i:400;s:6:\"height\";i:250;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-portfolio-image\";a:4:{s:4:\"file\";s:32:\"cropped-theater-icon-400x284.png\";s:5:\"width\";i:400;s:6:\"height\";i:284;s:9:\"mime-type\";s:9:\"image/png\";}s:28:\"et-pb-portfolio-module-image\";a:4:{s:4:\"file\";s:32:\"cropped-theater-icon-510x382.png\";s:5:\"width\";i:510;s:6:\"height\";i:382;s:9:\"mime-type\";s:9:\"image/png\";}s:35:\"et-pb-gallery-module-image-portrait\";a:4:{s:4:\"file\";s:32:\"cropped-theater-icon-400x512.png\";s:5:\"width\";i:400;s:6:\"height\";i:512;s:9:\"mime-type\";s:9:\"image/png\";}s:30:\"et-pb-image--responsive--phone\";a:4:{s:4:\"file\";s:32:\"cropped-theater-icon-480x480.png\";s:5:\"width\";i:480;s:6:\"height\";i:480;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-270\";a:4:{s:4:\"file\";s:32:\"cropped-theater-icon-270x270.png\";s:5:\"width\";i:270;s:6:\"height\";i:270;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-192\";a:4:{s:4:\"file\";s:32:\"cropped-theater-icon-192x192.png\";s:5:\"width\";i:192;s:6:\"height\";i:192;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-180\";a:4:{s:4:\"file\";s:32:\"cropped-theater-icon-180x180.png\";s:5:\"width\";i:180;s:6:\"height\";i:180;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"site_icon-32\";a:4:{s:4:\"file\";s:30:\"cropped-theater-icon-32x32.png\";s:5:\"width\";i:32;s:6:\"height\";i:32;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("1267", "951", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("1268", "951", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("1269", "951", "_menu_item_object_id", "2");
INSERT INTO `wp_postmeta` VALUES("1270", "951", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("1271", "951", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("1272", "951", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("1273", "951", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("1274", "951", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("1275", "951", "_menu_item_orphaned", "1584020153");
INSERT INTO `wp_postmeta` VALUES("1285", "953", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("1286", "953", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("1287", "953", "_menu_item_object_id", "195");
INSERT INTO `wp_postmeta` VALUES("1288", "953", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("1289", "953", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("1290", "953", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("1291", "953", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("1292", "953", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("1293", "953", "_menu_item_orphaned", "1584020154");
INSERT INTO `wp_postmeta` VALUES("1294", "954", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("1295", "954", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("1296", "954", "_menu_item_object_id", "187");
INSERT INTO `wp_postmeta` VALUES("1297", "954", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("1298", "954", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("1299", "954", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("1300", "954", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("1301", "954", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("1302", "954", "_menu_item_orphaned", "1584020155");
INSERT INTO `wp_postmeta` VALUES("1303", "955", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("1304", "955", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("1305", "955", "_menu_item_object_id", "899");
INSERT INTO `wp_postmeta` VALUES("1306", "955", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("1307", "955", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("1308", "955", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("1309", "955", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("1310", "955", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("1330", "958", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("1331", "958", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("1332", "958", "_menu_item_object_id", "267");
INSERT INTO `wp_postmeta` VALUES("1333", "958", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("1334", "958", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("1335", "958", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("1336", "958", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("1337", "958", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("1338", "958", "_menu_item_orphaned", "1584020157");
INSERT INTO `wp_postmeta` VALUES("1341", "955", "menu-icons", "a:8:{s:4:\"type\";s:9:\"dashicons\";s:4:\"icon\";s:15:\"dashicons-share\";s:10:\"hide_label\";s:0:\"\";s:8:\"position\";s:6:\"before\";s:14:\"vertical_align\";s:6:\"middle\";s:9:\"font_size\";s:3:\"1.2\";s:9:\"svg_width\";s:1:\"1\";s:10:\"image_size\";s:9:\"thumbnail\";}");
INSERT INTO `wp_postmeta` VALUES("1398", "899", "_wp_page_template", "default");
INSERT INTO `wp_postmeta` VALUES("1434", "2", "_et_pb_color_palette", "#af8447|#ffffff|#e8b500|#680000|#edf000|#7cda24|#0c71c3|#8300e9");
INSERT INTO `wp_postmeta` VALUES("1437", "1042", "_wp_attached_file", "2020/03/cropped-Custom-Screen-Printing-logo.png");
INSERT INTO `wp_postmeta` VALUES("1438", "1042", "_wp_attachment_context", "site-icon");
INSERT INTO `wp_postmeta` VALUES("1439", "1042", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:512;s:6:\"height\";i:512;s:4:\"file\";s:47:\"2020/03/cropped-Custom-Screen-Printing-logo.png\";s:5:\"sizes\";a:11:{s:6:\"medium\";a:4:{s:4:\"file\";s:47:\"cropped-Custom-Screen-Printing-logo-300x300.png\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:9:\"image/png\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:47:\"cropped-Custom-Screen-Printing-logo-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-post-main-image\";a:4:{s:4:\"file\";s:47:\"cropped-Custom-Screen-Printing-logo-400x250.png\";s:5:\"width\";i:400;s:6:\"height\";i:250;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-portfolio-image\";a:4:{s:4:\"file\";s:47:\"cropped-Custom-Screen-Printing-logo-400x284.png\";s:5:\"width\";i:400;s:6:\"height\";i:284;s:9:\"mime-type\";s:9:\"image/png\";}s:28:\"et-pb-portfolio-module-image\";a:4:{s:4:\"file\";s:47:\"cropped-Custom-Screen-Printing-logo-510x382.png\";s:5:\"width\";i:510;s:6:\"height\";i:382;s:9:\"mime-type\";s:9:\"image/png\";}s:35:\"et-pb-gallery-module-image-portrait\";a:4:{s:4:\"file\";s:47:\"cropped-Custom-Screen-Printing-logo-400x512.png\";s:5:\"width\";i:400;s:6:\"height\";i:512;s:9:\"mime-type\";s:9:\"image/png\";}s:30:\"et-pb-image--responsive--phone\";a:4:{s:4:\"file\";s:47:\"cropped-Custom-Screen-Printing-logo-480x480.png\";s:5:\"width\";i:480;s:6:\"height\";i:480;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-270\";a:4:{s:4:\"file\";s:47:\"cropped-Custom-Screen-Printing-logo-270x270.png\";s:5:\"width\";i:270;s:6:\"height\";i:270;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-192\";a:4:{s:4:\"file\";s:47:\"cropped-Custom-Screen-Printing-logo-192x192.png\";s:5:\"width\";i:192;s:6:\"height\";i:192;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-180\";a:4:{s:4:\"file\";s:47:\"cropped-Custom-Screen-Printing-logo-180x180.png\";s:5:\"width\";i:180;s:6:\"height\";i:180;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"site_icon-32\";a:4:{s:4:\"file\";s:45:\"cropped-Custom-Screen-Printing-logo-32x32.png\";s:5:\"width\";i:32;s:6:\"height\";i:32;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("1556", "1160", "_wp_attached_file", "2020/03/cropped-massage-therapy-icon-02.png");
INSERT INTO `wp_postmeta` VALUES("1557", "1160", "_wp_attachment_context", "site-icon");
INSERT INTO `wp_postmeta` VALUES("1558", "1160", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:512;s:6:\"height\";i:512;s:4:\"file\";s:43:\"2020/03/cropped-massage-therapy-icon-02.png\";s:5:\"sizes\";a:11:{s:6:\"medium\";a:4:{s:4:\"file\";s:43:\"cropped-massage-therapy-icon-02-300x300.png\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:9:\"image/png\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:43:\"cropped-massage-therapy-icon-02-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-post-main-image\";a:4:{s:4:\"file\";s:43:\"cropped-massage-therapy-icon-02-400x250.png\";s:5:\"width\";i:400;s:6:\"height\";i:250;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-portfolio-image\";a:4:{s:4:\"file\";s:43:\"cropped-massage-therapy-icon-02-400x284.png\";s:5:\"width\";i:400;s:6:\"height\";i:284;s:9:\"mime-type\";s:9:\"image/png\";}s:28:\"et-pb-portfolio-module-image\";a:4:{s:4:\"file\";s:43:\"cropped-massage-therapy-icon-02-510x382.png\";s:5:\"width\";i:510;s:6:\"height\";i:382;s:9:\"mime-type\";s:9:\"image/png\";}s:35:\"et-pb-gallery-module-image-portrait\";a:4:{s:4:\"file\";s:43:\"cropped-massage-therapy-icon-02-400x512.png\";s:5:\"width\";i:400;s:6:\"height\";i:512;s:9:\"mime-type\";s:9:\"image/png\";}s:30:\"et-pb-image--responsive--phone\";a:4:{s:4:\"file\";s:43:\"cropped-massage-therapy-icon-02-480x480.png\";s:5:\"width\";i:480;s:6:\"height\";i:480;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-270\";a:4:{s:4:\"file\";s:43:\"cropped-massage-therapy-icon-02-270x270.png\";s:5:\"width\";i:270;s:6:\"height\";i:270;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-192\";a:4:{s:4:\"file\";s:43:\"cropped-massage-therapy-icon-02-192x192.png\";s:5:\"width\";i:192;s:6:\"height\";i:192;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-180\";a:4:{s:4:\"file\";s:43:\"cropped-massage-therapy-icon-02-180x180.png\";s:5:\"width\";i:180;s:6:\"height\";i:180;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"site_icon-32\";a:4:{s:4:\"file\";s:41:\"cropped-massage-therapy-icon-02-32x32.png\";s:5:\"width\";i:32;s:6:\"height\";i:32;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("1690", "1285", "_wp_attached_file", "2020/03/cropped-hvac-logo.png");
INSERT INTO `wp_postmeta` VALUES("1691", "1285", "_wp_attachment_context", "site-icon");
INSERT INTO `wp_postmeta` VALUES("1692", "1285", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:512;s:6:\"height\";i:512;s:4:\"file\";s:29:\"2020/03/cropped-hvac-logo.png\";s:5:\"sizes\";a:11:{s:6:\"medium\";a:4:{s:4:\"file\";s:29:\"cropped-hvac-logo-300x300.png\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:9:\"image/png\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:29:\"cropped-hvac-logo-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-post-main-image\";a:4:{s:4:\"file\";s:29:\"cropped-hvac-logo-400x250.png\";s:5:\"width\";i:400;s:6:\"height\";i:250;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-portfolio-image\";a:4:{s:4:\"file\";s:29:\"cropped-hvac-logo-400x284.png\";s:5:\"width\";i:400;s:6:\"height\";i:284;s:9:\"mime-type\";s:9:\"image/png\";}s:28:\"et-pb-portfolio-module-image\";a:4:{s:4:\"file\";s:29:\"cropped-hvac-logo-510x382.png\";s:5:\"width\";i:510;s:6:\"height\";i:382;s:9:\"mime-type\";s:9:\"image/png\";}s:35:\"et-pb-gallery-module-image-portrait\";a:4:{s:4:\"file\";s:29:\"cropped-hvac-logo-400x512.png\";s:5:\"width\";i:400;s:6:\"height\";i:512;s:9:\"mime-type\";s:9:\"image/png\";}s:30:\"et-pb-image--responsive--phone\";a:4:{s:4:\"file\";s:29:\"cropped-hvac-logo-480x480.png\";s:5:\"width\";i:480;s:6:\"height\";i:480;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-270\";a:4:{s:4:\"file\";s:29:\"cropped-hvac-logo-270x270.png\";s:5:\"width\";i:270;s:6:\"height\";i:270;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-192\";a:4:{s:4:\"file\";s:29:\"cropped-hvac-logo-192x192.png\";s:5:\"width\";i:192;s:6:\"height\";i:192;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-180\";a:4:{s:4:\"file\";s:29:\"cropped-hvac-logo-180x180.png\";s:5:\"width\";i:180;s:6:\"height\";i:180;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"site_icon-32\";a:4:{s:4:\"file\";s:27:\"cropped-hvac-logo-32x32.png\";s:5:\"width\";i:32;s:6:\"height\";i:32;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("1827", "1475", "_wp_attached_file", "2020/03/cropped-Psychology-logo.png");
INSERT INTO `wp_postmeta` VALUES("1828", "1475", "_wp_attachment_context", "site-icon");
INSERT INTO `wp_postmeta` VALUES("1829", "1475", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:512;s:6:\"height\";i:512;s:4:\"file\";s:35:\"2020/03/cropped-Psychology-logo.png\";s:5:\"sizes\";a:11:{s:6:\"medium\";a:4:{s:4:\"file\";s:35:\"cropped-Psychology-logo-300x300.png\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:9:\"image/png\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:35:\"cropped-Psychology-logo-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-post-main-image\";a:4:{s:4:\"file\";s:35:\"cropped-Psychology-logo-400x250.png\";s:5:\"width\";i:400;s:6:\"height\";i:250;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-portfolio-image\";a:4:{s:4:\"file\";s:35:\"cropped-Psychology-logo-400x284.png\";s:5:\"width\";i:400;s:6:\"height\";i:284;s:9:\"mime-type\";s:9:\"image/png\";}s:28:\"et-pb-portfolio-module-image\";a:4:{s:4:\"file\";s:35:\"cropped-Psychology-logo-510x382.png\";s:5:\"width\";i:510;s:6:\"height\";i:382;s:9:\"mime-type\";s:9:\"image/png\";}s:35:\"et-pb-gallery-module-image-portrait\";a:4:{s:4:\"file\";s:35:\"cropped-Psychology-logo-400x512.png\";s:5:\"width\";i:400;s:6:\"height\";i:512;s:9:\"mime-type\";s:9:\"image/png\";}s:30:\"et-pb-image--responsive--phone\";a:4:{s:4:\"file\";s:35:\"cropped-Psychology-logo-480x480.png\";s:5:\"width\";i:480;s:6:\"height\";i:480;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-270\";a:4:{s:4:\"file\";s:35:\"cropped-Psychology-logo-270x270.png\";s:5:\"width\";i:270;s:6:\"height\";i:270;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-192\";a:4:{s:4:\"file\";s:35:\"cropped-Psychology-logo-192x192.png\";s:5:\"width\";i:192;s:6:\"height\";i:192;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-180\";a:4:{s:4:\"file\";s:35:\"cropped-Psychology-logo-180x180.png\";s:5:\"width\";i:180;s:6:\"height\";i:180;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"site_icon-32\";a:4:{s:4:\"file\";s:33:\"cropped-Psychology-logo-32x32.png\";s:5:\"width\";i:32;s:6:\"height\";i:32;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("1893", "1519", "_wp_attached_file", "2020/03/cropped-Chiropractics-logo.png");
INSERT INTO `wp_postmeta` VALUES("1894", "1519", "_wp_attachment_context", "site-icon");
INSERT INTO `wp_postmeta` VALUES("1895", "1519", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:512;s:6:\"height\";i:512;s:4:\"file\";s:38:\"2020/03/cropped-Chiropractics-logo.png\";s:5:\"sizes\";a:11:{s:6:\"medium\";a:4:{s:4:\"file\";s:38:\"cropped-Chiropractics-logo-300x300.png\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:9:\"image/png\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:38:\"cropped-Chiropractics-logo-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-post-main-image\";a:4:{s:4:\"file\";s:38:\"cropped-Chiropractics-logo-400x250.png\";s:5:\"width\";i:400;s:6:\"height\";i:250;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-portfolio-image\";a:4:{s:4:\"file\";s:38:\"cropped-Chiropractics-logo-400x284.png\";s:5:\"width\";i:400;s:6:\"height\";i:284;s:9:\"mime-type\";s:9:\"image/png\";}s:28:\"et-pb-portfolio-module-image\";a:4:{s:4:\"file\";s:38:\"cropped-Chiropractics-logo-510x382.png\";s:5:\"width\";i:510;s:6:\"height\";i:382;s:9:\"mime-type\";s:9:\"image/png\";}s:35:\"et-pb-gallery-module-image-portrait\";a:4:{s:4:\"file\";s:38:\"cropped-Chiropractics-logo-400x512.png\";s:5:\"width\";i:400;s:6:\"height\";i:512;s:9:\"mime-type\";s:9:\"image/png\";}s:30:\"et-pb-image--responsive--phone\";a:4:{s:4:\"file\";s:38:\"cropped-Chiropractics-logo-480x480.png\";s:5:\"width\";i:480;s:6:\"height\";i:480;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-270\";a:4:{s:4:\"file\";s:38:\"cropped-Chiropractics-logo-270x270.png\";s:5:\"width\";i:270;s:6:\"height\";i:270;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-192\";a:4:{s:4:\"file\";s:38:\"cropped-Chiropractics-logo-192x192.png\";s:5:\"width\";i:192;s:6:\"height\";i:192;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-180\";a:4:{s:4:\"file\";s:38:\"cropped-Chiropractics-logo-180x180.png\";s:5:\"width\";i:180;s:6:\"height\";i:180;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"site_icon-32\";a:4:{s:4:\"file\";s:36:\"cropped-Chiropractics-logo-32x32.png\";s:5:\"width\";i:32;s:6:\"height\";i:32;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("1984", "1591", "_wp_attached_file", "2020/03/cropped-Optometry-logo.png");
INSERT INTO `wp_postmeta` VALUES("1985", "1591", "_wp_attachment_context", "site-icon");
INSERT INTO `wp_postmeta` VALUES("1986", "1591", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:512;s:6:\"height\";i:512;s:4:\"file\";s:34:\"2020/03/cropped-Optometry-logo.png\";s:5:\"sizes\";a:11:{s:6:\"medium\";a:4:{s:4:\"file\";s:34:\"cropped-Optometry-logo-300x300.png\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:9:\"image/png\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:34:\"cropped-Optometry-logo-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-post-main-image\";a:4:{s:4:\"file\";s:34:\"cropped-Optometry-logo-400x250.png\";s:5:\"width\";i:400;s:6:\"height\";i:250;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-portfolio-image\";a:4:{s:4:\"file\";s:34:\"cropped-Optometry-logo-400x284.png\";s:5:\"width\";i:400;s:6:\"height\";i:284;s:9:\"mime-type\";s:9:\"image/png\";}s:28:\"et-pb-portfolio-module-image\";a:4:{s:4:\"file\";s:34:\"cropped-Optometry-logo-510x382.png\";s:5:\"width\";i:510;s:6:\"height\";i:382;s:9:\"mime-type\";s:9:\"image/png\";}s:35:\"et-pb-gallery-module-image-portrait\";a:4:{s:4:\"file\";s:34:\"cropped-Optometry-logo-400x512.png\";s:5:\"width\";i:400;s:6:\"height\";i:512;s:9:\"mime-type\";s:9:\"image/png\";}s:30:\"et-pb-image--responsive--phone\";a:4:{s:4:\"file\";s:34:\"cropped-Optometry-logo-480x480.png\";s:5:\"width\";i:480;s:6:\"height\";i:480;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-270\";a:4:{s:4:\"file\";s:34:\"cropped-Optometry-logo-270x270.png\";s:5:\"width\";i:270;s:6:\"height\";i:270;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-192\";a:4:{s:4:\"file\";s:34:\"cropped-Optometry-logo-192x192.png\";s:5:\"width\";i:192;s:6:\"height\";i:192;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-180\";a:4:{s:4:\"file\";s:34:\"cropped-Optometry-logo-180x180.png\";s:5:\"width\";i:180;s:6:\"height\";i:180;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"site_icon-32\";a:4:{s:4:\"file\";s:32:\"cropped-Optometry-logo-32x32.png\";s:5:\"width\";i:32;s:6:\"height\";i:32;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("1989", "1593", "_wp_attached_file", "2020/03/cropped-Optometry-logo-1.png");
INSERT INTO `wp_postmeta` VALUES("1990", "1593", "_wp_attachment_context", "site-icon");
INSERT INTO `wp_postmeta` VALUES("1991", "1593", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:512;s:6:\"height\";i:512;s:4:\"file\";s:36:\"2020/03/cropped-Optometry-logo-1.png\";s:5:\"sizes\";a:11:{s:6:\"medium\";a:4:{s:4:\"file\";s:36:\"cropped-Optometry-logo-1-300x300.png\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:9:\"image/png\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:36:\"cropped-Optometry-logo-1-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-post-main-image\";a:4:{s:4:\"file\";s:36:\"cropped-Optometry-logo-1-400x250.png\";s:5:\"width\";i:400;s:6:\"height\";i:250;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-portfolio-image\";a:4:{s:4:\"file\";s:36:\"cropped-Optometry-logo-1-400x284.png\";s:5:\"width\";i:400;s:6:\"height\";i:284;s:9:\"mime-type\";s:9:\"image/png\";}s:28:\"et-pb-portfolio-module-image\";a:4:{s:4:\"file\";s:36:\"cropped-Optometry-logo-1-510x382.png\";s:5:\"width\";i:510;s:6:\"height\";i:382;s:9:\"mime-type\";s:9:\"image/png\";}s:35:\"et-pb-gallery-module-image-portrait\";a:4:{s:4:\"file\";s:36:\"cropped-Optometry-logo-1-400x512.png\";s:5:\"width\";i:400;s:6:\"height\";i:512;s:9:\"mime-type\";s:9:\"image/png\";}s:30:\"et-pb-image--responsive--phone\";a:4:{s:4:\"file\";s:36:\"cropped-Optometry-logo-1-480x480.png\";s:5:\"width\";i:480;s:6:\"height\";i:480;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-270\";a:4:{s:4:\"file\";s:36:\"cropped-Optometry-logo-1-270x270.png\";s:5:\"width\";i:270;s:6:\"height\";i:270;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-192\";a:4:{s:4:\"file\";s:36:\"cropped-Optometry-logo-1-192x192.png\";s:5:\"width\";i:192;s:6:\"height\";i:192;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-180\";a:4:{s:4:\"file\";s:36:\"cropped-Optometry-logo-1-180x180.png\";s:5:\"width\";i:180;s:6:\"height\";i:180;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"site_icon-32\";a:4:{s:4:\"file\";s:34:\"cropped-Optometry-logo-1-32x32.png\";s:5:\"width\";i:32;s:6:\"height\";i:32;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("2127", "1730", "_wp_attached_file", "2020/03/cropped-Dental-logo.png");
INSERT INTO `wp_postmeta` VALUES("2128", "1730", "_wp_attachment_context", "site-icon");
INSERT INTO `wp_postmeta` VALUES("2129", "1730", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:512;s:6:\"height\";i:512;s:4:\"file\";s:31:\"2020/03/cropped-Dental-logo.png\";s:5:\"sizes\";a:11:{s:6:\"medium\";a:4:{s:4:\"file\";s:31:\"cropped-Dental-logo-300x300.png\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:9:\"image/png\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:31:\"cropped-Dental-logo-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-post-main-image\";a:4:{s:4:\"file\";s:31:\"cropped-Dental-logo-400x250.png\";s:5:\"width\";i:400;s:6:\"height\";i:250;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-portfolio-image\";a:4:{s:4:\"file\";s:31:\"cropped-Dental-logo-400x284.png\";s:5:\"width\";i:400;s:6:\"height\";i:284;s:9:\"mime-type\";s:9:\"image/png\";}s:28:\"et-pb-portfolio-module-image\";a:4:{s:4:\"file\";s:31:\"cropped-Dental-logo-510x382.png\";s:5:\"width\";i:510;s:6:\"height\";i:382;s:9:\"mime-type\";s:9:\"image/png\";}s:35:\"et-pb-gallery-module-image-portrait\";a:4:{s:4:\"file\";s:31:\"cropped-Dental-logo-400x512.png\";s:5:\"width\";i:400;s:6:\"height\";i:512;s:9:\"mime-type\";s:9:\"image/png\";}s:30:\"et-pb-image--responsive--phone\";a:4:{s:4:\"file\";s:31:\"cropped-Dental-logo-480x480.png\";s:5:\"width\";i:480;s:6:\"height\";i:480;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-270\";a:4:{s:4:\"file\";s:31:\"cropped-Dental-logo-270x270.png\";s:5:\"width\";i:270;s:6:\"height\";i:270;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-192\";a:4:{s:4:\"file\";s:31:\"cropped-Dental-logo-192x192.png\";s:5:\"width\";i:192;s:6:\"height\";i:192;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-180\";a:4:{s:4:\"file\";s:31:\"cropped-Dental-logo-180x180.png\";s:5:\"width\";i:180;s:6:\"height\";i:180;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"site_icon-32\";a:4:{s:4:\"file\";s:29:\"cropped-Dental-logo-32x32.png\";s:5:\"width\";i:32;s:6:\"height\";i:32;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("2331", "1928", "_wp_attached_file", "2020/03/cropped-health-icon-14-3.png");
INSERT INTO `wp_postmeta` VALUES("2332", "1928", "_wp_attachment_context", "site-icon");
INSERT INTO `wp_postmeta` VALUES("2333", "1928", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:512;s:6:\"height\";i:512;s:4:\"file\";s:36:\"2020/03/cropped-health-icon-14-3.png\";s:5:\"sizes\";a:11:{s:6:\"medium\";a:4:{s:4:\"file\";s:36:\"cropped-health-icon-14-3-300x300.png\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:9:\"image/png\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:36:\"cropped-health-icon-14-3-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-post-main-image\";a:4:{s:4:\"file\";s:36:\"cropped-health-icon-14-3-400x250.png\";s:5:\"width\";i:400;s:6:\"height\";i:250;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-portfolio-image\";a:4:{s:4:\"file\";s:36:\"cropped-health-icon-14-3-400x284.png\";s:5:\"width\";i:400;s:6:\"height\";i:284;s:9:\"mime-type\";s:9:\"image/png\";}s:28:\"et-pb-portfolio-module-image\";a:4:{s:4:\"file\";s:36:\"cropped-health-icon-14-3-510x382.png\";s:5:\"width\";i:510;s:6:\"height\";i:382;s:9:\"mime-type\";s:9:\"image/png\";}s:35:\"et-pb-gallery-module-image-portrait\";a:4:{s:4:\"file\";s:36:\"cropped-health-icon-14-3-400x512.png\";s:5:\"width\";i:400;s:6:\"height\";i:512;s:9:\"mime-type\";s:9:\"image/png\";}s:30:\"et-pb-image--responsive--phone\";a:4:{s:4:\"file\";s:36:\"cropped-health-icon-14-3-480x480.png\";s:5:\"width\";i:480;s:6:\"height\";i:480;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-270\";a:4:{s:4:\"file\";s:36:\"cropped-health-icon-14-3-270x270.png\";s:5:\"width\";i:270;s:6:\"height\";i:270;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-192\";a:4:{s:4:\"file\";s:36:\"cropped-health-icon-14-3-192x192.png\";s:5:\"width\";i:192;s:6:\"height\";i:192;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-180\";a:4:{s:4:\"file\";s:36:\"cropped-health-icon-14-3-180x180.png\";s:5:\"width\";i:180;s:6:\"height\";i:180;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"site_icon-32\";a:4:{s:4:\"file\";s:34:\"cropped-health-icon-14-3-32x32.png\";s:5:\"width\";i:32;s:6:\"height\";i:32;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("2454", "2006", "_wp_attached_file", "2020/03/cropped-green-energy-icon-18-2.png");
INSERT INTO `wp_postmeta` VALUES("2455", "2006", "_wp_attachment_context", "site-icon");
INSERT INTO `wp_postmeta` VALUES("2456", "2006", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:512;s:6:\"height\";i:512;s:4:\"file\";s:42:\"2020/03/cropped-green-energy-icon-18-2.png\";s:5:\"sizes\";a:11:{s:6:\"medium\";a:4:{s:4:\"file\";s:42:\"cropped-green-energy-icon-18-2-300x300.png\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:9:\"image/png\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:42:\"cropped-green-energy-icon-18-2-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-post-main-image\";a:4:{s:4:\"file\";s:42:\"cropped-green-energy-icon-18-2-400x250.png\";s:5:\"width\";i:400;s:6:\"height\";i:250;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-portfolio-image\";a:4:{s:4:\"file\";s:42:\"cropped-green-energy-icon-18-2-400x284.png\";s:5:\"width\";i:400;s:6:\"height\";i:284;s:9:\"mime-type\";s:9:\"image/png\";}s:28:\"et-pb-portfolio-module-image\";a:4:{s:4:\"file\";s:42:\"cropped-green-energy-icon-18-2-510x382.png\";s:5:\"width\";i:510;s:6:\"height\";i:382;s:9:\"mime-type\";s:9:\"image/png\";}s:35:\"et-pb-gallery-module-image-portrait\";a:4:{s:4:\"file\";s:42:\"cropped-green-energy-icon-18-2-400x512.png\";s:5:\"width\";i:400;s:6:\"height\";i:512;s:9:\"mime-type\";s:9:\"image/png\";}s:30:\"et-pb-image--responsive--phone\";a:4:{s:4:\"file\";s:42:\"cropped-green-energy-icon-18-2-480x480.png\";s:5:\"width\";i:480;s:6:\"height\";i:480;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-270\";a:4:{s:4:\"file\";s:42:\"cropped-green-energy-icon-18-2-270x270.png\";s:5:\"width\";i:270;s:6:\"height\";i:270;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-192\";a:4:{s:4:\"file\";s:42:\"cropped-green-energy-icon-18-2-192x192.png\";s:5:\"width\";i:192;s:6:\"height\";i:192;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-180\";a:4:{s:4:\"file\";s:42:\"cropped-green-energy-icon-18-2-180x180.png\";s:5:\"width\";i:180;s:6:\"height\";i:180;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"site_icon-32\";a:4:{s:4:\"file\";s:40:\"cropped-green-energy-icon-18-2-32x32.png\";s:5:\"width\";i:32;s:6:\"height\";i:32;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("2619", "2154", "_wp_attached_file", "2020/03/cropped-Icon_13.png");
INSERT INTO `wp_postmeta` VALUES("2620", "2154", "_wp_attachment_context", "site-icon");
INSERT INTO `wp_postmeta` VALUES("2621", "2154", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:512;s:6:\"height\";i:512;s:4:\"file\";s:27:\"2020/03/cropped-Icon_13.png\";s:5:\"sizes\";a:11:{s:6:\"medium\";a:4:{s:4:\"file\";s:27:\"cropped-Icon_13-300x300.png\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:9:\"image/png\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:27:\"cropped-Icon_13-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-post-main-image\";a:4:{s:4:\"file\";s:27:\"cropped-Icon_13-400x250.png\";s:5:\"width\";i:400;s:6:\"height\";i:250;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-portfolio-image\";a:4:{s:4:\"file\";s:27:\"cropped-Icon_13-400x284.png\";s:5:\"width\";i:400;s:6:\"height\";i:284;s:9:\"mime-type\";s:9:\"image/png\";}s:28:\"et-pb-portfolio-module-image\";a:4:{s:4:\"file\";s:27:\"cropped-Icon_13-510x382.png\";s:5:\"width\";i:510;s:6:\"height\";i:382;s:9:\"mime-type\";s:9:\"image/png\";}s:35:\"et-pb-gallery-module-image-portrait\";a:4:{s:4:\"file\";s:27:\"cropped-Icon_13-400x512.png\";s:5:\"width\";i:400;s:6:\"height\";i:512;s:9:\"mime-type\";s:9:\"image/png\";}s:30:\"et-pb-image--responsive--phone\";a:4:{s:4:\"file\";s:27:\"cropped-Icon_13-480x480.png\";s:5:\"width\";i:480;s:6:\"height\";i:480;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-270\";a:4:{s:4:\"file\";s:27:\"cropped-Icon_13-270x270.png\";s:5:\"width\";i:270;s:6:\"height\";i:270;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-192\";a:4:{s:4:\"file\";s:27:\"cropped-Icon_13-192x192.png\";s:5:\"width\";i:192;s:6:\"height\";i:192;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-180\";a:4:{s:4:\"file\";s:27:\"cropped-Icon_13-180x180.png\";s:5:\"width\";i:180;s:6:\"height\";i:180;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"site_icon-32\";a:4:{s:4:\"file\";s:25:\"cropped-Icon_13-32x32.png\";s:5:\"width\";i:32;s:6:\"height\";i:32;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("2768", "2272", "_wp_attached_file", "2020/03/cropped-Mechanic-logo2.png");
INSERT INTO `wp_postmeta` VALUES("2769", "2272", "_wp_attachment_context", "site-icon");
INSERT INTO `wp_postmeta` VALUES("2770", "2272", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:512;s:6:\"height\";i:512;s:4:\"file\";s:34:\"2020/03/cropped-Mechanic-logo2.png\";s:5:\"sizes\";a:11:{s:6:\"medium\";a:4:{s:4:\"file\";s:34:\"cropped-Mechanic-logo2-300x300.png\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:9:\"image/png\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:34:\"cropped-Mechanic-logo2-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-post-main-image\";a:4:{s:4:\"file\";s:34:\"cropped-Mechanic-logo2-400x250.png\";s:5:\"width\";i:400;s:6:\"height\";i:250;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-portfolio-image\";a:4:{s:4:\"file\";s:34:\"cropped-Mechanic-logo2-400x284.png\";s:5:\"width\";i:400;s:6:\"height\";i:284;s:9:\"mime-type\";s:9:\"image/png\";}s:28:\"et-pb-portfolio-module-image\";a:4:{s:4:\"file\";s:34:\"cropped-Mechanic-logo2-510x382.png\";s:5:\"width\";i:510;s:6:\"height\";i:382;s:9:\"mime-type\";s:9:\"image/png\";}s:35:\"et-pb-gallery-module-image-portrait\";a:4:{s:4:\"file\";s:34:\"cropped-Mechanic-logo2-400x512.png\";s:5:\"width\";i:400;s:6:\"height\";i:512;s:9:\"mime-type\";s:9:\"image/png\";}s:30:\"et-pb-image--responsive--phone\";a:4:{s:4:\"file\";s:34:\"cropped-Mechanic-logo2-480x480.png\";s:5:\"width\";i:480;s:6:\"height\";i:480;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-270\";a:4:{s:4:\"file\";s:34:\"cropped-Mechanic-logo2-270x270.png\";s:5:\"width\";i:270;s:6:\"height\";i:270;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-192\";a:4:{s:4:\"file\";s:34:\"cropped-Mechanic-logo2-192x192.png\";s:5:\"width\";i:192;s:6:\"height\";i:192;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-180\";a:4:{s:4:\"file\";s:34:\"cropped-Mechanic-logo2-180x180.png\";s:5:\"width\";i:180;s:6:\"height\";i:180;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"site_icon-32\";a:4:{s:4:\"file\";s:32:\"cropped-Mechanic-logo2-32x32.png\";s:5:\"width\";i:32;s:6:\"height\";i:32;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("2930", "2392", "_edit_lock", "1585836190:1");
INSERT INTO `wp_postmeta` VALUES("2931", "2392", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("2932", "2392", "_et_monarch_override", "");
INSERT INTO `wp_postmeta` VALUES("2933", "2392", "_et_pb_post_hide_nav", "default");
INSERT INTO `wp_postmeta` VALUES("2934", "2392", "_et_pb_page_layout", "et_left_sidebar");
INSERT INTO `wp_postmeta` VALUES("2935", "2392", "_et_pb_side_nav", "off");
INSERT INTO `wp_postmeta` VALUES("2936", "2392", "_et_pb_use_builder", "on");
INSERT INTO `wp_postmeta` VALUES("2937", "2392", "_et_gb_content_width", "");
INSERT INTO `wp_postmeta` VALUES("2946", "2392", "_et_pb_built_for_post_type", "page");
INSERT INTO `wp_postmeta` VALUES("2947", "2392", "_et_pb_ab_subjects", "");
INSERT INTO `wp_postmeta` VALUES("2948", "2392", "_et_pb_enable_shortcode_tracking", "");
INSERT INTO `wp_postmeta` VALUES("2949", "2392", "_et_pb_ab_current_shortcode", "[et_pb_split_track id=\"2392\" /]");
INSERT INTO `wp_postmeta` VALUES("2950", "2392", "_et_pb_custom_css", "");
INSERT INTO `wp_postmeta` VALUES("2951", "2392", "_et_pb_gutter_width", "3");
INSERT INTO `wp_postmeta` VALUES("2952", "2392", "_thumbnail_id", "");
INSERT INTO `wp_postmeta` VALUES("2953", "2392", "_et_pb_first_image", "");
INSERT INTO `wp_postmeta` VALUES("2954", "2392", "_et_pb_truncate_post", "");
INSERT INTO `wp_postmeta` VALUES("2955", "2392", "_et_pb_truncate_post_date", "");
INSERT INTO `wp_postmeta` VALUES("2956", "2392", "_et_builder_version", "VB|Divi|4.4.2");
INSERT INTO `wp_postmeta` VALUES("2957", "2392", "_et_pb_show_page_creation", "off");
INSERT INTO `wp_postmeta` VALUES("2998", "2447", "_wp_attached_file", "2020/03/cropped-Jaa-individua.png");
INSERT INTO `wp_postmeta` VALUES("2999", "2447", "_wp_attachment_context", "site-icon");
INSERT INTO `wp_postmeta` VALUES("3000", "2447", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:512;s:6:\"height\";i:512;s:4:\"file\";s:33:\"2020/03/cropped-Jaa-individua.png\";s:5:\"sizes\";a:11:{s:6:\"medium\";a:4:{s:4:\"file\";s:33:\"cropped-Jaa-individua-300x300.png\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:9:\"image/png\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:33:\"cropped-Jaa-individua-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-post-main-image\";a:4:{s:4:\"file\";s:33:\"cropped-Jaa-individua-400x250.png\";s:5:\"width\";i:400;s:6:\"height\";i:250;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-portfolio-image\";a:4:{s:4:\"file\";s:33:\"cropped-Jaa-individua-400x284.png\";s:5:\"width\";i:400;s:6:\"height\";i:284;s:9:\"mime-type\";s:9:\"image/png\";}s:28:\"et-pb-portfolio-module-image\";a:4:{s:4:\"file\";s:33:\"cropped-Jaa-individua-510x382.png\";s:5:\"width\";i:510;s:6:\"height\";i:382;s:9:\"mime-type\";s:9:\"image/png\";}s:35:\"et-pb-gallery-module-image-portrait\";a:4:{s:4:\"file\";s:33:\"cropped-Jaa-individua-400x512.png\";s:5:\"width\";i:400;s:6:\"height\";i:512;s:9:\"mime-type\";s:9:\"image/png\";}s:30:\"et-pb-image--responsive--phone\";a:4:{s:4:\"file\";s:33:\"cropped-Jaa-individua-480x480.png\";s:5:\"width\";i:480;s:6:\"height\";i:480;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-270\";a:4:{s:4:\"file\";s:33:\"cropped-Jaa-individua-270x270.png\";s:5:\"width\";i:270;s:6:\"height\";i:270;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-192\";a:4:{s:4:\"file\";s:33:\"cropped-Jaa-individua-192x192.png\";s:5:\"width\";i:192;s:6:\"height\";i:192;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-180\";a:4:{s:4:\"file\";s:33:\"cropped-Jaa-individua-180x180.png\";s:5:\"width\";i:180;s:6:\"height\";i:180;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"site_icon-32\";a:4:{s:4:\"file\";s:31:\"cropped-Jaa-individua-32x32.png\";s:5:\"width\";i:32;s:6:\"height\";i:32;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("3003", "2449", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("3004", "2449", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("3005", "2449", "_menu_item_object_id", "2392");
INSERT INTO `wp_postmeta` VALUES("3006", "2449", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("3007", "2449", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("3008", "2449", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("3009", "2449", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("3010", "2449", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("3021", "2449", "menu-icons", "a:8:{s:4:\"type\";s:9:\"dashicons\";s:4:\"icon\";s:21:\"dashicons-star-filled\";s:10:\"hide_label\";s:0:\"\";s:8:\"position\";s:6:\"before\";s:14:\"vertical_align\";s:6:\"middle\";s:9:\"font_size\";s:3:\"1.2\";s:9:\"svg_width\";s:1:\"1\";s:10:\"image_size\";s:9:\"thumbnail\";}");
INSERT INTO `wp_postmeta` VALUES("3123", "2392", "_wp_page_template", "default");
INSERT INTO `wp_postmeta` VALUES("3159", "2577", "_wp_attached_file", "2020/03/cropped-farmer-icon-23.png");
INSERT INTO `wp_postmeta` VALUES("3160", "2577", "_wp_attachment_context", "site-icon");
INSERT INTO `wp_postmeta` VALUES("3161", "2577", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:512;s:6:\"height\";i:512;s:4:\"file\";s:34:\"2020/03/cropped-farmer-icon-23.png\";s:5:\"sizes\";a:11:{s:6:\"medium\";a:4:{s:4:\"file\";s:34:\"cropped-farmer-icon-23-300x300.png\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:9:\"image/png\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:34:\"cropped-farmer-icon-23-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-post-main-image\";a:4:{s:4:\"file\";s:34:\"cropped-farmer-icon-23-400x250.png\";s:5:\"width\";i:400;s:6:\"height\";i:250;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-portfolio-image\";a:4:{s:4:\"file\";s:34:\"cropped-farmer-icon-23-400x284.png\";s:5:\"width\";i:400;s:6:\"height\";i:284;s:9:\"mime-type\";s:9:\"image/png\";}s:28:\"et-pb-portfolio-module-image\";a:4:{s:4:\"file\";s:34:\"cropped-farmer-icon-23-510x382.png\";s:5:\"width\";i:510;s:6:\"height\";i:382;s:9:\"mime-type\";s:9:\"image/png\";}s:35:\"et-pb-gallery-module-image-portrait\";a:4:{s:4:\"file\";s:34:\"cropped-farmer-icon-23-400x512.png\";s:5:\"width\";i:400;s:6:\"height\";i:512;s:9:\"mime-type\";s:9:\"image/png\";}s:30:\"et-pb-image--responsive--phone\";a:4:{s:4:\"file\";s:34:\"cropped-farmer-icon-23-480x480.png\";s:5:\"width\";i:480;s:6:\"height\";i:480;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-270\";a:4:{s:4:\"file\";s:34:\"cropped-farmer-icon-23-270x270.png\";s:5:\"width\";i:270;s:6:\"height\";i:270;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-192\";a:4:{s:4:\"file\";s:34:\"cropped-farmer-icon-23-192x192.png\";s:5:\"width\";i:192;s:6:\"height\";i:192;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-180\";a:4:{s:4:\"file\";s:34:\"cropped-farmer-icon-23-180x180.png\";s:5:\"width\";i:180;s:6:\"height\";i:180;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"site_icon-32\";a:4:{s:4:\"file\";s:32:\"cropped-farmer-icon-23-32x32.png\";s:5:\"width\";i:32;s:6:\"height\";i:32;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("3162", "2578", "_wp_attached_file", "2020/03/cropped-farmer-icon-23-3.png");
INSERT INTO `wp_postmeta` VALUES("3163", "2578", "_wp_attachment_context", "site-icon");
INSERT INTO `wp_postmeta` VALUES("3164", "2578", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:512;s:6:\"height\";i:512;s:4:\"file\";s:36:\"2020/03/cropped-farmer-icon-23-3.png\";s:5:\"sizes\";a:11:{s:6:\"medium\";a:4:{s:4:\"file\";s:36:\"cropped-farmer-icon-23-3-300x300.png\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:9:\"image/png\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:36:\"cropped-farmer-icon-23-3-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-post-main-image\";a:4:{s:4:\"file\";s:36:\"cropped-farmer-icon-23-3-400x250.png\";s:5:\"width\";i:400;s:6:\"height\";i:250;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-portfolio-image\";a:4:{s:4:\"file\";s:36:\"cropped-farmer-icon-23-3-400x284.png\";s:5:\"width\";i:400;s:6:\"height\";i:284;s:9:\"mime-type\";s:9:\"image/png\";}s:28:\"et-pb-portfolio-module-image\";a:4:{s:4:\"file\";s:36:\"cropped-farmer-icon-23-3-510x382.png\";s:5:\"width\";i:510;s:6:\"height\";i:382;s:9:\"mime-type\";s:9:\"image/png\";}s:35:\"et-pb-gallery-module-image-portrait\";a:4:{s:4:\"file\";s:36:\"cropped-farmer-icon-23-3-400x512.png\";s:5:\"width\";i:400;s:6:\"height\";i:512;s:9:\"mime-type\";s:9:\"image/png\";}s:30:\"et-pb-image--responsive--phone\";a:4:{s:4:\"file\";s:36:\"cropped-farmer-icon-23-3-480x480.png\";s:5:\"width\";i:480;s:6:\"height\";i:480;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-270\";a:4:{s:4:\"file\";s:36:\"cropped-farmer-icon-23-3-270x270.png\";s:5:\"width\";i:270;s:6:\"height\";i:270;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-192\";a:4:{s:4:\"file\";s:36:\"cropped-farmer-icon-23-3-192x192.png\";s:5:\"width\";i:192;s:6:\"height\";i:192;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-180\";a:4:{s:4:\"file\";s:36:\"cropped-farmer-icon-23-3-180x180.png\";s:5:\"width\";i:180;s:6:\"height\";i:180;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"site_icon-32\";a:4:{s:4:\"file\";s:34:\"cropped-farmer-icon-23-3-32x32.png\";s:5:\"width\";i:32;s:6:\"height\";i:32;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("3165", "2579", "_wp_attached_file", "2020/03/cropped-farmer-icon-23-1.png");
INSERT INTO `wp_postmeta` VALUES("3166", "2579", "_wp_attachment_context", "site-icon");
INSERT INTO `wp_postmeta` VALUES("3167", "2579", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:512;s:6:\"height\";i:512;s:4:\"file\";s:36:\"2020/03/cropped-farmer-icon-23-1.png\";s:5:\"sizes\";a:11:{s:6:\"medium\";a:4:{s:4:\"file\";s:36:\"cropped-farmer-icon-23-1-300x300.png\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:9:\"image/png\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:36:\"cropped-farmer-icon-23-1-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-post-main-image\";a:4:{s:4:\"file\";s:36:\"cropped-farmer-icon-23-1-400x250.png\";s:5:\"width\";i:400;s:6:\"height\";i:250;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-portfolio-image\";a:4:{s:4:\"file\";s:36:\"cropped-farmer-icon-23-1-400x284.png\";s:5:\"width\";i:400;s:6:\"height\";i:284;s:9:\"mime-type\";s:9:\"image/png\";}s:28:\"et-pb-portfolio-module-image\";a:4:{s:4:\"file\";s:36:\"cropped-farmer-icon-23-1-510x382.png\";s:5:\"width\";i:510;s:6:\"height\";i:382;s:9:\"mime-type\";s:9:\"image/png\";}s:35:\"et-pb-gallery-module-image-portrait\";a:4:{s:4:\"file\";s:36:\"cropped-farmer-icon-23-1-400x512.png\";s:5:\"width\";i:400;s:6:\"height\";i:512;s:9:\"mime-type\";s:9:\"image/png\";}s:30:\"et-pb-image--responsive--phone\";a:4:{s:4:\"file\";s:36:\"cropped-farmer-icon-23-1-480x480.png\";s:5:\"width\";i:480;s:6:\"height\";i:480;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-270\";a:4:{s:4:\"file\";s:36:\"cropped-farmer-icon-23-1-270x270.png\";s:5:\"width\";i:270;s:6:\"height\";i:270;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-192\";a:4:{s:4:\"file\";s:36:\"cropped-farmer-icon-23-1-192x192.png\";s:5:\"width\";i:192;s:6:\"height\";i:192;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-180\";a:4:{s:4:\"file\";s:36:\"cropped-farmer-icon-23-1-180x180.png\";s:5:\"width\";i:180;s:6:\"height\";i:180;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"site_icon-32\";a:4:{s:4:\"file\";s:34:\"cropped-farmer-icon-23-1-32x32.png\";s:5:\"width\";i:32;s:6:\"height\";i:32;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("3251", "2691", "_wp_attached_file", "2020/03/cropped-painting_illustration_04.png");
INSERT INTO `wp_postmeta` VALUES("3252", "2691", "_wp_attachment_context", "site-icon");
INSERT INTO `wp_postmeta` VALUES("3253", "2691", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:512;s:6:\"height\";i:512;s:4:\"file\";s:44:\"2020/03/cropped-painting_illustration_04.png\";s:5:\"sizes\";a:11:{s:6:\"medium\";a:4:{s:4:\"file\";s:44:\"cropped-painting_illustration_04-300x300.png\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:9:\"image/png\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:44:\"cropped-painting_illustration_04-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-post-main-image\";a:4:{s:4:\"file\";s:44:\"cropped-painting_illustration_04-400x250.png\";s:5:\"width\";i:400;s:6:\"height\";i:250;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-portfolio-image\";a:4:{s:4:\"file\";s:44:\"cropped-painting_illustration_04-400x284.png\";s:5:\"width\";i:400;s:6:\"height\";i:284;s:9:\"mime-type\";s:9:\"image/png\";}s:28:\"et-pb-portfolio-module-image\";a:4:{s:4:\"file\";s:44:\"cropped-painting_illustration_04-510x382.png\";s:5:\"width\";i:510;s:6:\"height\";i:382;s:9:\"mime-type\";s:9:\"image/png\";}s:35:\"et-pb-gallery-module-image-portrait\";a:4:{s:4:\"file\";s:44:\"cropped-painting_illustration_04-400x512.png\";s:5:\"width\";i:400;s:6:\"height\";i:512;s:9:\"mime-type\";s:9:\"image/png\";}s:30:\"et-pb-image--responsive--phone\";a:4:{s:4:\"file\";s:44:\"cropped-painting_illustration_04-480x480.png\";s:5:\"width\";i:480;s:6:\"height\";i:480;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-270\";a:4:{s:4:\"file\";s:44:\"cropped-painting_illustration_04-270x270.png\";s:5:\"width\";i:270;s:6:\"height\";i:270;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-192\";a:4:{s:4:\"file\";s:44:\"cropped-painting_illustration_04-192x192.png\";s:5:\"width\";i:192;s:6:\"height\";i:192;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-180\";a:4:{s:4:\"file\";s:44:\"cropped-painting_illustration_04-180x180.png\";s:5:\"width\";i:180;s:6:\"height\";i:180;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"site_icon-32\";a:4:{s:4:\"file\";s:42:\"cropped-painting_illustration_04-32x32.png\";s:5:\"width\";i:32;s:6:\"height\";i:32;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("3282", "267", "_et_pb_color_palette", "#af8447|#dadada|#ff5f24|#680000|#edf000|#35d764|#004fe8|#946ef4");
INSERT INTO `wp_postmeta` VALUES("3288", "2759", "_wp_trash_meta_status", "publish");
INSERT INTO `wp_postmeta` VALUES("3289", "2759", "_wp_trash_meta_time", "1585586450");
INSERT INTO `wp_postmeta` VALUES("3334", "2787", "_edit_lock", "1585642018:1");
INSERT INTO `wp_postmeta` VALUES("3335", "2787", "_wp_trash_meta_status", "publish");
INSERT INTO `wp_postmeta` VALUES("3336", "2787", "_wp_trash_meta_time", "1585642021");
INSERT INTO `wp_postmeta` VALUES("3377", "2818", "_wp_attached_file", "2020/03/cropped-tailor-icon-10.png");
INSERT INTO `wp_postmeta` VALUES("3378", "2818", "_wp_attachment_context", "site-icon");
INSERT INTO `wp_postmeta` VALUES("3379", "2818", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:512;s:6:\"height\";i:512;s:4:\"file\";s:34:\"2020/03/cropped-tailor-icon-10.png\";s:5:\"sizes\";a:11:{s:6:\"medium\";a:4:{s:4:\"file\";s:34:\"cropped-tailor-icon-10-300x300.png\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:9:\"image/png\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:34:\"cropped-tailor-icon-10-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-post-main-image\";a:4:{s:4:\"file\";s:34:\"cropped-tailor-icon-10-400x250.png\";s:5:\"width\";i:400;s:6:\"height\";i:250;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-portfolio-image\";a:4:{s:4:\"file\";s:34:\"cropped-tailor-icon-10-400x284.png\";s:5:\"width\";i:400;s:6:\"height\";i:284;s:9:\"mime-type\";s:9:\"image/png\";}s:28:\"et-pb-portfolio-module-image\";a:4:{s:4:\"file\";s:34:\"cropped-tailor-icon-10-510x382.png\";s:5:\"width\";i:510;s:6:\"height\";i:382;s:9:\"mime-type\";s:9:\"image/png\";}s:35:\"et-pb-gallery-module-image-portrait\";a:4:{s:4:\"file\";s:34:\"cropped-tailor-icon-10-400x512.png\";s:5:\"width\";i:400;s:6:\"height\";i:512;s:9:\"mime-type\";s:9:\"image/png\";}s:30:\"et-pb-image--responsive--phone\";a:4:{s:4:\"file\";s:34:\"cropped-tailor-icon-10-480x480.png\";s:5:\"width\";i:480;s:6:\"height\";i:480;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-270\";a:4:{s:4:\"file\";s:34:\"cropped-tailor-icon-10-270x270.png\";s:5:\"width\";i:270;s:6:\"height\";i:270;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-192\";a:4:{s:4:\"file\";s:34:\"cropped-tailor-icon-10-192x192.png\";s:5:\"width\";i:192;s:6:\"height\";i:192;s:9:\"mime-type\";s:9:\"image/png\";}s:13:\"site_icon-180\";a:4:{s:4:\"file\";s:34:\"cropped-tailor-icon-10-180x180.png\";s:5:\"width\";i:180;s:6:\"height\";i:180;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"site_icon-32\";a:4:{s:4:\"file\";s:32:\"cropped-tailor-icon-10-32x32.png\";s:5:\"width\";i:32;s:6:\"height\";i:32;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("3380", "2819", "_wp_trash_meta_status", "publish");
INSERT INTO `wp_postmeta` VALUES("3381", "2819", "_wp_trash_meta_time", "1585649376");
INSERT INTO `wp_postmeta` VALUES("3386", "2862", "_wp_trash_meta_status", "publish");
INSERT INTO `wp_postmeta` VALUES("3387", "2862", "_wp_trash_meta_time", "1585653955");
INSERT INTO `wp_postmeta` VALUES("3416", "2896", "_wp_trash_meta_status", "publish");
INSERT INTO `wp_postmeta` VALUES("3417", "2896", "_wp_trash_meta_time", "1585661472");
INSERT INTO `wp_postmeta` VALUES("3418", "2900", "_wp_attached_file", "2020/04/isp-05.png");
INSERT INTO `wp_postmeta` VALUES("3419", "2900", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:2560;s:6:\"height\";i:1948;s:4:\"file\";s:18:\"2020/04/isp-05.png\";s:5:\"sizes\";a:16:{s:6:\"medium\";a:4:{s:4:\"file\";s:18:\"isp-05-300x228.png\";s:5:\"width\";i:300;s:6:\"height\";i:228;s:9:\"mime-type\";s:9:\"image/png\";}s:5:\"large\";a:4:{s:4:\"file\";s:19:\"isp-05-1024x779.png\";s:5:\"width\";i:1024;s:6:\"height\";i:779;s:9:\"mime-type\";s:9:\"image/png\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:18:\"isp-05-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:18:\"isp-05-768x584.png\";s:5:\"width\";i:768;s:6:\"height\";i:584;s:9:\"mime-type\";s:9:\"image/png\";}s:9:\"1536x1536\";a:4:{s:4:\"file\";s:20:\"isp-05-1536x1169.png\";s:5:\"width\";i:1536;s:6:\"height\";i:1169;s:9:\"mime-type\";s:9:\"image/png\";}s:9:\"2048x2048\";a:4:{s:4:\"file\";s:20:\"isp-05-2048x1558.png\";s:5:\"width\";i:2048;s:6:\"height\";i:1558;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-post-main-image\";a:4:{s:4:\"file\";s:18:\"isp-05-400x250.png\";s:5:\"width\";i:400;s:6:\"height\";i:250;s:9:\"mime-type\";s:9:\"image/png\";}s:31:\"et-pb-post-main-image-fullwidth\";a:4:{s:4:\"file\";s:19:\"isp-05-1080x675.png\";s:5:\"width\";i:1080;s:6:\"height\";i:675;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-portfolio-image\";a:4:{s:4:\"file\";s:18:\"isp-05-400x284.png\";s:5:\"width\";i:400;s:6:\"height\";i:284;s:9:\"mime-type\";s:9:\"image/png\";}s:28:\"et-pb-portfolio-module-image\";a:4:{s:4:\"file\";s:18:\"isp-05-510x382.png\";s:5:\"width\";i:510;s:6:\"height\";i:382;s:9:\"mime-type\";s:9:\"image/png\";}s:28:\"et-pb-portfolio-image-single\";a:4:{s:4:\"file\";s:19:\"isp-05-1080x822.png\";s:5:\"width\";i:1080;s:6:\"height\";i:822;s:9:\"mime-type\";s:9:\"image/png\";}s:35:\"et-pb-gallery-module-image-portrait\";a:4:{s:4:\"file\";s:18:\"isp-05-400x516.png\";s:5:\"width\";i:400;s:6:\"height\";i:516;s:9:\"mime-type\";s:9:\"image/png\";}s:37:\"et-pb-post-main-image-fullwidth-large\";a:4:{s:4:\"file\";s:20:\"isp-05-2560x1800.png\";s:5:\"width\";i:2560;s:6:\"height\";i:1800;s:9:\"mime-type\";s:9:\"image/png\";}s:32:\"et-pb-image--responsive--desktop\";a:4:{s:4:\"file\";s:19:\"isp-05-1280x974.png\";s:5:\"width\";i:1280;s:6:\"height\";i:974;s:9:\"mime-type\";s:9:\"image/png\";}s:31:\"et-pb-image--responsive--tablet\";a:4:{s:4:\"file\";s:18:\"isp-05-980x746.png\";s:5:\"width\";i:980;s:6:\"height\";i:746;s:9:\"mime-type\";s:9:\"image/png\";}s:30:\"et-pb-image--responsive--phone\";a:4:{s:4:\"file\";s:18:\"isp-05-480x365.png\";s:5:\"width\";i:480;s:6:\"height\";i:365;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("3420", "2901", "_wp_attached_file", "2020/04/isp-03.png");
INSERT INTO `wp_postmeta` VALUES("3421", "2901", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:800;s:6:\"height\";i:800;s:4:\"file\";s:18:\"2020/04/isp-03.png\";s:5:\"sizes\";a:9:{s:6:\"medium\";a:4:{s:4:\"file\";s:18:\"isp-03-300x300.png\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:9:\"image/png\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:18:\"isp-03-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:18:\"isp-03-768x768.png\";s:5:\"width\";i:768;s:6:\"height\";i:768;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-post-main-image\";a:4:{s:4:\"file\";s:18:\"isp-03-400x250.png\";s:5:\"width\";i:400;s:6:\"height\";i:250;s:9:\"mime-type\";s:9:\"image/png\";}s:31:\"et-pb-post-main-image-fullwidth\";a:4:{s:4:\"file\";s:18:\"isp-03-800x675.png\";s:5:\"width\";i:800;s:6:\"height\";i:675;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-portfolio-image\";a:4:{s:4:\"file\";s:18:\"isp-03-400x284.png\";s:5:\"width\";i:400;s:6:\"height\";i:284;s:9:\"mime-type\";s:9:\"image/png\";}s:28:\"et-pb-portfolio-module-image\";a:4:{s:4:\"file\";s:18:\"isp-03-510x382.png\";s:5:\"width\";i:510;s:6:\"height\";i:382;s:9:\"mime-type\";s:9:\"image/png\";}s:35:\"et-pb-gallery-module-image-portrait\";a:4:{s:4:\"file\";s:18:\"isp-03-400x516.png\";s:5:\"width\";i:400;s:6:\"height\";i:516;s:9:\"mime-type\";s:9:\"image/png\";}s:30:\"et-pb-image--responsive--phone\";a:4:{s:4:\"file\";s:18:\"isp-03-480x480.png\";s:5:\"width\";i:480;s:6:\"height\";i:480;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("3422", "2902", "_wp_attached_file", "2020/04/isp-04.png");
INSERT INTO `wp_postmeta` VALUES("3423", "2902", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:800;s:6:\"height\";i:800;s:4:\"file\";s:18:\"2020/04/isp-04.png\";s:5:\"sizes\";a:9:{s:6:\"medium\";a:4:{s:4:\"file\";s:18:\"isp-04-300x300.png\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:9:\"image/png\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:18:\"isp-04-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:18:\"isp-04-768x768.png\";s:5:\"width\";i:768;s:6:\"height\";i:768;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-post-main-image\";a:4:{s:4:\"file\";s:18:\"isp-04-400x250.png\";s:5:\"width\";i:400;s:6:\"height\";i:250;s:9:\"mime-type\";s:9:\"image/png\";}s:31:\"et-pb-post-main-image-fullwidth\";a:4:{s:4:\"file\";s:18:\"isp-04-800x675.png\";s:5:\"width\";i:800;s:6:\"height\";i:675;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-portfolio-image\";a:4:{s:4:\"file\";s:18:\"isp-04-400x284.png\";s:5:\"width\";i:400;s:6:\"height\";i:284;s:9:\"mime-type\";s:9:\"image/png\";}s:28:\"et-pb-portfolio-module-image\";a:4:{s:4:\"file\";s:18:\"isp-04-510x382.png\";s:5:\"width\";i:510;s:6:\"height\";i:382;s:9:\"mime-type\";s:9:\"image/png\";}s:35:\"et-pb-gallery-module-image-portrait\";a:4:{s:4:\"file\";s:18:\"isp-04-400x516.png\";s:5:\"width\";i:400;s:6:\"height\";i:516;s:9:\"mime-type\";s:9:\"image/png\";}s:30:\"et-pb-image--responsive--phone\";a:4:{s:4:\"file\";s:18:\"isp-04-480x480.png\";s:5:\"width\";i:480;s:6:\"height\";i:480;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("3424", "2903", "_wp_attached_file", "2020/04/isp-08.png");
INSERT INTO `wp_postmeta` VALUES("3425", "2903", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1920;s:6:\"height\";i:2726;s:4:\"file\";s:18:\"2020/04/isp-08.png\";s:5:\"sizes\";a:16:{s:6:\"medium\";a:4:{s:4:\"file\";s:18:\"isp-08-211x300.png\";s:5:\"width\";i:211;s:6:\"height\";i:300;s:9:\"mime-type\";s:9:\"image/png\";}s:5:\"large\";a:4:{s:4:\"file\";s:19:\"isp-08-721x1024.png\";s:5:\"width\";i:721;s:6:\"height\";i:1024;s:9:\"mime-type\";s:9:\"image/png\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:18:\"isp-08-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:19:\"isp-08-768x1090.png\";s:5:\"width\";i:768;s:6:\"height\";i:1090;s:9:\"mime-type\";s:9:\"image/png\";}s:9:\"1536x1536\";a:4:{s:4:\"file\";s:20:\"isp-08-1082x1536.png\";s:5:\"width\";i:1082;s:6:\"height\";i:1536;s:9:\"mime-type\";s:9:\"image/png\";}s:9:\"2048x2048\";a:4:{s:4:\"file\";s:20:\"isp-08-1442x2048.png\";s:5:\"width\";i:1442;s:6:\"height\";i:2048;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-post-main-image\";a:4:{s:4:\"file\";s:18:\"isp-08-400x250.png\";s:5:\"width\";i:400;s:6:\"height\";i:250;s:9:\"mime-type\";s:9:\"image/png\";}s:31:\"et-pb-post-main-image-fullwidth\";a:4:{s:4:\"file\";s:19:\"isp-08-1080x675.png\";s:5:\"width\";i:1080;s:6:\"height\";i:675;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-portfolio-image\";a:4:{s:4:\"file\";s:18:\"isp-08-400x284.png\";s:5:\"width\";i:400;s:6:\"height\";i:284;s:9:\"mime-type\";s:9:\"image/png\";}s:28:\"et-pb-portfolio-module-image\";a:4:{s:4:\"file\";s:18:\"isp-08-510x382.png\";s:5:\"width\";i:510;s:6:\"height\";i:382;s:9:\"mime-type\";s:9:\"image/png\";}s:28:\"et-pb-portfolio-image-single\";a:4:{s:4:\"file\";s:20:\"isp-08-1080x1533.png\";s:5:\"width\";i:1080;s:6:\"height\";i:1533;s:9:\"mime-type\";s:9:\"image/png\";}s:35:\"et-pb-gallery-module-image-portrait\";a:4:{s:4:\"file\";s:18:\"isp-08-400x516.png\";s:5:\"width\";i:400;s:6:\"height\";i:516;s:9:\"mime-type\";s:9:\"image/png\";}s:37:\"et-pb-post-main-image-fullwidth-large\";a:4:{s:4:\"file\";s:20:\"isp-08-1920x1800.png\";s:5:\"width\";i:1920;s:6:\"height\";i:1800;s:9:\"mime-type\";s:9:\"image/png\";}s:32:\"et-pb-image--responsive--desktop\";a:4:{s:4:\"file\";s:20:\"isp-08-1280x1817.png\";s:5:\"width\";i:1280;s:6:\"height\";i:1817;s:9:\"mime-type\";s:9:\"image/png\";}s:31:\"et-pb-image--responsive--tablet\";a:4:{s:4:\"file\";s:19:\"isp-08-980x1391.png\";s:5:\"width\";i:980;s:6:\"height\";i:1391;s:9:\"mime-type\";s:9:\"image/png\";}s:30:\"et-pb-image--responsive--phone\";a:4:{s:4:\"file\";s:18:\"isp-08-480x682.png\";s:5:\"width\";i:480;s:6:\"height\";i:682;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("3426", "2904", "_wp_attached_file", "2020/04/isp-01.png");
INSERT INTO `wp_postmeta` VALUES("3427", "2904", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:800;s:6:\"height\";i:655;s:4:\"file\";s:18:\"2020/04/isp-01.png\";s:5:\"sizes\";a:8:{s:6:\"medium\";a:4:{s:4:\"file\";s:18:\"isp-01-300x246.png\";s:5:\"width\";i:300;s:6:\"height\";i:246;s:9:\"mime-type\";s:9:\"image/png\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:18:\"isp-01-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:18:\"isp-01-768x629.png\";s:5:\"width\";i:768;s:6:\"height\";i:629;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-post-main-image\";a:4:{s:4:\"file\";s:18:\"isp-01-400x250.png\";s:5:\"width\";i:400;s:6:\"height\";i:250;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-portfolio-image\";a:4:{s:4:\"file\";s:18:\"isp-01-400x284.png\";s:5:\"width\";i:400;s:6:\"height\";i:284;s:9:\"mime-type\";s:9:\"image/png\";}s:28:\"et-pb-portfolio-module-image\";a:4:{s:4:\"file\";s:18:\"isp-01-510x382.png\";s:5:\"width\";i:510;s:6:\"height\";i:382;s:9:\"mime-type\";s:9:\"image/png\";}s:35:\"et-pb-gallery-module-image-portrait\";a:4:{s:4:\"file\";s:18:\"isp-01-400x516.png\";s:5:\"width\";i:400;s:6:\"height\";i:516;s:9:\"mime-type\";s:9:\"image/png\";}s:30:\"et-pb-image--responsive--phone\";a:4:{s:4:\"file\";s:18:\"isp-01-480x393.png\";s:5:\"width\";i:480;s:6:\"height\";i:393;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("3428", "2905", "_wp_attached_file", "2020/04/isp-02.jpg");
INSERT INTO `wp_postmeta` VALUES("3429", "2905", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:800;s:6:\"height\";i:553;s:4:\"file\";s:18:\"2020/04/isp-02.jpg\";s:5:\"sizes\";a:8:{s:6:\"medium\";a:4:{s:4:\"file\";s:18:\"isp-02-300x207.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:207;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:18:\"isp-02-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:18:\"isp-02-768x531.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:531;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:21:\"et-pb-post-main-image\";a:4:{s:4:\"file\";s:18:\"isp-02-400x250.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:21:\"et-pb-portfolio-image\";a:4:{s:4:\"file\";s:18:\"isp-02-400x284.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:284;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:28:\"et-pb-portfolio-module-image\";a:4:{s:4:\"file\";s:18:\"isp-02-510x382.jpg\";s:5:\"width\";i:510;s:6:\"height\";i:382;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:35:\"et-pb-gallery-module-image-portrait\";a:4:{s:4:\"file\";s:18:\"isp-02-400x516.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:516;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:30:\"et-pb-image--responsive--phone\";a:4:{s:4:\"file\";s:18:\"isp-02-480x332.jpg\";s:5:\"width\";i:480;s:6:\"height\";i:332;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("3430", "2906", "_wp_attached_file", "2020/04/handyman_11.png");
INSERT INTO `wp_postmeta` VALUES("3431", "2906", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:474;s:6:\"height\";i:422;s:4:\"file\";s:23:\"2020/04/handyman_11.png\";s:5:\"sizes\";a:6:{s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"handyman_11-300x267.png\";s:5:\"width\";i:300;s:6:\"height\";i:267;s:9:\"mime-type\";s:9:\"image/png\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"handyman_11-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-post-main-image\";a:4:{s:4:\"file\";s:23:\"handyman_11-400x250.png\";s:5:\"width\";i:400;s:6:\"height\";i:250;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-portfolio-image\";a:4:{s:4:\"file\";s:23:\"handyman_11-400x284.png\";s:5:\"width\";i:400;s:6:\"height\";i:284;s:9:\"mime-type\";s:9:\"image/png\";}s:28:\"et-pb-portfolio-module-image\";a:4:{s:4:\"file\";s:23:\"handyman_11-474x382.png\";s:5:\"width\";i:474;s:6:\"height\";i:382;s:9:\"mime-type\";s:9:\"image/png\";}s:35:\"et-pb-gallery-module-image-portrait\";a:4:{s:4:\"file\";s:23:\"handyman_11-400x422.png\";s:5:\"width\";i:400;s:6:\"height\";i:422;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("3432", "2910", "_wp_attached_file", "2020/04/isp-11.png");
INSERT INTO `wp_postmeta` VALUES("3433", "2910", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1080;s:6:\"height\";i:884;s:4:\"file\";s:18:\"2020/04/isp-11.png\";s:5:\"sizes\";a:11:{s:6:\"medium\";a:4:{s:4:\"file\";s:18:\"isp-11-300x246.png\";s:5:\"width\";i:300;s:6:\"height\";i:246;s:9:\"mime-type\";s:9:\"image/png\";}s:5:\"large\";a:4:{s:4:\"file\";s:19:\"isp-11-1024x838.png\";s:5:\"width\";i:1024;s:6:\"height\";i:838;s:9:\"mime-type\";s:9:\"image/png\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:18:\"isp-11-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:18:\"isp-11-768x629.png\";s:5:\"width\";i:768;s:6:\"height\";i:629;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-post-main-image\";a:4:{s:4:\"file\";s:18:\"isp-11-400x250.png\";s:5:\"width\";i:400;s:6:\"height\";i:250;s:9:\"mime-type\";s:9:\"image/png\";}s:31:\"et-pb-post-main-image-fullwidth\";a:4:{s:4:\"file\";s:19:\"isp-11-1080x675.png\";s:5:\"width\";i:1080;s:6:\"height\";i:675;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-portfolio-image\";a:4:{s:4:\"file\";s:18:\"isp-11-400x284.png\";s:5:\"width\";i:400;s:6:\"height\";i:284;s:9:\"mime-type\";s:9:\"image/png\";}s:28:\"et-pb-portfolio-module-image\";a:4:{s:4:\"file\";s:18:\"isp-11-510x382.png\";s:5:\"width\";i:510;s:6:\"height\";i:382;s:9:\"mime-type\";s:9:\"image/png\";}s:35:\"et-pb-gallery-module-image-portrait\";a:4:{s:4:\"file\";s:18:\"isp-11-400x516.png\";s:5:\"width\";i:400;s:6:\"height\";i:516;s:9:\"mime-type\";s:9:\"image/png\";}s:31:\"et-pb-image--responsive--tablet\";a:4:{s:4:\"file\";s:18:\"isp-11-980x802.png\";s:5:\"width\";i:980;s:6:\"height\";i:802;s:9:\"mime-type\";s:9:\"image/png\";}s:30:\"et-pb-image--responsive--phone\";a:4:{s:4:\"file\";s:18:\"isp-11-480x393.png\";s:5:\"width\";i:480;s:6:\"height\";i:393;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("3434", "2913", "_wp_attached_file", "2020/04/isp-10.png");
INSERT INTO `wp_postmeta` VALUES("3435", "2913", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:2560;s:6:\"height\";i:1948;s:4:\"file\";s:18:\"2020/04/isp-10.png\";s:5:\"sizes\";a:16:{s:6:\"medium\";a:4:{s:4:\"file\";s:18:\"isp-10-300x228.png\";s:5:\"width\";i:300;s:6:\"height\";i:228;s:9:\"mime-type\";s:9:\"image/png\";}s:5:\"large\";a:4:{s:4:\"file\";s:19:\"isp-10-1024x779.png\";s:5:\"width\";i:1024;s:6:\"height\";i:779;s:9:\"mime-type\";s:9:\"image/png\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:18:\"isp-10-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:18:\"isp-10-768x584.png\";s:5:\"width\";i:768;s:6:\"height\";i:584;s:9:\"mime-type\";s:9:\"image/png\";}s:9:\"1536x1536\";a:4:{s:4:\"file\";s:20:\"isp-10-1536x1169.png\";s:5:\"width\";i:1536;s:6:\"height\";i:1169;s:9:\"mime-type\";s:9:\"image/png\";}s:9:\"2048x2048\";a:4:{s:4:\"file\";s:20:\"isp-10-2048x1558.png\";s:5:\"width\";i:2048;s:6:\"height\";i:1558;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-post-main-image\";a:4:{s:4:\"file\";s:18:\"isp-10-400x250.png\";s:5:\"width\";i:400;s:6:\"height\";i:250;s:9:\"mime-type\";s:9:\"image/png\";}s:31:\"et-pb-post-main-image-fullwidth\";a:4:{s:4:\"file\";s:19:\"isp-10-1080x675.png\";s:5:\"width\";i:1080;s:6:\"height\";i:675;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-portfolio-image\";a:4:{s:4:\"file\";s:18:\"isp-10-400x284.png\";s:5:\"width\";i:400;s:6:\"height\";i:284;s:9:\"mime-type\";s:9:\"image/png\";}s:28:\"et-pb-portfolio-module-image\";a:4:{s:4:\"file\";s:18:\"isp-10-510x382.png\";s:5:\"width\";i:510;s:6:\"height\";i:382;s:9:\"mime-type\";s:9:\"image/png\";}s:28:\"et-pb-portfolio-image-single\";a:4:{s:4:\"file\";s:19:\"isp-10-1080x822.png\";s:5:\"width\";i:1080;s:6:\"height\";i:822;s:9:\"mime-type\";s:9:\"image/png\";}s:35:\"et-pb-gallery-module-image-portrait\";a:4:{s:4:\"file\";s:18:\"isp-10-400x516.png\";s:5:\"width\";i:400;s:6:\"height\";i:516;s:9:\"mime-type\";s:9:\"image/png\";}s:37:\"et-pb-post-main-image-fullwidth-large\";a:4:{s:4:\"file\";s:20:\"isp-10-2560x1800.png\";s:5:\"width\";i:2560;s:6:\"height\";i:1800;s:9:\"mime-type\";s:9:\"image/png\";}s:32:\"et-pb-image--responsive--desktop\";a:4:{s:4:\"file\";s:19:\"isp-10-1280x974.png\";s:5:\"width\";i:1280;s:6:\"height\";i:974;s:9:\"mime-type\";s:9:\"image/png\";}s:31:\"et-pb-image--responsive--tablet\";a:4:{s:4:\"file\";s:18:\"isp-10-980x746.png\";s:5:\"width\";i:980;s:6:\"height\";i:746;s:9:\"mime-type\";s:9:\"image/png\";}s:30:\"et-pb-image--responsive--phone\";a:4:{s:4:\"file\";s:18:\"isp-10-480x365.png\";s:5:\"width\";i:480;s:6:\"height\";i:365;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("3436", "2914", "_wp_attached_file", "2020/04/isp-08.jpg");
INSERT INTO `wp_postmeta` VALUES("3437", "2914", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1920;s:6:\"height\";i:1275;s:4:\"file\";s:18:\"2020/04/isp-08.jpg\";s:5:\"sizes\";a:14:{s:6:\"medium\";a:4:{s:4:\"file\";s:18:\"isp-08-300x199.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:199;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:19:\"isp-08-1024x680.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:680;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:18:\"isp-08-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:18:\"isp-08-768x510.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:510;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"1536x1536\";a:4:{s:4:\"file\";s:20:\"isp-08-1536x1020.jpg\";s:5:\"width\";i:1536;s:6:\"height\";i:1020;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:21:\"et-pb-post-main-image\";a:4:{s:4:\"file\";s:18:\"isp-08-400x250.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:31:\"et-pb-post-main-image-fullwidth\";a:4:{s:4:\"file\";s:19:\"isp-08-1080x675.jpg\";s:5:\"width\";i:1080;s:6:\"height\";i:675;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:21:\"et-pb-portfolio-image\";a:4:{s:4:\"file\";s:18:\"isp-08-400x284.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:284;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:28:\"et-pb-portfolio-module-image\";a:4:{s:4:\"file\";s:18:\"isp-08-510x382.jpg\";s:5:\"width\";i:510;s:6:\"height\";i:382;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:28:\"et-pb-portfolio-image-single\";a:4:{s:4:\"file\";s:19:\"isp-08-1080x717.jpg\";s:5:\"width\";i:1080;s:6:\"height\";i:717;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:35:\"et-pb-gallery-module-image-portrait\";a:4:{s:4:\"file\";s:18:\"isp-08-400x516.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:516;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:32:\"et-pb-image--responsive--desktop\";a:4:{s:4:\"file\";s:19:\"isp-08-1280x850.jpg\";s:5:\"width\";i:1280;s:6:\"height\";i:850;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:31:\"et-pb-image--responsive--tablet\";a:4:{s:4:\"file\";s:18:\"isp-08-980x651.jpg\";s:5:\"width\";i:980;s:6:\"height\";i:651;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:30:\"et-pb-image--responsive--phone\";a:4:{s:4:\"file\";s:18:\"isp-08-480x319.jpg\";s:5:\"width\";i:480;s:6:\"height\";i:319;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("3438", "2917", "_wp_attached_file", "2020/04/tech-01.jpg");
INSERT INTO `wp_postmeta` VALUES("3439", "2917", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1280;s:6:\"height\";i:960;s:4:\"file\";s:19:\"2020/04/tech-01.jpg\";s:5:\"sizes\";a:12:{s:6:\"medium\";a:4:{s:4:\"file\";s:19:\"tech-01-300x225.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:225;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:20:\"tech-01-1024x768.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:768;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:19:\"tech-01-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:19:\"tech-01-768x576.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:576;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:21:\"et-pb-post-main-image\";a:4:{s:4:\"file\";s:19:\"tech-01-400x250.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:31:\"et-pb-post-main-image-fullwidth\";a:4:{s:4:\"file\";s:20:\"tech-01-1080x675.jpg\";s:5:\"width\";i:1080;s:6:\"height\";i:675;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:21:\"et-pb-portfolio-image\";a:4:{s:4:\"file\";s:19:\"tech-01-400x284.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:284;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:28:\"et-pb-portfolio-module-image\";a:4:{s:4:\"file\";s:19:\"tech-01-510x382.jpg\";s:5:\"width\";i:510;s:6:\"height\";i:382;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:28:\"et-pb-portfolio-image-single\";a:4:{s:4:\"file\";s:20:\"tech-01-1080x810.jpg\";s:5:\"width\";i:1080;s:6:\"height\";i:810;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:35:\"et-pb-gallery-module-image-portrait\";a:4:{s:4:\"file\";s:19:\"tech-01-400x516.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:516;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:31:\"et-pb-image--responsive--tablet\";a:4:{s:4:\"file\";s:19:\"tech-01-980x735.jpg\";s:5:\"width\";i:980;s:6:\"height\";i:735;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:30:\"et-pb-image--responsive--phone\";a:4:{s:4:\"file\";s:19:\"tech-01-480x360.jpg\";s:5:\"width\";i:480;s:6:\"height\";i:360;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("3440", "2918", "_wp_attached_file", "2020/04/tech-04.jpg");
INSERT INTO `wp_postmeta` VALUES("3441", "2918", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1280;s:6:\"height\";i:960;s:4:\"file\";s:19:\"2020/04/tech-04.jpg\";s:5:\"sizes\";a:12:{s:6:\"medium\";a:4:{s:4:\"file\";s:19:\"tech-04-300x225.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:225;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:20:\"tech-04-1024x768.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:768;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:19:\"tech-04-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:19:\"tech-04-768x576.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:576;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:21:\"et-pb-post-main-image\";a:4:{s:4:\"file\";s:19:\"tech-04-400x250.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:31:\"et-pb-post-main-image-fullwidth\";a:4:{s:4:\"file\";s:20:\"tech-04-1080x675.jpg\";s:5:\"width\";i:1080;s:6:\"height\";i:675;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:21:\"et-pb-portfolio-image\";a:4:{s:4:\"file\";s:19:\"tech-04-400x284.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:284;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:28:\"et-pb-portfolio-module-image\";a:4:{s:4:\"file\";s:19:\"tech-04-510x382.jpg\";s:5:\"width\";i:510;s:6:\"height\";i:382;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:28:\"et-pb-portfolio-image-single\";a:4:{s:4:\"file\";s:20:\"tech-04-1080x810.jpg\";s:5:\"width\";i:1080;s:6:\"height\";i:810;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:35:\"et-pb-gallery-module-image-portrait\";a:4:{s:4:\"file\";s:19:\"tech-04-400x516.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:516;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:31:\"et-pb-image--responsive--tablet\";a:4:{s:4:\"file\";s:19:\"tech-04-980x735.jpg\";s:5:\"width\";i:980;s:6:\"height\";i:735;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:30:\"et-pb-image--responsive--phone\";a:4:{s:4:\"file\";s:19:\"tech-04-480x360.jpg\";s:5:\"width\";i:480;s:6:\"height\";i:360;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("3442", "2919", "_wp_attached_file", "2020/04/tech-05.jpg");
INSERT INTO `wp_postmeta` VALUES("3443", "2919", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1280;s:6:\"height\";i:960;s:4:\"file\";s:19:\"2020/04/tech-05.jpg\";s:5:\"sizes\";a:12:{s:6:\"medium\";a:4:{s:4:\"file\";s:19:\"tech-05-300x225.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:225;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:20:\"tech-05-1024x768.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:768;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:19:\"tech-05-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:19:\"tech-05-768x576.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:576;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:21:\"et-pb-post-main-image\";a:4:{s:4:\"file\";s:19:\"tech-05-400x250.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:31:\"et-pb-post-main-image-fullwidth\";a:4:{s:4:\"file\";s:20:\"tech-05-1080x675.jpg\";s:5:\"width\";i:1080;s:6:\"height\";i:675;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:21:\"et-pb-portfolio-image\";a:4:{s:4:\"file\";s:19:\"tech-05-400x284.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:284;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:28:\"et-pb-portfolio-module-image\";a:4:{s:4:\"file\";s:19:\"tech-05-510x382.jpg\";s:5:\"width\";i:510;s:6:\"height\";i:382;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:28:\"et-pb-portfolio-image-single\";a:4:{s:4:\"file\";s:20:\"tech-05-1080x810.jpg\";s:5:\"width\";i:1080;s:6:\"height\";i:810;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:35:\"et-pb-gallery-module-image-portrait\";a:4:{s:4:\"file\";s:19:\"tech-05-400x516.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:516;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:31:\"et-pb-image--responsive--tablet\";a:4:{s:4:\"file\";s:19:\"tech-05-980x735.jpg\";s:5:\"width\";i:980;s:6:\"height\";i:735;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:30:\"et-pb-image--responsive--phone\";a:4:{s:4:\"file\";s:19:\"tech-05-480x360.jpg\";s:5:\"width\";i:480;s:6:\"height\";i:360;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("3444", "2920", "_wp_attached_file", "2020/04/business-03.jpg");
INSERT INTO `wp_postmeta` VALUES("3445", "2920", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1280;s:6:\"height\";i:960;s:4:\"file\";s:23:\"2020/04/business-03.jpg\";s:5:\"sizes\";a:12:{s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"business-03-300x225.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:225;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:24:\"business-03-1024x768.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:768;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"business-03-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:23:\"business-03-768x576.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:576;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:21:\"et-pb-post-main-image\";a:4:{s:4:\"file\";s:23:\"business-03-400x250.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:31:\"et-pb-post-main-image-fullwidth\";a:4:{s:4:\"file\";s:24:\"business-03-1080x675.jpg\";s:5:\"width\";i:1080;s:6:\"height\";i:675;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:21:\"et-pb-portfolio-image\";a:4:{s:4:\"file\";s:23:\"business-03-400x284.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:284;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:28:\"et-pb-portfolio-module-image\";a:4:{s:4:\"file\";s:23:\"business-03-510x382.jpg\";s:5:\"width\";i:510;s:6:\"height\";i:382;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:28:\"et-pb-portfolio-image-single\";a:4:{s:4:\"file\";s:24:\"business-03-1080x810.jpg\";s:5:\"width\";i:1080;s:6:\"height\";i:810;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:35:\"et-pb-gallery-module-image-portrait\";a:4:{s:4:\"file\";s:23:\"business-03-400x516.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:516;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:31:\"et-pb-image--responsive--tablet\";a:4:{s:4:\"file\";s:23:\"business-03-980x735.jpg\";s:5:\"width\";i:980;s:6:\"height\";i:735;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:30:\"et-pb-image--responsive--phone\";a:4:{s:4:\"file\";s:23:\"business-03-480x360.jpg\";s:5:\"width\";i:480;s:6:\"height\";i:360;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("3446", "2925", "_wp_attached_file", "2020/04/Internet-provider-logo.png");
INSERT INTO `wp_postmeta` VALUES("3447", "2925", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:156;s:6:\"height\";i:100;s:4:\"file\";s:34:\"2020/04/Internet-provider-logo.png\";s:5:\"sizes\";a:1:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:34:\"Internet-provider-logo-150x100.png\";s:5:\"width\";i:150;s:6:\"height\";i:100;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("3448", "2926", "_wp_attached_file", "2020/04/Internet-provider1.png");
INSERT INTO `wp_postmeta` VALUES("3449", "2926", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:600;s:6:\"height\";i:463;s:4:\"file\";s:30:\"2020/04/Internet-provider1.png\";s:5:\"sizes\";a:7:{s:6:\"medium\";a:4:{s:4:\"file\";s:30:\"Internet-provider1-300x232.png\";s:5:\"width\";i:300;s:6:\"height\";i:232;s:9:\"mime-type\";s:9:\"image/png\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:30:\"Internet-provider1-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-post-main-image\";a:4:{s:4:\"file\";s:30:\"Internet-provider1-400x250.png\";s:5:\"width\";i:400;s:6:\"height\";i:250;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-portfolio-image\";a:4:{s:4:\"file\";s:30:\"Internet-provider1-400x284.png\";s:5:\"width\";i:400;s:6:\"height\";i:284;s:9:\"mime-type\";s:9:\"image/png\";}s:28:\"et-pb-portfolio-module-image\";a:4:{s:4:\"file\";s:30:\"Internet-provider1-510x382.png\";s:5:\"width\";i:510;s:6:\"height\";i:382;s:9:\"mime-type\";s:9:\"image/png\";}s:35:\"et-pb-gallery-module-image-portrait\";a:4:{s:4:\"file\";s:30:\"Internet-provider1-400x463.png\";s:5:\"width\";i:400;s:6:\"height\";i:463;s:9:\"mime-type\";s:9:\"image/png\";}s:30:\"et-pb-image--responsive--phone\";a:4:{s:4:\"file\";s:30:\"Internet-provider1-480x370.png\";s:5:\"width\";i:480;s:6:\"height\";i:370;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("3450", "2927", "_wp_attached_file", "2020/04/Internet-provider2.png");
INSERT INTO `wp_postmeta` VALUES("3451", "2927", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:321;s:4:\"file\";s:30:\"2020/04/Internet-provider2.png\";s:5:\"sizes\";a:6:{s:6:\"medium\";a:4:{s:4:\"file\";s:30:\"Internet-provider2-300x193.png\";s:5:\"width\";i:300;s:6:\"height\";i:193;s:9:\"mime-type\";s:9:\"image/png\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:30:\"Internet-provider2-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-post-main-image\";a:4:{s:4:\"file\";s:30:\"Internet-provider2-400x250.png\";s:5:\"width\";i:400;s:6:\"height\";i:250;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"et-pb-portfolio-image\";a:4:{s:4:\"file\";s:30:\"Internet-provider2-400x284.png\";s:5:\"width\";i:400;s:6:\"height\";i:284;s:9:\"mime-type\";s:9:\"image/png\";}s:35:\"et-pb-gallery-module-image-portrait\";a:4:{s:4:\"file\";s:30:\"Internet-provider2-400x321.png\";s:5:\"width\";i:400;s:6:\"height\";i:321;s:9:\"mime-type\";s:9:\"image/png\";}s:30:\"et-pb-image--responsive--phone\";a:4:{s:4:\"file\";s:30:\"Internet-provider2-480x308.png\";s:5:\"width\";i:480;s:6:\"height\";i:308;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("3452", "2929", "_edit_lock", "1585816490:1");
INSERT INTO `wp_postmeta` VALUES("3453", "2929", "_wp_trash_meta_status", "publish");
INSERT INTO `wp_postmeta` VALUES("3454", "2929", "_wp_trash_meta_time", "1585816533");
INSERT INTO `wp_postmeta` VALUES("3465", "8", "_thumbnail_id", "2905");
INSERT INTO `wp_postmeta` VALUES("3470", "167", "_thumbnail_id", "2917");
INSERT INTO `wp_postmeta` VALUES("3475", "169", "_thumbnail_id", "2918");
INSERT INTO `wp_postmeta` VALUES("3480", "171", "_thumbnail_id", "2919");
INSERT INTO `wp_postmeta` VALUES("3485", "173", "_thumbnail_id", "2920");
INSERT INTO `wp_postmeta` VALUES("3490", "175", "_thumbnail_id", "2927");
INSERT INTO `wp_postmeta` VALUES("3491", "175", "_pingme", "1");
INSERT INTO `wp_postmeta` VALUES("3492", "175", "_encloseme", "1");
INSERT INTO `wp_postmeta` VALUES("3493", "2993", "_wp_trash_meta_status", "publish");
INSERT INTO `wp_postmeta` VALUES("3494", "2993", "_wp_trash_meta_time", "1585836931");
INSERT INTO `wp_postmeta` VALUES("3495", "2994", "_wp_trash_meta_status", "publish");
INSERT INTO `wp_postmeta` VALUES("3496", "2994", "_wp_trash_meta_time", "1585908626");

/* INSERT TABLE DATA: wp_posts */
INSERT INTO `wp_posts` VALUES("2", "1", "2020-03-05 13:23:00", "2020-03-05 09:53:00", "[et_pb_section fb_built=\"1\" admin_label=\"Header\" _builder_version=\"4.4.2\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-05.png\" parallax=\"on\" parallax_method=\"off\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"5vw||||false\" custom_padding=\"10vw||14vw||false\" bottom_divider_style=\"wave2\" bottom_divider_color=\"#ffffff\" bottom_divider_height=\"10vw\" bottom_divider_repeat=\"0.7x\" animation_style=\"slide\" animation_direction=\"bottom\" animation_intensity_slide=\"1%\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_phone=\"\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" animation_style=\"slide\" animation_direction=\"left\" animation_intensity_slide=\"10%\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_font=\"|900|on|on|||||\" header_font_size=\"10vw\" header_letter_spacing=\"0.1em\" header_line_height=\"1.2em\" header_2_font=\"|900|on|on|||||\" header_2_text_color=\"rgba(255,255,255,0.7)\" header_2_font_size=\"44px\" header_2_letter_spacing=\"0em\" header_2_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" header_font_size_tablet=\"50px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|phone\" header_2_font_size_tablet=\"30px\" header_2_font_size_phone=\"20px\" header_2_font_size_last_edited=\"on|phone\" header_text_shadow_style=\"preset1\" header_text_shadow_color=\"rgba(0,0,0,0.15)\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h1>نهایت سرعت</h1>\n<p>&nbsp;</p>\n<h2><span color=\"rgba(0, 0, 0, 0.701960784313725)\" style=\"color: rgba(0, 0, 0, 0.7);\">35 هزارتومان </span>اینترنت ADSL</h2>[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_font_size=\"18px\" text_line_height=\"2em\" text_orientation=\"center\" background_layout=\"dark\" max_width=\"800px\" module_alignment=\"center\" text_font_size_tablet=\"16px\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>[/et_pb_text][et_pb_button button_text=\"مشاهده تمام پلن های اینترنتی\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#0c71c3\" button_bg_enable_color__hover=\"on\" button_text_color__hover_enabled=\"on|hover\" button_text_color__hover=\"#ffffff\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Login\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(242,245,250,0)\" background_color_gradient_end=\"#f2f5fa\" background_color_gradient_direction=\"90deg\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_padding=\"0|0px|0|0px|false|false\" border_radii=\"on|60px|60px|60px|60px\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_font_size=\"20px\" link_font=\"||||||||\" link_text_color=\"#0492ff\" transform_translate_linked__hover=\"off\" text_orientation=\"center\" text_text_shadow_style=\"preset1\" text_text_shadow_color=\"#7cda24\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate__hover=\"-50px|0px\" content__hover_enabled=\"on|hover\" content__hover=\"<p><a href=%22#%22><strong>کلیک نمایید</strong></a></p>\n\"]<p>آماده اید ؟  جهت عضویت <a href=\"#\"><strong>اینجا را کلیک نمایید</strong></a></p>[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Value\" _builder_version=\"3.22\"][et_pb_row _builder_version=\"3.25\" custom_padding=\"||||false|false\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#0492ff\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>چرا انتخاب ما ؟</h2>[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" padding_top_bottom_link_1=\"false\" padding_top_bottom_link_2=\"false\" padding_top_bottom_link_3=\"false\" padding_left_right_link_1=\"true\" padding_left_right_link_2=\"true\" padding_left_right_link_3=\"true\" _builder_version=\"3.25\" max_width=\"1160px\" custom_padding=\"0|0px|27px|0px|false|false\" use_custom_width=\"on\" custom_width_px=\"1160px\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\" max_width__hover=\"1080px\" max_width__hover_enabled=\"1080px\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-03.png\" background_size=\"contain\" background_position=\"bottom_right\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"دریافت سرعت واقعی\" use_icon=\"on\" font_icon=\"%%243%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|hover\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"0deg|330deg|0deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"20 درصد تخفیف\" use_icon=\"on\" font_icon=\"%%171%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"0deg|0deg|330deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-04.png\" background_size=\"contain\" background_position=\"top_right\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"بدون محدودیت حجمی\" use_icon=\"on\" font_icon=\"%%231%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"330deg|0deg|0deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است </span></p>[/et_pb_blurb][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Features\" _builder_version=\"3.22\" background_color=\"#f2f5fa\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_padding=\"54px|0px|0|0px|false|false\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row column_structure=\"3_5,2_5\" _builder_version=\"3.25\" custom_margin=\"100px||100px||true\" custom_margin_tablet=\"40px||40px||true\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\"][et_pb_column type=\"3_5\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/04/isp-01.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"|||-7vw\" custom_margin_tablet=\"|||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\"][/et_pb_image][/et_pb_column][et_pb_column type=\"2_5\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>انتخاب شماره 1# کاربران برای اینترنت  فیبر نوری</h2>\n<h3></h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>[/et_pb_text][et_pb_blurb title=\"بدون قعطی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"2em\" custom_margin=\"||20px\"][/et_pb_blurb][et_pb_blurb title=\"سرعت تا 65 مگابایت\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"2em\" custom_margin=\"||20px\"][/et_pb_blurb][et_pb_blurb title=\"شامل مودم رایگان\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"2em\" custom_margin=\"||20px\"][/et_pb_blurb][et_pb_button button_text=\"مشاهده پلن های اینترنت\" button_alignment=\"left\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#7cda24\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" custom_margin=\"100px||100px||true\" custom_margin_tablet=\"40px||40px||true\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"14px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>داده نامحدود ،پشتیبانی شبانه روزی و سرویس پیامکی</h2>\n<h3>همه موارد را برای داشتن خطوط پیامکی موفق برای شما فراهم کرده ایم</h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد</span></p>[/et_pb_text][et_pb_button button_text=\"مشاهده پلن های پیامکی\" button_alignment=\"left\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#7cda24\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/04/isp-02.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"|-7vw||\" custom_margin_tablet=\"|0vw||\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\" border_radii=\"on|30px|30px|30px|30px\"][/et_pb_image][/et_pb_column][/et_pb_row][et_pb_row custom_padding_last_edited=\"on|tablet\" _builder_version=\"4.4.2\" background_color=\"#ffffff\" max_width=\"80%\" module_alignment=\"right\" custom_margin=\"||\" custom_padding=\"60px|60px|||false|false\" custom_padding_tablet=\"|40px||40px\" custom_padding_phone=\"\" animation_style=\"slide\" animation_direction=\"right\" animation_intensity_slide=\"10%\" border_radii=\"|30px|||\" use_custom_width=\"on\" width_unit=\"off\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>محبوب ترین خدمات</h2>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد</span></p>[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Categories\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(242,245,250,0)\" background_color_gradient_end=\"#f2f5fa\" background_color_gradient_direction=\"90deg\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||60px\" custom_margin_tablet=\"||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|desktop\" custom_padding=\"0||0px||false|false\" border_radii=\"on|60px|60px|60px|60px\" locked=\"off\"][et_pb_row column_structure=\"1_6,1_6,1_6,1_6,1_6,1_6\" use_custom_gutter=\"on\" gutter_width=\"2\" _builder_version=\"3.25\" locked=\"off\"][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#ffffff\" text_orientation=\"center\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" locked=\"off\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" box_shadow_color__hover_enabled=\"on\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\" background_layout__hover_enabled=\"on\" background_layout__hover=\"dark\"]<p>پیامک</p>[/et_pb_text][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"Poppins|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#a0cf00\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" locked=\"off\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" box_shadow_color__hover_enabled=\"on\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\"]<p>ADSL</p>[/et_pb_text][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#008a1c\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" box_shadow_color__hover_enabled=\"on\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\"]<p>وایرلس</p>[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Pricing\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||||false\" custom_padding=\"80px||80px||true\" animation_style=\"slide\" animation_direction=\"bottom\" animation_intensity_slide=\"1%\" border_radii=\"on|30px|30px|30px|30px\" locked=\"off\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\"][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"40px|||\" custom_padding_tablet=\"0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px||\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#ffffff\" price_text_color=\"rgba(0,0,0,0.75)\" body_text_color=\"#ffffff\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"||||||||\" body_text_align=\"center\" subheader_font=\"|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"||on||||||\" price_font_size=\"50px\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(255,255,255,0)\" background_color_gradient_end=\"rgba(255,255,255,0.16)\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" transform_translate_linked__hover=\"off\" animation_style=\"slide\" animation_direction=\"right\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate__hover=\"0px|-70px\"][et_pb_pricing_table title=\"اینترنت پایه\" subtitle=\"1 مگابایت\" currency=\"یک ساله \" per=\"هزارتومان\" sum=\"35\" button_url=\"#\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" header_level=\"h2\" header_font=\"||||||||\" body_font=\"VAZIR FARSI||||||||\" subheader_font=\"|800|||||||\" price_font=\"|800|on||||||\" price_letter_spacing=\"0px\" price_line_height=\"100px\" currency_frequency_font=\"|700|on||||||\" currency_frequency_line_height=\"1em\" excluded_text_color=\"rgba(255,255,255,0.5)\" custom_button=\"on\" button_font=\"VAZIR FARSI||||||||\" pricing_item_excluded_color=\"rgba(255,255,255,0.5)\"]<p>+ گارانتی سرعت</p>\n<p>+ گارنتی کیفیت</p>\n<p>+ نصب در محل</p>\n<p>- تنظیم مودم</p>\n<p>- پشتیبانی 24 ساعته</p>[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#a0cf00\" price_text_color=\"rgba(0,0,0,0.75)\" subheader_text_color=\"#000000\" header_text_color=\"#000000\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"Poppins||||||||\" body_text_align=\"center\" subheader_font=\"Poppins|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"|800|on||||||\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#ffffff\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#008a1c\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" transform_translate_linked__hover=\"off\" custom_margin=\"0px||\" animation_style=\"zoom\" animation_delay=\"100ms\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" border_color_all=\"#ffffff\" border_width_top=\"40px\" border_width_bottom=\"30px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" locked=\"off\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate__hover=\"0px|-70px\"][et_pb_pricing_table title=\"سرویس محبوب\" subtitle=\"65 مگابایت\" currency=\"سالانه\" per=\"هزارتومان\" sum=\"99\" button_url=\"#\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" header_level=\"h2\" header_font=\"||||||||\" body_font=\"VAZIR FARSI||||||||\" subheader_font=\"VAZIR FARSI|800|||||||\" price_font=\"VAZIR FARSI|800|on||||||\" price_font_size=\"50px\" price_line_height=\"100px\" custom_button=\"on\" button_font=\"VAZIR FARSI||||||||\"]<p>+ سرعت دانلود تا 65 مگابایت</p>\n<p>+ دانلود نامحدود</p>\n<p>+ پشتیبانی شبانه روزی</p>\n<p>+ مودم رایگان</p>\n<p>+ نصب رایگان</p>[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"40px|||\" custom_padding_tablet=\"0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|desktop\" padding_tablet=\"0px||\" padding_last_edited=\"on|desktop\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#ffffff\" price_text_color=\"rgba(0,0,0,0.75)\" body_text_color=\"#ffffff\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"||||||||\" body_text_align=\"center\" subheader_font=\"|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"||on||||||\" price_font_size=\"50px\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(255,255,255,0)\" background_color_gradient_end=\"rgba(255,255,255,0.16)\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" transform_translate_linked__hover=\"off\" animation_style=\"slide\" animation_direction=\"right\" price_letter_spacing_tablet=\"\" price_letter_spacing_phone=\"\" price_letter_spacing_last_edited=\"on|desktop\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" locked=\"off\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate__hover=\"0px|-70px\"][et_pb_pricing_table title=\"اینترنت حرفه ای\" subtitle=\"120 مگابایت\" currency=\"یک ساله \" per=\"هزارتومان\" sum=\"900\" button_url=\"#\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" header_level=\"h2\" header_font=\"||||||||\" body_font=\"VAZIR FARSI||||||||\" subheader_font=\"|800|||||||\" price_font=\"VAZIR FARSI||on||||||\" price_letter_spacing=\"0px\" price_line_height=\"100px\" currency_frequency_font=\"|700|on||||||\" currency_frequency_line_height=\"1em\" excluded_text_color=\"rgba(255,255,255,0.5)\" custom_button=\"on\" button_font=\"VAZIR FARSI||||||||\" pricing_item_excluded_color=\"rgba(255,255,255,0.5)\"]<p>+ گارانتی سرعت</p>\n<p>+ گارنتی کیفیت</p>\n<p>+ نصب در محل</p>\n<p>- تنظیم مودم</p>\n<p>- پشتیبانی 24 ساعته</p>[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Blog\" _builder_version=\"3.22\"][et_pb_row _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#0492ff\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>آخرین مقالات از وبلاگ ما</h2>[/et_pb_text][et_pb_blog fullwidth=\"off\" posts_number=\"3\" include_categories=\"70\" show_pagination=\"off\" _builder_version=\"4.4.2\" header_font=\"Poppins|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_line_height=\"2em\" meta_font=\"Poppins||||||||\" meta_text_color=\"#008a1c\" pagination_font=\"Poppins|700|on||||||\" pagination_text_color=\"#008a1c\" pagination_font_size=\"18px\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" show_categories=\"off\" use_overlay=\"on\" hover_icon=\"%%10%%\" hover_overlay_color=\"rgba(124,218,36,0.59)\" transform_styles__hover_enabled=\"off|hover\" transform_scale__hover_enabled=\"off|hover\" transform_translate__hover_enabled=\"off|hover\" transform_rotate__hover_enabled=\"off|hover\" transform_skew__hover_enabled=\"off|hover\" transform_origin__hover_enabled=\"off|hover\" transform_translate__hover=\"30px|30px\" animation_style=\"zoom\"][/et_pb_blog][et_pb_button button_text=\"رفتن به وبلاگ\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#7cda24\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonials\" _builder_version=\"3.22\"][et_pb_row column_structure=\"2_5,3_5\" padding_top_bottom_link_1=\"true\" padding_top_bottom_link_2=\"true\" padding_left_right_link_1=\"false\" padding_left_right_link_2=\"false\" _builder_version=\"3.25\" custom_padding=\"0||0||false|false\"][et_pb_column type=\"2_5\" _builder_version=\"3.25\" custom_padding=\"60px|60px|60px|\" custom_padding_tablet=\"0px||0px||true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px||0px||true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>مشتریان در مورد ما چه می گویند ؟</h2>\n<h3>بهترین شرکت خدمات اینترنتی از دید مشتریان در سال های اخیر</h3>[/et_pb_text][/et_pb_column][et_pb_column type=\"3_5\" _builder_version=\"3.25\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/handyman_11.png\" background_size=\"initial\" background_position=\"bottom_right\" custom_padding=\"60px|60px|60px|\" custom_padding_tablet=\"40px|40px|40px|40px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"40px|40px|40px|40px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_testimonial author=\"مشتری از سال 1390\" quote_icon=\"off\" _builder_version=\"4.4.2\" body_font=\"||on||||||\" body_font_size=\"14px\" body_line_height=\"2em\" background_color=\"#ffffff\" transform_translate_linked__hover=\"off\" custom_margin=\"|||-40px\" custom_margin_tablet=\"|||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|desktop\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0.15)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate__hover=\"-50px|0px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span>\"</p>[/et_pb_testimonial][et_pb_testimonial author=\"مشتری جدید\" quote_icon=\"off\" _builder_version=\"4.4.2\" body_font=\"||on||||||\" body_font_size=\"14px\" body_line_height=\"2em\" background_color=\"#ffffff\" transform_translate_linked__hover=\"off\" custom_margin=\"|||-40px\" custom_margin_tablet=\"|||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|desktop\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0.15)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate__hover=\"-50px|0px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span>\"</p>[/et_pb_testimonial][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" prev_background_color=\"#ffffff\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#0f1533\" background_color_gradient_end=\"#1f133a\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||5vw\" custom_padding=\"14vw||10vw\" top_divider_style=\"wave2\" top_divider_height=\"10vw\" top_divider_repeat=\"0.7x\" top_divider_flip=\"vertical\" animation_style=\"fade\" border_radii=\"on|30px|30px|30px|30px\" locked=\"off\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_phone=\"\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_2_font=\"|900|on||||||\" header_2_font_size=\"3.5vw\" header_2_letter_spacing=\"2px\" header_2_line_height=\"1.4em\" header_3_font=\"|900|on|on|||||\" header_3_text_color=\"rgba(255,255,255,0.7)\" header_3_font_size=\"1.5vw\" header_3_letter_spacing=\"0.4em\" header_3_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_font_size__hover=\"30px\" header_font_size__hover_enabled=\"30px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h2>سرعت مورد نظر خود را با قیمتی که می خواهید دریافت کنید</h2>\n<h3>سرویس های ADSL  و سرویس های پیامکی</h3>[/et_pb_text][et_pb_button button_text=\"مشاهده تمام سرویس های ما\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#7cda24\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section]", "خانه", "", "publish", "closed", "open", "", "home", "", "", "2020-04-02 13:37:54", "2020-04-02 10:07:54", "", "0", "http://modelsite.test/?page_id=2", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("3", "1", "2020-03-05 13:23:00", "2020-03-05 09:53:00", "<!-- wp:heading --><h2>ما که هستیم</h2><!-- /wp:heading --><!-- wp:paragraph --><p>نشانی وب‌سایت ما: http://modelsite.test.</p><!-- /wp:paragraph --><!-- wp:heading --><h2>کدامیک از اطلاعات شخصی را جمع آوری میکنیم و چرا</h2><!-- /wp:heading --><!-- wp:heading {\"level\":3} --><h3>دیدگاه‌ها</h3><!-- /wp:heading --><!-- wp:paragraph --><p>هنگامی که بازدیدکنندگان نظرات خود را در سایت می‌نویسند، ما اطلاعاتی را که در فرم نظرات و همچنین بازدید کننده‌ها ارائه می‌شود جمع آوری می‌کنیم &#8217;s آدرس IP و رجیستر عامل کاربر مرورگر برای کمک به تشخیص هرزنامه.</p><!-- /wp:paragraph --><!-- wp:paragraph --><p>یک رشته ناشناس ایجاد شده از آدرس ایمیل شما (همچنین هش نامیده می‌شود) ممکن است به سرویس Gravatar ارائه شود تا ببینید آیا از آن استفاده می‌کنید. سیاست حفظ حریم خصوصی خدمات Gravatar در اینجا در دسترس است: https://automattic.com/privacy/. پس از تأیید نظر شما، تصویر نمایه شما در متن نظر شما قابل مشاهده است.</p><!-- /wp:paragraph --><!-- wp:heading {\"level\":3} --><h3>رسانه</h3><!-- /wp:heading --><!-- wp:paragraph --><p>اگر تصاویر را به وبسایت آپلود کنید، نباید آپلود تصاویر با داده‌های مکان جغرافیایی (EXIF GPS) شامل شود. بازدیدکنندگان وب سایت می‌توانند هر گونه اطلاعات مکان را از تصاویر در وب سایت دانلود و استخراج کنند.</p><!-- /wp:paragraph --><!-- wp:heading {\"level\":3} --><h3>فرم‌های تماس</h3><!-- /wp:heading --><!-- wp:heading {\"level\":3} --><h3>کوکی‌ها</h3><!-- /wp:heading --><!-- wp:paragraph --><p>اگر شما نظر خود را در سایت ما ثبت کنید، ممکن است برای ذخیره نام، آدرس ایمیل و وب سایت خود در کوکی‌ها تصمیم گیری کنید. اینها برای راحتی شما هستند، به طوری که شما مجبور نیستید دوباره جزئیات خود را پر کنید زمانی که نظر دیگری را ترک کنید. این کوکی‌ها یک سال طول خواهد کشید.</p><!-- /wp:paragraph --><!-- wp:paragraph --><p>اگر از برگه ورود ما بازدید نمایید، ما یک کوکی موقت برای مشخص نمودن اینکه آیا مروگر شما کوکی قبول می‌کند را تنظیم می‌کنیم. این کوکی محتوای اطلاعات شخصی شما نیست و وقتی مرورگر شما بسته می‌شود از بین می‌رود.</p><!-- /wp:paragraph --><!-- wp:paragraph --><p>هنگام ورود به سیستم، ما همچنین کوکی‌ها را تنظیم خواهیم کرد تا اطلاعات ورود به سیستم و گزینه‌های صفحه نمایش خود را ذخیره کنید. کوکی‌های ورود به سیستم برای دو روز گذشته و کوکی‌های گزینه‌های صفحه نمایش برای یک سال گذشته است. اگر شما انتخاب کنید &quot; به یاد داشته باشید من Me&quot;، ورود شما برای دو هفته ادامه خواهد داشت. اگر از حساب خود خارج شوید، کوکی‌های ورود حذف خواهند شد.</p><!-- /wp:paragraph --><!-- wp:paragraph --><p>اگر یک مقاله را ویرایش یا منتشر کنید، یک کوکی اضافی در مرورگر شما ذخیره خواهد شد. این کوکی حاوی اطلاعات شخصی نیست و به سادگی نشان می‌دهد که شناسه پست مقاله شما فقط ویرایش شده است. بعد از یک روز منقضی می‌شود.</p><!-- /wp:paragraph --><!-- wp:heading {\"level\":3} --><h3>محتوای جاسازی‌شده از دیگر وب‌سایت‌ها</h3><!-- /wp:heading --><!-- wp:paragraph --><p>مقالات موجود در این سایت ممکن است شامل محتوای تعبیه شده (مثلا ویدئوها، تصاویر، مقالات و غیره) باشد. مطالب جاسازی شده از وب سایت‌های دیگر رفتار دقیقا همان طوری که بازدید کننده از وب سایت دیگر بازدید کرده است.</p><!-- /wp:paragraph --><!-- wp:paragraph --><p>این وبسایت‌ها ممکن است اطلاعاتی مربوط به شما را جمع‌آوری کنند، از کوکی‌ها استفاده کنند، ردیابی سوم شخص اضافه را جاسازی کنند و تعامل شما را با محتوای تعبیه شده نظارت کنند که شامل ردیابی تعامل شما با محتوای جاسازی شده است اگر حساب کاربری داشته و به آن وبسایت وارد شده باشید.</p><!-- /wp:paragraph --><!-- wp:heading {\"level\":3} --><h3>تجزیه و تحلیل</h3><!-- /wp:heading --><!-- wp:heading --><h2>اطلاعات شما را با چه کسی به اشتراک می‌گذاریم</h2><!-- /wp:heading --><!-- wp:heading --><h2>چه مدت ما اطلاعات شما را حفظ می‌کنیم</h2><!-- /wp:heading --><!-- wp:paragraph --><p>اگر یک نظر را ترک کنید، نظر و متادیتای آن به طور نامحدود حفظ می‌شوند. این به این معنا است که ما می‌توانیم به جای برگزاری آنها در یک خط مؤثر، به طور خودکار هر نظر پیگیری را تصدیق و تأیید کنیم.</p><!-- /wp:paragraph --><!-- wp:paragraph --><p>برای کاربرانی که در وب سایت ما ثبت نام می‌کنند (اگر وجود داشته باشند)، ما همچنین اطلاعات شخصی را که در مشخصات کاربر آنها ارائه می‌کنیم، ذخیره می‌کنیم. همه کاربران می‌توانند اطلاعات شخصی خود را در هر زمان (به جز آنها که نمی‌توانند نام کاربری خود را تغییر دهند) ببینند، ویرایش و یا حذف کنند. مدیران وب سایت همچنین می‌توانند این اطلاعات را مشاهده و ویرایش کنند.</p><!-- /wp:paragraph --><!-- wp:heading --><h2>حقوقی که بر روی داده‌هایتان دارید</h2><!-- /wp:heading --><!-- wp:paragraph --><p>اگر در این سایت حساب کاربری دارید یا نظرها را ترک کرده اید، می‌توانید درخواست دریافت یک فایل صادر شده از اطلاعات شخصی که ما در مورد شما نگه می‌داریم، از جمله هر گونه داده‌ای که برای ما ارائه کرده اید. همچنین می‌توانید درخواست کنید که ما هر گونه اطلاعات شخصی که در مورد شما نگه داریم پاک کنیم. این شامل اطلاعاتی نیست که ما مجبور به نگهداری آنها برای اهداف اداری، قانونی یا امنیتی باشیم.</p><!-- /wp:paragraph --><!-- wp:heading --><h2>داده‌های شما را به کجا ارسال می‌کنیم</h2><!-- /wp:heading --><!-- wp:paragraph --><p>دیدگاه‌های بازدیدکننده ممکن است از طریق یک سرویس تشخیص جفنگ خودکار بررسی شوند.</p><!-- /wp:paragraph --><!-- wp:heading --><h2>اطلاعات تماس شما</h2><!-- /wp:heading --><!-- wp:heading --><h2>اطلاعات اضافی</h2><!-- /wp:heading --><!-- wp:heading {\"level\":3} --><h3>چگونه از اطلاعات شما حفاظت می‌کنیم</h3><!-- /wp:heading --><!-- wp:heading {\"level\":3} --><h3>چه رویه‌های نقض اطلاعات در حال حاضر وجود دارد</h3><!-- /wp:heading --><!-- wp:heading {\"level\":3} --><h3>چه چیز جدیدی از داده‌ها دریافت می‌کنیم</h3><!-- /wp:heading --><!-- wp:heading {\"level\":3} --><h3>تصمیم گیری خودکار و / یا پروفایل ما با داده‌های کاربر انجام می‌شود</h3><!-- /wp:heading --><!-- wp:heading {\"level\":3} --><h3>الزامات افشای قانونی صنعت</h3><!-- /wp:heading -->", "سیاست حریم خصوصی", "", "draft", "closed", "open", "", "سیاست-حفظ-حریم-خصوصی", "", "", "2020-03-05 13:23:00", "2020-03-05 09:53:00", "", "0", "http://modelsite.test/?page_id=3", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("5", "1", "2020-03-05 13:26:42", "2020-03-05 09:56:42", "", "Divi-Child-Theme-master", "", "publish", "closed", "closed", "", "divi-child-theme-master", "", "", "2020-04-02 17:45:21", "2020-04-02 14:15:21", "", "0", "http://modelsite.test/2020/03/05/divi-child-theme-master/", "0", "custom_css", "", "0");
INSERT INTO `wp_posts` VALUES("8", "1", "2020-02-24 18:54:38", "2020-02-24 15:24:38", "<!-- wp:paragraph -->\n<p>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد. کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد. لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد. کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد. لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد. کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد.</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:paragraph -->\n<p>در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد. لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد. کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد. لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد. کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد.</p>\n<!-- /wp:paragraph -->", "تست اول عنوان مطلب وبلاگ", "", "publish", "open", "open", "", "%d8%aa%d8%b3%d8%aa-%d8%a7%d9%88%d9%84-%d8%b9%d9%86%d9%88%d8%a7%d9%86-%d9%85%d8%b7%d9%84%d8%a8-%d9%88%d8%a8%d9%84%d8%a7%da%af", "", "", "2020-04-02 13:30:21", "2020-04-02 10:00:21", "", "0", "http://veterinarian.test/?p=1", "0", "post", "", "1");
INSERT INTO `wp_posts` VALUES("167", "1", "2020-02-25 00:32:07", "2020-02-24 21:02:07", "<!-- wp:paragraph -->\n<p>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد. کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد. لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد. کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد. لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد. کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد. لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد. کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد. لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد. کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد.</p>\n<!-- /wp:paragraph -->", "تست دوم عنوان وبلاگ", "", "publish", "open", "closed", "", "%d8%aa%d8%b3%d8%aa-%d8%af%d9%88%d9%85-%d8%b9%d9%86%d9%88%d8%a7%d9%86-%d9%88%d8%a8%d9%84%d8%a7%da%af", "", "", "2020-04-02 13:30:32", "2020-04-02 10:00:32", "", "0", "http://veterinarian.test/?p=167", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("169", "1", "2020-02-25 00:32:46", "2020-02-24 21:02:46", "<!-- wp:paragraph -->\n<p>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد. کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد. لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد. کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد. لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد. کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد. لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد. کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد. لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد. کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد.</p>\n<!-- /wp:paragraph -->", "تست سوم عنوان وبلاگ", "", "publish", "open", "closed", "", "%d8%aa%d8%b3%d8%aa-%d8%b3%d9%88%d9%85-%d8%b9%d9%86%d9%88%d8%a7%d9%86-%d9%88%d8%a8%d9%84%d8%a7%da%af", "", "", "2020-04-02 13:30:40", "2020-04-02 10:00:40", "", "0", "http://veterinarian.test/?p=169", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("171", "1", "2020-02-25 00:34:01", "2020-02-24 21:04:01", "<!-- wp:paragraph -->\n<p>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد. کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد. لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد. کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد. لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد. کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد. لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد. کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد. لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد. کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد.</p>\n<!-- /wp:paragraph -->", "تست چهارم عنوان وبلاگ", "", "publish", "open", "closed", "", "%d8%aa%d8%b3%d8%aa-%da%86%d9%87%d8%a7%d8%b1%d9%85-%d8%b9%d9%86%d9%88%d8%a7%d9%86-%d9%88%d8%a8%d9%84%d8%a7%da%af", "", "", "2020-04-02 13:30:46", "2020-04-02 10:00:46", "", "0", "http://veterinarian.test/?p=171", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("173", "1", "2020-02-25 00:34:36", "2020-02-24 21:04:36", "<!-- wp:paragraph -->\n<p>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد. کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد. لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد. کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد. لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد. کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد. لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد. کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد. لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد. کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد.</p>\n<!-- /wp:paragraph -->", "تست پنجم عنوان وبلاگ", "", "publish", "open", "closed", "", "%d8%aa%d8%b3%d8%aa-%d9%be%d9%86%d8%ac%d9%85-%d8%b9%d9%86%d9%88%d8%a7%d9%86-%d9%88%d8%a8%d9%84%d8%a7%da%af", "", "", "2020-04-02 13:30:58", "2020-04-02 10:00:58", "", "0", "http://veterinarian.test/?p=173", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("175", "1", "2020-02-25 00:35:09", "2020-02-24 21:05:09", "<!-- wp:paragraph -->\n<p>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد. کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد. لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد. کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد. لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد. کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد. لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد. کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد. لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد. کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد.</p>\n<!-- /wp:paragraph -->", "تست ششم عنوان وبلاگ", "", "publish", "open", "closed", "", "%d8%aa%d8%b3%d8%aa-%d8%b4%d8%b4%d9%85-%d8%b9%d9%86%d9%88%d8%a7%d9%86-%d9%88%d8%a8%d9%84%d8%a7%da%af", "", "", "2020-04-02 13:31:25", "2020-04-02 10:01:25", "", "0", "http://veterinarian.test/?p=175", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("187", "1", "2020-03-05 13:58:09", "2020-03-05 10:28:09", "[et_pb_section fb_built=\"1\" admin_label=\"Header\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#0f1533\" background_color_gradient_end=\"#1f133a\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-10.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"5vw||||false\" custom_padding=\"14vw||18vw||false|false\" bottom_divider_style=\"wave2\" bottom_divider_color=\"#ffffff\" bottom_divider_height=\"10vw\" bottom_divider_repeat=\"0.7x\" animation_style=\"slide\" animation_direction=\"bottom\" animation_intensity_slide=\"1%\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_phone=\"\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" animation_style=\"slide\" animation_direction=\"left\" animation_intensity_slide=\"10%\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_font=\"|900|on|on|||||\" header_font_size=\"6vw\" header_letter_spacing=\"0.1em\" header_line_height=\"1.2em\" header_2_font=\"|900|on|on|||||\" header_2_text_color=\"rgba(255,255,255,0.7)\" header_2_font_size=\"3vw\" header_2_letter_spacing=\"0.1em\" header_2_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" hover_enabled=\"0\" header_font_size_tablet=\"50px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|phone\" header_2_font_size_tablet=\"30px\" header_2_font_size_phone=\"20px\" header_2_font_size_last_edited=\"on|phone\" header_text_shadow_style=\"preset1\" header_text_shadow_vertical_length=\"0.3em\" header_text_shadow_blur_strength=\"0.5em\" header_text_shadow_color=\"rgba(0,0,0,0.15)\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h1>درباره شرکت</h1>\n<p>&nbsp;</p>\n<h2>ارائه دهنده سرویس های ADSL</h2>\n[/et_pb_text][et_pb_button button_text=\"مشاهده تمام خدمات شرکت\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#0c71c3\" button_bg_enable_color__hover=\"on\" button_text_color__hover_enabled=\"on|hover\" button_text_color__hover=\"#ffffff\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" bg_img_1=\"http://modelsite.test/wp-content/uploads/2020/04/isp-03.png\" background_size_1=\"contain\" background_position_1=\"bottom_right\" background_repeat_1=\"no-repeat\" padding_top_bottom_link_1=\"false\" padding_left_right_link_1=\"true\" padding_right_1=\"40px\" padding_bottom_1=\"80px\" padding_left_1=\"40px\" admin_label=\"About\" _builder_version=\"3.22\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" background_size=\"contain\" background_position=\"bottom_right\" custom_padding=\"|||\" padding_bottom__hover=\"80px\" padding_left__hover=\"40px\" padding_right__hover=\"40px\" bg_img__hover=\"http://modelsite.test/wp-content/uploads/2020/04/isp-03.png\" parallax__hover=\"off\" parallax_method__hover=\"on\" background_size__hover=\"contain\" background_position__hover=\"bottom_right\" background_repeat__hover=\"no-repeat\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\" text_line_height__hover=\"1.7em\" text_line_height__hover_enabled=\"1.7em\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" max_width__hover=\"100%\" max_width__hover_enabled=\"100%\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" text_font_size__hover=\"14px\" text_font_size__hover_enabled=\"14px\" text_letter_spacing__hover=\"0px\" text_letter_spacing__hover_enabled=\"0px\" text_text_shadow_style__hover=\"none\" text_text_shadow_style__hover_enabled=\"none\" text_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" text_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" link_font_size__hover=\"14px\" link_font_size__hover_enabled=\"14px\" link_letter_spacing__hover=\"0px\" link_letter_spacing__hover_enabled=\"0px\" link_line_height__hover=\"1em\" link_line_height__hover_enabled=\"1em\" link_text_shadow_style__hover=\"none\" link_text_shadow_style__hover_enabled=\"none\" link_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" link_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" ul_font_size__hover=\"14px\" ul_font_size__hover_enabled=\"14px\" ul_letter_spacing__hover=\"0px\" ul_letter_spacing__hover_enabled=\"0px\" ul_line_height__hover=\"1em\" ul_line_height__hover_enabled=\"1em\" ul_text_shadow_style__hover=\"none\" ul_text_shadow_style__hover_enabled=\"none\" ul_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" ul_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" ol_font_size__hover=\"14px\" ol_font_size__hover_enabled=\"14px\" ol_letter_spacing__hover=\"0px\" ol_letter_spacing__hover_enabled=\"0px\" ol_line_height__hover=\"1em\" ol_line_height__hover_enabled=\"1em\" ol_text_shadow_style__hover=\"none\" ol_text_shadow_style__hover_enabled=\"none\" ol_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" ol_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" quote_font_size__hover=\"14px\" quote_font_size__hover_enabled=\"14px\" quote_letter_spacing__hover=\"0px\" quote_letter_spacing__hover_enabled=\"0px\" quote_line_height__hover=\"1em\" quote_line_height__hover_enabled=\"1em\" quote_text_shadow_style__hover=\"none\" quote_text_shadow_style__hover_enabled=\"none\" quote_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" quote_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_font_size__hover=\"30px\" header_font_size__hover_enabled=\"30px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" text_orientation__hover=\"left\" text_orientation__hover_enabled=\"left\" background_layout__hover=\"light\" background_layout__hover_enabled=\"light\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"]<h2>انتخاب 1 # کاربران هستیم</h2>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ، و با استفاده از طراحان گرافیک است، چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است، و برای شرایط فعلی تکنولوژی مورد نیاز، و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد، کتابهای زیادی در شصت و سه درصد گذشته حال و آینده، شناخت فراوان جامعه و متخصصان را می طلبد، تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی، و فرهنگ پیشرو در زبان فارسی ایجاد کرد، در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها، و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی، و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد.</span></p>\n[/et_pb_text][et_pb_button button_text=\"پلن های اینترنتی ما\" button_alignment=\"left\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#7cda24\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_row_inner _builder_version=\"3.25\" custom_padding=\"|40px|50px|40px||true\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\"][et_pb_column_inner saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\"]<h2>چرا شرکت ما</h2>\n[/et_pb_text][et_pb_blurb title=\"بدون قطعی نت\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"2em\" custom_margin=\"||20px\" hover_enabled=\"0\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"سرعت دهی تا 125 مگا بیت بر ثانیه\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"2em\" custom_margin=\"||20px\" hover_enabled=\"0\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"تجهیزات سخت افزاری به روز\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"2em\" custom_margin=\"||20px\" hover_enabled=\"0\" locked=\"off\"][/et_pb_blurb][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Features\" _builder_version=\"3.22\" background_color=\"#f2f5fa\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_padding=\"54px|0px|0|0px|false|false\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row column_structure=\"3_5,2_5\" _builder_version=\"3.25\" custom_margin=\"100px||100px||true\" custom_margin_tablet=\"40px||40px||true\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" locked=\"off\"][et_pb_column type=\"3_5\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/04/isp-01.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"|||-7vw\" custom_margin_tablet=\"|||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\"][/et_pb_image][/et_pb_column][et_pb_column type=\"2_5\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>داستان ما</h2>\n<h3></h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ، و با استفاده از طراحان گرافیک است، چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است، و برای شرایط فعلی تکنولوژی مورد نیاز، و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد، کتابهای زیادی در شصت و سه درصد گذشته حال و آینده، شناخت فراوان جامعه و متخصصان را می طلبد، تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی، و فرهنگ پیشرو در زبان فارسی ایجاد کرد، در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها، و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی، و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد.</span></p>\n[/et_pb_text][et_pb_button button_text=\"مشاهده پلن های اینترنت\" button_alignment=\"left\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#7cda24\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Value\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(255,255,255,0)\" background_color_gradient_end=\"#ffffff\" background_color_gradient_type=\"radial\" background_color_gradient_start_position=\"50%\" background_color_gradient_overlays_image=\"on\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.jpg\" custom_padding=\"10vw|0px|10vw|0px|true|false\"][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" padding_top_bottom_link_1=\"false\" padding_top_bottom_link_2=\"false\" padding_top_bottom_link_3=\"false\" padding_left_right_link_1=\"true\" padding_left_right_link_2=\"true\" padding_left_right_link_3=\"true\" _builder_version=\"3.25\" max_width=\"1160px\" custom_padding=\"0|0px|27px|0px|false|false\" use_custom_width=\"on\" custom_width_px=\"1160px\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\" max_width__hover=\"1080px\" max_width__hover_enabled=\"1080px\" locked=\"off\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-03.png\" background_size=\"contain\" background_position=\"bottom_right\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"دریافت سرعت واقعی\" use_icon=\"on\" font_icon=\"%%243%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|hover\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"0deg|330deg|0deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"20 درصد تخفیف\" use_icon=\"on\" font_icon=\"%%171%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"0deg|0deg|330deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-04.png\" background_size=\"contain\" background_position=\"top_right\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"بدون محدودیت حجمی\" use_icon=\"on\" font_icon=\"%%231%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"330deg|0deg|0deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است </span></p>[/et_pb_blurb][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" prev_background_color=\"#ffffff\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#0f1533\" background_color_gradient_end=\"#1f133a\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||5vw\" custom_padding=\"14vw||10vw\" top_divider_style=\"wave2\" top_divider_height=\"10vw\" top_divider_repeat=\"0.7x\" top_divider_flip=\"vertical\" animation_style=\"fade\" border_radii=\"on|30px|30px|30px|30px\" locked=\"off\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_phone=\"\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_2_font=\"|900|on||||||\" header_2_font_size=\"3.5vw\" header_2_letter_spacing=\"2px\" header_2_line_height=\"1.4em\" header_3_font=\"|900|on|on|||||\" header_3_text_color=\"rgba(255,255,255,0.7)\" header_3_font_size=\"1.5vw\" header_3_letter_spacing=\"0.4em\" header_3_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_font_size__hover=\"30px\" header_font_size__hover_enabled=\"30px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h2>سرعت مورد نظر خود را با قیمتی که می خواهید دریافت کنید</h2>\n<h3>سرویس های ADSL  و سرویس های پیامکی</h3>[/et_pb_text][et_pb_button button_text=\"مشاهده تمام سرویس های ما\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#7cda24\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section]", "درباره ما", "", "publish", "closed", "closed", "", "about", "", "", "2020-04-02 17:22:21", "2020-04-02 13:52:21", "", "0", "http://modelsite.test/?page_id=187", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("195", "1", "2020-03-05 14:06:29", "2020-03-05 10:36:29", "[et_pb_section fb_built=\"1\" admin_label=\"Header\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-05.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"5vw||||false\" custom_padding=\"6vw||10vw||false|false\" bottom_divider_style=\"wave2\" bottom_divider_color=\"#ffffff\" bottom_divider_height=\"10vw\" bottom_divider_repeat=\"0.7x\" animation_style=\"slide\" animation_direction=\"bottom\" animation_intensity_slide=\"1%\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_phone=\"\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" animation_style=\"slide\" animation_direction=\"left\" animation_intensity_slide=\"10%\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_font=\"|900|on|on|||||\" header_font_size=\"7vw\" header_letter_spacing=\"0em\" header_line_height=\"1.2em\" header_2_font=\"|900|on|on|||||\" header_2_text_color=\"rgba(255,255,255,0.7)\" header_2_font_size=\"4vw\" header_2_letter_spacing=\"0.1em\" header_2_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" hover_enabled=\"0\" header_font_size_tablet=\"50px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|phone\" header_2_font_size_tablet=\"30px\" header_2_font_size_phone=\"20px\" header_2_font_size_last_edited=\"on|phone\" header_text_shadow_style=\"preset1\" header_text_shadow_vertical_length=\"0.3em\" header_text_shadow_blur_strength=\"0.5em\" header_text_shadow_color=\"rgba(0,0,0,0.15)\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h1>ارتباط با ما</h1>\n<p>&nbsp;</p>\n<h2><span color=\"rgba(0, 0, 0, 0.701960784313725)\" style=\"color: rgba(0, 0, 0, 0.7);\">پشتیبانی 24/7</span></h2>\n[/et_pb_text][et_pb_search show_button=\"off\" placeholder=\"جستجو در مقالات .....\" button_color=\"#ffffff\" placeholder_color=\"#ffffff\" _builder_version=\"4.4.2\" button_font=\"VAZIR FARSI||||||||\" form_field_font=\"Poppins|600|||||||\" form_field_font_size=\"16px\" form_field_line_height=\"2em\" background_color=\"rgba(48,52,71,0.18)\" max_width=\"700px\" module_alignment=\"center\" custom_padding=\"14px||14px||true|false\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" input_font=\"Poppins|600|||||||\" input_font_size=\"16px\" input_line_height=\"2em\"][/et_pb_search][et_pb_button button_text=\"چت زنده\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Categories\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(242,245,250,0)\" background_color_gradient_end=\"#f2f5fa\" background_color_gradient_direction=\"90deg\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin_tablet=\"||0px\" custom_margin_last_edited=\"off|desktop\" custom_padding=\"0||0px||false|false\" border_radii=\"on|60px|60px|60px|60px\" locked=\"off\"][et_pb_row column_structure=\"1_4,1_4,1_4,1_4\" use_custom_gutter=\"on\" gutter_width=\"2\" _builder_version=\"3.25\" locked=\"off\"][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#a0cf00\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" locked=\"off\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" box_shadow_color__hover_enabled=\"on\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\"]<p>بیزینس ها</p>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#008a1c\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" box_shadow_color__hover_enabled=\"on\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\"]<p>منازل</p>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#ffffff\" text_orientation=\"center\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" locked=\"off\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" box_shadow_color__hover_enabled=\"on\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\" background_layout__hover_enabled=\"on\" background_layout__hover=\"dark\"]<p>همه مشاغل</p>\n[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Contact Info\" _builder_version=\"3.22\"][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"چت زنده\" use_icon=\"on\" font_icon=\"%%221%%\" use_circle=\"on\" circle_color=\"#ffffff\" icon_placement=\"left\" use_icon_font_size=\"on\" icon_font_size=\"22px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" background_color=\"#303447\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"20px|20px|20px|20px|true|true\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" background__hover_enabled=\"on\" background_color__hover=\"#008a1c\"]<p>24 ساعته </p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"ساعات کاری\" use_icon=\"on\" font_icon=\"%%128%%\" use_circle=\"on\" circle_color=\"#ffffff\" icon_placement=\"left\" use_icon_font_size=\"on\" icon_font_size=\"22px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" background_color=\"#303447\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"20px|20px|20px|20px|true|true\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" background__hover_enabled=\"on\" background_color__hover=\"#008a1c\"]<p>اداری 7 صبح تا 7 شب </p>\n<p>فنی 24 ساعته</p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"پشتیبانی\" use_icon=\"on\" font_icon=\"%%264%%\" use_circle=\"on\" circle_color=\"#ffffff\" icon_placement=\"left\" use_icon_font_size=\"on\" icon_font_size=\"22px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" background_color=\"#303447\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"20px|20px|20px|20px|true|true\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" background__hover_enabled=\"on\" background_color__hover=\"#008a1c\"]<p>(125) 462-2351  اداری<br /> (125) 462-1351  فنی</p>\n[/et_pb_blurb][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Call to Actions\" _builder_version=\"3.22\" custom_padding=\"0|0px|54px|0px|false|false\"][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_cta title=\"به پشتیبانی قبل از خرید نیاز دارید ؟\" button_url=\"#\" button_text=\"چت کنید\" _builder_version=\"4.4.2\" header_level=\"h3\" header_font=\"|700|on||||||\" header_font_size=\"26px\" header_line_height=\"1.5em\" body_font=\"|500|||||||\" body_text_color=\"#008a1c\" body_line_height=\"1.8em\" background_color=\"#ffffff\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" text_orientation=\"left\" background_layout=\"light\" hover_enabled=\"0\" header_font_size_tablet=\"\" header_font_size_phone=\"26px\" header_font_size_last_edited=\"on|phone\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" box_shadow_style_button=\"preset3\" box_shadow_vertical_button=\"20px\" box_shadow_blur_button=\"80px\" box_shadow_spread_button=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#a0cf00\" button_bg_enable_color__hover=\"on\"]<p>شماره تماس: (135) 624-1231</p>\n[/et_pb_cta][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_cta title=\"به پشتیبانی پس از خرید نیاز دارید ؟\" button_url=\"#\" button_text=\"تیکت بزنید\" _builder_version=\"4.4.2\" header_level=\"h3\" header_font=\"|700|on||||||\" header_font_size=\"26px\" header_line_height=\"1.5em\" body_font=\"|500|||||||\" body_text_color=\"#008a1c\" body_line_height=\"1.8em\" background_color=\"#ffffff\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" text_orientation=\"left\" background_layout=\"light\" hover_enabled=\"0\" header_font_size_tablet=\"\" header_font_size_phone=\"26px\" header_font_size_last_edited=\"on|phone\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" box_shadow_style_button=\"preset3\" box_shadow_vertical_button=\"20px\" box_shadow_blur_button=\"80px\" box_shadow_spread_button=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#a0cf00\" button_bg_enable_color__hover=\"on\"]<p>شماره تماس: (135) 624-1231</p>\n[/et_pb_cta][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"FAQ\" _builder_version=\"3.22\" background_color=\"#f2f5fa\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_padding=\"0|0px|0|0px|false|false\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row custom_padding_last_edited=\"on|tablet\" _builder_version=\"3.25\" background_color=\"#ffffff\" max_width=\"80%\" module_alignment=\"left\" custom_margin=\"||\" custom_padding=\"60px|||60px|false|false\" custom_padding_tablet=\"|40px||40px\" custom_padding_phone=\"\" animation_style=\"slide\" animation_direction=\"left\" animation_intensity_slide=\"10%\" border_radii=\"|||30px|\" use_custom_width=\"on\" width_unit=\"off\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2> مقالات راهنما</h2>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"3_5,2_5\" _builder_version=\"3.25\" custom_margin=\"100px||100px||true\" custom_margin_tablet=\"40px||40px||true\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\"][et_pb_column type=\"3_5\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"Poppins|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"|700|on||||||\" header_3_line_height=\"1.5em\" max_width=\"700px\" link_option_url=\"#\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" header_3_font_size_tablet=\"\" header_3_font_size_phone=\"26px\" header_3_font_size_last_edited=\"on|desktop\" locked=\"off\" header_3_text_color__hover_enabled=\"on\" header_3_text_color__hover=\"#008a1c\"]<h3>دستور نصب</h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span></p>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"Poppins|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"|700|on||||||\" header_3_line_height=\"1.5em\" max_width=\"700px\" link_option_url=\"#\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" header_3_font_size_tablet=\"\" header_3_font_size_phone=\"26px\" header_3_font_size_last_edited=\"on|desktop\" locked=\"off\" header_3_text_color__hover_enabled=\"on\" header_3_text_color__hover=\"#008a1c\"]<h3>تست سرعت</h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span></p>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"Poppins|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"|700|on||||||\" header_3_line_height=\"1.5em\" max_width=\"700px\" link_option_url=\"#\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" header_3_font_size_tablet=\"\" header_3_font_size_phone=\"26px\" header_3_font_size_last_edited=\"on|desktop\" locked=\"off\" header_3_text_color__hover_enabled=\"on\" header_3_text_color__hover=\"#008a1c\"]<h3>مدیریت اکانت</h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span></p>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"2_5\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_toggle title=\"نحوه تنظیم مودم چگونه است ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||20px\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span></p>\n[/et_pb_toggle][et_pb_toggle title=\"سوال دلخواه ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||20px\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span></p>\n[/et_pb_toggle][et_pb_toggle title=\"سوال دلخواه ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||20px\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span></p>\n[/et_pb_toggle][et_pb_toggle title=\"سوال دلخواه ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||20px\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span></p>\n[/et_pb_toggle][et_pb_toggle title=\"سوال دلخواه ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||20px\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span></p>\n[/et_pb_toggle][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" _builder_version=\"3.22\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\"][et_pb_row _builder_version=\"3.25\" width=\"100%\" max_width=\"100%\" custom_padding=\"0|0px|0|0px|true|false\" border_radii=\"on|30px|30px|30px|30px\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"100%\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][dsm_embed_google_map _builder_version=\"4.4.2\" address=\"برج میلاد\" hover_enabled=\"0\"][/dsm_embed_google_map][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Blog\" _builder_version=\"3.22\"][et_pb_row _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#0492ff\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>منابع بیشتر</h2>\n[/et_pb_text][et_pb_blog fullwidth=\"off\" posts_number=\"3\" show_pagination=\"off\" _builder_version=\"3.17.6\" header_font=\"Poppins|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_line_height=\"2em\" meta_font=\"Poppins||||||||\" meta_text_color=\"#008a1c\" pagination_font=\"Poppins|700|on||||||\" pagination_text_color=\"#008a1c\" pagination_font_size=\"18px\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"][/et_pb_blog][et_pb_button button_text=\"رفتن به وبلاگ\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#a0cf00\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" prev_background_color=\"#ffffff\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#0f1533\" background_color_gradient_end=\"#1f133a\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||5vw\" custom_padding=\"14vw||10vw\" top_divider_style=\"wave2\" top_divider_height=\"10vw\" top_divider_repeat=\"0.7x\" top_divider_flip=\"vertical\" animation_style=\"fade\" border_radii=\"on|30px|30px|30px|30px\" locked=\"off\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_phone=\"\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_2_font=\"|900|on||||||\" header_2_font_size=\"3.5vw\" header_2_letter_spacing=\"2px\" header_2_line_height=\"1.4em\" header_3_font=\"|900|on|on|||||\" header_3_text_color=\"rgba(255,255,255,0.7)\" header_3_font_size=\"1.5vw\" header_3_letter_spacing=\"0.4em\" header_3_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_font_size__hover=\"30px\" header_font_size__hover_enabled=\"30px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h2>سرعت مورد نظر خود را با قیمتی که می خواهید دریافت کنید</h2>\n<h3>سرویس های ADSL  و سرویس های پیامکی</h3>[/et_pb_text][et_pb_button button_text=\"مشاهده تمام سرویس های ما\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#7cda24\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section]", "تماس با ما", "", "publish", "closed", "closed", "", "contect", "", "", "2020-04-02 17:15:09", "2020-04-02 13:45:09", "", "0", "http://modelsite.test/?page_id=195", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("256", "1", "2020-03-05 16:02:56", "0000-00-00 00:00:00", "", "خانه", "", "draft", "closed", "closed", "", "", "", "", "2020-03-05 16:02:56", "0000-00-00 00:00:00", "", "0", "http://modelsite.test/?p=256", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("257", "1", "2020-03-05 16:03:25", "2020-03-05 12:33:25", " ", "", "", "publish", "closed", "closed", "", "257", "", "", "2020-04-02 17:34:40", "2020-04-02 14:04:40", "", "0", "http://modelsite.test/?p=257", "6", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("258", "1", "2020-03-05 16:03:24", "2020-03-05 12:33:24", " ", "", "", "publish", "closed", "closed", "", "258", "", "", "2020-04-02 17:34:39", "2020-04-02 14:04:39", "", "0", "http://modelsite.test/?p=258", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("260", "1", "2020-03-05 16:03:25", "2020-03-05 12:33:25", " ", "", "", "publish", "closed", "closed", "", "260", "", "", "2020-04-02 17:34:40", "2020-04-02 14:04:40", "", "0", "http://modelsite.test/?p=260", "5", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("267", "1", "2020-03-05 16:15:05", "2020-03-05 12:45:05", "[et_pb_section fb_built=\"1\" admin_label=\"Header\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-05.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"5vw||||false\" custom_padding=\"6vw||10vw||false|false\" bottom_divider_style=\"wave2\" bottom_divider_color=\"#ffffff\" bottom_divider_height=\"10vw\" bottom_divider_repeat=\"0.7x\" animation_style=\"slide\" animation_direction=\"bottom\" animation_intensity_slide=\"1%\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_phone=\"\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" animation_style=\"slide\" animation_direction=\"left\" animation_intensity_slide=\"10%\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_font=\"|900|on|on|||||\" header_font_size=\"6vw\" header_letter_spacing=\"0.1em\" header_line_height=\"1.2em\" header_2_font=\"Poppins|900|on|on|||||\" header_2_text_color=\"rgba(255,255,255,0.7)\" header_2_font_size=\"2vw\" header_2_letter_spacing=\"0.5em\" header_2_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" hover_enabled=\"0\" header_font_size_tablet=\"50px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|phone\" header_2_font_size_tablet=\"30px\" header_2_font_size_phone=\"20px\" header_2_font_size_last_edited=\"on|phone\" header_text_shadow_style=\"preset1\" header_text_shadow_vertical_length=\"0.3em\" header_text_shadow_blur_strength=\"0.5em\" header_text_shadow_color=\"rgba(0,0,0,0.15)\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h1>وبلاگ و مقالات</h1>\n[/et_pb_text][et_pb_signup mailchimp_list=\"elegantthemestest|26e9af0331\" layout=\"top_bottom\" first_name_field=\"off\" last_name_field=\"off\" _builder_version=\"4.4.2\" form_field_background_color=\"rgba(48,52,71,0.18)\" form_field_text_color=\"#ffffff\" form_field_font=\"Poppins|600|||||||\" form_field_line_height=\"2em\" use_background_color=\"off\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" max_width=\"800px\" module_alignment=\"center\" hover_enabled=\"0\" border_radii_fields=\"on|15px|15px|15px|15px\" box_shadow_style_button=\"preset3\" box_shadow_vertical_button=\"20px\" box_shadow_blur_button=\"80px\" box_shadow_spread_button=\"-20px\" button_text=\"اشتراک خبرنامه ایمیلی\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#004fe8\" button_bg_enable_color__hover=\"on\" button_text_color__hover_enabled=\"on|hover\" button_text_color__hover=\"#dadada\"][/et_pb_signup][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Categories\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(242,245,250,0)\" background_color_gradient_end=\"#f2f5fa\" background_color_gradient_direction=\"90deg\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||60px\" custom_margin_tablet=\"||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|desktop\" custom_padding=\"0||0px||false|false\" border_radii=\"on|60px|60px|60px|60px\" locked=\"off\"][et_pb_row column_structure=\"1_6,1_6,1_6,1_6,1_6,1_6\" use_custom_gutter=\"on\" gutter_width=\"2\" _builder_version=\"3.25\" locked=\"off\"][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#a0cf00\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" locked=\"off\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" box_shadow_color__hover_enabled=\"on\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\"]<p>تخفیف ها</p>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#ffffff\" text_orientation=\"center\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" locked=\"off\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" box_shadow_color__hover_enabled=\"on\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\" background_layout__hover_enabled=\"on\" background_layout__hover=\"dark\"]<p>آموزش ها</p>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#008a1c\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" box_shadow_color__hover_enabled=\"on\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\"]<p>اینترنت</p>\n[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Blog\" _builder_version=\"3.22\"][et_pb_row _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_blog fullwidth=\"off\" posts_number=\"9\" _builder_version=\"4.4.2\" header_font=\"Poppins|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_line_height=\"2em\" meta_font=\"Poppins||||||||\" meta_text_color=\"#008a1c\" pagination_font=\"Poppins|700|on||||||\" pagination_text_color=\"#008a1c\" pagination_font_size=\"18px\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" border_radii_image__hover_enabled=\"on|hover\" border_radii_image__hover=\"on|150px|150px|150px|150px\"][/et_pb_blog][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Videos\" _builder_version=\"3.22\" background_color=\"#f2f5fa\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_padding=\"54px|0px|0|0px|false|false\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row _builder_version=\"3.25\" custom_margin_tablet=\"40px||40px||true\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2><strong>فیلم های کمک آموزشی</strong></h2>\n<h3>نحوه پیکربندی مودم ، تغییر رمز وای فا و .....</h3>\n[/et_pb_text][et_pb_video_slider show_image_overlay=\"on\" play_icon_color=\"#000000\" _builder_version=\"4.4.2\" hover_enabled=\"0\"][et_pb_video_slider_item src=\"#\" image_src=\"http://modelsite.test/wp-content/uploads/2020/04/tech-01.jpg\" _builder_version=\"4.4.2\" hover_enabled=\"0\" show_image_overlay=\"on\"][/et_pb_video_slider_item][et_pb_video_slider_item src=\"#\" image_src=\"http://modelsite.test/wp-content/uploads/2020/04/tech-04.jpg\" _builder_version=\"4.4.2\" hover_enabled=\"0\" show_image_overlay=\"on\"][/et_pb_video_slider_item][et_pb_video_slider_item src=\"#\" image_src=\"http://modelsite.test/wp-content/uploads/2020/04/tech-05.jpg\" _builder_version=\"4.4.2\" hover_enabled=\"0\" show_image_overlay=\"on\"][/et_pb_video_slider_item][/et_pb_video_slider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonials\" _builder_version=\"3.22\"][et_pb_row column_structure=\"2_5,3_5\" padding_top_bottom_link_1=\"true\" padding_top_bottom_link_2=\"true\" padding_left_right_link_1=\"false\" padding_left_right_link_2=\"false\" _builder_version=\"3.25\"][et_pb_column type=\"2_5\" _builder_version=\"3.25\" custom_padding=\"60px|60px|60px|\" custom_padding_tablet=\"0px||0px||true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px||0px||true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>پرسش و پاسخ های متداول</h2>\n<h3>سوالات خود را ابتدا از این بخش جوابشان را پیدا کنید </h3>\n[/et_pb_text][et_pb_button button_text=\"سوال دیگری داری ؟\" button_alignment=\"left\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#37d73c\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][et_pb_column type=\"3_5\" _builder_version=\"3.25\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" background_size=\"initial\" background_position=\"bottom_right\" custom_padding=\"60px|60px|60px|\" custom_padding_tablet=\"40px|40px|40px|40px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"40px|40px|40px|40px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_toggle title=\"منظور از پهنای باند چیست ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||0px|-30px\" hover_enabled=\"0\" border_radii=\"|15px|15px||\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>منظور از پهنای باند مجموع داده ای می باشید که شما دانلود و آپلود می کنید .</p>\n[/et_pb_toggle][et_pb_toggle title=\"سوال دلخواه دیگر را وارد کنید ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||0px|-30px\" hover_enabled=\"0\" border_radii=\"|15px|15px||\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>جوابش هم اینجا وارد کنید .</p>\n[/et_pb_toggle][et_pb_toggle title=\"سوال دلخواه دیگر را وارد کنید ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||0px|-30px\" hover_enabled=\"0\" border_radii=\"|15px|15px||\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>جوابش هم اینجا وارد کنید .</p>\n[/et_pb_toggle][et_pb_toggle title=\"سوال دلخواه دیگر را وارد کنید ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||0px|-30px\" hover_enabled=\"0\" border_radii=\"|15px|15px||\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>جوابش هم اینجا وارد کنید .</p>\n[/et_pb_toggle][et_pb_toggle title=\"سوال دلخواه دیگر را وارد کنید ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||0px|-30px\" hover_enabled=\"0\" border_radii=\"|15px|15px||\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>جوابش هم اینجا وارد کنید .</p>\n[/et_pb_toggle][et_pb_toggle title=\"سوال دلخواه دیگر را وارد کنید ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||0px|-30px\" hover_enabled=\"0\" border_radii=\"|15px|15px||\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>جوابش هم اینجا وارد کنید .</p>\n[/et_pb_toggle][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" prev_background_color=\"#ffffff\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#0f1533\" background_color_gradient_end=\"#1f133a\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||5vw\" custom_padding=\"14vw||10vw\" top_divider_style=\"wave2\" top_divider_height=\"10vw\" top_divider_repeat=\"0.7x\" top_divider_flip=\"vertical\" animation_style=\"fade\" border_radii=\"on|30px|30px|30px|30px\" locked=\"off\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_phone=\"\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_2_font=\"|900|on||||||\" header_2_font_size=\"3.5vw\" header_2_letter_spacing=\"2px\" header_2_line_height=\"1.4em\" header_3_font=\"|900|on|on|||||\" header_3_text_color=\"rgba(255,255,255,0.7)\" header_3_font_size=\"1.5vw\" header_3_letter_spacing=\"0.4em\" header_3_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_font_size__hover=\"30px\" header_font_size__hover_enabled=\"30px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h2>سرعت مورد نظر خود را با قیمتی که می خواهید دریافت کنید</h2>\n<h3>سرویس های ADSL  و سرویس های پیامکی</h3>[/et_pb_text][et_pb_button button_text=\"مشاهده تمام سرویس های ما\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#7cda24\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section]", "وبلاگ", "", "publish", "closed", "closed", "", "blog", "", "", "2020-04-02 17:31:50", "2020-04-02 14:01:50", "", "0", "http://modelsite.test/?page_id=267", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("281", "1", "2020-03-05 16:18:03", "2020-03-05 12:48:03", " ", "", "", "publish", "closed", "closed", "", "281", "", "", "2020-04-02 17:34:40", "2020-04-02 14:04:40", "", "0", "http://modelsite.test/?p=281", "4", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("282", "1", "2020-03-05 16:19:03", "2020-03-05 12:49:03", "http://modelsite.test/wp-content/uploads/2020/03/cropped-cleaning-services-06.jpg", "cropped-cleaning-services-06.jpg", "", "inherit", "open", "closed", "", "cropped-cleaning-services-06-jpg", "", "", "2020-03-05 16:19:03", "2020-03-05 12:49:03", "", "0", "http://modelsite.test/wp-content/uploads/2020/03/cropped-cleaning-services-06.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("338", "1", "2020-03-05 21:45:23", "2020-03-05 18:15:23", "http://modelsite.test/wp-content/uploads/2020/03/cropped-icon-dry.png", "cropped-icon-dry.png", "", "inherit", "open", "closed", "", "cropped-icon-dry-png", "", "", "2020-03-05 21:45:23", "2020-03-05 18:15:23", "", "0", "http://modelsite.test/wp-content/uploads/2020/03/cropped-icon-dry.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("446", "1", "2020-03-06 16:52:43", "2020-03-06 13:22:43", "http://modelsite.test/wp-content/uploads/2020/03/cropped-Car-wash-logo.png", "cropped-Car-wash-logo.png", "", "inherit", "open", "closed", "", "cropped-car-wash-logo-png", "", "", "2020-03-06 16:52:43", "2020-03-06 13:22:43", "", "0", "http://modelsite.test/wp-content/uploads/2020/03/cropped-Car-wash-logo.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("570", "1", "2020-03-07 17:53:44", "2020-03-07 14:23:44", "http://modelsite.test/wp-content/uploads/2020/03/cropped-startup-logo.png", "cropped-startup-logo.png", "", "inherit", "open", "closed", "", "cropped-startup-logo-png", "", "", "2020-03-07 17:53:44", "2020-03-07 14:23:44", "", "0", "http://modelsite.test/wp-content/uploads/2020/03/cropped-startup-logo.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("572", "1", "2020-03-07 17:58:43", "2020-03-07 14:28:43", "", "تلگرام", "", "publish", "closed", "closed", "", "%d8%aa%d9%84%da%af%d8%b1%d8%a7%d9%85", "", "", "2020-03-11 17:33:53", "2020-03-11 14:03:53", "", "0", "http://modelsite.test/?p=572", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("573", "1", "2020-03-07 17:58:43", "2020-03-07 14:28:43", "", "آپارات", "", "publish", "closed", "closed", "", "%d8%a2%d9%be%d8%a7%d8%b1%d8%a7%d8%aa", "", "", "2020-03-11 17:33:53", "2020-03-11 14:03:53", "", "0", "http://modelsite.test/?p=573", "2", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("574", "1", "2020-03-07 17:58:43", "2020-03-07 14:28:43", "", "اینستاگرام", "", "publish", "closed", "closed", "", "%d8%a7%db%8c%d9%86%d8%b3%d8%aa%d8%a7%da%af%d8%b1%d8%a7%d9%85", "", "", "2020-03-11 17:33:53", "2020-03-11 14:03:53", "", "0", "http://modelsite.test/?p=574", "3", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("700", "1", "2020-03-10 16:39:19", "2020-03-10 13:09:19", "http://modelsite.test/wp-content/uploads/2020/03/cropped-app-logo.png", "cropped-app-logo.png", "", "inherit", "open", "closed", "", "cropped-app-logo-png", "", "", "2020-03-10 16:39:19", "2020-03-10 13:09:19", "", "0", "http://modelsite.test/wp-content/uploads/2020/03/cropped-app-logo.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("830", "1", "2020-03-11 16:29:51", "2020-03-11 12:59:51", "http://modelsite.test/wp-content/uploads/2020/03/cropped-barber-icon-1-1.png", "cropped-barber-icon-1-1.png", "", "inherit", "open", "closed", "", "cropped-barber-icon-1-1-png", "", "", "2020-03-11 16:29:51", "2020-03-11 12:59:51", "", "0", "http://modelsite.test/wp-content/uploads/2020/03/cropped-barber-icon-1-1.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("867", "1", "2020-03-11 17:33:32", "2020-03-11 14:03:32", "", "icon-aparat", "", "inherit", "open", "closed", "", "icon-aparat", "", "", "2020-03-11 17:33:32", "2020-03-11 14:03:32", "", "0", "http://modelsite.test/wp-content/uploads/2020/03/icon-aparat.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("868", "1", "2020-03-11 17:33:33", "2020-03-11 14:03:33", "", "icon-insta", "", "inherit", "open", "closed", "", "icon-insta", "", "", "2020-03-11 17:33:33", "2020-03-11 14:03:33", "", "0", "http://modelsite.test/wp-content/uploads/2020/03/icon-insta.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("869", "1", "2020-03-11 17:33:34", "2020-03-11 14:03:34", "", "icon-tel", "", "inherit", "open", "closed", "", "icon-tel", "", "", "2020-03-11 17:33:34", "2020-03-11 14:03:34", "", "0", "http://modelsite.test/wp-content/uploads/2020/03/icon-tel.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("899", "1", "2020-03-12 15:28:32", "2020-03-12 11:58:32", "[et_pb_section fb_built=\"1\" admin_label=\"Header\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-05.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"5vw||||false\" custom_padding=\"6vw||10vw||false|false\" bottom_divider_style=\"wave2\" bottom_divider_color=\"#ffffff\" bottom_divider_height=\"10vw\" bottom_divider_repeat=\"0.7x\" animation_style=\"slide\" animation_direction=\"bottom\" animation_intensity_slide=\"1%\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_phone=\"\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" animation_style=\"slide\" animation_direction=\"left\" animation_intensity_slide=\"10%\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_font=\"|900|on|on|||||\" header_font_size=\"6vw\" header_letter_spacing=\"0.1em\" header_line_height=\"1.2em\" header_2_font=\"|900|on|on|||||\" header_2_text_color=\"rgba(255,255,255,0.7)\" header_2_font_size=\"3vw\" header_2_letter_spacing=\"0em\" header_2_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" header_font_size_tablet=\"50px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|phone\" header_2_font_size_tablet=\"30px\" header_2_font_size_phone=\"20px\" header_2_font_size_last_edited=\"on|phone\" header_text_shadow_style=\"preset1\" header_text_shadow_vertical_length=\"0.3em\" header_text_shadow_blur_strength=\"0.5em\" header_text_shadow_color=\"rgba(0,0,0,0.15)\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h1>پلان های اینترنت</h1>\n<p>&nbsp;</p>\n<h2><span color=\"rgba(0, 0, 0, 0.701960784313725)\" style=\"color: rgba(0, 0, 0, 0.7);\">شروع از 35 هزارتومان / سالانه</span></h2>[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Features\" _builder_version=\"3.22\"][et_pb_row _builder_version=\"3.25\" custom_padding=\"||||false|false\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#0492ff\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" text_orientation=\"center\" max_width=\"700px\" module_alignment=\"center\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>تمامی سرویس ها شامل:</h2>[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" padding_top_bottom_link_1=\"false\" padding_top_bottom_link_2=\"false\" padding_top_bottom_link_3=\"false\" padding_left_right_link_1=\"true\" padding_left_right_link_2=\"true\" padding_left_right_link_3=\"true\" _builder_version=\"3.25\" max_width=\"1160px\" custom_padding=\"0|0px|27px|0px|false|false\" use_custom_width=\"on\" custom_width_px=\"1160px\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\" max_width__hover=\"1080px\" max_width__hover_enabled=\"1080px\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-03.png\" background_size=\"contain\" background_position=\"bottom_right\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"دریافت سرعت واقعی\" use_icon=\"on\" font_icon=\"%%243%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|hover\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"0deg|42deg|0deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"20 درصد تخفیف\" use_icon=\"on\" font_icon=\"%%171%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"0deg|0deg|25deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-04.png\" background_size=\"contain\" background_position=\"top_right\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"بدون محدودیت حجمی\" use_icon=\"on\" font_icon=\"%%231%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"330deg|0deg|0deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است </span></p>[/et_pb_blurb][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Pricing\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#0f1533\" background_color_gradient_end=\"#1f133a\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||40px||false\" custom_padding=\"80px||80px||true\" animation_style=\"slide\" animation_direction=\"bottom\" animation_intensity_slide=\"1%\" border_radii=\"on|30px|30px|30px|30px\" locked=\"off\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\"][et_pb_row _builder_version=\"3.25\" custom_padding=\"||||false|false\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#0492ff\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" text_orientation=\"center\" background_layout=\"dark\" max_width=\"700px\" module_alignment=\"center\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>سرویس های اینترنت</h2>[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"40px|||\" custom_padding_tablet=\"0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px||\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#ffffff\" price_text_color=\"rgba(0,0,0,0.75)\" body_text_color=\"#ffffff\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"||||||||\" body_text_align=\"center\" subheader_font=\"|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"||on||||||\" price_font_size=\"50px\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(255,255,255,0)\" background_color_gradient_end=\"rgba(255,255,255,0.16)\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" transform_translate_linked__hover=\"off\" animation_style=\"slide\" animation_direction=\"right\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate__hover=\"0px|-70px\"][et_pb_pricing_table title=\"اینترنت پایه\" subtitle=\"1 مگابایت\" currency=\"یک ساله \" per=\"هزارتومان\" sum=\"35\" button_url=\"#\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" header_level=\"h2\" header_font=\"||||||||\" body_font=\"VAZIR FARSI||||||||\" subheader_font=\"|800|||||||\" price_font=\"|800|on||||||\" price_letter_spacing=\"0px\" price_line_height=\"100px\" currency_frequency_font=\"|700|on||||||\" currency_frequency_line_height=\"1em\" excluded_text_color=\"rgba(255,255,255,0.5)\" custom_button=\"on\" button_font=\"VAZIR FARSI||||||||\" pricing_item_excluded_color=\"rgba(255,255,255,0.5)\"]<p>+ گارانتی سرعت</p>\n<p>+ گارنتی کیفیت</p>\n<p>+ نصب در محل</p>\n<p>- تنظیم مودم</p>\n<p>- پشتیبانی 24 ساعته</p>[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_pricing_tables featured_table_header_background_color=\"#ffffff\" featured_table_header_text_color=\"#ffffff\" header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#994ceb\" price_text_color=\"rgba(0,0,0,0.75)\" subheader_text_color=\"#ffffff\" header_text_color=\"#ffffff\" header_font=\"||||||||\" header_font_size=\"14px\" body_font=\"Poppins||||||||\" body_text_align=\"center\" subheader_font=\"|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"|800|on||||||\" currency_frequency_font=\"|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#ffffff\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#8a006e\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" transform_translate_linked__hover=\"off\" custom_margin=\"0px||\" animation_style=\"zoom\" animation_delay=\"100ms\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" border_color_all=\"#ffffff\" border_width_top=\"40px\" border_width_bottom=\"30px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" locked=\"off\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate__hover=\"0px|-70px\"][et_pb_pricing_table title=\"سرویس محبوب\" subtitle=\"65 مگابایت\" currency=\"سالانه\" per=\"هزارتومان\" sum=\"99\" button_url=\"#\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" header_level=\"h2\" header_font=\"||||||||\" body_font=\"VAZIR FARSI||||||||\" subheader_font=\"VAZIR FARSI|800|||||||\" price_font=\"VAZIR FARSI|800|on||||||\" price_font_size=\"50px\" price_line_height=\"100px\" custom_button=\"on\" button_font=\"VAZIR FARSI||||||||\"]<p>+ سرعت دانلود تا 65 مگابایت</p>\n<p>+ دانلود نامحدود</p>\n<p>+ پشتیبانی شبانه روزی</p>\n<p>+ مودم رایگان</p>\n<p>+ نصب رایگان</p>[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"40px|||\" custom_padding_tablet=\"0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|desktop\" padding_tablet=\"0px||\" padding_last_edited=\"on|desktop\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#ffffff\" price_text_color=\"rgba(0,0,0,0.75)\" body_text_color=\"#ffffff\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"||||||||\" body_text_align=\"center\" subheader_font=\"|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"||on||||||\" price_font_size=\"50px\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(255,255,255,0)\" background_color_gradient_end=\"rgba(255,255,255,0.16)\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" transform_translate_linked__hover=\"off\" animation_style=\"slide\" animation_direction=\"right\" price_letter_spacing_tablet=\"\" price_letter_spacing_phone=\"\" price_letter_spacing_last_edited=\"on|desktop\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" locked=\"off\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate__hover=\"0px|-70px\"][et_pb_pricing_table title=\"اینترنت حرفه ای\" subtitle=\"120 مگابایت\" currency=\"یک ساله \" per=\"هزارتومان\" sum=\"900\" button_url=\"#\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" header_level=\"h2\" header_font=\"||||||||\" body_font=\"VAZIR FARSI||||||||\" subheader_font=\"|800|||||||\" price_font=\"VAZIR FARSI||on||||||\" price_letter_spacing=\"0px\" price_line_height=\"100px\" currency_frequency_font=\"|700|on||||||\" currency_frequency_line_height=\"1em\" excluded_text_color=\"rgba(255,255,255,0.5)\" custom_button=\"on\" button_font=\"VAZIR FARSI||||||||\" pricing_item_excluded_color=\"rgba(255,255,255,0.5)\"]<p>+ گارانتی سرعت</p>\n<p>+ گارنتی کیفیت</p>\n<p>+ نصب در محل</p>\n<p>- تنظیم مودم</p>\n<p>- پشتیبانی 24 ساعته</p>[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Info & Bundles\" _builder_version=\"3.22\" background_color=\"#f2f5fa\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row _builder_version=\"3.25\" custom_margin_tablet=\"40px||40px||true\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" text_orientation=\"center\" max_width=\"700px\" module_alignment=\"center\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>کدام سرویس برای شما مناسب است؟</h2>[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_4,1_4,1_4,1_4\" _builder_version=\"3.25\"][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_circle_counter title=\"عادی\" number=\"60mbps\" percent_sign=\"off\" bar_bg_color=\"rgba(48,52,71,0.51)\" _builder_version=\"4.4.2\" title_level=\"h4\" title_font=\"Poppins|700|on||||||\" title_font_size=\"16px\" title_line_height=\"2em\" number_font=\"|700|on||||||\" number_text_color=\"#000000\" number_font_size=\"28px\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\"][/et_pb_circle_counter][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"rgba(48,52,71,0.51)\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"rgba(48,52,71,0.51)\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"rgba(48,52,71,0.51)\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" locked=\"off\"][/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_circle_counter title=\"بازی آنلاین\" number=\"85mbps\" percent_sign=\"off\" bar_bg_color=\"#303447\" _builder_version=\"4.4.2\" title_level=\"h4\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"2em\" number_font=\"|700|on||||||\" number_text_color=\"#000000\" number_font_size=\"28px\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\" locked=\"off\"][/et_pb_circle_counter][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#000000\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#000000\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#000000\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#000000\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" locked=\"off\"][/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_circle_counter title=\"چند کاربره\" number=\"120mbps\" percent_sign=\"off\" bar_bg_color=\"#008a1c\" _builder_version=\"4.4.2\" title_level=\"h4\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"2em\" number_font=\"|700|on||||||\" number_text_color=\"#000000\" number_font_size=\"28px\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\" locked=\"off\"][/et_pb_circle_counter][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#008a1c\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#008a1c\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#008a1c\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" locked=\"off\"][/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_circle_counter title=\"بهترین برای تجاری ها\" number=\"120mbps\" percent_sign=\"off\" _builder_version=\"4.4.2\" title_level=\"h4\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"2em\" number_font=\"|700|on||||||\" number_text_color=\"#000000\" number_font_size=\"28px\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\" locked=\"off\" background__hover_enabled=\"on|hover\" use_background_color_gradient__hover=\"off\" background_color_gradient_start__hover=\"#a0cf00\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_type__hover=\"radial\"][/et_pb_circle_counter][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" locked=\"off\"][/et_pb_blurb][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_button button_text=\"برای انتخاب بیشتر به راهنمایی نیاز دارید؟  1234-021\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover=\"#7cda24\" button_bg_color__hover_enabled=\"on|hover\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" custom_margin=\"100px||\" custom_margin_tablet=\"0px||\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" text_orientation=\"center\" max_width=\"700px\" module_alignment=\"center\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>با بسته های پیامکی بیشتر درآمد کسب کنید</h2>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد</span>.</p>[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"3_5,2_5\" _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"3_5\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/04/isp-11.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" module_alignment=\"center\" custom_margin=\"|||-7vw\" custom_margin_tablet=\"|||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\"][/et_pb_image][/et_pb_column][et_pb_column type=\"2_5\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"قیمت ارزانتر\" url=\"#\" use_icon=\"on\" font_icon=\"%%155%%\" use_circle=\"on\" circle_color=\"#ffffff\" icon_placement=\"left\" use_icon_font_size=\"on\" icon_font_size=\"22px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" background_color=\"#303447\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"20px|20px|20px|20px|true|true\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" background__hover_enabled=\"on\" background_color__hover=\"#008a1c\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][et_pb_blurb title=\"سازگار با تمام گوشی ها\" url=\"#\" use_icon=\"on\" font_icon=\"%%104%%\" use_circle=\"on\" circle_color=\"#ffffff\" icon_placement=\"left\" use_icon_font_size=\"on\" icon_font_size=\"22px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" background_color=\"#303447\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"20px|20px|20px|20px|true|true\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" background__hover_enabled=\"on\" background_color__hover=\"#008a1c\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][et_pb_blurb title=\"ارسال به شماره های مسدود\" url=\"#\" use_icon=\"on\" font_icon=\"%%70%%\" use_circle=\"on\" circle_color=\"#ffffff\" icon_placement=\"left\" use_icon_font_size=\"on\" icon_font_size=\"22px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" background_color=\"#303447\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"20px|20px|20px|20px|true|true\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" background__hover_enabled=\"on\" background_color__hover=\"#008a1c\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_button button_text=\"بسته پیشنهادی خود را ایجاد کنید 1234-021\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover=\"#7cda24\" button_bg_color__hover_enabled=\"on|hover\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" fullwidth=\"on\" _builder_version=\"4.4.2\"][et_pb_fullwidth_header title=\"سرویس های برتر اینترنتی و پیامکی\" button_one_text=\"021-1234\" _builder_version=\"4.4.2\" text_shadow_style=\"preset3\" title_font=\"VAZIR FARSI||||||||\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/Internet-provider1.png\" parallax=\"on\" parallax_method=\"on\" text_orientation=\"right\" header_fullscreen=\"on\" title_text_color=\"#dadada\" hover_enabled=\"0\" box_shadow_style=\"preset4\" custom_margin=\"50px||||false|false\" border_radii=\"on|50px|50px|50px|50px\"]<p>جهت سفارش سرویس های انبوه و دریافت تخفیفات ویژه با ما در تماس باشید </p>\n[/et_pb_fullwidth_header][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"FAQ\" _builder_version=\"3.22\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" max_width__hover=\"100%\" max_width__hover_enabled=\"100%\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" inner_shadow__hover=\"off\" inner_shadow__hover_enabled=\"off\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_row _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>سوالات متداول</h2>[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_toggle title=\"سوال دلخواه را وارد کنید ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||20px\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>جواب دلخواه این سوال را هم اینجا وارد کنید .</p>[/et_pb_toggle][et_pb_toggle title=\"سوال دلخواه را وارد کنید ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||20px\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>جواب دلخواه این سوال را هم اینجا وارد کنید .</p>[/et_pb_toggle][et_pb_toggle title=\"سوال دلخواه را وارد کنید ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||20px\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>جواب دلخواه این سوال را هم اینجا وارد کنید .</p>[/et_pb_toggle][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_toggle title=\"آیا دانلود شبانه رایگان دارید ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||20px\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>سرویس ها نامحدود هستند و نیازی به شبانه رایگان ندارید </p>[/et_pb_toggle][et_pb_toggle title=\"سوال دلخواه را وارد کنید ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||20px\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>جواب دلخواه این سوال را هم اینجا وارد کنید .</p>[/et_pb_toggle][et_pb_toggle title=\"سوال دلخواه را وارد کنید ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||20px\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>جواب دلخواه این سوال را هم اینجا وارد کنید .</p>[/et_pb_toggle][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_button button_text=\"سوال دیگری دارید پیام بفرستید\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover=\"#7cda24\" button_bg_color__hover_enabled=\"on|hover\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" prev_background_color=\"#ffffff\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#0f1533\" background_color_gradient_end=\"#1f133a\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||5vw\" custom_padding=\"14vw||10vw\" top_divider_style=\"wave2\" top_divider_height=\"10vw\" top_divider_repeat=\"0.7x\" top_divider_flip=\"vertical\" animation_style=\"fade\" border_radii=\"on|30px|30px|30px|30px\" locked=\"off\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_phone=\"\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_2_font=\"|900|on||||||\" header_2_font_size=\"3.5vw\" header_2_letter_spacing=\"2px\" header_2_line_height=\"1.4em\" header_3_font=\"|900|on|on|||||\" header_3_text_color=\"rgba(255,255,255,0.7)\" header_3_font_size=\"1.5vw\" header_3_letter_spacing=\"0.4em\" header_3_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_font_size__hover=\"30px\" header_font_size__hover_enabled=\"30px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h2>سرعت مورد نظر خود را با قیمتی که می خواهید دریافت کنید</h2>\n<h3>سرویس های ADSL  و سرویس های پیامکی</h3>[/et_pb_text][et_pb_button button_text=\"مشاهده تمام سرویس های ما\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#7cda24\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section]", "خدمات", "", "publish", "closed", "closed", "", "servises", "", "", "2020-04-02 17:43:58", "2020-04-02 14:13:58", "", "0", "http://modelsite.test/?page_id=899", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("923", "1", "2020-03-12 15:43:27", "2020-03-12 12:13:27", "http://modelsite.test/wp-content/uploads/2020/03/cropped-theater-icon.png", "cropped-theater-icon.png", "", "inherit", "open", "closed", "", "cropped-theater-icon-png", "", "", "2020-03-12 15:43:27", "2020-03-12 12:13:27", "", "0", "http://modelsite.test/wp-content/uploads/2020/03/cropped-theater-icon.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("951", "1", "2020-03-12 17:05:53", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "closed", "", "", "", "", "2020-03-12 17:05:53", "0000-00-00 00:00:00", "", "0", "http://modelsite.test/?p=951", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("953", "1", "2020-03-12 17:05:54", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "closed", "", "", "", "", "2020-03-12 17:05:54", "0000-00-00 00:00:00", "", "0", "http://modelsite.test/?p=953", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("954", "1", "2020-03-12 17:05:54", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "closed", "", "", "", "", "2020-03-12 17:05:54", "0000-00-00 00:00:00", "", "0", "http://modelsite.test/?p=954", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("955", "1", "2020-03-12 17:09:29", "2020-03-12 13:39:29", " ", "", "", "publish", "closed", "closed", "", "955", "", "", "2020-04-02 17:34:39", "2020-04-02 14:04:39", "", "0", "http://modelsite.test/?p=955", "2", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("958", "1", "2020-03-12 17:05:56", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "closed", "", "", "", "", "2020-03-12 17:05:56", "0000-00-00 00:00:00", "", "0", "http://modelsite.test/?p=958", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("1042", "1", "2020-03-14 12:16:33", "2020-03-14 08:46:33", "http://modelsite.test/wp-content/uploads/2020/03/cropped-Custom-Screen-Printing-logo.png", "cropped-Custom-Screen-Printing-logo.png", "", "inherit", "open", "closed", "", "cropped-custom-screen-printing-logo-png", "", "", "2020-03-14 12:16:33", "2020-03-14 08:46:33", "", "0", "http://modelsite.test/wp-content/uploads/2020/03/cropped-Custom-Screen-Printing-logo.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("1160", "1", "2020-03-14 22:13:39", "2020-03-14 18:43:39", "http://modelsite.test/wp-content/uploads/2020/03/cropped-massage-therapy-icon-02.png", "cropped-massage-therapy-icon-02.png", "", "inherit", "open", "closed", "", "cropped-massage-therapy-icon-02-png", "", "", "2020-03-14 22:13:39", "2020-03-14 18:43:39", "", "0", "http://modelsite.test/wp-content/uploads/2020/03/cropped-massage-therapy-icon-02.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("1285", "1", "2020-03-15 18:18:34", "2020-03-15 14:48:34", "http://modelsite.test/wp-content/uploads/2020/03/cropped-hvac-logo.png", "cropped-hvac-logo.png", "", "inherit", "open", "closed", "", "cropped-hvac-logo-png", "", "", "2020-03-15 18:18:34", "2020-03-15 14:48:34", "", "0", "http://modelsite.test/wp-content/uploads/2020/03/cropped-hvac-logo.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("1475", "1", "2020-03-17 17:48:21", "2020-03-17 14:18:21", "http://modelsite.test/wp-content/uploads/2020/03/cropped-Psychology-logo.png", "cropped-Psychology-logo.png", "", "inherit", "open", "closed", "", "cropped-psychology-logo-png", "", "", "2020-03-17 17:48:21", "2020-03-17 14:18:21", "", "0", "http://modelsite.test/wp-content/uploads/2020/03/cropped-Psychology-logo.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("1519", "1", "2020-03-18 16:59:02", "2020-03-18 13:29:02", "http://modelsite.test/wp-content/uploads/2020/03/cropped-Chiropractics-logo.png", "cropped-Chiropractics-logo.png", "", "inherit", "open", "closed", "", "cropped-chiropractics-logo-png", "", "", "2020-03-18 16:59:02", "2020-03-18 13:29:02", "", "0", "http://modelsite.test/wp-content/uploads/2020/03/cropped-Chiropractics-logo.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("1591", "1", "2020-03-19 22:26:42", "2020-03-19 18:56:42", "http://modelsite.test/wp-content/uploads/2020/03/cropped-Optometry-logo.png", "cropped-Optometry-logo.png", "", "inherit", "open", "closed", "", "cropped-optometry-logo-png", "", "", "2020-03-19 22:26:42", "2020-03-19 18:56:42", "", "0", "http://modelsite.test/wp-content/uploads/2020/03/cropped-Optometry-logo.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("1593", "1", "2020-03-19 22:42:17", "2020-03-19 19:12:17", "http://modelsite.test/wp-content/uploads/2020/03/cropped-Optometry-logo-1.png", "cropped-Optometry-logo-1.png", "", "inherit", "open", "closed", "", "cropped-optometry-logo-1-png", "", "", "2020-03-19 22:42:17", "2020-03-19 19:12:17", "", "0", "http://modelsite.test/wp-content/uploads/2020/03/cropped-Optometry-logo-1.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("1730", "1", "2020-03-20 22:21:18", "2020-03-20 18:51:18", "http://modelsite.test/wp-content/uploads/2020/03/cropped-Dental-logo.png", "cropped-Dental-logo.png", "", "inherit", "open", "closed", "", "cropped-dental-logo-png", "", "", "2020-03-20 22:21:18", "2020-03-20 18:51:18", "", "0", "http://modelsite.test/wp-content/uploads/2020/03/cropped-Dental-logo.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("1928", "1", "2020-03-23 21:15:21", "2020-03-23 17:45:21", "http://modelsite.test/wp-content/uploads/2020/03/cropped-health-icon-14-3.png", "cropped-health-icon-14-3.png", "", "inherit", "open", "closed", "", "cropped-health-icon-14-3-png", "", "", "2020-03-23 21:15:21", "2020-03-23 17:45:21", "", "0", "http://modelsite.test/wp-content/uploads/2020/03/cropped-health-icon-14-3.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("2006", "1", "2020-03-23 22:25:47", "2020-03-23 18:55:47", "http://modelsite.test/wp-content/uploads/2020/03/cropped-green-energy-icon-18-2.png", "cropped-green-energy-icon-18-2.png", "", "inherit", "open", "closed", "", "cropped-green-energy-icon-18-2-png", "", "", "2020-03-23 22:25:47", "2020-03-23 18:55:47", "", "0", "http://modelsite.test/wp-content/uploads/2020/03/cropped-green-energy-icon-18-2.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("2154", "1", "2020-03-25 21:21:43", "2020-03-25 17:51:43", "http://modelsite.test/wp-content/uploads/2020/03/cropped-Icon_13.png", "cropped-Icon_13.png", "", "inherit", "open", "closed", "", "cropped-icon_13-png", "", "", "2020-03-25 21:21:43", "2020-03-25 17:51:43", "", "0", "http://modelsite.test/wp-content/uploads/2020/03/cropped-Icon_13.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("2272", "1", "2020-03-26 22:35:30", "2020-03-26 19:05:30", "http://modelsite.test/wp-content/uploads/2020/03/cropped-Mechanic-logo2.png", "cropped-Mechanic-logo2.png", "", "inherit", "open", "closed", "", "cropped-mechanic-logo2-png", "", "", "2020-03-26 22:35:30", "2020-03-26 19:05:30", "", "0", "http://modelsite.test/wp-content/uploads/2020/03/cropped-Mechanic-logo2.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("2392", "1", "2020-03-28 15:50:03", "2020-03-28 12:20:03", "[et_pb_section fb_built=\"1\" admin_label=\"Header\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-05.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"5vw||||false\" custom_padding=\"6vw||10vw||false|false\" bottom_divider_style=\"wave2\" bottom_divider_color=\"#ffffff\" bottom_divider_height=\"10vw\" bottom_divider_repeat=\"0.7x\" animation_style=\"slide\" animation_direction=\"bottom\" animation_intensity_slide=\"1%\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_phone=\"\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" animation_style=\"slide\" animation_direction=\"left\" animation_intensity_slide=\"10%\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_font=\"|900|on|on|||||\" header_font_size=\"4vw\" header_letter_spacing=\"0.1em\" header_line_height=\"1.2em\" header_2_font=\"|900|on|on|||||\" header_2_text_color=\"rgba(255,255,255,0.7)\" header_2_font_size=\"4vw\" header_2_letter_spacing=\"0em\" header_2_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" hover_enabled=\"0\" header_font_size_tablet=\"50px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|phone\" header_2_font_size_tablet=\"30px\" header_2_font_size_phone=\"20px\" header_2_font_size_last_edited=\"on|phone\" header_text_shadow_style=\"preset1\" header_text_shadow_vertical_length=\"0.3em\" header_text_shadow_blur_strength=\"0.5em\" header_text_shadow_color=\"rgba(0,0,0,0.15)\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h1>65 مگابایت بر ثانیه</h1>\n<p>&nbsp;</p>\n<h2><span style=\"color: rgba(0, 0, 0, 0.7);\">اینترنت پایه</span></h2>\n[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"About\" _builder_version=\"3.22\"][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#a0cf00\" price_text_color=\"rgba(0,0,0,0.75)\" subheader_text_color=\"#000000\" header_text_color=\"#000000\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"Poppins||||||||\" body_text_align=\"center\" subheader_font=\"Poppins|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"Poppins|800|on||||||\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#ffffff\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0f1533\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" custom_margin=\"||\" animation_style=\"zoom\" animation_delay=\"100ms\" hover_enabled=\"0\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" border_color_all=\"#ffffff\" border_width_top=\"40px\" border_width_bottom=\"30px\" box_shadow_style=\"preset6\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" locked=\"off\" filter_hue_rotate__hover_enabled=\"off|desktop\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_scale__hover=\"105%|105%\"][et_pb_pricing_table title=\"اینترنت پایه\" subtitle=\"65mbps\" currency=\"ماهانه\" per=\"هزارتومان\" sum=\"10\" button_text=\"سفارش سرویس\" _builder_version=\"4.4.2\" body_font=\"VAZIR FARSI||||||||\" hover_enabled=\"0\" header_font=\"||||||||\" header_level=\"h2\" subheader_font=\"|800|||||||\" price_font=\"|800|on||||||\" price_line_height=\"100px\" price_text_shadow_style=\"preset3\" currency_frequency_font=\"VAZIR FARSI|700|on||||||\" button_url=\"#\" custom_button=\"on\" button_bg_color=\"#004fe8\" button_bg_enable_color=\"on\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#a0cf00\" button_bg_enable_color__hover=\"on\"]<p>+ 20 گیگابایت ترافیک ماهانه</p>\n<p>+ از ساعت 1 شب تا 7 صبح نیمه بها</p>\n<p>+ جمعه ها ترافیک رایگان </p>\n<p>+ ویژگی دیگر</p>\n<p>+ ویژگی دلخواه</p>\n[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"100px|||\" custom_padding_tablet=\"\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" module_alignment=\"center\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>چرا سرویس 65 مگابیت بر ثانیه رو انتخاب کنم ؟</h2>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span></p>\n[/et_pb_text][et_pb_blurb title=\"عنوان ویژگی خاص\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#000000\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" hover_enabled=\"0\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی خاص\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#000000\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" hover_enabled=\"0\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی خاص\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#000000\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" hover_enabled=\"0\" locked=\"off\"][/et_pb_blurb][et_pb_button button_text=\"برای انتخاب مردد هستید ؟ 1234-021\" button_alignment=\"right\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover=\"#7cda24\" button_bg_color__hover_enabled=\"on|hover\" hover_enabled=\"0\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Details\" _builder_version=\"3.22\"][et_pb_row _builder_version=\"3.25\" custom_margin_tablet=\"40px||40px||true\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"32px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" text_orientation=\"center\" max_width=\"700px\" module_alignment=\"center\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>شامل چه مواردی این سرویس می باشد</h2>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" padding_top_bottom_link_1=\"false\" padding_top_bottom_link_2=\"false\" padding_top_bottom_link_3=\"false\" padding_left_right_link_1=\"true\" padding_left_right_link_2=\"true\" padding_left_right_link_3=\"true\" _builder_version=\"3.25\" max_width=\"1160px\" custom_padding=\"0|0px|27px|0px|false|false\" use_custom_width=\"on\" custom_width_px=\"1160px\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\" max_width__hover=\"1080px\" max_width__hover_enabled=\"1080px\" locked=\"off\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-03.png\" background_size=\"contain\" background_position=\"bottom_right\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"دریافت سرعت واقعی\" use_icon=\"on\" font_icon=\"%%243%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|hover\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"0deg|42deg|0deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"20 درصد تخفیف\" use_icon=\"on\" font_icon=\"%%171%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"0deg|0deg|25deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-04.png\" background_size=\"contain\" background_position=\"top_right\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"بدون محدودیت حجمی\" use_icon=\"on\" font_icon=\"%%231%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"18deg|0deg|0deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است </span></p>[/et_pb_blurb][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" max_width=\"800px\" border_width_bottom=\"2px\" border_color_bottom=\"#f2f5fa\" use_custom_width=\"on\" custom_width_px=\"800px\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"Poppins|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"|700|on||||||\" header_3_line_height=\"1.5em\" max_width=\"700px\" link_option_url=\"#\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" header_3_font_size_tablet=\"\" header_3_font_size_phone=\"26px\" header_3_font_size_last_edited=\"on|desktop\" locked=\"off\" header_3_text_color__hover_enabled=\"on\" header_3_text_color__hover=\"#008a1c\"]<h3>نوع بسته</h3>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_toggle title=\"اینترنت پایه\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||\" custom_padding=\"0px|0px|0px|0px|true|true\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_toggle][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" max_width=\"800px\" border_width_bottom=\"2px\" border_color_bottom=\"#f2f5fa\" use_custom_width=\"on\" custom_width_px=\"800px\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"|700|on||||||\" header_3_line_height=\"1.5em\" max_width=\"700px\" link_option_url=\"#\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" header_3_font_size_tablet=\"\" header_3_font_size_phone=\"26px\" header_3_font_size_last_edited=\"on|desktop\" locked=\"off\" header_3_text_color__hover_enabled=\"on\" header_3_text_color__hover=\"#008a1c\"]<h3>مناسب برای تعداد کاربر</h3>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_toggle title=\"2-4\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||\" custom_padding=\"0px|0px|0px|0px|true|true\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_toggle][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" max_width=\"800px\" border_width_bottom=\"2px\" border_color_bottom=\"#f2f5fa\" use_custom_width=\"on\" custom_width_px=\"800px\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"Poppins|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"|700|on||||||\" header_3_line_height=\"1.5em\" max_width=\"700px\" link_option_url=\"#\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" header_3_font_size_tablet=\"\" header_3_font_size_phone=\"26px\" header_3_font_size_last_edited=\"on|desktop\" locked=\"off\" header_3_text_color__hover_enabled=\"on\" header_3_text_color__hover=\"#008a1c\"]<h3>پهنای دانلود</h3>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_toggle title=\"تا 65 مگابیت بر ثانیه\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||\" custom_padding=\"0px|0px|0px|0px|true|true\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_toggle][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" max_width=\"800px\" border_width_bottom=\"2px\" border_color_bottom=\"#f2f5fa\" use_custom_width=\"on\" custom_width_px=\"800px\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"Poppins|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"|700|on||||||\" header_3_line_height=\"1.5em\" max_width=\"700px\" link_option_url=\"#\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" header_3_font_size_tablet=\"\" header_3_font_size_phone=\"26px\" header_3_font_size_last_edited=\"on|desktop\" locked=\"off\" header_3_text_color__hover_enabled=\"on\" header_3_text_color__hover=\"#008a1c\"]<h3>میزان دانلود</h3>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_toggle title=\"نامحدود\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||\" custom_padding=\"0px|0px|0px|0px|true|true\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_toggle][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" max_width=\"800px\" border_width_bottom=\"2px\" border_color_bottom=\"#f2f5fa\" use_custom_width=\"on\" custom_width_px=\"800px\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"Poppins|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"|700|on||||||\" header_3_line_height=\"1.5em\" max_width=\"700px\" link_option_url=\"#\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" header_3_font_size_tablet=\"\" header_3_font_size_phone=\"26px\" header_3_font_size_last_edited=\"on|desktop\" locked=\"off\" header_3_text_color__hover_enabled=\"on\" header_3_text_color__hover=\"#008a1c\"]<h3>منطقه پوشش</h3>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_toggle title=\"در سراسر کشور\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||\" custom_padding=\"0px|0px|0px|0px|true|true\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_toggle][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" max_width=\"800px\" use_custom_width=\"on\" custom_width_px=\"800px\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"Poppins|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"|700|on||||||\" header_3_line_height=\"1.5em\" link_option_url=\"#\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" header_3_font_size_tablet=\"\" header_3_font_size_phone=\"26px\" header_3_font_size_last_edited=\"on|desktop\" locked=\"off\" header_3_text_color__hover_enabled=\"on\" header_3_text_color__hover=\"#008a1c\"]<h3>اطلاعات اضافی</h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ، و با استفاده از طراحان گرافیک است، چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است، و برای شرایط فعلی تکنولوژی مورد نیاز، و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد، کتابهای زیادی در شصت و سه درصد گذشته حال و آینده، شناخت فراوان جامعه و متخصصان را می طلبد، تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی، و فرهنگ پیشرو در زبان فارسی ایجاد کرد، در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها، و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی، و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد.</span></p>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ، و با استفاده از طراحان گرافیک است، چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است، و برای شرایط فعلی تکنولوژی مورد نیاز، و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد، کتابهای زیادی در شصت و سه درصد گذشته حال و آینده، شناخت فراوان جامعه و متخصصان را می طلبد، تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی، و فرهنگ پیشرو در زبان فارسی ایجاد کرد، در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها، و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی، و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد.</span></p>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ، و با استفاده از طراحان گرافیک است، چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است، و برای شرایط فعلی تکنولوژی مورد نیاز، و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد، کتابهای زیادی در شصت و سه درصد گذشته حال و آینده، شناخت فراوان جامعه و متخصصان را می طلبد، تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی، و فرهنگ پیشرو در زبان فارسی ایجاد کرد، در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها، و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی، و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد.</span></p>\n[/et_pb_text][et_pb_button button_text=\"امروز عضو شوید\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover=\"#7cda24\" button_bg_color__hover_enabled=\"on|hover\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Related Products\" _builder_version=\"3.22\" background_color=\"#f2f5fa\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" border_radii=\"|30px|30px||\" locked=\"off\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\"][et_pb_row _builder_version=\"3.25\" custom_padding=\"||||false|false\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" text_orientation=\"center\" max_width=\"700px\" module_alignment=\"center\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>دیگر سرویس ها</h2>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\" locked=\"off\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"40px|||\" custom_padding_tablet=\"0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px||\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_pricing_tables _builder_version=\"4.4.2\" center_list_items=\"on\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate__hover=\"0px|-70px\" header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" currency_frequency_text_color=\"#a0cf00\" price_text_color=\"rgba(0,0,0,0.75)\" body_text_color=\"#a0cf00\" header_font=\"||||||||\" header_font_size=\"14px\" body_font=\"||||||||\" body_text_align=\"center\" subheader_font=\"|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"||on||||||\" price_font_size=\"50px\" currency_frequency_font=\"|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(255,255,255,0)\" background_color_gradient_end=\"rgba(255,255,255,0.16)\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" animation_style=\"slide\" animation_direction=\"right\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" featured_table_header_background_color=\"#a0cf00\" header_text_color=\"#a0cf00\" subheader_text_color=\"#a0cf00\" price_letter_spacing_last_edited=\"on|desktop\" excluded_text_color=\"#004fe8\" price_line_height=\"100px\" hover_enabled=\"0\"][et_pb_pricing_table title=\"اینترنت پایه\" subtitle=\"1 مگابایت\" currency=\"یک ساله \" per=\"هزارتومان\" sum=\"35\" button_url=\"#\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" hover_enabled=\"0\" pricing_item_excluded_color=\"rgba(255,255,255,0.5)\"]<p>+ گارانتی سرعت</p>\n<p>+ گارنتی کیفیت</p>\n<p>+ نصب در محل</p>\n<p>- تنظیم مودم</p>\n<p>- پشتیبانی 24 ساعته</p>[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#a0cf00\" price_text_color=\"rgba(0,0,0,0.75)\" subheader_text_color=\"#000000\" header_text_color=\"#000000\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"Poppins||||||||\" body_text_align=\"center\" subheader_font=\"Poppins|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"|800|on||||||\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#ffffff\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#008a1c\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" transform_translate_linked__hover=\"off\" custom_margin=\"0px||\" animation_style=\"zoom\" animation_delay=\"100ms\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" border_color_all=\"#ffffff\" border_width_top=\"40px\" border_width_bottom=\"30px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" locked=\"off\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate__hover=\"0px|-70px\"][et_pb_pricing_table title=\"سرویس محبوب\" subtitle=\"65 مگابایت\" currency=\"سالانه\" per=\"هزارتومان\" sum=\"99\" button_url=\"#\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" header_level=\"h2\" header_font=\"||||||||\" body_font=\"VAZIR FARSI||||||||\" subheader_font=\"VAZIR FARSI|800|||||||\" price_font=\"VAZIR FARSI|800|on||||||\" price_font_size=\"50px\" price_line_height=\"100px\" custom_button=\"on\" button_font=\"VAZIR FARSI||||||||\"]<p>+ سرعت دانلود تا 65 مگابایت</p>\n<p>+ دانلود نامحدود</p>\n<p>+ پشتیبانی شبانه روزی</p>\n<p>+ مودم رایگان</p>\n<p>+ نصب رایگان</p>[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"40px|||\" custom_padding_tablet=\"0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|desktop\" padding_tablet=\"0px||\" padding_last_edited=\"on|desktop\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#a0cf00\" price_text_color=\"rgba(0,0,0,0.75)\" body_text_color=\"#a0cf00\" header_font=\"||||||||\" header_font_size=\"14px\" body_font=\"||||||||\" body_text_align=\"center\" subheader_font=\"|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"||on||||||\" price_font_size=\"50px\" currency_frequency_font=\"|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(255,255,255,0)\" background_color_gradient_end=\"rgba(255,255,255,0.16)\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" transform_translate_linked__hover=\"off\" animation_style=\"slide\" animation_direction=\"right\" hover_enabled=\"0\" price_letter_spacing_tablet=\"\" price_letter_spacing_phone=\"\" price_letter_spacing_last_edited=\"on|desktop\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" locked=\"off\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate__hover=\"0px|-70px\" featured_table_header_background_color=\"#a0cf00\" header_text_color=\"#a0cf00\" subheader_text_color=\"#a0cf00\"][et_pb_pricing_table title=\"اینترنت حرفه ای\" subtitle=\"120 مگابایت\" currency=\"یک ساله \" per=\"هزارتومان\" sum=\"900\" button_url=\"#\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" header_level=\"h2\" header_font=\"||||||||\" body_font=\"VAZIR FARSI||||||||\" subheader_font=\"|800|||||||\" price_font=\"VAZIR FARSI||on||||||\" price_letter_spacing=\"0px\" price_line_height=\"100px\" currency_frequency_font=\"|700|on||||||\" currency_frequency_line_height=\"1em\" excluded_text_color=\"#004fe8\" custom_button=\"on\" button_font=\"VAZIR FARSI||||||||\" hover_enabled=\"0\" pricing_item_excluded_color=\"rgba(255,255,255,0.5)\" body_text_color=\"#a0cf00\" bullet_color=\"#a0cf00\"]<p>+ گارانتی سرعت</p>\n<p>+ گارنتی کیفیت</p>\n<p>+ نصب در محل</p>\n<p>- تنظیم مودم</p>\n<p>- پشتیبانی 24 ساعته</p>[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" prev_background_color=\"#ffffff\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#0f1533\" background_color_gradient_end=\"#1f133a\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||5vw\" custom_padding=\"14vw||10vw\" top_divider_style=\"wave2\" top_divider_height=\"10vw\" top_divider_repeat=\"0.7x\" top_divider_flip=\"vertical\" animation_style=\"fade\" border_radii=\"on|30px|30px|30px|30px\" locked=\"off\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_phone=\"\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_2_font=\"|900|on||||||\" header_2_font_size=\"3.5vw\" header_2_letter_spacing=\"2px\" header_2_line_height=\"1.4em\" header_3_font=\"|900|on|on|||||\" header_3_text_color=\"rgba(255,255,255,0.7)\" header_3_font_size=\"1.5vw\" header_3_letter_spacing=\"0.4em\" header_3_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_font_size__hover=\"30px\" header_font_size__hover_enabled=\"30px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h2>سرعت مورد نظر خود را با قیمتی که می خواهید دریافت کنید</h2>\n<h3>سرویس های ADSL  و سرویس های پیامکی</h3>[/et_pb_text][et_pb_button button_text=\"مشاهده تمام سرویس های ما\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#7cda24\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section]", "تک سرویس", "", "publish", "closed", "closed", "", "servise", "", "", "2020-04-02 17:33:10", "2020-04-02 14:03:10", "", "0", "http://modelsite.test/?page_id=2392", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("2447", "1", "2020-03-28 17:54:59", "2020-03-28 14:24:59", "http://modelsite.test/wp-content/uploads/2020/03/cropped-Jaa-individua.png", "cropped-Jaa-individua.png", "", "inherit", "open", "closed", "", "cropped-jaa-individua-png", "", "", "2020-03-28 17:54:59", "2020-03-28 14:24:59", "", "0", "http://modelsite.test/wp-content/uploads/2020/03/cropped-Jaa-individua.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("2449", "1", "2020-03-28 17:56:36", "2020-03-28 14:26:36", " ", "", "", "publish", "closed", "closed", "", "2449", "", "", "2020-04-02 17:34:39", "2020-04-02 14:04:39", "", "0", "http://modelsite.test/?p=2449", "3", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("2577", "1", "2020-03-29 17:27:56", "2020-03-29 13:57:56", "http://modelsite.test/wp-content/uploads/2020/03/cropped-farmer-icon-23.png", "cropped-farmer-icon-23.png", "", "inherit", "open", "closed", "", "cropped-farmer-icon-23-png", "", "", "2020-03-29 17:27:56", "2020-03-29 13:57:56", "", "0", "http://modelsite.test/wp-content/uploads/2020/03/cropped-farmer-icon-23.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("2578", "1", "2020-03-29 17:28:11", "2020-03-29 13:58:11", "http://modelsite.test/wp-content/uploads/2020/03/cropped-farmer-icon-23-3.png", "cropped-farmer-icon-23-3.png", "", "inherit", "open", "closed", "", "cropped-farmer-icon-23-3-png", "", "", "2020-03-29 17:28:11", "2020-03-29 13:58:11", "", "0", "http://modelsite.test/wp-content/uploads/2020/03/cropped-farmer-icon-23-3.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("2579", "1", "2020-03-29 17:28:23", "2020-03-29 13:58:23", "http://modelsite.test/wp-content/uploads/2020/03/cropped-farmer-icon-23-1.png", "cropped-farmer-icon-23-1.png", "", "inherit", "open", "closed", "", "cropped-farmer-icon-23-1-png", "", "", "2020-03-29 17:28:23", "2020-03-29 13:58:23", "", "0", "http://modelsite.test/wp-content/uploads/2020/03/cropped-farmer-icon-23-1.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("2691", "1", "2020-03-30 15:47:46", "2020-03-30 12:17:46", "http://modelsite.test/wp-content/uploads/2020/03/cropped-painting_illustration_04.png", "cropped-painting_illustration_04.png", "", "inherit", "open", "closed", "", "cropped-painting_illustration_04-png", "", "", "2020-03-30 15:47:46", "2020-03-30 12:17:46", "", "0", "http://modelsite.test/wp-content/uploads/2020/03/cropped-painting_illustration_04.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("2758", "1", "2020-03-30 20:10:17", "2020-03-30 16:40:17", "", "Divi-Child-Theme-master", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2020-03-30 20:10:17", "2020-03-30 16:40:17", "", "5", "http://modelsite.test/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2759", "1", "2020-03-30 20:10:49", "2020-03-30 16:40:49", "[]", "", "", "trash", "closed", "closed", "", "04658e29-f44d-47df-841c-bedc08adee01", "", "", "2020-03-30 20:10:49", "2020-03-30 16:40:49", "", "0", "http://modelsite.test/04658e29-f44d-47df-841c-bedc08adee01/", "0", "customize_changeset", "", "0");
INSERT INTO `wp_posts` VALUES("2760", "1", "2020-03-31 11:16:42", "0000-00-00 00:00:00", "", "پیش‌نویس خودکار", "", "auto-draft", "open", "open", "", "", "", "", "2020-03-31 11:16:42", "0000-00-00 00:00:00", "", "0", "http://modelsite.test/?p=2760", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("2784", "1", "2020-03-31 11:27:32", "2020-03-31 07:57:32", "[et_pb_section fb_built=\"1\" use_custom_gutter=\"on\" gutter_width=\"1\" admin_label=\"Header\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#f7f9fc\" background_color_gradient_start_position=\"75%\" background_color_gradient_end_position=\"75%\" custom_padding=\"0|0px|0|0px|false|false\"][et_pb_row use_custom_gutter=\"on\" gutter_width=\"1\" make_equal=\"on\" padding_top_bottom_link_1=\"true\" _builder_version=\"3.25\" custom_padding=\"0|0px|0|0px|false|false\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" column_structure=\"1_2,1_2\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"8vw|60px|8vw|\" custom_padding_tablet=\"|0px||\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"|0px||\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"Cormorant Garamond|600|||||||\" header_font_size=\"60px\" header_line_height=\"1.4em\" header_2_font=\"Cormorant Garamond|600|||||||\" header_2_text_color=\"#dfab82\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" custom_margin=\"||40px\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\"]<h1>Suit Yourself</h1>\r\n<h2>Custom Suits &amp; Alterations</h2>\r\n<p>Sed porttitor lectus nibh. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus. Quisque velit nisi, pretium ut lacinia in, elementum id enim. Pellentesque in ipsum id orci porta dapibus. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubi</p>[/et_pb_text][et_pb_button button_text=\"Make an Appointment Online\" _builder_version=\"3.17.6\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#41547d\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"Muli|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(65,84,125,0.24)\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][et_pb_button button_text=\"Or Call: (235) 133-2511\" _builder_version=\"3.17.6\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#41547d\" button_bg_color=\"#ffffff\" button_border_width=\"0px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"Muli|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"1\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(65,84,125,0.06)\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-02.jpg\" parallax=\"on\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider show_divider=\"off\" disabled_on=\"off|off|on\" _builder_version=\"3.17.6\" height=\"250px\"][/et_pb_divider][/et_pb_column][/et_pb_row][et_pb_row use_custom_gutter=\"on\" gutter_width=\"1\" padding_top_bottom_link_2=\"false\" _builder_version=\"3.25\" custom_padding=\"0|0px|27px|0px|false|false\" column_structure=\"1_2,1_2\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_video src=\"https://www.youtube.com/watch?v=FkQuawiGWUw\" image_src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-03.jpg\" _builder_version=\"3.17.6\" custom_margin=\"|||-80px\" custom_margin_tablet=\"|||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\"][/et_pb_video][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"100px|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-04.jpg\" align_tablet=\"center\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" max_width=\"80%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" box_shadow_style=\"preset1\" box_shadow_horizontal=\"-41px\" box_shadow_vertical=\"45px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(0,0,0,0.52)\" locked=\"off\"][/et_pb_image][et_pb_text _builder_version=\"3.27.4\" text_font=\"Cormorant Garamond|600|||||||\" text_font_size=\"24px\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_2_font=\"||||||||\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" background_color=\"#dfab82\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-01.png\" background_position=\"bottom_right\" background_layout=\"dark\" custom_margin=\"|||0%\" custom_padding=\"50px|60px|50px|60px|true|true\" animation_direction=\"left\" link_option_url=\"#\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\" custom_padding__hover_enabled=\"on\" custom_padding__hover=\"|40px||80px||false\" background__hover_enabled=\"on\" background_color__hover=\"#ddb494\"]View Gallery\r[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"left\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" admin_label=\"Services\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" header_font=\"Cormorant Garamond||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"Cormorant Garamond|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>Get A Custom, Bespoke Suite Made By The Experts</h2>[/et_pb_text][et_pb_button button_text=\"Make an Appointment\" _builder_version=\"3.17.6\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"Muli|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_row_inner _builder_version=\"3.25\" column_structure=\"1_2,1_2\"][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-03.png\" _builder_version=\"3.23\" always_center_on_mobile=\"off\" locked=\"off\"][/et_pb_image][et_pb_blurb title=\"Lorem Ipsum Dolor\" content_max_width=\"1100px\" _builder_version=\"3.17.6\" header_font=\"Muli|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" locked=\"off\"]<p>Proin eget tortor risus. Donec sollicitudin molestie malesuada. Donec rutrum congue leo eget malesuada. . </p>[/et_pb_blurb][/et_pb_column_inner][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-12.png\" _builder_version=\"3.23\" always_center_on_mobile=\"off\" locked=\"off\"][/et_pb_image][et_pb_blurb title=\"Donec Rutrum Congue\" content_max_width=\"1100px\" _builder_version=\"3.17.6\" header_font=\"Muli|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" locked=\"off\"]<p>Proin eget tortor risus. Donec sollicitudin molestie malesuada. Donec rutrum congue leo eget malesuada. </p>[/et_pb_blurb][/et_pb_column_inner][/et_pb_row_inner][et_pb_row_inner _builder_version=\"3.25\" border_width_bottom=\"2px\" border_color_bottom=\"rgba(0,0,0,0.12)\" border_style_bottom=\"dashed\" column_structure=\"1_2,1_2\"][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-02.png\" _builder_version=\"3.23\" always_center_on_mobile=\"off\" locked=\"off\"][/et_pb_image][et_pb_blurb title=\"Congue Leo Malesuada \" content_max_width=\"1100px\" _builder_version=\"3.17.6\" header_font=\"Muli|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" locked=\"off\"]<p>Proin eget tortor risus. Donec sollicitudin molestie malesuada. Donec rutrum congue leo eget malesuada. us. </p>[/et_pb_blurb][/et_pb_column_inner][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-01.png\" _builder_version=\"3.23\" always_center_on_mobile=\"off\" locked=\"off\"][/et_pb_image][et_pb_blurb title=\"Proin Eget Tortor\" content_max_width=\"1100px\" _builder_version=\"3.17.6\" header_font=\"Muli|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" locked=\"off\"]<p>Proin eget tortor risus. Donec sollicitudin molestie malesuada. Donec rutrum congue leo eget malesuada. </p>[/et_pb_blurb][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonial\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_row _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-05.jpg\" custom_padding=\"0|0px|12vw|0px|false|false\" column_structure=\"1_2,1_2\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_testimonial quote_icon=\"off\" _builder_version=\"3.17.6\" body_font=\"Cormorant Garamond|600|on||||||\" body_font_size=\"22px\" body_line_height=\"2.5em\" background_color=\"#41547d\" background_layout=\"dark\" custom_margin=\"-12vw|||-10vw\" custom_margin_tablet=\"0vw||10vw|0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" custom_padding=\"80px|60px|80px|7vw|true|false\" custom_padding_tablet=\"40px|10%|40px|10%|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" animation_style=\"flip\" body_font_size_tablet=\"18px\" body_font_size_phone=\"\" body_font_size_last_edited=\"on|desktop\" body_line_height_tablet=\"\" body_line_height_phone=\"1.8em\" body_line_height_last_edited=\"on|phone\" box_shadow_style=\"preset1\" box_shadow_horizontal=\"-41px\" box_shadow_vertical=\"45px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(0,0,0,0.52)\" locked=\"off\"]<p>\"Proin eget tortor risus. Nulla porttitor accumsan tincidunt. Vestibulum ac diam sit amet quam vehicula elementum sed sit amet dui. Mauris blandit aliquet elit, eget tincidunt nibh pulvinar a. Donec sollicitudin molestie malesuada. Proin eget tortor risus. Sed porttitor lectus nibh. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque velit nisi\"</p>[/et_pb_testimonial][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" column_structure=\"1_6,1_6,1_6,1_6,1_6,1_6\"][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_08-1.png\" align_tablet=\"center\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_07-1.png\" align_tablet=\"center\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_06-1.png\" align_tablet=\"center\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_05-2.png\" align_tablet=\"center\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_03-2.png\" align_tablet=\"center\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_01-2.png\" align_tablet=\"center\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Feature\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_row _builder_version=\"3.25\" column_structure=\"1_2,1_2\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" header_font=\"Cormorant Garamond||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"Cormorant Garamond|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>Your Suit Begins With The Best Materials </h2>[/et_pb_text][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" locked=\"off\"]<p>Sed porttitor lectus nibh. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus. Quisque velit nisi, pretium ut lacinia in, elementum id enim. Pellentesque in ipsum id orci porta dapibus. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Donec velit neque, auctor sit amet aliquam vel, ullamcorper sit amet lig</p>[/et_pb_text][et_pb_button button_text=\"Learn More\" _builder_version=\"3.17.6\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"Muli|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-06.jpg\" align_tablet=\"center\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\"][/et_pb_image][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-07.jpg\" align_tablet=\"center\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" max_width=\"70%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" border_color_all=\"#ffffff\" border_width_right=\"20px\" border_width_bottom=\"20px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][/et_pb_image][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"right\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Services\" _builder_version=\"3.22\" background_color=\"#f7f9fc\" custom_margin=\"|||\" custom_padding=\"0|0px|80px|0px|false|false\"][et_pb_row custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#ffffff\" width=\"90%\" max_width=\"90%\" module_alignment=\"left\" custom_margin=\"|||\" custom_padding=\"60px|||15vw|false|false\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"120px\" box_shadow_color=\"rgba(96,104,121,0.12)\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"90%\" column_structure=\"1_2,1_2\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" header_font=\"Cormorant Garamond||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"Cormorant Garamond|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" max_width=\"600px\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>Tailoring &amp; Alterations</h2>[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][et_pb_row custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#ffffff\" width=\"90%\" max_width=\"90%\" module_alignment=\"left\" custom_margin=\"|||\" custom_padding=\"||120px|15vw|false|false\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"120px\" box_shadow_color=\"rgba(96,104,121,0.12)\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"90%\" column_structure=\"1_4,1_4,1_2\"][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-04.png\" _builder_version=\"3.23\" always_center_on_mobile=\"off\" locked=\"off\"][/et_pb_image][et_pb_blurb title=\"Tailoring Services\" content_max_width=\"1100px\" _builder_version=\"3.17.6\" header_font=\"Muli|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" locked=\"off\"]<p>Proin eget tortor risus. Donec sollicitudin molestie malesuada. Donec rutrum congue leo eget malesuada. Proin eget tortor.</p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-05.png\" _builder_version=\"3.23\" always_center_on_mobile=\"off\" locked=\"off\"][/et_pb_image][et_pb_blurb title=\"Alteration Services\" content_max_width=\"1100px\" _builder_version=\"3.17.6\" header_font=\"Muli|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" locked=\"off\"]<p>Proin eget tortor risus. Donec sollicitudin molestie malesuada. Donec rutrum congue leo eget malesuada. Proin eget tortor </p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"Muli|700|||||||\" text_font_size=\"18px\" text_line_height=\"2em\" background_color=\"#41547d\" background_layout=\"dark\" custom_margin=\"-14vw|-10vw||10vw\" custom_margin_tablet=\"0vw|0vw||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" custom_padding=\"80px|60px|80px|60px|true|true\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|phone\" animation_style=\"flip\" text_font_size_tablet=\"\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\" locked=\"off\"]<p>01. Shorten/lengthen hems</p>\n<p>02. Cuffs</p>\n<p>03. Linings</p>\n<p>04. Splitting the waist</p>\n<p>05. Lengthen/shorten sleeves</p>\n<p>06. Re-sew button/clasp</p>\n<p>07. Zipper replacement</p>[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" module_alignment=\"left\" custom_margin=\"-40px||\" custom_padding=\"0|0px|0|0px|false|false\" column_structure=\"1_2,1_2\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"Cormorant Garamond|600|||||||\" text_font_size=\"24px\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_2_font=\"||||||||\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" background_color=\"#dfab82\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-01.png\" background_position=\"bottom_right\" background_layout=\"dark\" custom_padding=\"50px|60px|50px|60px|true|true\" animation_style=\"flip\" link_option_url=\"#\" locked=\"off\" custom_padding__hover_enabled=\"on\" custom_padding__hover=\"|40px||80px||false\" background__hover_enabled=\"on\" background_color__hover=\"#ddb494\"]<p>View All Services</p>[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Gallery\" _builder_version=\"3.22\" background_color=\"#f7f9fc\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#f7f9fc\" background_color_gradient_end=\"#ffffff\"][et_pb_row _builder_version=\"3.25\" column_structure=\"1_4,1_4,1_2\"][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-08.jpg\" align_tablet=\"center\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"|||-10vw\" custom_margin_tablet=\"|||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|phone\" locked=\"off\"][/et_pb_image][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/crypto_image_03.jpg\" align_tablet=\"center\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" border_color_all=\"#ffffff\" border_width_bottom=\"20px\" border_width_left=\"20px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-10.jpg\" align_tablet=\"center\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"6vw||\" custom_margin_tablet=\"\" custom_margin_phone=\"0vw||\" custom_margin_last_edited=\"on|desktop\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" header_font=\"Cormorant Garamond||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"Cormorant Garamond|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>Some of Our Latest Work</h2>[/et_pb_text][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" locked=\"off\"]<p>Sed porttitor lectus nibh. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus. Quisque velit nisi, pretium ut lacinia in, elementum id enim. Pellentesque in ipsum id orci porta dapibus. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Donec velit neque, auctor sit amet aliquam vel, ullamcorper sit amet lig</p>[/et_pb_text][et_pb_button button_text=\"View Gallery\" _builder_version=\"3.17.6\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"Muli|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"left\" custom_padding=\"27px|0px|0|0px|false|false\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\" locked=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonials\" _builder_version=\"3.22\" background_color=\"#ffffff\" custom_padding=\"0|0px|54px|0px|false|false\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_slider _builder_version=\"3.17.6\" body_font=\"Cormorant Garamond|600|on||||||\" body_font_size=\"26px\" body_line_height=\"1.8em\" background_color=\"#dfab82\" animation_style=\"flip\" body_font_size_tablet=\"20px\" body_font_size_phone=\"18px\" body_font_size_last_edited=\"on|phone\" box_shadow_style=\"preset1\" box_shadow_vertical=\"50px\" box_shadow_blur=\"60px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_slide _builder_version=\"3.17.6\"]<p>\"Quisque velit nisi, pretium ut lacinia in, elementum id enim. Mauris blandit aliquet elit, eget tincidunt nibh pulvinar a. Nulla quis lorem ut libero malesuada feugiat. Donec sollicitudin molestie malesuada. Donec sollicitudin molestie malesuada. Donec rutrum congue leo eget malesuada. Quisque velit nisi, pretium ut lacinia\"</p>[/et_pb_slide][et_pb_slide _builder_version=\"3.17.6\"]<p>\"Quisque velit nisi, pretium ut lacinia in, elementum id enim. Mauris blandit aliquet elit, eget tincidunt nibh pulvinar a. Nulla quis lorem ut libero malesuada feugiat. Donec sollicitudin molestie malesuada. Donec sollicitudin molestie malesuada. Donec rutrum congue leo eget malesuada. Quisque velit nisi, pretium ut lacinia\"</p>[/et_pb_slide][et_pb_slide _builder_version=\"3.17.6\"]<p>\"Quisque velit nisi, pretium ut lacinia in, elementum id enim. Mauris blandit aliquet elit, eget tincidunt nibh pulvinar a. Nulla quis lorem ut libero malesuada feugiat. Donec sollicitudin molestie malesuada. Donec sollicitudin molestie malesuada. Donec rutrum congue leo eget malesuada. Quisque velit nisi, pretium ut lacinia\"</p>[/et_pb_slide][et_pb_slide _builder_version=\"3.17.6\"]<p>\"Quisque velit nisi, pretium ut lacinia in, elementum id enim. Mauris blandit aliquet elit, eget tincidunt nibh pulvinar a. Nulla quis lorem ut libero malesuada feugiat. Donec sollicitudin molestie malesuada. Donec sollicitudin molestie malesuada. Donec rutrum congue leo eget malesuada. Quisque velit nisi, pretium ut lacinia\"</p>[/et_pb_slide][/et_pb_slider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#f1f6ff\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" header_font=\"Cormorant Garamond||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"Cormorant Garamond|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>Get In Touch!</h2>[/et_pb_text][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" locked=\"off\"]<p>Sed porttitor lectus nibh. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus. Quisque velit nisi, pretium ut lacinia in, elementum id enim. Pellentesque in ipsum id orci porta dapibus.</p>[/et_pb_text][et_pb_blurb title=\"Visit Our Shop\" use_icon=\"on\" font_icon=\"%%249%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"3.17.6\" header_font=\"Muli|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\"]<p>1234 Divi St. San Francisco, CA 19351</p>[/et_pb_blurb][et_pb_blurb title=\"Call Us\" use_icon=\"on\" font_icon=\"%%264%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"3.17.6\" header_font=\"Muli|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\"]<p>(235) 235-1351</p>[/et_pb_blurb][et_pb_blurb title=\"Email Us\" use_icon=\"on\" font_icon=\"%%238%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"3.17.6\" header_font=\"Muli|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\"]<p>info@divisuits.com</p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_row_inner _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"60px|0px|60px|0px|true|false\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_column_inner saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_contact_form captcha=\"off\" module_id=\"et_pb_contact_form_0\" _builder_version=\"3.23\" form_field_background_color=\"#f5f9ff\" form_field_font=\"Muli||||||||\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#41547d\" button_border_width=\"10px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"Muli|800||on|||||\" custom_padding=\"|40px||40px||true\" form_background_color=\"#f5f9ff\"][et_pb_contact_field field_id=\"Name\" field_title=\"Name\" fullwidth_field=\"on\" _builder_version=\"3.17.6\" custom_margin=\"||20px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Email\" field_title=\"Email Address\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"3.17.6\" custom_margin=\"||20px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Phone\" field_title=\"Phone Number\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"3.17.6\" custom_margin=\"||20px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Message\" field_title=\"Message\" field_type=\"text\" fullwidth_field=\"on\" _builder_version=\"3.17.6\" custom_margin=\"||30px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][/et_pb_contact_form][/et_pb_column_inner][/et_pb_row_inner][et_pb_row_inner _builder_version=\"3.25\"][et_pb_column_inner saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_social_media_follow _builder_version=\"3.17.6\" text_orientation=\"center\" border_radii=\"on|0px|0px|0px|0px\"][et_pb_social_media_follow_network social_network=\"instagram\" _builder_version=\"3.17.6\" background_color=\"#dfab82\" custom_margin=\"|6px||6px||true\" custom_padding=\"8px|8px|8px|8px|true|true\" follow_button=\"off\" url_new_window=\"on\"]instagram[/et_pb_social_media_follow_network][et_pb_social_media_follow_network social_network=\"facebook\" _builder_version=\"3.17.6\" background_color=\"#dfab82\" custom_margin=\"|6px||6px||true\" custom_padding=\"8px|8px|8px|8px|true|true\" follow_button=\"off\" url_new_window=\"on\"]facebook[/et_pb_social_media_follow_network][et_pb_social_media_follow_network social_network=\"twitter\" _builder_version=\"3.17.6\" background_color=\"#dfab82\" custom_margin=\"|6px||6px||true\" custom_padding=\"8px|8px|8px|8px|true|true\" follow_button=\"off\" url_new_window=\"on\"]twitter[/et_pb_social_media_follow_network][/et_pb_social_media_follow][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section]", "خانه", "", "inherit", "closed", "closed", "", "2-revision-v1", "", "", "2020-03-31 11:27:32", "2020-03-31 07:57:32", "", "2", "http://modelsite.test/2-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2786", "1", "2020-03-31 11:35:07", "2020-03-31 08:05:07", "[et_pb_section fb_built=\"1\" use_custom_gutter=\"on\" gutter_width=\"1\" admin_label=\"Header\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#f7f9fc\" background_color_gradient_start_position=\"75%\" background_color_gradient_end_position=\"75%\" custom_padding=\"0|0px|0|0px|false|false\"][et_pb_row use_custom_gutter=\"on\" gutter_width=\"1\" make_equal=\"on\" padding_top_bottom_link_1=\"true\" _builder_version=\"3.25\" custom_padding=\"0|0px|0|0px|false|false\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" column_structure=\"1_2,1_2\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"8vw|60px|8vw|\" custom_padding_tablet=\"|0px||\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"|0px||\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"Cormorant Garamond|600|||||||\" header_font_size=\"60px\" header_line_height=\"1.4em\" header_2_font=\"Cormorant Garamond|600|||||||\" header_2_text_color=\"#dfab82\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" custom_margin=\"||40px\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\"]<h1>Suit Yourself</h1>\r\n<h2>Custom Suits &amp; Alterations</h2>\r\n<p>Sed porttitor lectus nibh. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus. Quisque velit nisi, pretium ut lacinia in, elementum id enim. Pellentesque in ipsum id orci porta dapibus. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubi</p>[/et_pb_text][et_pb_button button_text=\"Make an Appointment Online\" _builder_version=\"3.17.6\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#41547d\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"Muli|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(65,84,125,0.24)\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][et_pb_button button_text=\"Or Call: (235) 133-2511\" _builder_version=\"3.17.6\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#41547d\" button_bg_color=\"#ffffff\" button_border_width=\"0px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"Muli|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"1\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(65,84,125,0.06)\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-02.jpg\" parallax=\"on\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider show_divider=\"off\" disabled_on=\"off|off|on\" _builder_version=\"3.17.6\" height=\"250px\"][/et_pb_divider][/et_pb_column][/et_pb_row][et_pb_row use_custom_gutter=\"on\" gutter_width=\"1\" padding_top_bottom_link_2=\"false\" _builder_version=\"3.25\" custom_padding=\"0|0px|27px|0px|false|false\" column_structure=\"1_2,1_2\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_video src=\"https://www.youtube.com/watch?v=FkQuawiGWUw\" image_src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-03.jpg\" _builder_version=\"3.17.6\" custom_margin=\"|||-80px\" custom_margin_tablet=\"|||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\"][/et_pb_video][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"100px|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-04.jpg\" align_tablet=\"center\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" max_width=\"80%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" box_shadow_style=\"preset1\" box_shadow_horizontal=\"-41px\" box_shadow_vertical=\"45px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(0,0,0,0.52)\" locked=\"off\"][/et_pb_image][et_pb_text _builder_version=\"3.27.4\" text_font=\"Cormorant Garamond|600|||||||\" text_font_size=\"24px\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_2_font=\"||||||||\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" background_color=\"#dfab82\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-01.png\" background_position=\"bottom_right\" background_layout=\"dark\" custom_margin=\"|||0%\" custom_padding=\"50px|60px|50px|60px|true|true\" animation_direction=\"left\" link_option_url=\"#\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\" custom_padding__hover_enabled=\"on\" custom_padding__hover=\"|40px||80px||false\" background__hover_enabled=\"on\" background_color__hover=\"#ddb494\"]View Gallery\r[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"left\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" admin_label=\"Services\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" header_font=\"Cormorant Garamond||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"Cormorant Garamond|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>Get A Custom, Bespoke Suite Made By The Experts</h2>[/et_pb_text][et_pb_button button_text=\"Make an Appointment\" _builder_version=\"3.17.6\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"Muli|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_row_inner _builder_version=\"3.25\" column_structure=\"1_2,1_2\"][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-03.png\" _builder_version=\"3.23\" always_center_on_mobile=\"off\" locked=\"off\"][/et_pb_image][et_pb_blurb title=\"Lorem Ipsum Dolor\" content_max_width=\"1100px\" _builder_version=\"3.17.6\" header_font=\"Muli|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" locked=\"off\"]<p>Proin eget tortor risus. Donec sollicitudin molestie malesuada. Donec rutrum congue leo eget malesuada. . </p>[/et_pb_blurb][/et_pb_column_inner][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-12.png\" _builder_version=\"3.23\" always_center_on_mobile=\"off\" locked=\"off\"][/et_pb_image][et_pb_blurb title=\"Donec Rutrum Congue\" content_max_width=\"1100px\" _builder_version=\"3.17.6\" header_font=\"Muli|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" locked=\"off\"]<p>Proin eget tortor risus. Donec sollicitudin molestie malesuada. Donec rutrum congue leo eget malesuada. </p>[/et_pb_blurb][/et_pb_column_inner][/et_pb_row_inner][et_pb_row_inner _builder_version=\"3.25\" border_width_bottom=\"2px\" border_color_bottom=\"rgba(0,0,0,0.12)\" border_style_bottom=\"dashed\" column_structure=\"1_2,1_2\"][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-02.png\" _builder_version=\"3.23\" always_center_on_mobile=\"off\" locked=\"off\"][/et_pb_image][et_pb_blurb title=\"Congue Leo Malesuada \" content_max_width=\"1100px\" _builder_version=\"3.17.6\" header_font=\"Muli|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" locked=\"off\"]<p>Proin eget tortor risus. Donec sollicitudin molestie malesuada. Donec rutrum congue leo eget malesuada. us. </p>[/et_pb_blurb][/et_pb_column_inner][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-01.png\" _builder_version=\"3.23\" always_center_on_mobile=\"off\" locked=\"off\"][/et_pb_image][et_pb_blurb title=\"Proin Eget Tortor\" content_max_width=\"1100px\" _builder_version=\"3.17.6\" header_font=\"Muli|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" locked=\"off\"]<p>Proin eget tortor risus. Donec sollicitudin molestie malesuada. Donec rutrum congue leo eget malesuada. </p>[/et_pb_blurb][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonial\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_row _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-05.jpg\" custom_padding=\"0|0px|12vw|0px|false|false\" column_structure=\"1_2,1_2\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_testimonial quote_icon=\"off\" _builder_version=\"3.17.6\" body_font=\"Cormorant Garamond|600|on||||||\" body_font_size=\"22px\" body_line_height=\"2.5em\" background_color=\"#41547d\" background_layout=\"dark\" custom_margin=\"-12vw|||-10vw\" custom_margin_tablet=\"0vw||10vw|0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" custom_padding=\"80px|60px|80px|7vw|true|false\" custom_padding_tablet=\"40px|10%|40px|10%|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" animation_style=\"flip\" body_font_size_tablet=\"18px\" body_font_size_phone=\"\" body_font_size_last_edited=\"on|desktop\" body_line_height_tablet=\"\" body_line_height_phone=\"1.8em\" body_line_height_last_edited=\"on|phone\" box_shadow_style=\"preset1\" box_shadow_horizontal=\"-41px\" box_shadow_vertical=\"45px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(0,0,0,0.52)\" locked=\"off\"]<p>\"Proin eget tortor risus. Nulla porttitor accumsan tincidunt. Vestibulum ac diam sit amet quam vehicula elementum sed sit amet dui. Mauris blandit aliquet elit, eget tincidunt nibh pulvinar a. Donec sollicitudin molestie malesuada. Proin eget tortor risus. Sed porttitor lectus nibh. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque velit nisi\"</p>[/et_pb_testimonial][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" column_structure=\"1_6,1_6,1_6,1_6,1_6,1_6\"][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_08-1.png\" align_tablet=\"center\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_07-1.png\" align_tablet=\"center\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_06-1.png\" align_tablet=\"center\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_05-2.png\" align_tablet=\"center\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_03-2.png\" align_tablet=\"center\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_01-2.png\" align_tablet=\"center\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Feature\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_row _builder_version=\"3.25\" column_structure=\"1_2,1_2\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" header_font=\"Cormorant Garamond||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"Cormorant Garamond|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>Your Suit Begins With The Best Materials </h2>[/et_pb_text][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" locked=\"off\"]<p>Sed porttitor lectus nibh. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus. Quisque velit nisi, pretium ut lacinia in, elementum id enim. Pellentesque in ipsum id orci porta dapibus. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Donec velit neque, auctor sit amet aliquam vel, ullamcorper sit amet lig</p>[/et_pb_text][et_pb_button button_text=\"Learn More\" _builder_version=\"3.17.6\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"Muli|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-06.jpg\" align_tablet=\"center\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\"][/et_pb_image][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-07.jpg\" align_tablet=\"center\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" max_width=\"70%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" border_color_all=\"#ffffff\" border_width_right=\"20px\" border_width_bottom=\"20px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][/et_pb_image][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"right\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Services\" _builder_version=\"3.22\" background_color=\"#f7f9fc\" custom_margin=\"|||\" custom_padding=\"0|0px|80px|0px|false|false\"][et_pb_row custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#ffffff\" width=\"90%\" max_width=\"90%\" module_alignment=\"left\" custom_margin=\"|||\" custom_padding=\"60px|||15vw|false|false\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"120px\" box_shadow_color=\"rgba(96,104,121,0.12)\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"90%\" column_structure=\"1_2,1_2\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" header_font=\"Cormorant Garamond||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"Cormorant Garamond|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" max_width=\"600px\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>Tailoring &amp; Alterations</h2>[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][et_pb_row custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#ffffff\" width=\"90%\" max_width=\"90%\" module_alignment=\"left\" custom_margin=\"|||\" custom_padding=\"||120px|15vw|false|false\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"120px\" box_shadow_color=\"rgba(96,104,121,0.12)\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"90%\" column_structure=\"1_4,1_4,1_2\"][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-04.png\" _builder_version=\"3.23\" always_center_on_mobile=\"off\" locked=\"off\"][/et_pb_image][et_pb_blurb title=\"Tailoring Services\" content_max_width=\"1100px\" _builder_version=\"3.17.6\" header_font=\"Muli|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" locked=\"off\"]<p>Proin eget tortor risus. Donec sollicitudin molestie malesuada. Donec rutrum congue leo eget malesuada. Proin eget tortor.</p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-05.png\" _builder_version=\"3.23\" always_center_on_mobile=\"off\" locked=\"off\"][/et_pb_image][et_pb_blurb title=\"Alteration Services\" content_max_width=\"1100px\" _builder_version=\"3.17.6\" header_font=\"Muli|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" locked=\"off\"]<p>Proin eget tortor risus. Donec sollicitudin molestie malesuada. Donec rutrum congue leo eget malesuada. Proin eget tortor </p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"Muli|700|||||||\" text_font_size=\"18px\" text_line_height=\"2em\" background_color=\"#41547d\" background_layout=\"dark\" custom_margin=\"-14vw|-10vw||10vw\" custom_margin_tablet=\"0vw|0vw||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" custom_padding=\"80px|60px|80px|60px|true|true\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|phone\" animation_style=\"flip\" text_font_size_tablet=\"\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\" locked=\"off\"]<p>01. Shorten/lengthen hems</p>\n<p>02. Cuffs</p>\n<p>03. Linings</p>\n<p>04. Splitting the waist</p>\n<p>05. Lengthen/shorten sleeves</p>\n<p>06. Re-sew button/clasp</p>\n<p>07. Zipper replacement</p>[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" module_alignment=\"left\" custom_margin=\"-40px||\" custom_padding=\"0|0px|0|0px|false|false\" column_structure=\"1_2,1_2\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"Cormorant Garamond|600|||||||\" text_font_size=\"24px\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_2_font=\"||||||||\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" background_color=\"#dfab82\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-01.png\" background_position=\"bottom_right\" background_layout=\"dark\" custom_padding=\"50px|60px|50px|60px|true|true\" animation_style=\"flip\" link_option_url=\"#\" locked=\"off\" custom_padding__hover_enabled=\"on\" custom_padding__hover=\"|40px||80px||false\" background__hover_enabled=\"on\" background_color__hover=\"#ddb494\"]<p>View All Services</p>[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Gallery\" _builder_version=\"3.22\" background_color=\"#f7f9fc\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#f7f9fc\" background_color_gradient_end=\"#ffffff\"][et_pb_row _builder_version=\"3.25\" column_structure=\"1_4,1_4,1_2\"][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-08.jpg\" align_tablet=\"center\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"|||-10vw\" custom_margin_tablet=\"|||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|phone\" locked=\"off\"][/et_pb_image][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/crypto_image_03.jpg\" align_tablet=\"center\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" border_color_all=\"#ffffff\" border_width_bottom=\"20px\" border_width_left=\"20px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-10.jpg\" align_tablet=\"center\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"6vw||\" custom_margin_tablet=\"\" custom_margin_phone=\"0vw||\" custom_margin_last_edited=\"on|desktop\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" header_font=\"Cormorant Garamond||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"Cormorant Garamond|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>Some of Our Latest Work</h2>[/et_pb_text][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" locked=\"off\"]<p>Sed porttitor lectus nibh. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus. Quisque velit nisi, pretium ut lacinia in, elementum id enim. Pellentesque in ipsum id orci porta dapibus. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Donec velit neque, auctor sit amet aliquam vel, ullamcorper sit amet lig</p>[/et_pb_text][et_pb_button button_text=\"View Gallery\" _builder_version=\"3.17.6\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"Muli|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"left\" custom_padding=\"27px|0px|0|0px|false|false\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\" locked=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonials\" _builder_version=\"3.22\" background_color=\"#ffffff\" custom_padding=\"0|0px|54px|0px|false|false\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_slider _builder_version=\"3.17.6\" body_font=\"Cormorant Garamond|600|on||||||\" body_font_size=\"26px\" body_line_height=\"1.8em\" background_color=\"#dfab82\" animation_style=\"flip\" body_font_size_tablet=\"20px\" body_font_size_phone=\"18px\" body_font_size_last_edited=\"on|phone\" box_shadow_style=\"preset1\" box_shadow_vertical=\"50px\" box_shadow_blur=\"60px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_slide _builder_version=\"3.17.6\"]<p>\"Quisque velit nisi, pretium ut lacinia in, elementum id enim. Mauris blandit aliquet elit, eget tincidunt nibh pulvinar a. Nulla quis lorem ut libero malesuada feugiat. Donec sollicitudin molestie malesuada. Donec sollicitudin molestie malesuada. Donec rutrum congue leo eget malesuada. Quisque velit nisi, pretium ut lacinia\"</p>[/et_pb_slide][et_pb_slide _builder_version=\"3.17.6\"]<p>\"Quisque velit nisi, pretium ut lacinia in, elementum id enim. Mauris blandit aliquet elit, eget tincidunt nibh pulvinar a. Nulla quis lorem ut libero malesuada feugiat. Donec sollicitudin molestie malesuada. Donec sollicitudin molestie malesuada. Donec rutrum congue leo eget malesuada. Quisque velit nisi, pretium ut lacinia\"</p>[/et_pb_slide][et_pb_slide _builder_version=\"3.17.6\"]<p>\"Quisque velit nisi, pretium ut lacinia in, elementum id enim. Mauris blandit aliquet elit, eget tincidunt nibh pulvinar a. Nulla quis lorem ut libero malesuada feugiat. Donec sollicitudin molestie malesuada. Donec sollicitudin molestie malesuada. Donec rutrum congue leo eget malesuada. Quisque velit nisi, pretium ut lacinia\"</p>[/et_pb_slide][et_pb_slide _builder_version=\"3.17.6\"]<p>\"Quisque velit nisi, pretium ut lacinia in, elementum id enim. Mauris blandit aliquet elit, eget tincidunt nibh pulvinar a. Nulla quis lorem ut libero malesuada feugiat. Donec sollicitudin molestie malesuada. Donec sollicitudin molestie malesuada. Donec rutrum congue leo eget malesuada. Quisque velit nisi, pretium ut lacinia\"</p>[/et_pb_slide][/et_pb_slider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#f1f6ff\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" header_font=\"Cormorant Garamond||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"Cormorant Garamond|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>Get In Touch!</h2>[/et_pb_text][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" locked=\"off\"]<p>Sed porttitor lectus nibh. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus. Quisque velit nisi, pretium ut lacinia in, elementum id enim. Pellentesque in ipsum id orci porta dapibus.</p>[/et_pb_text][et_pb_blurb title=\"Visit Our Shop\" use_icon=\"on\" font_icon=\"%%249%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"3.17.6\" header_font=\"Muli|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\"]<p>1234 Divi St. San Francisco, CA 19351</p>[/et_pb_blurb][et_pb_blurb title=\"Call Us\" use_icon=\"on\" font_icon=\"%%264%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"3.17.6\" header_font=\"Muli|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\"]<p>(235) 235-1351</p>[/et_pb_blurb][et_pb_blurb title=\"Email Us\" use_icon=\"on\" font_icon=\"%%238%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"3.17.6\" header_font=\"Muli|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\"]<p>info@divisuits.com</p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_row_inner _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"60px|0px|60px|0px|true|false\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_column_inner saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_contact_form captcha=\"off\" module_id=\"et_pb_contact_form_0\" _builder_version=\"3.23\" form_field_background_color=\"#f5f9ff\" form_field_font=\"Muli||||||||\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#41547d\" button_border_width=\"10px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"Muli|800||on|||||\" custom_padding=\"|40px||40px||true\" form_background_color=\"#f5f9ff\"][et_pb_contact_field field_id=\"Name\" field_title=\"Name\" fullwidth_field=\"on\" _builder_version=\"3.17.6\" custom_margin=\"||20px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Email\" field_title=\"Email Address\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"3.17.6\" custom_margin=\"||20px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Phone\" field_title=\"Phone Number\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"3.17.6\" custom_margin=\"||20px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Message\" field_title=\"Message\" field_type=\"text\" fullwidth_field=\"on\" _builder_version=\"3.17.6\" custom_margin=\"||30px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][/et_pb_contact_form][/et_pb_column_inner][/et_pb_row_inner][et_pb_row_inner _builder_version=\"3.25\"][et_pb_column_inner saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_social_media_follow _builder_version=\"3.17.6\" text_orientation=\"center\" border_radii=\"on|0px|0px|0px|0px\"][et_pb_social_media_follow_network social_network=\"instagram\" _builder_version=\"3.17.6\" background_color=\"#dfab82\" custom_margin=\"|6px||6px||true\" custom_padding=\"8px|8px|8px|8px|true|true\" follow_button=\"off\" url_new_window=\"on\"]instagram[/et_pb_social_media_follow_network][et_pb_social_media_follow_network social_network=\"facebook\" _builder_version=\"3.17.6\" background_color=\"#dfab82\" custom_margin=\"|6px||6px||true\" custom_padding=\"8px|8px|8px|8px|true|true\" follow_button=\"off\" url_new_window=\"on\"]facebook[/et_pb_social_media_follow_network][et_pb_social_media_follow_network social_network=\"twitter\" _builder_version=\"3.17.6\" background_color=\"#dfab82\" custom_margin=\"|6px||6px||true\" custom_padding=\"8px|8px|8px|8px|true|true\" follow_button=\"off\" url_new_window=\"on\"]twitter[/et_pb_social_media_follow_network][/et_pb_social_media_follow][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section]", "خانه", "", "inherit", "closed", "closed", "", "2-revision-v1", "", "", "2020-03-31 11:35:07", "2020-03-31 08:05:07", "", "2", "http://modelsite.test/2-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2787", "1", "2020-03-31 11:37:00", "2020-03-31 08:07:00", "{\n    \"et_divi[accent_color]\": {\n        \"value\": \"#dfab82\",\n        \"type\": \"option\",\n        \"user_id\": 1,\n        \"date_modified_gmt\": \"2020-03-31 08:06:58\"\n    },\n    \"et_divi[menu_link]\": {\n        \"value\": \"#dfab82\",\n        \"type\": \"option\",\n        \"user_id\": 1,\n        \"date_modified_gmt\": \"2020-03-31 08:06:58\"\n    },\n    \"et_divi[menu_link_active]\": {\n        \"value\": \"#dd6000\",\n        \"type\": \"option\",\n        \"user_id\": 1,\n        \"date_modified_gmt\": \"2020-03-31 08:06:58\"\n    },\n    \"et_divi[primary_nav_dropdown_line_color]\": {\n        \"value\": \"#dfab82\",\n        \"type\": \"option\",\n        \"user_id\": 1,\n        \"date_modified_gmt\": \"2020-03-31 08:06:58\"\n    },\n    \"et_divi[primary_nav_dropdown_link_color]\": {\n        \"value\": \"#dfab82\",\n        \"type\": \"option\",\n        \"user_id\": 1,\n        \"date_modified_gmt\": \"2020-03-31 08:06:58\"\n    },\n    \"et_divi[secondary_nav_bg]\": {\n        \"value\": \"#dfab82\",\n        \"type\": \"option\",\n        \"user_id\": 1,\n        \"date_modified_gmt\": \"2020-03-31 08:06:58\"\n    },\n    \"et_divi[secondary_nav_dropdown_bg]\": {\n        \"value\": \"#dfab82\",\n        \"type\": \"option\",\n        \"user_id\": 1,\n        \"date_modified_gmt\": \"2020-03-31 08:06:58\"\n    },\n    \"et_divi[fixed_secondary_nav_bg]\": {\n        \"value\": \"#dfab82\",\n        \"type\": \"option\",\n        \"user_id\": 1,\n        \"date_modified_gmt\": \"2020-03-31 08:06:58\"\n    },\n    \"et_divi[fixed_menu_link]\": {\n        \"value\": \"#dfab82\",\n        \"type\": \"option\",\n        \"user_id\": 1,\n        \"date_modified_gmt\": \"2020-03-31 08:06:58\"\n    },\n    \"et_divi[fixed_menu_link_active]\": {\n        \"value\": \"#dd6000\",\n        \"type\": \"option\",\n        \"user_id\": 1,\n        \"date_modified_gmt\": \"2020-03-31 08:06:58\"\n    },\n    \"et_divi[bottom_bar_background_color]\": {\n        \"value\": \"#dfab82\",\n        \"type\": \"option\",\n        \"user_id\": 1,\n        \"date_modified_gmt\": \"2020-03-31 08:07:00\"\n    }\n}", "", "", "trash", "closed", "closed", "", "e8c51ad5-2b2d-4c07-a343-efba61a69766", "", "", "2020-03-31 11:37:00", "2020-03-31 08:07:00", "", "0", "http://modelsite.test/?p=2787", "0", "customize_changeset", "", "0");
INSERT INTO `wp_posts` VALUES("2791", "1", "2020-03-31 11:39:41", "2020-03-31 08:09:41", "[et_pb_section fb_built=\"1\" specialty=\"on\" bg_img_2=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-02.jpg\" padding_left_right_link_2=\"true\" padding_right_2=\"40px\" padding_left_2=\"40px\" padding_2_tablet=\"|||0px\" padding_2_phone=\"\" padding_2_last_edited=\"on|tablet\" admin_label=\"Footer\" _builder_version=\"3.22\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" inner_shadow__hover=\"off\" inner_shadow__hover_enabled=\"off\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" max_width__hover=\"100%\" max_width__hover_enabled=\"100%\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" parallax__hover_enabled=\"off\" parallax_method__hover_enabled=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"Cormorant Garamond|600|||||||\" header_font_size=\"60px\" header_line_height=\"1.4em\" header_2_font=\"Cormorant Garamond|600|||||||\" header_2_text_color=\"#dfab82\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" custom_margin=\"||40px\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h1>Have Questions? We Have Answers</h1>\n<h2>Contact Us Or Book An Appointment Online</h2>[/et_pb_text][et_pb_button button_text=\"Make an Appointment Online\" _builder_version=\"3.17.6\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#41547d\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"Muli|800||on|||||\" custom_margin=\"||0px\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(65,84,125,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][et_pb_button button_text=\"Or Call: (235) 133-2511\" _builder_version=\"3.17.6\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#41547d\" button_bg_color=\"#ffffff\" button_border_width=\"0px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"Muli|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"1\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(65,84,125,0.06)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" padding_tablet__hover=\"|||0px\" padding_last_edited__hover=\"on|tablet\" padding_left__hover=\"40px\" padding_right__hover=\"40px\" bg_img__hover=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-02.jpg\" parallax__hover_enabled=\"off\" parallax_method__hover_enabled=\"on\" padding_tablet=\"|||0px\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_row_inner _builder_version=\"3.25\" background_color=\"#ffffff\" custom_margin=\"||-80px||false|true\" custom_padding=\"60px|0px|60px|0px|true|false\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_column_inner saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_contact_form captcha=\"off\" module_id=\"et_pb_contact_form_0\" _builder_version=\"3.23\" form_field_background_color=\"#f5f9ff\" form_field_font=\"Muli||||||||\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#41547d\" button_border_width=\"10px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"Muli|800||on|||||\" custom_padding=\"|40px||40px||true\" form_background_color=\"#f5f9ff\"][et_pb_contact_field field_id=\"Name\" field_title=\"Name\" fullwidth_field=\"on\" _builder_version=\"3.17.6\" custom_margin=\"||20px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Email\" field_title=\"Email Address\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"3.17.6\" custom_margin=\"||20px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Phone\" field_title=\"Phone Number\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"3.17.6\" custom_margin=\"||20px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Message\" field_title=\"Message\" field_type=\"text\" fullwidth_field=\"on\" _builder_version=\"3.17.6\" custom_margin=\"||30px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][/et_pb_contact_form][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Contact Info\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#f7f9fc\"][et_pb_row _builder_version=\"3.25\" column_structure=\"1_3,1_3,1_3\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"Visit Our Shop\" use_icon=\"on\" font_icon=\"%%249%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"16px\" _builder_version=\"3.17.6\" header_font=\"Muli|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" text_orientation=\"center\" custom_padding=\"|30px|30px|30px|false|true\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\"]<p>1234 Divi St. San Francisco, CA 19351</p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"Call Us\" use_icon=\"on\" font_icon=\"%%264%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"16px\" _builder_version=\"3.17.6\" header_font=\"Muli|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" text_orientation=\"center\" custom_padding=\"|30px|30px|30px|false|true\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\"]<p>(235) 235-1351</p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"Email Us\" use_icon=\"on\" font_icon=\"%%238%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"16px\" _builder_version=\"3.17.6\" header_font=\"Muli|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" text_orientation=\"center\" custom_padding=\"|30px|30px|30px|false|true\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\"]<p>info@divisuits.com</p>[/et_pb_blurb][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" admin_label=\"Hours\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" header_font=\"Cormorant Garamond||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"Cormorant Garamond|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>Come Visit Our Showroom</h2>[/et_pb_text][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" locked=\"off\"]<p>Sed porttitor lectus nibh. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus. Quisque velit nisi, pretium ut lacinia in, elementum id enim. Pellentesque in ipsum id orci porta dapibus. Vestibulum ante ip</p>[/et_pb_text][et_pb_blurb title=\"Get Measured\" _builder_version=\"3.17.6\" header_font=\"Muli|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" locked=\"off\"]<p>Proin eget tortor risus. Donec sollicitudin molestie malesuada. </p>[/et_pb_blurb][et_pb_blurb title=\"Schedule a Try-On\" _builder_version=\"3.17.6\" header_font=\"Muli|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" locked=\"off\"]<p>Proin eget tortor risus. Donec sollicitudin molestie malesuada. </p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_row_inner _builder_version=\"3.25\" background_color=\"#41547d\" custom_margin=\"|||||false\" custom_padding=\"80px|60px||60px||true\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\"][et_pb_column_inner saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"Muli|700|||||||\" text_text_color=\"#dfab82\" text_font_size=\"18px\" text_line_height=\"2em\" background_layout=\"dark\" custom_margin_tablet=\"0vw|0vw||0vw\" custom_margin_last_edited=\"off|desktop\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_last_edited=\"off|desktop\" animation_style=\"flip\" text_font_size_tablet=\"\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\" locked=\"off\"]<p><span style=\"font-size: 18px;\">Showroom Hours</span></p>[/et_pb_text][/et_pb_column_inner][/et_pb_row_inner][et_pb_row_inner _builder_version=\"3.25\" background_color=\"#41547d\" custom_padding=\"10px|60px|10px|60px|true|true\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" column_structure=\"1_2,1_2\"][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"Cormorant Garamond|700|||||||\" text_font_size=\"18px\" text_line_height=\"2em\" background_layout=\"dark\" custom_margin=\"||\" custom_margin_tablet=\"0vw|0vw||0vw\" custom_margin_phone=\"||-20px\" custom_margin_last_edited=\"on|desktop\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_last_edited=\"off|desktop\" animation_style=\"flip\" text_font_size_tablet=\"\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\" locked=\"off\"]<p>Monday</p>[/et_pb_text][/et_pb_column_inner][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"Muli|700|||||||\" text_font_size=\"18px\" text_line_height=\"2em\" background_layout=\"dark\" custom_margin_tablet=\"0vw|0vw||0vw\" custom_margin_last_edited=\"off|desktop\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_last_edited=\"off|desktop\" animation_style=\"flip\" text_font_size_tablet=\"\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\" locked=\"off\"]<p>8am - 5pm</p>[/et_pb_text][/et_pb_column_inner][/et_pb_row_inner][et_pb_row_inner _builder_version=\"3.25\" background_color=\"#41547d\" custom_padding=\"10px|60px|10px|60px|true|true\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" column_structure=\"1_2,1_2\"][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"Cormorant Garamond|700|||||||\" text_font_size=\"18px\" text_line_height=\"2em\" background_layout=\"dark\" custom_margin=\"||\" custom_margin_tablet=\"0vw|0vw||0vw\" custom_margin_phone=\"||-20px\" custom_margin_last_edited=\"on|desktop\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_last_edited=\"off|desktop\" animation_style=\"flip\" text_font_size_tablet=\"\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\" locked=\"off\"]<p>Tuesday</p>[/et_pb_text][/et_pb_column_inner][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"Muli|700|||||||\" text_font_size=\"18px\" text_line_height=\"2em\" background_layout=\"dark\" custom_margin_tablet=\"0vw|0vw||0vw\" custom_margin_last_edited=\"off|desktop\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_last_edited=\"off|desktop\" animation_style=\"flip\" text_font_size_tablet=\"\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\" locked=\"off\"]<p>8am - 5pm</p>[/et_pb_text][/et_pb_column_inner][/et_pb_row_inner][et_pb_row_inner _builder_version=\"3.25\" background_color=\"#41547d\" custom_padding=\"10px|60px|10px|60px|true|true\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" column_structure=\"1_2,1_2\"][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"Cormorant Garamond|700|||||||\" text_font_size=\"18px\" text_line_height=\"2em\" background_layout=\"dark\" custom_margin=\"||\" custom_margin_tablet=\"0vw|0vw||0vw\" custom_margin_phone=\"||-20px\" custom_margin_last_edited=\"on|desktop\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_last_edited=\"off|desktop\" animation_style=\"flip\" text_font_size_tablet=\"\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\" locked=\"off\"]<p>Wednesday</p>[/et_pb_text][/et_pb_column_inner][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"Muli|700|||||||\" text_font_size=\"18px\" text_line_height=\"2em\" background_layout=\"dark\" custom_margin_tablet=\"0vw|0vw||0vw\" custom_margin_last_edited=\"off|desktop\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_last_edited=\"off|desktop\" animation_style=\"flip\" text_font_size_tablet=\"\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\" locked=\"off\"]<p>10am - 7pm</p>[/et_pb_text][/et_pb_column_inner][/et_pb_row_inner][et_pb_row_inner _builder_version=\"3.25\" background_color=\"#41547d\" custom_padding=\"10px|60px|10px|60px|true|true\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" column_structure=\"1_2,1_2\"][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"Cormorant Garamond|700|||||||\" text_font_size=\"18px\" text_line_height=\"2em\" background_layout=\"dark\" custom_margin=\"||\" custom_margin_tablet=\"0vw|0vw||0vw\" custom_margin_phone=\"||-20px\" custom_margin_last_edited=\"on|desktop\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_last_edited=\"off|desktop\" animation_style=\"flip\" text_font_size_tablet=\"\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\" locked=\"off\"]<p>Thursday</p>[/et_pb_text][/et_pb_column_inner][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"Muli|700|||||||\" text_font_size=\"18px\" text_line_height=\"2em\" background_layout=\"dark\" custom_margin_tablet=\"0vw|0vw||0vw\" custom_margin_last_edited=\"off|desktop\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_last_edited=\"off|desktop\" animation_style=\"flip\" text_font_size_tablet=\"\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\" locked=\"off\"]<p>8am - 5pm</p>[/et_pb_text][/et_pb_column_inner][/et_pb_row_inner][et_pb_row_inner _builder_version=\"3.25\" background_color=\"#41547d\" custom_padding=\"10px|60px|10px|60px|true|true\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" column_structure=\"1_2,1_2\"][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"Cormorant Garamond|700|||||||\" text_font_size=\"18px\" text_line_height=\"2em\" background_layout=\"dark\" custom_margin=\"||\" custom_margin_tablet=\"0vw|0vw||0vw\" custom_margin_phone=\"||-20px\" custom_margin_last_edited=\"on|desktop\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_last_edited=\"off|desktop\" animation_style=\"flip\" text_font_size_tablet=\"\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\" locked=\"off\"]<p>Friday</p>[/et_pb_text][/et_pb_column_inner][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"Muli|700|||||||\" text_font_size=\"18px\" text_line_height=\"2em\" background_layout=\"dark\" custom_margin_tablet=\"0vw|0vw||0vw\" custom_margin_last_edited=\"off|desktop\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_last_edited=\"off|desktop\" animation_style=\"flip\" text_font_size_tablet=\"\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\" locked=\"off\"]<p>8am - 2pm</p>[/et_pb_text][/et_pb_column_inner][/et_pb_row_inner][et_pb_row_inner _builder_version=\"3.25\" background_color=\"#41547d\" custom_padding=\"10px|60px|80px|60px|false|true\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" column_structure=\"1_2,1_2\"][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"Cormorant Garamond|700|||||||\" text_font_size=\"18px\" text_line_height=\"2em\" background_layout=\"dark\" custom_margin=\"||\" custom_margin_tablet=\"0vw|0vw||0vw\" custom_margin_phone=\"||-20px\" custom_margin_last_edited=\"on|desktop\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_last_edited=\"off|desktop\" animation_style=\"flip\" text_font_size_tablet=\"\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\" locked=\"off\"]<p>Sat &amp; Sun</p>[/et_pb_text][/et_pb_column_inner][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"Muli|700|||||||\" text_font_size=\"18px\" text_line_height=\"2em\" background_layout=\"dark\" custom_margin_tablet=\"0vw|0vw||0vw\" custom_margin_last_edited=\"off|desktop\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_last_edited=\"off|desktop\" animation_style=\"flip\" text_font_size_tablet=\"\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\" locked=\"off\"]<p><span style=\"font-size: 18px;\">Closed</span></p>[/et_pb_text][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section][et_pb_section fb_built=\"1\" fullwidth=\"on\" admin_label=\"Map\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#f7f9fc\" background_color_gradient_end=\"#ffffff\" background_color_gradient_start_position=\"50%\" background_color_gradient_end_position=\"50%\" custom_padding=\"0px|10vw|10vw|0px|false|false\"][et_pb_fullwidth_map address=\"San Francisco, CA, USA\" address_lat=\"37.7749295\" address_lng=\"-122.4194155\" mouse_wheel=\"off\" _builder_version=\"3.17.6\" child_filter_saturate=\"32%\" box_shadow_style=\"preset4\" box_shadow_horizontal=\"360px\" box_shadow_vertical=\"170px\" box_shadow_spread=\"-68px\" box_shadow_color=\"#dfab82\"][et_pb_map_pin pin_address=\"San Francisco, CA, USA\" pin_address_lat=\"37.7749295\" pin_address_lng=\"-122.4194155\" _builder_version=\"3.17.6\"][/et_pb_map_pin][/et_pb_fullwidth_map][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"FAQ\" _builder_version=\"3.22\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" header_font=\"Cormorant Garamond||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"Cormorant Garamond|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>General Questions</h2>[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" column_structure=\"1_2,1_2\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_toggle title=\"Elementum id enim vestibulum ante?\" open=\"on\" open_toggle_background_color=\"rgba(0,0,0,0)\" closed_toggle_background_color=\"rgba(0,0,0,0)\" icon_color=\"#dfab82\" _builder_version=\"3.17.6\" title_level=\"h4\" title_font=\"Muli|700|||||||\" title_font_size=\"14px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||0px\" custom_padding=\"30px|0px|30px|0px|true|true\" border_width_all=\"0px\" border_width_bottom=\"1px\"]<p>Cras ultricies ligula sed magna dictum porta. Quisque velit nisi, pretium ut lacinia in, elementum id enim. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Donec velit neque, auctor sit amet aliquam vel, ullamcorper sit amet ligula. Quisque velit nisi</p>[/et_pb_toggle][et_pb_toggle title=\"Cras ultricies ligula sed magna dictum porta?\" open_toggle_background_color=\"rgba(0,0,0,0)\" closed_toggle_background_color=\"rgba(0,0,0,0)\" icon_color=\"#dfab82\" _builder_version=\"3.17.6\" title_level=\"h4\" title_font=\"Muli|700|||||||\" title_font_size=\"14px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||0px\" custom_padding=\"30px|0px|30px|0px|true|true\" border_width_all=\"0px\" border_width_bottom=\"1px\"]<p>Cras ultricies ligula sed magna dictum porta. Quisque velit nisi, pretium ut lacinia in, elementum id enim. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Donec velit neque, auctor sit amet aliquam vel, ullamcorper sit amet ligula. Quisque velit nisi</p>[/et_pb_toggle][et_pb_toggle title=\"Donec velit neque auctor sit amet aliquam?\" open_toggle_background_color=\"rgba(0,0,0,0)\" closed_toggle_background_color=\"rgba(0,0,0,0)\" icon_color=\"#dfab82\" _builder_version=\"3.17.6\" title_level=\"h4\" title_font=\"Muli|700|||||||\" title_font_size=\"14px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||0px\" custom_padding=\"30px|0px|30px|0px|true|true\" border_width_all=\"0px\" border_width_bottom=\"1px\"]<p>Cras ultricies ligula sed magna dictum porta. Quisque velit nisi, pretium ut lacinia in, elementum id enim. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Donec velit neque, auctor sit amet aliquam vel, ullamcorper sit amet ligula. Quisque velit nisi</p>[/et_pb_toggle][et_pb_toggle title=\"Quisque velit nisi pretium ut lacinia in?\" open_toggle_background_color=\"rgba(0,0,0,0)\" closed_toggle_background_color=\"rgba(0,0,0,0)\" icon_color=\"#dfab82\" _builder_version=\"3.17.6\" title_level=\"h4\" title_font=\"Muli|700|||||||\" title_font_size=\"14px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||0px\" custom_padding=\"30px|0px|30px|0px|true|true\" border_width_all=\"0px\" border_width_bottom=\"1px\"]<p>Cras ultricies ligula sed magna dictum porta. Quisque velit nisi, pretium ut lacinia in, elementum id enim. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Donec velit neque, auctor sit amet aliquam vel, ullamcorper sit amet ligula. Quisque velit nisi</p>[/et_pb_toggle][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_toggle title=\" Ullamcorper sit amet ligula quisque velit nisi?\" open_toggle_background_color=\"rgba(0,0,0,0)\" closed_toggle_background_color=\"rgba(0,0,0,0)\" icon_color=\"#dfab82\" _builder_version=\"3.17.6\" title_level=\"h4\" title_font=\"Muli|700|||||||\" title_font_size=\"14px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||0px\" custom_padding=\"30px|0px|30px|0px|true|true\" border_width_all=\"0px\" border_width_bottom=\"1px\" locked=\"off\"]<p>Cras ultricies ligula sed magna dictum porta. Quisque velit nisi, pretium ut lacinia in, elementum id enim. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Donec velit neque, auctor sit amet aliquam vel, ullamcorper sit amet ligula. Quisque velit nisi</p>[/et_pb_toggle][et_pb_toggle title=\"Primis in faucibus orci luctus et ultrices posuere cubilia?\" open_toggle_background_color=\"rgba(0,0,0,0)\" closed_toggle_background_color=\"rgba(0,0,0,0)\" icon_color=\"#dfab82\" _builder_version=\"3.17.6\" title_level=\"h4\" title_font=\"Muli|700|||||||\" title_font_size=\"14px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||0px\" custom_padding=\"30px|0px|30px|0px|true|true\" border_width_all=\"0px\" border_width_bottom=\"1px\" locked=\"off\"]<p>Cras ultricies ligula sed magna dictum porta. Quisque velit nisi, pretium ut lacinia in, elementum id enim. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Donec velit neque, auctor sit amet aliquam vel, ullamcorper sit amet ligula. Quisque velit nisi</p>[/et_pb_toggle][et_pb_toggle title=\"Elementum id enim vestibulum ante?\" open_toggle_background_color=\"rgba(0,0,0,0)\" closed_toggle_background_color=\"rgba(0,0,0,0)\" icon_color=\"#dfab82\" _builder_version=\"3.17.6\" title_level=\"h4\" title_font=\"Muli|700|||||||\" title_font_size=\"14px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||0px\" custom_padding=\"30px|0px|30px|0px|true|true\" border_width_all=\"0px\" border_width_bottom=\"1px\" locked=\"off\"]<p>Cras ultricies ligula sed magna dictum porta. Quisque velit nisi, pretium ut lacinia in, elementum id enim. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Donec velit neque, auctor sit amet aliquam vel, ullamcorper sit amet ligula. Quisque velit nisi</p>[/et_pb_toggle][et_pb_toggle title=\"Cras ultricies ligula sed magna dictum porta?\" open_toggle_background_color=\"rgba(0,0,0,0)\" closed_toggle_background_color=\"rgba(0,0,0,0)\" icon_color=\"#dfab82\" _builder_version=\"3.17.6\" title_level=\"h4\" title_font=\"Muli|700|||||||\" title_font_size=\"14px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||0px\" custom_padding=\"30px|0px|30px|0px|true|true\" border_width_all=\"0px\" border_width_bottom=\"1px\" locked=\"off\"]<p>Cras ultricies ligula sed magna dictum porta. Quisque velit nisi, pretium ut lacinia in, elementum id enim. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Donec velit neque, auctor sit amet aliquam vel, ullamcorper sit amet ligula. Quisque velit nisi</p>[/et_pb_toggle][et_pb_button button_text=\"Ask a Different Question\" _builder_version=\"3.17.6\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"Muli|800||on|||||\" custom_margin=\"56px||0px\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(65,84,125,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#f1f6ff\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" header_font=\"Cormorant Garamond||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"Cormorant Garamond|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>Get In Touch!</h2>[/et_pb_text][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" locked=\"off\"]<p>Sed porttitor lectus nibh. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus. Quisque velit nisi, pretium ut lacinia in, elementum id enim. Pellentesque in ipsum id orci porta dapibus.</p>[/et_pb_text][et_pb_blurb title=\"Visit Our Shop\" use_icon=\"on\" font_icon=\"%%249%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"3.17.6\" header_font=\"Muli|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\"]<p>1234 Divi St. San Francisco, CA 19351</p>[/et_pb_blurb][et_pb_blurb title=\"Call Us\" use_icon=\"on\" font_icon=\"%%264%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"3.17.6\" header_font=\"Muli|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\"]<p>(235) 235-1351</p>[/et_pb_blurb][et_pb_blurb title=\"Email Us\" use_icon=\"on\" font_icon=\"%%238%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"3.17.6\" header_font=\"Muli|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\"]<p>info@divisuits.com</p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_row_inner _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"60px|0px|60px|0px|true|false\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_column_inner saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_contact_form captcha=\"off\" module_id=\"et_pb_contact_form_0\" _builder_version=\"3.23\" form_field_background_color=\"#f5f9ff\" form_field_font=\"Muli||||||||\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#41547d\" button_border_width=\"10px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"Muli|800||on|||||\" custom_padding=\"|40px||40px||true\" form_background_color=\"#f5f9ff\"][et_pb_contact_field field_id=\"Name\" field_title=\"Name\" fullwidth_field=\"on\" _builder_version=\"3.17.6\" custom_margin=\"||20px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Email\" field_title=\"Email Address\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"3.17.6\" custom_margin=\"||20px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Phone\" field_title=\"Phone Number\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"3.17.6\" custom_margin=\"||20px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Message\" field_title=\"Message\" field_type=\"text\" fullwidth_field=\"on\" _builder_version=\"3.17.6\" custom_margin=\"||30px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][/et_pb_contact_form][/et_pb_column_inner][/et_pb_row_inner][et_pb_row_inner _builder_version=\"3.25\"][et_pb_column_inner saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_social_media_follow _builder_version=\"3.17.6\" text_orientation=\"center\" border_radii=\"on|0px|0px|0px|0px\"][et_pb_social_media_follow_network social_network=\"instagram\" _builder_version=\"3.17.6\" background_color=\"#dfab82\" custom_margin=\"|6px||6px||true\" custom_padding=\"8px|8px|8px|8px|true|true\" follow_button=\"off\" url_new_window=\"on\"]instagram[/et_pb_social_media_follow_network][et_pb_social_media_follow_network social_network=\"facebook\" _builder_version=\"3.17.6\" background_color=\"#dfab82\" custom_margin=\"|6px||6px||true\" custom_padding=\"8px|8px|8px|8px|true|true\" follow_button=\"off\" url_new_window=\"on\"]facebook[/et_pb_social_media_follow_network][et_pb_social_media_follow_network social_network=\"twitter\" _builder_version=\"3.17.6\" background_color=\"#dfab82\" custom_margin=\"|6px||6px||true\" custom_padding=\"8px|8px|8px|8px|true|true\" follow_button=\"off\" url_new_window=\"on\"]twitter[/et_pb_social_media_follow_network][/et_pb_social_media_follow][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section]", "تماس با ما", "", "inherit", "closed", "closed", "", "195-revision-v1", "", "", "2020-03-31 11:39:41", "2020-03-31 08:09:41", "", "195", "http://modelsite.test/195-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2800", "1", "2020-03-31 11:41:21", "2020-03-31 08:11:21", "[et_pb_section fb_built=\"1\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(48,57,78,0.95)\" background_color_gradient_end=\"rgba(96,124,179,0.85)\" background_color_gradient_direction=\"60deg\" background_color_gradient_overlays_image=\"on\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-17.jpg\" custom_padding=\"6vw||6vw||true\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"Cormorant Garamond|600|||||||\" header_font_size=\"60px\" header_line_height=\"1.4em\" header_2_font=\"Cormorant Garamond|600|||||||\" header_2_text_color=\"#dfab82\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" text_orientation=\"center\" background_layout=\"dark\" max_width=\"800px\" module_alignment=\"center\" custom_margin=\"||40px\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h1>About Us</h1>\n<h2>Custom Suits &amp; Alterations</h2>\n<p>Sed porttitor lectus nibh. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus. Quisque velit nisi, pretium ut lacinia in, elementum id enim. Pellentesque in ipsum id orci porta dapibus. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubi</p>[/et_pb_text][et_pb_button button_text=\"Make an Appointment\" button_alignment=\"center\" _builder_version=\"3.17.6\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"Muli|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"About\" _builder_version=\"3.22\"][et_pb_row _builder_version=\"3.25\" column_structure=\"1_3,1_3,1_3\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" header_font=\"Cormorant Garamond||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"Cormorant Garamond|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>Get A Custom, Bespoke Suite Made By The Experts</h2>[/et_pb_text][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" locked=\"off\"]<p>Sed porttitor lectus nibh. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus. Quisque velit nisi, pretium ut lacinia in, elementum id enim. Pellentesque in ipsum id orci porta dapibus. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Donec velit neque, auctor sit amet aliquam vel, ullamcorper sit amet lig</p>[/et_pb_text][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" locked=\"off\"]<p>Sed porttitor lectus nibh. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus. Quisque velit nisi, pretium ut lacinia in, elementum id enim. Pellentesque in ipsum id orci porta dapibus. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Donec velit neque, auctor sit amet aliquam vel, ullamcorper sit amet lig</p>[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Process\" _builder_version=\"3.22\"][et_pb_row custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#41547d\" custom_padding=\"80px|60px|80px|60px|true|true\" custom_padding_tablet=\"\" custom_padding_phone=\"60px|40px|60px|40px|true|true\" column_structure=\"1_2,1_2\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"Cormorant Garamond||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"Cormorant Garamond|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" background_layout=\"dark\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>We Make High Quality, Custom Suits </h2>[/et_pb_text][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" background_layout=\"dark\" locked=\"off\"]<p>Sed porttitor lectus nibh. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus. Quisque velit nisi, pretium ut lacinia in, elementum id enim. Pellentesque in ipsum id orci porta dapibus. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Donec velit neque, auctor sit amet aliquam vel, ullamcorper sit amet lig</p>[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"Only the Finest Materials\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-08-1.png\" icon_placement=\"left\" image_max_width=\"90px\" content_max_width=\"1100px\" image_max_width_tablet=\"\" image_max_width_phone=\"45px\" image_max_width_last_edited=\"on|phone\" _builder_version=\"3.17.6\" header_font=\"Muli|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" background_layout=\"dark\" locked=\"off\"]<p>Sed porttitor lectus nibh. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus. Quisque velit nisi, pretium ut lacinia in, elementum id enim.</p>[/et_pb_blurb][et_pb_blurb title=\"Designed & Cut to Perfection\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-06-1.png\" icon_placement=\"left\" image_max_width=\"90px\" content_max_width=\"1100px\" image_max_width_tablet=\"\" image_max_width_phone=\"45px\" image_max_width_last_edited=\"on|phone\" _builder_version=\"3.17.6\" header_font=\"Muli|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" background_layout=\"dark\" locked=\"off\"]<p>Sed porttitor lectus nibh. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus. Quisque velit nisi, pretium ut lacinia in, elementum id enim.</p>[/et_pb_blurb][et_pb_blurb title=\"Constructed In Our Shop\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-02-1.png\" icon_placement=\"left\" image_max_width=\"90px\" content_max_width=\"1100px\" image_max_width_tablet=\"\" image_max_width_phone=\"45px\" image_max_width_last_edited=\"on|phone\" _builder_version=\"3.17.6\" header_font=\"Muli|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" background_layout=\"dark\" locked=\"off\"]<p>Sed porttitor lectus nibh. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus. Quisque velit nisi, pretium ut lacinia in, elementum id enim.</p>[/et_pb_blurb][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" custom_padding=\"0|0px|27px|0px|false|false\" column_structure=\"1_2,1_2\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"Cormorant Garamond|600|||||||\" text_font_size=\"24px\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_2_font=\"||||||||\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" background_color=\"#dfab82\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-01.png\" background_position=\"bottom_right\" background_layout=\"dark\" custom_margin=\"|||0%\" custom_padding=\"50px|60px|50px|60px|true|true\" animation_direction=\"left\" link_option_url=\"#\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\" custom_padding__hover_enabled=\"on\" custom_padding__hover=\"|40px||80px||false\" background__hover_enabled=\"on\" background_color__hover=\"#ddb494\"]Make an Appointment[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" use_custom_gutter=\"on\" gutter_width=\"1\" admin_label=\"Video\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#f7f9fc\" background_color_gradient_start_position=\"75%\" background_color_gradient_end_position=\"75%\" custom_padding=\"0|0px|0|0px|false|false\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_video src=\"https://www.youtube.com/watch?v=FkQuawiGWUw\" image_src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-05.jpg\" play_icon_color=\"#607CB3\" _builder_version=\"3.17.6\"][/et_pb_video][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Gallery\" _builder_version=\"3.22\" background_color=\"#f7f9fc\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#f7f9fc\" background_color_gradient_end=\"#ffffff\"][et_pb_row _builder_version=\"3.25\" column_structure=\"1_4,1_4,1_2\"][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-08.jpg\" align_tablet=\"center\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"|||-10vw\" custom_margin_tablet=\"|||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|phone\" locked=\"off\"][/et_pb_image][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/crypto_image_03.jpg\" align_tablet=\"center\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" border_color_all=\"#ffffff\" border_width_bottom=\"20px\" border_width_left=\"20px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-10.jpg\" align_tablet=\"center\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"6vw||\" custom_margin_tablet=\"\" custom_margin_phone=\"0vw||\" custom_margin_last_edited=\"on|desktop\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" header_font=\"Cormorant Garamond||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"Cormorant Garamond|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>Some of Our Latest Work</h2>[/et_pb_text][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" locked=\"off\"]<p>Sed porttitor lectus nibh. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus. Quisque velit nisi, pretium ut lacinia in, elementum id enim. Pellentesque in ipsum id orci porta dapibus. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Donec velit neque, auctor sit amet aliquam vel, ullamcorper sit amet lig</p>[/et_pb_text][et_pb_button button_text=\"View Gallery\" _builder_version=\"3.17.6\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"Muli|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"left\" custom_padding=\"27px|0px|0|0px|false|false\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\" locked=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Team\" _builder_version=\"3.22\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" header_font=\"Cormorant Garamond||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"Cormorant Garamond|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>Meet Our Designers</h2>[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" column_structure=\"1_2,1_2\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/portrait-04.jpg\" align_tablet=\"center\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\"][/et_pb_image][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"Cormorant Garamond||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_3_font=\"Cormorant Garamond|600|||||||\" header_3_font_size=\"30px\" header_3_line_height=\"1.4em\" header_4_font=\"Muli|700||on|||||\" header_4_text_color=\"#dfab82\" header_4_font_size=\"12px\" header_4_letter_spacing=\"2px\" header_4_line_height=\"2em\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_3_font_size_tablet=\"40px\" header_3_font_size_phone=\"30px\" header_3_font_size_last_edited=\"off|desktop\" locked=\"off\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h3>Owen Hill</h3>\n<h4>Designer &amp; Tailor</h4>\n<p>Sed porttitor lectus nibh. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus. Quisque velit nisi, pretium ut lacinia in, elementum id enim. Pellentesque in ipsum id orci porta dapibus. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Donec velit neque, auctor sit amet aliquam vel, ullamcorper sit amet lig</p>[/et_pb_text][et_pb_counters bar_bg_color=\"#607cb3\" use_percentages=\"off\" _builder_version=\"3.17.6\" title_font=\"Muli|700||on|||||\" title_text_color=\"#41547d\" title_font_size=\"12px\" title_letter_spacing=\"2px\" title_line_height=\"2em\" percent_font=\"||||||||\" background_color=\"#f1f6ff\"][et_pb_counter percent=\"80\" _builder_version=\"3.17.6\" background_color_default=\"#f1f6ff\" background_enable_color_default=\"on\" parallax_default=\"off\" parallax_method_default=\"on\" bar_background_color_default=\"#607cb3\" use_percentages=\"off\" allow_player_pause_default=\"off\"]Men\'s Suit Construction[/et_pb_counter][et_pb_counter percent=\"60\" _builder_version=\"3.17.6\" background_color_default=\"#f1f6ff\" background_enable_color_default=\"on\" parallax_default=\"off\" parallax_method_default=\"on\" bar_background_color_default=\"#607cb3\" use_percentages=\"off\" allow_player_pause_default=\"off\"]Men\'s Suit Design[/et_pb_counter][et_pb_counter percent=\"50\" _builder_version=\"3.17.6\" background_color_default=\"#f1f6ff\" background_enable_color_default=\"on\" parallax_default=\"off\" parallax_method_default=\"on\" bar_background_color_default=\"#607cb3\" use_percentages=\"off\" allow_player_pause_default=\"off\"]Dress Alterations[/et_pb_counter][/et_pb_counters][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/portrait-06.jpg\" align_tablet=\"center\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\"][/et_pb_image][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"Cormorant Garamond||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_3_font=\"Cormorant Garamond|600|||||||\" header_3_font_size=\"30px\" header_3_line_height=\"1.4em\" header_4_font=\"Muli|700||on|||||\" header_4_text_color=\"#dfab82\" header_4_font_size=\"12px\" header_4_letter_spacing=\"2px\" header_4_line_height=\"2em\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_3_font_size_tablet=\"40px\" header_3_font_size_phone=\"30px\" header_3_font_size_last_edited=\"off|desktop\" locked=\"off\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h3>Edwin Richardson</h3>\n<h4>Designer &amp; Tailor</h4>\n<p>Sed porttitor lectus nibh. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus. Quisque velit nisi, pretium ut lacinia in, elementum id enim. Pellentesque in ipsum id orci porta dapibus. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Donec velit neque, auctor sit amet aliquam vel, ullamcorper sit amet lig</p>[/et_pb_text][et_pb_counters bar_bg_color=\"#607cb3\" use_percentages=\"off\" _builder_version=\"3.17.6\" title_font=\"Muli|700||on|||||\" title_text_color=\"#41547d\" title_font_size=\"12px\" title_letter_spacing=\"2px\" title_line_height=\"2em\" percent_font=\"||||||||\" background_color=\"#f1f6ff\" locked=\"off\"][et_pb_counter percent=\"80\" _builder_version=\"3.17.6\" background_color_default=\"#f1f6ff\" background_enable_color_default=\"on\" parallax_default=\"off\" parallax_method_default=\"on\" bar_background_color_default=\"#607cb3\" use_percentages=\"off\" allow_player_pause_default=\"off\"]Dress Design[/et_pb_counter][et_pb_counter percent=\"60\" _builder_version=\"3.17.6\" background_color_default=\"#f1f6ff\" background_enable_color_default=\"on\" parallax_default=\"off\" parallax_method_default=\"on\" bar_background_color_default=\"#607cb3\" use_percentages=\"off\" allow_player_pause_default=\"off\"]Dress Construction[/et_pb_counter][et_pb_counter percent=\"50\" _builder_version=\"3.17.6\" background_color_default=\"#f1f6ff\" background_enable_color_default=\"on\" parallax_default=\"off\" parallax_method_default=\"on\" bar_background_color_default=\"#607cb3\" use_percentages=\"off\" allow_player_pause_default=\"off\"]Suit Design[/et_pb_counter][/et_pb_counters][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonials\" _builder_version=\"3.22\" background_color=\"#ffffff\" custom_padding=\"0|0px|54px|0px|false|false\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_slider _builder_version=\"3.17.6\" body_font=\"Cormorant Garamond|600|on||||||\" body_font_size=\"26px\" body_line_height=\"1.8em\" background_color=\"#dfab82\" animation_style=\"flip\" body_font_size_tablet=\"20px\" body_font_size_phone=\"18px\" body_font_size_last_edited=\"on|phone\" box_shadow_style=\"preset1\" box_shadow_vertical=\"50px\" box_shadow_blur=\"60px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_slide _builder_version=\"3.17.6\"]<p>\"Quisque velit nisi, pretium ut lacinia in, elementum id enim. Mauris blandit aliquet elit, eget tincidunt nibh pulvinar a. Nulla quis lorem ut libero malesuada feugiat. Donec sollicitudin molestie malesuada. Donec sollicitudin molestie malesuada. Donec rutrum congue leo eget malesuada. Quisque velit nisi, pretium ut lacinia\"</p>[/et_pb_slide][et_pb_slide _builder_version=\"3.17.6\"]<p>\"Quisque velit nisi, pretium ut lacinia in, elementum id enim. Mauris blandit aliquet elit, eget tincidunt nibh pulvinar a. Nulla quis lorem ut libero malesuada feugiat. Donec sollicitudin molestie malesuada. Donec sollicitudin molestie malesuada. Donec rutrum congue leo eget malesuada. Quisque velit nisi, pretium ut lacinia\"</p>[/et_pb_slide][et_pb_slide _builder_version=\"3.17.6\"]<p>\"Quisque velit nisi, pretium ut lacinia in, elementum id enim. Mauris blandit aliquet elit, eget tincidunt nibh pulvinar a. Nulla quis lorem ut libero malesuada feugiat. Donec sollicitudin molestie malesuada. Donec sollicitudin molestie malesuada. Donec rutrum congue leo eget malesuada. Quisque velit nisi, pretium ut lacinia\"</p>[/et_pb_slide][et_pb_slide _builder_version=\"3.17.6\"]<p>\"Quisque velit nisi, pretium ut lacinia in, elementum id enim. Mauris blandit aliquet elit, eget tincidunt nibh pulvinar a. Nulla quis lorem ut libero malesuada feugiat. Donec sollicitudin molestie malesuada. Donec sollicitudin molestie malesuada. Donec rutrum congue leo eget malesuada. Quisque velit nisi, pretium ut lacinia\"</p>[/et_pb_slide][/et_pb_slider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#f1f6ff\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" header_font=\"Cormorant Garamond||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"Cormorant Garamond|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>Get In Touch!</h2>[/et_pb_text][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" locked=\"off\"]<p>Sed porttitor lectus nibh. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus. Quisque velit nisi, pretium ut lacinia in, elementum id enim. Pellentesque in ipsum id orci porta dapibus.</p>[/et_pb_text][et_pb_blurb title=\"Visit Our Shop\" use_icon=\"on\" font_icon=\"%%249%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"3.17.6\" header_font=\"Muli|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\"]<p>1234 Divi St. San Francisco, CA 19351</p>[/et_pb_blurb][et_pb_blurb title=\"Call Us\" use_icon=\"on\" font_icon=\"%%264%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"3.17.6\" header_font=\"Muli|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\"]<p>(235) 235-1351</p>[/et_pb_blurb][et_pb_blurb title=\"Email Us\" use_icon=\"on\" font_icon=\"%%238%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"3.17.6\" header_font=\"Muli|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\"]<p>info@divisuits.com</p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_row_inner _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"60px|0px|60px|0px|true|false\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_column_inner saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_contact_form captcha=\"off\" module_id=\"et_pb_contact_form_0\" _builder_version=\"3.23\" form_field_background_color=\"#f5f9ff\" form_field_font=\"Muli||||||||\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#41547d\" button_border_width=\"10px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"Muli|800||on|||||\" custom_padding=\"|40px||40px||true\" form_background_color=\"#f5f9ff\"][et_pb_contact_field field_id=\"Name\" field_title=\"Name\" fullwidth_field=\"on\" _builder_version=\"3.17.6\" custom_margin=\"||20px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Email\" field_title=\"Email Address\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"3.17.6\" custom_margin=\"||20px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Phone\" field_title=\"Phone Number\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"3.17.6\" custom_margin=\"||20px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Message\" field_title=\"Message\" field_type=\"text\" fullwidth_field=\"on\" _builder_version=\"3.17.6\" custom_margin=\"||30px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][/et_pb_contact_form][/et_pb_column_inner][/et_pb_row_inner][et_pb_row_inner _builder_version=\"3.25\"][et_pb_column_inner saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_social_media_follow _builder_version=\"3.17.6\" text_orientation=\"center\" border_radii=\"on|0px|0px|0px|0px\"][et_pb_social_media_follow_network social_network=\"instagram\" _builder_version=\"3.17.6\" background_color=\"#dfab82\" custom_margin=\"|6px||6px||true\" custom_padding=\"8px|8px|8px|8px|true|true\" follow_button=\"off\" url_new_window=\"on\"]instagram[/et_pb_social_media_follow_network][et_pb_social_media_follow_network social_network=\"facebook\" _builder_version=\"3.17.6\" background_color=\"#dfab82\" custom_margin=\"|6px||6px||true\" custom_padding=\"8px|8px|8px|8px|true|true\" follow_button=\"off\" url_new_window=\"on\"]facebook[/et_pb_social_media_follow_network][et_pb_social_media_follow_network social_network=\"twitter\" _builder_version=\"3.17.6\" background_color=\"#dfab82\" custom_margin=\"|6px||6px||true\" custom_padding=\"8px|8px|8px|8px|true|true\" follow_button=\"off\" url_new_window=\"on\"]twitter[/et_pb_social_media_follow_network][/et_pb_social_media_follow][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section]", "درباره ما", "", "inherit", "closed", "closed", "", "187-revision-v1", "", "", "2020-03-31 11:41:21", "2020-03-31 08:11:21", "", "187", "http://modelsite.test/187-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2813", "1", "2020-03-31 11:42:41", "2020-03-31 08:12:41", "[et_pb_section fb_built=\"1\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(48,57,78,0.95)\" background_color_gradient_end=\"rgba(96,124,179,0.85)\" background_color_gradient_direction=\"60deg\" background_color_gradient_overlays_image=\"on\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-18.jpg\" custom_padding=\"6vw||6vw||true\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"Cormorant Garamond|600|||||||\" header_font_size=\"60px\" header_line_height=\"1.4em\" header_2_font=\"Cormorant Garamond|600|||||||\" header_2_text_color=\"#dfab82\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" text_orientation=\"center\" background_layout=\"dark\" max_width=\"800px\" module_alignment=\"center\" custom_margin=\"||40px\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h1>Our Services</h1>\r\n<h2>Custom Suits &amp; Alterations</h2>\r\nSed porttitor lectus nibh. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus. Quisque velit nisi, pretium ut lacinia in, elementum id enim. Pellentesque in ipsum id orci porta dapibus. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubi\r[/et_pb_text][et_pb_button button_text=\"Make an Appointment\" button_alignment=\"center\" _builder_version=\"3.17.6\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"Muli|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" padding_top_2=\"7vw\" admin_label=\"Services\" _builder_version=\"3.22\" background_color=\"#f7f9fc\" locked=\"off\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" header_font=\"Cormorant Garamond||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"Cormorant Garamond|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>We Design Custom Suits, Shirts, Shoes, Repairs, &amp; Alterations</h2>\r[/et_pb_text][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-09.jpg\" align_tablet=\"center\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\"][/et_pb_image][et_pb_button button_text=\"Make an Appointment\" _builder_version=\"3.17.6\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"Muli|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" padding_top__hover=\"7vw\" custom_padding__hover=\"|||\"][et_pb_row_inner _builder_version=\"3.25\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" max_width__hover=\"100%\" max_width__hover_enabled=\"100%\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\" column_structure=\"1_2,1_2\"][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" parallax__hover_enabled=\"off\" parallax_method__hover_enabled=\"on\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-04.png\" _builder_version=\"3.23\" always_center_on_mobile=\"off\" locked=\"off\"][/et_pb_image][et_pb_blurb title=\"Congue Leo Malesuada \" content_max_width=\"1100px\" _builder_version=\"3.17.6\" header_font=\"Muli|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" locked=\"off\"]Proin eget tortor risus. Donec sollicitudin molestie malesuada. Donec rutrum congue leo eget malesuada. us.\r[/et_pb_blurb][/et_pb_column_inner][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" parallax__hover_enabled=\"off\" parallax_method__hover_enabled=\"on\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-10.png\" _builder_version=\"3.23\" always_center_on_mobile=\"off\" locked=\"off\"][/et_pb_image][et_pb_blurb title=\"Proin Eget Tortor\" content_max_width=\"1100px\" _builder_version=\"3.17.6\" header_font=\"Muli|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" locked=\"off\"]Proin eget tortor risus. Donec sollicitudin molestie malesuada. Donec rutrum congue leo eget malesuada.\r[/et_pb_blurb][/et_pb_column_inner][/et_pb_row_inner][et_pb_row_inner _builder_version=\"3.25\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" max_width__hover=\"100%\" max_width__hover_enabled=\"100%\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\" column_structure=\"1_2,1_2\"][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" parallax__hover_enabled=\"off\" parallax_method__hover_enabled=\"on\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-09.png\" _builder_version=\"3.23\" always_center_on_mobile=\"off\" locked=\"off\"][/et_pb_image][et_pb_blurb title=\"Congue Leo Malesuada \" content_max_width=\"1100px\" _builder_version=\"3.17.6\" header_font=\"Muli|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" locked=\"off\"]Proin eget tortor risus. Donec sollicitudin molestie malesuada. Donec rutrum congue leo eget malesuada. us.\r[/et_pb_blurb][/et_pb_column_inner][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" parallax__hover_enabled=\"off\" parallax_method__hover_enabled=\"on\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-06.png\" _builder_version=\"3.23\" always_center_on_mobile=\"off\" locked=\"off\"][/et_pb_image][et_pb_blurb title=\"Proin Eget Tortor\" content_max_width=\"1100px\" _builder_version=\"3.17.6\" header_font=\"Muli|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" locked=\"off\"]Proin eget tortor risus. Donec sollicitudin molestie malesuada. Donec rutrum congue leo eget malesuada.\r[/et_pb_blurb][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Services\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_row custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#41547d\" custom_padding=\"80px|60px|80px|60px|true|true\" custom_padding_tablet=\"\" custom_padding_phone=\"60px|40px|60px|40px|true|true\" column_structure=\"1_2,1_2\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"Cormorant Garamond||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"Cormorant Garamond|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" background_layout=\"dark\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>Bespoke Suits Made With Comfort in Mind</h2>\r[/et_pb_text][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" background_layout=\"dark\" locked=\"off\"]Sed porttitor lectus nibh. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus. Quisque velit nisi, pretium ut lacinia in, elementum id enim. Pellentesque in ipsum id orci porta dapibus. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Donec velit neque, auctor sit amet aliquam vel, ullamcorper sit amet lig\r[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"Only the Finest Materials\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-08-1.png\" icon_placement=\"left\" image_max_width=\"90px\" content_max_width=\"1100px\" image_max_width_tablet=\"\" image_max_width_phone=\"45px\" image_max_width_last_edited=\"on|phone\" _builder_version=\"3.17.6\" header_font=\"Muli|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" background_layout=\"dark\" locked=\"off\"]Sed porttitor lectus nibh. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus. Quisque velit nisi, pretium ut lacinia in, elementum id enim.\r[/et_pb_blurb][et_pb_blurb title=\"Designed & Cut to Perfection\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-06-1.png\" icon_placement=\"left\" image_max_width=\"90px\" content_max_width=\"1100px\" image_max_width_tablet=\"\" image_max_width_phone=\"45px\" image_max_width_last_edited=\"on|phone\" _builder_version=\"3.17.6\" header_font=\"Muli|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" background_layout=\"dark\" locked=\"off\"]Sed porttitor lectus nibh. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus. Quisque velit nisi, pretium ut lacinia in, elementum id enim.\r[/et_pb_blurb][et_pb_blurb title=\"Constructed In Our Shop\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-02-1.png\" icon_placement=\"left\" image_max_width=\"90px\" content_max_width=\"1100px\" image_max_width_tablet=\"\" image_max_width_phone=\"45px\" image_max_width_last_edited=\"on|phone\" _builder_version=\"3.17.6\" header_font=\"Muli|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" background_layout=\"dark\" locked=\"off\"]Sed porttitor lectus nibh. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus. Quisque velit nisi, pretium ut lacinia in, elementum id enim.\r[/et_pb_blurb][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" custom_padding=\"0|0px|27px|0px|false|false\" locked=\"off\" column_structure=\"1_2,1_2\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"Cormorant Garamond|600|||||||\" text_font_size=\"24px\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_2_font=\"||||||||\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" background_color=\"#dfab82\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-01.png\" background_position=\"bottom_right\" background_layout=\"dark\" custom_margin=\"|||0%\" custom_padding=\"50px|60px|50px|60px|true|true\" animation_direction=\"left\" link_option_url=\"#\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\" custom_padding__hover_enabled=\"on\" custom_padding__hover=\"|40px||80px||false\" background__hover_enabled=\"on\" background_color__hover=\"#ddb494\"]Make an Appointment[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Service\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_row _builder_version=\"3.25\" column_structure=\"1_2,1_2\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" header_font=\"Cormorant Garamond||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"Cormorant Garamond|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>Have An Existing Suit that Needs Repairing or Altering?</h2>\r[/et_pb_text][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" locked=\"off\"]Sed porttitor lectus nibh. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus. Quisque velit nisi, pretium ut lacinia in, elementum id enim. Pellentesque in ipsum id orci porta dapibus. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Donec velit neque, auctor sit amet aliquam vel, ullamcorper sit amet lig\r[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-06.jpg\" align_tablet=\"center\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\"][/et_pb_image][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-07.jpg\" align_tablet=\"center\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" max_width=\"70%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" border_color_all=\"#ffffff\" border_width_right=\"20px\" border_width_bottom=\"20px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][/et_pb_image][et_pb_button button_text=\"Make an Appointment\" _builder_version=\"3.17.6\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"Muli|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"right\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"About\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" header_font=\"Cormorant Garamond||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"Cormorant Garamond|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" text_orientation=\"center\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>Other Services</h2>\r[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row use_custom_gutter=\"on\" gutter_width=\"2\" padding_top_bottom_link_1=\"true\" padding_top_bottom_link_2=\"true\" padding_top_bottom_link_3=\"true\" padding_left_right_link_1=\"true\" padding_left_right_link_2=\"true\" padding_left_right_link_3=\"true\" _builder_version=\"3.25\" column_structure=\"1_3,1_3,1_3\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"30px|30px|30px|30px\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-16.jpg\" align_tablet=\"center\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\"][/et_pb_image][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"Cormorant Garamond||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_3_font=\"Cormorant Garamond|600|||||||\" header_3_font_size=\"20px\" header_3_line_height=\"1.4em\" header_4_font=\"Muli|700||on|||||\" header_4_text_color=\"#dfab82\" header_4_font_size=\"12px\" header_4_letter_spacing=\"2px\" header_4_line_height=\"2em\" text_orientation=\"center\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_3_font_size_tablet=\"40px\" header_3_font_size_phone=\"30px\" header_3_font_size_last_edited=\"off|desktop\" locked=\"off\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h3>Groomsmen Suits</h3>\r\nSed porttitor lectus nibh. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus. Quisque velit nisi, pretium ut lacinia in, elementum id enim. Pellentesque in\r[/et_pb_text][et_pb_button button_text=\"Lern More\" button_alignment=\"center\" _builder_version=\"3.17.6\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"Muli|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"30px|30px|30px|30px\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-13.jpg\" align_tablet=\"center\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"Cormorant Garamond||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_3_font=\"Cormorant Garamond|600|||||||\" header_3_font_size=\"20px\" header_3_line_height=\"1.4em\" header_4_font=\"Muli|700||on|||||\" header_4_text_color=\"#dfab82\" header_4_font_size=\"12px\" header_4_letter_spacing=\"2px\" header_4_line_height=\"2em\" text_orientation=\"center\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_3_font_size_tablet=\"40px\" header_3_font_size_phone=\"30px\" header_3_font_size_last_edited=\"off|desktop\" locked=\"off\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h3>Blazers &amp; Coats</h3>\r\nSed porttitor lectus nibh. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus. Quisque velit nisi, pretium ut lacinia in, elementum id enim. Pellentesque in\r[/et_pb_text][et_pb_button button_text=\"Lern More\" button_alignment=\"center\" _builder_version=\"3.17.6\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"Muli|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"30px|30px|30px|30px\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-12.jpg\" align_tablet=\"center\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"Cormorant Garamond||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_3_font=\"Cormorant Garamond|600|||||||\" header_3_font_size=\"20px\" header_3_line_height=\"1.4em\" header_4_font=\"Muli|700||on|||||\" header_4_text_color=\"#dfab82\" header_4_font_size=\"12px\" header_4_letter_spacing=\"2px\" header_4_line_height=\"2em\" text_orientation=\"center\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_3_font_size_tablet=\"40px\" header_3_font_size_phone=\"30px\" header_3_font_size_last_edited=\"off|desktop\" locked=\"off\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h3>Tuxedos</h3>\r\nSed porttitor lectus nibh. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus. Quisque velit nisi, pretium ut lacinia in, elementum id enim. Pellentesque in\r[/et_pb_text][et_pb_button button_text=\"Lern More\" button_alignment=\"center\" _builder_version=\"3.17.6\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"Muli|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row use_custom_gutter=\"on\" gutter_width=\"2\" padding_top_bottom_link_1=\"true\" padding_top_bottom_link_2=\"true\" padding_top_bottom_link_3=\"true\" padding_left_right_link_1=\"true\" padding_left_right_link_2=\"true\" padding_left_right_link_3=\"true\" _builder_version=\"3.25\" column_structure=\"1_3,1_3,1_3\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"30px|30px|30px|30px\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-11.jpg\" align_tablet=\"center\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\"][/et_pb_image][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"Cormorant Garamond||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_3_font=\"Cormorant Garamond|600|||||||\" header_3_font_size=\"20px\" header_3_line_height=\"1.4em\" header_4_font=\"Muli|700||on|||||\" header_4_text_color=\"#dfab82\" header_4_font_size=\"12px\" header_4_letter_spacing=\"2px\" header_4_line_height=\"2em\" text_orientation=\"center\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_3_font_size_tablet=\"40px\" header_3_font_size_phone=\"30px\" header_3_font_size_last_edited=\"off|desktop\" locked=\"off\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h3>Custom Dress Shirts</h3>\r\nSed porttitor lectus nibh. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus. Quisque velit nisi, pretium ut lacinia in, elementum id enim. Pellentesque in\r[/et_pb_text][et_pb_button button_text=\"Lern More\" button_alignment=\"center\" _builder_version=\"3.17.6\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"Muli|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"30px|30px|30px|30px\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-14.jpg\" align_tablet=\"center\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"Cormorant Garamond||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_3_font=\"Cormorant Garamond|600|||||||\" header_3_font_size=\"20px\" header_3_line_height=\"1.4em\" header_4_font=\"Muli|700||on|||||\" header_4_text_color=\"#dfab82\" header_4_font_size=\"12px\" header_4_letter_spacing=\"2px\" header_4_line_height=\"2em\" text_orientation=\"center\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_3_font_size_tablet=\"40px\" header_3_font_size_phone=\"30px\" header_3_font_size_last_edited=\"off|desktop\" locked=\"off\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h3>Dress Shoes</h3>\r\nSed porttitor lectus nibh. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus. Quisque velit nisi, pretium ut lacinia in, elementum id enim. Pellentesque in\r[/et_pb_text][et_pb_button button_text=\"Lern More\" button_alignment=\"center\" _builder_version=\"3.17.6\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"Muli|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"30px|30px|30px|30px\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-15.jpg\" align_tablet=\"center\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"Cormorant Garamond||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_3_font=\"Cormorant Garamond|600|||||||\" header_3_font_size=\"20px\" header_3_line_height=\"1.4em\" header_4_font=\"Muli|700||on|||||\" header_4_text_color=\"#dfab82\" header_4_font_size=\"12px\" header_4_letter_spacing=\"2px\" header_4_line_height=\"2em\" text_orientation=\"center\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_3_font_size_tablet=\"40px\" header_3_font_size_phone=\"30px\" header_3_font_size_last_edited=\"off|desktop\" locked=\"off\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h3>Accessories</h3>\r\nSed porttitor lectus nibh. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus. Quisque velit nisi, pretium ut lacinia in, elementum id enim. Pellentesque in\r[/et_pb_text][et_pb_button button_text=\"Lern More\" button_alignment=\"center\" _builder_version=\"3.17.6\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"Muli|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonials\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#f7f9fc\" background_color_gradient_end=\"#ffffff\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" inner_shadow__hover=\"off\" inner_shadow__hover_enabled=\"off\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" max_width__hover=\"100%\" max_width__hover_enabled=\"100%\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_slider _builder_version=\"3.17.6\" body_font=\"Cormorant Garamond|600|on||||||\" body_font_size=\"26px\" body_line_height=\"1.8em\" background_color=\"#dfab82\" animation_style=\"flip\" body_font_size_tablet=\"20px\" body_font_size_phone=\"18px\" body_font_size_last_edited=\"on|phone\" box_shadow_style=\"preset1\" box_shadow_vertical=\"50px\" box_shadow_blur=\"60px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\"][et_pb_slide _builder_version=\"3.17.6\"]\"Quisque velit nisi, pretium ut lacinia in, elementum id enim. Mauris blandit aliquet elit, eget tincidunt nibh pulvinar a. Nulla quis lorem ut libero malesuada feugiat. Donec sollicitudin molestie malesuada. Donec sollicitudin molestie malesuada. Donec rutrum congue leo eget malesuada. Quisque velit nisi, pretium ut lacinia\"\r[/et_pb_slide][et_pb_slide _builder_version=\"3.17.6\"]\"Quisque velit nisi, pretium ut lacinia in, elementum id enim. Mauris blandit aliquet elit, eget tincidunt nibh pulvinar a. Nulla quis lorem ut libero malesuada feugiat. Donec sollicitudin molestie malesuada. Donec sollicitudin molestie malesuada. Donec rutrum congue leo eget malesuada. Quisque velit nisi, pretium ut lacinia\"\r[/et_pb_slide][et_pb_slide _builder_version=\"3.17.6\"]\"Quisque velit nisi, pretium ut lacinia in, elementum id enim. Mauris blandit aliquet elit, eget tincidunt nibh pulvinar a. Nulla quis lorem ut libero malesuada feugiat. Donec sollicitudin molestie malesuada. Donec sollicitudin molestie malesuada. Donec rutrum congue leo eget malesuada. Quisque velit nisi, pretium ut lacinia\"\r[/et_pb_slide][et_pb_slide _builder_version=\"3.17.6\"]\"Quisque velit nisi, pretium ut lacinia in, elementum id enim. Mauris blandit aliquet elit, eget tincidunt nibh pulvinar a. Nulla quis lorem ut libero malesuada feugiat. Donec sollicitudin molestie malesuada. Donec sollicitudin molestie malesuada. Donec rutrum congue leo eget malesuada. Quisque velit nisi, pretium ut lacinia\"\r[/et_pb_slide][/et_pb_slider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#f1f6ff\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" header_font=\"Cormorant Garamond||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"Cormorant Garamond|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>Get In Touch!</h2>\r[/et_pb_text][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" locked=\"off\"]Sed porttitor lectus nibh. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus. Quisque velit nisi, pretium ut lacinia in, elementum id enim. Pellentesque in ipsum id orci porta dapibus.\r[/et_pb_text][et_pb_blurb title=\"Visit Our Shop\" use_icon=\"on\" font_icon=\"%%249%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"3.17.6\" header_font=\"Muli|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\"]1234 Divi St. San Francisco, CA 19351\r[/et_pb_blurb][et_pb_blurb title=\"Call Us\" use_icon=\"on\" font_icon=\"%%264%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"3.17.6\" header_font=\"Muli|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\"](235) 235-1351\r[/et_pb_blurb][et_pb_blurb title=\"Email Us\" use_icon=\"on\" font_icon=\"%%238%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"3.17.6\" header_font=\"Muli|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\"]info@divisuits.com\r[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_row_inner _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"60px|0px|60px|0px|true|false\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_column_inner saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_contact_form captcha=\"off\" module_id=\"et_pb_contact_form_0\" _builder_version=\"3.23\" form_field_background_color=\"#f5f9ff\" form_field_font=\"Muli||||||||\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#41547d\" button_border_width=\"10px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"Muli|800||on|||||\" custom_padding=\"|40px||40px||true\" form_background_color=\"#f5f9ff\"][et_pb_contact_field field_id=\"Name\" field_title=\"Name\" fullwidth_field=\"on\" _builder_version=\"3.17.6\" custom_margin=\"||20px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Email\" field_title=\"Email Address\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"3.17.6\" custom_margin=\"||20px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Phone\" field_title=\"Phone Number\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"3.17.6\" custom_margin=\"||20px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Message\" field_title=\"Message\" field_type=\"text\" fullwidth_field=\"on\" _builder_version=\"3.17.6\" custom_margin=\"||30px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][/et_pb_contact_form][/et_pb_column_inner][/et_pb_row_inner][et_pb_row_inner _builder_version=\"3.25\"][et_pb_column_inner saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_social_media_follow _builder_version=\"3.17.6\" text_orientation=\"center\" border_radii=\"on|0px|0px|0px|0px\"][et_pb_social_media_follow_network social_network=\"instagram\" _builder_version=\"3.17.6\" background_color=\"#dfab82\" custom_margin=\"|6px||6px||true\" custom_padding=\"8px|8px|8px|8px|true|true\" follow_button=\"off\" url_new_window=\"on\"]instagram[/et_pb_social_media_follow_network][et_pb_social_media_follow_network social_network=\"facebook\" _builder_version=\"3.17.6\" background_color=\"#dfab82\" custom_margin=\"|6px||6px||true\" custom_padding=\"8px|8px|8px|8px|true|true\" follow_button=\"off\" url_new_window=\"on\"]facebook[/et_pb_social_media_follow_network][et_pb_social_media_follow_network social_network=\"twitter\" _builder_version=\"3.17.6\" background_color=\"#dfab82\" custom_margin=\"|6px||6px||true\" custom_padding=\"8px|8px|8px|8px|true|true\" follow_button=\"off\" url_new_window=\"on\"]twitter[/et_pb_social_media_follow_network][/et_pb_social_media_follow][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section]", "خدمات", "", "inherit", "closed", "closed", "", "899-revision-v1", "", "", "2020-03-31 11:42:41", "2020-03-31 08:12:41", "", "899", "http://modelsite.test/899-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2814", "1", "2020-03-31 11:43:32", "2020-03-31 08:13:32", "[et_pb_section fb_built=\"1\" admin_label=\"Header\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"Cormorant Garamond|600|||||||\" header_font_size=\"60px\" header_line_height=\"1.4em\" header_2_font=\"Cormorant Garamond|600|||||||\" header_2_text_color=\"#dfab82\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" text_orientation=\"center\" max_width=\"800px\" module_alignment=\"center\" custom_margin=\"||40px\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h1>Our Blog</h1>\r[/et_pb_text][et_pb_button button_text=\"Subscribe\" button_alignment=\"center\" _builder_version=\"3.17.6\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"Muli|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Blog\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_blog fullwidth=\"off\" posts_number=\"6\" _builder_version=\"3.17.6\" header_level=\"h4\" header_font=\"Muli|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" meta_font=\"|600|||||||\" meta_text_color=\"#dfab82\" meta_font_size=\"12px\" pagination_font=\"Cormorant Garamond|600|||||||\" pagination_text_color=\"rgba(48,57,78,0.95)\" pagination_font_size=\"24px\" border_width_all=\"0px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"80px\" box_shadow_blur=\"80px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][/et_pb_blog][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Resources\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" header_font=\"Cormorant Garamond||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"Cormorant Garamond|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>Resources From Our Experts</h2>\r[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#ffffff\" custom_margin=\"||60px|||false\" custom_padding=\"60px|60px|60px|60px|true|true\" custom_padding_tablet=\"\" custom_padding_phone=\"|40px||40px||true\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" column_structure=\"1_2,1_2\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" header_font=\"Cormorant Garamond||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_3_font=\"Cormorant Garamond|600|||||||\" header_3_font_size=\"30px\" header_3_line_height=\"1.4em\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_3_font_size_phone=\"30px\" header_3_font_size_last_edited=\"off|desktop\" locked=\"off\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h3>Taking Care of Your Bespoke Suit</h3>\r[/et_pb_text][et_pb_button button_text=\"Downloa Full Resource\" _builder_version=\"3.17.6\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"Muli|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" locked=\"off\"]Sed porttitor lectus nibh. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus. Quisque velit nisi, pretium ut lacinia in, elementum id enim. Pellentesque in ipsum id orci porta dapibus. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Donec velit neque, auctor sit amet aliquam vel, ullamcorper sit amet lig\r[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#ffffff\" custom_margin=\"||60px|||false\" custom_padding=\"60px|60px|60px|60px|true|true\" custom_padding_tablet=\"\" custom_padding_phone=\"|40px||40px||true\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" column_structure=\"1_2,1_2\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" header_font=\"Cormorant Garamond||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_3_font=\"Cormorant Garamond|600|||||||\" header_3_font_size=\"30px\" header_3_line_height=\"1.4em\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_3_font_size_phone=\"30px\" header_3_font_size_last_edited=\"off|desktop\" locked=\"off\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h3>Taking Your Own Measurements</h3>\r[/et_pb_text][et_pb_button button_text=\"Downloa Full Resource\" _builder_version=\"3.17.6\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"Muli|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" locked=\"off\"]Sed porttitor lectus nibh. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus. Quisque velit nisi, pretium ut lacinia in, elementum id enim. Pellentesque in ipsum id orci porta dapibus. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Donec velit neque, auctor sit amet aliquam vel, ullamcorper sit amet lig\r[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#ffffff\" custom_margin=\"||60px|||false\" custom_padding=\"60px|60px|60px|60px|true|true\" custom_padding_tablet=\"\" custom_padding_phone=\"|40px||40px||true\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" column_structure=\"1_2,1_2\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" header_font=\"Cormorant Garamond||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_3_font=\"Cormorant Garamond|600|||||||\" header_3_font_size=\"30px\" header_3_line_height=\"1.4em\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_3_font_size_phone=\"30px\" header_3_font_size_last_edited=\"off|desktop\" locked=\"off\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h3>Making Your Own Suit</h3>\r[/et_pb_text][et_pb_button button_text=\"Downloa Full Resource\" _builder_version=\"3.17.6\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"Muli|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" locked=\"off\"]Sed porttitor lectus nibh. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus. Quisque velit nisi, pretium ut lacinia in, elementum id enim. Pellentesque in ipsum id orci porta dapibus. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Donec velit neque, auctor sit amet aliquam vel, ullamcorper sit amet lig\r[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Subscribe\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#f7f9fc\" background_color_gradient_end=\"#ffffff\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" inner_shadow__hover=\"off\" inner_shadow__hover_enabled=\"off\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" max_width__hover=\"100%\" max_width__hover_enabled=\"100%\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_row custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#dfab82\" custom_padding=\"80px|60px|80px|60px|true|true\" custom_padding_tablet=\"\" custom_padding_phone=\"60px|40px|60px|40px|true|true\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_signup mailchimp_list=\"elegantthemestest|26e9af0331\" layout=\"top_bottom\" name_field=\"on\" title=\"Join Our Newsletter\" description=\"\r\n\r\nCurabitur aliquet quam id dui posuere blandit. Nulla porttitor accumsan tincidunt. Donec sollicitudin molestie malesuada. Praesent sapien massa, convallis a pell\r\n\r\n\" _builder_version=\"3.23\" form_field_background_color=\"rgba(255,255,255,0.27)\" form_field_text_color=\"#ffffff\" header_font=\"Cormorant Garamond||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_line_height=\"2em\" form_field_font=\"Muli||||||||\" use_background_color=\"off\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#41547d\" button_bg_color=\"#ffffff\" button_border_width=\"10px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"Muli|800||on|||||\" text_orientation=\"center\" max_width=\"600px\" module_alignment=\"center\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" border_radii_fields=\"on|0px|0px|0px|0px\"][/et_pb_signup][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#f1f6ff\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" header_font=\"Cormorant Garamond||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"Cormorant Garamond|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>Get In Touch!</h2>\r[/et_pb_text][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" locked=\"off\"]Sed porttitor lectus nibh. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus. Quisque velit nisi, pretium ut lacinia in, elementum id enim. Pellentesque in ipsum id orci porta dapibus.\r[/et_pb_text][et_pb_blurb title=\"Visit Our Shop\" use_icon=\"on\" font_icon=\"%%249%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"3.17.6\" header_font=\"Muli|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\"]1234 Divi St. San Francisco, CA 19351\r[/et_pb_blurb][et_pb_blurb title=\"Call Us\" use_icon=\"on\" font_icon=\"%%264%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"3.17.6\" header_font=\"Muli|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\"](235) 235-1351\r[/et_pb_blurb][et_pb_blurb title=\"Email Us\" use_icon=\"on\" font_icon=\"%%238%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"3.17.6\" header_font=\"Muli|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\"]info@divisuits.com\r[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_row_inner _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"60px|0px|60px|0px|true|false\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_column_inner saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_contact_form captcha=\"off\" module_id=\"et_pb_contact_form_0\" _builder_version=\"3.23\" form_field_background_color=\"#f5f9ff\" form_field_font=\"Muli||||||||\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#41547d\" button_border_width=\"10px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"Muli|800||on|||||\" custom_padding=\"|40px||40px||true\" form_background_color=\"#f5f9ff\"][et_pb_contact_field field_id=\"Name\" field_title=\"Name\" fullwidth_field=\"on\" _builder_version=\"3.17.6\" custom_margin=\"||20px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Email\" field_title=\"Email Address\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"3.17.6\" custom_margin=\"||20px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Phone\" field_title=\"Phone Number\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"3.17.6\" custom_margin=\"||20px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Message\" field_title=\"Message\" field_type=\"text\" fullwidth_field=\"on\" _builder_version=\"3.17.6\" custom_margin=\"||30px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][/et_pb_contact_form][/et_pb_column_inner][/et_pb_row_inner][et_pb_row_inner _builder_version=\"3.25\"][et_pb_column_inner saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_social_media_follow _builder_version=\"3.17.6\" text_orientation=\"center\" border_radii=\"on|0px|0px|0px|0px\"][et_pb_social_media_follow_network social_network=\"instagram\" _builder_version=\"3.17.6\" background_color=\"#dfab82\" custom_margin=\"|6px||6px||true\" custom_padding=\"8px|8px|8px|8px|true|true\" follow_button=\"off\" url_new_window=\"on\"]instagram[/et_pb_social_media_follow_network][et_pb_social_media_follow_network social_network=\"facebook\" _builder_version=\"3.17.6\" background_color=\"#dfab82\" custom_margin=\"|6px||6px||true\" custom_padding=\"8px|8px|8px|8px|true|true\" follow_button=\"off\" url_new_window=\"on\"]facebook[/et_pb_social_media_follow_network][et_pb_social_media_follow_network social_network=\"twitter\" _builder_version=\"3.17.6\" background_color=\"#dfab82\" custom_margin=\"|6px||6px||true\" custom_padding=\"8px|8px|8px|8px|true|true\" follow_button=\"off\" url_new_window=\"on\"]twitter[/et_pb_social_media_follow_network][/et_pb_social_media_follow][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section]", "وبلاگ", "", "inherit", "closed", "closed", "", "267-revision-v1", "", "", "2020-03-31 11:43:32", "2020-03-31 08:13:32", "", "267", "http://modelsite.test/267-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2815", "1", "2020-03-31 11:44:47", "2020-03-31 08:14:47", "[et_pb_section fb_built=\"1\" _builder_version=\"4.4.2\" bottom_divider_style=\"asymmetric2\" bottom_divider_color=\"#dfab82\" hover_enabled=\"0\"][et_pb_row _builder_version=\"4.4.2\"][et_pb_column type=\"4_4\" _builder_version=\"4.4.2\"][dsm_gradient_text gradient_text=\"گالری نمونه کارها\" _builder_version=\"4.4.2\" header_text_color=\"#ff8675\" background_color_gradient_start=\"#ff8675\"][/dsm_gradient_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" _builder_version=\"4.4.2\" bottom_divider_color=\"#ff8675\"][et_pb_row _builder_version=\"4.4.2\"][et_pb_column type=\"4_4\" _builder_version=\"4.4.2\"][et_pb_gallery gallery_ids=\"2678,2679,2680,2705\" orientation=\"portrait\" hover_icon=\"%%16%%\" _builder_version=\"4.4.2\"][/et_pb_gallery][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" _builder_version=\"4.4.2\" bottom_divider_style=\"graph2\" bottom_divider_color=\"#dfab82\" hover_enabled=\"0\"][/et_pb_section]", "گالری", "", "inherit", "closed", "closed", "", "2392-revision-v1", "", "", "2020-03-31 11:44:47", "2020-03-31 08:14:47", "", "2392", "http://modelsite.test/2392-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2817", "1", "2020-03-31 11:46:38", "2020-03-31 08:16:38", "[et_pb_section fb_built=\"1\" _builder_version=\"4.4.2\" bottom_divider_style=\"asymmetric2\" bottom_divider_color=\"#dfab82\" hover_enabled=\"0\"][et_pb_row _builder_version=\"4.4.2\"][et_pb_column type=\"4_4\" _builder_version=\"4.4.2\"][dsm_gradient_text gradient_text=\"گالری نمونه کارها\" _builder_version=\"4.4.2\" header_text_color=\"#ff8675\" background_color_gradient_start=\"#ff8675\"][/dsm_gradient_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" _builder_version=\"4.4.2\" bottom_divider_color=\"#ff8675\"][et_pb_row _builder_version=\"4.4.2\"][et_pb_column type=\"4_4\" _builder_version=\"4.4.2\"][et_pb_gallery gallery_ids=\"2797,2783,2802,2782\" orientation=\"portrait\" hover_icon=\"%%16%%\" _builder_version=\"4.4.2\" hover_enabled=\"0\"][/et_pb_gallery][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" _builder_version=\"4.4.2\" bottom_divider_style=\"graph2\" bottom_divider_color=\"#dfab82\" hover_enabled=\"0\"][/et_pb_section]", "گالری", "", "inherit", "closed", "closed", "", "2392-revision-v1", "", "", "2020-03-31 11:46:38", "2020-03-31 08:16:38", "", "2392", "http://modelsite.test/2392-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2818", "1", "2020-03-31 13:39:13", "2020-03-31 10:09:13", "http://modelsite.test/wp-content/uploads/2020/03/cropped-tailor-icon-10.png", "cropped-tailor-icon-10.png", "", "inherit", "open", "closed", "", "cropped-tailor-icon-10-png", "", "", "2020-03-31 13:39:13", "2020-03-31 10:09:13", "", "0", "http://modelsite.test/wp-content/uploads/2020/03/cropped-tailor-icon-10.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("2819", "1", "2020-03-31 13:39:35", "2020-03-31 10:09:35", "{\n    \"site_icon\": {\n        \"value\": 2818,\n        \"type\": \"option\",\n        \"user_id\": 1,\n        \"date_modified_gmt\": \"2020-03-31 10:09:35\"\n    },\n    \"et_divi[header_style]\": {\n        \"value\": \"split\",\n        \"type\": \"option\",\n        \"user_id\": 1,\n        \"date_modified_gmt\": \"2020-03-31 10:09:35\"\n    }\n}", "", "", "trash", "closed", "closed", "", "210e2048-730e-4178-9dd3-9b4f045044de", "", "", "2020-03-31 13:39:35", "2020-03-31 10:09:35", "", "0", "http://modelsite.test/210e2048-730e-4178-9dd3-9b4f045044de/", "0", "customize_changeset", "", "0");
INSERT INTO `wp_posts` VALUES("2822", "1", "2020-03-31 14:12:39", "2020-03-31 10:42:39", "[et_pb_section fb_built=\"1\" use_custom_gutter=\"on\" gutter_width=\"1\" admin_label=\"Header\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#f7f9fc\" background_color_gradient_start_position=\"75%\" background_color_gradient_end_position=\"75%\" custom_padding=\"0|0px|0|0px|false|false\" hover_enabled=\"0\"][et_pb_row column_structure=\"1_2,1_2\" use_custom_gutter=\"on\" gutter_width=\"1\" make_equal=\"on\" padding_top_bottom_link_1=\"true\" _builder_version=\"3.25\" custom_padding=\"0|0px|0|0px|false|false\" hover_enabled=\"0\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"8vw|60px|8vw|\" custom_padding_tablet=\"|0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"|0px||\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"|600|||||||\" header_font_size=\"60px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_text_color=\"#dfab82\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" custom_margin=\"||40px\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\"]<h1>خیاطی مردانه</h1>\n<h2>شیک پوش باشید </h2>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"آنلاین رزرو کنید\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#41547d\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(65,84,125,0.24)\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][et_pb_button button_text=\"یا تماس بگیرید : 12345-021\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#41547d\" button_bg_color=\"#ffffff\" button_border_width=\"0px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(65,84,125,0.06)\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_text_color_last_edited=\"on|desktop\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#af8447\" button_bg_enable_color__hover=\"on\" button_text_color__hover_enabled=\"on|hover\" button_text_color__hover=\"#ffffff\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-02.jpg\" parallax=\"on\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider show_divider=\"off\" disabled_on=\"off|off|on\" _builder_version=\"3.17.6\" height=\"250px\" hover_enabled=\"0\"][/et_pb_divider][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" use_custom_gutter=\"on\" gutter_width=\"1\" padding_top_bottom_link_2=\"false\" _builder_version=\"3.25\" custom_padding=\"0|0px|27px|0px|false|false\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_video src=\"#\" image_src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-03.jpg\" _builder_version=\"4.4.2\" custom_margin=\"|||-80px\" custom_margin_tablet=\"|||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" hover_enabled=\"0\"][/et_pb_video][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"100px|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-04.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" max_width=\"80%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" box_shadow_style=\"preset1\" box_shadow_horizontal=\"-41px\" box_shadow_vertical=\"45px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(0,0,0,0.52)\" locked=\"off\"][/et_pb_image][et_pb_text _builder_version=\"4.4.2\" text_font=\"|600|||||||\" text_font_size=\"24px\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_2_font=\"||||||||\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" background_color=\"#dfab82\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-01.png\" background_position=\"bottom_right\" background_layout=\"dark\" custom_margin=\"|||0%\" custom_padding=\"50px|60px|50px|60px|true|true\" animation_direction=\"left\" link_option_url=\"#\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\" custom_padding__hover_enabled=\"on\" custom_padding__hover=\"|40px||80px||false\" background__hover_enabled=\"on\" background_color__hover=\"#ddb494\"]<p>مشاهده گالری نمونه کارها</p>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"left\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" admin_label=\"Services\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>یک کت و شلوار سفارش دهید که توسط خیاطان متخصص برای تن شما ساخته شده است</h2>\n[/et_pb_text][et_pb_button button_text=\"یک وقت بگیرید\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_row_inner column_structure=\"1_2,1_2\" _builder_version=\"3.25\"][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"خیاطی لباس دامادی\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-03.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][et_pb_blurb title=\"تعمیرات لباس\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-02.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][/et_pb_column_inner][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"میلیمترها رو ما حواسمان هست\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-12.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][et_pb_blurb title=\"دوخت انواع پیراهن و شلوار\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-01.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonial\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-05.jpg\" custom_padding=\"0|0px|12vw|0px|false|false\" hover_enabled=\"0\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_testimonial quote_icon=\"off\" _builder_version=\"4.4.2\" body_font=\"|600|on||||||\" body_font_size=\"18px\" body_line_height=\"2.5em\" background_color=\"#41547d\" background_layout=\"dark\" custom_margin=\"-12vw|||-10vw\" custom_margin_tablet=\"0vw||10vw|0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" custom_padding=\"80px|60px|80px|7vw|true|false\" custom_padding_tablet=\"40px|10%|40px|10%|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" animation_style=\"flip\" hover_enabled=\"0\" body_font_size_tablet=\"18px\" body_font_size_phone=\"\" body_font_size_last_edited=\"on|desktop\" body_line_height_tablet=\"\" body_line_height_phone=\"1.8em\" body_line_height_last_edited=\"on|phone\" box_shadow_style=\"preset1\" box_shadow_horizontal=\"-41px\" box_shadow_vertical=\"45px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(0,0,0,0.52)\" locked=\"off\"]<p>\"<b>دوزندگی</b><span> </span>صنعت و هنر<span> پیوست یا پیوند اشیاء با استفاده از </span>بخیه<span> ساخته شده با </span>سوزن<span> و </span>نخ<span> است. دوزندگی یکی از قدیمی‌ترین </span>هنرهای منسوجات<span> پدید آمده در دوران </span>پارینه‌سنگی<span> است</span><span>.</span>\"</p>\n[/et_pb_testimonial][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_6,1_6,1_6,1_6,1_6,1_6\" _builder_version=\"3.25\"][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_08-1.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_07-1.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_06-1.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_05-2.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_03-2.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_01-2.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Feature\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"32px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>لباس شما با بهترین مواد دوخته می شود</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"اطلاعات بیشتر\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-06.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\"][/et_pb_image][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-07.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" max_width=\"70%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" border_color_all=\"#ffffff\" border_width_right=\"20px\" border_width_bottom=\"20px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][/et_pb_image][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"right\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Services\" _builder_version=\"3.22\" background_color=\"#f7f9fc\" custom_margin=\"|||\" custom_padding=\"0|0px|80px|0px|false|false\"][et_pb_row column_structure=\"1_2,1_2\" custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#ffffff\" width=\"90%\" max_width=\"90%\" module_alignment=\"left\" custom_margin=\"|||\" custom_padding=\"60px|||15vw|false|false\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"120px\" box_shadow_color=\"rgba(96,104,121,0.12)\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"90%\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"Cormorant Garamond||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"Cormorant Garamond|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" max_width=\"600px\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>خیاطی و تعمیرات</h2>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_4,1_4,1_2\" custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#ffffff\" width=\"90%\" max_width=\"90%\" module_alignment=\"left\" custom_margin=\"|||\" custom_padding=\"||120px|15vw|false|false\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"120px\" box_shadow_color=\"rgba(96,104,121,0.12)\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"90%\"][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-04.png\" _builder_version=\"4.4.2\" hover_enabled=\"0\" always_center_on_mobile=\"off\" locked=\"off\" animation_style=\"slide\" animation_direction=\"bottom\"][/et_pb_image][et_pb_blurb title=\"خدمات خیاطی\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-05.png\" _builder_version=\"4.4.2\" hover_enabled=\"0\" always_center_on_mobile=\"off\" locked=\"off\" animation_style=\"slide\" animation_direction=\"bottom\"][/et_pb_image][et_pb_blurb title=\"خدمات تعمیرات\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_font_size=\"18px\" background_color=\"#41547d\" background_layout=\"dark\" custom_margin=\"-14vw|-10vw||10vw\" custom_margin_tablet=\"0vw|0vw||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" custom_padding=\"80px|60px|80px|60px|true|true\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|phone\" animation_style=\"flip\" hover_enabled=\"0\" text_font_size_tablet=\"\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\" locked=\"off\" text_text_shadow_style=\"preset3\" text_letter_spacing=\"1px\"]<ol>\n<li> کوتاه کردن / بلند کردن</li>\n<li>کاف</li>\n<li>پوشش</li>\n<li>دور کمر</li>\n<li>آستین ها را بلند / کوتاه کنید</li>\n<li>دکمه / قلاب دوباره دوخت</li>\n<li>تعویض زیپ</li>\n<li>و ......</li>\n</ol>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" module_alignment=\"left\" custom_margin=\"-40px||\" custom_padding=\"0|0px|0|0px|false|false\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|600|||||||\" text_font_size=\"24px\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_2_font=\"||||||||\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" background_color=\"#dfab82\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-01.png\" background_position=\"bottom_right\" background_layout=\"dark\" custom_padding=\"50px|60px|50px|60px|true|true\" animation_style=\"flip\" link_option_url=\"#\" hover_enabled=\"0\" locked=\"off\" custom_padding__hover_enabled=\"on\" custom_padding__hover=\"|40px||80px||false\" background__hover_enabled=\"on|hover\" background_color__hover=\"#680000\" background_enable_color__hover=\"on\"]<p>مشاهده تمام خدمات</p>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Gallery\" _builder_version=\"3.22\" background_color=\"#f7f9fc\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#f7f9fc\" background_color_gradient_end=\"#ffffff\"][et_pb_row column_structure=\"1_4,1_4,1_2\" _builder_version=\"3.25\"][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-08.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"|||-10vw\" custom_margin_tablet=\"|||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|phone\" locked=\"off\"][/et_pb_image][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/crypto_image_03.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" border_color_all=\"#ffffff\" border_width_bottom=\"20px\" border_width_left=\"20px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-10.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"6vw||\" custom_margin_tablet=\"\" custom_margin_phone=\"0vw||\" custom_margin_last_edited=\"on|desktop\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>چند نمونه کار اخیر ما</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"مشاهده سایر نمونه کارها\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"left\" custom_padding=\"27px|0px|0|0px|false|false\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\" locked=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonials\" _builder_version=\"3.22\" background_color=\"#ffffff\" custom_padding=\"0|0px|54px|0px|false|false\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_slider _builder_version=\"4.4.2\" body_font=\"|600|on||||||\" body_font_size=\"26px\" body_line_height=\"1.8em\" background_color=\"#dfab82\" animation_style=\"flip\" hover_enabled=\"0\" body_font_size_tablet=\"20px\" body_font_size_phone=\"18px\" body_font_size_last_edited=\"on|phone\" box_shadow_style=\"preset1\" box_shadow_vertical=\"50px\" box_shadow_blur=\"60px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][/et_pb_slider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#f1f6ff\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>در تماس باشید!</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_blurb title=\"بازدید از محل کار ما\" use_icon=\"on\" font_icon=\"%%249%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\"]<p>ایران - تهران - شهرک خیاط</p>\n[/et_pb_blurb][et_pb_blurb title=\"شماره تماس\" use_icon=\"on\" font_icon=\"%%264%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\"]<p>091312345678</p>\n[/et_pb_blurb][et_pb_blurb title=\"ایمیل ما\" use_icon=\"on\" font_icon=\"%%238%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\"]<p>info@modelsite.ir</p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_row_inner _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"60px|0px|60px|0px|true|false\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_column_inner saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_contact_form captcha=\"off\" module_id=\"et_pb_contact_form_0\" _builder_version=\"4.4.2\" form_field_background_color=\"#f5f9ff\" form_field_font=\"||||||||\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#af8447\" button_border_width=\"10px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"|40px||40px||true\" hover_enabled=\"0\" form_background_color=\"#f5f9ff\" submit_button_text=\"ارسال پیام\" success_message=\"پیام شما با موفقیت ارسال شد .\" button_bg_enable_color=\"on\" box_shadow_style_button=\"preset1\" form_field_text_shadow_style=\"preset4\"][et_pb_contact_field field_id=\"Name\" field_title=\"نام\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Email\" field_title=\"ایمیل شما\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Phone\" field_title=\"شماره تماس\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Message\" field_title=\"پیام شما ....\" field_type=\"text\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||30px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][/et_pb_contact_form][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section]", "خانه", "", "inherit", "closed", "closed", "", "2-revision-v1", "", "", "2020-03-31 14:12:39", "2020-03-31 10:42:39", "", "2", "http://modelsite.test/2-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2824", "1", "2020-03-31 14:14:37", "2020-03-31 10:44:37", "[et_pb_section fb_built=\"1\" use_custom_gutter=\"on\" gutter_width=\"1\" admin_label=\"Header\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#f7f9fc\" background_color_gradient_start_position=\"75%\" background_color_gradient_end_position=\"75%\" custom_padding=\"0|0px|0|0px|false|false\" hover_enabled=\"0\"][et_pb_row column_structure=\"1_2,1_2\" use_custom_gutter=\"on\" gutter_width=\"1\" make_equal=\"on\" padding_top_bottom_link_1=\"true\" _builder_version=\"3.25\" custom_padding=\"0|0px|0|0px|false|false\" hover_enabled=\"0\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"8vw|60px|8vw|\" custom_padding_tablet=\"|0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"|0px||\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"|600|||||||\" header_font_size=\"60px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_text_color=\"#dfab82\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" custom_margin=\"||40px\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\"]<h1>خیاطی مردانه</h1>\n<h2>شیک پوش باشید </h2>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"آنلاین رزرو کنید\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#41547d\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(65,84,125,0.24)\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][et_pb_button button_text=\"یا تماس بگیرید : 12345-021\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#41547d\" button_bg_color=\"#ffffff\" button_border_width=\"0px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(65,84,125,0.06)\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_text_color_last_edited=\"on|desktop\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#af8447\" button_bg_enable_color__hover=\"on\" button_text_color__hover_enabled=\"on|hover\" button_text_color__hover=\"#ffffff\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-02.jpg\" parallax=\"on\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider show_divider=\"off\" disabled_on=\"off|off|on\" _builder_version=\"3.17.6\" height=\"250px\" hover_enabled=\"0\"][/et_pb_divider][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" use_custom_gutter=\"on\" gutter_width=\"1\" padding_top_bottom_link_2=\"false\" _builder_version=\"3.25\" custom_padding=\"0|0px|27px|0px|false|false\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_video src=\"#\" image_src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-03.jpg\" _builder_version=\"4.4.2\" custom_margin=\"|||-80px\" custom_margin_tablet=\"|||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" hover_enabled=\"0\"][/et_pb_video][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"100px|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-04.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" max_width=\"80%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" box_shadow_style=\"preset1\" box_shadow_horizontal=\"-41px\" box_shadow_vertical=\"45px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(0,0,0,0.52)\" locked=\"off\"][/et_pb_image][et_pb_text _builder_version=\"4.4.2\" text_font=\"|600|||||||\" text_font_size=\"24px\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_2_font=\"||||||||\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" background_color=\"#dfab82\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-01.png\" background_position=\"bottom_right\" background_layout=\"dark\" custom_margin=\"|||0%\" custom_padding=\"50px|60px|50px|60px|true|true\" animation_direction=\"left\" link_option_url=\"#\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\" custom_padding__hover_enabled=\"on\" custom_padding__hover=\"|40px||80px||false\" background__hover_enabled=\"on\" background_color__hover=\"#ddb494\"]<p>مشاهده گالری نمونه کارها</p>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"left\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" admin_label=\"Services\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"22px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>یک کت و شلوار سفارش دهید که توسط خیاطان متخصص برای تن شما ساخته شده است</h2>\n[/et_pb_text][et_pb_button button_text=\"یک وقت بگیرید\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_row_inner column_structure=\"1_2,1_2\" _builder_version=\"3.25\"][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"خیاطی لباس دامادی\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-03.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][et_pb_blurb title=\"تعمیرات لباس\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-02.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][/et_pb_column_inner][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"میلیمترها رو ما حواسمان هست\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-12.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][et_pb_blurb title=\"دوخت انواع پیراهن و شلوار\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-01.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonial\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-05.jpg\" custom_padding=\"0|0px|12vw|0px|false|false\" hover_enabled=\"0\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_testimonial quote_icon=\"off\" _builder_version=\"4.4.2\" body_font=\"|600|on||||||\" body_font_size=\"18px\" body_line_height=\"2.5em\" background_color=\"#41547d\" background_layout=\"dark\" custom_margin=\"-12vw|||-10vw\" custom_margin_tablet=\"0vw||10vw|0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" custom_padding=\"80px|60px|80px|7vw|true|false\" custom_padding_tablet=\"40px|10%|40px|10%|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" animation_style=\"flip\" hover_enabled=\"0\" body_font_size_tablet=\"18px\" body_font_size_phone=\"\" body_font_size_last_edited=\"on|desktop\" body_line_height_tablet=\"\" body_line_height_phone=\"1.8em\" body_line_height_last_edited=\"on|phone\" box_shadow_style=\"preset1\" box_shadow_horizontal=\"-41px\" box_shadow_vertical=\"45px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(0,0,0,0.52)\" locked=\"off\"]<p>\"<b>دوزندگی</b><span> </span>صنعت و هنر<span> پیوست یا پیوند اشیاء با استفاده از </span>بخیه<span> ساخته شده با </span>سوزن<span> و </span>نخ<span> است. دوزندگی یکی از قدیمی‌ترین </span>هنرهای منسوجات<span> پدید آمده در دوران </span>پارینه‌سنگی<span> است</span><span>.</span>\"</p>\n[/et_pb_testimonial][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_6,1_6,1_6,1_6,1_6,1_6\" _builder_version=\"3.25\"][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_08-1.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_07-1.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_06-1.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_05-2.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_03-2.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_01-2.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Feature\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"32px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>لباس شما با بهترین مواد دوخته می شود</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"اطلاعات بیشتر\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-06.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\"][/et_pb_image][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-07.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" max_width=\"70%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" border_color_all=\"#ffffff\" border_width_right=\"20px\" border_width_bottom=\"20px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][/et_pb_image][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"right\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Services\" _builder_version=\"3.22\" background_color=\"#f7f9fc\" custom_margin=\"|||\" custom_padding=\"0|0px|80px|0px|false|false\"][et_pb_row column_structure=\"1_2,1_2\" custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#ffffff\" width=\"90%\" max_width=\"90%\" module_alignment=\"left\" custom_margin=\"|||\" custom_padding=\"60px|||15vw|false|false\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"120px\" box_shadow_color=\"rgba(96,104,121,0.12)\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"90%\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"Cormorant Garamond||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"Cormorant Garamond|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" max_width=\"600px\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>خیاطی و تعمیرات</h2>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_4,1_4,1_2\" custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#ffffff\" width=\"90%\" max_width=\"90%\" module_alignment=\"left\" custom_margin=\"|||\" custom_padding=\"||120px|15vw|false|false\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"120px\" box_shadow_color=\"rgba(96,104,121,0.12)\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"90%\"][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-04.png\" _builder_version=\"4.4.2\" hover_enabled=\"0\" always_center_on_mobile=\"off\" locked=\"off\" animation_style=\"slide\" animation_direction=\"bottom\"][/et_pb_image][et_pb_blurb title=\"خدمات خیاطی\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-05.png\" _builder_version=\"4.4.2\" hover_enabled=\"0\" always_center_on_mobile=\"off\" locked=\"off\" animation_style=\"slide\" animation_direction=\"bottom\"][/et_pb_image][et_pb_blurb title=\"خدمات تعمیرات\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_font_size=\"18px\" background_color=\"#41547d\" background_layout=\"dark\" custom_margin=\"-14vw|-10vw||10vw\" custom_margin_tablet=\"0vw|0vw||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" custom_padding=\"80px|60px|80px|60px|true|true\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|phone\" animation_style=\"flip\" hover_enabled=\"0\" text_font_size_tablet=\"\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\" locked=\"off\" text_text_shadow_style=\"preset3\" text_letter_spacing=\"1px\"]<ol>\n<li> کوتاه کردن / بلند کردن</li>\n<li>کاف</li>\n<li>پوشش</li>\n<li>دور کمر</li>\n<li>آستین ها را بلند / کوتاه کنید</li>\n<li>دکمه / قلاب دوباره دوخت</li>\n<li>تعویض زیپ</li>\n<li>و ......</li>\n</ol>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" module_alignment=\"left\" custom_margin=\"-40px||\" custom_padding=\"0|0px|0|0px|false|false\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|600|||||||\" text_font_size=\"24px\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_2_font=\"||||||||\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" background_color=\"#dfab82\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-01.png\" background_position=\"bottom_right\" background_layout=\"dark\" custom_padding=\"50px|60px|50px|60px|true|true\" animation_style=\"flip\" link_option_url=\"#\" hover_enabled=\"0\" locked=\"off\" custom_padding__hover_enabled=\"on\" custom_padding__hover=\"|40px||80px||false\" background__hover_enabled=\"on|hover\" background_color__hover=\"#680000\" background_enable_color__hover=\"on\"]<p>مشاهده تمام خدمات</p>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Gallery\" _builder_version=\"3.22\" background_color=\"#f7f9fc\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#f7f9fc\" background_color_gradient_end=\"#ffffff\"][et_pb_row column_structure=\"1_4,1_4,1_2\" _builder_version=\"3.25\"][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-08.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"|||-10vw\" custom_margin_tablet=\"|||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|phone\" locked=\"off\"][/et_pb_image][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/crypto_image_03.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" border_color_all=\"#ffffff\" border_width_bottom=\"20px\" border_width_left=\"20px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-10.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"6vw||\" custom_margin_tablet=\"\" custom_margin_phone=\"0vw||\" custom_margin_last_edited=\"on|desktop\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>چند نمونه کار اخیر ما</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"مشاهده سایر نمونه کارها\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"left\" custom_padding=\"27px|0px|0|0px|false|false\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\" locked=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonials\" _builder_version=\"3.22\" background_color=\"#ffffff\" custom_padding=\"0|0px|54px|0px|false|false\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_slider _builder_version=\"4.4.2\" body_font=\"|600|on||||||\" body_font_size=\"26px\" body_line_height=\"1.8em\" background_color=\"#dfab82\" animation_style=\"flip\" hover_enabled=\"0\" body_font_size_tablet=\"20px\" body_font_size_phone=\"12px\" body_font_size_last_edited=\"on|phone\" box_shadow_style=\"preset1\" box_shadow_vertical=\"50px\" box_shadow_blur=\"60px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][/et_pb_slider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#f1f6ff\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>در تماس باشید!</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_blurb title=\"بازدید از محل کار ما\" use_icon=\"on\" font_icon=\"%%249%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\"]<p>ایران - تهران - شهرک خیاط</p>\n[/et_pb_blurb][et_pb_blurb title=\"شماره تماس\" use_icon=\"on\" font_icon=\"%%264%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\"]<p>091312345678</p>\n[/et_pb_blurb][et_pb_blurb title=\"ایمیل ما\" use_icon=\"on\" font_icon=\"%%238%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\"]<p>info@modelsite.ir</p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_row_inner _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"60px|0px|60px|0px|true|false\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_column_inner saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_contact_form captcha=\"off\" module_id=\"et_pb_contact_form_0\" _builder_version=\"4.4.2\" form_field_background_color=\"#f5f9ff\" form_field_font=\"||||||||\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#af8447\" button_border_width=\"10px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"|40px||40px||true\" hover_enabled=\"0\" form_background_color=\"#f5f9ff\" submit_button_text=\"ارسال پیام\" success_message=\"پیام شما با موفقیت ارسال شد .\" button_bg_enable_color=\"on\" box_shadow_style_button=\"preset1\" form_field_text_shadow_style=\"preset4\"][et_pb_contact_field field_id=\"Name\" field_title=\"نام\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Email\" field_title=\"ایمیل شما\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Phone\" field_title=\"شماره تماس\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Message\" field_title=\"پیام شما ....\" field_type=\"text\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||30px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][/et_pb_contact_form][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section]", "خانه", "", "inherit", "closed", "closed", "", "2-revision-v1", "", "", "2020-03-31 14:14:37", "2020-03-31 10:44:37", "", "2", "http://modelsite.test/2-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2827", "1", "2020-03-31 14:19:40", "2020-03-31 10:49:40", "[et_pb_section fb_built=\"1\" use_custom_gutter=\"on\" gutter_width=\"1\" admin_label=\"Header\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#f7f9fc\" background_color_gradient_start_position=\"75%\" background_color_gradient_end_position=\"75%\" custom_padding=\"0|0px|0|0px|false|false\" hover_enabled=\"0\"][et_pb_row column_structure=\"1_2,1_2\" use_custom_gutter=\"on\" gutter_width=\"1\" make_equal=\"on\" padding_top_bottom_link_1=\"true\" _builder_version=\"3.25\" custom_padding=\"0|0px|0|0px|false|false\" hover_enabled=\"0\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"8vw|60px|8vw|\" custom_padding_tablet=\"|0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"|0px||\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"|600|||||||\" header_font_size=\"60px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_text_color=\"#dfab82\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" custom_margin=\"||40px\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\"]<h1>خیاطی مردانه</h1>\n<h2>شیک پوش باشید </h2>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"آنلاین رزرو کنید\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#41547d\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(65,84,125,0.24)\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][et_pb_button button_text=\"یا تماس بگیرید : 12345-021\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#41547d\" button_bg_color=\"#ffffff\" button_border_width=\"0px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(65,84,125,0.06)\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_text_color_last_edited=\"on|desktop\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#af8447\" button_bg_enable_color__hover=\"on\" button_text_color__hover_enabled=\"on|hover\" button_text_color__hover=\"#ffffff\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-02.jpg\" parallax=\"on\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider show_divider=\"off\" disabled_on=\"off|off|on\" _builder_version=\"3.17.6\" height=\"250px\" hover_enabled=\"0\"][/et_pb_divider][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" use_custom_gutter=\"on\" gutter_width=\"1\" padding_top_bottom_link_2=\"false\" _builder_version=\"3.25\" custom_padding=\"0|0px|27px|0px|false|false\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_video src=\"#\" image_src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-03.jpg\" _builder_version=\"4.4.2\" custom_margin=\"|||-80px\" custom_margin_tablet=\"|||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" hover_enabled=\"0\"][/et_pb_video][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"100px|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-04.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" max_width=\"80%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" box_shadow_style=\"preset1\" box_shadow_horizontal=\"-41px\" box_shadow_vertical=\"45px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(0,0,0,0.52)\" locked=\"off\"][/et_pb_image][et_pb_text _builder_version=\"4.4.2\" text_font=\"|600|||||||\" text_font_size=\"24px\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_2_font=\"||||||||\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" background_color=\"#dfab82\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-01.png\" background_position=\"bottom_right\" background_layout=\"dark\" custom_margin=\"|||0%\" custom_padding=\"50px|60px|50px|60px|true|true\" animation_direction=\"left\" link_option_url=\"#\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\" custom_padding__hover_enabled=\"on\" custom_padding__hover=\"|40px||80px||false\" background__hover_enabled=\"on\" background_color__hover=\"#ddb494\"]<p>مشاهده گالری نمونه کارها</p>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"left\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" admin_label=\"Services\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"22px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>یک کت و شلوار سفارش دهید که توسط خیاطان متخصص برای تن شما ساخته شده است</h2>\n[/et_pb_text][et_pb_button button_text=\"یک وقت بگیرید\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_row_inner column_structure=\"1_2,1_2\" _builder_version=\"3.25\"][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"خیاطی لباس دامادی\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-03.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][et_pb_blurb title=\"تعمیرات لباس\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-02.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][/et_pb_column_inner][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"میلیمترها رو ما حواسمان هست\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-12.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][et_pb_blurb title=\"دوخت انواع پیراهن و شلوار\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-01.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonial\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-05.jpg\" custom_padding=\"0|0px|12vw|0px|false|false\" hover_enabled=\"0\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_testimonial quote_icon=\"off\" _builder_version=\"4.4.2\" body_font=\"|600|on||||||\" body_font_size=\"18px\" body_line_height=\"2.5em\" background_color=\"#41547d\" background_layout=\"dark\" custom_margin=\"-12vw|||-10vw\" custom_margin_tablet=\"0vw||10vw|0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" custom_padding=\"80px|60px|80px|7vw|true|false\" custom_padding_tablet=\"40px|10%|40px|10%|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" animation_style=\"flip\" hover_enabled=\"0\" body_font_size_tablet=\"18px\" body_font_size_phone=\"\" body_font_size_last_edited=\"on|desktop\" body_line_height_tablet=\"\" body_line_height_phone=\"1.8em\" body_line_height_last_edited=\"on|phone\" box_shadow_style=\"preset1\" box_shadow_horizontal=\"-41px\" box_shadow_vertical=\"45px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(0,0,0,0.52)\" locked=\"off\"]<p>\"<b>دوزندگی</b><span> </span>صنعت و هنر<span> پیوست یا پیوند اشیاء با استفاده از </span>بخیه<span> ساخته شده با </span>سوزن<span> و </span>نخ<span> است. دوزندگی یکی از قدیمی‌ترین </span>هنرهای منسوجات<span> پدید آمده در دوران </span>پارینه‌سنگی<span> است</span><span>.</span>\"</p>\n[/et_pb_testimonial][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_6,1_6,1_6,1_6,1_6,1_6\" _builder_version=\"3.25\"][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_08-1.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_07-1.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_06-1.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_05-2.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_03-2.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_01-2.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Feature\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"32px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>لباس شما با بهترین مواد دوخته می شود</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"اطلاعات بیشتر\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-06.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\"][/et_pb_image][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-07.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" max_width=\"70%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" border_color_all=\"#ffffff\" border_width_right=\"20px\" border_width_bottom=\"20px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][/et_pb_image][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"right\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Services\" _builder_version=\"3.22\" background_color=\"#f7f9fc\" custom_margin=\"|||\" custom_padding=\"0|0px|80px|0px|false|false\"][et_pb_row column_structure=\"1_2,1_2\" custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#ffffff\" width=\"90%\" max_width=\"90%\" module_alignment=\"left\" custom_margin=\"|||\" custom_padding=\"60px|||15vw|false|false\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"120px\" box_shadow_color=\"rgba(96,104,121,0.12)\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"90%\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"Cormorant Garamond||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"Cormorant Garamond|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" max_width=\"600px\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>خیاطی و تعمیرات</h2>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_4,1_4,1_2\" custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#ffffff\" width=\"90%\" max_width=\"90%\" module_alignment=\"left\" custom_margin=\"|||\" custom_padding=\"||120px|15vw|false|false\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"120px\" box_shadow_color=\"rgba(96,104,121,0.12)\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"90%\"][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-04.png\" _builder_version=\"4.4.2\" hover_enabled=\"0\" always_center_on_mobile=\"off\" locked=\"off\" animation_style=\"slide\" animation_direction=\"bottom\"][/et_pb_image][et_pb_blurb title=\"خدمات خیاطی\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-05.png\" _builder_version=\"4.4.2\" hover_enabled=\"0\" always_center_on_mobile=\"off\" locked=\"off\" animation_style=\"slide\" animation_direction=\"bottom\"][/et_pb_image][et_pb_blurb title=\"خدمات تعمیرات\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_font_size=\"18px\" background_color=\"#41547d\" background_layout=\"dark\" custom_margin=\"-14vw|-10vw||10vw\" custom_margin_tablet=\"0vw|0vw||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" custom_padding=\"80px|60px|80px|60px|true|true\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|phone\" animation_style=\"flip\" hover_enabled=\"0\" text_font_size_tablet=\"\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\" locked=\"off\" text_text_shadow_style=\"preset3\" text_letter_spacing=\"1px\"]<ol>\n<li> کوتاه کردن / بلند کردن</li>\n<li>کاف</li>\n<li>پوشش</li>\n<li>دور کمر</li>\n<li>آستین ها را بلند / کوتاه کنید</li>\n<li>دکمه / قلاب دوباره دوخت</li>\n<li>تعویض زیپ</li>\n<li>و ......</li>\n</ol>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" module_alignment=\"left\" custom_margin=\"-40px||\" custom_padding=\"0|0px|0|0px|false|false\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|600|||||||\" text_font_size=\"24px\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_2_font=\"||||||||\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" background_color=\"#dfab82\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-01.png\" background_position=\"bottom_right\" background_layout=\"dark\" custom_padding=\"50px|60px|50px|60px|true|true\" animation_style=\"flip\" link_option_url=\"#\" hover_enabled=\"0\" locked=\"off\" custom_padding__hover_enabled=\"on\" custom_padding__hover=\"|40px||80px||false\" background__hover_enabled=\"on|hover\" background_color__hover=\"#680000\" background_enable_color__hover=\"on\"]<p>مشاهده تمام خدمات</p>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Gallery\" _builder_version=\"3.22\" background_color=\"#f7f9fc\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#f7f9fc\" background_color_gradient_end=\"#ffffff\"][et_pb_row column_structure=\"1_4,1_4,1_2\" _builder_version=\"3.25\"][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-08.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"|||-10vw\" custom_margin_tablet=\"|||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|phone\" locked=\"off\"][/et_pb_image][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/crypto_image_03.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" border_color_all=\"#ffffff\" border_width_bottom=\"20px\" border_width_left=\"20px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-10.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"6vw||\" custom_margin_tablet=\"\" custom_margin_phone=\"0vw||\" custom_margin_last_edited=\"on|desktop\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>چند نمونه کار اخیر ما</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"مشاهده سایر نمونه کارها\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"left\" custom_padding=\"27px|0px|0|0px|false|false\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\" locked=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonials\" _builder_version=\"3.22\" background_color=\"#ffffff\" custom_padding=\"0|0px|54px|0px|false|false\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_slider _builder_version=\"4.4.2\" body_font=\"|600|on||||||\" body_font_size=\"26px\" body_line_height=\"1.8em\" background_color=\"#dfab82\" animation_style=\"flip\" hover_enabled=\"0\" body_font_size_tablet=\"20px\" body_font_size_phone=\"12px\" body_font_size_last_edited=\"on|phone\" box_shadow_style=\"preset1\" box_shadow_vertical=\"50px\" box_shadow_blur=\"60px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][/et_pb_slider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" _builder_version=\"4.4.2\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/Tailor-back.jpg\" hover_enabled=\"0\"][et_pb_row _builder_version=\"4.4.2\"][et_pb_column _builder_version=\"4.4.2\" type=\"4_4\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/Tailor1.png\" _builder_version=\"4.4.2\" scroll_horizontal_motion_enable=\"on\" hover_enabled=\"0\"][/et_pb_image][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#f1f6ff\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>در تماس باشید!</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_blurb title=\"بازدید از محل کار ما\" use_icon=\"on\" font_icon=\"%%249%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\"]<p>ایران - تهران - شهرک خیاط</p>\n[/et_pb_blurb][et_pb_blurb title=\"شماره تماس\" use_icon=\"on\" font_icon=\"%%264%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\"]<p>091312345678</p>\n[/et_pb_blurb][et_pb_blurb title=\"ایمیل ما\" use_icon=\"on\" font_icon=\"%%238%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\"]<p>info@modelsite.ir</p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_row_inner _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"60px|0px|60px|0px|true|false\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_column_inner saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_contact_form captcha=\"off\" module_id=\"et_pb_contact_form_0\" _builder_version=\"4.4.2\" form_field_background_color=\"#f5f9ff\" form_field_font=\"||||||||\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#af8447\" button_border_width=\"10px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"|40px||40px||true\" hover_enabled=\"0\" form_background_color=\"#f5f9ff\" submit_button_text=\"ارسال پیام\" success_message=\"پیام شما با موفقیت ارسال شد .\" button_bg_enable_color=\"on\" box_shadow_style_button=\"preset1\" form_field_text_shadow_style=\"preset4\"][et_pb_contact_field field_id=\"Name\" field_title=\"نام\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Email\" field_title=\"ایمیل شما\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Phone\" field_title=\"شماره تماس\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Message\" field_title=\"پیام شما ....\" field_type=\"text\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||30px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][/et_pb_contact_form][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section]", "خانه", "", "inherit", "closed", "closed", "", "2-revision-v1", "", "", "2020-03-31 14:19:40", "2020-03-31 10:49:40", "", "2", "http://modelsite.test/2-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2829", "1", "2020-03-31 14:21:58", "2020-03-31 10:51:58", "[et_pb_section fb_built=\"1\" use_custom_gutter=\"on\" gutter_width=\"1\" admin_label=\"Header\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#f7f9fc\" background_color_gradient_start_position=\"75%\" background_color_gradient_end_position=\"75%\" custom_padding=\"0|0px|0|0px|false|false\" hover_enabled=\"0\"][et_pb_row column_structure=\"1_2,1_2\" use_custom_gutter=\"on\" gutter_width=\"1\" make_equal=\"on\" padding_top_bottom_link_1=\"true\" _builder_version=\"3.25\" custom_padding=\"0|0px|0|0px|false|false\" hover_enabled=\"0\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"8vw|60px|8vw|\" custom_padding_tablet=\"|0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"|0px||\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"|600|||||||\" header_font_size=\"60px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_text_color=\"#dfab82\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" custom_margin=\"||40px\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\"]<h1>خیاطی مردانه</h1>\n<h2>شیک پوش باشید </h2>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"آنلاین رزرو کنید\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#41547d\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(65,84,125,0.24)\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][et_pb_button button_text=\"یا تماس بگیرید : 12345-021\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#41547d\" button_bg_color=\"#ffffff\" button_border_width=\"0px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(65,84,125,0.06)\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_text_color_last_edited=\"on|desktop\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#af8447\" button_bg_enable_color__hover=\"on\" button_text_color__hover_enabled=\"on|hover\" button_text_color__hover=\"#ffffff\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-02.jpg\" parallax=\"on\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider show_divider=\"off\" disabled_on=\"off|off|on\" _builder_version=\"3.17.6\" height=\"250px\" hover_enabled=\"0\"][/et_pb_divider][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" use_custom_gutter=\"on\" gutter_width=\"1\" padding_top_bottom_link_2=\"false\" _builder_version=\"3.25\" custom_padding=\"0|0px|27px|0px|false|false\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_video src=\"#\" image_src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-03.jpg\" _builder_version=\"4.4.2\" custom_margin=\"|||-80px\" custom_margin_tablet=\"|||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" hover_enabled=\"0\"][/et_pb_video][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"100px|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-04.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" max_width=\"80%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" box_shadow_style=\"preset1\" box_shadow_horizontal=\"-41px\" box_shadow_vertical=\"45px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(0,0,0,0.52)\" locked=\"off\"][/et_pb_image][et_pb_text _builder_version=\"4.4.2\" text_font=\"|600|||||||\" text_font_size=\"24px\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_2_font=\"||||||||\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" background_color=\"#dfab82\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-01.png\" background_position=\"bottom_right\" background_layout=\"dark\" custom_margin=\"|||0%\" custom_padding=\"50px|60px|50px|60px|true|true\" animation_direction=\"left\" link_option_url=\"#\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\" custom_padding__hover_enabled=\"on\" custom_padding__hover=\"|40px||80px||false\" background__hover_enabled=\"on\" background_color__hover=\"#ddb494\"]<p>مشاهده گالری نمونه کارها</p>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"left\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" admin_label=\"Services\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"22px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>یک کت و شلوار سفارش دهید که توسط خیاطان متخصص برای تن شما ساخته شده است</h2>\n[/et_pb_text][et_pb_button button_text=\"یک وقت بگیرید\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_row_inner column_structure=\"1_2,1_2\" _builder_version=\"3.25\"][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"خیاطی لباس دامادی\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-03.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][et_pb_blurb title=\"تعمیرات لباس\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-02.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][/et_pb_column_inner][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"میلیمترها رو ما حواسمان هست\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-12.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][et_pb_blurb title=\"دوخت انواع پیراهن و شلوار\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-01.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonial\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-05.jpg\" custom_padding=\"0|0px|12vw|0px|false|false\" hover_enabled=\"0\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_testimonial quote_icon=\"off\" _builder_version=\"4.4.2\" body_font=\"|600|on||||||\" body_font_size=\"18px\" body_line_height=\"2.5em\" background_color=\"#41547d\" background_layout=\"dark\" custom_margin=\"-12vw|||-10vw\" custom_margin_tablet=\"0vw||10vw|0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" custom_padding=\"80px|60px|80px|7vw|true|false\" custom_padding_tablet=\"40px|10%|40px|10%|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" animation_style=\"flip\" hover_enabled=\"0\" body_font_size_tablet=\"18px\" body_font_size_phone=\"\" body_font_size_last_edited=\"on|desktop\" body_line_height_tablet=\"\" body_line_height_phone=\"1.8em\" body_line_height_last_edited=\"on|phone\" box_shadow_style=\"preset1\" box_shadow_horizontal=\"-41px\" box_shadow_vertical=\"45px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(0,0,0,0.52)\" locked=\"off\"]<p>\"<b>دوزندگی</b><span> </span>صنعت و هنر<span> پیوست یا پیوند اشیاء با استفاده از </span>بخیه<span> ساخته شده با </span>سوزن<span> و </span>نخ<span> است. دوزندگی یکی از قدیمی‌ترین </span>هنرهای منسوجات<span> پدید آمده در دوران </span>پارینه‌سنگی<span> است</span><span>.</span>\"</p>\n[/et_pb_testimonial][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_6,1_6,1_6,1_6,1_6,1_6\" _builder_version=\"3.25\"][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_08-1.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_07-1.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_06-1.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_05-2.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_03-2.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_01-2.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Feature\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"32px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>لباس شما با بهترین مواد دوخته می شود</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"اطلاعات بیشتر\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-06.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\"][/et_pb_image][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-07.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" max_width=\"70%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" border_color_all=\"#ffffff\" border_width_right=\"20px\" border_width_bottom=\"20px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][/et_pb_image][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"right\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Services\" _builder_version=\"3.22\" background_color=\"#f7f9fc\" custom_margin=\"|||\" custom_padding=\"0|0px|80px|0px|false|false\"][et_pb_row column_structure=\"1_2,1_2\" custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#ffffff\" width=\"90%\" max_width=\"90%\" module_alignment=\"left\" custom_margin=\"|||\" custom_padding=\"60px|||15vw|false|false\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"120px\" box_shadow_color=\"rgba(96,104,121,0.12)\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"90%\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.4em\" max_width=\"600px\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>خیاطی و تعمیرات</h2>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_4,1_4,1_2\" custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#ffffff\" width=\"90%\" max_width=\"90%\" module_alignment=\"left\" custom_margin=\"|||\" custom_padding=\"||120px|15vw|false|false\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"120px\" box_shadow_color=\"rgba(96,104,121,0.12)\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"90%\"][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-04.png\" _builder_version=\"4.4.2\" hover_enabled=\"0\" always_center_on_mobile=\"off\" locked=\"off\" animation_style=\"slide\" animation_direction=\"bottom\" animation_delay=\"600ms\"][/et_pb_image][et_pb_blurb title=\"خدمات خیاطی\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-05.png\" _builder_version=\"4.4.2\" hover_enabled=\"0\" always_center_on_mobile=\"off\" locked=\"off\" animation_style=\"slide\" animation_direction=\"bottom\" transform_styles__hover_enabled=\"off|hover\" transform_scale__hover_enabled=\"off|hover\" transform_translate__hover_enabled=\"off|hover\" transform_rotate__hover_enabled=\"off|hover\" transform_skew__hover_enabled=\"off|hover\" transform_origin__hover_enabled=\"off|hover\" animation_delay=\"600ms\"][/et_pb_image][et_pb_blurb title=\"خدمات تعمیرات\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_font_size=\"18px\" background_color=\"#41547d\" background_layout=\"dark\" custom_margin=\"-14vw|-10vw||10vw\" custom_margin_tablet=\"0vw|0vw||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" custom_padding=\"80px|60px|80px|60px|true|true\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|phone\" animation_style=\"flip\" hover_enabled=\"0\" text_font_size_tablet=\"\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\" locked=\"off\" text_text_shadow_style=\"preset3\" text_letter_spacing=\"1px\"]<ol>\n<li> کوتاه کردن / بلند کردن</li>\n<li>کاف</li>\n<li>پوشش</li>\n<li>دور کمر</li>\n<li>آستین ها را بلند / کوتاه کنید</li>\n<li>دکمه / قلاب دوباره دوخت</li>\n<li>تعویض زیپ</li>\n<li>و ......</li>\n</ol>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" module_alignment=\"left\" custom_margin=\"-40px||\" custom_padding=\"0|0px|0|0px|false|false\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|600|||||||\" text_font_size=\"24px\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_2_font=\"||||||||\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" background_color=\"#dfab82\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-01.png\" background_position=\"bottom_right\" background_layout=\"dark\" custom_padding=\"50px|60px|50px|60px|true|true\" animation_style=\"flip\" link_option_url=\"#\" hover_enabled=\"0\" locked=\"off\" custom_padding__hover_enabled=\"on\" custom_padding__hover=\"|40px||80px||false\" background__hover_enabled=\"on|hover\" background_color__hover=\"#680000\" background_enable_color__hover=\"on\"]<p>مشاهده تمام خدمات</p>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Gallery\" _builder_version=\"3.22\" background_color=\"#f7f9fc\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#f7f9fc\" background_color_gradient_end=\"#ffffff\"][et_pb_row column_structure=\"1_4,1_4,1_2\" _builder_version=\"3.25\"][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-08.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"|||-10vw\" custom_margin_tablet=\"|||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|phone\" locked=\"off\"][/et_pb_image][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/crypto_image_03.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" border_color_all=\"#ffffff\" border_width_bottom=\"20px\" border_width_left=\"20px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-10.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"6vw||\" custom_margin_tablet=\"\" custom_margin_phone=\"0vw||\" custom_margin_last_edited=\"on|desktop\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>چند نمونه کار اخیر ما</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"مشاهده سایر نمونه کارها\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"left\" custom_padding=\"27px|0px|0|0px|false|false\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\" locked=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonials\" _builder_version=\"3.22\" background_color=\"#ffffff\" custom_padding=\"0|0px|54px|0px|false|false\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_slider _builder_version=\"4.4.2\" body_font=\"|600|on||||||\" body_font_size=\"26px\" body_line_height=\"1.8em\" background_color=\"#dfab82\" animation_style=\"flip\" hover_enabled=\"0\" body_font_size_tablet=\"20px\" body_font_size_phone=\"12px\" body_font_size_last_edited=\"on|phone\" box_shadow_style=\"preset1\" box_shadow_vertical=\"50px\" box_shadow_blur=\"60px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][/et_pb_slider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" _builder_version=\"4.4.2\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/Tailor-back.jpg\" hover_enabled=\"0\"][et_pb_row _builder_version=\"4.4.2\"][et_pb_column _builder_version=\"4.4.2\" type=\"4_4\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/Tailor1.png\" _builder_version=\"4.4.2\" scroll_horizontal_motion_enable=\"on\" hover_enabled=\"0\"][/et_pb_image][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#f1f6ff\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>در تماس باشید!</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_blurb title=\"بازدید از محل کار ما\" use_icon=\"on\" font_icon=\"%%249%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\"]<p>ایران - تهران - شهرک خیاط</p>\n[/et_pb_blurb][et_pb_blurb title=\"شماره تماس\" use_icon=\"on\" font_icon=\"%%264%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\"]<p>091312345678</p>\n[/et_pb_blurb][et_pb_blurb title=\"ایمیل ما\" use_icon=\"on\" font_icon=\"%%238%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\"]<p>info@modelsite.ir</p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_row_inner _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"60px|0px|60px|0px|true|false\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_column_inner saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_contact_form captcha=\"off\" module_id=\"et_pb_contact_form_0\" _builder_version=\"4.4.2\" form_field_background_color=\"#f5f9ff\" form_field_font=\"||||||||\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#af8447\" button_border_width=\"10px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"|40px||40px||true\" hover_enabled=\"0\" form_background_color=\"#f5f9ff\" submit_button_text=\"ارسال پیام\" success_message=\"پیام شما با موفقیت ارسال شد .\" button_bg_enable_color=\"on\" box_shadow_style_button=\"preset1\" form_field_text_shadow_style=\"preset4\"][et_pb_contact_field field_id=\"Name\" field_title=\"نام\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Email\" field_title=\"ایمیل شما\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Phone\" field_title=\"شماره تماس\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Message\" field_title=\"پیام شما ....\" field_type=\"text\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||30px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][/et_pb_contact_form][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section]", "خانه", "", "inherit", "closed", "closed", "", "2-revision-v1", "", "", "2020-03-31 14:21:58", "2020-03-31 10:51:58", "", "2", "http://modelsite.test/2-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2831", "1", "2020-03-31 14:23:24", "2020-03-31 10:53:24", "[et_pb_section fb_built=\"1\" use_custom_gutter=\"on\" gutter_width=\"1\" admin_label=\"Header\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#f7f9fc\" background_color_gradient_start_position=\"75%\" background_color_gradient_end_position=\"75%\" custom_padding=\"0|0px|0|0px|false|false\" hover_enabled=\"0\"][et_pb_row column_structure=\"1_2,1_2\" use_custom_gutter=\"on\" gutter_width=\"1\" make_equal=\"on\" padding_top_bottom_link_1=\"true\" _builder_version=\"3.25\" custom_padding=\"0|0px|0|0px|false|false\" hover_enabled=\"0\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"8vw|60px|8vw|\" custom_padding_tablet=\"|0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"|0px||\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"|600|||||||\" header_font_size=\"60px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_text_color=\"#dfab82\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" custom_margin=\"||40px\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\"]<h1>خیاطی مردانه</h1>\n<h2>شیک پوش باشید </h2>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"آنلاین رزرو کنید\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#41547d\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(65,84,125,0.24)\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][et_pb_button button_text=\"یا تماس بگیرید : 12345-021\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#41547d\" button_bg_color=\"#ffffff\" button_border_width=\"0px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(65,84,125,0.06)\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_text_color_last_edited=\"on|desktop\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#af8447\" button_bg_enable_color__hover=\"on\" button_text_color__hover_enabled=\"on|hover\" button_text_color__hover=\"#ffffff\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-02.jpg\" parallax=\"on\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider show_divider=\"off\" disabled_on=\"off|off|on\" _builder_version=\"3.17.6\" height=\"250px\" hover_enabled=\"0\"][/et_pb_divider][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" use_custom_gutter=\"on\" gutter_width=\"1\" padding_top_bottom_link_2=\"false\" _builder_version=\"3.25\" custom_padding=\"0|0px|27px|0px|false|false\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_video src=\"#\" image_src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-03.jpg\" _builder_version=\"4.4.2\" custom_margin=\"|||-80px\" custom_margin_tablet=\"|||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" hover_enabled=\"0\"][/et_pb_video][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"100px|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-04.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" max_width=\"80%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" box_shadow_style=\"preset1\" box_shadow_horizontal=\"-41px\" box_shadow_vertical=\"45px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(0,0,0,0.52)\" locked=\"off\"][/et_pb_image][et_pb_text _builder_version=\"4.4.2\" text_font=\"|600|||||||\" text_font_size=\"24px\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_2_font=\"||||||||\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" background_color=\"#dfab82\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-01.png\" background_position=\"bottom_right\" background_layout=\"dark\" custom_margin=\"|||0%\" custom_padding=\"50px|60px|50px|60px|true|true\" animation_direction=\"left\" link_option_url=\"#\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\" custom_padding__hover_enabled=\"on\" custom_padding__hover=\"|40px||80px||false\" background__hover_enabled=\"on\" background_color__hover=\"#ddb494\"]<p>مشاهده گالری نمونه کارها</p>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"left\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" admin_label=\"Services\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"22px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>یک کت و شلوار سفارش دهید که توسط خیاطان متخصص برای تن شما ساخته شده است</h2>\n[/et_pb_text][et_pb_button button_text=\"یک وقت بگیرید\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_row_inner column_structure=\"1_2,1_2\" _builder_version=\"3.25\"][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"خیاطی لباس دامادی\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-03.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][et_pb_blurb title=\"تعمیرات لباس\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-02.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][/et_pb_column_inner][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"میلیمترها رو ما حواسمان هست\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-12.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][et_pb_blurb title=\"دوخت انواع پیراهن و شلوار\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-01.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonial\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-05.jpg\" custom_padding=\"0|0px|12vw|0px|false|false\" hover_enabled=\"0\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_testimonial quote_icon=\"off\" _builder_version=\"4.4.2\" body_font=\"|600|on||||||\" body_font_size=\"18px\" body_line_height=\"2.5em\" background_color=\"#41547d\" background_layout=\"dark\" custom_margin=\"-12vw|||-10vw\" custom_margin_tablet=\"0vw||10vw|0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" custom_padding=\"80px|60px|80px|7vw|true|false\" custom_padding_tablet=\"40px|10%|40px|10%|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" animation_style=\"flip\" hover_enabled=\"0\" body_font_size_tablet=\"18px\" body_font_size_phone=\"\" body_font_size_last_edited=\"on|desktop\" body_line_height_tablet=\"\" body_line_height_phone=\"1.8em\" body_line_height_last_edited=\"on|phone\" box_shadow_style=\"preset1\" box_shadow_horizontal=\"-41px\" box_shadow_vertical=\"45px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(0,0,0,0.52)\" locked=\"off\"]<p>\"<b>دوزندگی</b><span> </span>صنعت و هنر<span> پیوست یا پیوند اشیاء با استفاده از </span>بخیه<span> ساخته شده با </span>سوزن<span> و </span>نخ<span> است. دوزندگی یکی از قدیمی‌ترین </span>هنرهای منسوجات<span> پدید آمده در دوران </span>پارینه‌سنگی<span> است</span><span>.</span>\"</p>\n[/et_pb_testimonial][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_6,1_6,1_6,1_6,1_6,1_6\" _builder_version=\"3.25\"][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_08-1.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_07-1.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_06-1.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_05-2.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_03-2.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_01-2.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Feature\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"32px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>لباس شما با بهترین مواد دوخته می شود</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"اطلاعات بیشتر\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-06.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\"][/et_pb_image][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-07.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" max_width=\"70%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" border_color_all=\"#ffffff\" border_width_right=\"20px\" border_width_bottom=\"20px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][/et_pb_image][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"right\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Services\" _builder_version=\"3.22\" background_color=\"#f7f9fc\" custom_margin=\"|||\" custom_padding=\"0|0px|80px|0px|false|false\"][et_pb_row column_structure=\"1_2,1_2\" custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#ffffff\" width=\"90%\" max_width=\"90%\" module_alignment=\"left\" custom_margin=\"|||\" custom_padding=\"60px|||15vw|false|false\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"120px\" box_shadow_color=\"rgba(96,104,121,0.12)\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"90%\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.4em\" max_width=\"600px\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>خیاطی و تعمیرات</h2>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_4,1_4,1_2\" custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#ffffff\" width=\"90%\" max_width=\"90%\" module_alignment=\"left\" custom_margin=\"|||\" custom_padding=\"||120px|15vw|false|false\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"120px\" box_shadow_color=\"rgba(96,104,121,0.12)\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"90%\"][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-04.png\" _builder_version=\"4.4.2\" hover_enabled=\"0\" always_center_on_mobile=\"off\" locked=\"off\" animation_style=\"slide\" animation_direction=\"bottom\" animation_delay=\"600ms\"][/et_pb_image][et_pb_blurb title=\"خدمات خیاطی\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-05.png\" _builder_version=\"4.4.2\" hover_enabled=\"0\" always_center_on_mobile=\"off\" locked=\"off\" animation_style=\"slide\" animation_direction=\"bottom\" transform_styles__hover_enabled=\"off|hover\" transform_scale__hover_enabled=\"off|hover\" transform_translate__hover_enabled=\"off|hover\" transform_rotate__hover_enabled=\"off|hover\" transform_skew__hover_enabled=\"off|hover\" transform_origin__hover_enabled=\"off|hover\" animation_delay=\"600ms\"][/et_pb_image][et_pb_blurb title=\"خدمات تعمیرات\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_font_size=\"18px\" background_color=\"#41547d\" background_layout=\"dark\" custom_margin=\"-14vw|-10vw||10vw\" custom_margin_tablet=\"0vw|0vw||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" custom_padding=\"80px|60px|80px|60px|true|true\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|phone\" animation_style=\"flip\" hover_enabled=\"0\" text_font_size_tablet=\"\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\" locked=\"off\" text_text_shadow_style=\"preset3\" text_letter_spacing=\"1px\"]<ol>\n<li> کوتاه کردن / بلند کردن</li>\n<li>کاف</li>\n<li>پوشش</li>\n<li>دور کمر</li>\n<li>آستین ها را بلند / کوتاه کنید</li>\n<li>دکمه / قلاب دوباره دوخت</li>\n<li>تعویض زیپ</li>\n<li>و ......</li>\n</ol>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" module_alignment=\"left\" custom_margin=\"-40px||\" custom_padding=\"0|0px|0|0px|false|false\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|600|||||||\" text_font_size=\"24px\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_2_font=\"||||||||\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" background_color=\"#dfab82\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-01.png\" background_position=\"bottom_right\" background_layout=\"dark\" custom_padding=\"50px|60px|50px|60px|true|true\" animation_style=\"flip\" link_option_url=\"#\" hover_enabled=\"0\" locked=\"off\" custom_padding__hover_enabled=\"on\" custom_padding__hover=\"|40px||80px||false\" background__hover_enabled=\"on|hover\" background_color__hover=\"#680000\" background_enable_color__hover=\"on\"]<p>مشاهده تمام خدمات</p>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Gallery\" _builder_version=\"3.22\" background_color=\"#f7f9fc\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#f7f9fc\" background_color_gradient_end=\"#ffffff\"][et_pb_row column_structure=\"1_4,1_4,1_2\" _builder_version=\"3.25\"][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-08.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"|||-10vw\" custom_margin_tablet=\"|||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|phone\" locked=\"off\"][/et_pb_image][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/crypto_image_03.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" border_color_all=\"#ffffff\" border_width_bottom=\"20px\" border_width_left=\"20px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-10.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"6vw||\" custom_margin_tablet=\"\" custom_margin_phone=\"0vw||\" custom_margin_last_edited=\"on|desktop\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>چند نمونه کار اخیر ما</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"مشاهده سایر نمونه کارها\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"left\" custom_padding=\"27px|0px|0|0px|false|false\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\" locked=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonials\" _builder_version=\"3.22\" background_color=\"#ffffff\" custom_padding=\"0|0px|54px|0px|false|false\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_slider _builder_version=\"4.4.2\" body_font=\"|600|on||||||\" body_font_size=\"26px\" body_line_height=\"1.8em\" background_color=\"#dfab82\" animation_style=\"flip\" hover_enabled=\"0\" body_font_size_tablet=\"20px\" body_font_size_phone=\"12px\" body_font_size_last_edited=\"on|phone\" box_shadow_style=\"preset1\" box_shadow_vertical=\"50px\" box_shadow_blur=\"60px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][/et_pb_slider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" _builder_version=\"4.4.2\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/Tailor-back.jpg\" hover_enabled=\"0\"][et_pb_row _builder_version=\"4.4.2\"][et_pb_column _builder_version=\"4.4.2\" type=\"4_4\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/Tailor1.png\" _builder_version=\"4.4.2\" scroll_horizontal_motion_enable=\"on\" hover_enabled=\"0\" scroll_horizontal_motion=\"39|50|50|100|4|0|-4\"][/et_pb_image][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#f1f6ff\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>در تماس باشید!</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_blurb title=\"بازدید از محل کار ما\" use_icon=\"on\" font_icon=\"%%249%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\"]<p>ایران - تهران - شهرک خیاط</p>\n[/et_pb_blurb][et_pb_blurb title=\"شماره تماس\" use_icon=\"on\" font_icon=\"%%264%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\"]<p>091312345678</p>\n[/et_pb_blurb][et_pb_blurb title=\"ایمیل ما\" use_icon=\"on\" font_icon=\"%%238%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\"]<p>info@modelsite.ir</p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_row_inner _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"60px|0px|60px|0px|true|false\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_column_inner saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_contact_form captcha=\"off\" module_id=\"et_pb_contact_form_0\" _builder_version=\"4.4.2\" form_field_background_color=\"#f5f9ff\" form_field_font=\"||||||||\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#af8447\" button_border_width=\"10px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"|40px||40px||true\" hover_enabled=\"0\" form_background_color=\"#f5f9ff\" submit_button_text=\"ارسال پیام\" success_message=\"پیام شما با موفقیت ارسال شد .\" button_bg_enable_color=\"on\" box_shadow_style_button=\"preset1\" form_field_text_shadow_style=\"preset4\"][et_pb_contact_field field_id=\"Name\" field_title=\"نام\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Email\" field_title=\"ایمیل شما\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Phone\" field_title=\"شماره تماس\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Message\" field_title=\"پیام شما ....\" field_type=\"text\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||30px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][/et_pb_contact_form][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section]", "خانه", "", "inherit", "closed", "closed", "", "2-revision-v1", "", "", "2020-03-31 14:23:24", "2020-03-31 10:53:24", "", "2", "http://modelsite.test/2-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2833", "1", "2020-03-31 14:26:37", "2020-03-31 10:56:37", "[et_pb_section fb_built=\"1\" use_custom_gutter=\"on\" gutter_width=\"1\" admin_label=\"Header\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#f7f9fc\" background_color_gradient_start_position=\"75%\" background_color_gradient_end_position=\"75%\" custom_padding=\"0|0px|0|0px|false|false\" hover_enabled=\"0\"][et_pb_row column_structure=\"1_2,1_2\" use_custom_gutter=\"on\" gutter_width=\"1\" make_equal=\"on\" padding_top_bottom_link_1=\"true\" _builder_version=\"3.25\" custom_padding=\"0|0px|0|0px|false|false\" hover_enabled=\"0\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"8vw|60px|8vw|\" custom_padding_tablet=\"|0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"|0px||\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"|600|||||||\" header_font_size=\"60px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_text_color=\"#dfab82\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" custom_margin=\"||40px\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\"]<h1>خیاطی مردانه</h1>\n<h2>شیک پوش باشید </h2>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"آنلاین رزرو کنید\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#41547d\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(65,84,125,0.24)\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][et_pb_button button_text=\"یا تماس بگیرید : 12345-021\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#41547d\" button_bg_color=\"#ffffff\" button_border_width=\"0px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(65,84,125,0.06)\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_text_color_last_edited=\"on|desktop\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#af8447\" button_bg_enable_color__hover=\"on\" button_text_color__hover_enabled=\"on|hover\" button_text_color__hover=\"#ffffff\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-02.jpg\" parallax=\"on\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider show_divider=\"off\" disabled_on=\"off|off|on\" _builder_version=\"3.17.6\" height=\"250px\" hover_enabled=\"0\"][/et_pb_divider][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" use_custom_gutter=\"on\" gutter_width=\"1\" padding_top_bottom_link_2=\"false\" _builder_version=\"3.25\" custom_padding=\"0|0px|27px|0px|false|false\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_video src=\"#\" image_src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-03.jpg\" _builder_version=\"4.4.2\" custom_margin=\"|||-80px\" custom_margin_tablet=\"|||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" hover_enabled=\"0\"][/et_pb_video][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"100px|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-04.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" max_width=\"80%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" box_shadow_style=\"preset1\" box_shadow_horizontal=\"-41px\" box_shadow_vertical=\"45px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(0,0,0,0.52)\" locked=\"off\"][/et_pb_image][et_pb_text _builder_version=\"4.4.2\" text_font=\"|600|||||||\" text_font_size=\"24px\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_2_font=\"||||||||\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" background_color=\"#dfab82\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-01.png\" background_position=\"bottom_right\" background_layout=\"dark\" custom_margin=\"|||0%\" custom_padding=\"50px|60px|50px|60px|true|true\" animation_direction=\"left\" link_option_url=\"#\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\" custom_padding__hover_enabled=\"on\" custom_padding__hover=\"|40px||80px||false\" background__hover_enabled=\"on\" background_color__hover=\"#ddb494\"]<p>مشاهده گالری نمونه کارها</p>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"left\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" admin_label=\"Services\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"22px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>یک کت و شلوار سفارش دهید که توسط خیاطان متخصص برای تن شما ساخته شده است</h2>\n[/et_pb_text][et_pb_button button_text=\"یک وقت بگیرید\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_row_inner column_structure=\"1_2,1_2\" _builder_version=\"3.25\"][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"خیاطی لباس دامادی\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-03.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][et_pb_blurb title=\"تعمیرات لباس\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-02.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][/et_pb_column_inner][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"میلیمترها رو ما حواسمان هست\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-12.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][et_pb_blurb title=\"دوخت انواع پیراهن و شلوار\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-01.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonial\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-05.jpg\" custom_padding=\"0|0px|12vw|0px|false|false\" hover_enabled=\"0\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_testimonial quote_icon=\"off\" _builder_version=\"4.4.2\" body_font=\"|600|on||||||\" body_font_size=\"18px\" body_line_height=\"2.5em\" background_color=\"#41547d\" background_layout=\"dark\" custom_margin=\"-12vw|||-10vw\" custom_margin_tablet=\"0vw||10vw|0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" custom_padding=\"80px|60px|80px|7vw|true|false\" custom_padding_tablet=\"40px|10%|40px|10%|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" animation_style=\"flip\" hover_enabled=\"0\" body_font_size_tablet=\"18px\" body_font_size_phone=\"\" body_font_size_last_edited=\"on|desktop\" body_line_height_tablet=\"\" body_line_height_phone=\"1.8em\" body_line_height_last_edited=\"on|phone\" box_shadow_style=\"preset1\" box_shadow_horizontal=\"-41px\" box_shadow_vertical=\"45px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(0,0,0,0.52)\" locked=\"off\"]<p>\"<b>دوزندگی</b><span> </span>صنعت و هنر<span> پیوست یا پیوند اشیاء با استفاده از </span>بخیه<span> ساخته شده با </span>سوزن<span> و </span>نخ<span> است. دوزندگی یکی از قدیمی‌ترین </span>هنرهای منسوجات<span> پدید آمده در دوران </span>پارینه‌سنگی<span> است</span><span>.</span>\"</p>\n[/et_pb_testimonial][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_6,1_6,1_6,1_6,1_6,1_6\" _builder_version=\"3.25\"][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_08-1.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_07-1.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_06-1.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_05-2.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_03-2.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_01-2.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Feature\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"32px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>لباس شما با بهترین مواد دوخته می شود</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"اطلاعات بیشتر\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-06.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\"][/et_pb_image][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-07.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" max_width=\"70%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" border_color_all=\"#ffffff\" border_width_right=\"20px\" border_width_bottom=\"20px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][/et_pb_image][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"right\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Services\" _builder_version=\"3.22\" background_color=\"#f7f9fc\" custom_margin=\"|||\" custom_padding=\"0|0px|80px|0px|false|false\"][et_pb_row column_structure=\"1_2,1_2\" custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#ffffff\" width=\"90%\" max_width=\"90%\" module_alignment=\"left\" custom_margin=\"|||\" custom_padding=\"60px|||15vw|false|false\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"120px\" box_shadow_color=\"rgba(96,104,121,0.12)\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"90%\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.4em\" max_width=\"600px\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>خیاطی و تعمیرات</h2>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_4,1_4,1_2\" custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#ffffff\" width=\"90%\" max_width=\"90%\" module_alignment=\"left\" custom_margin=\"|||\" custom_padding=\"||120px|15vw|false|false\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"120px\" box_shadow_color=\"rgba(96,104,121,0.12)\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"90%\"][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-04.png\" _builder_version=\"4.4.2\" hover_enabled=\"0\" always_center_on_mobile=\"off\" locked=\"off\" animation_style=\"slide\" animation_direction=\"bottom\" animation_delay=\"600ms\"][/et_pb_image][et_pb_blurb title=\"خدمات خیاطی\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-05.png\" _builder_version=\"4.4.2\" hover_enabled=\"0\" always_center_on_mobile=\"off\" locked=\"off\" animation_style=\"slide\" animation_direction=\"bottom\" transform_styles__hover_enabled=\"off|hover\" transform_scale__hover_enabled=\"off|hover\" transform_translate__hover_enabled=\"off|hover\" transform_rotate__hover_enabled=\"off|hover\" transform_skew__hover_enabled=\"off|hover\" transform_origin__hover_enabled=\"off|hover\" animation_delay=\"600ms\"][/et_pb_image][et_pb_blurb title=\"خدمات تعمیرات\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_font_size=\"18px\" background_color=\"#41547d\" background_layout=\"dark\" custom_margin=\"-14vw|-10vw||10vw\" custom_margin_tablet=\"0vw|0vw||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" custom_padding=\"80px|60px|80px|60px|true|true\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|phone\" animation_style=\"flip\" hover_enabled=\"0\" text_font_size_tablet=\"\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\" locked=\"off\" text_text_shadow_style=\"preset3\" text_letter_spacing=\"1px\"]<ol>\n<li> کوتاه کردن / بلند کردن</li>\n<li>کاف</li>\n<li>پوشش</li>\n<li>دور کمر</li>\n<li>آستین ها را بلند / کوتاه کنید</li>\n<li>دکمه / قلاب دوباره دوخت</li>\n<li>تعویض زیپ</li>\n<li>و ......</li>\n</ol>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" module_alignment=\"left\" custom_margin=\"-40px||\" custom_padding=\"0|0px|0|0px|false|false\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|600|||||||\" text_font_size=\"24px\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_2_font=\"||||||||\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" background_color=\"#dfab82\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-01.png\" background_position=\"bottom_right\" background_layout=\"dark\" custom_padding=\"50px|60px|50px|60px|true|true\" animation_style=\"flip\" link_option_url=\"#\" hover_enabled=\"0\" locked=\"off\" custom_padding__hover_enabled=\"on\" custom_padding__hover=\"|40px||80px||false\" background__hover_enabled=\"on|hover\" background_color__hover=\"#680000\" background_enable_color__hover=\"on\"]<p>مشاهده تمام خدمات</p>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Gallery\" _builder_version=\"3.22\" background_color=\"#f7f9fc\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#f7f9fc\" background_color_gradient_end=\"#ffffff\"][et_pb_row column_structure=\"1_4,1_4,1_2\" _builder_version=\"3.25\"][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-08.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"|||-10vw\" custom_margin_tablet=\"|||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|phone\" locked=\"off\"][/et_pb_image][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/crypto_image_03.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" border_color_all=\"#ffffff\" border_width_bottom=\"20px\" border_width_left=\"20px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-10.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"6vw||\" custom_margin_tablet=\"\" custom_margin_phone=\"0vw||\" custom_margin_last_edited=\"on|desktop\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>چند نمونه کار اخیر ما</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"مشاهده سایر نمونه کارها\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"left\" custom_padding=\"27px|0px|0|0px|false|false\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\" locked=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonials\" _builder_version=\"3.22\" background_color=\"#ffffff\" custom_padding=\"0|0px|54px|0px|false|false\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_slider _builder_version=\"4.4.2\" body_font=\"|600|on||||||\" body_font_size=\"26px\" body_line_height=\"1.8em\" background_color=\"#dfab82\" animation_style=\"flip\" hover_enabled=\"0\" body_font_size_tablet=\"20px\" body_font_size_phone=\"12px\" body_font_size_last_edited=\"on|phone\" box_shadow_style=\"preset1\" box_shadow_vertical=\"50px\" box_shadow_blur=\"60px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][/et_pb_slider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" _builder_version=\"4.4.2\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/Tailor-back.jpg\" hover_enabled=\"0\"][et_pb_row _builder_version=\"4.4.2\"][et_pb_column _builder_version=\"4.4.2\" type=\"4_4\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/Tailor1.png\" _builder_version=\"4.4.2\" scroll_horizontal_motion_enable=\"on\" hover_enabled=\"0\" scroll_horizontal_motion=\"39|50|50|100|4|0|-4\" custom_css_main_element=\"||.class{||    overflow-x: hidden;||}||\"][/et_pb_image][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#f1f6ff\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>در تماس باشید!</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_blurb title=\"بازدید از محل کار ما\" use_icon=\"on\" font_icon=\"%%249%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\"]<p>ایران - تهران - شهرک خیاط</p>\n[/et_pb_blurb][et_pb_blurb title=\"شماره تماس\" use_icon=\"on\" font_icon=\"%%264%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\"]<p>091312345678</p>\n[/et_pb_blurb][et_pb_blurb title=\"ایمیل ما\" use_icon=\"on\" font_icon=\"%%238%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\"]<p>info@modelsite.ir</p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_row_inner _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"60px|0px|60px|0px|true|false\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_column_inner saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_contact_form captcha=\"off\" module_id=\"et_pb_contact_form_0\" _builder_version=\"4.4.2\" form_field_background_color=\"#f5f9ff\" form_field_font=\"||||||||\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#af8447\" button_border_width=\"10px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"|40px||40px||true\" hover_enabled=\"0\" form_background_color=\"#f5f9ff\" submit_button_text=\"ارسال پیام\" success_message=\"پیام شما با موفقیت ارسال شد .\" button_bg_enable_color=\"on\" box_shadow_style_button=\"preset1\" form_field_text_shadow_style=\"preset4\"][et_pb_contact_field field_id=\"Name\" field_title=\"نام\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Email\" field_title=\"ایمیل شما\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Phone\" field_title=\"شماره تماس\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Message\" field_title=\"پیام شما ....\" field_type=\"text\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||30px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][/et_pb_contact_form][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section]", "خانه", "", "inherit", "closed", "closed", "", "2-revision-v1", "", "", "2020-03-31 14:26:37", "2020-03-31 10:56:37", "", "2", "http://modelsite.test/2-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2835", "1", "2020-03-31 14:27:28", "2020-03-31 10:57:28", "[et_pb_section fb_built=\"1\" use_custom_gutter=\"on\" gutter_width=\"1\" admin_label=\"Header\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#f7f9fc\" background_color_gradient_start_position=\"75%\" background_color_gradient_end_position=\"75%\" custom_padding=\"0|0px|0|0px|false|false\" hover_enabled=\"0\"][et_pb_row column_structure=\"1_2,1_2\" use_custom_gutter=\"on\" gutter_width=\"1\" make_equal=\"on\" padding_top_bottom_link_1=\"true\" _builder_version=\"3.25\" custom_padding=\"0|0px|0|0px|false|false\" hover_enabled=\"0\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"8vw|60px|8vw|\" custom_padding_tablet=\"|0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"|0px||\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"|600|||||||\" header_font_size=\"60px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_text_color=\"#dfab82\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" custom_margin=\"||40px\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\"]<h1>خیاطی مردانه</h1>\n<h2>شیک پوش باشید </h2>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"آنلاین رزرو کنید\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#41547d\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(65,84,125,0.24)\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][et_pb_button button_text=\"یا تماس بگیرید : 12345-021\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#41547d\" button_bg_color=\"#ffffff\" button_border_width=\"0px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(65,84,125,0.06)\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_text_color_last_edited=\"on|desktop\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#af8447\" button_bg_enable_color__hover=\"on\" button_text_color__hover_enabled=\"on|hover\" button_text_color__hover=\"#ffffff\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-02.jpg\" parallax=\"on\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider show_divider=\"off\" disabled_on=\"off|off|on\" _builder_version=\"3.17.6\" height=\"250px\" hover_enabled=\"0\"][/et_pb_divider][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" use_custom_gutter=\"on\" gutter_width=\"1\" padding_top_bottom_link_2=\"false\" _builder_version=\"3.25\" custom_padding=\"0|0px|27px|0px|false|false\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_video src=\"#\" image_src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-03.jpg\" _builder_version=\"4.4.2\" custom_margin=\"|||-80px\" custom_margin_tablet=\"|||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" hover_enabled=\"0\"][/et_pb_video][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"100px|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-04.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" max_width=\"80%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" box_shadow_style=\"preset1\" box_shadow_horizontal=\"-41px\" box_shadow_vertical=\"45px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(0,0,0,0.52)\" locked=\"off\"][/et_pb_image][et_pb_text _builder_version=\"4.4.2\" text_font=\"|600|||||||\" text_font_size=\"24px\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_2_font=\"||||||||\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" background_color=\"#dfab82\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-01.png\" background_position=\"bottom_right\" background_layout=\"dark\" custom_margin=\"|||0%\" custom_padding=\"50px|60px|50px|60px|true|true\" animation_direction=\"left\" link_option_url=\"#\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\" custom_padding__hover_enabled=\"on\" custom_padding__hover=\"|40px||80px||false\" background__hover_enabled=\"on\" background_color__hover=\"#ddb494\"]<p>مشاهده گالری نمونه کارها</p>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"left\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" admin_label=\"Services\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"22px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>یک کت و شلوار سفارش دهید که توسط خیاطان متخصص برای تن شما ساخته شده است</h2>\n[/et_pb_text][et_pb_button button_text=\"یک وقت بگیرید\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_row_inner column_structure=\"1_2,1_2\" _builder_version=\"3.25\"][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"خیاطی لباس دامادی\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-03.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][et_pb_blurb title=\"تعمیرات لباس\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-02.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][/et_pb_column_inner][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"میلیمترها رو ما حواسمان هست\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-12.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][et_pb_blurb title=\"دوخت انواع پیراهن و شلوار\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-01.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonial\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-05.jpg\" custom_padding=\"0|0px|12vw|0px|false|false\" hover_enabled=\"0\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_testimonial quote_icon=\"off\" _builder_version=\"4.4.2\" body_font=\"|600|on||||||\" body_font_size=\"18px\" body_line_height=\"2.5em\" background_color=\"#41547d\" background_layout=\"dark\" custom_margin=\"-12vw|||-10vw\" custom_margin_tablet=\"0vw||10vw|0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" custom_padding=\"80px|60px|80px|7vw|true|false\" custom_padding_tablet=\"40px|10%|40px|10%|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" animation_style=\"flip\" hover_enabled=\"0\" body_font_size_tablet=\"18px\" body_font_size_phone=\"\" body_font_size_last_edited=\"on|desktop\" body_line_height_tablet=\"\" body_line_height_phone=\"1.8em\" body_line_height_last_edited=\"on|phone\" box_shadow_style=\"preset1\" box_shadow_horizontal=\"-41px\" box_shadow_vertical=\"45px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(0,0,0,0.52)\" locked=\"off\"]<p>\"<b>دوزندگی</b><span> </span>صنعت و هنر<span> پیوست یا پیوند اشیاء با استفاده از </span>بخیه<span> ساخته شده با </span>سوزن<span> و </span>نخ<span> است. دوزندگی یکی از قدیمی‌ترین </span>هنرهای منسوجات<span> پدید آمده در دوران </span>پارینه‌سنگی<span> است</span><span>.</span>\"</p>\n[/et_pb_testimonial][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_6,1_6,1_6,1_6,1_6,1_6\" _builder_version=\"3.25\"][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_08-1.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_07-1.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_06-1.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_05-2.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_03-2.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_01-2.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Feature\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"32px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>لباس شما با بهترین مواد دوخته می شود</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"اطلاعات بیشتر\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-06.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\"][/et_pb_image][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-07.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" max_width=\"70%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" border_color_all=\"#ffffff\" border_width_right=\"20px\" border_width_bottom=\"20px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][/et_pb_image][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"right\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Services\" _builder_version=\"3.22\" background_color=\"#f7f9fc\" custom_margin=\"|||\" custom_padding=\"0|0px|80px|0px|false|false\"][et_pb_row column_structure=\"1_2,1_2\" custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#ffffff\" width=\"90%\" max_width=\"90%\" module_alignment=\"left\" custom_margin=\"|||\" custom_padding=\"60px|||15vw|false|false\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"120px\" box_shadow_color=\"rgba(96,104,121,0.12)\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"90%\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.4em\" max_width=\"600px\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>خیاطی و تعمیرات</h2>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_4,1_4,1_2\" custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#ffffff\" width=\"90%\" max_width=\"90%\" module_alignment=\"left\" custom_margin=\"|||\" custom_padding=\"||120px|15vw|false|false\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"120px\" box_shadow_color=\"rgba(96,104,121,0.12)\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"90%\"][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-04.png\" _builder_version=\"4.4.2\" hover_enabled=\"0\" always_center_on_mobile=\"off\" locked=\"off\" animation_style=\"slide\" animation_direction=\"bottom\" animation_delay=\"600ms\"][/et_pb_image][et_pb_blurb title=\"خدمات خیاطی\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-05.png\" _builder_version=\"4.4.2\" hover_enabled=\"0\" always_center_on_mobile=\"off\" locked=\"off\" animation_style=\"slide\" animation_direction=\"bottom\" transform_styles__hover_enabled=\"off|hover\" transform_scale__hover_enabled=\"off|hover\" transform_translate__hover_enabled=\"off|hover\" transform_rotate__hover_enabled=\"off|hover\" transform_skew__hover_enabled=\"off|hover\" transform_origin__hover_enabled=\"off|hover\" animation_delay=\"600ms\"][/et_pb_image][et_pb_blurb title=\"خدمات تعمیرات\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_font_size=\"18px\" background_color=\"#41547d\" background_layout=\"dark\" custom_margin=\"-14vw|-10vw||10vw\" custom_margin_tablet=\"0vw|0vw||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" custom_padding=\"80px|60px|80px|60px|true|true\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|phone\" animation_style=\"flip\" hover_enabled=\"0\" text_font_size_tablet=\"\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\" locked=\"off\" text_text_shadow_style=\"preset3\" text_letter_spacing=\"1px\"]<ol>\n<li> کوتاه کردن / بلند کردن</li>\n<li>کاف</li>\n<li>پوشش</li>\n<li>دور کمر</li>\n<li>آستین ها را بلند / کوتاه کنید</li>\n<li>دکمه / قلاب دوباره دوخت</li>\n<li>تعویض زیپ</li>\n<li>و ......</li>\n</ol>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" module_alignment=\"left\" custom_margin=\"-40px||\" custom_padding=\"0|0px|0|0px|false|false\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|600|||||||\" text_font_size=\"24px\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_2_font=\"||||||||\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" background_color=\"#dfab82\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-01.png\" background_position=\"bottom_right\" background_layout=\"dark\" custom_padding=\"50px|60px|50px|60px|true|true\" animation_style=\"flip\" link_option_url=\"#\" hover_enabled=\"0\" locked=\"off\" custom_padding__hover_enabled=\"on\" custom_padding__hover=\"|40px||80px||false\" background__hover_enabled=\"on|hover\" background_color__hover=\"#680000\" background_enable_color__hover=\"on\"]<p>مشاهده تمام خدمات</p>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Gallery\" _builder_version=\"3.22\" background_color=\"#f7f9fc\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#f7f9fc\" background_color_gradient_end=\"#ffffff\"][et_pb_row column_structure=\"1_4,1_4,1_2\" _builder_version=\"3.25\"][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-08.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"|||-10vw\" custom_margin_tablet=\"|||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|phone\" locked=\"off\"][/et_pb_image][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/crypto_image_03.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" border_color_all=\"#ffffff\" border_width_bottom=\"20px\" border_width_left=\"20px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-10.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"6vw||\" custom_margin_tablet=\"\" custom_margin_phone=\"0vw||\" custom_margin_last_edited=\"on|desktop\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>چند نمونه کار اخیر ما</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"مشاهده سایر نمونه کارها\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"left\" custom_padding=\"27px|0px|0|0px|false|false\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\" locked=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonials\" _builder_version=\"3.22\" background_color=\"#ffffff\" custom_padding=\"0|0px|54px|0px|false|false\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_slider _builder_version=\"4.4.2\" body_font=\"|600|on||||||\" body_font_size=\"26px\" body_line_height=\"1.8em\" background_color=\"#dfab82\" animation_style=\"flip\" hover_enabled=\"0\" body_font_size_tablet=\"20px\" body_font_size_phone=\"12px\" body_font_size_last_edited=\"on|phone\" box_shadow_style=\"preset1\" box_shadow_vertical=\"50px\" box_shadow_blur=\"60px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][/et_pb_slider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" _builder_version=\"4.4.2\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/Tailor-back.jpg\" hover_enabled=\"0\"][et_pb_row _builder_version=\"4.4.2\"][et_pb_column _builder_version=\"4.4.2\" type=\"4_4\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/Tailor1.png\" _builder_version=\"4.4.2\" scroll_horizontal_motion_enable=\"on\" hover_enabled=\"0\" scroll_horizontal_motion=\"39|50|50|100|4|0|-4\" custom_css_main_element=\"||\"][/et_pb_image][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#f1f6ff\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>در تماس باشید!</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_blurb title=\"بازدید از محل کار ما\" use_icon=\"on\" font_icon=\"%%249%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\"]<p>ایران - تهران - شهرک خیاط</p>\n[/et_pb_blurb][et_pb_blurb title=\"شماره تماس\" use_icon=\"on\" font_icon=\"%%264%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\"]<p>091312345678</p>\n[/et_pb_blurb][et_pb_blurb title=\"ایمیل ما\" use_icon=\"on\" font_icon=\"%%238%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\"]<p>info@modelsite.ir</p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_row_inner _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"60px|0px|60px|0px|true|false\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_column_inner saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_contact_form captcha=\"off\" module_id=\"et_pb_contact_form_0\" _builder_version=\"4.4.2\" form_field_background_color=\"#f5f9ff\" form_field_font=\"||||||||\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#af8447\" button_border_width=\"10px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"|40px||40px||true\" hover_enabled=\"0\" form_background_color=\"#f5f9ff\" submit_button_text=\"ارسال پیام\" success_message=\"پیام شما با موفقیت ارسال شد .\" button_bg_enable_color=\"on\" box_shadow_style_button=\"preset1\" form_field_text_shadow_style=\"preset4\"][et_pb_contact_field field_id=\"Name\" field_title=\"نام\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Email\" field_title=\"ایمیل شما\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Phone\" field_title=\"شماره تماس\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Message\" field_title=\"پیام شما ....\" field_type=\"text\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||30px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][/et_pb_contact_form][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section]", "خانه", "", "inherit", "closed", "closed", "", "2-revision-v1", "", "", "2020-03-31 14:27:28", "2020-03-31 10:57:28", "", "2", "http://modelsite.test/2-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2837", "1", "2020-03-31 14:28:21", "2020-03-31 10:58:21", ".class{\r\n     /* حذف اسکرول افقی */\r\n    overflow-x: hidden;\r\n}", "Divi-Child-Theme-master", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2020-03-31 14:28:21", "2020-03-31 10:58:21", "", "5", "http://modelsite.test/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2838", "1", "2020-03-31 14:31:42", "2020-03-31 11:01:42", "body {\r\noverflow-x: hidden !important;\r\n}", "Divi-Child-Theme-master", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2020-03-31 14:31:42", "2020-03-31 11:01:42", "", "5", "http://modelsite.test/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2839", "1", "2020-03-31 14:32:33", "2020-03-31 11:02:33", "", "Divi-Child-Theme-master", "", "inherit", "closed", "closed", "", "5-revision-v1", "", "", "2020-03-31 14:32:33", "2020-03-31 11:02:33", "", "5", "http://modelsite.test/5-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2840", "1", "2020-03-31 14:33:05", "2020-03-31 11:03:05", "[et_pb_section fb_built=\"1\" use_custom_gutter=\"on\" gutter_width=\"1\" admin_label=\"Header\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#f7f9fc\" background_color_gradient_start_position=\"75%\" background_color_gradient_end_position=\"75%\" custom_padding=\"0|0px|0|0px|false|false\" hover_enabled=\"0\"][et_pb_row column_structure=\"1_2,1_2\" use_custom_gutter=\"on\" gutter_width=\"1\" make_equal=\"on\" padding_top_bottom_link_1=\"true\" _builder_version=\"3.25\" custom_padding=\"0|0px|0|0px|false|false\" hover_enabled=\"0\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"8vw|60px|8vw|\" custom_padding_tablet=\"|0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"|0px||\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"|600|||||||\" header_font_size=\"60px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_text_color=\"#dfab82\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" custom_margin=\"||40px\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\"]<h1>خیاطی مردانه</h1>\n<h2>شیک پوش باشید </h2>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"آنلاین رزرو کنید\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#41547d\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(65,84,125,0.24)\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][et_pb_button button_text=\"یا تماس بگیرید : 12345-021\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#41547d\" button_bg_color=\"#ffffff\" button_border_width=\"0px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(65,84,125,0.06)\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_text_color_last_edited=\"on|desktop\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#af8447\" button_bg_enable_color__hover=\"on\" button_text_color__hover_enabled=\"on|hover\" button_text_color__hover=\"#ffffff\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-02.jpg\" parallax=\"on\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider show_divider=\"off\" disabled_on=\"off|off|on\" _builder_version=\"3.17.6\" height=\"250px\" hover_enabled=\"0\"][/et_pb_divider][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" use_custom_gutter=\"on\" gutter_width=\"1\" padding_top_bottom_link_2=\"false\" _builder_version=\"3.25\" custom_padding=\"0|0px|27px|0px|false|false\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_video src=\"#\" image_src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-03.jpg\" _builder_version=\"4.4.2\" custom_margin=\"|||-80px\" custom_margin_tablet=\"|||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" hover_enabled=\"0\"][/et_pb_video][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"100px|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-04.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" max_width=\"80%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" box_shadow_style=\"preset1\" box_shadow_horizontal=\"-41px\" box_shadow_vertical=\"45px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(0,0,0,0.52)\" locked=\"off\"][/et_pb_image][et_pb_text _builder_version=\"4.4.2\" text_font=\"|600|||||||\" text_font_size=\"24px\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_2_font=\"||||||||\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" background_color=\"#dfab82\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-01.png\" background_position=\"bottom_right\" background_layout=\"dark\" custom_margin=\"|||0%\" custom_padding=\"50px|60px|50px|60px|true|true\" animation_direction=\"left\" link_option_url=\"#\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\" custom_padding__hover_enabled=\"on\" custom_padding__hover=\"|40px||80px||false\" background__hover_enabled=\"on\" background_color__hover=\"#ddb494\"]<p>مشاهده گالری نمونه کارها</p>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"left\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" admin_label=\"Services\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"22px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>یک کت و شلوار سفارش دهید که توسط خیاطان متخصص برای تن شما ساخته شده است</h2>\n[/et_pb_text][et_pb_button button_text=\"یک وقت بگیرید\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_row_inner column_structure=\"1_2,1_2\" _builder_version=\"3.25\"][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"خیاطی لباس دامادی\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-03.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][et_pb_blurb title=\"تعمیرات لباس\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-02.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][/et_pb_column_inner][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"میلیمترها رو ما حواسمان هست\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-12.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][et_pb_blurb title=\"دوخت انواع پیراهن و شلوار\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-01.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonial\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-05.jpg\" custom_padding=\"0|0px|12vw|0px|false|false\" hover_enabled=\"0\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_testimonial quote_icon=\"off\" _builder_version=\"4.4.2\" body_font=\"|600|on||||||\" body_font_size=\"18px\" body_line_height=\"2.5em\" background_color=\"#41547d\" background_layout=\"dark\" custom_margin=\"-12vw|||-10vw\" custom_margin_tablet=\"0vw||10vw|0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" custom_padding=\"80px|60px|80px|7vw|true|false\" custom_padding_tablet=\"40px|10%|40px|10%|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" animation_style=\"flip\" hover_enabled=\"0\" body_font_size_tablet=\"18px\" body_font_size_phone=\"\" body_font_size_last_edited=\"on|desktop\" body_line_height_tablet=\"\" body_line_height_phone=\"1.8em\" body_line_height_last_edited=\"on|phone\" box_shadow_style=\"preset1\" box_shadow_horizontal=\"-41px\" box_shadow_vertical=\"45px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(0,0,0,0.52)\" locked=\"off\"]<p>\"<b>دوزندگی</b><span> </span>صنعت و هنر<span> پیوست یا پیوند اشیاء با استفاده از </span>بخیه<span> ساخته شده با </span>سوزن<span> و </span>نخ<span> است. دوزندگی یکی از قدیمی‌ترین </span>هنرهای منسوجات<span> پدید آمده در دوران </span>پارینه‌سنگی<span> است</span><span>.</span>\"</p>\n[/et_pb_testimonial][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_6,1_6,1_6,1_6,1_6,1_6\" _builder_version=\"3.25\"][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_08-1.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_07-1.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_06-1.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_05-2.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_03-2.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_01-2.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Feature\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"32px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>لباس شما با بهترین مواد دوخته می شود</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"اطلاعات بیشتر\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-06.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\"][/et_pb_image][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-07.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" max_width=\"70%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" border_color_all=\"#ffffff\" border_width_right=\"20px\" border_width_bottom=\"20px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][/et_pb_image][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"right\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Services\" _builder_version=\"3.22\" background_color=\"#f7f9fc\" custom_margin=\"|||\" custom_padding=\"0|0px|80px|0px|false|false\"][et_pb_row column_structure=\"1_2,1_2\" custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#ffffff\" width=\"90%\" max_width=\"90%\" module_alignment=\"left\" custom_margin=\"|||\" custom_padding=\"60px|||15vw|false|false\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"120px\" box_shadow_color=\"rgba(96,104,121,0.12)\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"90%\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.4em\" max_width=\"600px\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>خیاطی و تعمیرات</h2>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_4,1_4,1_2\" custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#ffffff\" width=\"90%\" max_width=\"90%\" module_alignment=\"left\" custom_margin=\"|||\" custom_padding=\"||120px|15vw|false|false\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"120px\" box_shadow_color=\"rgba(96,104,121,0.12)\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"90%\"][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-04.png\" _builder_version=\"4.4.2\" hover_enabled=\"0\" always_center_on_mobile=\"off\" locked=\"off\" animation_style=\"slide\" animation_direction=\"bottom\" animation_delay=\"600ms\"][/et_pb_image][et_pb_blurb title=\"خدمات خیاطی\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-05.png\" _builder_version=\"4.4.2\" hover_enabled=\"0\" always_center_on_mobile=\"off\" locked=\"off\" animation_style=\"slide\" animation_direction=\"bottom\" transform_styles__hover_enabled=\"off|hover\" transform_scale__hover_enabled=\"off|hover\" transform_translate__hover_enabled=\"off|hover\" transform_rotate__hover_enabled=\"off|hover\" transform_skew__hover_enabled=\"off|hover\" transform_origin__hover_enabled=\"off|hover\" animation_delay=\"600ms\"][/et_pb_image][et_pb_blurb title=\"خدمات تعمیرات\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_font_size=\"18px\" background_color=\"#41547d\" background_layout=\"dark\" custom_margin=\"-14vw|-10vw||10vw\" custom_margin_tablet=\"0vw|0vw||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" custom_padding=\"80px|60px|80px|60px|true|true\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|phone\" animation_style=\"flip\" hover_enabled=\"0\" text_font_size_tablet=\"\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\" locked=\"off\" text_text_shadow_style=\"preset3\" text_letter_spacing=\"1px\"]<ol>\n<li> کوتاه کردن / بلند کردن</li>\n<li>کاف</li>\n<li>پوشش</li>\n<li>دور کمر</li>\n<li>آستین ها را بلند / کوتاه کنید</li>\n<li>دکمه / قلاب دوباره دوخت</li>\n<li>تعویض زیپ</li>\n<li>و ......</li>\n</ol>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" module_alignment=\"left\" custom_margin=\"-40px||\" custom_padding=\"0|0px|0|0px|false|false\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|600|||||||\" text_font_size=\"24px\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_2_font=\"||||||||\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" background_color=\"#dfab82\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-01.png\" background_position=\"bottom_right\" background_layout=\"dark\" custom_padding=\"50px|60px|50px|60px|true|true\" animation_style=\"flip\" link_option_url=\"#\" hover_enabled=\"0\" locked=\"off\" custom_padding__hover_enabled=\"on\" custom_padding__hover=\"|40px||80px||false\" background__hover_enabled=\"on|hover\" background_color__hover=\"#680000\" background_enable_color__hover=\"on\"]<p>مشاهده تمام خدمات</p>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Gallery\" _builder_version=\"3.22\" background_color=\"#f7f9fc\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#f7f9fc\" background_color_gradient_end=\"#ffffff\"][et_pb_row column_structure=\"1_4,1_4,1_2\" _builder_version=\"3.25\"][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-08.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"|||-10vw\" custom_margin_tablet=\"|||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|phone\" locked=\"off\"][/et_pb_image][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/crypto_image_03.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" border_color_all=\"#ffffff\" border_width_bottom=\"20px\" border_width_left=\"20px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-10.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"6vw||\" custom_margin_tablet=\"\" custom_margin_phone=\"0vw||\" custom_margin_last_edited=\"on|desktop\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>چند نمونه کار اخیر ما</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"مشاهده سایر نمونه کارها\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"left\" custom_padding=\"27px|0px|0|0px|false|false\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\" locked=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonials\" _builder_version=\"3.22\" background_color=\"#ffffff\" custom_padding=\"0|0px|54px|0px|false|false\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_slider _builder_version=\"4.4.2\" body_font=\"|600|on||||||\" body_font_size=\"26px\" body_line_height=\"1.8em\" background_color=\"#dfab82\" animation_style=\"flip\" hover_enabled=\"0\" body_font_size_tablet=\"20px\" body_font_size_phone=\"12px\" body_font_size_last_edited=\"on|phone\" box_shadow_style=\"preset1\" box_shadow_vertical=\"50px\" box_shadow_blur=\"60px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][/et_pb_slider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" _builder_version=\"4.4.2\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/Tailor-back.jpg\" hover_enabled=\"0\"][et_pb_row _builder_version=\"4.4.2\"][et_pb_column _builder_version=\"4.4.2\" type=\"4_4\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/Tailor1.png\" _builder_version=\"4.4.2\" scroll_horizontal_motion_enable=\"on\" hover_enabled=\"0\" custom_css_main_element=\"||\" scroll_horizontal_motion=\"0|50|50|73|4|0|-4\"][/et_pb_image][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#f1f6ff\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>در تماس باشید!</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_blurb title=\"بازدید از محل کار ما\" use_icon=\"on\" font_icon=\"%%249%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\"]<p>ایران - تهران - شهرک خیاط</p>\n[/et_pb_blurb][et_pb_blurb title=\"شماره تماس\" use_icon=\"on\" font_icon=\"%%264%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\"]<p>091312345678</p>\n[/et_pb_blurb][et_pb_blurb title=\"ایمیل ما\" use_icon=\"on\" font_icon=\"%%238%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\"]<p>info@modelsite.ir</p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_row_inner _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"60px|0px|60px|0px|true|false\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_column_inner saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_contact_form captcha=\"off\" module_id=\"et_pb_contact_form_0\" _builder_version=\"4.4.2\" form_field_background_color=\"#f5f9ff\" form_field_font=\"||||||||\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#af8447\" button_border_width=\"10px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"|40px||40px||true\" hover_enabled=\"0\" form_background_color=\"#f5f9ff\" submit_button_text=\"ارسال پیام\" success_message=\"پیام شما با موفقیت ارسال شد .\" button_bg_enable_color=\"on\" box_shadow_style_button=\"preset1\" form_field_text_shadow_style=\"preset4\"][et_pb_contact_field field_id=\"Name\" field_title=\"نام\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Email\" field_title=\"ایمیل شما\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Phone\" field_title=\"شماره تماس\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Message\" field_title=\"پیام شما ....\" field_type=\"text\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||30px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][/et_pb_contact_form][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section]", "خانه", "", "inherit", "closed", "closed", "", "2-revision-v1", "", "", "2020-03-31 14:33:05", "2020-03-31 11:03:05", "", "2", "http://modelsite.test/2-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2843", "1", "2020-03-31 14:38:54", "2020-03-31 11:08:54", "[et_pb_section fb_built=\"1\" use_custom_gutter=\"on\" gutter_width=\"1\" admin_label=\"Header\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#f7f9fc\" background_color_gradient_start_position=\"75%\" background_color_gradient_end_position=\"75%\" custom_padding=\"0|0px|0|0px|false|false\" hover_enabled=\"0\"][et_pb_row column_structure=\"1_2,1_2\" use_custom_gutter=\"on\" gutter_width=\"1\" make_equal=\"on\" padding_top_bottom_link_1=\"true\" _builder_version=\"3.25\" custom_padding=\"0|0px|0|0px|false|false\" hover_enabled=\"0\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"8vw|60px|8vw|\" custom_padding_tablet=\"|0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"|0px||\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"|600|||||||\" header_font_size=\"60px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_text_color=\"#dfab82\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" custom_margin=\"||40px\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\"]<h1>خیاطی مردانه</h1>\n<h2>شیک پوش باشید </h2>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"آنلاین رزرو کنید\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#41547d\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(65,84,125,0.24)\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][et_pb_button button_text=\"یا تماس بگیرید : 12345-021\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#41547d\" button_bg_color=\"#ffffff\" button_border_width=\"0px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(65,84,125,0.06)\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_text_color_last_edited=\"on|desktop\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#af8447\" button_bg_enable_color__hover=\"on\" button_text_color__hover_enabled=\"on|hover\" button_text_color__hover=\"#ffffff\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-02.jpg\" parallax=\"on\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider show_divider=\"off\" disabled_on=\"off|off|on\" _builder_version=\"3.17.6\" height=\"250px\" hover_enabled=\"0\"][/et_pb_divider][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" use_custom_gutter=\"on\" gutter_width=\"1\" padding_top_bottom_link_2=\"false\" _builder_version=\"3.25\" custom_padding=\"0|0px|27px|0px|false|false\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_video src=\"#\" image_src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-03.jpg\" _builder_version=\"4.4.2\" custom_margin=\"|||-80px\" custom_margin_tablet=\"|||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" hover_enabled=\"0\"][/et_pb_video][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"100px|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-04.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" max_width=\"80%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" box_shadow_style=\"preset1\" box_shadow_horizontal=\"-41px\" box_shadow_vertical=\"45px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(0,0,0,0.52)\" locked=\"off\"][/et_pb_image][et_pb_text _builder_version=\"4.4.2\" text_font=\"|600|||||||\" text_font_size=\"24px\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_2_font=\"||||||||\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" background_color=\"#dfab82\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-01.png\" background_position=\"bottom_right\" background_layout=\"dark\" custom_margin=\"|||0%\" custom_padding=\"50px|60px|50px|60px|true|true\" animation_direction=\"left\" link_option_url=\"#\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\" custom_padding__hover_enabled=\"on\" custom_padding__hover=\"|40px||80px||false\" background__hover_enabled=\"on\" background_color__hover=\"#ddb494\"]<p>مشاهده گالری نمونه کارها</p>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"left\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" admin_label=\"Services\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"22px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>یک کت و شلوار سفارش دهید که توسط خیاطان متخصص برای تن شما ساخته شده است</h2>\n[/et_pb_text][et_pb_button button_text=\"یک وقت بگیرید\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_row_inner column_structure=\"1_2,1_2\" _builder_version=\"3.25\"][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"خیاطی لباس دامادی\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-03.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][et_pb_blurb title=\"تعمیرات لباس\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-02.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][/et_pb_column_inner][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"میلیمترها رو ما حواسمان هست\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-12.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][et_pb_blurb title=\"دوخت انواع پیراهن و شلوار\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-01.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonial\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-05.jpg\" custom_padding=\"0|0px|12vw|0px|false|false\" hover_enabled=\"0\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_testimonial quote_icon=\"off\" _builder_version=\"4.4.2\" body_font=\"|600|on||||||\" body_font_size=\"18px\" body_line_height=\"2.5em\" background_color=\"#41547d\" background_layout=\"dark\" custom_margin=\"-12vw|||-10vw\" custom_margin_tablet=\"0vw||10vw|0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" custom_padding=\"80px|60px|80px|7vw|true|false\" custom_padding_tablet=\"40px|10%|40px|10%|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" animation_style=\"flip\" hover_enabled=\"0\" body_font_size_tablet=\"18px\" body_font_size_phone=\"\" body_font_size_last_edited=\"on|desktop\" body_line_height_tablet=\"\" body_line_height_phone=\"1.8em\" body_line_height_last_edited=\"on|phone\" box_shadow_style=\"preset1\" box_shadow_horizontal=\"-41px\" box_shadow_vertical=\"45px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(0,0,0,0.52)\" locked=\"off\"]<p>\"<b>دوزندگی</b><span> </span>صنعت و هنر<span> پیوست یا پیوند اشیاء با استفاده از </span>بخیه<span> ساخته شده با </span>سوزن<span> و </span>نخ<span> است. دوزندگی یکی از قدیمی‌ترین </span>هنرهای منسوجات<span> پدید آمده در دوران </span>پارینه‌سنگی<span> است</span><span>.</span>\"</p>\n[/et_pb_testimonial][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_6,1_6,1_6,1_6,1_6,1_6\" _builder_version=\"3.25\"][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_08-1.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_07-1.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_06-1.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_05-2.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_03-2.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_01-2.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Feature\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"32px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>لباس شما با بهترین مواد دوخته می شود</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"اطلاعات بیشتر\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-06.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\"][/et_pb_image][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-07.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" max_width=\"70%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" border_color_all=\"#ffffff\" border_width_right=\"20px\" border_width_bottom=\"20px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][/et_pb_image][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"right\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Services\" _builder_version=\"3.22\" background_color=\"#f7f9fc\" custom_margin=\"|||\" custom_padding=\"0|0px|80px|0px|false|false\"][et_pb_row column_structure=\"1_2,1_2\" custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#ffffff\" width=\"90%\" max_width=\"90%\" module_alignment=\"left\" custom_margin=\"|||\" custom_padding=\"60px|||15vw|false|false\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"120px\" box_shadow_color=\"rgba(96,104,121,0.12)\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"90%\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.4em\" max_width=\"600px\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>خیاطی و تعمیرات</h2>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_4,1_4,1_2\" custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#ffffff\" width=\"90%\" max_width=\"90%\" module_alignment=\"left\" custom_margin=\"|||\" custom_padding=\"||120px|15vw|false|false\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"120px\" box_shadow_color=\"rgba(96,104,121,0.12)\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"90%\"][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-04.png\" _builder_version=\"4.4.2\" hover_enabled=\"0\" always_center_on_mobile=\"off\" locked=\"off\" animation_style=\"slide\" animation_direction=\"bottom\" animation_delay=\"600ms\"][/et_pb_image][et_pb_blurb title=\"خدمات خیاطی\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-05.png\" _builder_version=\"4.4.2\" hover_enabled=\"0\" always_center_on_mobile=\"off\" locked=\"off\" animation_style=\"slide\" animation_direction=\"bottom\" transform_styles__hover_enabled=\"off|hover\" transform_scale__hover_enabled=\"off|hover\" transform_translate__hover_enabled=\"off|hover\" transform_rotate__hover_enabled=\"off|hover\" transform_skew__hover_enabled=\"off|hover\" transform_origin__hover_enabled=\"off|hover\" animation_delay=\"600ms\"][/et_pb_image][et_pb_blurb title=\"خدمات تعمیرات\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_font_size=\"18px\" background_color=\"#41547d\" background_layout=\"dark\" custom_margin=\"-14vw|-10vw||10vw\" custom_margin_tablet=\"0vw|0vw||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" custom_padding=\"80px|60px|80px|60px|true|true\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|phone\" animation_style=\"flip\" hover_enabled=\"0\" text_font_size_tablet=\"\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\" locked=\"off\" text_text_shadow_style=\"preset3\" text_letter_spacing=\"1px\"]<ol>\n<li> کوتاه کردن / بلند کردن</li>\n<li>کاف</li>\n<li>پوشش</li>\n<li>دور کمر</li>\n<li>آستین ها را بلند / کوتاه کنید</li>\n<li>دکمه / قلاب دوباره دوخت</li>\n<li>تعویض زیپ</li>\n<li>و ......</li>\n</ol>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" module_alignment=\"left\" custom_margin=\"-40px||\" custom_padding=\"0|0px|0|0px|false|false\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|600|||||||\" text_font_size=\"24px\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_2_font=\"||||||||\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" background_color=\"#dfab82\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-01.png\" background_position=\"bottom_right\" background_layout=\"dark\" custom_padding=\"50px|60px|50px|60px|true|true\" animation_style=\"flip\" link_option_url=\"#\" hover_enabled=\"0\" locked=\"off\" custom_padding__hover_enabled=\"on\" custom_padding__hover=\"|40px||80px||false\" background__hover_enabled=\"on|hover\" background_color__hover=\"#680000\" background_enable_color__hover=\"on\"]<p>مشاهده تمام خدمات</p>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Gallery\" _builder_version=\"3.22\" background_color=\"#f7f9fc\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#f7f9fc\" background_color_gradient_end=\"#ffffff\"][et_pb_row column_structure=\"1_4,1_4,1_2\" _builder_version=\"3.25\"][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-08.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"|||-10vw\" custom_margin_tablet=\"|||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|phone\" locked=\"off\"][/et_pb_image][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/crypto_image_03.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" border_color_all=\"#ffffff\" border_width_bottom=\"20px\" border_width_left=\"20px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-10.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"6vw||\" custom_margin_tablet=\"\" custom_margin_phone=\"0vw||\" custom_margin_last_edited=\"on|desktop\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>چند نمونه کار اخیر ما</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"مشاهده سایر نمونه کارها\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"left\" custom_padding=\"27px|0px|0|0px|false|false\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\" locked=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonials\" _builder_version=\"3.22\" background_color=\"#ffffff\" custom_padding=\"0|0px|54px|0px|false|false\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_slider _builder_version=\"4.4.2\" body_font=\"|600|on||||||\" body_font_size=\"26px\" body_line_height=\"1.8em\" background_color=\"#dfab82\" animation_style=\"flip\" hover_enabled=\"0\" body_font_size_tablet=\"20px\" body_font_size_phone=\"12px\" body_font_size_last_edited=\"on|phone\" box_shadow_style=\"preset1\" box_shadow_vertical=\"50px\" box_shadow_blur=\"60px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][/et_pb_slider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" _builder_version=\"4.4.2\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/Tailor-back.jpg\" hover_enabled=\"0\"][et_pb_row _builder_version=\"4.4.2\"][et_pb_column _builder_version=\"4.4.2\" type=\"4_4\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/Tailor3.png\" _builder_version=\"4.4.2\" hover_enabled=\"0\" custom_css_main_element=\"||\" scroll_vertical_motion_enable=\"on\" scroll_vertical_motion=\"20|50|50|90|4|0|-4\"][/et_pb_image][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#f1f6ff\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>در تماس باشید!</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_blurb title=\"بازدید از محل کار ما\" use_icon=\"on\" font_icon=\"%%249%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\"]<p>ایران - تهران - شهرک خیاط</p>\n[/et_pb_blurb][et_pb_blurb title=\"شماره تماس\" use_icon=\"on\" font_icon=\"%%264%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\"]<p>091312345678</p>\n[/et_pb_blurb][et_pb_blurb title=\"ایمیل ما\" use_icon=\"on\" font_icon=\"%%238%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\"]<p>info@modelsite.ir</p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_row_inner _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"60px|0px|60px|0px|true|false\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_column_inner saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_contact_form captcha=\"off\" module_id=\"et_pb_contact_form_0\" _builder_version=\"4.4.2\" form_field_background_color=\"#f5f9ff\" form_field_font=\"||||||||\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#af8447\" button_border_width=\"10px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"|40px||40px||true\" hover_enabled=\"0\" form_background_color=\"#f5f9ff\" submit_button_text=\"ارسال پیام\" success_message=\"پیام شما با موفقیت ارسال شد .\" button_bg_enable_color=\"on\" box_shadow_style_button=\"preset1\" form_field_text_shadow_style=\"preset4\"][et_pb_contact_field field_id=\"Name\" field_title=\"نام\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Email\" field_title=\"ایمیل شما\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Phone\" field_title=\"شماره تماس\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Message\" field_title=\"پیام شما ....\" field_type=\"text\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||30px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][/et_pb_contact_form][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section]", "خانه", "", "inherit", "closed", "closed", "", "2-revision-v1", "", "", "2020-03-31 14:38:54", "2020-03-31 11:08:54", "", "2", "http://modelsite.test/2-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2845", "1", "2020-03-31 14:41:52", "2020-03-31 11:11:52", "[et_pb_section fb_built=\"1\" use_custom_gutter=\"on\" gutter_width=\"1\" admin_label=\"Header\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#f7f9fc\" background_color_gradient_start_position=\"75%\" background_color_gradient_end_position=\"75%\" custom_padding=\"0|0px|0|0px|false|false\" hover_enabled=\"0\"][et_pb_row column_structure=\"1_2,1_2\" use_custom_gutter=\"on\" gutter_width=\"1\" make_equal=\"on\" padding_top_bottom_link_1=\"true\" _builder_version=\"3.25\" custom_padding=\"0|0px|0|0px|false|false\" hover_enabled=\"0\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"8vw|60px|8vw|\" custom_padding_tablet=\"|0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"|0px||\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"|600|||||||\" header_font_size=\"60px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_text_color=\"#dfab82\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" custom_margin=\"||40px\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\"]<h1>خیاطی مردانه</h1>\n<h2>شیک پوش باشید </h2>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"آنلاین رزرو کنید\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#41547d\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(65,84,125,0.24)\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][et_pb_button button_text=\"یا تماس بگیرید : 12345-021\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#41547d\" button_bg_color=\"#ffffff\" button_border_width=\"0px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(65,84,125,0.06)\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_text_color_last_edited=\"on|desktop\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#af8447\" button_bg_enable_color__hover=\"on\" button_text_color__hover_enabled=\"on|hover\" button_text_color__hover=\"#ffffff\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-02.jpg\" parallax=\"on\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider show_divider=\"off\" disabled_on=\"off|off|on\" _builder_version=\"3.17.6\" height=\"250px\" hover_enabled=\"0\"][/et_pb_divider][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" use_custom_gutter=\"on\" gutter_width=\"1\" padding_top_bottom_link_2=\"false\" _builder_version=\"3.25\" custom_padding=\"0|0px|27px|0px|false|false\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_video src=\"#\" image_src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-03.jpg\" _builder_version=\"4.4.2\" custom_margin=\"|||-80px\" custom_margin_tablet=\"|||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" hover_enabled=\"0\"][/et_pb_video][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"100px|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-04.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" max_width=\"80%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" box_shadow_style=\"preset1\" box_shadow_horizontal=\"-41px\" box_shadow_vertical=\"45px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(0,0,0,0.52)\" locked=\"off\"][/et_pb_image][et_pb_text _builder_version=\"4.4.2\" text_font=\"|600|||||||\" text_font_size=\"24px\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_2_font=\"||||||||\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" background_color=\"#dfab82\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-01.png\" background_position=\"bottom_right\" background_layout=\"dark\" custom_margin=\"|||0%\" custom_padding=\"50px|60px|50px|60px|true|true\" animation_direction=\"left\" link_option_url=\"#\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\" custom_padding__hover_enabled=\"on\" custom_padding__hover=\"|40px||80px||false\" background__hover_enabled=\"on\" background_color__hover=\"#ddb494\"]<p>مشاهده گالری نمونه کارها</p>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"left\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" admin_label=\"Services\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"22px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>یک کت و شلوار سفارش دهید که توسط خیاطان متخصص برای تن شما ساخته شده است</h2>\n[/et_pb_text][et_pb_button button_text=\"یک وقت بگیرید\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_row_inner column_structure=\"1_2,1_2\" _builder_version=\"3.25\"][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"خیاطی لباس دامادی\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-03.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][et_pb_blurb title=\"تعمیرات لباس\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-02.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][/et_pb_column_inner][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"میلیمترها رو ما حواسمان هست\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-12.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][et_pb_blurb title=\"دوخت انواع پیراهن و شلوار\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-01.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonial\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-05.jpg\" custom_padding=\"0|0px|12vw|0px|false|false\" hover_enabled=\"0\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_testimonial quote_icon=\"off\" _builder_version=\"4.4.2\" body_font=\"|600|on||||||\" body_font_size=\"18px\" body_line_height=\"2.5em\" background_color=\"#41547d\" background_layout=\"dark\" custom_margin=\"-12vw|||-10vw\" custom_margin_tablet=\"0vw||10vw|0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" custom_padding=\"80px|60px|80px|7vw|true|false\" custom_padding_tablet=\"40px|10%|40px|10%|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" animation_style=\"flip\" hover_enabled=\"0\" body_font_size_tablet=\"18px\" body_font_size_phone=\"\" body_font_size_last_edited=\"on|desktop\" body_line_height_tablet=\"\" body_line_height_phone=\"1.8em\" body_line_height_last_edited=\"on|phone\" box_shadow_style=\"preset1\" box_shadow_horizontal=\"-41px\" box_shadow_vertical=\"45px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(0,0,0,0.52)\" locked=\"off\"]<p>\"<b>دوزندگی</b><span> </span>صنعت و هنر<span> پیوست یا پیوند اشیاء با استفاده از </span>بخیه<span> ساخته شده با </span>سوزن<span> و </span>نخ<span> است. دوزندگی یکی از قدیمی‌ترین </span>هنرهای منسوجات<span> پدید آمده در دوران </span>پارینه‌سنگی<span> است</span><span>.</span>\"</p>\n[/et_pb_testimonial][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_6,1_6,1_6,1_6,1_6,1_6\" _builder_version=\"3.25\"][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_08-1.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_07-1.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_06-1.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_05-2.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_03-2.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_01-2.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Feature\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"32px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>لباس شما با بهترین مواد دوخته می شود</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"اطلاعات بیشتر\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-06.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\"][/et_pb_image][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-07.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" max_width=\"70%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" border_color_all=\"#ffffff\" border_width_right=\"20px\" border_width_bottom=\"20px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][/et_pb_image][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"right\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Services\" _builder_version=\"3.22\" background_color=\"#f7f9fc\" custom_margin=\"|||\" custom_padding=\"0|0px|80px|0px|false|false\"][et_pb_row column_structure=\"1_2,1_2\" custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#ffffff\" width=\"90%\" max_width=\"90%\" module_alignment=\"left\" custom_margin=\"|||\" custom_padding=\"60px|||15vw|false|false\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"120px\" box_shadow_color=\"rgba(96,104,121,0.12)\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"90%\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.4em\" max_width=\"600px\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>خیاطی و تعمیرات</h2>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_4,1_4,1_2\" custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#ffffff\" width=\"90%\" max_width=\"90%\" module_alignment=\"left\" custom_margin=\"|||\" custom_padding=\"||120px|15vw|false|false\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"120px\" box_shadow_color=\"rgba(96,104,121,0.12)\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"90%\"][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-04.png\" _builder_version=\"4.4.2\" hover_enabled=\"0\" always_center_on_mobile=\"off\" locked=\"off\" animation_style=\"slide\" animation_direction=\"bottom\" animation_delay=\"600ms\"][/et_pb_image][et_pb_blurb title=\"خدمات خیاطی\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-05.png\" _builder_version=\"4.4.2\" hover_enabled=\"0\" always_center_on_mobile=\"off\" locked=\"off\" animation_style=\"slide\" animation_direction=\"bottom\" transform_styles__hover_enabled=\"off|hover\" transform_scale__hover_enabled=\"off|hover\" transform_translate__hover_enabled=\"off|hover\" transform_rotate__hover_enabled=\"off|hover\" transform_skew__hover_enabled=\"off|hover\" transform_origin__hover_enabled=\"off|hover\" animation_delay=\"600ms\"][/et_pb_image][et_pb_blurb title=\"خدمات تعمیرات\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_font_size=\"18px\" background_color=\"#41547d\" background_layout=\"dark\" custom_margin=\"-14vw|-10vw||10vw\" custom_margin_tablet=\"0vw|0vw||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" custom_padding=\"80px|60px|80px|60px|true|true\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|phone\" animation_style=\"flip\" hover_enabled=\"0\" text_font_size_tablet=\"\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\" locked=\"off\" text_text_shadow_style=\"preset3\" text_letter_spacing=\"1px\"]<ol>\n<li> کوتاه کردن / بلند کردن</li>\n<li>کاف</li>\n<li>پوشش</li>\n<li>دور کمر</li>\n<li>آستین ها را بلند / کوتاه کنید</li>\n<li>دکمه / قلاب دوباره دوخت</li>\n<li>تعویض زیپ</li>\n<li>و ......</li>\n</ol>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" module_alignment=\"left\" custom_margin=\"-40px||\" custom_padding=\"0|0px|0|0px|false|false\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|600|||||||\" text_font_size=\"24px\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_2_font=\"||||||||\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" background_color=\"#dfab82\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-01.png\" background_position=\"bottom_right\" background_layout=\"dark\" custom_padding=\"50px|60px|50px|60px|true|true\" animation_style=\"flip\" link_option_url=\"#\" hover_enabled=\"0\" locked=\"off\" custom_padding__hover_enabled=\"on\" custom_padding__hover=\"|40px||80px||false\" background__hover_enabled=\"on|hover\" background_color__hover=\"#680000\" background_enable_color__hover=\"on\"]<p>مشاهده تمام خدمات</p>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Gallery\" _builder_version=\"3.22\" background_color=\"#f7f9fc\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#f7f9fc\" background_color_gradient_end=\"#ffffff\"][et_pb_row column_structure=\"1_4,1_4,1_2\" _builder_version=\"3.25\"][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-08.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"4.4.2\" custom_margin=\"|||-7vw|false|false\" custom_margin_tablet=\"|||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|phone\" hover_enabled=\"0\" locked=\"off\"][/et_pb_image][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/crypto_image_03.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" border_color_all=\"#ffffff\" border_width_bottom=\"20px\" border_width_left=\"20px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-10.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"6vw||\" custom_margin_tablet=\"\" custom_margin_phone=\"0vw||\" custom_margin_last_edited=\"on|desktop\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>چند نمونه کار اخیر ما</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"مشاهده سایر نمونه کارها\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"left\" custom_padding=\"27px|0px|0|0px|false|false\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\" locked=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonials\" _builder_version=\"3.22\" background_color=\"#ffffff\" custom_padding=\"0|0px|54px|0px|false|false\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_slider _builder_version=\"4.4.2\" body_font=\"|600|on||||||\" body_font_size=\"26px\" body_line_height=\"1.8em\" background_color=\"#dfab82\" animation_style=\"flip\" hover_enabled=\"0\" body_font_size_tablet=\"20px\" body_font_size_phone=\"12px\" body_font_size_last_edited=\"on|phone\" box_shadow_style=\"preset1\" box_shadow_vertical=\"50px\" box_shadow_blur=\"60px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][/et_pb_slider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" _builder_version=\"4.4.2\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/Tailor-back.jpg\" hover_enabled=\"0\"][et_pb_row _builder_version=\"4.4.2\"][et_pb_column _builder_version=\"4.4.2\" type=\"4_4\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/Tailor3.png\" _builder_version=\"4.4.2\" hover_enabled=\"0\" custom_css_main_element=\"||\" scroll_vertical_motion_enable=\"on\" scroll_vertical_motion=\"20|50|50|90|4|0|-4\"][/et_pb_image][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#f1f6ff\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>در تماس باشید!</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_blurb title=\"بازدید از محل کار ما\" use_icon=\"on\" font_icon=\"%%249%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\"]<p>ایران - تهران - شهرک خیاط</p>\n[/et_pb_blurb][et_pb_blurb title=\"شماره تماس\" use_icon=\"on\" font_icon=\"%%264%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\"]<p>091312345678</p>\n[/et_pb_blurb][et_pb_blurb title=\"ایمیل ما\" use_icon=\"on\" font_icon=\"%%238%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\"]<p>info@modelsite.ir</p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_row_inner _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"60px|0px|60px|0px|true|false\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_column_inner saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_contact_form captcha=\"off\" module_id=\"et_pb_contact_form_0\" _builder_version=\"4.4.2\" form_field_background_color=\"#f5f9ff\" form_field_font=\"||||||||\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#af8447\" button_border_width=\"10px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"|40px||40px||true\" hover_enabled=\"0\" form_background_color=\"#f5f9ff\" submit_button_text=\"ارسال پیام\" success_message=\"پیام شما با موفقیت ارسال شد .\" button_bg_enable_color=\"on\" box_shadow_style_button=\"preset1\" form_field_text_shadow_style=\"preset4\"][et_pb_contact_field field_id=\"Name\" field_title=\"نام\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Email\" field_title=\"ایمیل شما\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Phone\" field_title=\"شماره تماس\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Message\" field_title=\"پیام شما ....\" field_type=\"text\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||30px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][/et_pb_contact_form][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section]", "خانه", "", "inherit", "closed", "closed", "", "2-revision-v1", "", "", "2020-03-31 14:41:52", "2020-03-31 11:11:52", "", "2", "http://modelsite.test/2-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2847", "1", "2020-03-31 14:43:01", "2020-03-31 11:13:01", "[et_pb_section fb_built=\"1\" use_custom_gutter=\"on\" gutter_width=\"1\" admin_label=\"Header\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#f7f9fc\" background_color_gradient_start_position=\"75%\" background_color_gradient_end_position=\"75%\" custom_padding=\"0|0px|0|0px|false|false\" hover_enabled=\"0\"][et_pb_row column_structure=\"1_2,1_2\" use_custom_gutter=\"on\" gutter_width=\"1\" make_equal=\"on\" padding_top_bottom_link_1=\"true\" _builder_version=\"3.25\" custom_padding=\"0|0px|0|0px|false|false\" hover_enabled=\"0\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"8vw|60px|8vw|\" custom_padding_tablet=\"|0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"|0px||\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"|600|||||||\" header_font_size=\"60px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_text_color=\"#dfab82\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" custom_margin=\"||40px\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\"]<h1>خیاطی مردانه</h1>\n<h2>شیک پوش باشید </h2>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"آنلاین رزرو کنید\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#41547d\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(65,84,125,0.24)\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][et_pb_button button_text=\"یا تماس بگیرید : 12345-021\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#41547d\" button_bg_color=\"#ffffff\" button_border_width=\"0px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(65,84,125,0.06)\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_text_color_last_edited=\"on|desktop\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#af8447\" button_bg_enable_color__hover=\"on\" button_text_color__hover_enabled=\"on|hover\" button_text_color__hover=\"#ffffff\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-02.jpg\" parallax=\"on\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider show_divider=\"off\" disabled_on=\"off|off|on\" _builder_version=\"3.17.6\" height=\"250px\" hover_enabled=\"0\"][/et_pb_divider][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" use_custom_gutter=\"on\" gutter_width=\"1\" padding_top_bottom_link_2=\"false\" _builder_version=\"3.25\" custom_padding=\"0|0px|27px|0px|false|false\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_video src=\"#\" image_src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-03.jpg\" _builder_version=\"4.4.2\" custom_margin=\"|||-80px\" custom_margin_tablet=\"|||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" hover_enabled=\"0\"][/et_pb_video][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"100px|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-04.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" max_width=\"80%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" box_shadow_style=\"preset1\" box_shadow_horizontal=\"-41px\" box_shadow_vertical=\"45px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(0,0,0,0.52)\" locked=\"off\"][/et_pb_image][et_pb_text _builder_version=\"4.4.2\" text_font=\"|600|||||||\" text_font_size=\"24px\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_2_font=\"||||||||\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" background_color=\"#dfab82\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-01.png\" background_position=\"bottom_right\" background_layout=\"dark\" custom_margin=\"|||0%\" custom_padding=\"50px|60px|50px|60px|true|true\" animation_direction=\"left\" link_option_url=\"#\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\" custom_padding__hover_enabled=\"on\" custom_padding__hover=\"|40px||80px||false\" background__hover_enabled=\"on\" background_color__hover=\"#ddb494\"]<p>مشاهده گالری نمونه کارها</p>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"left\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" admin_label=\"Services\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"22px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>یک کت و شلوار سفارش دهید که توسط خیاطان متخصص برای تن شما ساخته شده است</h2>\n[/et_pb_text][et_pb_button button_text=\"یک وقت بگیرید\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_row_inner column_structure=\"1_2,1_2\" _builder_version=\"3.25\"][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"خیاطی لباس دامادی\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-03.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][et_pb_blurb title=\"تعمیرات لباس\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-02.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][/et_pb_column_inner][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"میلیمترها رو ما حواسمان هست\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-12.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][et_pb_blurb title=\"دوخت انواع پیراهن و شلوار\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-01.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonial\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-05.jpg\" custom_padding=\"0|0px|12vw|0px|false|false\" hover_enabled=\"0\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_testimonial quote_icon=\"off\" _builder_version=\"4.4.2\" body_font=\"|600|on||||||\" body_font_size=\"18px\" body_line_height=\"2.5em\" background_color=\"#41547d\" background_layout=\"dark\" custom_margin=\"-12vw|||-10vw\" custom_margin_tablet=\"0vw||10vw|0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" custom_padding=\"80px|60px|80px|7vw|true|false\" custom_padding_tablet=\"40px|10%|40px|10%|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" animation_style=\"flip\" hover_enabled=\"0\" body_font_size_tablet=\"18px\" body_font_size_phone=\"\" body_font_size_last_edited=\"on|desktop\" body_line_height_tablet=\"\" body_line_height_phone=\"1.8em\" body_line_height_last_edited=\"on|phone\" box_shadow_style=\"preset1\" box_shadow_horizontal=\"-41px\" box_shadow_vertical=\"45px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(0,0,0,0.52)\" locked=\"off\"]<p>\"<b>دوزندگی</b><span> </span>صنعت و هنر<span> پیوست یا پیوند اشیاء با استفاده از </span>بخیه<span> ساخته شده با </span>سوزن<span> و </span>نخ<span> است. دوزندگی یکی از قدیمی‌ترین </span>هنرهای منسوجات<span> پدید آمده در دوران </span>پارینه‌سنگی<span> است</span><span>.</span>\"</p>\n[/et_pb_testimonial][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_6,1_6,1_6,1_6,1_6,1_6\" _builder_version=\"3.25\"][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_08-1.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_07-1.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_06-1.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_05-2.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_03-2.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_01-2.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Feature\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"32px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>لباس شما با بهترین مواد دوخته می شود</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"اطلاعات بیشتر\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-06.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\"][/et_pb_image][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-07.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" max_width=\"70%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" border_color_all=\"#ffffff\" border_width_right=\"20px\" border_width_bottom=\"20px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][/et_pb_image][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"right\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Services\" _builder_version=\"3.22\" background_color=\"#f7f9fc\" custom_margin=\"|||\" custom_padding=\"0|0px|80px|0px|false|false\"][et_pb_row column_structure=\"1_2,1_2\" custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#ffffff\" width=\"90%\" max_width=\"90%\" module_alignment=\"left\" custom_margin=\"|||\" custom_padding=\"60px|||15vw|false|false\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"120px\" box_shadow_color=\"rgba(96,104,121,0.12)\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"90%\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.4em\" max_width=\"600px\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>خیاطی و تعمیرات</h2>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_4,1_4,1_2\" custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#ffffff\" width=\"90%\" max_width=\"90%\" module_alignment=\"left\" custom_margin=\"|||\" custom_padding=\"||120px|15vw|false|false\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"120px\" box_shadow_color=\"rgba(96,104,121,0.12)\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"90%\"][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-04.png\" _builder_version=\"4.4.2\" hover_enabled=\"0\" always_center_on_mobile=\"off\" locked=\"off\" animation_style=\"slide\" animation_direction=\"bottom\" animation_delay=\"600ms\"][/et_pb_image][et_pb_blurb title=\"خدمات خیاطی\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-05.png\" _builder_version=\"4.4.2\" hover_enabled=\"0\" always_center_on_mobile=\"off\" locked=\"off\" animation_style=\"slide\" animation_direction=\"bottom\" transform_styles__hover_enabled=\"off|hover\" transform_scale__hover_enabled=\"off|hover\" transform_translate__hover_enabled=\"off|hover\" transform_rotate__hover_enabled=\"off|hover\" transform_skew__hover_enabled=\"off|hover\" transform_origin__hover_enabled=\"off|hover\" animation_delay=\"600ms\"][/et_pb_image][et_pb_blurb title=\"خدمات تعمیرات\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_font_size=\"18px\" background_color=\"#41547d\" background_layout=\"dark\" custom_margin=\"-14vw|-10vw||10vw\" custom_margin_tablet=\"0vw|0vw||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" custom_padding=\"80px|60px|80px|60px|true|true\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|phone\" animation_style=\"flip\" hover_enabled=\"0\" text_font_size_tablet=\"\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\" locked=\"off\" text_text_shadow_style=\"preset3\" text_letter_spacing=\"1px\"]<ol>\n<li> کوتاه کردن / بلند کردن</li>\n<li>کاف</li>\n<li>پوشش</li>\n<li>دور کمر</li>\n<li>آستین ها را بلند / کوتاه کنید</li>\n<li>دکمه / قلاب دوباره دوخت</li>\n<li>تعویض زیپ</li>\n<li>و ......</li>\n</ol>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" module_alignment=\"left\" custom_margin=\"-40px||\" custom_padding=\"0|0px|0|0px|false|false\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|600|||||||\" text_font_size=\"24px\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_2_font=\"||||||||\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" background_color=\"#dfab82\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-01.png\" background_position=\"bottom_right\" background_layout=\"dark\" custom_padding=\"50px|60px|50px|60px|true|true\" animation_style=\"flip\" link_option_url=\"#\" hover_enabled=\"0\" locked=\"off\" custom_padding__hover_enabled=\"on\" custom_padding__hover=\"|40px||80px||false\" background__hover_enabled=\"on|hover\" background_color__hover=\"#680000\" background_enable_color__hover=\"on\"]<p>مشاهده تمام خدمات</p>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Gallery\" _builder_version=\"3.22\" background_color=\"#f7f9fc\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#f7f9fc\" background_color_gradient_end=\"#ffffff\"][et_pb_row column_structure=\"1_4,1_4,1_2\" _builder_version=\"3.25\"][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-08.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"4.4.2\" custom_margin=\"|||-7vw|false|false\" custom_margin_tablet=\"|||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|phone\" hover_enabled=\"0\" locked=\"off\"][/et_pb_image][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/crypto_image_03.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" border_color_all=\"#ffffff\" border_width_bottom=\"20px\" border_width_left=\"20px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-10.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"6vw||\" custom_margin_tablet=\"\" custom_margin_phone=\"0vw||\" custom_margin_last_edited=\"on|desktop\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>چند نمونه کار اخیر ما</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"مشاهده سایر نمونه کارها\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"left\" custom_padding=\"27px|0px|0|0px|false|false\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\" locked=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonials\" _builder_version=\"3.22\" background_color=\"#ffffff\" custom_padding=\"0|0px|54px|0px|false|false\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_slider _builder_version=\"4.4.2\" body_font=\"|600|on||||||\" body_font_size=\"26px\" body_line_height=\"1.8em\" background_color=\"#dfab82\" animation_style=\"flip\" hover_enabled=\"0\" body_font_size_tablet=\"20px\" body_font_size_phone=\"12px\" body_font_size_last_edited=\"on|phone\" box_shadow_style=\"preset1\" box_shadow_vertical=\"50px\" box_shadow_blur=\"60px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][/et_pb_slider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" _builder_version=\"4.4.2\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/Tailor-back.jpg\" hover_enabled=\"0\" disabled_on=\"off|off|on\"][et_pb_row _builder_version=\"4.4.2\"][et_pb_column _builder_version=\"4.4.2\" type=\"4_4\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/Tailor3.png\" _builder_version=\"4.4.2\" hover_enabled=\"0\" custom_css_main_element=\"||\" scroll_vertical_motion_enable=\"on\" scroll_vertical_motion=\"20|50|50|90|4|0|-4\"][/et_pb_image][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#f1f6ff\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>در تماس باشید!</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_blurb title=\"بازدید از محل کار ما\" use_icon=\"on\" font_icon=\"%%249%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\"]<p>ایران - تهران - شهرک خیاط</p>\n[/et_pb_blurb][et_pb_blurb title=\"شماره تماس\" use_icon=\"on\" font_icon=\"%%264%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\"]<p>091312345678</p>\n[/et_pb_blurb][et_pb_blurb title=\"ایمیل ما\" use_icon=\"on\" font_icon=\"%%238%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\"]<p>info@modelsite.ir</p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_row_inner _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"60px|0px|60px|0px|true|false\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_column_inner saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_contact_form captcha=\"off\" module_id=\"et_pb_contact_form_0\" _builder_version=\"4.4.2\" form_field_background_color=\"#f5f9ff\" form_field_font=\"||||||||\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#af8447\" button_border_width=\"10px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"|40px||40px||true\" hover_enabled=\"0\" form_background_color=\"#f5f9ff\" submit_button_text=\"ارسال پیام\" success_message=\"پیام شما با موفقیت ارسال شد .\" button_bg_enable_color=\"on\" box_shadow_style_button=\"preset1\" form_field_text_shadow_style=\"preset4\"][et_pb_contact_field field_id=\"Name\" field_title=\"نام\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Email\" field_title=\"ایمیل شما\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Phone\" field_title=\"شماره تماس\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Message\" field_title=\"پیام شما ....\" field_type=\"text\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||30px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][/et_pb_contact_form][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section]", "خانه", "", "inherit", "closed", "closed", "", "2-revision-v1", "", "", "2020-03-31 14:43:01", "2020-03-31 11:13:01", "", "2", "http://modelsite.test/2-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2848", "1", "2020-03-31 14:43:43", "2020-03-31 11:13:43", "[et_pb_section fb_built=\"1\" use_custom_gutter=\"on\" gutter_width=\"1\" admin_label=\"Header\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#f7f9fc\" background_color_gradient_start_position=\"75%\" background_color_gradient_end_position=\"75%\" custom_padding=\"0|0px|0|0px|false|false\" hover_enabled=\"0\"][et_pb_row column_structure=\"1_2,1_2\" use_custom_gutter=\"on\" gutter_width=\"1\" make_equal=\"on\" padding_top_bottom_link_1=\"true\" _builder_version=\"3.25\" custom_padding=\"0|0px|0|0px|false|false\" hover_enabled=\"0\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"8vw|60px|8vw|\" custom_padding_tablet=\"|0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"|0px||\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"|600|||||||\" header_font_size=\"60px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_text_color=\"#dfab82\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" custom_margin=\"||40px\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\"]<h1>خیاطی مردانه</h1>\n<h2>شیک پوش باشید </h2>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"آنلاین رزرو کنید\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#41547d\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(65,84,125,0.24)\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][et_pb_button button_text=\"یا تماس بگیرید : 12345-021\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#41547d\" button_bg_color=\"#ffffff\" button_border_width=\"0px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(65,84,125,0.06)\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_text_color_last_edited=\"on|desktop\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#af8447\" button_bg_enable_color__hover=\"on\" button_text_color__hover_enabled=\"on|hover\" button_text_color__hover=\"#ffffff\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-02.jpg\" parallax=\"on\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider show_divider=\"off\" disabled_on=\"off|off|on\" _builder_version=\"3.17.6\" height=\"250px\" hover_enabled=\"0\"][/et_pb_divider][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" use_custom_gutter=\"on\" gutter_width=\"1\" padding_top_bottom_link_2=\"false\" _builder_version=\"3.25\" custom_padding=\"0|0px|27px|0px|false|false\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_video src=\"#\" image_src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-03.jpg\" _builder_version=\"4.4.2\" custom_margin=\"|||-80px\" custom_margin_tablet=\"|||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" hover_enabled=\"0\"][/et_pb_video][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"100px|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-04.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" max_width=\"80%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" box_shadow_style=\"preset1\" box_shadow_horizontal=\"-41px\" box_shadow_vertical=\"45px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(0,0,0,0.52)\" locked=\"off\"][/et_pb_image][et_pb_text _builder_version=\"4.4.2\" text_font=\"|600|||||||\" text_font_size=\"24px\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_2_font=\"||||||||\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" background_color=\"#dfab82\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-01.png\" background_position=\"bottom_right\" background_layout=\"dark\" custom_margin=\"|||0%\" custom_padding=\"50px|60px|50px|60px|true|true\" animation_direction=\"left\" link_option_url=\"#\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\" custom_padding__hover_enabled=\"on\" custom_padding__hover=\"|40px||80px||false\" background__hover_enabled=\"on\" background_color__hover=\"#ddb494\"]<p>مشاهده گالری نمونه کارها</p>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"left\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" admin_label=\"Services\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"22px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>یک کت و شلوار سفارش دهید که توسط خیاطان متخصص برای تن شما ساخته شده است</h2>\n[/et_pb_text][et_pb_button button_text=\"یک وقت بگیرید\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_row_inner column_structure=\"1_2,1_2\" _builder_version=\"3.25\"][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"خیاطی لباس دامادی\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-03.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][et_pb_blurb title=\"تعمیرات لباس\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-02.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][/et_pb_column_inner][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"میلیمترها رو ما حواسمان هست\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-12.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][et_pb_blurb title=\"دوخت انواع پیراهن و شلوار\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-01.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonial\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-05.jpg\" custom_padding=\"0|0px|12vw|0px|false|false\" hover_enabled=\"0\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_testimonial quote_icon=\"off\" _builder_version=\"4.4.2\" body_font=\"|600|on||||||\" body_font_size=\"18px\" body_line_height=\"2.5em\" background_color=\"#41547d\" background_layout=\"dark\" custom_margin=\"-12vw|||-10vw\" custom_margin_tablet=\"0vw||10vw|0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" custom_padding=\"80px|60px|80px|7vw|true|false\" custom_padding_tablet=\"40px|10%|40px|10%|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" animation_style=\"flip\" hover_enabled=\"0\" body_font_size_tablet=\"18px\" body_font_size_phone=\"\" body_font_size_last_edited=\"on|desktop\" body_line_height_tablet=\"\" body_line_height_phone=\"1.8em\" body_line_height_last_edited=\"on|phone\" box_shadow_style=\"preset1\" box_shadow_horizontal=\"-41px\" box_shadow_vertical=\"45px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(0,0,0,0.52)\" locked=\"off\"]<p>\"<b>دوزندگی</b><span> </span>صنعت و هنر<span> پیوست یا پیوند اشیاء با استفاده از </span>بخیه<span> ساخته شده با </span>سوزن<span> و </span>نخ<span> است. دوزندگی یکی از قدیمی‌ترین </span>هنرهای منسوجات<span> پدید آمده در دوران </span>پارینه‌سنگی<span> است</span><span>.</span>\"</p>\n[/et_pb_testimonial][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_6,1_6,1_6,1_6,1_6,1_6\" _builder_version=\"3.25\"][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_08-1.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_07-1.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_06-1.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_05-2.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_03-2.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_01-2.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Feature\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"32px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>لباس شما با بهترین مواد دوخته می شود</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"اطلاعات بیشتر\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-06.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\"][/et_pb_image][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-07.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" max_width=\"70%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" border_color_all=\"#ffffff\" border_width_right=\"20px\" border_width_bottom=\"20px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][/et_pb_image][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"right\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Services\" _builder_version=\"3.22\" background_color=\"#f7f9fc\" custom_margin=\"|||\" custom_padding=\"0|0px|80px|0px|false|false\"][et_pb_row column_structure=\"1_2,1_2\" custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#ffffff\" width=\"90%\" max_width=\"90%\" module_alignment=\"left\" custom_margin=\"|||\" custom_padding=\"60px|||15vw|false|false\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"120px\" box_shadow_color=\"rgba(96,104,121,0.12)\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"90%\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.4em\" max_width=\"600px\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>خیاطی و تعمیرات</h2>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_4,1_4,1_2\" custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#ffffff\" width=\"90%\" max_width=\"90%\" module_alignment=\"left\" custom_margin=\"|||\" custom_padding=\"||120px|15vw|false|false\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"120px\" box_shadow_color=\"rgba(96,104,121,0.12)\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"90%\"][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-04.png\" _builder_version=\"4.4.2\" hover_enabled=\"0\" always_center_on_mobile=\"off\" locked=\"off\" animation_style=\"slide\" animation_direction=\"bottom\" animation_delay=\"600ms\"][/et_pb_image][et_pb_blurb title=\"خدمات خیاطی\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-05.png\" _builder_version=\"4.4.2\" hover_enabled=\"0\" always_center_on_mobile=\"off\" locked=\"off\" animation_style=\"slide\" animation_direction=\"bottom\" transform_styles__hover_enabled=\"off|hover\" transform_scale__hover_enabled=\"off|hover\" transform_translate__hover_enabled=\"off|hover\" transform_rotate__hover_enabled=\"off|hover\" transform_skew__hover_enabled=\"off|hover\" transform_origin__hover_enabled=\"off|hover\" animation_delay=\"600ms\"][/et_pb_image][et_pb_blurb title=\"خدمات تعمیرات\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_font_size=\"18px\" background_color=\"#41547d\" background_layout=\"dark\" custom_margin=\"-14vw|-10vw||10vw\" custom_margin_tablet=\"0vw|0vw||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" custom_padding=\"80px|60px|80px|60px|true|true\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|phone\" animation_style=\"flip\" hover_enabled=\"0\" text_font_size_tablet=\"\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\" locked=\"off\" text_text_shadow_style=\"preset3\" text_letter_spacing=\"1px\"]<ol>\n<li> کوتاه کردن / بلند کردن</li>\n<li>کاف</li>\n<li>پوشش</li>\n<li>دور کمر</li>\n<li>آستین ها را بلند / کوتاه کنید</li>\n<li>دکمه / قلاب دوباره دوخت</li>\n<li>تعویض زیپ</li>\n<li>و ......</li>\n</ol>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" module_alignment=\"left\" custom_margin=\"-40px||\" custom_padding=\"0|0px|0|0px|false|false\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|600|||||||\" text_font_size=\"24px\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_2_font=\"||||||||\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" background_color=\"#dfab82\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-01.png\" background_position=\"bottom_right\" background_layout=\"dark\" custom_padding=\"50px|60px|50px|60px|true|true\" animation_style=\"flip\" link_option_url=\"#\" hover_enabled=\"0\" locked=\"off\" custom_padding__hover_enabled=\"on\" custom_padding__hover=\"|40px||80px||false\" background__hover_enabled=\"on|hover\" background_color__hover=\"#680000\" background_enable_color__hover=\"on\"]<p>مشاهده تمام خدمات</p>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Gallery\" _builder_version=\"4.4.2\" background_color=\"#f7f9fc\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#f7f9fc\" background_color_gradient_end=\"#ffffff\" hover_enabled=\"0\" disabled_on=\"off|off|on\"][et_pb_row column_structure=\"1_4,1_4,1_2\" _builder_version=\"3.25\"][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-08.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"4.4.2\" custom_margin=\"|||-7vw|false|false\" custom_margin_tablet=\"|||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|phone\" hover_enabled=\"0\" locked=\"off\"][/et_pb_image][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/crypto_image_03.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" border_color_all=\"#ffffff\" border_width_bottom=\"20px\" border_width_left=\"20px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-10.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"6vw||\" custom_margin_tablet=\"\" custom_margin_phone=\"0vw||\" custom_margin_last_edited=\"on|desktop\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>چند نمونه کار اخیر ما</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"مشاهده سایر نمونه کارها\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"left\" custom_padding=\"27px|0px|0|0px|false|false\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\" locked=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonials\" _builder_version=\"3.22\" background_color=\"#ffffff\" custom_padding=\"0|0px|54px|0px|false|false\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_slider _builder_version=\"4.4.2\" body_font=\"|600|on||||||\" body_font_size=\"26px\" body_line_height=\"1.8em\" background_color=\"#dfab82\" animation_style=\"flip\" hover_enabled=\"0\" body_font_size_tablet=\"20px\" body_font_size_phone=\"12px\" body_font_size_last_edited=\"on|phone\" box_shadow_style=\"preset1\" box_shadow_vertical=\"50px\" box_shadow_blur=\"60px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][/et_pb_slider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" _builder_version=\"4.4.2\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/Tailor-back.jpg\" hover_enabled=\"0\" disabled_on=\"off|off|on\"][et_pb_row _builder_version=\"4.4.2\"][et_pb_column _builder_version=\"4.4.2\" type=\"4_4\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/Tailor3.png\" _builder_version=\"4.4.2\" hover_enabled=\"0\" custom_css_main_element=\"||\" scroll_vertical_motion_enable=\"on\" scroll_vertical_motion=\"20|50|50|90|4|0|-4\"][/et_pb_image][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#f1f6ff\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>در تماس باشید!</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_blurb title=\"بازدید از محل کار ما\" use_icon=\"on\" font_icon=\"%%249%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\"]<p>ایران - تهران - شهرک خیاط</p>\n[/et_pb_blurb][et_pb_blurb title=\"شماره تماس\" use_icon=\"on\" font_icon=\"%%264%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\"]<p>091312345678</p>\n[/et_pb_blurb][et_pb_blurb title=\"ایمیل ما\" use_icon=\"on\" font_icon=\"%%238%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\"]<p>info@modelsite.ir</p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_row_inner _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"60px|0px|60px|0px|true|false\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_column_inner saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_contact_form captcha=\"off\" module_id=\"et_pb_contact_form_0\" _builder_version=\"4.4.2\" form_field_background_color=\"#f5f9ff\" form_field_font=\"||||||||\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#af8447\" button_border_width=\"10px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"|40px||40px||true\" hover_enabled=\"0\" form_background_color=\"#f5f9ff\" submit_button_text=\"ارسال پیام\" success_message=\"پیام شما با موفقیت ارسال شد .\" button_bg_enable_color=\"on\" box_shadow_style_button=\"preset1\" form_field_text_shadow_style=\"preset4\"][et_pb_contact_field field_id=\"Name\" field_title=\"نام\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Email\" field_title=\"ایمیل شما\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Phone\" field_title=\"شماره تماس\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Message\" field_title=\"پیام شما ....\" field_type=\"text\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||30px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][/et_pb_contact_form][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section]", "خانه", "", "inherit", "closed", "closed", "", "2-revision-v1", "", "", "2020-03-31 14:43:43", "2020-03-31 11:13:43", "", "2", "http://modelsite.test/2-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2850", "1", "2020-03-31 14:45:17", "2020-03-31 11:15:17", "[et_pb_section fb_built=\"1\" use_custom_gutter=\"on\" gutter_width=\"1\" admin_label=\"Header\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#f7f9fc\" background_color_gradient_start_position=\"75%\" background_color_gradient_end_position=\"75%\" custom_padding=\"0|0px|0|0px|false|false\" hover_enabled=\"0\"][et_pb_row column_structure=\"1_2,1_2\" use_custom_gutter=\"on\" gutter_width=\"1\" make_equal=\"on\" padding_top_bottom_link_1=\"true\" _builder_version=\"3.25\" custom_padding=\"0|0px|0|0px|false|false\" hover_enabled=\"0\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"8vw|60px|8vw|\" custom_padding_tablet=\"|0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"|0px||\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"|600|||||||\" header_font_size=\"60px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_text_color=\"#dfab82\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" custom_margin=\"||40px\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\"]<h1>خیاطی مردانه</h1>\n<h2>شیک پوش باشید </h2>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"آنلاین رزرو کنید\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#41547d\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(65,84,125,0.24)\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][et_pb_button button_text=\"یا تماس بگیرید : 12345-021\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#41547d\" button_bg_color=\"#ffffff\" button_border_width=\"0px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(65,84,125,0.06)\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_text_color_last_edited=\"on|desktop\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#af8447\" button_bg_enable_color__hover=\"on\" button_text_color__hover_enabled=\"on|hover\" button_text_color__hover=\"#ffffff\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-02.jpg\" parallax=\"on\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider show_divider=\"off\" disabled_on=\"off|off|on\" _builder_version=\"3.17.6\" height=\"250px\" hover_enabled=\"0\"][/et_pb_divider][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" use_custom_gutter=\"on\" gutter_width=\"1\" padding_top_bottom_link_2=\"false\" _builder_version=\"3.25\" custom_padding=\"0|0px|27px|0px|false|false\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_video src=\"#\" image_src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-03.jpg\" _builder_version=\"4.4.2\" custom_margin=\"|||-80px\" custom_margin_tablet=\"|||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" hover_enabled=\"0\"][/et_pb_video][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"100px|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-04.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" max_width=\"80%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" box_shadow_style=\"preset1\" box_shadow_horizontal=\"-41px\" box_shadow_vertical=\"45px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(0,0,0,0.52)\" locked=\"off\"][/et_pb_image][et_pb_text _builder_version=\"4.4.2\" text_font=\"|600|||||||\" text_font_size=\"24px\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_2_font=\"||||||||\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" background_color=\"#dfab82\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-01.png\" background_position=\"bottom_right\" background_layout=\"dark\" custom_margin=\"|||0%\" custom_padding=\"50px|60px|50px|60px|true|true\" animation_direction=\"left\" link_option_url=\"#\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\" custom_padding__hover_enabled=\"on\" custom_padding__hover=\"|40px||80px||false\" background__hover_enabled=\"on\" background_color__hover=\"#ddb494\"]<p>مشاهده گالری نمونه کارها</p>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"left\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" admin_label=\"Services\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"22px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>یک کت و شلوار سفارش دهید که توسط خیاطان متخصص برای تن شما ساخته شده است</h2>\n[/et_pb_text][et_pb_button button_text=\"یک وقت بگیرید\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_row_inner column_structure=\"1_2,1_2\" _builder_version=\"3.25\"][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"خیاطی لباس دامادی\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-03.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][et_pb_blurb title=\"تعمیرات لباس\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-02.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][/et_pb_column_inner][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"میلیمترها رو ما حواسمان هست\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-12.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][et_pb_blurb title=\"دوخت انواع پیراهن و شلوار\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-01.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonial\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-05.jpg\" custom_padding=\"0|0px|12vw|0px|false|false\" hover_enabled=\"0\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_testimonial quote_icon=\"off\" _builder_version=\"4.4.2\" body_font=\"|600|on||||||\" body_font_size=\"18px\" body_line_height=\"2.5em\" background_color=\"#41547d\" background_layout=\"dark\" custom_margin=\"-12vw|||-10vw\" custom_margin_tablet=\"0vw||10vw|0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" custom_padding=\"80px|60px|80px|7vw|true|false\" custom_padding_tablet=\"40px|10%|40px|10%|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" animation_style=\"flip\" hover_enabled=\"0\" body_font_size_tablet=\"18px\" body_font_size_phone=\"\" body_font_size_last_edited=\"on|desktop\" body_line_height_tablet=\"\" body_line_height_phone=\"1.8em\" body_line_height_last_edited=\"on|phone\" box_shadow_style=\"preset1\" box_shadow_horizontal=\"-41px\" box_shadow_vertical=\"45px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(0,0,0,0.52)\" locked=\"off\"]<p>\"<b>دوزندگی</b><span> </span>صنعت و هنر<span> پیوست یا پیوند اشیاء با استفاده از </span>بخیه<span> ساخته شده با </span>سوزن<span> و </span>نخ<span> است. دوزندگی یکی از قدیمی‌ترین </span>هنرهای منسوجات<span> پدید آمده در دوران </span>پارینه‌سنگی<span> است</span><span>.</span>\"</p>\n[/et_pb_testimonial][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_6,1_6,1_6,1_6,1_6,1_6\" _builder_version=\"3.25\"][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_08-1.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_07-1.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_06-1.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_05-2.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_03-2.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_01-2.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Feature\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"32px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>لباس شما با بهترین مواد دوخته می شود</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"اطلاعات بیشتر\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-06.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\"][/et_pb_image][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-07.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" max_width=\"70%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" border_color_all=\"#ffffff\" border_width_right=\"20px\" border_width_bottom=\"20px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][/et_pb_image][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"right\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Services\" _builder_version=\"3.22\" background_color=\"#f7f9fc\" custom_margin=\"|||\" custom_padding=\"0|0px|80px|0px|false|false\"][et_pb_row column_structure=\"1_2,1_2\" custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#ffffff\" width=\"90%\" max_width=\"90%\" module_alignment=\"left\" custom_margin=\"|||\" custom_padding=\"60px|||15vw|false|false\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"120px\" box_shadow_color=\"rgba(96,104,121,0.12)\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"90%\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.4em\" max_width=\"600px\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>خیاطی و تعمیرات</h2>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_4,1_4,1_2\" custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#ffffff\" width=\"90%\" max_width=\"90%\" module_alignment=\"left\" custom_margin=\"|||\" custom_padding=\"||120px|15vw|false|false\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"120px\" box_shadow_color=\"rgba(96,104,121,0.12)\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"90%\"][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-04.png\" _builder_version=\"4.4.2\" hover_enabled=\"0\" always_center_on_mobile=\"off\" locked=\"off\" animation_style=\"slide\" animation_direction=\"bottom\" animation_delay=\"600ms\"][/et_pb_image][et_pb_blurb title=\"خدمات خیاطی\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-05.png\" _builder_version=\"4.4.2\" hover_enabled=\"0\" always_center_on_mobile=\"off\" locked=\"off\" animation_style=\"slide\" animation_direction=\"bottom\" transform_styles__hover_enabled=\"off|hover\" transform_scale__hover_enabled=\"off|hover\" transform_translate__hover_enabled=\"off|hover\" transform_rotate__hover_enabled=\"off|hover\" transform_skew__hover_enabled=\"off|hover\" transform_origin__hover_enabled=\"off|hover\" animation_delay=\"600ms\"][/et_pb_image][et_pb_blurb title=\"خدمات تعمیرات\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_font_size=\"18px\" background_color=\"#41547d\" background_layout=\"dark\" custom_margin=\"-14vw|-10vw||10vw\" custom_margin_tablet=\"0vw|0vw||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" custom_padding=\"80px|60px|80px|60px|true|true\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|phone\" animation_style=\"flip\" hover_enabled=\"0\" text_font_size_tablet=\"\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\" locked=\"off\" text_text_shadow_style=\"preset3\" text_letter_spacing=\"1px\"]<ol>\n<li> کوتاه کردن / بلند کردن</li>\n<li>کاف</li>\n<li>پوشش</li>\n<li>دور کمر</li>\n<li>آستین ها را بلند / کوتاه کنید</li>\n<li>دکمه / قلاب دوباره دوخت</li>\n<li>تعویض زیپ</li>\n<li>و ......</li>\n</ol>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"4.4.2\" module_alignment=\"center\" custom_margin=\"-40px||\" custom_padding=\"0|0px|0|0px|false|false\" hover_enabled=\"0\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|600|||||||\" text_font_size=\"24px\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_2_font=\"||||||||\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" background_color=\"#dfab82\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-01.png\" background_position=\"bottom_right\" background_layout=\"dark\" custom_padding=\"50px|60px|50px|60px|true|true\" animation_style=\"flip\" link_option_url=\"#\" hover_enabled=\"0\" locked=\"off\" custom_padding__hover_enabled=\"on\" custom_padding__hover=\"|40px||80px||false\" background__hover_enabled=\"on|hover\" background_color__hover=\"#680000\" background_enable_color__hover=\"on\"]<p>مشاهده تمام خدمات</p>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Gallery\" _builder_version=\"4.4.2\" background_color=\"#f7f9fc\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#f7f9fc\" background_color_gradient_end=\"#ffffff\" hover_enabled=\"0\" disabled_on=\"off|off|off\"][et_pb_row column_structure=\"1_4,1_4,1_2\" _builder_version=\"3.25\"][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-08.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"4.4.2\" custom_margin=\"|||-7vw|false|false\" custom_margin_tablet=\"|||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|phone\" hover_enabled=\"0\" locked=\"off\"][/et_pb_image][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/crypto_image_03.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" border_color_all=\"#ffffff\" border_width_bottom=\"20px\" border_width_left=\"20px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-10.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"6vw||\" custom_margin_tablet=\"\" custom_margin_phone=\"0vw||\" custom_margin_last_edited=\"on|desktop\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>چند نمونه کار اخیر ما</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"مشاهده سایر نمونه کارها\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"left\" custom_padding=\"27px|0px|0|0px|false|false\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\" locked=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonials\" _builder_version=\"3.22\" background_color=\"#ffffff\" custom_padding=\"0|0px|54px|0px|false|false\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_slider _builder_version=\"4.4.2\" body_font=\"|600|on||||||\" body_font_size=\"26px\" body_line_height=\"1.8em\" background_color=\"#dfab82\" animation_style=\"flip\" hover_enabled=\"0\" body_font_size_tablet=\"20px\" body_font_size_phone=\"12px\" body_font_size_last_edited=\"on|phone\" box_shadow_style=\"preset1\" box_shadow_vertical=\"50px\" box_shadow_blur=\"60px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][/et_pb_slider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" _builder_version=\"4.4.2\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/Tailor-back.jpg\" hover_enabled=\"0\" disabled_on=\"off|off|off\" scroll_vertical_motion_enable=\"on\"][et_pb_row _builder_version=\"4.4.2\"][et_pb_column _builder_version=\"4.4.2\" type=\"4_4\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/Tailor3.png\" _builder_version=\"4.4.2\" hover_enabled=\"0\" custom_css_main_element=\"||\" scroll_vertical_motion_enable=\"on\" scroll_vertical_motion=\"20|50|50|90|4|0|-4\"][/et_pb_image][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#f1f6ff\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>در تماس باشید!</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_blurb title=\"بازدید از محل کار ما\" use_icon=\"on\" font_icon=\"%%249%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\"]<p>ایران - تهران - شهرک خیاط</p>\n[/et_pb_blurb][et_pb_blurb title=\"شماره تماس\" use_icon=\"on\" font_icon=\"%%264%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\"]<p>091312345678</p>\n[/et_pb_blurb][et_pb_blurb title=\"ایمیل ما\" use_icon=\"on\" font_icon=\"%%238%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\"]<p>info@modelsite.ir</p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_row_inner _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"60px|0px|60px|0px|true|false\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_column_inner saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_contact_form captcha=\"off\" module_id=\"et_pb_contact_form_0\" _builder_version=\"4.4.2\" form_field_background_color=\"#f5f9ff\" form_field_font=\"||||||||\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#af8447\" button_border_width=\"10px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"|40px||40px||true\" hover_enabled=\"0\" form_background_color=\"#f5f9ff\" submit_button_text=\"ارسال پیام\" success_message=\"پیام شما با موفقیت ارسال شد .\" button_bg_enable_color=\"on\" box_shadow_style_button=\"preset1\" form_field_text_shadow_style=\"preset4\"][et_pb_contact_field field_id=\"Name\" field_title=\"نام\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Email\" field_title=\"ایمیل شما\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Phone\" field_title=\"شماره تماس\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Message\" field_title=\"پیام شما ....\" field_type=\"text\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||30px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][/et_pb_contact_form][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section]", "خانه", "", "inherit", "closed", "closed", "", "2-revision-v1", "", "", "2020-03-31 14:45:17", "2020-03-31 11:15:17", "", "2", "http://modelsite.test/2-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2852", "1", "2020-03-31 14:46:12", "2020-03-31 11:16:12", "[et_pb_section fb_built=\"1\" use_custom_gutter=\"on\" gutter_width=\"1\" admin_label=\"Header\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#f7f9fc\" background_color_gradient_start_position=\"75%\" background_color_gradient_end_position=\"75%\" custom_padding=\"0|0px|0|0px|false|false\" hover_enabled=\"0\"][et_pb_row column_structure=\"1_2,1_2\" use_custom_gutter=\"on\" gutter_width=\"1\" make_equal=\"on\" padding_top_bottom_link_1=\"true\" _builder_version=\"3.25\" custom_padding=\"0|0px|0|0px|false|false\" hover_enabled=\"0\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"8vw|60px|8vw|\" custom_padding_tablet=\"|0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"|0px||\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"|600|||||||\" header_font_size=\"60px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_text_color=\"#dfab82\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" custom_margin=\"||40px\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\"]<h1>خیاطی مردانه</h1>\n<h2>شیک پوش باشید </h2>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"آنلاین رزرو کنید\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#41547d\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(65,84,125,0.24)\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][et_pb_button button_text=\"یا تماس بگیرید : 12345-021\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#41547d\" button_bg_color=\"#ffffff\" button_border_width=\"0px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(65,84,125,0.06)\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_text_color_last_edited=\"on|desktop\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#af8447\" button_bg_enable_color__hover=\"on\" button_text_color__hover_enabled=\"on|hover\" button_text_color__hover=\"#ffffff\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-02.jpg\" parallax=\"on\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider show_divider=\"off\" disabled_on=\"off|off|on\" _builder_version=\"3.17.6\" height=\"250px\" hover_enabled=\"0\"][/et_pb_divider][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" use_custom_gutter=\"on\" gutter_width=\"1\" padding_top_bottom_link_2=\"false\" _builder_version=\"3.25\" custom_padding=\"0|0px|27px|0px|false|false\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_video src=\"#\" image_src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-03.jpg\" _builder_version=\"4.4.2\" custom_margin=\"|||-80px\" custom_margin_tablet=\"|||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" hover_enabled=\"0\"][/et_pb_video][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"100px|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-04.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" max_width=\"80%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" box_shadow_style=\"preset1\" box_shadow_horizontal=\"-41px\" box_shadow_vertical=\"45px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(0,0,0,0.52)\" locked=\"off\"][/et_pb_image][et_pb_text _builder_version=\"4.4.2\" text_font=\"|600|||||||\" text_font_size=\"24px\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_2_font=\"||||||||\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" background_color=\"#dfab82\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-01.png\" background_position=\"bottom_right\" background_layout=\"dark\" custom_margin=\"|||0%\" custom_padding=\"50px|60px|50px|60px|true|true\" animation_direction=\"left\" link_option_url=\"#\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\" custom_padding__hover_enabled=\"on\" custom_padding__hover=\"|40px||80px||false\" background__hover_enabled=\"on\" background_color__hover=\"#ddb494\"]<p>مشاهده گالری نمونه کارها</p>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"left\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" admin_label=\"Services\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"22px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>یک کت و شلوار سفارش دهید که توسط خیاطان متخصص برای تن شما ساخته شده است</h2>\n[/et_pb_text][et_pb_button button_text=\"یک وقت بگیرید\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_row_inner column_structure=\"1_2,1_2\" _builder_version=\"3.25\"][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"خیاطی لباس دامادی\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-03.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][et_pb_blurb title=\"تعمیرات لباس\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-02.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][/et_pb_column_inner][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"میلیمترها رو ما حواسمان هست\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-12.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][et_pb_blurb title=\"دوخت انواع پیراهن و شلوار\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-01.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonial\" _builder_version=\"4.4.2\" background_color=\"#f7f9fc\" hover_enabled=\"0\" disabled_on=\"off|off|on\"][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-05.jpg\" custom_padding=\"0|0px|12vw|0px|false|false\" hover_enabled=\"0\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_testimonial quote_icon=\"off\" _builder_version=\"4.4.2\" body_font=\"|600|on||||||\" body_font_size=\"18px\" body_line_height=\"2.5em\" background_color=\"#41547d\" background_layout=\"dark\" custom_margin=\"-12vw|||-10vw\" custom_margin_tablet=\"0vw||10vw|0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" custom_padding=\"80px|60px|80px|7vw|true|false\" custom_padding_tablet=\"40px|10%|40px|10%|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" animation_style=\"flip\" hover_enabled=\"0\" body_font_size_tablet=\"18px\" body_font_size_phone=\"\" body_font_size_last_edited=\"on|desktop\" body_line_height_tablet=\"\" body_line_height_phone=\"1.8em\" body_line_height_last_edited=\"on|phone\" box_shadow_style=\"preset1\" box_shadow_horizontal=\"-41px\" box_shadow_vertical=\"45px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(0,0,0,0.52)\" locked=\"off\"]<p>\"<b>دوزندگی</b><span> </span>صنعت و هنر<span> پیوست یا پیوند اشیاء با استفاده از </span>بخیه<span> ساخته شده با </span>سوزن<span> و </span>نخ<span> است. دوزندگی یکی از قدیمی‌ترین </span>هنرهای منسوجات<span> پدید آمده در دوران </span>پارینه‌سنگی<span> است</span><span>.</span>\"</p>\n[/et_pb_testimonial][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_6,1_6,1_6,1_6,1_6,1_6\" _builder_version=\"3.25\"][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_08-1.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_07-1.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_06-1.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_05-2.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_03-2.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_01-2.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Feature\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"32px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>لباس شما با بهترین مواد دوخته می شود</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"اطلاعات بیشتر\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-06.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\"][/et_pb_image][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-07.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" max_width=\"70%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" border_color_all=\"#ffffff\" border_width_right=\"20px\" border_width_bottom=\"20px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][/et_pb_image][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"right\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Services\" _builder_version=\"3.22\" background_color=\"#f7f9fc\" custom_margin=\"|||\" custom_padding=\"0|0px|80px|0px|false|false\"][et_pb_row column_structure=\"1_2,1_2\" custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#ffffff\" width=\"90%\" max_width=\"90%\" module_alignment=\"left\" custom_margin=\"|||\" custom_padding=\"60px|||15vw|false|false\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"120px\" box_shadow_color=\"rgba(96,104,121,0.12)\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"90%\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.4em\" max_width=\"600px\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>خیاطی و تعمیرات</h2>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_4,1_4,1_2\" custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#ffffff\" width=\"90%\" max_width=\"90%\" module_alignment=\"left\" custom_margin=\"|||\" custom_padding=\"||120px|15vw|false|false\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"120px\" box_shadow_color=\"rgba(96,104,121,0.12)\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"90%\"][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-04.png\" _builder_version=\"4.4.2\" hover_enabled=\"0\" always_center_on_mobile=\"off\" locked=\"off\" animation_style=\"slide\" animation_direction=\"bottom\" animation_delay=\"600ms\"][/et_pb_image][et_pb_blurb title=\"خدمات خیاطی\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-05.png\" _builder_version=\"4.4.2\" hover_enabled=\"0\" always_center_on_mobile=\"off\" locked=\"off\" animation_style=\"slide\" animation_direction=\"bottom\" transform_styles__hover_enabled=\"off|hover\" transform_scale__hover_enabled=\"off|hover\" transform_translate__hover_enabled=\"off|hover\" transform_rotate__hover_enabled=\"off|hover\" transform_skew__hover_enabled=\"off|hover\" transform_origin__hover_enabled=\"off|hover\" animation_delay=\"600ms\"][/et_pb_image][et_pb_blurb title=\"خدمات تعمیرات\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_font_size=\"18px\" background_color=\"#41547d\" background_layout=\"dark\" custom_margin=\"-14vw|-10vw||10vw\" custom_margin_tablet=\"0vw|0vw||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" custom_padding=\"80px|60px|80px|60px|true|true\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|phone\" animation_style=\"flip\" hover_enabled=\"0\" text_font_size_tablet=\"\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\" locked=\"off\" text_text_shadow_style=\"preset3\" text_letter_spacing=\"1px\"]<ol>\n<li> کوتاه کردن / بلند کردن</li>\n<li>کاف</li>\n<li>پوشش</li>\n<li>دور کمر</li>\n<li>آستین ها را بلند / کوتاه کنید</li>\n<li>دکمه / قلاب دوباره دوخت</li>\n<li>تعویض زیپ</li>\n<li>و ......</li>\n</ol>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"4.4.2\" module_alignment=\"center\" custom_margin=\"-40px||\" custom_padding=\"0|0px|0|0px|false|false\" hover_enabled=\"0\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|600|||||||\" text_font_size=\"24px\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_2_font=\"||||||||\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" background_color=\"#dfab82\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-01.png\" background_position=\"bottom_right\" background_layout=\"dark\" custom_padding=\"50px|60px|50px|60px|true|true\" animation_style=\"flip\" link_option_url=\"#\" hover_enabled=\"0\" locked=\"off\" custom_padding__hover_enabled=\"on\" custom_padding__hover=\"|40px||80px||false\" background__hover_enabled=\"on|hover\" background_color__hover=\"#680000\" background_enable_color__hover=\"on\"]<p>مشاهده تمام خدمات</p>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Gallery\" _builder_version=\"4.4.2\" background_color=\"#f7f9fc\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#f7f9fc\" background_color_gradient_end=\"#ffffff\" hover_enabled=\"0\" disabled_on=\"off|off|off\"][et_pb_row column_structure=\"1_4,1_4,1_2\" _builder_version=\"3.25\"][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-08.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"4.4.2\" custom_margin=\"|||-7vw|false|false\" custom_margin_tablet=\"|||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|phone\" hover_enabled=\"0\" locked=\"off\"][/et_pb_image][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/crypto_image_03.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" border_color_all=\"#ffffff\" border_width_bottom=\"20px\" border_width_left=\"20px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-10.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"6vw||\" custom_margin_tablet=\"\" custom_margin_phone=\"0vw||\" custom_margin_last_edited=\"on|desktop\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>چند نمونه کار اخیر ما</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"مشاهده سایر نمونه کارها\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"left\" custom_padding=\"27px|0px|0|0px|false|false\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\" locked=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonials\" _builder_version=\"3.22\" background_color=\"#ffffff\" custom_padding=\"0|0px|54px|0px|false|false\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_slider _builder_version=\"4.4.2\" body_font=\"|600|on||||||\" body_font_size=\"26px\" body_line_height=\"1.8em\" background_color=\"#dfab82\" animation_style=\"flip\" hover_enabled=\"0\" body_font_size_tablet=\"20px\" body_font_size_phone=\"12px\" body_font_size_last_edited=\"on|phone\" box_shadow_style=\"preset1\" box_shadow_vertical=\"50px\" box_shadow_blur=\"60px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][/et_pb_slider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" _builder_version=\"4.4.2\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/Tailor-back.jpg\" hover_enabled=\"0\" disabled_on=\"off|off|off\" scroll_vertical_motion_enable=\"on\"][et_pb_row _builder_version=\"4.4.2\"][et_pb_column _builder_version=\"4.4.2\" type=\"4_4\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/Tailor3.png\" _builder_version=\"4.4.2\" hover_enabled=\"0\" custom_css_main_element=\"||\" scroll_vertical_motion_enable=\"on\" scroll_vertical_motion=\"20|50|50|90|4|0|-4\"][/et_pb_image][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#f1f6ff\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>در تماس باشید!</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_blurb title=\"بازدید از محل کار ما\" use_icon=\"on\" font_icon=\"%%249%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\"]<p>ایران - تهران - شهرک خیاط</p>\n[/et_pb_blurb][et_pb_blurb title=\"شماره تماس\" use_icon=\"on\" font_icon=\"%%264%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\"]<p>091312345678</p>\n[/et_pb_blurb][et_pb_blurb title=\"ایمیل ما\" use_icon=\"on\" font_icon=\"%%238%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\"]<p>info@modelsite.ir</p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_row_inner _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"60px|0px|60px|0px|true|false\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_column_inner saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_contact_form captcha=\"off\" module_id=\"et_pb_contact_form_0\" _builder_version=\"4.4.2\" form_field_background_color=\"#f5f9ff\" form_field_font=\"||||||||\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#af8447\" button_border_width=\"10px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"|40px||40px||true\" hover_enabled=\"0\" form_background_color=\"#f5f9ff\" submit_button_text=\"ارسال پیام\" success_message=\"پیام شما با موفقیت ارسال شد .\" button_bg_enable_color=\"on\" box_shadow_style_button=\"preset1\" form_field_text_shadow_style=\"preset4\"][et_pb_contact_field field_id=\"Name\" field_title=\"نام\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Email\" field_title=\"ایمیل شما\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Phone\" field_title=\"شماره تماس\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Message\" field_title=\"پیام شما ....\" field_type=\"text\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||30px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][/et_pb_contact_form][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section]", "خانه", "", "inherit", "closed", "closed", "", "2-revision-v1", "", "", "2020-03-31 14:46:12", "2020-03-31 11:16:12", "", "2", "http://modelsite.test/2-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2854", "1", "2020-03-31 14:47:39", "2020-03-31 11:17:39", "[et_pb_section fb_built=\"1\" use_custom_gutter=\"on\" gutter_width=\"1\" admin_label=\"Header\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#f7f9fc\" background_color_gradient_start_position=\"75%\" background_color_gradient_end_position=\"75%\" custom_padding=\"0|0px|0|0px|false|false\" hover_enabled=\"0\"][et_pb_row column_structure=\"1_2,1_2\" use_custom_gutter=\"on\" gutter_width=\"1\" make_equal=\"on\" padding_top_bottom_link_1=\"true\" _builder_version=\"3.25\" custom_padding=\"0|0px|0|0px|false|false\" hover_enabled=\"0\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"8vw|60px|8vw|\" custom_padding_tablet=\"|0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"|0px||\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"|600|||||||\" header_font_size=\"60px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_text_color=\"#dfab82\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" custom_margin=\"||40px\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\"]<h1>خیاطی مردانه</h1>\n<h2>شیک پوش باشید </h2>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"آنلاین رزرو کنید\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#41547d\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(65,84,125,0.24)\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][et_pb_button button_text=\"یا تماس بگیرید : 12345-021\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#41547d\" button_bg_color=\"#ffffff\" button_border_width=\"0px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(65,84,125,0.06)\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_text_color_last_edited=\"on|desktop\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#af8447\" button_bg_enable_color__hover=\"on\" button_text_color__hover_enabled=\"on|hover\" button_text_color__hover=\"#ffffff\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-02.jpg\" parallax=\"on\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider show_divider=\"off\" disabled_on=\"off|off|on\" _builder_version=\"3.17.6\" height=\"250px\" hover_enabled=\"0\"][/et_pb_divider][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" use_custom_gutter=\"on\" gutter_width=\"1\" padding_top_bottom_link_2=\"false\" _builder_version=\"3.25\" custom_padding=\"0|0px|27px|0px|false|false\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_video src=\"#\" image_src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-03.jpg\" _builder_version=\"4.4.2\" custom_margin=\"|||-80px\" custom_margin_tablet=\"|||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" hover_enabled=\"0\"][/et_pb_video][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"100px|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-04.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" max_width=\"80%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" box_shadow_style=\"preset1\" box_shadow_horizontal=\"-41px\" box_shadow_vertical=\"45px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(0,0,0,0.52)\" locked=\"off\"][/et_pb_image][et_pb_text _builder_version=\"4.4.2\" text_font=\"|600|||||||\" text_font_size=\"24px\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_2_font=\"||||||||\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" background_color=\"#dfab82\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-01.png\" background_position=\"bottom_right\" background_layout=\"dark\" custom_margin=\"|||0%\" custom_padding=\"50px|60px|50px|60px|true|true\" animation_direction=\"left\" link_option_url=\"#\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\" custom_padding__hover_enabled=\"on\" custom_padding__hover=\"|40px||80px||false\" background__hover_enabled=\"on\" background_color__hover=\"#ddb494\"]<p>مشاهده گالری نمونه کارها</p>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"left\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" admin_label=\"Services\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"22px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>یک کت و شلوار سفارش دهید که توسط خیاطان متخصص برای تن شما ساخته شده است</h2>\n[/et_pb_text][et_pb_button button_text=\"یک وقت بگیرید\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_row_inner column_structure=\"1_2,1_2\" _builder_version=\"3.25\"][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"خیاطی لباس دامادی\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-03.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][et_pb_blurb title=\"تعمیرات لباس\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-02.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][/et_pb_column_inner][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"میلیمترها رو ما حواسمان هست\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-12.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][et_pb_blurb title=\"دوخت انواع پیراهن و شلوار\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-01.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonial\" _builder_version=\"4.4.2\" background_color=\"#f7f9fc\" hover_enabled=\"0\" disabled_on=\"off|off|off\"][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"4.4.2\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-05.jpg\" custom_padding=\"0|0px|12vw|0px|false|false\" hover_enabled=\"0\" module_alignment=\"center\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_testimonial quote_icon=\"off\" _builder_version=\"4.4.2\" body_font=\"|600|on||||||\" body_font_size=\"18px\" body_line_height=\"2.5em\" background_color=\"#41547d\" background_layout=\"dark\" custom_margin=\"-12vw|||-10vw\" custom_margin_tablet=\"0vw||10vw|0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" custom_padding=\"80px|60px|80px|7vw|true|false\" custom_padding_tablet=\"40px|10%|40px|10%|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" animation_style=\"flip\" hover_enabled=\"0\" body_font_size_tablet=\"18px\" body_font_size_phone=\"\" body_font_size_last_edited=\"on|desktop\" body_line_height_tablet=\"\" body_line_height_phone=\"1.8em\" body_line_height_last_edited=\"on|phone\" box_shadow_style=\"preset1\" box_shadow_horizontal=\"-41px\" box_shadow_vertical=\"45px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(0,0,0,0.52)\" locked=\"off\"]<p>\"<b>دوزندگی</b><span> </span>صنعت و هنر<span> پیوست یا پیوند اشیاء با استفاده از </span>بخیه<span> ساخته شده با </span>سوزن<span> و </span>نخ<span> است. دوزندگی یکی از قدیمی‌ترین </span>هنرهای منسوجات<span> پدید آمده در دوران </span>پارینه‌سنگی<span> است</span><span>.</span>\"</p>\n[/et_pb_testimonial][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_6,1_6,1_6,1_6,1_6,1_6\" _builder_version=\"3.25\"][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_08-1.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_07-1.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_06-1.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_05-2.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_03-2.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_01-2.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Feature\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"32px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>لباس شما با بهترین مواد دوخته می شود</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"اطلاعات بیشتر\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-06.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\"][/et_pb_image][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-07.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" max_width=\"70%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" border_color_all=\"#ffffff\" border_width_right=\"20px\" border_width_bottom=\"20px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][/et_pb_image][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"right\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Services\" _builder_version=\"3.22\" background_color=\"#f7f9fc\" custom_margin=\"|||\" custom_padding=\"0|0px|80px|0px|false|false\"][et_pb_row column_structure=\"1_2,1_2\" custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#ffffff\" width=\"90%\" max_width=\"90%\" module_alignment=\"left\" custom_margin=\"|||\" custom_padding=\"60px|||15vw|false|false\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"120px\" box_shadow_color=\"rgba(96,104,121,0.12)\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"90%\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.4em\" max_width=\"600px\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>خیاطی و تعمیرات</h2>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_4,1_4,1_2\" custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#ffffff\" width=\"90%\" max_width=\"90%\" module_alignment=\"left\" custom_margin=\"|||\" custom_padding=\"||120px|15vw|false|false\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"120px\" box_shadow_color=\"rgba(96,104,121,0.12)\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"90%\"][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-04.png\" _builder_version=\"4.4.2\" hover_enabled=\"0\" always_center_on_mobile=\"off\" locked=\"off\" animation_style=\"slide\" animation_direction=\"bottom\" animation_delay=\"600ms\"][/et_pb_image][et_pb_blurb title=\"خدمات خیاطی\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-05.png\" _builder_version=\"4.4.2\" hover_enabled=\"0\" always_center_on_mobile=\"off\" locked=\"off\" animation_style=\"slide\" animation_direction=\"bottom\" transform_styles__hover_enabled=\"off|hover\" transform_scale__hover_enabled=\"off|hover\" transform_translate__hover_enabled=\"off|hover\" transform_rotate__hover_enabled=\"off|hover\" transform_skew__hover_enabled=\"off|hover\" transform_origin__hover_enabled=\"off|hover\" animation_delay=\"600ms\"][/et_pb_image][et_pb_blurb title=\"خدمات تعمیرات\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_font_size=\"18px\" background_color=\"#41547d\" background_layout=\"dark\" custom_margin=\"-14vw|-10vw||10vw\" custom_margin_tablet=\"0vw|0vw||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" custom_padding=\"80px|60px|80px|60px|true|true\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|phone\" animation_style=\"flip\" hover_enabled=\"0\" text_font_size_tablet=\"\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\" locked=\"off\" text_text_shadow_style=\"preset3\" text_letter_spacing=\"1px\"]<ol>\n<li> کوتاه کردن / بلند کردن</li>\n<li>کاف</li>\n<li>پوشش</li>\n<li>دور کمر</li>\n<li>آستین ها را بلند / کوتاه کنید</li>\n<li>دکمه / قلاب دوباره دوخت</li>\n<li>تعویض زیپ</li>\n<li>و ......</li>\n</ol>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"4.4.2\" module_alignment=\"center\" custom_margin=\"-40px||\" custom_padding=\"0|0px|0|0px|false|false\" hover_enabled=\"0\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|600|||||||\" text_font_size=\"24px\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_2_font=\"||||||||\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" background_color=\"#dfab82\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-01.png\" background_position=\"bottom_right\" background_layout=\"dark\" custom_padding=\"50px|60px|50px|60px|true|true\" animation_style=\"flip\" link_option_url=\"#\" hover_enabled=\"0\" locked=\"off\" custom_padding__hover_enabled=\"on\" custom_padding__hover=\"|40px||80px||false\" background__hover_enabled=\"on|hover\" background_color__hover=\"#680000\" background_enable_color__hover=\"on\"]<p>مشاهده تمام خدمات</p>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Gallery\" _builder_version=\"4.4.2\" background_color=\"#f7f9fc\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#f7f9fc\" background_color_gradient_end=\"#ffffff\" hover_enabled=\"0\" disabled_on=\"off|off|off\"][et_pb_row column_structure=\"1_4,1_4,1_2\" _builder_version=\"3.25\"][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-08.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"4.4.2\" custom_margin=\"|||-7vw|false|false\" custom_margin_tablet=\"|||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|phone\" hover_enabled=\"0\" locked=\"off\"][/et_pb_image][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/crypto_image_03.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" border_color_all=\"#ffffff\" border_width_bottom=\"20px\" border_width_left=\"20px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-10.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"6vw||\" custom_margin_tablet=\"\" custom_margin_phone=\"0vw||\" custom_margin_last_edited=\"on|desktop\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>چند نمونه کار اخیر ما</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"مشاهده سایر نمونه کارها\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"left\" custom_padding=\"27px|0px|0|0px|false|false\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\" locked=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonials\" _builder_version=\"3.22\" background_color=\"#ffffff\" custom_padding=\"0|0px|54px|0px|false|false\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_slider _builder_version=\"4.4.2\" body_font=\"|600|on||||||\" body_font_size=\"26px\" body_line_height=\"1.8em\" background_color=\"#dfab82\" animation_style=\"flip\" hover_enabled=\"0\" body_font_size_tablet=\"20px\" body_font_size_phone=\"12px\" body_font_size_last_edited=\"on|phone\" box_shadow_style=\"preset1\" box_shadow_vertical=\"50px\" box_shadow_blur=\"60px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][/et_pb_slider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" _builder_version=\"4.4.2\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/Tailor-back.jpg\" hover_enabled=\"0\" disabled_on=\"off|off|off\" scroll_vertical_motion_enable=\"on\"][et_pb_row _builder_version=\"4.4.2\"][et_pb_column _builder_version=\"4.4.2\" type=\"4_4\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/Tailor3.png\" _builder_version=\"4.4.2\" hover_enabled=\"0\" custom_css_main_element=\"||\" scroll_vertical_motion_enable=\"on\" scroll_vertical_motion=\"20|50|50|90|4|0|-4\"][/et_pb_image][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#f1f6ff\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>در تماس باشید!</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_blurb title=\"بازدید از محل کار ما\" use_icon=\"on\" font_icon=\"%%249%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\"]<p>ایران - تهران - شهرک خیاط</p>\n[/et_pb_blurb][et_pb_blurb title=\"شماره تماس\" use_icon=\"on\" font_icon=\"%%264%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\"]<p>091312345678</p>\n[/et_pb_blurb][et_pb_blurb title=\"ایمیل ما\" use_icon=\"on\" font_icon=\"%%238%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\"]<p>info@modelsite.ir</p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_row_inner _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"60px|0px|60px|0px|true|false\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_column_inner saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_contact_form captcha=\"off\" module_id=\"et_pb_contact_form_0\" _builder_version=\"4.4.2\" form_field_background_color=\"#f5f9ff\" form_field_font=\"||||||||\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#af8447\" button_border_width=\"10px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"|40px||40px||true\" hover_enabled=\"0\" form_background_color=\"#f5f9ff\" submit_button_text=\"ارسال پیام\" success_message=\"پیام شما با موفقیت ارسال شد .\" button_bg_enable_color=\"on\" box_shadow_style_button=\"preset1\" form_field_text_shadow_style=\"preset4\"][et_pb_contact_field field_id=\"Name\" field_title=\"نام\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Email\" field_title=\"ایمیل شما\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Phone\" field_title=\"شماره تماس\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Message\" field_title=\"پیام شما ....\" field_type=\"text\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||30px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][/et_pb_contact_form][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section]", "خانه", "", "inherit", "closed", "closed", "", "2-revision-v1", "", "", "2020-03-31 14:47:39", "2020-03-31 11:17:39", "", "2", "http://modelsite.test/2-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2856", "1", "2020-03-31 14:50:07", "2020-03-31 11:20:07", "[et_pb_section fb_built=\"1\" use_custom_gutter=\"on\" gutter_width=\"1\" admin_label=\"Header\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#f7f9fc\" background_color_gradient_start_position=\"75%\" background_color_gradient_end_position=\"75%\" custom_padding=\"0|0px|0|0px|false|false\" hover_enabled=\"0\"][et_pb_row column_structure=\"1_2,1_2\" use_custom_gutter=\"on\" gutter_width=\"1\" make_equal=\"on\" padding_top_bottom_link_1=\"true\" _builder_version=\"3.25\" custom_padding=\"0|0px|0|0px|false|false\" hover_enabled=\"0\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"8vw|60px|8vw|\" custom_padding_tablet=\"|0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"|0px||\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"|600|||||||\" header_font_size=\"60px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_text_color=\"#dfab82\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" custom_margin=\"||40px\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\"]<h1>خیاطی مردانه</h1>\n<h2>شیک پوش باشید </h2>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"آنلاین رزرو کنید\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#41547d\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(65,84,125,0.24)\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][et_pb_button button_text=\"یا تماس بگیرید : 12345-021\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#41547d\" button_bg_color=\"#ffffff\" button_border_width=\"0px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(65,84,125,0.06)\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_text_color_last_edited=\"on|desktop\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#af8447\" button_bg_enable_color__hover=\"on\" button_text_color__hover_enabled=\"on|hover\" button_text_color__hover=\"#ffffff\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-02.jpg\" parallax=\"on\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider show_divider=\"off\" disabled_on=\"off|off|on\" _builder_version=\"3.17.6\" height=\"250px\" hover_enabled=\"0\"][/et_pb_divider][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" use_custom_gutter=\"on\" gutter_width=\"1\" padding_top_bottom_link_2=\"false\" _builder_version=\"3.25\" custom_padding=\"0|0px|27px|0px|false|false\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_video src=\"#\" image_src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-03.jpg\" _builder_version=\"4.4.2\" custom_margin=\"|||-80px\" custom_margin_tablet=\"|||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" hover_enabled=\"0\"][/et_pb_video][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"100px|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-04.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" max_width=\"80%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" box_shadow_style=\"preset1\" box_shadow_horizontal=\"-41px\" box_shadow_vertical=\"45px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(0,0,0,0.52)\" locked=\"off\"][/et_pb_image][et_pb_text _builder_version=\"4.4.2\" text_font=\"|600|||||||\" text_font_size=\"24px\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_2_font=\"||||||||\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" background_color=\"#dfab82\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-01.png\" background_position=\"bottom_right\" background_layout=\"dark\" custom_margin=\"|||0%\" custom_padding=\"50px|60px|50px|60px|true|true\" animation_direction=\"left\" link_option_url=\"#\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\" custom_padding__hover_enabled=\"on\" custom_padding__hover=\"|40px||80px||false\" background__hover_enabled=\"on\" background_color__hover=\"#ddb494\"]<p>مشاهده گالری نمونه کارها</p>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"left\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" admin_label=\"Services\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"22px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>یک کت و شلوار سفارش دهید که توسط خیاطان متخصص برای تن شما ساخته شده است</h2>\n[/et_pb_text][et_pb_button button_text=\"یک وقت بگیرید\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_row_inner column_structure=\"1_2,1_2\" _builder_version=\"3.25\"][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"خیاطی لباس دامادی\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-03.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][et_pb_blurb title=\"تعمیرات لباس\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-02.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][/et_pb_column_inner][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"میلیمترها رو ما حواسمان هست\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-12.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][et_pb_blurb title=\"دوخت انواع پیراهن و شلوار\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-01.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonial\" _builder_version=\"4.4.2\" background_color=\"#f7f9fc\" hover_enabled=\"0\" disabled_on=\"off|off|off\"][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"4.4.2\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-05.jpg\" custom_padding=\"0|0px|12vw|0px|false|false\" hover_enabled=\"0\" module_alignment=\"center\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_testimonial quote_icon=\"off\" _builder_version=\"4.4.2\" body_font=\"||on||||||\" body_font_size=\"20px\" body_line_height=\"2em\" background_color=\"#41547d\" background_layout=\"dark\" custom_margin=\"-12vw|||-10vw\" custom_margin_tablet=\"0vw||10vw|0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" custom_padding=\"80px|60px|80px|7vw|true|false\" custom_padding_tablet=\"40px|10%|40px|10%|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" animation_style=\"flip\" hover_enabled=\"0\" body_font_size_tablet=\"18px\" body_font_size_phone=\"\" body_font_size_last_edited=\"on|desktop\" body_line_height_tablet=\"\" body_line_height_phone=\"1.8em\" body_line_height_last_edited=\"on|phone\" box_shadow_style=\"preset1\" box_shadow_horizontal=\"-41px\" box_shadow_vertical=\"45px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(0,0,0,0.52)\" locked=\"off\" module_alignment=\"center\"]<p>\"<b>دوزندگی</b><span> </span>صنعت و هنر<span> پیوست یا پیوند اشیاء با استفاده از </span>بخیه<span> ساخته شده با </span>سوزن<span> و </span>نخ<span> است</span><span>.</span>\"</p>\n[/et_pb_testimonial][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_6,1_6,1_6,1_6,1_6,1_6\" _builder_version=\"3.25\"][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_08-1.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_07-1.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_06-1.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_05-2.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_03-2.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_01-2.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Feature\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"32px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>لباس شما با بهترین مواد دوخته می شود</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"اطلاعات بیشتر\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-06.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\"][/et_pb_image][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-07.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" max_width=\"70%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" border_color_all=\"#ffffff\" border_width_right=\"20px\" border_width_bottom=\"20px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][/et_pb_image][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"right\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Services\" _builder_version=\"3.22\" background_color=\"#f7f9fc\" custom_margin=\"|||\" custom_padding=\"0|0px|80px|0px|false|false\"][et_pb_row column_structure=\"1_2,1_2\" custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#ffffff\" width=\"90%\" max_width=\"90%\" module_alignment=\"left\" custom_margin=\"|||\" custom_padding=\"60px|||15vw|false|false\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"120px\" box_shadow_color=\"rgba(96,104,121,0.12)\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"90%\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.4em\" max_width=\"600px\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>خیاطی و تعمیرات</h2>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_4,1_4,1_2\" custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#ffffff\" width=\"90%\" max_width=\"90%\" module_alignment=\"left\" custom_margin=\"|||\" custom_padding=\"||120px|15vw|false|false\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"120px\" box_shadow_color=\"rgba(96,104,121,0.12)\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"90%\"][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-04.png\" _builder_version=\"4.4.2\" hover_enabled=\"0\" always_center_on_mobile=\"off\" locked=\"off\" animation_style=\"slide\" animation_direction=\"bottom\" animation_delay=\"600ms\"][/et_pb_image][et_pb_blurb title=\"خدمات خیاطی\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-05.png\" _builder_version=\"4.4.2\" hover_enabled=\"0\" always_center_on_mobile=\"off\" locked=\"off\" animation_style=\"slide\" animation_direction=\"bottom\" transform_styles__hover_enabled=\"off|hover\" transform_scale__hover_enabled=\"off|hover\" transform_translate__hover_enabled=\"off|hover\" transform_rotate__hover_enabled=\"off|hover\" transform_skew__hover_enabled=\"off|hover\" transform_origin__hover_enabled=\"off|hover\" animation_delay=\"600ms\"][/et_pb_image][et_pb_blurb title=\"خدمات تعمیرات\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_font_size=\"18px\" background_color=\"#41547d\" background_layout=\"dark\" custom_margin=\"-14vw|-10vw||10vw\" custom_margin_tablet=\"0vw|0vw||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" custom_padding=\"80px|60px|80px|60px|true|true\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|phone\" animation_style=\"flip\" hover_enabled=\"0\" text_font_size_tablet=\"\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\" locked=\"off\" text_text_shadow_style=\"preset3\" text_letter_spacing=\"1px\"]<ol>\n<li> کوتاه کردن / بلند کردن</li>\n<li>کاف</li>\n<li>پوشش</li>\n<li>دور کمر</li>\n<li>آستین ها را بلند / کوتاه کنید</li>\n<li>دکمه / قلاب دوباره دوخت</li>\n<li>تعویض زیپ</li>\n<li>و ......</li>\n</ol>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"4.4.2\" module_alignment=\"center\" custom_margin=\"-40px||\" custom_padding=\"0|0px|0|0px|false|false\" hover_enabled=\"0\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|600|||||||\" text_font_size=\"24px\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_2_font=\"||||||||\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" background_color=\"#dfab82\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-01.png\" background_position=\"bottom_right\" background_layout=\"dark\" custom_padding=\"50px|60px|50px|60px|true|true\" animation_style=\"flip\" link_option_url=\"#\" hover_enabled=\"0\" locked=\"off\" custom_padding__hover_enabled=\"on\" custom_padding__hover=\"|40px||80px||false\" background__hover_enabled=\"on|hover\" background_color__hover=\"#680000\" background_enable_color__hover=\"on\"]<p>مشاهده تمام خدمات</p>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Gallery\" _builder_version=\"4.4.2\" background_color=\"#f7f9fc\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#f7f9fc\" background_color_gradient_end=\"#ffffff\" hover_enabled=\"0\" disabled_on=\"off|off|off\"][et_pb_row column_structure=\"1_4,1_4,1_2\" _builder_version=\"3.25\"][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-08.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"4.4.2\" custom_margin=\"|||-7vw|false|false\" custom_margin_tablet=\"|||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|phone\" hover_enabled=\"0\" locked=\"off\"][/et_pb_image][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/crypto_image_03.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" border_color_all=\"#ffffff\" border_width_bottom=\"20px\" border_width_left=\"20px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-10.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"6vw||\" custom_margin_tablet=\"\" custom_margin_phone=\"0vw||\" custom_margin_last_edited=\"on|desktop\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>چند نمونه کار اخیر ما</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"مشاهده سایر نمونه کارها\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"left\" custom_padding=\"27px|0px|0|0px|false|false\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\" locked=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonials\" _builder_version=\"3.22\" background_color=\"#ffffff\" custom_padding=\"0|0px|54px|0px|false|false\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_slider _builder_version=\"4.4.2\" body_font=\"|600|on||||||\" body_font_size=\"26px\" body_line_height=\"1.8em\" background_color=\"#dfab82\" animation_style=\"flip\" hover_enabled=\"0\" body_font_size_tablet=\"20px\" body_font_size_phone=\"12px\" body_font_size_last_edited=\"on|phone\" box_shadow_style=\"preset1\" box_shadow_vertical=\"50px\" box_shadow_blur=\"60px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][/et_pb_slider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" _builder_version=\"4.4.2\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/Tailor-back.jpg\" hover_enabled=\"0\" disabled_on=\"off|off|off\" scroll_vertical_motion_enable=\"on\"][et_pb_row _builder_version=\"4.4.2\"][et_pb_column _builder_version=\"4.4.2\" type=\"4_4\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/Tailor3.png\" _builder_version=\"4.4.2\" hover_enabled=\"0\" custom_css_main_element=\"||\" scroll_vertical_motion_enable=\"on\" scroll_vertical_motion=\"20|50|50|90|4|0|-4\"][/et_pb_image][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#f1f6ff\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>در تماس باشید!</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_blurb title=\"بازدید از محل کار ما\" use_icon=\"on\" font_icon=\"%%249%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\"]<p>ایران - تهران - شهرک خیاط</p>\n[/et_pb_blurb][et_pb_blurb title=\"شماره تماس\" use_icon=\"on\" font_icon=\"%%264%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\"]<p>091312345678</p>\n[/et_pb_blurb][et_pb_blurb title=\"ایمیل ما\" use_icon=\"on\" font_icon=\"%%238%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\"]<p>info@modelsite.ir</p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_row_inner _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"60px|0px|60px|0px|true|false\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_column_inner saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_contact_form captcha=\"off\" module_id=\"et_pb_contact_form_0\" _builder_version=\"4.4.2\" form_field_background_color=\"#f5f9ff\" form_field_font=\"||||||||\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#af8447\" button_border_width=\"10px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"|40px||40px||true\" hover_enabled=\"0\" form_background_color=\"#f5f9ff\" submit_button_text=\"ارسال پیام\" success_message=\"پیام شما با موفقیت ارسال شد .\" button_bg_enable_color=\"on\" box_shadow_style_button=\"preset1\" form_field_text_shadow_style=\"preset4\"][et_pb_contact_field field_id=\"Name\" field_title=\"نام\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Email\" field_title=\"ایمیل شما\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Phone\" field_title=\"شماره تماس\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Message\" field_title=\"پیام شما ....\" field_type=\"text\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||30px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][/et_pb_contact_form][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section]", "خانه", "", "inherit", "closed", "closed", "", "2-revision-v1", "", "", "2020-03-31 14:50:07", "2020-03-31 11:20:07", "", "2", "http://modelsite.test/2-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2858", "1", "2020-03-31 14:51:19", "2020-03-31 11:21:19", "[et_pb_section fb_built=\"1\" use_custom_gutter=\"on\" gutter_width=\"1\" admin_label=\"Header\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#f7f9fc\" background_color_gradient_start_position=\"75%\" background_color_gradient_end_position=\"75%\" custom_padding=\"0|0px|0|0px|false|false\" hover_enabled=\"0\"][et_pb_row column_structure=\"1_2,1_2\" use_custom_gutter=\"on\" gutter_width=\"1\" make_equal=\"on\" padding_top_bottom_link_1=\"true\" _builder_version=\"3.25\" custom_padding=\"0|0px|0|0px|false|false\" hover_enabled=\"0\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"8vw|60px|8vw|\" custom_padding_tablet=\"|0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"|0px||\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"|600|||||||\" header_font_size=\"60px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_text_color=\"#dfab82\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" custom_margin=\"||40px\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\"]<h1>خیاطی مردانه</h1>\n<h2>شیک پوش باشید </h2>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"آنلاین رزرو کنید\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#41547d\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(65,84,125,0.24)\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][et_pb_button button_text=\"یا تماس بگیرید : 12345-021\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#41547d\" button_bg_color=\"#ffffff\" button_border_width=\"0px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(65,84,125,0.06)\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_text_color_last_edited=\"on|desktop\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#af8447\" button_bg_enable_color__hover=\"on\" button_text_color__hover_enabled=\"on|hover\" button_text_color__hover=\"#ffffff\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-02.jpg\" parallax=\"on\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider show_divider=\"off\" disabled_on=\"off|off|on\" _builder_version=\"3.17.6\" height=\"250px\" hover_enabled=\"0\"][/et_pb_divider][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" use_custom_gutter=\"on\" gutter_width=\"1\" padding_top_bottom_link_2=\"false\" _builder_version=\"3.25\" custom_padding=\"0|0px|27px|0px|false|false\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_video src=\"#\" image_src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-03.jpg\" _builder_version=\"4.4.2\" custom_margin=\"|||-80px\" custom_margin_tablet=\"|||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" hover_enabled=\"0\"][/et_pb_video][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"100px|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-04.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" max_width=\"80%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" box_shadow_style=\"preset1\" box_shadow_horizontal=\"-41px\" box_shadow_vertical=\"45px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(0,0,0,0.52)\" locked=\"off\"][/et_pb_image][et_pb_text _builder_version=\"4.4.2\" text_font=\"|600|||||||\" text_font_size=\"24px\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_2_font=\"||||||||\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" background_color=\"#dfab82\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-01.png\" background_position=\"bottom_right\" background_layout=\"dark\" custom_margin=\"|||0%\" custom_padding=\"50px|60px|50px|60px|true|true\" animation_direction=\"left\" link_option_url=\"#\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\" custom_padding__hover_enabled=\"on\" custom_padding__hover=\"|40px||80px||false\" background__hover_enabled=\"on\" background_color__hover=\"#ddb494\"]<p>مشاهده گالری نمونه کارها</p>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"left\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" admin_label=\"Services\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"22px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>یک کت و شلوار سفارش دهید که توسط خیاطان متخصص برای تن شما ساخته شده است</h2>\n[/et_pb_text][et_pb_button button_text=\"یک وقت بگیرید\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_row_inner column_structure=\"1_2,1_2\" _builder_version=\"3.25\"][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"خیاطی لباس دامادی\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-03.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][et_pb_blurb title=\"تعمیرات لباس\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-02.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][/et_pb_column_inner][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"میلیمترها رو ما حواسمان هست\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-12.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][et_pb_blurb title=\"دوخت انواع پیراهن و شلوار\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-01.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonial\" _builder_version=\"4.4.2\" background_color=\"#f7f9fc\" hover_enabled=\"0\" disabled_on=\"off|off|off\"][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"4.4.2\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-05.jpg\" custom_padding=\"0|0px|12vw|0px|false|false\" hover_enabled=\"0\" module_alignment=\"center\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_testimonial quote_icon=\"off\" _builder_version=\"4.4.2\" body_font=\"||on||||||\" body_font_size=\"20px\" body_line_height=\"2em\" background_color=\"#41547d\" background_layout=\"dark\" custom_margin=\"-12vw|||-10vw\" custom_margin_tablet=\"0vw||10vw|0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" custom_padding=\"80px|60px|80px|7vw|true|false\" custom_padding_tablet=\"40px|10%|40px|10%|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" animation_style=\"flip\" hover_enabled=\"0\" body_font_size_tablet=\"18px\" body_font_size_phone=\"\" body_font_size_last_edited=\"on|desktop\" body_line_height_tablet=\"\" body_line_height_phone=\"1.8em\" body_line_height_last_edited=\"on|phone\" box_shadow_style=\"preset1\" box_shadow_horizontal=\"-41px\" box_shadow_vertical=\"45px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(0,0,0,0.52)\" locked=\"off\" module_alignment=\"right\" width=\"92%\"]<p>\"<b>دوزندگی</b><span> </span>صنعت و هنر<span> پیوست یا پیوند اشیاء با استفاده از </span>بخیه<span> ساخته شده با </span>سوزن<span> و </span>نخ<span> است</span><span>.</span>\"</p>\n[/et_pb_testimonial][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_6,1_6,1_6,1_6,1_6,1_6\" _builder_version=\"3.25\"][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_08-1.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_07-1.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_06-1.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_05-2.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_03-2.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_01-2.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Feature\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"32px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>لباس شما با بهترین مواد دوخته می شود</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"اطلاعات بیشتر\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-06.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\"][/et_pb_image][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-07.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" max_width=\"70%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" border_color_all=\"#ffffff\" border_width_right=\"20px\" border_width_bottom=\"20px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][/et_pb_image][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"right\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Services\" _builder_version=\"3.22\" background_color=\"#f7f9fc\" custom_margin=\"|||\" custom_padding=\"0|0px|80px|0px|false|false\"][et_pb_row column_structure=\"1_2,1_2\" custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#ffffff\" width=\"90%\" max_width=\"90%\" module_alignment=\"left\" custom_margin=\"|||\" custom_padding=\"60px|||15vw|false|false\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"120px\" box_shadow_color=\"rgba(96,104,121,0.12)\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"90%\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.4em\" max_width=\"600px\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>خیاطی و تعمیرات</h2>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_4,1_4,1_2\" custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#ffffff\" width=\"90%\" max_width=\"90%\" module_alignment=\"left\" custom_margin=\"|||\" custom_padding=\"||120px|15vw|false|false\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"120px\" box_shadow_color=\"rgba(96,104,121,0.12)\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"90%\"][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-04.png\" _builder_version=\"4.4.2\" hover_enabled=\"0\" always_center_on_mobile=\"off\" locked=\"off\" animation_style=\"slide\" animation_direction=\"bottom\" animation_delay=\"600ms\"][/et_pb_image][et_pb_blurb title=\"خدمات خیاطی\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-05.png\" _builder_version=\"4.4.2\" hover_enabled=\"0\" always_center_on_mobile=\"off\" locked=\"off\" animation_style=\"slide\" animation_direction=\"bottom\" transform_styles__hover_enabled=\"off|hover\" transform_scale__hover_enabled=\"off|hover\" transform_translate__hover_enabled=\"off|hover\" transform_rotate__hover_enabled=\"off|hover\" transform_skew__hover_enabled=\"off|hover\" transform_origin__hover_enabled=\"off|hover\" animation_delay=\"600ms\"][/et_pb_image][et_pb_blurb title=\"خدمات تعمیرات\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_font_size=\"18px\" background_color=\"#41547d\" background_layout=\"dark\" custom_margin=\"-14vw|-10vw||10vw\" custom_margin_tablet=\"0vw|0vw||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" custom_padding=\"80px|60px|80px|60px|true|true\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|phone\" animation_style=\"flip\" hover_enabled=\"0\" text_font_size_tablet=\"\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\" locked=\"off\" text_text_shadow_style=\"preset3\" text_letter_spacing=\"1px\"]<ol>\n<li> کوتاه کردن / بلند کردن</li>\n<li>کاف</li>\n<li>پوشش</li>\n<li>دور کمر</li>\n<li>آستین ها را بلند / کوتاه کنید</li>\n<li>دکمه / قلاب دوباره دوخت</li>\n<li>تعویض زیپ</li>\n<li>و ......</li>\n</ol>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"4.4.2\" module_alignment=\"center\" custom_margin=\"-40px||\" custom_padding=\"0|0px|0|0px|false|false\" hover_enabled=\"0\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|600|||||||\" text_font_size=\"24px\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_2_font=\"||||||||\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" background_color=\"#dfab82\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-01.png\" background_position=\"bottom_right\" background_layout=\"dark\" custom_padding=\"50px|60px|50px|60px|true|true\" animation_style=\"flip\" link_option_url=\"#\" hover_enabled=\"0\" locked=\"off\" custom_padding__hover_enabled=\"on\" custom_padding__hover=\"|40px||80px||false\" background__hover_enabled=\"on|hover\" background_color__hover=\"#680000\" background_enable_color__hover=\"on\"]<p>مشاهده تمام خدمات</p>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Gallery\" _builder_version=\"4.4.2\" background_color=\"#f7f9fc\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#f7f9fc\" background_color_gradient_end=\"#ffffff\" hover_enabled=\"0\" disabled_on=\"off|off|off\"][et_pb_row column_structure=\"1_4,1_4,1_2\" _builder_version=\"3.25\"][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-08.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"4.4.2\" custom_margin=\"|||-7vw|false|false\" custom_margin_tablet=\"|||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|phone\" hover_enabled=\"0\" locked=\"off\"][/et_pb_image][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/crypto_image_03.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" border_color_all=\"#ffffff\" border_width_bottom=\"20px\" border_width_left=\"20px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-10.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"6vw||\" custom_margin_tablet=\"\" custom_margin_phone=\"0vw||\" custom_margin_last_edited=\"on|desktop\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>چند نمونه کار اخیر ما</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"مشاهده سایر نمونه کارها\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"left\" custom_padding=\"27px|0px|0|0px|false|false\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\" locked=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonials\" _builder_version=\"3.22\" background_color=\"#ffffff\" custom_padding=\"0|0px|54px|0px|false|false\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_slider _builder_version=\"4.4.2\" body_font=\"|600|on||||||\" body_font_size=\"26px\" body_line_height=\"1.8em\" background_color=\"#dfab82\" animation_style=\"flip\" hover_enabled=\"0\" body_font_size_tablet=\"20px\" body_font_size_phone=\"12px\" body_font_size_last_edited=\"on|phone\" box_shadow_style=\"preset1\" box_shadow_vertical=\"50px\" box_shadow_blur=\"60px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][/et_pb_slider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" _builder_version=\"4.4.2\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/Tailor-back.jpg\" hover_enabled=\"0\" disabled_on=\"off|off|off\" scroll_vertical_motion_enable=\"on\"][et_pb_row _builder_version=\"4.4.2\"][et_pb_column _builder_version=\"4.4.2\" type=\"4_4\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/Tailor3.png\" _builder_version=\"4.4.2\" hover_enabled=\"0\" custom_css_main_element=\"||\" scroll_vertical_motion_enable=\"on\" scroll_vertical_motion=\"20|50|50|90|4|0|-4\"][/et_pb_image][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#f1f6ff\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>در تماس باشید!</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_blurb title=\"بازدید از محل کار ما\" use_icon=\"on\" font_icon=\"%%249%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\"]<p>ایران - تهران - شهرک خیاط</p>\n[/et_pb_blurb][et_pb_blurb title=\"شماره تماس\" use_icon=\"on\" font_icon=\"%%264%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\"]<p>091312345678</p>\n[/et_pb_blurb][et_pb_blurb title=\"ایمیل ما\" use_icon=\"on\" font_icon=\"%%238%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\"]<p>info@modelsite.ir</p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_row_inner _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"60px|0px|60px|0px|true|false\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_column_inner saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_contact_form captcha=\"off\" module_id=\"et_pb_contact_form_0\" _builder_version=\"4.4.2\" form_field_background_color=\"#f5f9ff\" form_field_font=\"||||||||\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#af8447\" button_border_width=\"10px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"|40px||40px||true\" hover_enabled=\"0\" form_background_color=\"#f5f9ff\" submit_button_text=\"ارسال پیام\" success_message=\"پیام شما با موفقیت ارسال شد .\" button_bg_enable_color=\"on\" box_shadow_style_button=\"preset1\" form_field_text_shadow_style=\"preset4\"][et_pb_contact_field field_id=\"Name\" field_title=\"نام\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Email\" field_title=\"ایمیل شما\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Phone\" field_title=\"شماره تماس\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Message\" field_title=\"پیام شما ....\" field_type=\"text\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||30px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][/et_pb_contact_form][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section]", "خانه", "", "inherit", "closed", "closed", "", "2-revision-v1", "", "", "2020-03-31 14:51:19", "2020-03-31 11:21:19", "", "2", "http://modelsite.test/2-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2860", "1", "2020-03-31 14:54:01", "2020-03-31 11:24:01", "[et_pb_section fb_built=\"1\" use_custom_gutter=\"on\" gutter_width=\"1\" admin_label=\"Header\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#f7f9fc\" background_color_gradient_start_position=\"75%\" background_color_gradient_end_position=\"75%\" custom_padding=\"0|0px|0|0px|false|false\" hover_enabled=\"0\"][et_pb_row column_structure=\"1_2,1_2\" use_custom_gutter=\"on\" gutter_width=\"1\" make_equal=\"on\" padding_top_bottom_link_1=\"true\" _builder_version=\"3.25\" custom_padding=\"0|0px|0|0px|false|false\" hover_enabled=\"0\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"8vw|60px|8vw|\" custom_padding_tablet=\"|0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"|0px||\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"|600|||||||\" header_font_size=\"60px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_text_color=\"#dfab82\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" custom_margin=\"||40px\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\"]<h1>خیاطی مردانه</h1>\n<h2>شیک پوش باشید </h2>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"آنلاین رزرو کنید\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#41547d\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(65,84,125,0.24)\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][et_pb_button button_text=\"یا تماس بگیرید : 12345-021\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#41547d\" button_bg_color=\"#ffffff\" button_border_width=\"0px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(65,84,125,0.06)\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_text_color_last_edited=\"on|desktop\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#af8447\" button_bg_enable_color__hover=\"on\" button_text_color__hover_enabled=\"on|hover\" button_text_color__hover=\"#ffffff\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-02.jpg\" parallax=\"on\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider show_divider=\"off\" disabled_on=\"off|off|on\" _builder_version=\"3.17.6\" height=\"250px\" hover_enabled=\"0\"][/et_pb_divider][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" use_custom_gutter=\"on\" gutter_width=\"1\" padding_top_bottom_link_2=\"false\" _builder_version=\"3.25\" custom_padding=\"0|0px|27px|0px|false|false\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_video src=\"#\" image_src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-03.jpg\" _builder_version=\"4.4.2\" custom_margin=\"|||-80px\" custom_margin_tablet=\"|||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" hover_enabled=\"0\"][/et_pb_video][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"100px|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-04.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" max_width=\"80%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" box_shadow_style=\"preset1\" box_shadow_horizontal=\"-41px\" box_shadow_vertical=\"45px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(0,0,0,0.52)\" locked=\"off\"][/et_pb_image][et_pb_text _builder_version=\"4.4.2\" text_font=\"|600|||||||\" text_font_size=\"24px\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_2_font=\"||||||||\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" background_color=\"#dfab82\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-01.png\" background_position=\"bottom_right\" background_layout=\"dark\" custom_margin=\"|||0%\" custom_padding=\"50px|60px|50px|60px|true|true\" animation_direction=\"left\" link_option_url=\"#\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\" custom_padding__hover_enabled=\"on\" custom_padding__hover=\"|40px||80px||false\" background__hover_enabled=\"on\" background_color__hover=\"#ddb494\"]<p>مشاهده گالری نمونه کارها</p>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"left\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" admin_label=\"Services\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"22px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>یک کت و شلوار سفارش دهید که توسط خیاطان متخصص برای تن شما ساخته شده است</h2>\n[/et_pb_text][et_pb_button button_text=\"یک وقت بگیرید\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_row_inner column_structure=\"1_2,1_2\" _builder_version=\"3.25\"][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"خیاطی لباس دامادی\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-03.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][et_pb_blurb title=\"تعمیرات لباس\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-02.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][/et_pb_column_inner][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"میلیمترها رو ما حواسمان هست\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-12.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][et_pb_blurb title=\"دوخت انواع پیراهن و شلوار\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-01.png\" _builder_version=\"4.4.2\" header_font_size=\"14px\" header_font=\"|700|||||||\" icon_alignment=\"right\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale__hover=\"110%|110%\" body_font_size=\"12px\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonial\" _builder_version=\"4.4.2\" background_color=\"#f7f9fc\" hover_enabled=\"0\" disabled_on=\"off|off|off\"][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"4.4.2\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-05.jpg\" custom_padding=\"0|0px|12vw|0px|false|false\" hover_enabled=\"0\" module_alignment=\"center\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_testimonial quote_icon=\"off\" _builder_version=\"4.4.2\" body_font=\"||on||||||\" body_font_size=\"20px\" body_line_height=\"2em\" background_color=\"#41547d\" background_layout=\"dark\" custom_margin=\"-12vw|||-10vw\" custom_margin_tablet=\"0vw||10vw|0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" custom_padding=\"80px|60px|80px|7vw|true|false\" custom_padding_tablet=\"40px|10%|40px|10%|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" animation_style=\"flip\" hover_enabled=\"0\" body_font_size_tablet=\"18px\" body_font_size_phone=\"\" body_font_size_last_edited=\"on|desktop\" body_line_height_tablet=\"\" body_line_height_phone=\"1.8em\" body_line_height_last_edited=\"on|phone\" box_shadow_style=\"preset1\" box_shadow_horizontal=\"-41px\" box_shadow_vertical=\"45px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(0,0,0,0.52)\" locked=\"off\" module_alignment=\"right\" width=\"92%\"]<p>\"<b>دوزندگی</b><span> </span>صنعت و هنر<span> پیوست یا پیوند اشیاء با استفاده از </span>بخیه<span> ساخته شده با </span>سوزن<span> و </span>نخ<span> است</span><span>.</span>\"</p>\n[/et_pb_testimonial][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_6,1_6,1_6,1_6,1_6,1_6\" _builder_version=\"3.25\"][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_08-1.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_07-1.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_06-1.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_05-2.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_03-2.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_01-2.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Feature\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"32px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>لباس شما با بهترین مواد دوخته می شود</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"اطلاعات بیشتر\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-06.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\"][/et_pb_image][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-07.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" max_width=\"70%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" border_color_all=\"#ffffff\" border_width_right=\"20px\" border_width_bottom=\"20px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][/et_pb_image][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"right\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Services\" _builder_version=\"3.22\" background_color=\"#f7f9fc\" custom_margin=\"|||\" custom_padding=\"0|0px|80px|0px|false|false\"][et_pb_row column_structure=\"1_2,1_2\" custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#ffffff\" width=\"90%\" max_width=\"90%\" module_alignment=\"left\" custom_margin=\"|||\" custom_padding=\"60px|||15vw|false|false\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"120px\" box_shadow_color=\"rgba(96,104,121,0.12)\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"90%\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.4em\" max_width=\"600px\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>خیاطی و تعمیرات</h2>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_4,1_4,1_2\" custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#ffffff\" width=\"90%\" max_width=\"90%\" module_alignment=\"left\" custom_margin=\"|||\" custom_padding=\"||120px|15vw|false|false\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"120px\" box_shadow_color=\"rgba(96,104,121,0.12)\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"90%\"][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-04.png\" _builder_version=\"4.4.2\" hover_enabled=\"0\" always_center_on_mobile=\"off\" locked=\"off\" animation_style=\"slide\" animation_direction=\"bottom\" animation_delay=\"600ms\"][/et_pb_image][et_pb_blurb title=\"خدمات خیاطی\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-05.png\" _builder_version=\"4.4.2\" hover_enabled=\"0\" always_center_on_mobile=\"off\" locked=\"off\" animation_style=\"slide\" animation_direction=\"bottom\" transform_styles__hover_enabled=\"off|hover\" transform_scale__hover_enabled=\"off|hover\" transform_translate__hover_enabled=\"off|hover\" transform_rotate__hover_enabled=\"off|hover\" transform_skew__hover_enabled=\"off|hover\" transform_origin__hover_enabled=\"off|hover\" animation_delay=\"600ms\"][/et_pb_image][et_pb_blurb title=\"خدمات تعمیرات\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_font_size=\"18px\" background_color=\"#41547d\" background_layout=\"dark\" custom_margin=\"-14vw|-10vw||10vw\" custom_margin_tablet=\"0vw|0vw||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" custom_padding=\"80px|60px|80px|60px|true|true\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|phone\" animation_style=\"flip\" hover_enabled=\"0\" text_font_size_tablet=\"\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\" locked=\"off\" text_text_shadow_style=\"preset3\" text_letter_spacing=\"1px\"]<ol>\n<li> کوتاه کردن / بلند کردن</li>\n<li>کاف</li>\n<li>پوشش</li>\n<li>دور کمر</li>\n<li>آستین ها را بلند / کوتاه کنید</li>\n<li>دکمه / قلاب دوباره دوخت</li>\n<li>تعویض زیپ</li>\n<li>و ......</li>\n</ol>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"4.4.2\" module_alignment=\"center\" custom_margin=\"-40px||\" custom_padding=\"0|0px|0|0px|false|false\" hover_enabled=\"0\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|600|||||||\" text_font_size=\"24px\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_2_font=\"||||||||\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" background_color=\"#dfab82\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-01.png\" background_position=\"bottom_right\" background_layout=\"dark\" custom_padding=\"50px|60px|50px|60px|true|true\" animation_style=\"flip\" link_option_url=\"#\" hover_enabled=\"0\" locked=\"off\" custom_padding__hover_enabled=\"on\" custom_padding__hover=\"|40px||80px||false\" background__hover_enabled=\"on|hover\" background_color__hover=\"#680000\" background_enable_color__hover=\"on\"]<p>مشاهده تمام خدمات</p>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Gallery\" _builder_version=\"4.4.2\" background_color=\"#f7f9fc\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#f7f9fc\" background_color_gradient_end=\"#ffffff\" hover_enabled=\"0\" disabled_on=\"off|off|off\"][et_pb_row column_structure=\"1_4,1_4,1_2\" _builder_version=\"3.25\"][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-08.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"4.4.2\" custom_margin=\"|||-7vw|false|false\" custom_margin_tablet=\"|||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|phone\" hover_enabled=\"0\" locked=\"off\"][/et_pb_image][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/crypto_image_03.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" border_color_all=\"#ffffff\" border_width_bottom=\"20px\" border_width_left=\"20px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-10.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"6vw||\" custom_margin_tablet=\"\" custom_margin_phone=\"0vw||\" custom_margin_last_edited=\"on|desktop\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>چند نمونه کار اخیر ما</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"مشاهده سایر نمونه کارها\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"left\" custom_padding=\"27px|0px|0|0px|false|false\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\" locked=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonials\" _builder_version=\"3.22\" background_color=\"#ffffff\" custom_padding=\"0|0px|54px|0px|false|false\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_slider _builder_version=\"4.4.2\" body_font=\"|600|on||||||\" body_font_size=\"26px\" body_line_height=\"1.8em\" background_color=\"#dfab82\" animation_style=\"flip\" hover_enabled=\"0\" body_font_size_tablet=\"20px\" body_font_size_phone=\"12px\" body_font_size_last_edited=\"on|phone\" box_shadow_style=\"preset1\" box_shadow_vertical=\"50px\" box_shadow_blur=\"60px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" hover_enabled=\"0\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>\n[/et_pb_slide][/et_pb_slider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" _builder_version=\"4.4.2\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/Tailor-back.jpg\" hover_enabled=\"0\" disabled_on=\"off|off|off\"][et_pb_row _builder_version=\"4.4.2\"][et_pb_column _builder_version=\"4.4.2\" type=\"4_4\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/Tailor3.png\" _builder_version=\"4.4.2\" hover_enabled=\"0\" custom_css_main_element=\"||\" scroll_vertical_motion_enable=\"on\" scroll_vertical_motion=\"8|50|50|96|4|0|-4\"][/et_pb_image][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#f1f6ff\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>در تماس باشید!</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_blurb title=\"بازدید از محل کار ما\" use_icon=\"on\" font_icon=\"%%249%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\"]<p>ایران - تهران - شهرک خیاط</p>\n[/et_pb_blurb][et_pb_blurb title=\"شماره تماس\" use_icon=\"on\" font_icon=\"%%264%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\"]<p>091312345678</p>\n[/et_pb_blurb][et_pb_blurb title=\"ایمیل ما\" use_icon=\"on\" font_icon=\"%%238%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\"]<p>info@modelsite.ir</p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_row_inner _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"60px|0px|60px|0px|true|false\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_column_inner saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_contact_form captcha=\"off\" module_id=\"et_pb_contact_form_0\" _builder_version=\"4.4.2\" form_field_background_color=\"#f5f9ff\" form_field_font=\"||||||||\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#af8447\" button_border_width=\"10px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"|40px||40px||true\" hover_enabled=\"0\" form_background_color=\"#f5f9ff\" submit_button_text=\"ارسال پیام\" success_message=\"پیام شما با موفقیت ارسال شد .\" button_bg_enable_color=\"on\" box_shadow_style_button=\"preset1\" form_field_text_shadow_style=\"preset4\"][et_pb_contact_field field_id=\"Name\" field_title=\"نام\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Email\" field_title=\"ایمیل شما\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Phone\" field_title=\"شماره تماس\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Message\" field_title=\"پیام شما ....\" field_type=\"text\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||30px\" hover_enabled=\"0\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][/et_pb_contact_form][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section]", "خانه", "", "inherit", "closed", "closed", "", "2-revision-v1", "", "", "2020-03-31 14:54:01", "2020-03-31 11:24:01", "", "2", "http://modelsite.test/2-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2862", "1", "2020-03-31 14:55:55", "2020-03-31 11:25:55", "{\n    \"et_divi[mobile_menu_link]\": {\n        \"value\": \"#dfab82\",\n        \"type\": \"option\",\n        \"user_id\": 1,\n        \"date_modified_gmt\": \"2020-03-31 11:25:55\"\n    }\n}", "", "", "trash", "closed", "closed", "", "b940d5db-ac3e-4c15-ba92-08c05b0d22a0", "", "", "2020-03-31 14:55:55", "2020-03-31 11:25:55", "", "0", "http://modelsite.test/b940d5db-ac3e-4c15-ba92-08c05b0d22a0/", "0", "customize_changeset", "", "0");
INSERT INTO `wp_posts` VALUES("2864", "1", "2020-03-31 15:14:43", "2020-03-31 11:44:43", "[et_pb_section fb_built=\"1\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(48,57,78,0.95)\" background_color_gradient_end=\"rgba(96,124,179,0.85)\" background_color_gradient_direction=\"60deg\" background_color_gradient_overlays_image=\"on\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-18.jpg\" custom_padding=\"6vw||6vw||true\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"|600|||||||\" header_font_size=\"60px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_text_color=\"#dfab82\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" text_orientation=\"center\" background_layout=\"dark\" max_width=\"800px\" module_alignment=\"center\" custom_margin=\"||40px\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h1>خدمات ما</h1>\n<h2>لباس های سفارشی و تعمیرات لباس</h2>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span></p>\n[/et_pb_text][et_pb_button button_text=\"ارتباط با ما\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" padding_top_2=\"7vw\" admin_label=\"Services\" _builder_version=\"3.22\" background_color=\"#f7f9fc\" locked=\"off\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"32px\" header_2_line_height=\"1.5em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>ما لباس ، پیراهن ، شلوار را می دوزیم و تعمیر و تغییرات را انجام میدهیم</h2>\n[/et_pb_text][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-09.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\"][/et_pb_image][et_pb_button button_text=\"Make an Appointment\" _builder_version=\"3.17.6\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"Muli|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" padding_top__hover=\"7vw\" custom_padding__hover=\"|||\"][et_pb_row_inner column_structure=\"1_2,1_2\" _builder_version=\"3.25\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" max_width__hover=\"100%\" max_width__hover_enabled=\"100%\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" parallax__hover_enabled=\"off\" parallax_method__hover_enabled=\"on\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-04.png\" _builder_version=\"3.23\" always_center_on_mobile=\"off\" locked=\"off\"][/et_pb_image][et_pb_blurb title=\"دوخت انواع لباس\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_blurb][/et_pb_column_inner][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" parallax__hover_enabled=\"off\" parallax_method__hover_enabled=\"on\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-10.png\" _builder_version=\"3.23\" always_center_on_mobile=\"off\" locked=\"off\"][/et_pb_image][et_pb_blurb title=\"تجهیزات مدرن خیاطی\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_blurb][/et_pb_column_inner][/et_pb_row_inner][et_pb_row_inner column_structure=\"1_2,1_2\" _builder_version=\"3.25\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" max_width__hover=\"100%\" max_width__hover_enabled=\"100%\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" parallax__hover_enabled=\"off\" parallax_method__hover_enabled=\"on\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-09.png\" _builder_version=\"3.23\" always_center_on_mobile=\"off\" locked=\"off\"][/et_pb_image][et_pb_blurb title=\"لباس مجلسی\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_blurb][/et_pb_column_inner][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" parallax__hover_enabled=\"off\" parallax_method__hover_enabled=\"on\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-06.png\" _builder_version=\"3.23\" always_center_on_mobile=\"off\" locked=\"off\"][/et_pb_image][et_pb_blurb title=\"اتو لباس\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_blurb][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Services\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_row column_structure=\"1_2,1_2\" custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#41547d\" custom_padding=\"80px|60px|80px|60px|true|true\" custom_padding_tablet=\"\" custom_padding_phone=\"60px|40px|60px|40px|true|true\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"34px\" header_2_line_height=\"1.4em\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" background_layout=\"dark\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>لباس راحت طراحی شده برای راحتی  شما</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" background_layout=\"dark\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span></p>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"فقط بهترین پارچه ها انتخاب میشوند\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-08-1.png\" icon_placement=\"left\" image_max_width=\"90px\" content_max_width=\"1100px\" image_max_width_tablet=\"\" image_max_width_phone=\"45px\" image_max_width_last_edited=\"on|phone\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" background_layout=\"dark\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز</span>.</p>\n[/et_pb_blurb][et_pb_blurb title=\"طراحی و برش با کمال دقت و زیبایی\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-06-1.png\" icon_placement=\"left\" image_max_width=\"90px\" content_max_width=\"1100px\" image_max_width_tablet=\"\" image_max_width_phone=\"45px\" image_max_width_last_edited=\"on|phone\" _builder_version=\"4.4.2\" header_font=\"Muli|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" background_layout=\"dark\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز</span></p>\n[/et_pb_blurb][et_pb_blurb title=\"ساخته شده در خیاطی ما\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-02-1.png\" icon_placement=\"left\" image_max_width=\"90px\" content_max_width=\"1100px\" image_max_width_tablet=\"\" image_max_width_phone=\"45px\" image_max_width_last_edited=\"on|phone\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" background_layout=\"dark\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز</span></p>\n[/et_pb_blurb][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" custom_padding=\"0|0px|27px|0px|false|false\" locked=\"off\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|600|||||||\" text_font_size=\"24px\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_2_font=\"||||||||\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" background_color=\"#dfab82\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-01.png\" background_position=\"bottom_right\" background_layout=\"dark\" custom_margin=\"|||0%\" custom_padding=\"50px|60px|50px|60px|true|true\" animation_direction=\"left\" link_option_url=\"#\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\" custom_padding__hover_enabled=\"on\" custom_padding__hover=\"|40px||80px||false\" background__hover_enabled=\"on\" background_color__hover=\"#ddb494\"]<p>رزرو یک وقت</p>\n[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Service\" _builder_version=\"4.4.2\" background_color=\"#f7f9fc\" hover_enabled=\"0\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/Tailor2.png\" background_size=\"initial\" background_position=\"bottom_left\" background_last_edited=\"on|tablet\" background_size_phone=\"initial\" background_position_phone=\"top_center\" background_blend_phone=\"normal\" background_enable_image_phone=\"off\"][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>آیا یک لباس مجلسی و خاص دارید که نیاز به تعمیر یا تغییرات حساس دارد؟</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span></p>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-06.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\"][/et_pb_image][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-07.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" max_width=\"70%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" border_color_all=\"#ffffff\" border_width_right=\"20px\" border_width_bottom=\"20px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][/et_pb_image][et_pb_button button_text=\"کار را به کاردان بسپارید\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"16px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"right\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"About\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" text_orientation=\"center\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>دیگر خدمات ما</h2>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" padding_top_bottom_link_1=\"true\" padding_top_bottom_link_2=\"true\" padding_top_bottom_link_3=\"true\" padding_left_right_link_1=\"true\" padding_left_right_link_2=\"true\" padding_left_right_link_3=\"true\" _builder_version=\"3.25\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"30px|30px|30px|30px\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-16.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\"][/et_pb_image][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_3_font=\"|600|||||||\" header_3_font_size=\"20px\" header_3_line_height=\"1.4em\" header_4_font=\"Muli|700||on|||||\" header_4_text_color=\"#dfab82\" header_4_font_size=\"12px\" header_4_letter_spacing=\"2px\" header_4_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_3_font_size_tablet=\"40px\" header_3_font_size_phone=\"30px\" header_3_font_size_last_edited=\"off|desktop\" locked=\"off\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h3>کت و شلوار دامادی</h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"بیشتر بدانید\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"0px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_text_color__hover_enabled=\"off|hover\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#680000\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"30px|30px|30px|30px\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-13.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_3_font=\"|600|||||||\" header_3_font_size=\"20px\" header_3_line_height=\"1.4em\" header_4_font=\"Muli|700||on|||||\" header_4_text_color=\"#dfab82\" header_4_font_size=\"12px\" header_4_letter_spacing=\"2px\" header_4_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_3_font_size_tablet=\"40px\" header_3_font_size_phone=\"30px\" header_3_font_size_last_edited=\"off|desktop\" locked=\"off\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h3>تعمیر کیف مردانه</h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"بیشتر بدانید\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"0px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_text_color__hover_enabled=\"off|hover\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#680000\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"30px|30px|30px|30px\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-12.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_3_font=\"|600|||||||\" header_3_font_size=\"20px\" header_3_line_height=\"1.4em\" header_4_font=\"|700||on|||||\" header_4_text_color=\"#dfab82\" header_4_font_size=\"12px\" header_4_letter_spacing=\"2px\" header_4_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_3_font_size_tablet=\"40px\" header_3_font_size_phone=\"30px\" header_3_font_size_last_edited=\"off|desktop\" locked=\"off\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h3>ست لباس داماد</h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"بیشتر بدانید\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"0px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_text_color__hover_enabled=\"off|hover\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#680000\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" padding_top_bottom_link_1=\"true\" padding_top_bottom_link_2=\"true\" padding_top_bottom_link_3=\"true\" padding_left_right_link_1=\"true\" padding_left_right_link_2=\"true\" padding_left_right_link_3=\"true\" _builder_version=\"3.25\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"30px|30px|30px|30px\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-11.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\"][/et_pb_image][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_3_font=\"|600|||||||\" header_3_font_size=\"20px\" header_3_line_height=\"1.4em\" header_4_font=\"Muli|700||on|||||\" header_4_text_color=\"#dfab82\" header_4_font_size=\"12px\" header_4_letter_spacing=\"2px\" header_4_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_3_font_size_tablet=\"40px\" header_3_font_size_phone=\"30px\" header_3_font_size_last_edited=\"off|desktop\" locked=\"off\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h3>دوخت انواع پیراهن</h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"بیشتر بدانید\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"0px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_text_color__hover_enabled=\"off|hover\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#680000\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"30px|30px|30px|30px\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-14.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_3_font=\"|600|||||||\" header_3_font_size=\"20px\" header_3_line_height=\"1.4em\" header_4_font=\"Muli|700||on|||||\" header_4_text_color=\"#dfab82\" header_4_font_size=\"12px\" header_4_letter_spacing=\"2px\" header_4_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_3_font_size_tablet=\"40px\" header_3_font_size_phone=\"30px\" header_3_font_size_last_edited=\"off|desktop\" locked=\"off\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h3>دوخت انواع شلوار</h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"بیشتر بدانید\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"0px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_text_color__hover_enabled=\"off|hover\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#680000\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"30px|30px|30px|30px\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-15.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_3_font=\"|600|||||||\" header_3_font_size=\"20px\" header_3_line_height=\"1.4em\" header_4_font=\"Muli|700||on|||||\" header_4_text_color=\"#dfab82\" header_4_font_size=\"12px\" header_4_letter_spacing=\"2px\" header_4_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_3_font_size_tablet=\"40px\" header_3_font_size_phone=\"30px\" header_3_font_size_last_edited=\"off|desktop\" locked=\"off\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h3>اتو لباس ها</h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"بیشتر بدانید\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"0px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_text_color__hover_enabled=\"off|hover\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#680000\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonials\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#f7f9fc\" background_color_gradient_end=\"#ffffff\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" inner_shadow__hover=\"off\" inner_shadow__hover_enabled=\"off\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" max_width__hover=\"100%\" max_width__hover_enabled=\"100%\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_slider _builder_version=\"4.4.2\" body_font=\"|600|on||||||\" body_font_size=\"26px\" body_line_height=\"1.8em\" background_color=\"#dfab82\" animation_style=\"flip\" body_font_size_tablet=\"20px\" body_font_size_phone=\"12px\" body_font_size_last_edited=\"on|phone\" box_shadow_style=\"preset1\" box_shadow_vertical=\"50px\" box_shadow_blur=\"60px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\"][et_pb_slide _builder_version=\"4.4.2\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>[/et_pb_slide][/et_pb_slider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#f1f6ff\" locked=\"off\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>در تماس باشید!</h2>[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>[/et_pb_text][et_pb_blurb title=\"بازدید از محل کار ما\" use_icon=\"on\" font_icon=\"%%249%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\"]<p>ایران - تهران - شهرک خیاط</p>[/et_pb_blurb][et_pb_blurb title=\"شماره تماس\" use_icon=\"on\" font_icon=\"%%264%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\"]<p>091312345678</p>[/et_pb_blurb][et_pb_blurb title=\"ایمیل ما\" use_icon=\"on\" font_icon=\"%%238%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\"]<p>info@modelsite.ir</p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_row_inner _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"60px|0px|60px|0px|true|false\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_column_inner saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_contact_form captcha=\"off\" success_message=\"پیام شما با موفقیت ارسال شد .\" submit_button_text=\"ارسال پیام\" module_id=\"et_pb_contact_form_0\" _builder_version=\"4.4.2\" form_field_background_color=\"#f5f9ff\" form_field_font=\"||||||||\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#af8447\" button_border_width=\"10px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"|40px||40px||true\" form_field_text_shadow_style=\"preset4\" box_shadow_style_button=\"preset1\" form_background_color=\"#f5f9ff\"][et_pb_contact_field field_id=\"Name\" field_title=\"نام\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Email\" field_title=\"ایمیل شما\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Phone\" field_title=\"شماره تماس\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Message\" field_title=\"پیام شما ....\" field_type=\"text\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||30px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][/et_pb_contact_form][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section]", "خدمات", "", "inherit", "closed", "closed", "", "899-revision-v1", "", "", "2020-03-31 15:14:43", "2020-03-31 11:44:43", "", "899", "http://modelsite.test/899-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2868", "1", "2020-03-31 15:25:21", "2020-03-31 11:55:21", "[et_pb_section fb_built=\"1\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(48,57,78,0.95)\" background_color_gradient_end=\"rgba(96,124,179,0.85)\" background_color_gradient_direction=\"60deg\" background_color_gradient_overlays_image=\"on\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-17.jpg\" custom_padding=\"6vw||6vw||true\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"|600|||||||\" header_font_size=\"60px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_text_color=\"#dfab82\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" text_orientation=\"center\" background_layout=\"dark\" max_width=\"800px\" module_alignment=\"center\" custom_margin=\"||40px\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h1>درباره ما</h1>\n<h2>خیاطی 5 ستاره ما</h2>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span></p>\n[/et_pb_text][et_pb_button button_text=\"تماس با ما و رزرو وقت\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"About\" _builder_version=\"3.22\"][et_pb_row column_structure=\"1_3,1_3,1_3\" _builder_version=\"3.25\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span></p>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span></p>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>با بیش از سه قرن تجربه ، تاسیس در سال 1370</h2>\n[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Process\" _builder_version=\"3.22\"][et_pb_row column_structure=\"1_2,1_2\" custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#41547d\" custom_padding=\"80px|60px|80px|60px|true|true\" custom_padding_tablet=\"\" custom_padding_phone=\"60px|40px|60px|40px|true|true\" locked=\"off\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"34px\" header_2_line_height=\"1.4em\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" background_layout=\"dark\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>لباس راحت طراحی شده برای راحتی  شما</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" background_layout=\"dark\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span></p>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"فقط بهترین پارچه ها انتخاب میشوند\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-08-1.png\" icon_placement=\"left\" image_max_width=\"90px\" content_max_width=\"1100px\" image_max_width_tablet=\"\" image_max_width_phone=\"45px\" image_max_width_last_edited=\"on|phone\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" background_layout=\"dark\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز</span>.</p>\n[/et_pb_blurb][et_pb_blurb title=\"طراحی و برش با کمال دقت و زیبایی\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-06-1.png\" icon_placement=\"left\" image_max_width=\"90px\" content_max_width=\"1100px\" image_max_width_tablet=\"\" image_max_width_phone=\"45px\" image_max_width_last_edited=\"on|phone\" _builder_version=\"4.4.2\" header_font=\"Muli|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" background_layout=\"dark\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز</span></p>\n[/et_pb_blurb][et_pb_blurb title=\"ساخته شده در خیاطی ما\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-02-1.png\" icon_placement=\"left\" image_max_width=\"90px\" content_max_width=\"1100px\" image_max_width_tablet=\"\" image_max_width_phone=\"45px\" image_max_width_last_edited=\"on|phone\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" background_layout=\"dark\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز</span></p>\n[/et_pb_blurb][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" custom_padding=\"0|0px|27px|0px|false|false\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|600|||||||\" text_font_size=\"24px\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_2_font=\"||||||||\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" background_color=\"#dfab82\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-01.png\" background_position=\"bottom_right\" background_layout=\"dark\" custom_margin=\"|||0%\" custom_padding=\"50px|60px|50px|60px|true|true\" animation_direction=\"left\" link_option_url=\"#\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\" custom_padding__hover_enabled=\"on\" custom_padding__hover=\"|40px||80px||false\" background__hover_enabled=\"on\" background_color__hover=\"#ddb494\"]<p>رزرو یک وقت</p>\n[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" use_custom_gutter=\"on\" gutter_width=\"1\" admin_label=\"Video\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#f7f9fc\" background_color_gradient_start_position=\"75%\" background_color_gradient_end_position=\"75%\" custom_padding=\"0|0px|0|0px|false|false\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_video src=\"#\" image_src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-05.jpg\" play_icon_color=\"#607CB3\" _builder_version=\"4.4.2\" hover_enabled=\"0\"][/et_pb_video][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" disabled_on=\"off|off|off\" admin_label=\"Gallery\" _builder_version=\"4.4.2\" background_color=\"#f7f9fc\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#f7f9fc\" background_color_gradient_end=\"#ffffff\" locked=\"off\"][et_pb_row column_structure=\"1_4,1_4,1_2\" _builder_version=\"3.25\"][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-08.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"4.4.2\" custom_margin=\"|||-7vw|false|false\" custom_margin_tablet=\"|||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|phone\" locked=\"off\"][/et_pb_image][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/crypto_image_03.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" border_color_all=\"#ffffff\" border_width_bottom=\"20px\" border_width_left=\"20px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-10.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"6vw||\" custom_margin_tablet=\"\" custom_margin_phone=\"0vw||\" custom_margin_last_edited=\"on|desktop\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>چند نمونه کار اخیر ما</h2>[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>[/et_pb_text][et_pb_button button_text=\"مشاهده سایر نمونه کارها\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"left\" custom_padding=\"27px|0px|0|0px|false|false\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\" locked=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Team\" _builder_version=\"3.22\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>با خیاطان ما آشنا شوید</h2>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/portrait-04.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"4.4.2\" hover_enabled=\"0\" animation_style=\"bounce\"][/et_pb_image][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_3_font=\"|600|||||||\" header_3_font_size=\"30px\" header_3_line_height=\"1.4em\" header_4_font=\"|700||on|||||\" header_4_text_color=\"#dfab82\" header_4_font_size=\"12px\" header_4_letter_spacing=\"2px\" header_4_line_height=\"2em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_3_font_size_tablet=\"40px\" header_3_font_size_phone=\"30px\" header_3_font_size_last_edited=\"off|desktop\" locked=\"off\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h3>جان</h3>\n<h4>چرخ کار</h4>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span></p>\n[/et_pb_text][et_pb_counters bar_bg_color=\"#607cb3\" use_percentages=\"off\" _builder_version=\"4.4.2\" title_font=\"|700||on|||||\" title_text_color=\"#41547d\" title_font_size=\"16px\" title_line_height=\"2em\" percent_font=\"||||||||\" background_color=\"#f1f6ff\" hover_enabled=\"0\"][et_pb_counter percent=\"80\" _builder_version=\"4.4.2\" hover_enabled=\"0\" background_color_default=\"#f1f6ff\" background_enable_color_default=\"on\" parallax_default=\"off\" parallax_method_default=\"on\" bar_background_color_default=\"#607cb3\" use_percentages=\"off\" allow_player_pause_default=\"off\"]\n\nدوخت کت مردانه\n\n[/et_pb_counter][et_pb_counter percent=\"60\" _builder_version=\"4.4.2\" hover_enabled=\"0\" background_color_default=\"#f1f6ff\" background_enable_color_default=\"on\" parallax_default=\"off\" parallax_method_default=\"on\" bar_background_color_default=\"#607cb3\" use_percentages=\"off\" allow_player_pause_default=\"off\"]\n\nدوخت شلوار مردانه\n\n[/et_pb_counter][et_pb_counter percent=\"50\" _builder_version=\"4.4.2\" hover_enabled=\"0\" background_color_default=\"#f1f6ff\" background_enable_color_default=\"on\" parallax_default=\"off\" parallax_method_default=\"on\" bar_background_color_default=\"#607cb3\" use_percentages=\"off\" allow_player_pause_default=\"off\"]\n\nدوخت پیراهن مردانه\n\n[/et_pb_counter][/et_pb_counters][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/crypto_image_03.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"4.4.2\" hover_enabled=\"0\" animation_style=\"bounce\"][/et_pb_image][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_3_font=\"|600|||||||\" header_3_font_size=\"30px\" header_3_line_height=\"1.4em\" header_4_font=\"|700||on|||||\" header_4_text_color=\"#dfab82\" header_4_font_size=\"12px\" header_4_letter_spacing=\"2px\" header_4_line_height=\"2em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_3_font_size_tablet=\"40px\" header_3_font_size_phone=\"30px\" header_3_font_size_last_edited=\"off|desktop\" locked=\"off\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h3>جک</h3>\n<h4>طراح مد</h4>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span></p>\n[/et_pb_text][et_pb_counters bar_bg_color=\"#607cb3\" use_percentages=\"off\" _builder_version=\"4.4.2\" title_font=\"|700||on|||||\" title_text_color=\"#41547d\" title_font_size=\"16px\" title_line_height=\"2em\" percent_font=\"||||||||\" background_color=\"#f1f6ff\" hover_enabled=\"0\" locked=\"off\"][et_pb_counter percent=\"80\" _builder_version=\"4.4.2\" hover_enabled=\"0\" background_color_default=\"#f1f6ff\" background_enable_color_default=\"on\" parallax_default=\"off\" parallax_method_default=\"on\" bar_background_color_default=\"#607cb3\" use_percentages=\"off\" allow_player_pause_default=\"off\"]\n\nطراحی مد\n\n[/et_pb_counter][et_pb_counter percent=\"60\" _builder_version=\"4.4.2\" hover_enabled=\"0\" background_color_default=\"#f1f6ff\" background_enable_color_default=\"on\" parallax_default=\"off\" parallax_method_default=\"on\" bar_background_color_default=\"#607cb3\" use_percentages=\"off\" allow_player_pause_default=\"off\"]\n\nکت و شلوار\n\n[/et_pb_counter][et_pb_counter percent=\"50\" _builder_version=\"4.4.2\" hover_enabled=\"0\" background_color_default=\"#f1f6ff\" background_enable_color_default=\"on\" parallax_default=\"off\" parallax_method_default=\"on\" bar_background_color_default=\"#607cb3\" use_percentages=\"off\" allow_player_pause_default=\"off\" title_font=\"|700||on|||||\" title_letter_spacing=\"0px\"]\n\nمهارت دیگر\n\n[/et_pb_counter][/et_pb_counters][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonials\" _builder_version=\"3.22\" background_color=\"#ffffff\" custom_padding=\"0|0px|54px|0px|false|false\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_slider _builder_version=\"4.4.2\" body_font=\"|600|on||||||\" body_font_size=\"26px\" body_line_height=\"1.8em\" background_color=\"#dfab82\" animation_style=\"flip\" body_font_size_tablet=\"20px\" body_font_size_phone=\"12px\" body_font_size_last_edited=\"on|phone\" box_shadow_style=\"preset1\" box_shadow_vertical=\"50px\" box_shadow_blur=\"60px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\"][et_pb_slide _builder_version=\"4.4.2\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>[/et_pb_slide][/et_pb_slider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#f1f6ff\" locked=\"off\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>در تماس باشید!</h2>[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>[/et_pb_text][et_pb_blurb title=\"بازدید از محل کار ما\" use_icon=\"on\" font_icon=\"%%249%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\"]<p>ایران - تهران - شهرک خیاط</p>[/et_pb_blurb][et_pb_blurb title=\"شماره تماس\" use_icon=\"on\" font_icon=\"%%264%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\"]<p>091312345678</p>[/et_pb_blurb][et_pb_blurb title=\"ایمیل ما\" use_icon=\"on\" font_icon=\"%%238%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\"]<p>info@modelsite.ir</p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_row_inner _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"60px|0px|60px|0px|true|false\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_column_inner saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_contact_form captcha=\"off\" success_message=\"پیام شما با موفقیت ارسال شد .\" submit_button_text=\"ارسال پیام\" module_id=\"et_pb_contact_form_0\" _builder_version=\"4.4.2\" form_field_background_color=\"#f5f9ff\" form_field_font=\"||||||||\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#af8447\" button_border_width=\"10px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"|40px||40px||true\" form_field_text_shadow_style=\"preset4\" box_shadow_style_button=\"preset1\" form_background_color=\"#f5f9ff\"][et_pb_contact_field field_id=\"Name\" field_title=\"نام\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Email\" field_title=\"ایمیل شما\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Phone\" field_title=\"شماره تماس\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Message\" field_title=\"پیام شما ....\" field_type=\"text\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||30px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][/et_pb_contact_form][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section]", "درباره ما", "", "inherit", "closed", "closed", "", "187-revision-v1", "", "", "2020-03-31 15:25:21", "2020-03-31 11:55:21", "", "187", "http://modelsite.test/187-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2870", "1", "2020-03-31 15:30:14", "2020-03-31 12:00:14", "[et_pb_section fb_built=\"1\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(48,57,78,0.95)\" background_color_gradient_end=\"rgba(96,124,179,0.85)\" background_color_gradient_direction=\"60deg\" background_color_gradient_overlays_image=\"on\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-18.jpg\" custom_padding=\"6vw||6vw||true\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"|600|||||||\" header_font_size=\"60px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_text_color=\"#dfab82\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" text_orientation=\"center\" background_layout=\"dark\" max_width=\"800px\" module_alignment=\"center\" custom_margin=\"||40px\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h1>خدمات ما</h1>\n<h2>لباس های سفارشی و تعمیرات لباس</h2>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span></p>\n[/et_pb_text][et_pb_button button_text=\"ارتباط با ما\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" padding_top_2=\"7vw\" admin_label=\"Services\" _builder_version=\"3.22\" background_color=\"#f7f9fc\" locked=\"off\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"32px\" header_2_line_height=\"1.5em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>ما لباس ، پیراهن ، شلوار را می دوزیم و تعمیر و تغییرات را انجام میدهیم</h2>\n[/et_pb_text][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-09.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\"][/et_pb_image][et_pb_button button_text=\"گرفت نوبت آنلاین\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" padding_top__hover=\"7vw\" custom_padding__hover=\"|||\"][et_pb_row_inner column_structure=\"1_2,1_2\" _builder_version=\"3.25\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" max_width__hover=\"100%\" max_width__hover_enabled=\"100%\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" parallax__hover_enabled=\"off\" parallax_method__hover_enabled=\"on\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-04.png\" _builder_version=\"4.4.2\" hover_enabled=\"0\" always_center_on_mobile=\"off\" locked=\"off\" src__hover_enabled=\"off|hover\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate_linked__hover=\"off\" transform_translate__hover=\"0px|-10px\"][/et_pb_image][et_pb_blurb title=\"دوخت انواع لباس\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_blurb][/et_pb_column_inner][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" parallax__hover_enabled=\"off\" parallax_method__hover_enabled=\"on\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-10.png\" _builder_version=\"3.23\" always_center_on_mobile=\"off\" locked=\"off\"][/et_pb_image][et_pb_blurb title=\"تجهیزات مدرن خیاطی\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_blurb][/et_pb_column_inner][/et_pb_row_inner][et_pb_row_inner column_structure=\"1_2,1_2\" _builder_version=\"3.25\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" max_width__hover=\"100%\" max_width__hover_enabled=\"100%\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" parallax__hover_enabled=\"off\" parallax_method__hover_enabled=\"on\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-09.png\" _builder_version=\"3.23\" always_center_on_mobile=\"off\" locked=\"off\"][/et_pb_image][et_pb_blurb title=\"لباس مجلسی\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_blurb][/et_pb_column_inner][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" parallax__hover_enabled=\"off\" parallax_method__hover_enabled=\"on\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-06.png\" _builder_version=\"3.23\" always_center_on_mobile=\"off\" locked=\"off\"][/et_pb_image][et_pb_blurb title=\"اتو لباس\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_blurb][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Services\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_row column_structure=\"1_2,1_2\" custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#41547d\" custom_padding=\"80px|60px|80px|60px|true|true\" custom_padding_tablet=\"\" custom_padding_phone=\"60px|40px|60px|40px|true|true\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"34px\" header_2_line_height=\"1.4em\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" background_layout=\"dark\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>لباس راحت طراحی شده برای راحتی  شما</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" background_layout=\"dark\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span></p>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"فقط بهترین پارچه ها انتخاب میشوند\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-08-1.png\" icon_placement=\"left\" image_max_width=\"90px\" content_max_width=\"1100px\" image_max_width_tablet=\"\" image_max_width_phone=\"45px\" image_max_width_last_edited=\"on|phone\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" background_layout=\"dark\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز</span>.</p>\n[/et_pb_blurb][et_pb_blurb title=\"طراحی و برش با کمال دقت و زیبایی\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-06-1.png\" icon_placement=\"left\" image_max_width=\"90px\" content_max_width=\"1100px\" image_max_width_tablet=\"\" image_max_width_phone=\"45px\" image_max_width_last_edited=\"on|phone\" _builder_version=\"4.4.2\" header_font=\"Muli|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" background_layout=\"dark\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز</span></p>\n[/et_pb_blurb][et_pb_blurb title=\"ساخته شده در خیاطی ما\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-02-1.png\" icon_placement=\"left\" image_max_width=\"90px\" content_max_width=\"1100px\" image_max_width_tablet=\"\" image_max_width_phone=\"45px\" image_max_width_last_edited=\"on|phone\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" background_layout=\"dark\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز</span></p>\n[/et_pb_blurb][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" custom_padding=\"0|0px|27px|0px|false|false\" locked=\"off\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|600|||||||\" text_font_size=\"24px\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_2_font=\"||||||||\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" background_color=\"#dfab82\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-01.png\" background_position=\"bottom_right\" background_layout=\"dark\" custom_margin=\"|||0%\" custom_padding=\"50px|60px|50px|60px|true|true\" animation_direction=\"left\" link_option_url=\"#\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\" custom_padding__hover_enabled=\"on\" custom_padding__hover=\"|40px||80px||false\" background__hover_enabled=\"on\" background_color__hover=\"#ddb494\"]<p>رزرو یک وقت</p>\n[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Service\" _builder_version=\"4.4.2\" background_color=\"#f7f9fc\" hover_enabled=\"0\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/Tailor2.png\" background_size=\"initial\" background_position=\"bottom_left\" background_last_edited=\"on|tablet\" background_size_phone=\"initial\" background_position_phone=\"top_center\" background_blend_phone=\"normal\" background_enable_image_phone=\"off\"][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>آیا یک لباس مجلسی و خاص دارید که نیاز به تعمیر یا تغییرات حساس دارد؟</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span></p>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-06.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\"][/et_pb_image][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-07.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" max_width=\"70%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" border_color_all=\"#ffffff\" border_width_right=\"20px\" border_width_bottom=\"20px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][/et_pb_image][et_pb_button button_text=\"کار را به کاردان بسپارید\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"16px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"right\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"About\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" text_orientation=\"center\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>دیگر خدمات ما</h2>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" padding_top_bottom_link_1=\"true\" padding_top_bottom_link_2=\"true\" padding_top_bottom_link_3=\"true\" padding_left_right_link_1=\"true\" padding_left_right_link_2=\"true\" padding_left_right_link_3=\"true\" _builder_version=\"3.25\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"30px|30px|30px|30px\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-16.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" filter_sepia__hover=\"85%\" filter_sepia__hover_enabled=\"on|hover\"][/et_pb_image][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_3_font=\"|600|||||||\" header_3_font_size=\"20px\" header_3_line_height=\"1.4em\" header_4_font=\"Muli|700||on|||||\" header_4_text_color=\"#dfab82\" header_4_font_size=\"12px\" header_4_letter_spacing=\"2px\" header_4_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_3_font_size_tablet=\"40px\" header_3_font_size_phone=\"30px\" header_3_font_size_last_edited=\"off|desktop\" locked=\"off\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h3>کت و شلوار دامادی</h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"بیشتر بدانید\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"0px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_text_color__hover_enabled=\"off|hover\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#680000\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"30px|30px|30px|30px\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-13.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"4.4.2\" locked=\"off\" filter_sepia__hover=\"85%\" filter_sepia__hover_enabled=\"on|hover\" hover_enabled=\"0\"][/et_pb_image][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_3_font=\"|600|||||||\" header_3_font_size=\"20px\" header_3_line_height=\"1.4em\" header_4_font=\"Muli|700||on|||||\" header_4_text_color=\"#dfab82\" header_4_font_size=\"12px\" header_4_letter_spacing=\"2px\" header_4_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_3_font_size_tablet=\"40px\" header_3_font_size_phone=\"30px\" header_3_font_size_last_edited=\"off|desktop\" locked=\"off\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h3>تعمیر کیف مردانه</h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"بیشتر بدانید\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"0px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_text_color__hover_enabled=\"off|hover\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#680000\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"30px|30px|30px|30px\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-12.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"4.4.2\" hover_enabled=\"0\" locked=\"off\" filter_sepia__hover_enabled=\"on|hover\" filter_sepia__hover=\"85%\"][/et_pb_image][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_3_font=\"|600|||||||\" header_3_font_size=\"20px\" header_3_line_height=\"1.4em\" header_4_font=\"|700||on|||||\" header_4_text_color=\"#dfab82\" header_4_font_size=\"12px\" header_4_letter_spacing=\"2px\" header_4_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_3_font_size_tablet=\"40px\" header_3_font_size_phone=\"30px\" header_3_font_size_last_edited=\"off|desktop\" locked=\"off\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h3>ست لباس داماد</h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"بیشتر بدانید\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"0px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_text_color__hover_enabled=\"off|hover\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#680000\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" padding_top_bottom_link_1=\"true\" padding_top_bottom_link_2=\"true\" padding_top_bottom_link_3=\"true\" padding_left_right_link_1=\"true\" padding_left_right_link_2=\"true\" padding_left_right_link_3=\"true\" _builder_version=\"3.25\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"30px|30px|30px|30px\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-11.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" filter_sepia__hover=\"85%\" filter_sepia__hover_enabled=\"on|hover\"][/et_pb_image][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_3_font=\"|600|||||||\" header_3_font_size=\"20px\" header_3_line_height=\"1.4em\" header_4_font=\"Muli|700||on|||||\" header_4_text_color=\"#dfab82\" header_4_font_size=\"12px\" header_4_letter_spacing=\"2px\" header_4_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_3_font_size_tablet=\"40px\" header_3_font_size_phone=\"30px\" header_3_font_size_last_edited=\"off|desktop\" locked=\"off\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h3>دوخت انواع پیراهن</h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"بیشتر بدانید\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"0px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_text_color__hover_enabled=\"off|hover\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#680000\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"30px|30px|30px|30px\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-14.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\" filter_sepia__hover=\"85%\" filter_sepia__hover_enabled=\"on|hover\"][/et_pb_image][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_3_font=\"|600|||||||\" header_3_font_size=\"20px\" header_3_line_height=\"1.4em\" header_4_font=\"Muli|700||on|||||\" header_4_text_color=\"#dfab82\" header_4_font_size=\"12px\" header_4_letter_spacing=\"2px\" header_4_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_3_font_size_tablet=\"40px\" header_3_font_size_phone=\"30px\" header_3_font_size_last_edited=\"off|desktop\" locked=\"off\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h3>دوخت انواع شلوار</h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"بیشتر بدانید\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"0px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_text_color__hover_enabled=\"off|hover\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#680000\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"30px|30px|30px|30px\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-15.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\" filter_sepia__hover=\"85%\" filter_sepia__hover_enabled=\"on|hover\"][/et_pb_image][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_3_font=\"|600|||||||\" header_3_font_size=\"20px\" header_3_line_height=\"1.4em\" header_4_font=\"Muli|700||on|||||\" header_4_text_color=\"#dfab82\" header_4_font_size=\"12px\" header_4_letter_spacing=\"2px\" header_4_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_3_font_size_tablet=\"40px\" header_3_font_size_phone=\"30px\" header_3_font_size_last_edited=\"off|desktop\" locked=\"off\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h3>اتو لباس ها</h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"بیشتر بدانید\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"0px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_text_color__hover_enabled=\"off|hover\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#680000\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonials\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#f7f9fc\" background_color_gradient_end=\"#ffffff\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" inner_shadow__hover=\"off\" inner_shadow__hover_enabled=\"off\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" max_width__hover=\"100%\" max_width__hover_enabled=\"100%\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_slider _builder_version=\"4.4.2\" body_font=\"|600|on||||||\" body_font_size=\"26px\" body_line_height=\"1.8em\" background_color=\"#dfab82\" animation_style=\"flip\" body_font_size_tablet=\"20px\" body_font_size_phone=\"12px\" body_font_size_last_edited=\"on|phone\" box_shadow_style=\"preset1\" box_shadow_vertical=\"50px\" box_shadow_blur=\"60px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\"][et_pb_slide _builder_version=\"4.4.2\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>[/et_pb_slide][/et_pb_slider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#f1f6ff\" locked=\"off\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>در تماس باشید!</h2>[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>[/et_pb_text][et_pb_blurb title=\"بازدید از محل کار ما\" use_icon=\"on\" font_icon=\"%%249%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\"]<p>ایران - تهران - شهرک خیاط</p>[/et_pb_blurb][et_pb_blurb title=\"شماره تماس\" use_icon=\"on\" font_icon=\"%%264%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\"]<p>091312345678</p>[/et_pb_blurb][et_pb_blurb title=\"ایمیل ما\" use_icon=\"on\" font_icon=\"%%238%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\"]<p>info@modelsite.ir</p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_row_inner _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"60px|0px|60px|0px|true|false\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_column_inner saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_contact_form captcha=\"off\" success_message=\"پیام شما با موفقیت ارسال شد .\" submit_button_text=\"ارسال پیام\" module_id=\"et_pb_contact_form_0\" _builder_version=\"4.4.2\" form_field_background_color=\"#f5f9ff\" form_field_font=\"||||||||\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#af8447\" button_border_width=\"10px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"|40px||40px||true\" form_field_text_shadow_style=\"preset4\" box_shadow_style_button=\"preset1\" form_background_color=\"#f5f9ff\"][et_pb_contact_field field_id=\"Name\" field_title=\"نام\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Email\" field_title=\"ایمیل شما\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Phone\" field_title=\"شماره تماس\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Message\" field_title=\"پیام شما ....\" field_type=\"text\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||30px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][/et_pb_contact_form][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section]", "خدمات", "", "inherit", "closed", "closed", "", "899-revision-v1", "", "", "2020-03-31 15:30:14", "2020-03-31 12:00:14", "", "899", "http://modelsite.test/899-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2872", "1", "2020-03-31 15:33:04", "2020-03-31 12:03:04", "[et_pb_section fb_built=\"1\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(48,57,78,0.95)\" background_color_gradient_end=\"rgba(96,124,179,0.85)\" background_color_gradient_direction=\"60deg\" background_color_gradient_overlays_image=\"on\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-18.jpg\" custom_padding=\"6vw||6vw||true\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"|600|||||||\" header_font_size=\"60px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_text_color=\"#dfab82\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" text_orientation=\"center\" background_layout=\"dark\" max_width=\"800px\" module_alignment=\"center\" custom_margin=\"||40px\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h1>خدمات ما</h1>\n<h2>لباس های سفارشی و تعمیرات لباس</h2>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span></p>\n[/et_pb_text][et_pb_button button_text=\"ارتباط با ما\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" padding_top_2=\"7vw\" admin_label=\"Services\" _builder_version=\"3.22\" background_color=\"#f7f9fc\" locked=\"off\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"32px\" header_2_line_height=\"1.5em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>ما لباس ، پیراهن ، شلوار را می دوزیم و تعمیر و تغییرات را انجام میدهیم</h2>\n[/et_pb_text][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-09.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\"][/et_pb_image][et_pb_button button_text=\"گرفت نوبت آنلاین\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" padding_top__hover=\"7vw\" custom_padding__hover=\"|||\"][et_pb_row_inner column_structure=\"1_2,1_2\" _builder_version=\"3.25\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" max_width__hover=\"100%\" max_width__hover_enabled=\"100%\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" parallax__hover_enabled=\"off\" parallax_method__hover_enabled=\"on\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-04.png\" _builder_version=\"4.4.2\" hover_enabled=\"0\" always_center_on_mobile=\"off\" locked=\"off\" src__hover_enabled=\"off|hover\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate_linked__hover=\"off\" transform_translate__hover=\"0px|-10px\"][/et_pb_image][et_pb_blurb title=\"دوخت انواع لباس\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_blurb][/et_pb_column_inner][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" parallax__hover_enabled=\"off\" parallax_method__hover_enabled=\"on\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-10.png\" _builder_version=\"4.4.2\" always_center_on_mobile=\"off\" locked=\"off\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_translate_linked__hover=\"off\" transform_translate__hover=\"0px|-10px\"][/et_pb_image][et_pb_blurb title=\"تجهیزات مدرن خیاطی\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_blurb][/et_pb_column_inner][/et_pb_row_inner][et_pb_row_inner column_structure=\"1_2,1_2\" _builder_version=\"3.25\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" max_width__hover=\"100%\" max_width__hover_enabled=\"100%\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" parallax__hover_enabled=\"off\" parallax_method__hover_enabled=\"on\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-09.png\" _builder_version=\"4.4.2\" always_center_on_mobile=\"off\" locked=\"off\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|hover\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale_linked__hover=\"off\" transform_translate__hover=\"-10px|-10px\"][/et_pb_image][et_pb_blurb title=\"لباس مجلسی\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_blurb][/et_pb_column_inner][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" parallax__hover_enabled=\"off\" parallax_method__hover_enabled=\"on\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-06.png\" _builder_version=\"4.4.2\" always_center_on_mobile=\"off\" locked=\"off\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_translate_linked__hover=\"off\" transform_translate__hover=\"0px|-10px\"][/et_pb_image][et_pb_blurb title=\"اتو لباس\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_blurb][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Services\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_row column_structure=\"1_2,1_2\" custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#41547d\" custom_padding=\"80px|60px|80px|60px|true|true\" custom_padding_tablet=\"\" custom_padding_phone=\"60px|40px|60px|40px|true|true\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"34px\" header_2_line_height=\"1.4em\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" background_layout=\"dark\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>لباس راحت طراحی شده برای راحتی  شما</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" background_layout=\"dark\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span></p>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"فقط بهترین پارچه ها انتخاب میشوند\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-08-1.png\" icon_placement=\"left\" image_max_width=\"90px\" content_max_width=\"1100px\" image_max_width_tablet=\"\" image_max_width_phone=\"45px\" image_max_width_last_edited=\"on|phone\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" background_layout=\"dark\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز</span>.</p>\n[/et_pb_blurb][et_pb_blurb title=\"طراحی و برش با کمال دقت و زیبایی\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-06-1.png\" icon_placement=\"left\" image_max_width=\"90px\" content_max_width=\"1100px\" image_max_width_tablet=\"\" image_max_width_phone=\"45px\" image_max_width_last_edited=\"on|phone\" _builder_version=\"4.4.2\" header_font=\"Muli|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" background_layout=\"dark\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز</span></p>\n[/et_pb_blurb][et_pb_blurb title=\"ساخته شده در خیاطی ما\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-02-1.png\" icon_placement=\"left\" image_max_width=\"90px\" content_max_width=\"1100px\" image_max_width_tablet=\"\" image_max_width_phone=\"45px\" image_max_width_last_edited=\"on|phone\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" background_layout=\"dark\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز</span></p>\n[/et_pb_blurb][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" custom_padding=\"0|0px|27px|0px|false|false\" locked=\"off\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|600|||||||\" text_font_size=\"24px\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_2_font=\"||||||||\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" background_color=\"#dfab82\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-01.png\" background_position=\"bottom_right\" background_layout=\"dark\" custom_margin=\"|||0%\" custom_padding=\"50px|60px|50px|60px|true|true\" animation_direction=\"left\" link_option_url=\"#\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\" custom_padding__hover_enabled=\"on\" custom_padding__hover=\"|40px||80px||false\" background__hover_enabled=\"on\" background_color__hover=\"#ddb494\"]<p>رزرو یک وقت</p>\n[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Service\" _builder_version=\"4.4.2\" background_color=\"#f7f9fc\" hover_enabled=\"0\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/Tailor2.png\" background_size=\"initial\" background_position=\"bottom_left\" background_last_edited=\"on|tablet\" background_size_phone=\"initial\" background_position_phone=\"top_center\" background_blend_phone=\"normal\" background_enable_image_phone=\"off\"][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>آیا یک لباس مجلسی و خاص دارید که نیاز به تعمیر یا تغییرات حساس دارد؟</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span></p>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-06.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\"][/et_pb_image][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-07.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" max_width=\"70%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" border_color_all=\"#ffffff\" border_width_right=\"20px\" border_width_bottom=\"20px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][/et_pb_image][et_pb_button button_text=\"کار را به کاردان بسپارید\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"16px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"right\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"About\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" text_orientation=\"center\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>دیگر خدمات ما</h2>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" padding_top_bottom_link_1=\"true\" padding_top_bottom_link_2=\"true\" padding_top_bottom_link_3=\"true\" padding_left_right_link_1=\"true\" padding_left_right_link_2=\"true\" padding_left_right_link_3=\"true\" _builder_version=\"3.25\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"30px|30px|30px|30px\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-16.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" filter_sepia__hover=\"85%\" filter_sepia__hover_enabled=\"on|hover\"][/et_pb_image][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_3_font=\"|600|||||||\" header_3_font_size=\"20px\" header_3_line_height=\"1.4em\" header_4_font=\"Muli|700||on|||||\" header_4_text_color=\"#dfab82\" header_4_font_size=\"12px\" header_4_letter_spacing=\"2px\" header_4_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_3_font_size_tablet=\"40px\" header_3_font_size_phone=\"30px\" header_3_font_size_last_edited=\"off|desktop\" locked=\"off\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h3>کت و شلوار دامادی</h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"بیشتر بدانید\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"0px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_text_color__hover_enabled=\"off|hover\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#680000\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"30px|30px|30px|30px\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-13.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"4.4.2\" locked=\"off\" filter_sepia__hover=\"85%\" filter_sepia__hover_enabled=\"on|hover\" hover_enabled=\"0\"][/et_pb_image][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_3_font=\"|600|||||||\" header_3_font_size=\"20px\" header_3_line_height=\"1.4em\" header_4_font=\"Muli|700||on|||||\" header_4_text_color=\"#dfab82\" header_4_font_size=\"12px\" header_4_letter_spacing=\"2px\" header_4_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_3_font_size_tablet=\"40px\" header_3_font_size_phone=\"30px\" header_3_font_size_last_edited=\"off|desktop\" locked=\"off\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h3>تعمیر کیف مردانه</h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"بیشتر بدانید\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"0px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_text_color__hover_enabled=\"off|hover\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#680000\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"30px|30px|30px|30px\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-12.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"4.4.2\" hover_enabled=\"0\" locked=\"off\" filter_sepia__hover_enabled=\"on|hover\" filter_sepia__hover=\"85%\"][/et_pb_image][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_3_font=\"|600|||||||\" header_3_font_size=\"20px\" header_3_line_height=\"1.4em\" header_4_font=\"|700||on|||||\" header_4_text_color=\"#dfab82\" header_4_font_size=\"12px\" header_4_letter_spacing=\"2px\" header_4_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_3_font_size_tablet=\"40px\" header_3_font_size_phone=\"30px\" header_3_font_size_last_edited=\"off|desktop\" locked=\"off\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h3>ست لباس داماد</h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"بیشتر بدانید\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"0px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_text_color__hover_enabled=\"off|hover\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#680000\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" padding_top_bottom_link_1=\"true\" padding_top_bottom_link_2=\"true\" padding_top_bottom_link_3=\"true\" padding_left_right_link_1=\"true\" padding_left_right_link_2=\"true\" padding_left_right_link_3=\"true\" _builder_version=\"3.25\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"30px|30px|30px|30px\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-11.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" filter_sepia__hover=\"85%\" filter_sepia__hover_enabled=\"on|hover\"][/et_pb_image][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_3_font=\"|600|||||||\" header_3_font_size=\"20px\" header_3_line_height=\"1.4em\" header_4_font=\"Muli|700||on|||||\" header_4_text_color=\"#dfab82\" header_4_font_size=\"12px\" header_4_letter_spacing=\"2px\" header_4_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_3_font_size_tablet=\"40px\" header_3_font_size_phone=\"30px\" header_3_font_size_last_edited=\"off|desktop\" locked=\"off\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h3>دوخت انواع پیراهن</h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"بیشتر بدانید\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"0px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_text_color__hover_enabled=\"off|hover\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#680000\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"30px|30px|30px|30px\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-14.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\" filter_sepia__hover=\"85%\" filter_sepia__hover_enabled=\"on|hover\"][/et_pb_image][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_3_font=\"|600|||||||\" header_3_font_size=\"20px\" header_3_line_height=\"1.4em\" header_4_font=\"Muli|700||on|||||\" header_4_text_color=\"#dfab82\" header_4_font_size=\"12px\" header_4_letter_spacing=\"2px\" header_4_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_3_font_size_tablet=\"40px\" header_3_font_size_phone=\"30px\" header_3_font_size_last_edited=\"off|desktop\" locked=\"off\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h3>دوخت انواع شلوار</h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"بیشتر بدانید\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"0px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_text_color__hover_enabled=\"off|hover\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#680000\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"30px|30px|30px|30px\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-15.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\" filter_sepia__hover=\"85%\" filter_sepia__hover_enabled=\"on|hover\"][/et_pb_image][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_3_font=\"|600|||||||\" header_3_font_size=\"20px\" header_3_line_height=\"1.4em\" header_4_font=\"Muli|700||on|||||\" header_4_text_color=\"#dfab82\" header_4_font_size=\"12px\" header_4_letter_spacing=\"2px\" header_4_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_3_font_size_tablet=\"40px\" header_3_font_size_phone=\"30px\" header_3_font_size_last_edited=\"off|desktop\" locked=\"off\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h3>اتو لباس ها</h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"بیشتر بدانید\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"0px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_text_color__hover_enabled=\"off|hover\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#680000\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonials\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#f7f9fc\" background_color_gradient_end=\"#ffffff\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" inner_shadow__hover=\"off\" inner_shadow__hover_enabled=\"off\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" max_width__hover=\"100%\" max_width__hover_enabled=\"100%\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_slider _builder_version=\"4.4.2\" body_font=\"|600|on||||||\" body_font_size=\"26px\" body_line_height=\"1.8em\" background_color=\"#dfab82\" animation_style=\"flip\" body_font_size_tablet=\"20px\" body_font_size_phone=\"12px\" body_font_size_last_edited=\"on|phone\" box_shadow_style=\"preset1\" box_shadow_vertical=\"50px\" box_shadow_blur=\"60px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\"][et_pb_slide _builder_version=\"4.4.2\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>[/et_pb_slide][/et_pb_slider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#f1f6ff\" locked=\"off\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>در تماس باشید!</h2>[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>[/et_pb_text][et_pb_blurb title=\"بازدید از محل کار ما\" use_icon=\"on\" font_icon=\"%%249%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\"]<p>ایران - تهران - شهرک خیاط</p>[/et_pb_blurb][et_pb_blurb title=\"شماره تماس\" use_icon=\"on\" font_icon=\"%%264%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\"]<p>091312345678</p>[/et_pb_blurb][et_pb_blurb title=\"ایمیل ما\" use_icon=\"on\" font_icon=\"%%238%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\"]<p>info@modelsite.ir</p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_row_inner _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"60px|0px|60px|0px|true|false\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_column_inner saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_contact_form captcha=\"off\" success_message=\"پیام شما با موفقیت ارسال شد .\" submit_button_text=\"ارسال پیام\" module_id=\"et_pb_contact_form_0\" _builder_version=\"4.4.2\" form_field_background_color=\"#f5f9ff\" form_field_font=\"||||||||\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#af8447\" button_border_width=\"10px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"|40px||40px||true\" form_field_text_shadow_style=\"preset4\" box_shadow_style_button=\"preset1\" form_background_color=\"#f5f9ff\"][et_pb_contact_field field_id=\"Name\" field_title=\"نام\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Email\" field_title=\"ایمیل شما\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Phone\" field_title=\"شماره تماس\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Message\" field_title=\"پیام شما ....\" field_type=\"text\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||30px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][/et_pb_contact_form][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section]", "خدمات", "", "inherit", "closed", "closed", "", "899-revision-v1", "", "", "2020-03-31 15:33:04", "2020-03-31 12:03:04", "", "899", "http://modelsite.test/899-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2874", "1", "2020-03-31 15:37:54", "2020-03-31 12:07:54", "[et_pb_section fb_built=\"1\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(48,57,78,0.95)\" background_color_gradient_end=\"rgba(96,124,179,0.85)\" background_color_gradient_direction=\"60deg\" background_color_gradient_overlays_image=\"on\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-18.jpg\" custom_padding=\"6vw||6vw||true\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"|600|||||||\" header_font_size=\"60px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_text_color=\"#dfab82\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" text_orientation=\"center\" background_layout=\"dark\" max_width=\"800px\" module_alignment=\"center\" custom_margin=\"||40px\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h1>خدمات ما</h1>\n<h2>لباس های سفارشی و تعمیرات لباس</h2>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span></p>\n[/et_pb_text][et_pb_button button_text=\"ارتباط با ما\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" padding_top_2=\"7vw\" admin_label=\"Services\" _builder_version=\"3.22\" background_color=\"#f7f9fc\" locked=\"off\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"32px\" header_2_line_height=\"1.5em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>ما لباس ، پیراهن ، شلوار را می دوزیم و تعمیر و تغییرات را انجام میدهیم</h2>\n[/et_pb_text][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-09.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\"][/et_pb_image][et_pb_button button_text=\"گرفت نوبت آنلاین\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" padding_top__hover=\"7vw\" custom_padding__hover=\"|||\"][et_pb_row_inner column_structure=\"1_2,1_2\" _builder_version=\"3.25\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" max_width__hover=\"100%\" max_width__hover_enabled=\"100%\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" parallax__hover_enabled=\"off\" parallax_method__hover_enabled=\"on\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-04.png\" _builder_version=\"4.4.2\" hover_enabled=\"0\" always_center_on_mobile=\"off\" locked=\"off\" src__hover_enabled=\"off|hover\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate_linked__hover=\"off\" transform_translate__hover=\"0px|-10px\"][/et_pb_image][et_pb_blurb title=\"دوخت انواع لباس\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_blurb][/et_pb_column_inner][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" parallax__hover_enabled=\"off\" parallax_method__hover_enabled=\"on\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-10.png\" _builder_version=\"4.4.2\" always_center_on_mobile=\"off\" locked=\"off\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_translate_linked__hover=\"off\" transform_translate__hover=\"0px|-10px\"][/et_pb_image][et_pb_blurb title=\"تجهیزات مدرن خیاطی\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_blurb][/et_pb_column_inner][/et_pb_row_inner][et_pb_row_inner column_structure=\"1_2,1_2\" _builder_version=\"3.25\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" max_width__hover=\"100%\" max_width__hover_enabled=\"100%\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" parallax__hover_enabled=\"off\" parallax_method__hover_enabled=\"on\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-09.png\" _builder_version=\"4.4.2\" always_center_on_mobile=\"off\" locked=\"off\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|hover\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale_linked__hover=\"off\" transform_translate__hover=\"-10px|-10px\"][/et_pb_image][et_pb_blurb title=\"لباس مجلسی\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_blurb][/et_pb_column_inner][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" parallax__hover_enabled=\"off\" parallax_method__hover_enabled=\"on\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-06.png\" _builder_version=\"4.4.2\" always_center_on_mobile=\"off\" locked=\"off\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_translate_linked__hover=\"off\" transform_translate__hover=\"0px|-10px\"][/et_pb_image][et_pb_blurb title=\"اتو لباس\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_blurb][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Services\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_row column_structure=\"1_2,1_2\" custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#41547d\" custom_padding=\"80px|60px|80px|60px|true|true\" custom_padding_tablet=\"\" custom_padding_phone=\"60px|40px|60px|40px|true|true\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"34px\" header_2_line_height=\"1.4em\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" background_layout=\"dark\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>لباس راحت طراحی شده برای راحتی  شما</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" background_layout=\"dark\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span></p>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"فقط بهترین پارچه ها انتخاب میشوند\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-08-1.png\" icon_placement=\"left\" image_max_width=\"90px\" content_max_width=\"1100px\" image_max_width_tablet=\"\" image_max_width_phone=\"45px\" image_max_width_last_edited=\"on|phone\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" background_layout=\"dark\" hover_enabled=\"0\" locked=\"off\" icon_placement_last_edited=\"on|phone\" icon_placement_phone=\"top\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز</span>.</p>\n[/et_pb_blurb][et_pb_blurb title=\"طراحی و برش با کمال دقت و زیبایی\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-06-1.png\" icon_placement=\"left\" image_max_width=\"90px\" content_max_width=\"1100px\" image_max_width_tablet=\"\" image_max_width_phone=\"45px\" image_max_width_last_edited=\"on|phone\" _builder_version=\"4.4.2\" header_font=\"Muli|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" background_layout=\"dark\" hover_enabled=\"0\" locked=\"off\" icon_placement_last_edited=\"on|phone\" icon_placement_phone=\"top\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز</span></p>\n[/et_pb_blurb][et_pb_blurb title=\"ساخته شده در خیاطی ما\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-02-1.png\" image_max_width=\"90px\" content_max_width=\"1100px\" image_max_width_tablet=\"\" image_max_width_phone=\"45px\" image_max_width_last_edited=\"on|phone\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" background_layout=\"dark\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز</span></p>\n[/et_pb_blurb][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" custom_padding=\"0|0px|27px|0px|false|false\" locked=\"off\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|600|||||||\" text_font_size=\"24px\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_2_font=\"||||||||\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" background_color=\"#dfab82\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-01.png\" background_position=\"bottom_right\" background_layout=\"dark\" custom_margin=\"|||0%\" custom_padding=\"50px|60px|50px|60px|true|true\" animation_direction=\"left\" link_option_url=\"#\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\" custom_padding__hover_enabled=\"on\" custom_padding__hover=\"|40px||80px||false\" background__hover_enabled=\"on\" background_color__hover=\"#ddb494\"]<p>رزرو یک وقت</p>\n[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Service\" _builder_version=\"4.4.2\" background_color=\"#f7f9fc\" hover_enabled=\"0\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/Tailor2.png\" background_size=\"initial\" background_position=\"bottom_left\" background_last_edited=\"on|tablet\" background_size_phone=\"initial\" background_position_phone=\"top_center\" background_blend_phone=\"normal\" background_enable_image_phone=\"off\"][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>آیا یک لباس مجلسی و خاص دارید که نیاز به تعمیر یا تغییرات حساس دارد؟</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span></p>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-06.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\"][/et_pb_image][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-07.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" max_width=\"70%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" border_color_all=\"#ffffff\" border_width_right=\"20px\" border_width_bottom=\"20px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][/et_pb_image][et_pb_button button_text=\"کار را به کاردان بسپارید\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"16px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"right\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"About\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" text_orientation=\"center\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>دیگر خدمات ما</h2>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" padding_top_bottom_link_1=\"true\" padding_top_bottom_link_2=\"true\" padding_top_bottom_link_3=\"true\" padding_left_right_link_1=\"true\" padding_left_right_link_2=\"true\" padding_left_right_link_3=\"true\" _builder_version=\"3.25\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"30px|30px|30px|30px\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-16.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" filter_sepia__hover=\"85%\" filter_sepia__hover_enabled=\"on|hover\"][/et_pb_image][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_3_font=\"|600|||||||\" header_3_font_size=\"20px\" header_3_line_height=\"1.4em\" header_4_font=\"Muli|700||on|||||\" header_4_text_color=\"#dfab82\" header_4_font_size=\"12px\" header_4_letter_spacing=\"2px\" header_4_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_3_font_size_tablet=\"40px\" header_3_font_size_phone=\"30px\" header_3_font_size_last_edited=\"off|desktop\" locked=\"off\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h3>کت و شلوار دامادی</h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"بیشتر بدانید\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"0px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_text_color__hover_enabled=\"off|hover\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#680000\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"30px|30px|30px|30px\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-13.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"4.4.2\" locked=\"off\" filter_sepia__hover=\"85%\" filter_sepia__hover_enabled=\"on|hover\" hover_enabled=\"0\"][/et_pb_image][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_3_font=\"|600|||||||\" header_3_font_size=\"20px\" header_3_line_height=\"1.4em\" header_4_font=\"Muli|700||on|||||\" header_4_text_color=\"#dfab82\" header_4_font_size=\"12px\" header_4_letter_spacing=\"2px\" header_4_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_3_font_size_tablet=\"40px\" header_3_font_size_phone=\"30px\" header_3_font_size_last_edited=\"off|desktop\" locked=\"off\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h3>تعمیر کیف مردانه</h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"بیشتر بدانید\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"0px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_text_color__hover_enabled=\"off|hover\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#680000\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"30px|30px|30px|30px\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-12.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"4.4.2\" hover_enabled=\"0\" locked=\"off\" filter_sepia__hover_enabled=\"on|hover\" filter_sepia__hover=\"85%\"][/et_pb_image][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_3_font=\"|600|||||||\" header_3_font_size=\"20px\" header_3_line_height=\"1.4em\" header_4_font=\"|700||on|||||\" header_4_text_color=\"#dfab82\" header_4_font_size=\"12px\" header_4_letter_spacing=\"2px\" header_4_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_3_font_size_tablet=\"40px\" header_3_font_size_phone=\"30px\" header_3_font_size_last_edited=\"off|desktop\" locked=\"off\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h3>ست لباس داماد</h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"بیشتر بدانید\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"0px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_text_color__hover_enabled=\"off|hover\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#680000\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" padding_top_bottom_link_1=\"true\" padding_top_bottom_link_2=\"true\" padding_top_bottom_link_3=\"true\" padding_left_right_link_1=\"true\" padding_left_right_link_2=\"true\" padding_left_right_link_3=\"true\" _builder_version=\"3.25\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"30px|30px|30px|30px\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-11.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" filter_sepia__hover=\"85%\" filter_sepia__hover_enabled=\"on|hover\"][/et_pb_image][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_3_font=\"|600|||||||\" header_3_font_size=\"20px\" header_3_line_height=\"1.4em\" header_4_font=\"Muli|700||on|||||\" header_4_text_color=\"#dfab82\" header_4_font_size=\"12px\" header_4_letter_spacing=\"2px\" header_4_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_3_font_size_tablet=\"40px\" header_3_font_size_phone=\"30px\" header_3_font_size_last_edited=\"off|desktop\" locked=\"off\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h3>دوخت انواع پیراهن</h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"بیشتر بدانید\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"0px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_text_color__hover_enabled=\"off|hover\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#680000\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"30px|30px|30px|30px\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-14.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\" filter_sepia__hover=\"85%\" filter_sepia__hover_enabled=\"on|hover\"][/et_pb_image][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_3_font=\"|600|||||||\" header_3_font_size=\"20px\" header_3_line_height=\"1.4em\" header_4_font=\"Muli|700||on|||||\" header_4_text_color=\"#dfab82\" header_4_font_size=\"12px\" header_4_letter_spacing=\"2px\" header_4_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_3_font_size_tablet=\"40px\" header_3_font_size_phone=\"30px\" header_3_font_size_last_edited=\"off|desktop\" locked=\"off\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h3>دوخت انواع شلوار</h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"بیشتر بدانید\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"0px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_text_color__hover_enabled=\"off|hover\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#680000\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"30px|30px|30px|30px\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-15.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\" filter_sepia__hover=\"85%\" filter_sepia__hover_enabled=\"on|hover\"][/et_pb_image][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_3_font=\"|600|||||||\" header_3_font_size=\"20px\" header_3_line_height=\"1.4em\" header_4_font=\"Muli|700||on|||||\" header_4_text_color=\"#dfab82\" header_4_font_size=\"12px\" header_4_letter_spacing=\"2px\" header_4_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_3_font_size_tablet=\"40px\" header_3_font_size_phone=\"30px\" header_3_font_size_last_edited=\"off|desktop\" locked=\"off\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h3>اتو لباس ها</h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"بیشتر بدانید\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"0px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_text_color__hover_enabled=\"off|hover\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#680000\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonials\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#f7f9fc\" background_color_gradient_end=\"#ffffff\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" inner_shadow__hover=\"off\" inner_shadow__hover_enabled=\"off\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" max_width__hover=\"100%\" max_width__hover_enabled=\"100%\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_slider _builder_version=\"4.4.2\" body_font=\"|600|on||||||\" body_font_size=\"26px\" body_line_height=\"1.4em\" background_color=\"#dfab82\" animation_style=\"flip\" hover_enabled=\"0\" body_font_size_tablet=\"20px\" body_font_size_phone=\"12px\" body_font_size_last_edited=\"on|phone\" box_shadow_style=\"preset1\" box_shadow_vertical=\"50px\" box_shadow_blur=\"60px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\"][et_pb_slide _builder_version=\"4.4.2\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\" body_font=\"||on||||||\" body_font_size=\"22px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>[/et_pb_slide][/et_pb_slider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#f1f6ff\" locked=\"off\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>در تماس باشید!</h2>[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>[/et_pb_text][et_pb_blurb title=\"بازدید از محل کار ما\" use_icon=\"on\" font_icon=\"%%249%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\"]<p>ایران - تهران - شهرک خیاط</p>[/et_pb_blurb][et_pb_blurb title=\"شماره تماس\" use_icon=\"on\" font_icon=\"%%264%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\"]<p>091312345678</p>[/et_pb_blurb][et_pb_blurb title=\"ایمیل ما\" use_icon=\"on\" font_icon=\"%%238%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\"]<p>info@modelsite.ir</p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_row_inner _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"60px|0px|60px|0px|true|false\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_column_inner saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_contact_form captcha=\"off\" success_message=\"پیام شما با موفقیت ارسال شد .\" submit_button_text=\"ارسال پیام\" module_id=\"et_pb_contact_form_0\" _builder_version=\"4.4.2\" form_field_background_color=\"#f5f9ff\" form_field_font=\"||||||||\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#af8447\" button_border_width=\"10px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"|40px||40px||true\" form_field_text_shadow_style=\"preset4\" box_shadow_style_button=\"preset1\" form_background_color=\"#f5f9ff\"][et_pb_contact_field field_id=\"Name\" field_title=\"نام\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Email\" field_title=\"ایمیل شما\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Phone\" field_title=\"شماره تماس\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Message\" field_title=\"پیام شما ....\" field_type=\"text\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||30px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][/et_pb_contact_form][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section]", "خدمات", "", "inherit", "closed", "closed", "", "899-revision-v1", "", "", "2020-03-31 15:37:54", "2020-03-31 12:07:54", "", "899", "http://modelsite.test/899-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2876", "1", "2020-03-31 15:39:05", "2020-03-31 12:09:05", "[et_pb_section fb_built=\"1\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(48,57,78,0.95)\" background_color_gradient_end=\"rgba(96,124,179,0.85)\" background_color_gradient_direction=\"60deg\" background_color_gradient_overlays_image=\"on\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-18.jpg\" custom_padding=\"6vw||6vw||true\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"|600|||||||\" header_font_size=\"60px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_text_color=\"#dfab82\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" text_orientation=\"center\" background_layout=\"dark\" max_width=\"800px\" module_alignment=\"center\" custom_margin=\"||40px\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h1>خدمات ما</h1>\n<h2>لباس های سفارشی و تعمیرات لباس</h2>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span></p>\n[/et_pb_text][et_pb_button button_text=\"ارتباط با ما\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" padding_top_2=\"7vw\" admin_label=\"Services\" _builder_version=\"3.22\" background_color=\"#f7f9fc\" locked=\"off\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"32px\" header_2_line_height=\"1.5em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>ما لباس ، پیراهن ، شلوار را می دوزیم و تعمیر و تغییرات را انجام میدهیم</h2>\n[/et_pb_text][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-09.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\"][/et_pb_image][et_pb_button button_text=\"گرفت نوبت آنلاین\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" padding_top__hover=\"7vw\" custom_padding__hover=\"|||\"][et_pb_row_inner column_structure=\"1_2,1_2\" _builder_version=\"3.25\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" max_width__hover=\"100%\" max_width__hover_enabled=\"100%\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" parallax__hover_enabled=\"off\" parallax_method__hover_enabled=\"on\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-04.png\" _builder_version=\"4.4.2\" hover_enabled=\"0\" always_center_on_mobile=\"off\" locked=\"off\" src__hover_enabled=\"off|hover\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate_linked__hover=\"off\" transform_translate__hover=\"0px|-10px\"][/et_pb_image][et_pb_blurb title=\"دوخت انواع لباس\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_blurb][/et_pb_column_inner][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" parallax__hover_enabled=\"off\" parallax_method__hover_enabled=\"on\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-10.png\" _builder_version=\"4.4.2\" always_center_on_mobile=\"off\" locked=\"off\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_translate_linked__hover=\"off\" transform_translate__hover=\"0px|-10px\"][/et_pb_image][et_pb_blurb title=\"تجهیزات مدرن خیاطی\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_blurb][/et_pb_column_inner][/et_pb_row_inner][et_pb_row_inner column_structure=\"1_2,1_2\" _builder_version=\"3.25\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" max_width__hover=\"100%\" max_width__hover_enabled=\"100%\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" parallax__hover_enabled=\"off\" parallax_method__hover_enabled=\"on\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-09.png\" _builder_version=\"4.4.2\" always_center_on_mobile=\"off\" locked=\"off\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|hover\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale_linked__hover=\"off\" transform_translate__hover=\"-10px|-10px\"][/et_pb_image][et_pb_blurb title=\"لباس مجلسی\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_blurb][/et_pb_column_inner][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" parallax__hover_enabled=\"off\" parallax_method__hover_enabled=\"on\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-06.png\" _builder_version=\"4.4.2\" always_center_on_mobile=\"off\" locked=\"off\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_translate_linked__hover=\"off\" transform_translate__hover=\"0px|-10px\"][/et_pb_image][et_pb_blurb title=\"اتو لباس\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_blurb][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Services\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_row column_structure=\"1_2,1_2\" custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#41547d\" custom_padding=\"80px|60px|80px|60px|true|true\" custom_padding_tablet=\"\" custom_padding_phone=\"60px|40px|60px|40px|true|true\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"34px\" header_2_line_height=\"1.4em\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" background_layout=\"dark\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>لباس راحت طراحی شده برای راحتی  شما</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" background_layout=\"dark\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span></p>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"فقط بهترین پارچه ها انتخاب میشوند\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-08-1.png\" icon_placement=\"left\" image_max_width=\"90px\" content_max_width=\"1100px\" image_max_width_tablet=\"\" image_max_width_phone=\"45px\" image_max_width_last_edited=\"on|phone\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" background_layout=\"dark\" hover_enabled=\"0\" locked=\"off\" icon_placement_last_edited=\"on|phone\" icon_placement_phone=\"top\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز</span>.</p>\n[/et_pb_blurb][et_pb_blurb title=\"طراحی و برش با کمال دقت و زیبایی\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-06-1.png\" icon_placement=\"left\" image_max_width=\"90px\" content_max_width=\"1100px\" image_max_width_tablet=\"\" image_max_width_phone=\"45px\" image_max_width_last_edited=\"on|phone\" _builder_version=\"4.4.2\" header_font=\"Muli|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" background_layout=\"dark\" hover_enabled=\"0\" locked=\"off\" icon_placement_last_edited=\"on|phone\" icon_placement_phone=\"top\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز</span></p>\n[/et_pb_blurb][et_pb_blurb title=\"ساخته شده در خیاطی ما\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-02-1.png\" image_max_width=\"90px\" content_max_width=\"1100px\" image_max_width_tablet=\"\" image_max_width_phone=\"45px\" image_max_width_last_edited=\"on|phone\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" background_layout=\"dark\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز</span></p>\n[/et_pb_blurb][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" custom_padding=\"0|0px|27px|0px|false|false\" locked=\"off\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|600|||||||\" text_font_size=\"24px\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_2_font=\"||||||||\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" background_color=\"#dfab82\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-01.png\" background_position=\"bottom_right\" background_layout=\"dark\" custom_margin=\"|||0%\" custom_padding=\"50px|60px|50px|60px|true|true\" animation_direction=\"left\" link_option_url=\"#\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\" custom_padding__hover_enabled=\"on\" custom_padding__hover=\"|40px||80px||false\" background__hover_enabled=\"on\" background_color__hover=\"#ddb494\"]<p>رزرو یک وقت</p>\n[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Service\" _builder_version=\"4.4.2\" background_color=\"#f7f9fc\" hover_enabled=\"0\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/Tailor2.png\" background_size=\"initial\" background_position=\"bottom_left\" background_last_edited=\"on|tablet\" background_size_phone=\"initial\" background_position_phone=\"top_center\" background_blend_phone=\"normal\" background_enable_image_phone=\"off\"][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>آیا یک لباس مجلسی و خاص دارید که نیاز به تعمیر یا تغییرات حساس دارد؟</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span></p>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-06.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\"][/et_pb_image][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-07.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" max_width=\"70%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" border_color_all=\"#ffffff\" border_width_right=\"20px\" border_width_bottom=\"20px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][/et_pb_image][et_pb_button button_text=\"کار را به کاردان بسپارید\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"16px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"right\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"About\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" text_orientation=\"center\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>دیگر خدمات ما</h2>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" padding_top_bottom_link_1=\"true\" padding_top_bottom_link_2=\"true\" padding_top_bottom_link_3=\"true\" padding_left_right_link_1=\"true\" padding_left_right_link_2=\"true\" padding_left_right_link_3=\"true\" _builder_version=\"3.25\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"30px|30px|30px|30px\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-16.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" filter_sepia__hover=\"85%\" filter_sepia__hover_enabled=\"on|hover\"][/et_pb_image][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_3_font=\"|600|||||||\" header_3_font_size=\"20px\" header_3_line_height=\"1.4em\" header_4_font=\"Muli|700||on|||||\" header_4_text_color=\"#dfab82\" header_4_font_size=\"12px\" header_4_letter_spacing=\"2px\" header_4_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_3_font_size_tablet=\"40px\" header_3_font_size_phone=\"30px\" header_3_font_size_last_edited=\"off|desktop\" locked=\"off\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h3>کت و شلوار دامادی</h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"بیشتر بدانید\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"0px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_text_color__hover_enabled=\"off|hover\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#680000\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"30px|30px|30px|30px\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-13.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"4.4.2\" locked=\"off\" filter_sepia__hover=\"85%\" filter_sepia__hover_enabled=\"on|hover\" hover_enabled=\"0\"][/et_pb_image][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_3_font=\"|600|||||||\" header_3_font_size=\"20px\" header_3_line_height=\"1.4em\" header_4_font=\"Muli|700||on|||||\" header_4_text_color=\"#dfab82\" header_4_font_size=\"12px\" header_4_letter_spacing=\"2px\" header_4_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_3_font_size_tablet=\"40px\" header_3_font_size_phone=\"30px\" header_3_font_size_last_edited=\"off|desktop\" locked=\"off\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h3>تعمیر کیف مردانه</h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"بیشتر بدانید\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"0px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_text_color__hover_enabled=\"off|hover\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#680000\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"30px|30px|30px|30px\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-12.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"4.4.2\" hover_enabled=\"0\" locked=\"off\" filter_sepia__hover_enabled=\"on|hover\" filter_sepia__hover=\"85%\"][/et_pb_image][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_3_font=\"|600|||||||\" header_3_font_size=\"20px\" header_3_line_height=\"1.4em\" header_4_font=\"|700||on|||||\" header_4_text_color=\"#dfab82\" header_4_font_size=\"12px\" header_4_letter_spacing=\"2px\" header_4_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_3_font_size_tablet=\"40px\" header_3_font_size_phone=\"30px\" header_3_font_size_last_edited=\"off|desktop\" locked=\"off\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h3>ست لباس داماد</h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"بیشتر بدانید\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"0px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_text_color__hover_enabled=\"off|hover\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#680000\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" padding_top_bottom_link_1=\"true\" padding_top_bottom_link_2=\"true\" padding_top_bottom_link_3=\"true\" padding_left_right_link_1=\"true\" padding_left_right_link_2=\"true\" padding_left_right_link_3=\"true\" _builder_version=\"3.25\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"30px|30px|30px|30px\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-11.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" filter_sepia__hover=\"85%\" filter_sepia__hover_enabled=\"on|hover\"][/et_pb_image][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_3_font=\"|600|||||||\" header_3_font_size=\"20px\" header_3_line_height=\"1.4em\" header_4_font=\"Muli|700||on|||||\" header_4_text_color=\"#dfab82\" header_4_font_size=\"12px\" header_4_letter_spacing=\"2px\" header_4_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_3_font_size_tablet=\"40px\" header_3_font_size_phone=\"30px\" header_3_font_size_last_edited=\"off|desktop\" locked=\"off\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h3>دوخت انواع پیراهن</h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"بیشتر بدانید\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"0px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_text_color__hover_enabled=\"off|hover\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#680000\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"30px|30px|30px|30px\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-14.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\" filter_sepia__hover=\"85%\" filter_sepia__hover_enabled=\"on|hover\"][/et_pb_image][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_3_font=\"|600|||||||\" header_3_font_size=\"20px\" header_3_line_height=\"1.4em\" header_4_font=\"Muli|700||on|||||\" header_4_text_color=\"#dfab82\" header_4_font_size=\"12px\" header_4_letter_spacing=\"2px\" header_4_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_3_font_size_tablet=\"40px\" header_3_font_size_phone=\"30px\" header_3_font_size_last_edited=\"off|desktop\" locked=\"off\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h3>دوخت انواع شلوار</h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"بیشتر بدانید\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"0px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_text_color__hover_enabled=\"off|hover\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#680000\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"30px|30px|30px|30px\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-15.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\" filter_sepia__hover=\"85%\" filter_sepia__hover_enabled=\"on|hover\"][/et_pb_image][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_3_font=\"|600|||||||\" header_3_font_size=\"20px\" header_3_line_height=\"1.4em\" header_4_font=\"Muli|700||on|||||\" header_4_text_color=\"#dfab82\" header_4_font_size=\"12px\" header_4_letter_spacing=\"2px\" header_4_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_3_font_size_tablet=\"40px\" header_3_font_size_phone=\"30px\" header_3_font_size_last_edited=\"off|desktop\" locked=\"off\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h3>اتو لباس ها</h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"بیشتر بدانید\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"0px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_text_color__hover_enabled=\"off|hover\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#680000\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonials\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#f7f9fc\" background_color_gradient_end=\"#ffffff\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" inner_shadow__hover=\"off\" inner_shadow__hover_enabled=\"off\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" max_width__hover=\"100%\" max_width__hover_enabled=\"100%\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_slider _builder_version=\"4.4.2\" locked=\"off\" hover_enabled=\"0\"][et_pb_slide _builder_version=\"4.4.2\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>[/et_pb_slide][/et_pb_slider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#f1f6ff\" locked=\"off\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>در تماس باشید!</h2>[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>[/et_pb_text][et_pb_blurb title=\"بازدید از محل کار ما\" use_icon=\"on\" font_icon=\"%%249%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\"]<p>ایران - تهران - شهرک خیاط</p>[/et_pb_blurb][et_pb_blurb title=\"شماره تماس\" use_icon=\"on\" font_icon=\"%%264%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\"]<p>091312345678</p>[/et_pb_blurb][et_pb_blurb title=\"ایمیل ما\" use_icon=\"on\" font_icon=\"%%238%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\"]<p>info@modelsite.ir</p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_row_inner _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"60px|0px|60px|0px|true|false\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_column_inner saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_contact_form captcha=\"off\" success_message=\"پیام شما با موفقیت ارسال شد .\" submit_button_text=\"ارسال پیام\" module_id=\"et_pb_contact_form_0\" _builder_version=\"4.4.2\" form_field_background_color=\"#f5f9ff\" form_field_font=\"||||||||\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#af8447\" button_border_width=\"10px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"|40px||40px||true\" form_field_text_shadow_style=\"preset4\" box_shadow_style_button=\"preset1\" form_background_color=\"#f5f9ff\"][et_pb_contact_field field_id=\"Name\" field_title=\"نام\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Email\" field_title=\"ایمیل شما\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Phone\" field_title=\"شماره تماس\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Message\" field_title=\"پیام شما ....\" field_type=\"text\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||30px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][/et_pb_contact_form][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section]", "خدمات", "", "inherit", "closed", "closed", "", "899-revision-v1", "", "", "2020-03-31 15:39:05", "2020-03-31 12:09:05", "", "899", "http://modelsite.test/899-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2879", "1", "2020-03-31 15:42:11", "2020-03-31 12:12:11", "[et_pb_section fb_built=\"1\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(48,57,78,0.95)\" background_color_gradient_end=\"rgba(96,124,179,0.85)\" background_color_gradient_direction=\"60deg\" background_color_gradient_overlays_image=\"on\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-18.jpg\" custom_padding=\"6vw||6vw||true\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"|600|||||||\" header_font_size=\"60px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_text_color=\"#dfab82\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" text_orientation=\"center\" background_layout=\"dark\" max_width=\"800px\" module_alignment=\"center\" custom_margin=\"||40px\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h1>خدمات ما</h1>\n<h2>لباس های سفارشی و تعمیرات لباس</h2>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span></p>\n[/et_pb_text][et_pb_button button_text=\"ارتباط با ما\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" padding_top_2=\"7vw\" admin_label=\"Services\" _builder_version=\"3.22\" background_color=\"#f7f9fc\" locked=\"off\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"32px\" header_2_line_height=\"1.5em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>ما لباس ، پیراهن ، شلوار را می دوزیم و تعمیر و تغییرات را انجام میدهیم</h2>\n[/et_pb_text][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-09.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\"][/et_pb_image][et_pb_button button_text=\"گرفت نوبت آنلاین\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" padding_top__hover=\"7vw\" custom_padding__hover=\"|||\"][et_pb_row_inner column_structure=\"1_2,1_2\" _builder_version=\"3.25\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" max_width__hover=\"100%\" max_width__hover_enabled=\"100%\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" parallax__hover_enabled=\"off\" parallax_method__hover_enabled=\"on\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-04.png\" _builder_version=\"4.4.2\" hover_enabled=\"0\" always_center_on_mobile=\"off\" locked=\"off\" src__hover_enabled=\"off|hover\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate_linked__hover=\"off\" transform_translate__hover=\"0px|-10px\"][/et_pb_image][et_pb_blurb title=\"دوخت انواع لباس\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_blurb][/et_pb_column_inner][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" parallax__hover_enabled=\"off\" parallax_method__hover_enabled=\"on\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-10.png\" _builder_version=\"4.4.2\" always_center_on_mobile=\"off\" locked=\"off\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_translate_linked__hover=\"off\" transform_translate__hover=\"0px|-10px\"][/et_pb_image][et_pb_blurb title=\"تجهیزات مدرن خیاطی\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_blurb][/et_pb_column_inner][/et_pb_row_inner][et_pb_row_inner column_structure=\"1_2,1_2\" _builder_version=\"3.25\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" max_width__hover=\"100%\" max_width__hover_enabled=\"100%\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" parallax__hover_enabled=\"off\" parallax_method__hover_enabled=\"on\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-09.png\" _builder_version=\"4.4.2\" always_center_on_mobile=\"off\" locked=\"off\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|hover\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_scale_linked__hover=\"off\" transform_translate__hover=\"-10px|-10px\"][/et_pb_image][et_pb_blurb title=\"لباس مجلسی\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_blurb][/et_pb_column_inner][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" parallax__hover_enabled=\"off\" parallax_method__hover_enabled=\"on\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-06.png\" _builder_version=\"4.4.2\" always_center_on_mobile=\"off\" locked=\"off\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" hover_enabled=\"0\" transform_translate_linked__hover=\"off\" transform_translate__hover=\"0px|-10px\"][/et_pb_image][et_pb_blurb title=\"اتو لباس\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_blurb][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Services\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_row column_structure=\"1_2,1_2\" custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#41547d\" custom_padding=\"80px|60px|80px|60px|true|true\" custom_padding_tablet=\"\" custom_padding_phone=\"60px|40px|60px|40px|true|true\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"34px\" header_2_line_height=\"1.4em\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" background_layout=\"dark\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>لباس راحت طراحی شده برای راحتی  شما</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" background_layout=\"dark\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span></p>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"فقط بهترین پارچه ها انتخاب میشوند\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-08-1.png\" icon_placement=\"left\" image_max_width=\"90px\" content_max_width=\"1100px\" image_max_width_tablet=\"\" image_max_width_phone=\"45px\" image_max_width_last_edited=\"on|phone\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" background_layout=\"dark\" hover_enabled=\"0\" locked=\"off\" icon_placement_last_edited=\"on|phone\" icon_placement_phone=\"top\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز</span>.</p>\n[/et_pb_blurb][et_pb_blurb title=\"طراحی و برش با کمال دقت و زیبایی\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-06-1.png\" icon_placement=\"left\" image_max_width=\"90px\" content_max_width=\"1100px\" image_max_width_tablet=\"\" image_max_width_phone=\"45px\" image_max_width_last_edited=\"on|phone\" _builder_version=\"4.4.2\" header_font=\"Muli|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" background_layout=\"dark\" hover_enabled=\"0\" locked=\"off\" icon_placement_last_edited=\"on|phone\" icon_placement_phone=\"top\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز</span></p>\n[/et_pb_blurb][et_pb_blurb title=\"ساخته شده در خیاطی ما\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-02-1.png\" icon_placement=\"right\" image_max_width=\"90px\" content_max_width=\"1100px\" image_max_width_tablet=\"\" image_max_width_phone=\"45px\" image_max_width_last_edited=\"on|phone\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" background_layout=\"dark\" hover_enabled=\"0\" locked=\"off\" icon_placement_last_edited=\"on|phone\" icon_placement_phone=\"top\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز</span></p>\n[/et_pb_blurb][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" custom_padding=\"0|0px|27px|0px|false|false\" locked=\"off\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|600|||||||\" text_font_size=\"24px\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_2_font=\"||||||||\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" background_color=\"#dfab82\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-01.png\" background_position=\"bottom_right\" background_layout=\"dark\" custom_margin=\"|||0%\" custom_padding=\"50px|60px|50px|60px|true|true\" animation_direction=\"left\" link_option_url=\"#\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\" custom_padding__hover_enabled=\"on\" custom_padding__hover=\"|40px||80px||false\" background__hover_enabled=\"on\" background_color__hover=\"#ddb494\"]<p>رزرو یک وقت</p>\n[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Service\" _builder_version=\"4.4.2\" background_color=\"#f7f9fc\" hover_enabled=\"0\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/Tailor2.png\" background_size=\"initial\" background_position=\"bottom_left\" background_last_edited=\"on|tablet\" background_size_phone=\"initial\" background_position_phone=\"top_center\" background_blend_phone=\"normal\" background_enable_image_phone=\"off\"][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>آیا یک لباس مجلسی و خاص دارید که نیاز به تعمیر یا تغییرات حساس دارد؟</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span></p>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-06.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\"][/et_pb_image][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-07.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" max_width=\"70%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" border_color_all=\"#ffffff\" border_width_right=\"20px\" border_width_bottom=\"20px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][/et_pb_image][et_pb_button button_text=\"کار را به کاردان بسپارید\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"16px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"right\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"About\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" text_orientation=\"center\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>دیگر خدمات ما</h2>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" padding_top_bottom_link_1=\"true\" padding_top_bottom_link_2=\"true\" padding_top_bottom_link_3=\"true\" padding_left_right_link_1=\"true\" padding_left_right_link_2=\"true\" padding_left_right_link_3=\"true\" _builder_version=\"3.25\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"30px|30px|30px|30px\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-16.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" filter_sepia__hover=\"85%\" filter_sepia__hover_enabled=\"on|hover\"][/et_pb_image][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_3_font=\"|600|||||||\" header_3_font_size=\"20px\" header_3_line_height=\"1.4em\" header_4_font=\"Muli|700||on|||||\" header_4_text_color=\"#dfab82\" header_4_font_size=\"12px\" header_4_letter_spacing=\"2px\" header_4_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_3_font_size_tablet=\"40px\" header_3_font_size_phone=\"30px\" header_3_font_size_last_edited=\"off|desktop\" locked=\"off\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h3>کت و شلوار دامادی</h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"بیشتر بدانید\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"0px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_text_color__hover_enabled=\"off|hover\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#680000\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"30px|30px|30px|30px\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-13.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"4.4.2\" locked=\"off\" filter_sepia__hover=\"85%\" filter_sepia__hover_enabled=\"on|hover\" hover_enabled=\"0\"][/et_pb_image][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_3_font=\"|600|||||||\" header_3_font_size=\"20px\" header_3_line_height=\"1.4em\" header_4_font=\"Muli|700||on|||||\" header_4_text_color=\"#dfab82\" header_4_font_size=\"12px\" header_4_letter_spacing=\"2px\" header_4_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_3_font_size_tablet=\"40px\" header_3_font_size_phone=\"30px\" header_3_font_size_last_edited=\"off|desktop\" locked=\"off\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h3>تعمیر کیف مردانه</h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"بیشتر بدانید\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"0px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_text_color__hover_enabled=\"off|hover\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#680000\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"30px|30px|30px|30px\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-12.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"4.4.2\" hover_enabled=\"0\" locked=\"off\" filter_sepia__hover_enabled=\"on|hover\" filter_sepia__hover=\"85%\"][/et_pb_image][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_3_font=\"|600|||||||\" header_3_font_size=\"20px\" header_3_line_height=\"1.4em\" header_4_font=\"|700||on|||||\" header_4_text_color=\"#dfab82\" header_4_font_size=\"12px\" header_4_letter_spacing=\"2px\" header_4_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_3_font_size_tablet=\"40px\" header_3_font_size_phone=\"30px\" header_3_font_size_last_edited=\"off|desktop\" locked=\"off\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h3>ست لباس داماد</h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"بیشتر بدانید\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"0px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_text_color__hover_enabled=\"off|hover\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#680000\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" padding_top_bottom_link_1=\"true\" padding_top_bottom_link_2=\"true\" padding_top_bottom_link_3=\"true\" padding_left_right_link_1=\"true\" padding_left_right_link_2=\"true\" padding_left_right_link_3=\"true\" _builder_version=\"3.25\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"30px|30px|30px|30px\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-11.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" filter_sepia__hover=\"85%\" filter_sepia__hover_enabled=\"on|hover\"][/et_pb_image][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_3_font=\"|600|||||||\" header_3_font_size=\"20px\" header_3_line_height=\"1.4em\" header_4_font=\"Muli|700||on|||||\" header_4_text_color=\"#dfab82\" header_4_font_size=\"12px\" header_4_letter_spacing=\"2px\" header_4_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_3_font_size_tablet=\"40px\" header_3_font_size_phone=\"30px\" header_3_font_size_last_edited=\"off|desktop\" locked=\"off\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h3>دوخت انواع پیراهن</h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"بیشتر بدانید\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"0px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_text_color__hover_enabled=\"off|hover\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#680000\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"30px|30px|30px|30px\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-14.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\" filter_sepia__hover=\"85%\" filter_sepia__hover_enabled=\"on|hover\"][/et_pb_image][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_3_font=\"|600|||||||\" header_3_font_size=\"20px\" header_3_line_height=\"1.4em\" header_4_font=\"Muli|700||on|||||\" header_4_text_color=\"#dfab82\" header_4_font_size=\"12px\" header_4_letter_spacing=\"2px\" header_4_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_3_font_size_tablet=\"40px\" header_3_font_size_phone=\"30px\" header_3_font_size_last_edited=\"off|desktop\" locked=\"off\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h3>دوخت انواع شلوار</h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"بیشتر بدانید\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"0px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_text_color__hover_enabled=\"off|hover\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#680000\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"30px|30px|30px|30px\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-15.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\" filter_sepia__hover=\"85%\" filter_sepia__hover_enabled=\"on|hover\"][/et_pb_image][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_3_font=\"|600|||||||\" header_3_font_size=\"20px\" header_3_line_height=\"1.4em\" header_4_font=\"Muli|700||on|||||\" header_4_text_color=\"#dfab82\" header_4_font_size=\"12px\" header_4_letter_spacing=\"2px\" header_4_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_3_font_size_tablet=\"40px\" header_3_font_size_phone=\"30px\" header_3_font_size_last_edited=\"off|desktop\" locked=\"off\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h3>اتو لباس ها</h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"بیشتر بدانید\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"0px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_text_color__hover_enabled=\"off|hover\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#680000\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonials\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#f7f9fc\" background_color_gradient_end=\"#ffffff\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" inner_shadow__hover=\"off\" inner_shadow__hover_enabled=\"off\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" max_width__hover=\"100%\" max_width__hover_enabled=\"100%\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_slider _builder_version=\"4.4.2\" locked=\"off\" hover_enabled=\"0\"][et_pb_slide _builder_version=\"4.4.2\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>[/et_pb_slide][/et_pb_slider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#f1f6ff\" locked=\"off\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>در تماس باشید!</h2>[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>[/et_pb_text][et_pb_blurb title=\"بازدید از محل کار ما\" use_icon=\"on\" font_icon=\"%%249%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\"]<p>ایران - تهران - شهرک خیاط</p>[/et_pb_blurb][et_pb_blurb title=\"شماره تماس\" use_icon=\"on\" font_icon=\"%%264%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\"]<p>091312345678</p>[/et_pb_blurb][et_pb_blurb title=\"ایمیل ما\" use_icon=\"on\" font_icon=\"%%238%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\"]<p>info@modelsite.ir</p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_row_inner _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"60px|0px|60px|0px|true|false\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_column_inner saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_contact_form captcha=\"off\" success_message=\"پیام شما با موفقیت ارسال شد .\" submit_button_text=\"ارسال پیام\" module_id=\"et_pb_contact_form_0\" _builder_version=\"4.4.2\" form_field_background_color=\"#f5f9ff\" form_field_font=\"||||||||\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#af8447\" button_border_width=\"10px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"|40px||40px||true\" form_field_text_shadow_style=\"preset4\" box_shadow_style_button=\"preset1\" form_background_color=\"#f5f9ff\"][et_pb_contact_field field_id=\"Name\" field_title=\"نام\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Email\" field_title=\"ایمیل شما\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Phone\" field_title=\"شماره تماس\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Message\" field_title=\"پیام شما ....\" field_type=\"text\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||30px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][/et_pb_contact_form][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section]", "خدمات", "", "inherit", "closed", "closed", "", "899-revision-v1", "", "", "2020-03-31 15:42:11", "2020-03-31 12:12:11", "", "899", "http://modelsite.test/899-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2881", "1", "2020-03-31 15:42:51", "2020-03-31 12:12:51", "[et_pb_section fb_built=\"1\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(48,57,78,0.95)\" background_color_gradient_end=\"rgba(96,124,179,0.85)\" background_color_gradient_direction=\"60deg\" background_color_gradient_overlays_image=\"on\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-17.jpg\" custom_padding=\"6vw||6vw||true\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"|600|||||||\" header_font_size=\"60px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_text_color=\"#dfab82\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" text_orientation=\"center\" background_layout=\"dark\" max_width=\"800px\" module_alignment=\"center\" custom_margin=\"||40px\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h1>درباره ما</h1>\n<h2>خیاطی 5 ستاره ما</h2>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span></p>\n[/et_pb_text][et_pb_button button_text=\"تماس با ما و رزرو وقت\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"About\" _builder_version=\"3.22\"][et_pb_row column_structure=\"1_3,1_3,1_3\" _builder_version=\"3.25\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span></p>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span></p>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>با بیش از سه قرن تجربه ، تاسیس در سال 1370</h2>\n[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Process\" _builder_version=\"3.22\"][et_pb_row column_structure=\"1_2,1_2\" custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#41547d\" custom_padding=\"80px|60px|80px|60px|true|true\" custom_padding_tablet=\"\" custom_padding_phone=\"60px|40px|60px|40px|true|true\" locked=\"off\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"34px\" header_2_line_height=\"1.4em\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" background_layout=\"dark\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>لباس راحت طراحی شده برای راحتی  شما</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" background_layout=\"dark\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span></p>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"فقط بهترین پارچه ها انتخاب میشوند\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-08-1.png\" icon_placement=\"left\" image_max_width=\"90px\" content_max_width=\"1100px\" image_max_width_tablet=\"\" image_max_width_phone=\"45px\" image_max_width_last_edited=\"on|phone\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" background_layout=\"dark\" hover_enabled=\"0\" locked=\"off\" icon_placement_last_edited=\"on|phone\" icon_placement_phone=\"top\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز</span>.</p>\n[/et_pb_blurb][et_pb_blurb title=\"طراحی و برش با کمال دقت و زیبایی\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-06-1.png\" icon_placement=\"left\" image_max_width=\"90px\" content_max_width=\"1100px\" image_max_width_tablet=\"\" image_max_width_phone=\"45px\" image_max_width_last_edited=\"on|phone\" _builder_version=\"4.4.2\" header_font=\"Muli|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" background_layout=\"dark\" hover_enabled=\"0\" locked=\"off\" icon_placement_last_edited=\"on|phone\" icon_placement_phone=\"top\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز</span></p>\n[/et_pb_blurb][et_pb_blurb title=\"ساخته شده در خیاطی ما\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-02-1.png\" icon_placement=\"right\" image_max_width=\"90px\" content_max_width=\"1100px\" image_max_width_tablet=\"\" image_max_width_phone=\"45px\" image_max_width_last_edited=\"on|phone\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" background_layout=\"dark\" hover_enabled=\"0\" locked=\"off\" icon_placement_last_edited=\"on|phone\" icon_placement_phone=\"top\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز</span></p>\n[/et_pb_blurb][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" custom_padding=\"0|0px|27px|0px|false|false\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|600|||||||\" text_font_size=\"24px\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_2_font=\"||||||||\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" background_color=\"#dfab82\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-01.png\" background_position=\"bottom_right\" background_layout=\"dark\" custom_margin=\"|||0%\" custom_padding=\"50px|60px|50px|60px|true|true\" animation_direction=\"left\" link_option_url=\"#\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\" custom_padding__hover_enabled=\"on\" custom_padding__hover=\"|40px||80px||false\" background__hover_enabled=\"on\" background_color__hover=\"#ddb494\"]<p>رزرو یک وقت</p>\n[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" use_custom_gutter=\"on\" gutter_width=\"1\" admin_label=\"Video\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#f7f9fc\" background_color_gradient_start_position=\"75%\" background_color_gradient_end_position=\"75%\" custom_padding=\"0|0px|0|0px|false|false\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_video src=\"#\" image_src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-05.jpg\" play_icon_color=\"#607CB3\" _builder_version=\"4.4.2\" hover_enabled=\"0\"][/et_pb_video][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" disabled_on=\"off|off|off\" admin_label=\"Gallery\" _builder_version=\"4.4.2\" background_color=\"#f7f9fc\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#f7f9fc\" background_color_gradient_end=\"#ffffff\" locked=\"off\"][et_pb_row column_structure=\"1_4,1_4,1_2\" _builder_version=\"3.25\"][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-08.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"4.4.2\" custom_margin=\"|||-7vw|false|false\" custom_margin_tablet=\"|||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|phone\" locked=\"off\"][/et_pb_image][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/crypto_image_03.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" border_color_all=\"#ffffff\" border_width_bottom=\"20px\" border_width_left=\"20px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-10.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"6vw||\" custom_margin_tablet=\"\" custom_margin_phone=\"0vw||\" custom_margin_last_edited=\"on|desktop\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>چند نمونه کار اخیر ما</h2>[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>[/et_pb_text][et_pb_button button_text=\"مشاهده سایر نمونه کارها\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"left\" custom_padding=\"27px|0px|0|0px|false|false\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\" locked=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Team\" _builder_version=\"3.22\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>با خیاطان ما آشنا شوید</h2>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/portrait-04.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"4.4.2\" hover_enabled=\"0\" animation_style=\"bounce\"][/et_pb_image][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_3_font=\"|600|||||||\" header_3_font_size=\"30px\" header_3_line_height=\"1.4em\" header_4_font=\"|700||on|||||\" header_4_text_color=\"#dfab82\" header_4_font_size=\"12px\" header_4_letter_spacing=\"2px\" header_4_line_height=\"2em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_3_font_size_tablet=\"40px\" header_3_font_size_phone=\"30px\" header_3_font_size_last_edited=\"off|desktop\" locked=\"off\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h3>جان</h3>\n<h4>چرخ کار</h4>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span></p>\n[/et_pb_text][et_pb_counters bar_bg_color=\"#607cb3\" use_percentages=\"off\" _builder_version=\"4.4.2\" title_font=\"|700||on|||||\" title_text_color=\"#41547d\" title_font_size=\"16px\" title_line_height=\"2em\" percent_font=\"||||||||\" background_color=\"#f1f6ff\" hover_enabled=\"0\"][et_pb_counter percent=\"80\" _builder_version=\"4.4.2\" hover_enabled=\"0\" background_color_default=\"#f1f6ff\" background_enable_color_default=\"on\" parallax_default=\"off\" parallax_method_default=\"on\" bar_background_color_default=\"#607cb3\" use_percentages=\"off\" allow_player_pause_default=\"off\"]\n\nدوخت کت مردانه\n\n[/et_pb_counter][et_pb_counter percent=\"60\" _builder_version=\"4.4.2\" hover_enabled=\"0\" background_color_default=\"#f1f6ff\" background_enable_color_default=\"on\" parallax_default=\"off\" parallax_method_default=\"on\" bar_background_color_default=\"#607cb3\" use_percentages=\"off\" allow_player_pause_default=\"off\"]\n\nدوخت شلوار مردانه\n\n[/et_pb_counter][et_pb_counter percent=\"50\" _builder_version=\"4.4.2\" hover_enabled=\"0\" background_color_default=\"#f1f6ff\" background_enable_color_default=\"on\" parallax_default=\"off\" parallax_method_default=\"on\" bar_background_color_default=\"#607cb3\" use_percentages=\"off\" allow_player_pause_default=\"off\"]\n\nدوخت پیراهن مردانه\n\n[/et_pb_counter][/et_pb_counters][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/crypto_image_03.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"4.4.2\" hover_enabled=\"0\" animation_style=\"bounce\"][/et_pb_image][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_3_font=\"|600|||||||\" header_3_font_size=\"30px\" header_3_line_height=\"1.4em\" header_4_font=\"|700||on|||||\" header_4_text_color=\"#dfab82\" header_4_font_size=\"12px\" header_4_letter_spacing=\"2px\" header_4_line_height=\"2em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_3_font_size_tablet=\"40px\" header_3_font_size_phone=\"30px\" header_3_font_size_last_edited=\"off|desktop\" locked=\"off\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h3>جک</h3>\n<h4>طراح مد</h4>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span></p>\n[/et_pb_text][et_pb_counters bar_bg_color=\"#607cb3\" use_percentages=\"off\" _builder_version=\"4.4.2\" title_font=\"|700||on|||||\" title_text_color=\"#41547d\" title_font_size=\"16px\" title_line_height=\"2em\" percent_font=\"||||||||\" background_color=\"#f1f6ff\" hover_enabled=\"0\" locked=\"off\"][et_pb_counter percent=\"80\" _builder_version=\"4.4.2\" hover_enabled=\"0\" background_color_default=\"#f1f6ff\" background_enable_color_default=\"on\" parallax_default=\"off\" parallax_method_default=\"on\" bar_background_color_default=\"#607cb3\" use_percentages=\"off\" allow_player_pause_default=\"off\"]\n\nطراحی مد\n\n[/et_pb_counter][et_pb_counter percent=\"60\" _builder_version=\"4.4.2\" hover_enabled=\"0\" background_color_default=\"#f1f6ff\" background_enable_color_default=\"on\" parallax_default=\"off\" parallax_method_default=\"on\" bar_background_color_default=\"#607cb3\" use_percentages=\"off\" allow_player_pause_default=\"off\"]\n\nکت و شلوار\n\n[/et_pb_counter][et_pb_counter percent=\"50\" _builder_version=\"4.4.2\" hover_enabled=\"0\" background_color_default=\"#f1f6ff\" background_enable_color_default=\"on\" parallax_default=\"off\" parallax_method_default=\"on\" bar_background_color_default=\"#607cb3\" use_percentages=\"off\" allow_player_pause_default=\"off\" title_font=\"|700||on|||||\" title_letter_spacing=\"0px\"]\n\nمهارت دیگر\n\n[/et_pb_counter][/et_pb_counters][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonials\" _builder_version=\"3.22\" background_color=\"#ffffff\" custom_padding=\"0|0px|54px|0px|false|false\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_slider _builder_version=\"4.4.2\" locked=\"off\"][et_pb_slide _builder_version=\"4.4.2\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>[/et_pb_slide][/et_pb_slider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#f1f6ff\" locked=\"off\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>در تماس باشید!</h2>[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>[/et_pb_text][et_pb_blurb title=\"بازدید از محل کار ما\" use_icon=\"on\" font_icon=\"%%249%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\"]<p>ایران - تهران - شهرک خیاط</p>[/et_pb_blurb][et_pb_blurb title=\"شماره تماس\" use_icon=\"on\" font_icon=\"%%264%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\"]<p>091312345678</p>[/et_pb_blurb][et_pb_blurb title=\"ایمیل ما\" use_icon=\"on\" font_icon=\"%%238%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\"]<p>info@modelsite.ir</p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_row_inner _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"60px|0px|60px|0px|true|false\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_column_inner saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_contact_form captcha=\"off\" success_message=\"پیام شما با موفقیت ارسال شد .\" submit_button_text=\"ارسال پیام\" module_id=\"et_pb_contact_form_0\" _builder_version=\"4.4.2\" form_field_background_color=\"#f5f9ff\" form_field_font=\"||||||||\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#af8447\" button_border_width=\"10px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"|40px||40px||true\" form_field_text_shadow_style=\"preset4\" box_shadow_style_button=\"preset1\" form_background_color=\"#f5f9ff\"][et_pb_contact_field field_id=\"Name\" field_title=\"نام\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Email\" field_title=\"ایمیل شما\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Phone\" field_title=\"شماره تماس\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Message\" field_title=\"پیام شما ....\" field_type=\"text\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||30px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][/et_pb_contact_form][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section]", "درباره ما", "", "inherit", "closed", "closed", "", "187-revision-v1", "", "", "2020-03-31 15:42:51", "2020-03-31 12:12:51", "", "187", "http://modelsite.test/187-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2884", "1", "2020-03-31 16:30:10", "2020-03-31 13:00:10", "[et_pb_section fb_built=\"1\" specialty=\"on\" bg_img_2=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-02.jpg\" padding_left_right_link_2=\"true\" padding_right_2=\"40px\" padding_left_2=\"40px\" padding_2_tablet=\"|||0px\" padding_2_phone=\"\" padding_2_last_edited=\"on|tablet\" admin_label=\"Footer\" _builder_version=\"3.22\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" inner_shadow__hover=\"off\" inner_shadow__hover_enabled=\"off\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" max_width__hover=\"100%\" max_width__hover_enabled=\"100%\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" parallax__hover_enabled=\"off\" parallax_method__hover_enabled=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"|600|||||||\" header_font_size=\"40px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_text_color=\"#dfab82\" header_2_font_size=\"36px\" header_2_line_height=\"1.4em\" custom_margin=\"||40px\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h1>آیا سوالی دارید ؟ ما پاسخگو شما هستیم</h1>\n<h2>با ما تماس بگیرید یا فرم تماس را پر نمایید</h2>\n[/et_pb_text][et_pb_button button_text=\"یا تماس بگیرید : 12345-021\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#41547d\" button_bg_color=\"#ffffff\" button_border_width=\"0px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" button_text_color_tablet=\"\" button_text_color_phone=\"\" button_text_color_last_edited=\"on|desktop\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(65,84,125,0.06)\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#af8447\" button_bg_enable_color__hover=\"on\" button_text_color__hover_enabled=\"on|hover\" button_text_color__hover=\"#ffffff\" locked=\"off\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" padding_tablet__hover=\"|||0px\" padding_last_edited__hover=\"on|tablet\" padding_left__hover=\"40px\" padding_right__hover=\"40px\" bg_img__hover=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-02.jpg\" parallax__hover_enabled=\"off\" parallax_method__hover_enabled=\"on\" padding_tablet=\"|||0px\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_row_inner _builder_version=\"3.25\" background_color=\"#ffffff\" custom_margin=\"||-80px||false|true\" custom_padding=\"60px|0px|60px|0px|true|false\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_column_inner saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_contact_form captcha=\"off\" success_message=\"پیام شما با موفقیت ارسال شد .\" submit_button_text=\"ارسال پیام\" module_id=\"et_pb_contact_form_1\" _builder_version=\"4.4.2\" form_field_background_color=\"#f5f9ff\" form_field_font=\"||||||||\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#af8447\" button_border_width=\"10px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"|40px||40px||true\" form_field_text_shadow_style=\"preset4\" box_shadow_style_button=\"preset1\" form_background_color=\"#f5f9ff\" locked=\"off\"][et_pb_contact_field field_id=\"Name\" field_title=\"نام\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Email\" field_title=\"ایمیل شما\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Phone\" field_title=\"شماره تماس\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Message\" field_title=\"پیام شما ....\" field_type=\"text\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||30px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][/et_pb_contact_form][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Contact Info\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#f7f9fc\"][et_pb_row column_structure=\"1_3,1_3,1_3\" _builder_version=\"3.25\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"آدرس مغازه\" use_icon=\"on\" font_icon=\"%%249%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"16px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" text_orientation=\"center\" custom_padding=\"|30px|30px|30px|false|true\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\"]<p>ایران - تهران - شهرک خیاط</p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"شماره همراه\" use_icon=\"on\" font_icon=\"%%264%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"16px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" text_orientation=\"center\" custom_padding=\"|30px|30px|30px|false|true\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\"]<p>0913123456</p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"ایمیل ما\" use_icon=\"on\" font_icon=\"%%238%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"16px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\" text_orientation=\"center\" custom_padding=\"|30px|30px|30px|false|true\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\"]<p>info@modelsite.ir</p>\n[/et_pb_blurb][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" admin_label=\"Hours\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>سرعت و دقت شعار ماست</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_blurb title=\"مقایسه کنید\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][et_pb_blurb title=\"سفارش بدید\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_row_inner _builder_version=\"3.25\" background_color=\"#41547d\" custom_margin=\"|||||false\" custom_padding=\"80px|60px||60px||true\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\"][et_pb_column_inner saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_text_color=\"#dfab82\" text_font_size=\"18px\" text_line_height=\"2em\" background_layout=\"dark\" custom_margin_tablet=\"0vw|0vw||0vw\" custom_margin_last_edited=\"off|desktop\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_last_edited=\"off|desktop\" animation_style=\"flip\" hover_enabled=\"0\" text_font_size_tablet=\"\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\" locked=\"off\"]<p><span style=\"font-size: 18px;\">ساعات کاری</span></p>\n[/et_pb_text][/et_pb_column_inner][/et_pb_row_inner][et_pb_row_inner column_structure=\"1_2,1_2\" _builder_version=\"3.25\" background_color=\"#41547d\" custom_padding=\"10px|60px|10px|60px|true|true\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\"][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_font_size=\"14px\" text_line_height=\"2em\" background_layout=\"dark\" custom_margin=\"||\" custom_margin_tablet=\"0vw|0vw||0vw\" custom_margin_phone=\"||-20px\" custom_margin_last_edited=\"on|desktop\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_last_edited=\"off|desktop\" animation_style=\"flip\" hover_enabled=\"0\" text_font_size_tablet=\"\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\" locked=\"off\"]<p>شنبه</p>\n[/et_pb_text][/et_pb_column_inner][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_font_size=\"12px\" text_line_height=\"2em\" background_layout=\"dark\" custom_margin_tablet=\"0vw|0vw||0vw\" custom_margin_last_edited=\"off|desktop\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_last_edited=\"off|desktop\" animation_style=\"flip\" hover_enabled=\"0\" text_font_size_tablet=\"\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\" locked=\"off\" text_letter_spacing_last_edited=\"on|desktop\"]<p>8 صبح تا 1 ظهر و 5 عصر تا 9 شب</p>\n[/et_pb_text][/et_pb_column_inner][/et_pb_row_inner][et_pb_row_inner column_structure=\"1_2,1_2\" _builder_version=\"3.25\" background_color=\"#41547d\" custom_padding=\"10px|60px|10px|60px|true|true\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\"][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_font_size=\"14px\" text_line_height=\"2em\" background_layout=\"dark\" custom_margin=\"||\" custom_margin_tablet=\"0vw|0vw||0vw\" custom_margin_phone=\"||-20px\" custom_margin_last_edited=\"on|desktop\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_last_edited=\"off|desktop\" animation_style=\"flip\" hover_enabled=\"0\" text_font_size_tablet=\"\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\" locked=\"off\"]<p>یکشنبه</p>\n[/et_pb_text][/et_pb_column_inner][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_font_size=\"12px\" text_line_height=\"2em\" background_layout=\"dark\" custom_margin_tablet=\"0vw|0vw||0vw\" custom_margin_last_edited=\"off|desktop\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_last_edited=\"off|desktop\" animation_style=\"flip\" hover_enabled=\"0\" text_font_size_tablet=\"\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\" locked=\"off\" text_letter_spacing_last_edited=\"on|desktop\"]<p>8 صبح تا 1 ظهر و 5 عصر تا 9 شب</p>\n[/et_pb_text][/et_pb_column_inner][/et_pb_row_inner][et_pb_row_inner column_structure=\"1_2,1_2\" _builder_version=\"3.25\" background_color=\"#41547d\" custom_padding=\"10px|60px|10px|60px|true|true\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\"][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_font_size=\"14px\" text_line_height=\"2em\" background_layout=\"dark\" custom_margin=\"||\" custom_margin_tablet=\"0vw|0vw||0vw\" custom_margin_phone=\"||-20px\" custom_margin_last_edited=\"on|desktop\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_last_edited=\"off|desktop\" animation_style=\"flip\" hover_enabled=\"0\" text_font_size_tablet=\"\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\" locked=\"off\"]<p>دوشنبه</p>\n[/et_pb_text][/et_pb_column_inner][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_font_size=\"12px\" text_line_height=\"2em\" background_layout=\"dark\" custom_margin_tablet=\"0vw|0vw||0vw\" custom_margin_last_edited=\"off|desktop\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_last_edited=\"off|desktop\" animation_style=\"flip\" hover_enabled=\"0\" text_font_size_tablet=\"\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\" locked=\"off\" text_letter_spacing_last_edited=\"on|desktop\"]<p>8 صبح تا 1 ظهر و 5 عصر تا 9 شب</p>\n[/et_pb_text][/et_pb_column_inner][/et_pb_row_inner][et_pb_row_inner column_structure=\"1_2,1_2\" _builder_version=\"3.25\" background_color=\"#41547d\" custom_padding=\"10px|60px|10px|60px|true|true\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\"][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_font_size=\"14px\" text_line_height=\"2em\" background_layout=\"dark\" custom_margin=\"||\" custom_margin_tablet=\"0vw|0vw||0vw\" custom_margin_phone=\"||-20px\" custom_margin_last_edited=\"on|desktop\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_last_edited=\"off|desktop\" animation_style=\"flip\" hover_enabled=\"0\" text_font_size_tablet=\"\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\" locked=\"off\"]<p>سه شنبه</p>\n[/et_pb_text][/et_pb_column_inner][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_font_size=\"12px\" text_line_height=\"2em\" background_layout=\"dark\" custom_margin_tablet=\"0vw|0vw||0vw\" custom_margin_last_edited=\"off|desktop\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_last_edited=\"off|desktop\" animation_style=\"flip\" hover_enabled=\"0\" text_font_size_tablet=\"\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\" locked=\"off\" text_letter_spacing_last_edited=\"on|desktop\"]<p>8 صبح تا 1 ظهر و 5 عصر تا 9 شب</p>\n[/et_pb_text][/et_pb_column_inner][/et_pb_row_inner][et_pb_row_inner column_structure=\"1_2,1_2\" _builder_version=\"3.25\" background_color=\"#41547d\" custom_padding=\"10px|60px|10px|60px|true|true\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\"][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_font_size=\"14px\" text_line_height=\"2em\" background_layout=\"dark\" custom_margin=\"||\" custom_margin_tablet=\"0vw|0vw||0vw\" custom_margin_phone=\"||-20px\" custom_margin_last_edited=\"on|desktop\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_last_edited=\"off|desktop\" animation_style=\"flip\" hover_enabled=\"0\" text_font_size_tablet=\"\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\" locked=\"off\"]<p>چهارشنبه</p>\n[/et_pb_text][/et_pb_column_inner][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_font_size=\"12px\" text_line_height=\"2em\" background_layout=\"dark\" custom_margin_tablet=\"0vw|0vw||0vw\" custom_margin_last_edited=\"off|desktop\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_last_edited=\"off|desktop\" animation_style=\"flip\" hover_enabled=\"0\" text_font_size_tablet=\"\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\" locked=\"off\" text_letter_spacing_last_edited=\"on|desktop\"]<p>8 صبح تا 1 ظهر و 5 عصر تا 9 شب</p>\n[/et_pb_text][/et_pb_column_inner][/et_pb_row_inner][et_pb_row_inner column_structure=\"1_2,1_2\" _builder_version=\"3.25\" background_color=\"#41547d\" custom_padding=\"10px|60px|10px|60px|true|true\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\"][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_font_size=\"14px\" text_line_height=\"2em\" background_layout=\"dark\" custom_margin=\"||\" custom_margin_tablet=\"0vw|0vw||0vw\" custom_margin_phone=\"||-20px\" custom_margin_last_edited=\"on|desktop\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_last_edited=\"off|desktop\" animation_style=\"flip\" hover_enabled=\"0\" text_font_size_tablet=\"\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\" locked=\"off\"]<p>پنجشنبه</p>\n[/et_pb_text][/et_pb_column_inner][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_font_size=\"12px\" text_line_height=\"2em\" background_layout=\"dark\" custom_margin_tablet=\"0vw|0vw||0vw\" custom_margin_last_edited=\"off|desktop\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_last_edited=\"off|desktop\" animation_style=\"flip\" hover_enabled=\"0\" text_font_size_tablet=\"\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\" locked=\"off\" text_letter_spacing_last_edited=\"on|desktop\"]<p>8 صبح تا 1 ظهر و 5 عصر تا 8 شب</p>\n[/et_pb_text][/et_pb_column_inner][/et_pb_row_inner][et_pb_row_inner column_structure=\"1_2,1_2\" _builder_version=\"3.25\" background_color=\"#41547d\" custom_padding=\"10px|60px|10px|60px|true|true\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\"][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_font_size=\"14px\" text_line_height=\"2em\" background_layout=\"dark\" custom_margin=\"||\" custom_margin_tablet=\"0vw|0vw||0vw\" custom_margin_phone=\"||-20px\" custom_margin_last_edited=\"on|desktop\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_last_edited=\"off|desktop\" animation_style=\"flip\" hover_enabled=\"0\" text_font_size_tablet=\"\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\" locked=\"off\"]<p>جمعه</p>\n[/et_pb_text][/et_pb_column_inner][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_font_size=\"12px\" text_line_height=\"2em\" background_layout=\"dark\" custom_margin_tablet=\"0vw|0vw||0vw\" custom_margin_last_edited=\"off|desktop\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_last_edited=\"off|desktop\" animation_style=\"flip\" hover_enabled=\"0\" text_font_size_tablet=\"\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\" locked=\"off\" text_letter_spacing_last_edited=\"on|desktop\"]<p style=\"text-align: center;\">تعطیل</p>\n[/et_pb_text][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section][et_pb_section fb_built=\"1\" _builder_version=\"4.4.2\"][et_pb_row _builder_version=\"4.4.2\" box_shadow_style=\"preset1\" hover_enabled=\"0\"][et_pb_column _builder_version=\"4.4.2\" type=\"4_4\"][dsm_embed_google_map _builder_version=\"4.4.2\" address=\"برج میلاد\" height=\"450px\" hover_enabled=\"0\"][/dsm_embed_google_map][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"FAQ\" _builder_version=\"3.22\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>سوالات عمومی</h2>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_toggle title=\"یک سوال دلخواه را اینجا وارد کنید ؟\" open_toggle_background_color=\"rgba(0,0,0,0)\" closed_toggle_background_color=\"rgba(0,0,0,0)\" icon_color=\"#dfab82\" _builder_version=\"4.4.2\" title_level=\"h4\" title_font=\"|700|||||||\" title_font_size=\"14px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||0px\" custom_padding=\"30px|0px|30px|0px|true|true\" hover_enabled=\"0\" border_width_all=\"0px\" border_width_bottom=\"1px\" locked=\"off\"]<p>جواب این سوال را هم اینجا وارد کنید .</p>\n[/et_pb_toggle][et_pb_toggle title=\"یک سوال دلخواه را اینجا وارد کنید ؟\" open_toggle_background_color=\"rgba(0,0,0,0)\" closed_toggle_background_color=\"rgba(0,0,0,0)\" icon_color=\"#dfab82\" _builder_version=\"4.4.2\" title_level=\"h4\" title_font=\"|700|||||||\" title_font_size=\"14px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||0px\" custom_padding=\"30px|0px|30px|0px|true|true\" hover_enabled=\"0\" border_width_all=\"0px\" border_width_bottom=\"1px\" locked=\"off\"]<p>جواب این سوال را هم اینجا وارد کنید .</p>\n[/et_pb_toggle][et_pb_toggle title=\"یک سوال دلخواه را اینجا وارد کنید ؟\" open_toggle_background_color=\"rgba(0,0,0,0)\" closed_toggle_background_color=\"rgba(0,0,0,0)\" icon_color=\"#dfab82\" _builder_version=\"4.4.2\" title_level=\"h4\" title_font=\"|700|||||||\" title_font_size=\"14px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||0px\" custom_padding=\"30px|0px|30px|0px|true|true\" hover_enabled=\"0\" border_width_all=\"0px\" border_width_bottom=\"1px\" locked=\"off\"]<p>جواب این سوال را هم اینجا وارد کنید .</p>\n[/et_pb_toggle][et_pb_button button_text=\"سوال دیگری دارید از فرم بالا استفاده کنید\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"0px\" button_font=\"|800||on|||||\" custom_margin=\"56px||0px\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(65,84,125,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_toggle title=\"آیا شما مدل های خاص را هم خیاطی می کنید ؟\" open=\"on\" open_toggle_background_color=\"rgba(0,0,0,0)\" closed_toggle_background_color=\"rgba(0,0,0,0)\" icon_color=\"#dfab82\" _builder_version=\"4.4.2\" title_level=\"h4\" title_font=\"|700|||||||\" title_font_size=\"14px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||0px\" custom_padding=\"30px|0px|30px|0px|true|true\" hover_enabled=\"0\" border_width_all=\"0px\" border_width_bottom=\"1px\"]<p>با توجه با داشتن کادری متخصص در زمینه خیاطی و مد بله امکان طراحی هر مدلی را داریم . </p>\n[/et_pb_toggle][et_pb_toggle title=\"یک سوال دلخواه را اینجا وارد کنید ؟\" open_toggle_background_color=\"rgba(0,0,0,0)\" closed_toggle_background_color=\"rgba(0,0,0,0)\" icon_color=\"#dfab82\" _builder_version=\"4.4.2\" title_level=\"h4\" title_font=\"|700|||||||\" title_font_size=\"14px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||0px\" custom_padding=\"30px|0px|30px|0px|true|true\" hover_enabled=\"0\" border_width_all=\"0px\" border_width_bottom=\"1px\" locked=\"off\"]<p>جواب این سوال را هم اینجا وارد کنید .</p>\n[/et_pb_toggle][et_pb_toggle title=\"یک سوال دلخواه را اینجا وارد کنید ؟\" open_toggle_background_color=\"rgba(0,0,0,0)\" closed_toggle_background_color=\"rgba(0,0,0,0)\" icon_color=\"#dfab82\" _builder_version=\"4.4.2\" title_level=\"h4\" title_font=\"|700|||||||\" title_font_size=\"14px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||0px\" custom_padding=\"30px|0px|30px|0px|true|true\" hover_enabled=\"0\" border_width_all=\"0px\" border_width_bottom=\"1px\" locked=\"off\"]<p>جواب این سوال را هم اینجا وارد کنید .</p>\n[/et_pb_toggle][et_pb_toggle title=\"یک سوال دلخواه را اینجا وارد کنید ؟\" open_toggle_background_color=\"rgba(0,0,0,0)\" closed_toggle_background_color=\"rgba(0,0,0,0)\" icon_color=\"#dfab82\" _builder_version=\"4.4.2\" title_level=\"h4\" title_font=\"|700|||||||\" title_font_size=\"14px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||0px\" custom_padding=\"30px|0px|30px|0px|true|true\" hover_enabled=\"0\" border_width_all=\"0px\" border_width_bottom=\"1px\" locked=\"off\"]<p>جواب این سوال را هم اینجا وارد کنید .</p>\n[/et_pb_toggle][/et_pb_column][/et_pb_row][/et_pb_section]", "تماس با ما", "", "inherit", "closed", "closed", "", "195-revision-v1", "", "", "2020-03-31 16:30:10", "2020-03-31 13:00:10", "", "195", "http://modelsite.test/195-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2885", "1", "2020-03-31 16:36:43", "2020-03-31 13:06:43", "<!-- wp:paragraph -->\n<p>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد. کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد. لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد. کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد. لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد. کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد. لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد. کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد. لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد. کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد.</p>\n<!-- /wp:paragraph -->", "تست ششم عنوان وبلاگ", "", "inherit", "closed", "closed", "", "175-revision-v1", "", "", "2020-03-31 16:36:43", "2020-03-31 13:06:43", "", "175", "http://modelsite.test/175-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2886", "1", "2020-03-31 16:36:54", "2020-03-31 13:06:54", "<!-- wp:paragraph -->\n<p>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد. کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد. لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد. کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد. لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد. کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد. لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد. کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد. لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد. کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد.</p>\n<!-- /wp:paragraph -->", "تست پنجم عنوان وبلاگ", "", "inherit", "closed", "closed", "", "173-revision-v1", "", "", "2020-03-31 16:36:54", "2020-03-31 13:06:54", "", "173", "http://modelsite.test/173-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2887", "1", "2020-03-31 16:37:07", "2020-03-31 13:07:07", "<!-- wp:paragraph -->\n<p>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد. کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد. لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد. کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد. لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد. کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد. لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد. کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد. لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد. کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد.</p>\n<!-- /wp:paragraph -->", "تست چهارم عنوان وبلاگ", "", "inherit", "closed", "closed", "", "171-revision-v1", "", "", "2020-03-31 16:37:07", "2020-03-31 13:07:07", "", "171", "http://modelsite.test/171-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2888", "1", "2020-03-31 16:38:24", "2020-03-31 13:08:24", "<!-- wp:paragraph -->\n<p>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد. کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد. لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد. کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد. لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد. کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد. لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد. کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد. لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد. کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد.</p>\n<!-- /wp:paragraph -->", "تست سوم عنوان وبلاگ", "", "inherit", "closed", "closed", "", "169-revision-v1", "", "", "2020-03-31 16:38:24", "2020-03-31 13:08:24", "", "169", "http://modelsite.test/169-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2889", "1", "2020-03-31 16:42:00", "2020-03-31 13:12:00", "<!-- wp:paragraph -->\n<p>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد. کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد. لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد. کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد. لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد. کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد. لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد. کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد. لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد. کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد.</p>\n<!-- /wp:paragraph -->", "تست دوم عنوان وبلاگ", "", "inherit", "closed", "closed", "", "167-revision-v1", "", "", "2020-03-31 16:42:00", "2020-03-31 13:12:00", "", "167", "http://modelsite.test/167-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2890", "1", "2020-03-31 16:42:11", "2020-03-31 13:12:11", "<!-- wp:paragraph -->\n<p>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد. کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد. لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد. کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد. لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد. کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد.</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:paragraph -->\n<p>در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد. لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد. کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد. لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد. کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد.</p>\n<!-- /wp:paragraph -->", "تست اول عنوان مطلب وبلاگ", "", "inherit", "closed", "closed", "", "8-revision-v1", "", "", "2020-03-31 16:42:11", "2020-03-31 13:12:11", "", "8", "http://modelsite.test/8-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2892", "1", "2020-03-31 16:49:58", "2020-03-31 13:19:58", "[et_pb_section fb_built=\"1\" admin_label=\"Header\" _builder_version=\"4.4.2\" background_color=\"#f7f9fc\" hover_enabled=\"0\" top_divider_style=\"clouds2\" top_divider_color=\"#dfab82\" bottom_divider_style=\"waves\" bottom_divider_color=\"#dfab82\"][et_pb_row _builder_version=\"3.25\" hover_enabled=\"0\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"|600|||||||\" header_font_size=\"60px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_text_color=\"#dfab82\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" text_orientation=\"center\" max_width=\"800px\" module_alignment=\"center\" custom_margin=\"||40px\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h1>وبلاگ ما</h1>\n[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Blog\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_blog fullwidth=\"off\" posts_number=\"6\" _builder_version=\"4.4.2\" header_level=\"h4\" header_font=\"Muli|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" meta_font=\"|600|||||||\" meta_text_color=\"#dfab82\" meta_font_size=\"12px\" pagination_font=\"Cormorant Garamond|600|||||||\" pagination_text_color=\"rgba(48,57,78,0.95)\" pagination_font_size=\"24px\" hover_enabled=\"0\" border_width_all=\"0px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"80px\" box_shadow_blur=\"80px\" box_shadow_color=\"rgba(96,104,121,0.12)\" use_overlay=\"on\" hover_icon=\"%%15%%\" overlay_icon_color=\"#af8447\" hover_overlay_color=\"rgba(175,132,71,0.34)\"][/et_pb_blog][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Resources\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>آخرین منابع و کاتولوگ های دوخت</h2>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#ffffff\" custom_margin=\"||60px|||false\" custom_padding=\"60px|60px|60px|60px|true|true\" custom_padding_tablet=\"\" custom_padding_phone=\"|40px||40px||true\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span></p>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_3_font=\"|600|||||||\" header_3_font_size=\"28px\" header_3_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_3_font_size_phone=\"30px\" header_3_font_size_last_edited=\"off|desktop\" locked=\"off\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h3>عنوان فایل کاتالوگ را اینجا وارد کنید</h3>\n[/et_pb_text][et_pb_button button_text=\"لینک دانلود \" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"18px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#680000\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#ffffff\" custom_margin=\"||60px|||false\" custom_padding=\"60px|60px|60px|60px|true|true\" custom_padding_tablet=\"\" custom_padding_phone=\"|40px||40px||true\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span></p>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_3_font=\"|600|||||||\" header_3_font_size=\"28px\" header_3_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_3_font_size_phone=\"30px\" header_3_font_size_last_edited=\"off|desktop\" locked=\"off\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h3>عنوان فایل کاتالوگ را اینجا وارد کنید</h3>\n[/et_pb_text][et_pb_button button_text=\"لینک دانلود \" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"18px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#680000\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#ffffff\" custom_margin=\"||60px|||false\" custom_padding=\"60px|60px|60px|60px|true|true\" custom_padding_tablet=\"\" custom_padding_phone=\"|40px||40px||true\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span></p>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_3_font=\"|600|||||||\" header_3_font_size=\"28px\" header_3_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_3_font_size_phone=\"30px\" header_3_font_size_last_edited=\"off|desktop\" locked=\"off\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h3>عنوان فایل کاتالوگ را اینجا وارد کنید</h3>\n[/et_pb_text][et_pb_button button_text=\"لینک دانلود \" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"18px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#680000\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Subscribe\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#f7f9fc\" background_color_gradient_end=\"#ffffff\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" inner_shadow__hover=\"off\" inner_shadow__hover_enabled=\"off\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" max_width__hover=\"100%\" max_width__hover_enabled=\"100%\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_row custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#dfab82\" custom_padding=\"80px|60px|80px|60px|true|true\" custom_padding_tablet=\"\" custom_padding_phone=\"60px|40px|60px|40px|true|true\" hover_enabled=\"0\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_signup mailchimp_list=\"elegantthemestest|26e9af0331\" layout=\"top_bottom\" name_field=\"on\" title=\"عضو خبرنامه ایمیلی ما شوید\" description=\"<p>از آخرین مقالات و اخبار و تخفیفات ما از طریق ایمیل آگاه شوید</p>\n\" _builder_version=\"4.4.2\" form_field_background_color=\"rgba(255,255,255,0.27)\" form_field_text_color=\"#ffffff\" header_font=\"||||||||\" header_font_size=\"40px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_line_height=\"2em\" form_field_font=\"Muli||||||||\" use_background_color=\"off\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#41547d\" button_bg_color=\"#ffffff\" button_border_width=\"10px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" text_orientation=\"center\" max_width=\"600px\" module_alignment=\"center\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" border_radii_fields=\"on|0px|0px|0px|0px\" button_text=\"اشتراک خبرنامه\"][/et_pb_signup][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#f1f6ff\" locked=\"off\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>در تماس باشید!</h2>[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>[/et_pb_text][et_pb_blurb title=\"بازدید از محل کار ما\" use_icon=\"on\" font_icon=\"%%249%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\"]<p>ایران - تهران - شهرک خیاط</p>[/et_pb_blurb][et_pb_blurb title=\"شماره تماس\" use_icon=\"on\" font_icon=\"%%264%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\"]<p>091312345678</p>[/et_pb_blurb][et_pb_blurb title=\"ایمیل ما\" use_icon=\"on\" font_icon=\"%%238%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\"]<p>info@modelsite.ir</p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_row_inner _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"60px|0px|60px|0px|true|false\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_column_inner saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_contact_form captcha=\"off\" success_message=\"پیام شما با موفقیت ارسال شد .\" submit_button_text=\"ارسال پیام\" module_id=\"et_pb_contact_form_0\" _builder_version=\"4.4.2\" form_field_background_color=\"#f5f9ff\" form_field_font=\"||||||||\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#af8447\" button_border_width=\"10px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"|40px||40px||true\" form_field_text_shadow_style=\"preset4\" box_shadow_style_button=\"preset1\" form_background_color=\"#f5f9ff\"][et_pb_contact_field field_id=\"Name\" field_title=\"نام\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Email\" field_title=\"ایمیل شما\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Phone\" field_title=\"شماره تماس\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Message\" field_title=\"پیام شما ....\" field_type=\"text\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||30px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][/et_pb_contact_form][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section]", "وبلاگ", "", "inherit", "closed", "closed", "", "267-revision-v1", "", "", "2020-03-31 16:49:58", "2020-03-31 13:19:58", "", "267", "http://modelsite.test/267-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2894", "1", "2020-03-31 16:51:36", "2020-03-31 13:21:36", "[et_pb_section fb_built=\"1\" admin_label=\"Header\" _builder_version=\"4.4.2\" background_color=\"#f7f9fc\" hover_enabled=\"0\" top_divider_style=\"clouds2\" top_divider_color=\"#dfab82\" bottom_divider_style=\"waves\" bottom_divider_color=\"#dfab82\"][et_pb_row _builder_version=\"3.25\" hover_enabled=\"0\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"|600|||||||\" header_font_size=\"60px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_text_color=\"#dfab82\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" text_orientation=\"center\" max_width=\"800px\" module_alignment=\"center\" custom_margin=\"||40px\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h1>وبلاگ ما</h1>\n[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Blog\" _builder_version=\"4.4.2\" background_color=\"#f7f9fc\" hover_enabled=\"0\" top_divider_style=\"waves\" top_divider_color=\"#dfab82\"][et_pb_row _builder_version=\"4.4.2\" hover_enabled=\"0\" custom_margin=\"50px||||false|false\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_blog fullwidth=\"off\" posts_number=\"6\" _builder_version=\"4.4.2\" header_level=\"h4\" header_font=\"Muli|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" meta_font=\"|600|||||||\" meta_text_color=\"#dfab82\" meta_font_size=\"12px\" pagination_font=\"Cormorant Garamond|600|||||||\" pagination_text_color=\"rgba(48,57,78,0.95)\" pagination_font_size=\"24px\" hover_enabled=\"0\" border_width_all=\"0px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"80px\" box_shadow_blur=\"80px\" box_shadow_color=\"rgba(96,104,121,0.12)\" use_overlay=\"on\" hover_icon=\"%%15%%\" overlay_icon_color=\"#af8447\" hover_overlay_color=\"rgba(175,132,71,0.34)\"][/et_pb_blog][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Resources\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>آخرین منابع و کاتولوگ های دوخت</h2>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#ffffff\" custom_margin=\"||60px|||false\" custom_padding=\"60px|60px|60px|60px|true|true\" custom_padding_tablet=\"\" custom_padding_phone=\"|40px||40px||true\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span></p>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_3_font=\"|600|||||||\" header_3_font_size=\"28px\" header_3_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_3_font_size_phone=\"30px\" header_3_font_size_last_edited=\"off|desktop\" locked=\"off\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h3>عنوان فایل کاتالوگ را اینجا وارد کنید</h3>\n[/et_pb_text][et_pb_button button_text=\"لینک دانلود \" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"18px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#680000\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#ffffff\" custom_margin=\"||60px|||false\" custom_padding=\"60px|60px|60px|60px|true|true\" custom_padding_tablet=\"\" custom_padding_phone=\"|40px||40px||true\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span></p>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_3_font=\"|600|||||||\" header_3_font_size=\"28px\" header_3_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_3_font_size_phone=\"30px\" header_3_font_size_last_edited=\"off|desktop\" locked=\"off\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h3>عنوان فایل کاتالوگ را اینجا وارد کنید</h3>\n[/et_pb_text][et_pb_button button_text=\"لینک دانلود \" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"18px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#680000\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#ffffff\" custom_margin=\"||60px|||false\" custom_padding=\"60px|60px|60px|60px|true|true\" custom_padding_tablet=\"\" custom_padding_phone=\"|40px||40px||true\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" hover_enabled=\"0\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span></p>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_3_font=\"|600|||||||\" header_3_font_size=\"28px\" header_3_line_height=\"1.4em\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_3_font_size_phone=\"30px\" header_3_font_size_last_edited=\"off|desktop\" locked=\"off\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h3>عنوان فایل کاتالوگ را اینجا وارد کنید</h3>\n[/et_pb_text][et_pb_button button_text=\"لینک دانلود \" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"18px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#680000\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Subscribe\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#f7f9fc\" background_color_gradient_end=\"#ffffff\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" inner_shadow__hover=\"off\" inner_shadow__hover_enabled=\"off\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" max_width__hover=\"100%\" max_width__hover_enabled=\"100%\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_row custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#dfab82\" custom_padding=\"80px|60px|80px|60px|true|true\" custom_padding_tablet=\"\" custom_padding_phone=\"60px|40px|60px|40px|true|true\" hover_enabled=\"0\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_signup mailchimp_list=\"elegantthemestest|26e9af0331\" layout=\"top_bottom\" name_field=\"on\" title=\"عضو خبرنامه ایمیلی ما شوید\" description=\"<p>از آخرین مقالات و اخبار و تخفیفات ما از طریق ایمیل آگاه شوید</p>\n\" _builder_version=\"4.4.2\" form_field_background_color=\"rgba(255,255,255,0.27)\" form_field_text_color=\"#ffffff\" header_font=\"||||||||\" header_font_size=\"40px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_line_height=\"2em\" form_field_font=\"Muli||||||||\" use_background_color=\"off\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#41547d\" button_bg_color=\"#ffffff\" button_border_width=\"10px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" text_orientation=\"center\" max_width=\"600px\" module_alignment=\"center\" hover_enabled=\"0\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" border_radii_fields=\"on|0px|0px|0px|0px\" button_text=\"اشتراک خبرنامه\"][/et_pb_signup][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#f1f6ff\" locked=\"off\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>در تماس باشید!</h2>[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>[/et_pb_text][et_pb_blurb title=\"بازدید از محل کار ما\" use_icon=\"on\" font_icon=\"%%249%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\"]<p>ایران - تهران - شهرک خیاط</p>[/et_pb_blurb][et_pb_blurb title=\"شماره تماس\" use_icon=\"on\" font_icon=\"%%264%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\"]<p>091312345678</p>[/et_pb_blurb][et_pb_blurb title=\"ایمیل ما\" use_icon=\"on\" font_icon=\"%%238%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\"]<p>info@modelsite.ir</p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_row_inner _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"60px|0px|60px|0px|true|false\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_column_inner saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_contact_form captcha=\"off\" success_message=\"پیام شما با موفقیت ارسال شد .\" submit_button_text=\"ارسال پیام\" module_id=\"et_pb_contact_form_0\" _builder_version=\"4.4.2\" form_field_background_color=\"#f5f9ff\" form_field_font=\"||||||||\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#af8447\" button_border_width=\"10px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"|40px||40px||true\" form_field_text_shadow_style=\"preset4\" box_shadow_style_button=\"preset1\" form_background_color=\"#f5f9ff\"][et_pb_contact_field field_id=\"Name\" field_title=\"نام\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Email\" field_title=\"ایمیل شما\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Phone\" field_title=\"شماره تماس\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Message\" field_title=\"پیام شما ....\" field_type=\"text\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||30px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][/et_pb_contact_form][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section]", "وبلاگ", "", "inherit", "closed", "closed", "", "267-revision-v1", "", "", "2020-03-31 16:51:36", "2020-03-31 13:21:36", "", "267", "http://modelsite.test/267-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2895", "1", "2020-03-31 16:56:44", "2020-03-31 13:26:44", "[et_pb_section fb_built=\"1\" admin_label=\"Header\" _builder_version=\"4.4.2\" background_color=\"#f7f9fc\" top_divider_color=\"#dfab82\" bottom_divider_style=\"waves\" bottom_divider_color=\"#dfab82\" hover_enabled=\"0\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"|600|||||||\" header_font_size=\"60px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_text_color=\"#dfab82\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" text_orientation=\"center\" max_width=\"800px\" module_alignment=\"center\" custom_margin=\"||40px\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h1>وبلاگ ما</h1>[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Blog\" _builder_version=\"4.4.2\" background_color=\"#f7f9fc\" top_divider_style=\"waves\" top_divider_color=\"#dfab82\"][et_pb_row _builder_version=\"4.4.2\" custom_margin=\"50px||||false|false\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_blog fullwidth=\"off\" posts_number=\"6\" use_overlay=\"on\" overlay_icon_color=\"#af8447\" hover_overlay_color=\"rgba(175,132,71,0.34)\" hover_icon=\"%%15%%\" _builder_version=\"4.4.2\" header_level=\"h4\" header_font=\"Muli|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" meta_font=\"|600|||||||\" meta_text_color=\"#dfab82\" meta_font_size=\"12px\" pagination_font=\"Cormorant Garamond|600|||||||\" pagination_text_color=\"rgba(48,57,78,0.95)\" pagination_font_size=\"24px\" border_width_all=\"0px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"80px\" box_shadow_blur=\"80px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][/et_pb_blog][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Resources\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.4em\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>آخرین منابع و کاتولوگ های دوخت</h2>[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#ffffff\" custom_margin=\"||60px|||false\" custom_padding=\"60px|60px|60px|60px|true|true\" custom_padding_tablet=\"\" custom_padding_phone=\"|40px||40px||true\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span></p>[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_3_font=\"|600|||||||\" header_3_font_size=\"28px\" header_3_line_height=\"1.4em\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_3_font_size_phone=\"30px\" header_3_font_size_last_edited=\"off|desktop\" locked=\"off\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h3>عنوان فایل کاتالوگ را اینجا وارد کنید</h3>[/et_pb_text][et_pb_button button_text=\"لینک دانلود \" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"18px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#680000\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#ffffff\" custom_margin=\"||60px|||false\" custom_padding=\"60px|60px|60px|60px|true|true\" custom_padding_tablet=\"\" custom_padding_phone=\"|40px||40px||true\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span></p>[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_3_font=\"|600|||||||\" header_3_font_size=\"28px\" header_3_line_height=\"1.4em\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_3_font_size_phone=\"30px\" header_3_font_size_last_edited=\"off|desktop\" locked=\"off\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h3>عنوان فایل کاتالوگ را اینجا وارد کنید</h3>[/et_pb_text][et_pb_button button_text=\"لینک دانلود \" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"18px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#680000\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#ffffff\" custom_margin=\"||60px|||false\" custom_padding=\"60px|60px|60px|60px|true|true\" custom_padding_tablet=\"\" custom_padding_phone=\"|40px||40px||true\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span></p>[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_3_font=\"|600|||||||\" header_3_font_size=\"28px\" header_3_line_height=\"1.4em\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_3_font_size_phone=\"30px\" header_3_font_size_last_edited=\"off|desktop\" locked=\"off\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h3>عنوان فایل کاتالوگ را اینجا وارد کنید</h3>[/et_pb_text][et_pb_button button_text=\"لینک دانلود \" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"18px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#680000\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Subscribe\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#f7f9fc\" background_color_gradient_end=\"#ffffff\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" inner_shadow__hover=\"off\" inner_shadow__hover_enabled=\"off\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" max_width__hover=\"100%\" max_width__hover_enabled=\"100%\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_row custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#dfab82\" custom_padding=\"80px|60px|80px|60px|true|true\" custom_padding_tablet=\"\" custom_padding_phone=\"60px|40px|60px|40px|true|true\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_signup mailchimp_list=\"elegantthemestest|26e9af0331\" layout=\"top_bottom\" name_field=\"on\" title=\"عضو خبرنامه ایمیلی ما شوید\" button_text=\"اشتراک خبرنامه\" description=\"<p>از آخرین مقالات و اخبار و تخفیفات ما از طریق ایمیل آگاه شوید</p>\n\" _builder_version=\"4.4.2\" form_field_background_color=\"rgba(255,255,255,0.27)\" form_field_text_color=\"#ffffff\" header_font=\"||||||||\" header_font_size=\"40px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_line_height=\"2em\" form_field_font=\"Muli||||||||\" use_background_color=\"off\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#41547d\" button_bg_color=\"#ffffff\" button_border_width=\"10px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" text_orientation=\"center\" max_width=\"600px\" module_alignment=\"center\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" border_radii_fields=\"on|0px|0px|0px|0px\"][/et_pb_signup][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#f1f6ff\" locked=\"off\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>در تماس باشید!</h2>[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>[/et_pb_text][et_pb_blurb title=\"بازدید از محل کار ما\" use_icon=\"on\" font_icon=\"%%249%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\"]<p>ایران - تهران - شهرک خیاط</p>[/et_pb_blurb][et_pb_blurb title=\"شماره تماس\" use_icon=\"on\" font_icon=\"%%264%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\"]<p>091312345678</p>[/et_pb_blurb][et_pb_blurb title=\"ایمیل ما\" use_icon=\"on\" font_icon=\"%%238%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\"]<p>info@modelsite.ir</p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_row_inner _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"60px|0px|60px|0px|true|false\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_column_inner saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_contact_form captcha=\"off\" success_message=\"پیام شما با موفقیت ارسال شد .\" submit_button_text=\"ارسال پیام\" module_id=\"et_pb_contact_form_0\" _builder_version=\"4.4.2\" form_field_background_color=\"#f5f9ff\" form_field_font=\"||||||||\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#af8447\" button_border_width=\"10px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"|40px||40px||true\" form_field_text_shadow_style=\"preset4\" box_shadow_style_button=\"preset1\" form_background_color=\"#f5f9ff\"][et_pb_contact_field field_id=\"Name\" field_title=\"نام\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Email\" field_title=\"ایمیل شما\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Phone\" field_title=\"شماره تماس\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Message\" field_title=\"پیام شما ....\" field_type=\"text\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||30px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][/et_pb_contact_form][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section]", "وبلاگ", "", "inherit", "closed", "closed", "", "267-revision-v1", "", "", "2020-03-31 16:56:44", "2020-03-31 13:26:44", "", "267", "http://modelsite.test/267-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2896", "1", "2020-03-31 17:01:12", "2020-03-31 13:31:12", "[]", "", "", "trash", "closed", "closed", "", "9fbc2a24-e1f2-4673-975a-c69cccb7fa08", "", "", "2020-03-31 17:01:12", "2020-03-31 13:31:12", "", "0", "http://modelsite.test/9fbc2a24-e1f2-4673-975a-c69cccb7fa08/", "0", "customize_changeset", "", "0");
INSERT INTO `wp_posts` VALUES("2898", "1", "2020-04-02 10:26:34", "2020-04-02 06:56:34", "[et_pb_section fb_built=\"1\" use_custom_gutter=\"on\" gutter_width=\"1\" admin_label=\"Header\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#f7f9fc\" background_color_gradient_start_position=\"75%\" background_color_gradient_end_position=\"75%\" custom_padding=\"0|0px|0|0px|false|false\"][et_pb_row column_structure=\"1_2,1_2\" use_custom_gutter=\"on\" gutter_width=\"1\" make_equal=\"on\" padding_top_bottom_link_1=\"true\" _builder_version=\"3.25\" custom_padding=\"0|0px|0|0px|false|false\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"8vw|60px|8vw|\" custom_padding_tablet=\"|0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"|0px||\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"VAZIR FARSI|600|||||||\" header_font_size=\"60px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_text_color=\"#dfab82\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" custom_margin=\"||40px\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\"]<h1>خیاطی مردانه</h1>\n<h2>شیک پوش باشید </h2>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>[/et_pb_text][et_pb_button button_text=\"آنلاین رزرو کنید\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#41547d\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(65,84,125,0.24)\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][et_pb_button button_text=\"یا تماس بگیرید : 12345-021\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#41547d\" button_bg_color=\"#ffffff\" button_border_width=\"0px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" button_text_color_tablet=\"\" button_text_color_phone=\"\" button_text_color_last_edited=\"on|desktop\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(65,84,125,0.06)\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#af8447\" button_bg_enable_color__hover=\"on\" button_text_color__hover_enabled=\"on|hover\" button_text_color__hover=\"#ffffff\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-02.jpg\" parallax=\"on\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider show_divider=\"off\" disabled_on=\"off|off|on\" _builder_version=\"3.17.6\" height=\"250px\"][/et_pb_divider][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" use_custom_gutter=\"on\" gutter_width=\"1\" padding_top_bottom_link_2=\"false\" _builder_version=\"3.25\" custom_padding=\"0|0px|27px|0px|false|false\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_video src=\"#\" image_src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-03.jpg\" _builder_version=\"4.4.2\" custom_margin=\"|||-80px\" custom_margin_tablet=\"|||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\"][/et_pb_video][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"100px|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-04.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" max_width=\"80%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" box_shadow_style=\"preset1\" box_shadow_horizontal=\"-41px\" box_shadow_vertical=\"45px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(0,0,0,0.52)\" locked=\"off\"][/et_pb_image][et_pb_text _builder_version=\"4.4.2\" text_font=\"|600|||||||\" text_font_size=\"24px\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_2_font=\"||||||||\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" background_color=\"#dfab82\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-01.png\" background_position=\"bottom_right\" background_layout=\"dark\" custom_margin=\"|||0%\" custom_padding=\"50px|60px|50px|60px|true|true\" animation_direction=\"left\" link_option_url=\"#\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\" custom_padding__hover_enabled=\"on\" custom_padding__hover=\"|40px||80px||false\" background__hover_enabled=\"on\" background_color__hover=\"#ddb494\"]<p>مشاهده گالری نمونه کارها</p>[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"left\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" admin_label=\"Services\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"22px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>یک کت و شلوار سفارش دهید که توسط خیاطان متخصص برای تن شما ساخته شده است</h2>[/et_pb_text][et_pb_button button_text=\"یک وقت بگیرید\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_row_inner column_structure=\"1_2,1_2\" _builder_version=\"3.25\"][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"خیاطی لباس دامادی\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-03.png\" icon_alignment=\"right\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" body_font_size=\"12px\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_scale__hover=\"110%|110%\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][et_pb_blurb title=\"تعمیرات لباس\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-02.png\" icon_alignment=\"right\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" body_font_size=\"12px\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_scale__hover=\"110%|110%\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][/et_pb_column_inner][et_pb_column_inner type=\"1_2\" saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"میلیمترها رو ما حواسمان هست\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-12.png\" icon_alignment=\"right\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" body_font_size=\"12px\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_scale__hover=\"110%|110%\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][et_pb_blurb title=\"دوخت انواع پیراهن و شلوار\" image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-01.png\" icon_alignment=\"right\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" body_font_size=\"12px\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_scale__hover=\"110%|110%\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section][et_pb_section fb_built=\"1\" disabled_on=\"off|off|off\" admin_label=\"Testimonial\" _builder_version=\"4.4.2\" background_color=\"#f7f9fc\"][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"4.4.2\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-05.jpg\" module_alignment=\"center\" custom_padding=\"0|0px|12vw|0px|false|false\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_testimonial quote_icon=\"off\" _builder_version=\"4.4.2\" body_font=\"||on||||||\" body_font_size=\"20px\" body_line_height=\"2em\" background_color=\"#41547d\" background_layout=\"dark\" width=\"92%\" module_alignment=\"right\" custom_margin=\"-12vw|||-10vw\" custom_margin_tablet=\"0vw||10vw|0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" custom_padding=\"80px|60px|80px|7vw|true|false\" custom_padding_tablet=\"40px|10%|40px|10%|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" animation_style=\"flip\" body_font_size_tablet=\"18px\" body_font_size_phone=\"\" body_font_size_last_edited=\"on|desktop\" body_line_height_tablet=\"\" body_line_height_phone=\"1.8em\" body_line_height_last_edited=\"on|phone\" box_shadow_style=\"preset1\" box_shadow_horizontal=\"-41px\" box_shadow_vertical=\"45px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(0,0,0,0.52)\" locked=\"off\"]<p>\"<b>دوزندگی</b><span> </span>صنعت و هنر<span> پیوست یا پیوند اشیاء با استفاده از </span>بخیه<span> ساخته شده با </span>سوزن<span> و </span>نخ<span> است</span><span>.</span>\"</p>[/et_pb_testimonial][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_6,1_6,1_6,1_6,1_6,1_6\" _builder_version=\"3.25\"][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_08-1.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_07-1.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_06-1.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_05-2.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_03-2.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/logo_01-2.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" locked=\"off\"][/et_pb_image][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Feature\" _builder_version=\"3.22\" background_color=\"#f7f9fc\"][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"32px\" header_2_line_height=\"1.4em\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>لباس شما با بهترین مواد دوخته می شود</h2>[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>[/et_pb_text][et_pb_button button_text=\"اطلاعات بیشتر\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-06.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\"][/et_pb_image][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-07.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" max_width=\"70%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" border_color_all=\"#ffffff\" border_width_right=\"20px\" border_width_bottom=\"20px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][/et_pb_image][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"right\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Services\" _builder_version=\"3.22\" background_color=\"#f7f9fc\" custom_margin=\"|||\" custom_padding=\"0|0px|80px|0px|false|false\"][et_pb_row column_structure=\"1_2,1_2\" custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#ffffff\" width=\"90%\" max_width=\"90%\" module_alignment=\"left\" custom_margin=\"|||\" custom_padding=\"60px|||15vw|false|false\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"120px\" box_shadow_color=\"rgba(96,104,121,0.12)\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"90%\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.4em\" max_width=\"600px\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>خیاطی و تعمیرات</h2>[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_4,1_4,1_2\" custom_padding_last_edited=\"on|phone\" _builder_version=\"3.25\" background_color=\"#ffffff\" width=\"90%\" max_width=\"90%\" module_alignment=\"left\" custom_margin=\"|||\" custom_padding=\"||120px|15vw|false|false\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"120px\" box_shadow_color=\"rgba(96,104,121,0.12)\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"90%\"][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-04.png\" _builder_version=\"4.4.2\" animation_style=\"slide\" animation_direction=\"bottom\" animation_delay=\"600ms\" always_center_on_mobile=\"off\" locked=\"off\"][/et_pb_image][et_pb_blurb title=\"خدمات خیاطی\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-icon-05.png\" _builder_version=\"4.4.2\" animation_style=\"slide\" animation_direction=\"bottom\" animation_delay=\"600ms\" always_center_on_mobile=\"off\" locked=\"off\" transform_styles__hover_enabled=\"off|hover\" transform_scale__hover_enabled=\"off|hover\" transform_translate__hover_enabled=\"off|hover\" transform_rotate__hover_enabled=\"off|hover\" transform_skew__hover_enabled=\"off|hover\" transform_origin__hover_enabled=\"off|hover\"][/et_pb_image][et_pb_blurb title=\"خدمات تعمیرات\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"2em\" body_font_size=\"12px\" body_line_height=\"2em\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_font_size=\"18px\" text_letter_spacing=\"1px\" background_color=\"#41547d\" background_layout=\"dark\" custom_margin=\"-14vw|-10vw||10vw\" custom_margin_tablet=\"0vw|0vw||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" custom_padding=\"80px|60px|80px|60px|true|true\" custom_padding_tablet=\"|10vw||10vw||true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|phone\" animation_style=\"flip\" text_font_size_tablet=\"\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\" text_text_shadow_style=\"preset3\" locked=\"off\"]<ol>\n<li> کوتاه کردن / بلند کردن</li>\n<li>کاف</li>\n<li>پوشش</li>\n<li>دور کمر</li>\n<li>آستین ها را بلند / کوتاه کنید</li>\n<li>دکمه / قلاب دوباره دوخت</li>\n<li>تعویض زیپ</li>\n<li>و ......</li>\n</ol>[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"4.4.2\" module_alignment=\"center\" custom_margin=\"-40px||\" custom_padding=\"0|0px|0|0px|false|false\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|600|||||||\" text_font_size=\"24px\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_2_font=\"||||||||\" header_3_font=\"||||||||\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" background_color=\"#dfab82\" background_image=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-01.png\" background_position=\"bottom_right\" background_layout=\"dark\" custom_padding=\"50px|60px|50px|60px|true|true\" animation_style=\"flip\" link_option_url=\"#\" locked=\"off\" custom_padding__hover_enabled=\"on\" custom_padding__hover=\"|40px||80px||false\" background__hover_enabled=\"on|hover\" background_color__hover=\"#680000\" background_enable_color__hover=\"on\"]<p>مشاهده تمام خدمات</p>[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" disabled_on=\"off|off|off\" admin_label=\"Gallery\" _builder_version=\"4.4.2\" background_color=\"#f7f9fc\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#f7f9fc\" background_color_gradient_end=\"#ffffff\"][et_pb_row column_structure=\"1_4,1_4,1_2\" _builder_version=\"3.25\"][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-08.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"4.4.2\" custom_margin=\"|||-7vw|false|false\" custom_margin_tablet=\"|||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|phone\" locked=\"off\"][/et_pb_image][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/crypto_image_03.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" border_color_all=\"#ffffff\" border_width_bottom=\"20px\" border_width_left=\"20px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/03/tailor-10.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"6vw||\" custom_margin_tablet=\"\" custom_margin_phone=\"0vw||\" custom_margin_last_edited=\"on|desktop\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\" locked=\"off\"][/et_pb_image][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>چند نمونه کار اخیر ما</h2>[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>[/et_pb_text][et_pb_button button_text=\"مشاهده سایر نمونه کارها\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"12px\" button_text_color=\"#ffffff\" button_bg_color=\"#dfab82\" button_border_width=\"0px\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"18px|30px|18px|30px|true|true\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"10px\" box_shadow_blur=\"20px\" box_shadow_color=\"rgba(223,171,130,0.24)\" locked=\"off\" box_shadow_blur__hover=\"20px\" box_shadow_color__hover=\"rgba(223,171,130,0.52)\" box_shadow_vertical__hover_enabled=\"on\" box_shadow_vertical__hover=\"20px\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" width=\"50%\" max_width=\"50%\" module_alignment=\"left\" custom_padding=\"27px|0px|0|0px|false|false\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"50%\" locked=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_divider color=\"rgba(0,0,0,0.12)\" divider_style=\"dashed\" divider_weight=\"2px\" _builder_version=\"3.17.6\"][/et_pb_divider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonials\" _builder_version=\"3.22\" background_color=\"#ffffff\" custom_padding=\"0|0px|54px|0px|false|false\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_slider _builder_version=\"4.4.2\" locked=\"off\"][et_pb_slide _builder_version=\"4.4.2\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>[/et_pb_slide][et_pb_slide _builder_version=\"4.4.2\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span>\"</p>[/et_pb_slide][/et_pb_slider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#f1f6ff\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" header_font=\"||||||||\" header_font_size=\"50px\" header_line_height=\"1.4em\" header_2_font=\"|600|||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.4em\" header_font_size_tablet=\"40px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|desktop\" header_2_font_size_tablet=\"40px\" header_2_font_size_phone=\"30px\" header_2_font_size_last_edited=\"on|desktop\" locked=\"off\"]<h2>در تماس باشید!</h2>[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" locked=\"off\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>[/et_pb_text][et_pb_blurb title=\"بازدید از محل کار ما\" use_icon=\"on\" font_icon=\"%%249%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\"]<p>ایران - تهران - شهرک خیاط</p>[/et_pb_blurb][et_pb_blurb title=\"شماره تماس\" use_icon=\"on\" font_icon=\"%%264%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\"]<p>091312345678</p>[/et_pb_blurb][et_pb_blurb title=\"ایمیل ما\" use_icon=\"on\" font_icon=\"%%238%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#41547d\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" body_font_size=\"12px\" body_line_height=\"2em\"]<p>info@modelsite.ir</p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_row_inner _builder_version=\"3.25\" background_color=\"#ffffff\" custom_padding=\"60px|0px|60px|0px|true|false\" animation_style=\"flip\" box_shadow_style=\"preset1\" box_shadow_vertical=\"100px\" box_shadow_blur=\"180px\" box_shadow_color=\"rgba(96,104,121,0.12)\"][et_pb_column_inner saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_contact_form captcha=\"off\" success_message=\"پیام شما با موفقیت ارسال شد .\" submit_button_text=\"ارسال پیام\" module_id=\"et_pb_contact_form_0\" _builder_version=\"4.4.2\" form_field_background_color=\"#f5f9ff\" form_field_font=\"||||||||\" custom_button=\"on\" button_text_size=\"14px\" button_text_color=\"#ffffff\" button_bg_color=\"#af8447\" button_border_width=\"10px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"0px\" button_letter_spacing=\"2px\" button_font=\"|800||on|||||\" custom_padding=\"|40px||40px||true\" form_field_text_shadow_style=\"preset4\" box_shadow_style_button=\"preset1\" form_background_color=\"#f5f9ff\"][et_pb_contact_field field_id=\"Name\" field_title=\"نام\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Email\" field_title=\"ایمیل شما\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Phone\" field_title=\"شماره تماس\" field_type=\"email\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||20px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][et_pb_contact_field field_id=\"Message\" field_title=\"پیام شما ....\" field_type=\"text\" fullwidth_field=\"on\" _builder_version=\"4.4.2\" custom_margin=\"||30px\" button_text_size__hover_enabled=\"off\" button_one_text_size__hover_enabled=\"off\" button_two_text_size__hover_enabled=\"off\" button_text_color__hover_enabled=\"off\" button_one_text_color__hover_enabled=\"off\" button_two_text_color__hover_enabled=\"off\" button_border_width__hover_enabled=\"off\" button_one_border_width__hover_enabled=\"off\" button_two_border_width__hover_enabled=\"off\" button_border_color__hover_enabled=\"off\" button_one_border_color__hover_enabled=\"off\" button_two_border_color__hover_enabled=\"off\" button_border_radius__hover_enabled=\"off\" button_one_border_radius__hover_enabled=\"off\" button_two_border_radius__hover_enabled=\"off\" button_letter_spacing__hover_enabled=\"off\" button_one_letter_spacing__hover_enabled=\"off\" button_two_letter_spacing__hover_enabled=\"off\" button_bg_color__hover_enabled=\"off\" button_one_bg_color__hover_enabled=\"off\" button_two_bg_color__hover_enabled=\"off\"][/et_pb_contact_field][/et_pb_contact_form][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section]", "خانه", "", "inherit", "closed", "closed", "", "2-revision-v1", "", "", "2020-04-02 10:26:34", "2020-04-02 06:56:34", "", "2", "http://modelsite.test/2-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2900", "1", "2020-04-02 11:48:46", "2020-04-02 08:18:46", "", "isp-05", "", "inherit", "open", "closed", "", "isp-05", "", "", "2020-04-02 11:48:46", "2020-04-02 08:18:46", "", "0", "http://modelsite.test/wp-content/uploads/2020/04/isp-05.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("2901", "1", "2020-04-02 11:48:56", "2020-04-02 08:18:56", "", "isp-03", "", "inherit", "open", "closed", "", "isp-03", "", "", "2020-04-02 11:48:56", "2020-04-02 08:18:56", "", "0", "http://modelsite.test/wp-content/uploads/2020/04/isp-03.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("2902", "1", "2020-04-02 11:48:58", "2020-04-02 08:18:58", "", "isp-04", "", "inherit", "open", "closed", "", "isp-04", "", "", "2020-04-02 11:48:58", "2020-04-02 08:18:58", "", "0", "http://modelsite.test/wp-content/uploads/2020/04/isp-04.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("2903", "1", "2020-04-02 11:49:00", "2020-04-02 08:19:00", "", "isp-08", "", "inherit", "open", "closed", "", "isp-08", "", "", "2020-04-02 11:49:00", "2020-04-02 08:19:00", "", "0", "http://modelsite.test/wp-content/uploads/2020/04/isp-08.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("2904", "1", "2020-04-02 11:49:12", "2020-04-02 08:19:12", "", "isp-01", "", "inherit", "open", "closed", "", "isp-01", "", "", "2020-04-02 11:49:12", "2020-04-02 08:19:12", "", "0", "http://modelsite.test/wp-content/uploads/2020/04/isp-01.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("2905", "1", "2020-04-02 11:49:15", "2020-04-02 08:19:15", "", "isp-02", "", "inherit", "open", "closed", "", "isp-02", "", "", "2020-04-02 11:49:15", "2020-04-02 08:19:15", "", "0", "http://modelsite.test/wp-content/uploads/2020/04/isp-02.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("2906", "1", "2020-04-02 11:49:17", "2020-04-02 08:19:17", "", "handyman_11", "", "inherit", "open", "closed", "", "handyman_11", "", "", "2020-04-02 11:49:17", "2020-04-02 08:19:17", "", "0", "http://modelsite.test/wp-content/uploads/2020/04/handyman_11.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("2907", "1", "2020-04-02 11:49:35", "2020-04-02 08:19:35", "[et_pb_section fb_built=\"1\" admin_label=\"Header\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-05.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"5vw||||false\" custom_padding=\"10vw||14vw||false\" bottom_divider_style=\"wave2\" bottom_divider_color=\"#ffffff\" bottom_divider_height=\"10vw\" bottom_divider_repeat=\"0.7x\" animation_style=\"slide\" animation_direction=\"bottom\" animation_intensity_slide=\"1%\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_last_edited=\"on|desktop\" animation_style=\"slide\" animation_direction=\"left\" animation_intensity_slide=\"10%\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" header_font=\"Poppins|900|on|on|||||\" header_font_size=\"10vw\" header_letter_spacing=\"0.1em\" header_line_height=\"1.2em\" header_2_font=\"Poppins|900|on|on|||||\" header_2_text_color=\"rgba(255,255,255,0.7)\" header_2_font_size=\"2vw\" header_2_letter_spacing=\"0.5em\" header_2_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" header_font_size_tablet=\"50px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|phone\" header_2_font_size_tablet=\"30px\" header_2_font_size_phone=\"20px\" header_2_font_size_last_edited=\"on|phone\" header_text_shadow_style=\"preset1\" header_text_shadow_vertical_length=\"0.3em\" header_text_shadow_blur_strength=\"0.5em\" header_text_shadow_color=\"rgba(0,0,0,0.15)\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h1>Go Faster</h1>\n<p>&nbsp;</p>\n<h2><span style=\"color: rgba(0, 0, 0, 0.7);\">$35</span> Internet</h2>[/et_pb_text][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_font_size=\"18px\" text_line_height=\"2em\" text_orientation=\"center\" background_layout=\"dark\" max_width=\"800px\" module_alignment=\"center\" text_font_size_tablet=\"16px\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\"]<p>Nulla porttitor accumsan tincidunt. Proin eget tortor risus. Pellentesque in ipsum id orci porta dapibus. Proin eget tortor risus. Mauris blandit aliquet eli</p>[/et_pb_text][et_pb_button button_text=\"All Internet & TV Offers\" button_alignment=\"center\" _builder_version=\"3.17.6\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"Poppins|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Login\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(242,245,250,0)\" background_color_gradient_end=\"#f2f5fa\" background_color_gradient_direction=\"90deg\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_padding=\"0|0px|0|0px|false|false\" border_radii=\"on|60px|60px|60px|60px\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"Poppins||||||||\" link_font=\"||||||||\" link_text_color=\"#0492ff\" text_orientation=\"center\"]<p>Already a member? <a href=\"#\">Sign In Here.</a></p>[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Value\" _builder_version=\"3.22\"][et_pb_row _builder_version=\"3.25\" custom_padding=\"||||false|false\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"Poppins|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#0492ff\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>Why Choose Us?</h2>[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row use_custom_gutter=\"on\" gutter_width=\"2\" padding_top_bottom_link_1=\"false\" padding_top_bottom_link_2=\"false\" padding_top_bottom_link_3=\"false\" padding_left_right_link_1=\"true\" padding_left_right_link_2=\"true\" padding_left_right_link_3=\"true\" _builder_version=\"3.25\" max_width=\"1160px\" custom_padding=\"0|0px|27px|0px|false|false\" use_custom_width=\"on\" custom_width_px=\"1160px\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\" max_width__hover=\"1080px\" max_width__hover_enabled=\"1080px\" column_structure=\"1_3,1_3,1_3\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-03.png\" background_size=\"contain\" background_position=\"bottom_right\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"Free Standard Installation\" use_icon=\"on\" font_icon=\"%%243%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#a0cf00\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"3.17.6\" header_font=\"Poppins|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>Sed porttitor lectus nibh. Curabitur arcu erat, accumsan id imperdiet et, porttitor at sem. Donec sollicitudin molestie malesuada. Vivamus suscipit tortor eget felis porttitor volutpat.</p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"18 Month Price Guarantee\" use_icon=\"on\" font_icon=\"%%171%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#a0cf00\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"3.17.6\" header_font=\"Poppins|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>Sed porttitor lectus nibh. Curabitur arcu erat, accumsan id imperdiet et, porttitor at sem. Donec sollicitudin molestie malesuada. Vivamus suscipit tortor eget felis porttitor volutpat.</p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-04.png\" background_size=\"contain\" background_position=\"top_right\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"Not Data Limits\" use_icon=\"on\" font_icon=\"%%231%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#a0cf00\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"3.17.6\" header_font=\"Poppins|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>Sed porttitor lectus nibh. Curabitur arcu erat, accumsan id imperdiet et, porttitor at sem. Donec sollicitudin molestie malesuada. Vivamus suscipit tortor eget felis porttitor volutpat.</p>[/et_pb_blurb][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Features\" _builder_version=\"3.22\" background_color=\"#f2f5fa\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_padding=\"54px|0px|0|0px|false|false\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row _builder_version=\"3.25\" custom_margin=\"100px||100px||true\" custom_margin_tablet=\"40px||40px||true\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" column_structure=\"3_5,2_5\"][et_pb_column type=\"3_5\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/04/isp-01.png\" align_tablet=\"center\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"|||-7vw\" custom_margin_tablet=\"|||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\"][/et_pb_image][/et_pb_column][et_pb_column type=\"2_5\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"Poppins|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>Your #1 Choice For Fiber Internet</h2>\n<h3></h3>\n<p>Curabitur non nulla sit amet nisl tempus convallis quis ac lectus. Nulla porttitor accumsan tincidunt. Sed porttitor lectus nibh. Curabitur non nulla sit amet nisl tempus convallis quis ac lectus. Donec sollicitudin molestie malesuada. Vestibulum ac diam sit amet quam vehicula elementum sed sit amet dui. Donec sollicit</p>[/et_pb_text][et_pb_blurb title=\"No Contract\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#a0cf00\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"3.17.6\" header_font=\"Poppins|700|on||||||\" header_font_size=\"16px\" header_line_height=\"2em\" custom_margin=\"||20px\"][/et_pb_blurb][et_pb_blurb title=\"Up to 175mbps\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#a0cf00\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"3.17.6\" header_font=\"Poppins|700|on||||||\" header_font_size=\"16px\" header_line_height=\"2em\" custom_margin=\"||20px\"][/et_pb_blurb][et_pb_blurb title=\"Hardware Included\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#a0cf00\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"3.17.6\" header_font=\"Poppins|700|on||||||\" header_font_size=\"16px\" header_line_height=\"2em\" custom_margin=\"||20px\"][/et_pb_blurb][et_pb_button button_text=\"internet Plans\" button_alignment=\"left\" _builder_version=\"3.17.6\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"Poppins|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" custom_margin=\"100px||100px||true\" custom_margin_tablet=\"40px||40px||true\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" column_structure=\"1_2,1_2\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"Poppins|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2><strong>Unlimited Data, Talking, &amp; Texting</strong> </h2>\n<h3>Curabitur non nulla sit amet nisl tempus conva</h3>\n<p>Curabitur non nulla sit amet nisl tempus convallis quis ac lectus. Nulla porttitor accumsan tincidunt. Sed porttitor lectus nibh. Curabitur non nulla sit amet nisl tempus convallis quis ac lectus. Donec sollicitudin molestie malesuada. Vestibulum ac diam sit amet quam vehicula elementum sed sit amet dui. Donec sollicit Curabitur non nulla sit amet nisl tempus convallis quis ac lectus. Nulla porttitor accumsan tincidunt. Sed porttitor lectus nibh.</p>[/et_pb_text][et_pb_button button_text=\"Phone Plans\" button_alignment=\"left\" _builder_version=\"3.17.6\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"Poppins|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/04/isp-02.jpg\" align_tablet=\"center\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"|-7vw||\" custom_margin_tablet=\"|0vw||\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\" border_radii=\"on|30px|30px|30px|30px\"][/et_pb_image][/et_pb_column][/et_pb_row][et_pb_row custom_padding_last_edited=\"on|tablet\" _builder_version=\"3.25\" background_color=\"#ffffff\" max_width=\"80%\" module_alignment=\"right\" custom_margin=\"||\" custom_padding=\"60px|||60px|false|false\" custom_padding_tablet=\"|40px||40px\" custom_padding_phone=\"\" animation_style=\"slide\" animation_direction=\"right\" animation_intensity_slide=\"10%\" border_radii=\"|30px|||\" use_custom_width=\"on\" width_unit=\"off\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"Poppins|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>Most Popular Bundles</h2>\n<p>Curabitur non nulla sit amet nisl tempus convallis quis ac lectus. Nulla porttitor accumsan tincidunt. Sed porttitor lectus nibh. Curabitur non nulla sit amet nisl tempus convallis quis ac lectus. Donec sollicitudin molestie malesuada. Vestibulum ac diam sit amet quam vehicula elementum sed sit amet dui. </p>[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Categories\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(242,245,250,0)\" background_color_gradient_end=\"#f2f5fa\" background_color_gradient_direction=\"90deg\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||60px\" custom_margin_tablet=\"||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|desktop\" custom_padding=\"0||0px||false|false\" border_radii=\"on|60px|60px|60px|60px\" locked=\"off\"][et_pb_row use_custom_gutter=\"on\" gutter_width=\"2\" _builder_version=\"3.25\" locked=\"off\" column_structure=\"1_6,1_6,1_6,1_6,1_6,1_6\"][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"Poppins|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#008a1c\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" box_shadow_color__hover_enabled=\"on\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\"]<p>TV</p>[/et_pb_text][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"Poppins|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#a0cf00\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" locked=\"off\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" box_shadow_color__hover_enabled=\"on\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\"]<p>Internet</p>[/et_pb_text][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"Poppins|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#ffffff\" text_orientation=\"center\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" locked=\"off\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" box_shadow_color__hover_enabled=\"on\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\" background_layout__hover_enabled=\"on\" background_layout__hover=\"dark\"]<p>Phone</p>[/et_pb_text][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Pricing\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||||false\" custom_padding=\"80px||80px||true\" animation_style=\"slide\" animation_direction=\"bottom\" animation_intensity_slide=\"1%\" border_radii=\"on|30px|30px|30px|30px\" locked=\"off\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\"][et_pb_row use_custom_gutter=\"on\" gutter_width=\"2\" _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\" column_structure=\"1_3,1_3,1_3\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"40px|||\" custom_padding_tablet=\"0px||\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px||\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"3.23\" currency_frequency_text_color=\"#ffffff\" price_text_color=\"rgba(0,0,0,0.75)\" body_text_color=\"#ffffff\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"Poppins||||||||\" body_text_align=\"center\" subheader_font=\"Poppins|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"Poppins|800|on||||||\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(255,255,255,0)\" background_color_gradient_end=\"rgba(255,255,255,0.16)\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"Poppins|700||on|||||\" animation_style=\"slide\" animation_direction=\"right\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\"][et_pb_pricing_table title=\"Basic Internet\" subtitle=\"85mbps\" currency=\"$\" per=\"mo\" sum=\"35\" button_text=\"Sign Up\" _builder_version=\"3.23\" body_font=\"||||||||\" excluded_text_color=\"rgba(255,255,255,0.5)\" pricing_item_excluded_color=\"rgba(255,255,255,0.5)\"]<p>+ Donec rutrum congue</p>\n<p>+ Quisque velit nisi</p>\n<p>+ Pretium ut lacinia in</p>\n<p>- Elementum id enim</p>\n<p>- Pellentesque in ipsum id</p>[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"3.23\" currency_frequency_text_color=\"#a0cf00\" price_text_color=\"rgba(0,0,0,0.75)\" subheader_text_color=\"#000000\" header_text_color=\"#000000\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"Poppins||||||||\" body_text_align=\"center\" subheader_font=\"Poppins|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"Poppins|800|on||||||\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#ffffff\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#008a1c\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"Poppins|700||on|||||\" custom_margin=\"0px||\" animation_style=\"zoom\" animation_delay=\"100ms\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" border_color_all=\"#ffffff\" border_width_top=\"40px\" border_width_bottom=\"30px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" locked=\"off\"][et_pb_pricing_table title=\"Pro Internet\" subtitle=\"120mbps\" currency=\"$\" per=\"mo\" sum=\"85\" button_text=\"Sign Up\" _builder_version=\"3.17.6\" body_font=\"||||||||\"]<p>+ Donec rutrum congue</p>\n<p>+ Quisque velit nisi</p>\n<p>+ Pretium ut lacinia in</p>\n<p>+ Elementum id enim</p>\n<p>+ Pellentesque in ipsum id</p>[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"40px|||\" custom_padding_tablet=\"0px||\" custom_padding_last_edited=\"on|desktop\" padding_tablet=\"0px||\" padding_last_edited=\"on|desktop\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"3.23\" currency_frequency_text_color=\"#ffffff\" price_text_color=\"rgba(0,0,0,0.75)\" body_text_color=\"#ffffff\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"Poppins||||||||\" body_text_align=\"center\" subheader_font=\"Poppins|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"Poppins|800|on||||||\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(255,255,255,0)\" background_color_gradient_end=\"rgba(255,255,255,0.16)\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"Poppins|700||on|||||\" custom_margin=\"||\" animation_style=\"slide\" animation_direction=\"left\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" locked=\"off\"][et_pb_pricing_table title=\"Internet + TV\" subtitle=\"120mbps\" currency=\"$\" per=\"mo\" sum=\"120\" button_text=\"Sign Up\" _builder_version=\"3.23\" body_font=\"||||||||\" excluded_text_color=\"rgba(255,255,255,0.5)\" pricing_item_excluded_color=\"rgba(255,255,255,0.5)\"]<p>+ Donec rutrum congue</p>\n<p>+ Quisque velit nisi</p>\n<p>+ Pretium ut lacinia in</p>\n<p>+ Elementum id enim</p>\n<p>- Pellentesque in ipsum id</p>[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Blog\" _builder_version=\"3.22\"][et_pb_row _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"Poppins|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#0492ff\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>Our Blog</h2>[/et_pb_text][et_pb_blog fullwidth=\"off\" posts_number=\"3\" include_categories=\"70\" show_pagination=\"off\" _builder_version=\"3.17.6\" header_font=\"Poppins|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_line_height=\"2em\" meta_font=\"Poppins||||||||\" meta_text_color=\"#008a1c\" pagination_font=\"Poppins|700|on||||||\" pagination_text_color=\"#008a1c\" pagination_font_size=\"18px\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"][/et_pb_blog][et_pb_button button_text=\"Read More\" button_alignment=\"center\" _builder_version=\"3.17.6\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"Poppins|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonials\" _builder_version=\"3.22\"][et_pb_row padding_top_bottom_link_1=\"true\" padding_top_bottom_link_2=\"true\" padding_left_right_link_1=\"false\" padding_left_right_link_2=\"false\" _builder_version=\"3.25\" custom_padding=\"0||0||false|false\" column_structure=\"2_5,3_5\"][et_pb_column type=\"2_5\" _builder_version=\"3.25\" custom_padding=\"60px|60px|60px|\" custom_padding_tablet=\"0px||0px||true\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px||0px||true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"Poppins|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>What People Are Saying About Divi</h2>\n<h3>Curabitur non nulla sit amet nisl tempus convallis quis ac lectus</h3>[/et_pb_text][/et_pb_column][et_pb_column type=\"3_5\" _builder_version=\"3.25\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/handyman_11.png\" background_size=\"initial\" background_position=\"bottom_right\" custom_padding=\"60px|60px|60px|\" custom_padding_tablet=\"40px|40px|40px|40px|true|true\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"40px|40px|40px|40px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_testimonial author=\"Customer Since 2014\" quote_icon=\"off\" _builder_version=\"3.17.6\" body_font=\"Poppins||on||||||\" body_font_size=\"14px\" body_line_height=\"2em\" background_color=\"#ffffff\" custom_margin=\"|||-40px\" custom_margin_tablet=\"|||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|desktop\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0.15)\"]<p>\"Pellentesque in ipsum id orci porta dapibus. Nulla quis lorem ut libero malesuada feugiat. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus. Praesent sapien massa, convallis a pellentesque nec, egestas non nisi\"</p>[/et_pb_testimonial][et_pb_testimonial author=\"Customer Since 2015\" quote_icon=\"off\" _builder_version=\"3.17.6\" body_font=\"Poppins||on||||||\" body_font_size=\"14px\" body_line_height=\"2em\" background_color=\"#ffffff\" custom_margin=\"|||-40px\" custom_margin_tablet=\"|||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|desktop\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0.15)\"]<p>\"Praesent sapien massa, convallis a pellentesque nec, egestas non nisi. Nulla porttitor accumsan tincidunt. Curabitur non nulla sit amet nisl tempus convallis quis ac lectus. Curabitur non nulla sit amet nisl tempus convallis quis ac lectus. Curabitur arcu erat, accumsan id imperdiet et\"</p>[/et_pb_testimonial][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" prev_background_color=\"#ffffff\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#0f1533\" background_color_gradient_end=\"#1f133a\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||5vw\" custom_padding=\"14vw||10vw\" top_divider_style=\"wave2\" top_divider_height=\"10vw\" top_divider_repeat=\"0.7x\" top_divider_flip=\"vertical\" animation_style=\"fade\" border_radii=\"on|30px|30px|30px|30px\" locked=\"off\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_last_edited=\"on|desktop\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" header_2_font=\"Poppins|900|on||||||\" header_2_font_size=\"5vw\" header_2_letter_spacing=\"2px\" header_2_line_height=\"1.4em\" header_3_font=\"Poppins|900|on|on|||||\" header_3_text_color=\"rgba(255,255,255,0.7)\" header_3_font_size=\"1.5vw\" header_3_letter_spacing=\"0.8em\" header_3_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_font_size__hover=\"30px\" header_font_size__hover_enabled=\"30px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h2>Get The Speeds You Want at the Price You Want</h2>\n<h3>TV & Internet</h3>[/et_pb_text][et_pb_button button_text=\"View All Plans\" button_alignment=\"center\" _builder_version=\"3.17.6\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"Poppins|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section]", "خانه", "", "inherit", "closed", "closed", "", "2-revision-v1", "", "", "2020-04-02 11:49:35", "2020-04-02 08:19:35", "", "2", "http://modelsite.test/2-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2909", "1", "2020-04-02 11:51:48", "2020-04-02 08:21:48", "[et_pb_section fb_built=\"1\" admin_label=\"Header\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-05.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"5vw||||false\" custom_padding=\"6vw||10vw||false|false\" bottom_divider_style=\"wave2\" bottom_divider_color=\"#ffffff\" bottom_divider_height=\"10vw\" bottom_divider_repeat=\"0.7x\" animation_style=\"slide\" animation_direction=\"bottom\" animation_intensity_slide=\"1%\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_last_edited=\"on|desktop\" animation_style=\"slide\" animation_direction=\"left\" animation_intensity_slide=\"10%\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" header_font=\"Poppins|900|on|on|||||\" header_font_size=\"6vw\" header_letter_spacing=\"0.1em\" header_line_height=\"1.2em\" header_2_font=\"Poppins|900|on|on|||||\" header_2_text_color=\"rgba(255,255,255,0.7)\" header_2_font_size=\"2vw\" header_2_letter_spacing=\"0.5em\" header_2_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" header_font_size_tablet=\"50px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|phone\" header_2_font_size_tablet=\"30px\" header_2_font_size_phone=\"20px\" header_2_font_size_last_edited=\"on|phone\" header_text_shadow_style=\"preset1\" header_text_shadow_vertical_length=\"0.3em\" header_text_shadow_blur_strength=\"0.5em\" header_text_shadow_color=\"rgba(0,0,0,0.15)\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h1>Contact Us</h1>\n<p>&nbsp;</p>\n<h2><span style=\"color: rgba(0, 0, 0, 0.7);\">24/7</span> supprt</h2>[/et_pb_text][et_pb_search show_button=\"off\" placeholder=\"Search Articles\" button_color=\"#ffffff\" placeholder_color=\"#ffffff\" _builder_version=\"3.23\" button_font=\"||||||||\" form_field_font=\"Poppins|600|||||||\" form_field_font_size=\"16px\" form_field_line_height=\"2em\" background_color=\"rgba(48,52,71,0.18)\" max_width=\"700px\" module_alignment=\"center\" custom_padding=\"14px||14px||true|false\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" input_font=\"Poppins|600|||||||\" input_font_size=\"16px\" input_line_height=\"2em\"][/et_pb_search][et_pb_button button_text=\"Live Chat\" button_alignment=\"center\" _builder_version=\"3.17.6\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"Poppins|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Categories\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(242,245,250,0)\" background_color_gradient_end=\"#f2f5fa\" background_color_gradient_direction=\"90deg\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin_tablet=\"||0px\" custom_margin_last_edited=\"off|desktop\" custom_padding=\"0||0px||false|false\" border_radii=\"on|60px|60px|60px|60px\" locked=\"off\"][et_pb_row use_custom_gutter=\"on\" gutter_width=\"2\" _builder_version=\"3.25\" locked=\"off\" column_structure=\"1_4,1_4,1_4,1_4\"][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"Poppins|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#008a1c\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" box_shadow_color__hover_enabled=\"on\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\"]<p>Residential</p>[/et_pb_text][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"Poppins|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#a0cf00\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" locked=\"off\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" box_shadow_color__hover_enabled=\"on\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\"]<p>Business</p>[/et_pb_text][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"Poppins|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#ffffff\" text_orientation=\"center\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" locked=\"off\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" box_shadow_color__hover_enabled=\"on\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\" background_layout__hover_enabled=\"on\" background_layout__hover=\"dark\"]<p>All Contacts\n</p>[/et_pb_text][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Contact Info\" _builder_version=\"3.22\"][et_pb_row use_custom_gutter=\"on\" gutter_width=\"2\" _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\" column_structure=\"1_3,1_3,1_3\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"Live Chat\" use_icon=\"on\" font_icon=\"%%221%%\" icon_color=\"#a0cf00\" use_circle=\"on\" circle_color=\"#ffffff\" icon_placement=\"left\" use_icon_font_size=\"on\" icon_font_size=\"22px\" _builder_version=\"3.17.6\" header_font=\"Poppins|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" background_color=\"#303447\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"20px|20px|20px|20px|true|true\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" background__hover_enabled=\"on\" background_color__hover=\"#008a1c\"]<p>Sed porttitor lectus nibh. Curabitur arcu erat, accumsan id imperdie</p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"Schedule an Appointment\" use_icon=\"on\" font_icon=\"%%128%%\" icon_color=\"#a0cf00\" use_circle=\"on\" circle_color=\"#ffffff\" icon_placement=\"left\" use_icon_font_size=\"on\" icon_font_size=\"22px\" _builder_version=\"3.17.6\" header_font=\"Poppins|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" background_color=\"#303447\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"20px|20px|20px|20px|true|true\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" background__hover_enabled=\"on\" background_color__hover=\"#008a1c\"]<p>Sed porttitor lectus nibh. Curabitur arcu erat, accutitor volutpat.</p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"Call Us\" use_icon=\"on\" font_icon=\"%%264%%\" icon_color=\"#a0cf00\" use_circle=\"on\" circle_color=\"#ffffff\" icon_placement=\"left\" use_icon_font_size=\"on\" icon_font_size=\"22px\" _builder_version=\"3.17.6\" header_font=\"Poppins|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" background_color=\"#303447\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"20px|20px|20px|20px|true|true\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" background__hover_enabled=\"on\" background_color__hover=\"#008a1c\"]<p>(125) 462-2351<br />(125) 462-1351</p>[/et_pb_blurb][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Call to Actions\" _builder_version=\"3.22\" custom_padding=\"0|0px|54px|0px|false|false\"][et_pb_row _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\" column_structure=\"1_2,1_2\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_cta title=\"Need to Pay a Bill? Have a Billing Question?\" button_url=\"#\" button_text=\"Login to Your Account\" _builder_version=\"3.17.6\" header_level=\"h3\" header_font=\"Poppins|700|on||||||\" header_font_size=\"32px\" header_line_height=\"1.5em\" body_font=\"Poppins|500|||||||\" body_text_color=\"#008a1c\" body_line_height=\"1.8em\" background_color=\"#ffffff\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"Poppins|700||on|||||\" text_orientation=\"left\" background_layout=\"light\" header_font_size_tablet=\"\" header_font_size_phone=\"26px\" header_font_size_last_edited=\"on|phone\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" box_shadow_style_button=\"preset3\" box_shadow_vertical_button=\"20px\" box_shadow_blur_button=\"80px\" box_shadow_spread_button=\"-20px\"]<p>Call: (135) 624-1231</p>[/et_pb_cta][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_cta title=\"Contact our World-Class 24/7 Support\" button_url=\"#\" button_text=\"Contact Support\" _builder_version=\"3.17.6\" header_level=\"h3\" header_font=\"Poppins|700|on||||||\" header_font_size=\"32px\" header_line_height=\"1.5em\" body_font=\"Poppins|500|||||||\" body_text_color=\"#008a1c\" body_line_height=\"1.8em\" background_color=\"#ffffff\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"Poppins|700||on|||||\" text_orientation=\"left\" background_layout=\"light\" header_font_size_tablet=\"\" header_font_size_phone=\"26px\" header_font_size_last_edited=\"on|phone\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" box_shadow_style_button=\"preset3\" box_shadow_vertical_button=\"20px\" box_shadow_blur_button=\"80px\" box_shadow_spread_button=\"-20px\" locked=\"off\"]<p>Call: (135) 624-1231</p>[/et_pb_cta][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"FAQ\" _builder_version=\"3.22\" background_color=\"#f2f5fa\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_padding=\"0|0px|0|0px|false|false\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row custom_padding_last_edited=\"on|tablet\" _builder_version=\"3.25\" background_color=\"#ffffff\" max_width=\"80%\" module_alignment=\"left\" custom_margin=\"||\" custom_padding=\"60px|||60px|false|false\" custom_padding_tablet=\"|40px||40px\" custom_padding_phone=\"\" animation_style=\"slide\" animation_direction=\"left\" animation_intensity_slide=\"10%\" border_radii=\"|||30px|\" use_custom_width=\"on\" width_unit=\"off\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"Poppins|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2> Popular Topics</h2>[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" custom_margin=\"100px||100px||true\" custom_margin_tablet=\"40px||40px||true\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" column_structure=\"3_5,2_5\"][et_pb_column type=\"3_5\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"Poppins|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|700|on||||||\" header_3_line_height=\"1.5em\" max_width=\"700px\" link_option_url=\"#\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" header_3_font_size_tablet=\"\" header_3_font_size_phone=\"26px\" header_3_font_size_last_edited=\"on|desktop\" locked=\"off\" header_3_text_color__hover_enabled=\"on\" header_3_text_color__hover=\"#008a1c\"]<h3>Setup Guides</h3>\n<p>Curabitur non nulla sit amet nisl tempus convallis quis ac lectus. Nulla porttitor accumsan tincidunt. Sed porttitor lectus nibh. Curabitur non nulla sit amet nisl tempus convallis quis ac lectus. Donec sollicitudin molestie malesuada. Vestibulum ac diam sit ame</p>[/et_pb_text][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"Poppins|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|700|on||||||\" header_3_line_height=\"1.5em\" max_width=\"700px\" link_option_url=\"#\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" header_3_font_size_tablet=\"\" header_3_font_size_phone=\"26px\" header_3_font_size_last_edited=\"on|desktop\" locked=\"off\" header_3_text_color__hover_enabled=\"on\" header_3_text_color__hover=\"#008a1c\"]<h3>Speed Tests</h3>\n<p>Curabitur non nulla sit amet nisl tempus convallis quis ac lectus. Nulla porttitor accumsan tincidunt. Sed porttitor lectus nibh. Curabitur non nulla sit amet nisl tempus convallis quis ac lectus. Donec sollicitudin molestie malesuada. Vestibulum ac diam sit am</p>[/et_pb_text][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"Poppins|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|700|on||||||\" header_3_line_height=\"1.5em\" max_width=\"700px\" link_option_url=\"#\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" header_3_font_size_tablet=\"\" header_3_font_size_phone=\"26px\" header_3_font_size_last_edited=\"on|desktop\" locked=\"off\" header_3_text_color__hover_enabled=\"on\" header_3_text_color__hover=\"#008a1c\"]<h3>Account Management</h3>\n<p>Curabitur non nulla sit amet nisl tempus convallis quis ac lectus. Nulla porttitor accumsan tincidunt. Sed porttitor lectus nibh. Curabitur non nulla sit amet nisl tempus convallis quis ac lectus. Donec sollicitudin molestie malesuada. Vestibulum ac diam sit a</p>[/et_pb_text][/et_pb_column][et_pb_column type=\"2_5\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_toggle title=\"Quisque velit nisi pretium ut?\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"3.17.6\" title_level=\"h2\" title_font=\"Poppins|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||20px\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>Quisque velit nisi, pretium ut lacinia in, elementum id enim. Sed porttitor lectus nibh. Sed porttitor lectus nibh. Nulla porttitor accumsan tincidunt. Sed porttitor lectus nibh. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus</p>[/et_pb_toggle][et_pb_toggle title=\"Elementum id enim. Sed porttitor lectus nibh? \" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"3.17.6\" title_level=\"h2\" title_font=\"Poppins|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||20px\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>Quisque velit nisi, pretium ut lacinia in, elementum id enim. Sed porttitor lectus nibh. Sed porttitor lectus nibh. Nulla porttitor accumsan tincidunt. Sed porttitor lectus nibh. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus</p>[/et_pb_toggle][et_pb_toggle title=\"Sed porttitor lectus nibh?\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"3.17.6\" title_level=\"h2\" title_font=\"Poppins|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||20px\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>Quisque velit nisi, pretium ut lacinia in, elementum id enim. Sed porttitor lectus nibh. Sed porttitor lectus nibh. Nulla porttitor accumsan tincidunt. Sed porttitor lectus nibh. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus</p>[/et_pb_toggle][et_pb_toggle title=\"Nulla porttitor accumsan tincidunt?\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"3.17.6\" title_level=\"h2\" title_font=\"Poppins|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||20px\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>Quisque velit nisi, pretium ut lacinia in, elementum id enim. Sed porttitor lectus nibh. Sed porttitor lectus nibh. Nulla porttitor accumsan tincidunt. Sed porttitor lectus nibh. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus</p>[/et_pb_toggle][et_pb_toggle title=\"Sed porttitor lectus nibh?\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"3.17.6\" title_level=\"h2\" title_font=\"Poppins|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||20px\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>Quisque velit nisi, pretium ut lacinia in, elementum id enim. Sed porttitor lectus nibh. Sed porttitor lectus nibh. Nulla porttitor accumsan tincidunt. Sed porttitor lectus nibh. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus</p>[/et_pb_toggle][et_pb_toggle title=\"Vivamus magna justo lacinia eget consectetur sed?\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"3.17.6\" title_level=\"h2\" title_font=\"Poppins|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||20px\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>Quisque velit nisi, pretium ut lacinia in, elementum id enim. Sed porttitor lectus nibh. Sed porttitor lectus nibh. Nulla porttitor accumsan tincidunt. Sed porttitor lectus nibh. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus</p>[/et_pb_toggle][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" _builder_version=\"3.22\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\"][et_pb_row _builder_version=\"3.25\" width=\"100%\" max_width=\"100%\" custom_padding=\"0|0px|0|0px|true|false\" border_radii=\"on|30px|30px|30px|30px\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"100%\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_map address=\"San Francisco, CA, USA\" zoom_level=\"17\" address_lat=\"37.7749295\" address_lng=\"-122.4194155\" mouse_wheel=\"off\" _builder_version=\"3.17.6\" locked=\"off\"][et_pb_map_pin pin_address=\"San Francisco, CA, USA\" pin_address_lat=\"37.7749295\" pin_address_lng=\"-122.4194155\" _builder_version=\"3.0.105\"][/et_pb_map_pin][/et_pb_map][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Blog\" _builder_version=\"3.22\"][et_pb_row _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"Poppins|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#0492ff\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>More Resources</h2>[/et_pb_text][et_pb_blog fullwidth=\"off\" posts_number=\"3\" show_pagination=\"off\" _builder_version=\"3.17.6\" header_font=\"Poppins|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_line_height=\"2em\" meta_font=\"Poppins||||||||\" meta_text_color=\"#008a1c\" pagination_font=\"Poppins|700|on||||||\" pagination_text_color=\"#008a1c\" pagination_font_size=\"18px\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"][/et_pb_blog][et_pb_button button_text=\"Subscribe For More\" button_alignment=\"center\" _builder_version=\"3.17.6\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"Poppins|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" prev_background_color=\"#ffffff\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#0f1533\" background_color_gradient_end=\"#1f133a\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||5vw\" custom_padding=\"14vw||10vw\" top_divider_style=\"wave2\" top_divider_height=\"10vw\" top_divider_repeat=\"0.7x\" top_divider_flip=\"vertical\" animation_style=\"fade\" border_radii=\"on|30px|30px|30px|30px\" locked=\"off\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_last_edited=\"on|desktop\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" header_2_font=\"Poppins|900|on||||||\" header_2_font_size=\"5vw\" header_2_letter_spacing=\"2px\" header_2_line_height=\"1.4em\" header_3_font=\"Poppins|900|on|on|||||\" header_3_text_color=\"rgba(255,255,255,0.7)\" header_3_font_size=\"1.5vw\" header_3_letter_spacing=\"0.8em\" header_3_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_font_size__hover=\"30px\" header_font_size__hover_enabled=\"30px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h2>Get The Speeds You Want at the Price You Want</h2>\n<h3>TV & Internet</h3>[/et_pb_text][et_pb_button button_text=\"View All Plans\" button_alignment=\"center\" _builder_version=\"3.17.6\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"Poppins|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section]", "تماس با ما", "", "inherit", "closed", "closed", "", "195-revision-v1", "", "", "2020-04-02 11:51:48", "2020-04-02 08:21:48", "", "195", "http://modelsite.test/195-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2910", "1", "2020-04-02 11:52:47", "2020-04-02 08:22:47", "", "isp-11", "", "inherit", "open", "closed", "", "isp-11", "", "", "2020-04-02 11:52:47", "2020-04-02 08:22:47", "", "0", "http://modelsite.test/wp-content/uploads/2020/04/isp-11.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("2911", "1", "2020-04-02 11:53:05", "2020-04-02 08:23:05", "[et_pb_section fb_built=\"1\" admin_label=\"Header\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-05.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"5vw||||false\" custom_padding=\"6vw||10vw||false|false\" bottom_divider_style=\"wave2\" bottom_divider_color=\"#ffffff\" bottom_divider_height=\"10vw\" bottom_divider_repeat=\"0.7x\" animation_style=\"slide\" animation_direction=\"bottom\" animation_intensity_slide=\"1%\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_last_edited=\"on|desktop\" animation_style=\"slide\" animation_direction=\"left\" animation_intensity_slide=\"10%\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" header_font=\"Poppins|900|on|on|||||\" header_font_size=\"6vw\" header_letter_spacing=\"0.1em\" header_line_height=\"1.2em\" header_2_font=\"Poppins|900|on|on|||||\" header_2_text_color=\"rgba(255,255,255,0.7)\" header_2_font_size=\"2vw\" header_2_letter_spacing=\"0.5em\" header_2_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" header_font_size_tablet=\"50px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|phone\" header_2_font_size_tablet=\"30px\" header_2_font_size_phone=\"20px\" header_2_font_size_last_edited=\"on|phone\" header_text_shadow_style=\"preset1\" header_text_shadow_vertical_length=\"0.3em\" header_text_shadow_blur_strength=\"0.5em\" header_text_shadow_color=\"rgba(0,0,0,0.15)\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h1>Internet Plans</h1>\r\n<p>&nbsp;</p>\r\n<h2><span style=\"color: rgba(0, 0, 0, 0.7);\">Starting at</span> $35/mo</h2>\r[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Features\" _builder_version=\"3.22\"][et_pb_row _builder_version=\"3.25\" custom_padding=\"||||false|false\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"Poppins|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#0492ff\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" text_orientation=\"center\" max_width=\"700px\" module_alignment=\"center\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>All Plans Include</h2>\r[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row use_custom_gutter=\"on\" gutter_width=\"2\" padding_top_bottom_link_1=\"false\" padding_top_bottom_link_2=\"false\" padding_top_bottom_link_3=\"false\" padding_left_right_link_1=\"true\" padding_left_right_link_2=\"true\" padding_left_right_link_3=\"true\" _builder_version=\"3.25\" max_width=\"1160px\" custom_padding=\"0|0px|27px|0px|false|false\" use_custom_width=\"on\" custom_width_px=\"1160px\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\" max_width__hover=\"1080px\" max_width__hover_enabled=\"1080px\" column_structure=\"1_3,1_3,1_3\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-03.png\" background_size=\"contain\" background_position=\"bottom_right\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"Free Standard Installation\" use_icon=\"on\" font_icon=\"%%243%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#a0cf00\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"3.17.6\" header_font=\"Poppins|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>Sed porttitor lectus nibh. Curabitur arcu erat, accumsan id imperdiet et, porttitor at sem. Donec sollicitudin molestie malesuada. Vivamus suscipit tortor eget felis porttitor volutpat.</p>\r[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"18 Month Price Guarantee\" use_icon=\"on\" font_icon=\"%%171%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#a0cf00\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"3.17.6\" header_font=\"Poppins|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>Sed porttitor lectus nibh. Curabitur arcu erat, accumsan id imperdiet et, p</p>\r[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-04.png\" background_size=\"contain\" background_position=\"top_right\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"Not Data Limits\" use_icon=\"on\" font_icon=\"%%231%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#a0cf00\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"3.17.6\" header_font=\"Poppins|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>Sed porttitor lectus nibh. Curabitur arcu erat, accumsan id imperdiet et, po</p>\r[/et_pb_blurb][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Pricing\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#0f1533\" background_color_gradient_end=\"#1f133a\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||40px||false\" custom_padding=\"80px||80px||true\" animation_style=\"slide\" animation_direction=\"bottom\" animation_intensity_slide=\"1%\" border_radii=\"on|30px|30px|30px|30px\" locked=\"off\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\"][et_pb_row _builder_version=\"3.25\" custom_padding=\"||||false|false\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_2_font=\"Poppins|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#0492ff\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" text_orientation=\"center\" background_layout=\"dark\" max_width=\"700px\" module_alignment=\"center\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>Internet Plans</h2>\r[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row use_custom_gutter=\"on\" gutter_width=\"2\" _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\" column_structure=\"1_3,1_3,1_3\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"40px|||\" custom_padding_tablet=\"0px||\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px||\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"3.23\" currency_frequency_text_color=\"#ffffff\" price_text_color=\"#a0cf00\" body_text_color=\"#ffffff\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"Poppins||||||||\" body_text_align=\"center\" subheader_font=\"Poppins|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"Poppins|800|on||||||\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(255,255,255,0)\" background_color_gradient_end=\"rgba(255,255,255,0.16)\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"Poppins|700||on|||||\" animation_style=\"slide\" animation_direction=\"right\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\"][et_pb_pricing_table title=\"Basic Internet\" subtitle=\"85mbps\" currency=\"$\" per=\"mo\" sum=\"35\" button_text=\"Sign Up\" _builder_version=\"3.23\" body_font=\"||||||||\" excluded_text_color=\"rgba(255,255,255,0.5)\" pricing_item_excluded_color=\"rgba(255,255,255,0.5)\"]<p>+ Donec rutrum congue</p>\r\n<p>+ Quisque velit nisi</p>\r\n<p>+ Pretium ut lacinia in</p>\r\n<p>- Elementum id enim</p>\r\n<p>- Pellentesque in ipsum id</p>[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"3.23\" currency_frequency_text_color=\"#a0cf00\" price_text_color=\"rgba(0,0,0,0.75)\" subheader_text_color=\"#000000\" header_text_color=\"#000000\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"Poppins||||||||\" body_text_align=\"center\" subheader_font=\"Poppins|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"Poppins|800|on||||||\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#ffffff\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0f1533\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"Poppins|700||on|||||\" custom_margin=\"||\" animation_style=\"zoom\" animation_delay=\"100ms\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" border_color_all=\"#ffffff\" border_width_top=\"40px\" border_width_bottom=\"30px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" locked=\"off\"][et_pb_pricing_table title=\"Pro Internet\" subtitle=\"120mbps\" currency=\"$\" per=\"mo\" sum=\"85\" button_text=\"Sign Up\" _builder_version=\"3.17.6\" body_font=\"||||||||\"]<p>+ Donec rutrum congue</p>\r\n<p>+ Quisque velit nisi</p>\r\n<p>+ Pretium ut lacinia in</p>\r\n<p>+ Elementum id enim</p>\r\n<p>+ Pellentesque in ipsum id</p>[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"40px|||\" custom_padding_tablet=\"0px||\" custom_padding_last_edited=\"on|desktop\" padding_tablet=\"0px||\" padding_last_edited=\"on|desktop\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"3.23\" currency_frequency_text_color=\"#ffffff\" price_text_color=\"#a0cf00\" body_text_color=\"#ffffff\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"Poppins||||||||\" body_text_align=\"center\" subheader_font=\"Poppins|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"Poppins|800|on||||||\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(255,255,255,0)\" background_color_gradient_end=\"rgba(255,255,255,0.16)\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"Poppins|700||on|||||\" animation_style=\"slide\" animation_direction=\"left\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" locked=\"off\"][et_pb_pricing_table title=\"Internet + TV\" subtitle=\"120mbps\" currency=\"$\" per=\"mo\" sum=\"120\" button_text=\"Sign Up\" _builder_version=\"3.23\" body_font=\"||||||||\" excluded_text_color=\"rgba(255,255,255,0.5)\" pricing_item_excluded_color=\"rgba(255,255,255,0.5)\"]<p>+ Donec rutrum congue</p>\r\n<p>+ Quisque velit nisi</p>\r\n<p>+ Pretium ut lacinia in</p>\r\n<p>+ Elementum id enim</p>\r\n<p>- Pellentesque in ipsum id</p>[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Info & Bundles\" _builder_version=\"3.22\" background_color=\"#f2f5fa\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row _builder_version=\"3.25\" custom_margin_tablet=\"40px||40px||true\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"Poppins|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" text_orientation=\"center\" max_width=\"700px\" module_alignment=\"center\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>Which Plan is Right For You?</h2>\r[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" column_structure=\"1_4,1_4,1_4,1_4\"][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_circle_counter title=\"Casual use\" number=\"60mbps\" percent_sign=\"off\" bar_bg_color=\"rgba(48,52,71,0.51)\" _builder_version=\"3.17.6\" title_level=\"h4\" title_font=\"Poppins|700|on||||||\" title_font_size=\"16px\" title_line_height=\"2em\" number_font=\"Poppins|700|on||||||\" number_text_color=\"#000000\" number_font_size=\"28px\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\"][/et_pb_circle_counter][et_pb_blurb title=\"Curabitur arcu erat\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"rgba(48,52,71,0.51)\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"3.17.6\" header_font=\"Poppins|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"Imperdiet et, porttitor\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"rgba(48,52,71,0.51)\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"3.17.6\" header_font=\"Poppins|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"Curabitur arcu erat,\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"rgba(48,52,71,0.51)\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"3.17.6\" header_font=\"Poppins|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" locked=\"off\"][/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_circle_counter title=\"Media Streaming\" number=\"85mbps\" percent_sign=\"off\" bar_bg_color=\"#303447\" _builder_version=\"3.17.6\" title_level=\"h4\" title_font=\"Poppins|700|on||||||\" title_font_size=\"16px\" title_line_height=\"2em\" number_font=\"Poppins|700|on||||||\" number_text_color=\"#000000\" number_font_size=\"28px\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\" locked=\"off\"][/et_pb_circle_counter][et_pb_blurb title=\"Imperdiet et porttitor\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#000000\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"3.17.6\" header_font=\"Poppins|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"Lacinia eget consectet\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#000000\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"3.17.6\" header_font=\"Poppins|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"Curabitur arcu era\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#000000\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"3.17.6\" header_font=\"Poppins|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" locked=\"off\"][/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_circle_counter title=\"Multi-Device\" number=\"120mbps\" percent_sign=\"off\" bar_bg_color=\"#008a1c\" _builder_version=\"3.17.6\" title_level=\"h4\" title_font=\"Poppins|700|on||||||\" title_font_size=\"16px\" title_line_height=\"2em\" number_font=\"Poppins|700|on||||||\" number_text_color=\"#000000\" number_font_size=\"28px\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\" locked=\"off\"][/et_pb_circle_counter][et_pb_blurb title=\"Imperdiet eporttitor\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#008a1c\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"3.17.6\" header_font=\"Poppins|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"Curabitur arcu era\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#008a1c\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"3.17.6\" header_font=\"Poppins|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"Porttitor at sem\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#008a1c\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"3.17.6\" header_font=\"Poppins|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" locked=\"off\"][/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_circle_counter title=\"Best for Businesses\" number=\"120mbps\" percent_sign=\"off\" bar_bg_color=\"#a0cf00\" _builder_version=\"3.17.6\" title_level=\"h4\" title_font=\"Poppins|700|on||||||\" title_font_size=\"16px\" title_line_height=\"2em\" number_font=\"Poppins|700|on||||||\" number_text_color=\"#000000\" number_font_size=\"28px\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\" locked=\"off\"][/et_pb_circle_counter][et_pb_blurb title=\"Curabitur arcu erat,\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#a0cf00\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"3.17.6\" header_font=\"Poppins|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"Imperdiet et porttitor\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#a0cf00\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"3.17.6\" header_font=\"Poppins|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"Lacinia eget consectet\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#a0cf00\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"3.17.6\" header_font=\"Poppins|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" locked=\"off\"][/et_pb_blurb][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_button button_text=\"Need More Help Choosing?\" button_alignment=\"center\" _builder_version=\"3.17.6\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"Poppins|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" custom_margin=\"100px||\" custom_margin_tablet=\"0px||\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"Poppins|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" text_orientation=\"center\" max_width=\"700px\" module_alignment=\"center\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>Get More When You Bundle</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vivamus suscipit tortor eget felis porttitor volutpat. Proin eget tortor risus. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Curabitur non nulla sit amet nisl tempus convallis quis ac lectus. Quisque velit nisi, pretium ut lacinia in, elementum id enim. </p>\r[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\" column_structure=\"3_5,2_5\"][et_pb_column type=\"3_5\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/04/isp-11.png\" align_tablet=\"center\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" module_alignment=\"center\" custom_margin=\"|||-7vw\" custom_margin_tablet=\"|||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\"][/et_pb_image][/et_pb_column][et_pb_column type=\"2_5\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"Better Value\" url=\"#\" use_icon=\"on\" font_icon=\"%%155%%\" icon_color=\"#a0cf00\" use_circle=\"on\" circle_color=\"#ffffff\" icon_placement=\"left\" use_icon_font_size=\"on\" icon_font_size=\"22px\" _builder_version=\"3.17.6\" header_font=\"Poppins|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" background_color=\"#303447\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"20px|20px|20px|20px|true|true\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" background__hover_enabled=\"on\" background_color__hover=\"#008a1c\"]<p>Sed porttitor lectus nibh. Curabitur arcu erat, accumsan id imperdie</p>\r[/et_pb_blurb][et_pb_blurb title=\"Connected Devices\" url=\"#\" use_icon=\"on\" font_icon=\"%%104%%\" icon_color=\"#a0cf00\" use_circle=\"on\" circle_color=\"#ffffff\" icon_placement=\"left\" use_icon_font_size=\"on\" icon_font_size=\"22px\" _builder_version=\"3.17.6\" header_font=\"Poppins|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" background_color=\"#303447\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"20px|20px|20px|20px|true|true\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" background__hover_enabled=\"on\" background_color__hover=\"#008a1c\"]<p>Sed porttitor lectus nibh. Curabitur arcu erat, accutitor volutpat.</p>\r[/et_pb_blurb][et_pb_blurb title=\"Custom Packages\" url=\"#\" use_icon=\"on\" font_icon=\"%%70%%\" icon_color=\"#a0cf00\" use_circle=\"on\" circle_color=\"#ffffff\" icon_placement=\"left\" use_icon_font_size=\"on\" icon_font_size=\"22px\" _builder_version=\"3.17.6\" header_font=\"Poppins|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" background_color=\"#303447\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"20px|20px|20px|20px|true|true\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" background__hover_enabled=\"on\" background_color__hover=\"#008a1c\"]<p>Sed porttitor lectus nibh. Curabitur arcu erat, accumsan id imperdie</p>\r[/et_pb_blurb][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_button button_text=\"Customize Your Package\" button_alignment=\"center\" _builder_version=\"3.17.6\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"Poppins|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"FAQ\" _builder_version=\"3.22\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" max_width__hover=\"100%\" max_width__hover_enabled=\"100%\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" inner_shadow__hover=\"off\" inner_shadow__hover_enabled=\"off\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_row _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"Poppins|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2> F.A.Q.</h2>\r[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\" column_structure=\"1_2,1_2\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_toggle title=\"Nulla porttitor accumsan tincidunt?\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"3.17.6\" title_level=\"h2\" title_font=\"Poppins|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||20px\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>Quisque velit nisi, pretium ut lacinia in, elementum id enim. Sed porttitor lectus nibh. Sed porttitor lectus nibh. Nulla porttitor accumsan tincidunt. Sed porttitor lectus nibh. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus</p>\r[/et_pb_toggle][et_pb_toggle title=\"Sed porttitor lectus nibh?\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"3.17.6\" title_level=\"h2\" title_font=\"Poppins|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||20px\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>Quisque velit nisi, pretium ut lacinia in, elementum id enim. Sed porttitor lectus nibh. Sed porttitor lectus nibh. Nulla porttitor accumsan tincidunt. Sed porttitor lectus nibh. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus</p>\r[/et_pb_toggle][et_pb_toggle title=\"Vivamus magna justo lacinia eget consectetur?\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"3.17.6\" title_level=\"h2\" title_font=\"Poppins|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||20px\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>Quisque velit nisi, pretium ut lacinia in, elementum id enim. Sed porttitor lectus nibh. Sed porttitor lectus nibh. Nulla porttitor accumsan tincidunt. Sed porttitor lectus nibh. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus</p>\r[/et_pb_toggle][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_toggle title=\"Quisque velit nisi pretium ut?\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"3.17.6\" title_level=\"h2\" title_font=\"Poppins|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||20px\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>Quisque velit nisi, pretium ut lacinia in, elementum id enim. Sed porttitor lectus nibh. Sed porttitor lectus nibh. Nulla porttitor accumsan tincidunt. Sed porttitor lectus nibh. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus</p>\r[/et_pb_toggle][et_pb_toggle title=\"Elementum id enim. Sed porttitor lectus nibh? \" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"3.17.6\" title_level=\"h2\" title_font=\"Poppins|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||20px\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>Quisque velit nisi, pretium ut lacinia in, elementum id enim. Sed porttitor lectus nibh. Sed porttitor lectus nibh. Nulla porttitor accumsan tincidunt. Sed porttitor lectus nibh. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus</p>\r[/et_pb_toggle][et_pb_toggle title=\"Sed porttitor lectus nibh?\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"3.17.6\" title_level=\"h2\" title_font=\"Poppins|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||20px\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>Quisque velit nisi, pretium ut lacinia in, elementum id enim. Sed porttitor lectus nibh. Sed porttitor lectus nibh. Nulla porttitor accumsan tincidunt. Sed porttitor lectus nibh. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus</p>\r[/et_pb_toggle][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_button button_text=\"Ask a Question\" button_alignment=\"center\" _builder_version=\"3.17.6\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"Poppins|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#0f1533\" background_color_gradient_end=\"#1f133a\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||5vw\" custom_padding=\"14vw||10vw\" top_divider_style=\"wave2\" top_divider_color=\"#ffffff\" top_divider_height=\"10vw\" top_divider_repeat=\"0.7x\" top_divider_flip=\"vertical\" animation_style=\"fade\" border_radii=\"on|30px|30px|30px|30px\" locked=\"off\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_last_edited=\"on|desktop\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" header_2_font=\"Poppins|900|on||||||\" header_2_font_size=\"5vw\" header_2_letter_spacing=\"2px\" header_2_line_height=\"1.4em\" header_3_font=\"Poppins|900|on|on|||||\" header_3_text_color=\"rgba(255,255,255,0.7)\" header_3_font_size=\"1.5vw\" header_3_letter_spacing=\"0.8em\" header_3_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_font_size__hover=\"30px\" header_font_size__hover_enabled=\"30px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h2>Get The Speeds You Want at the Price You Want</h2>\r\n<h3>TV & Internet</h3>\r[/et_pb_text][et_pb_button button_text=\"View All Plans\" button_alignment=\"center\" _builder_version=\"3.17.6\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"Poppins|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section]", "خدمات", "", "inherit", "closed", "closed", "", "899-revision-v1", "", "", "2020-04-02 11:53:05", "2020-04-02 08:23:05", "", "899", "http://modelsite.test/899-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2913", "1", "2020-04-02 11:53:44", "2020-04-02 08:23:44", "", "isp-10", "", "inherit", "open", "closed", "", "isp-10", "", "", "2020-04-02 11:53:44", "2020-04-02 08:23:44", "", "0", "http://modelsite.test/wp-content/uploads/2020/04/isp-10.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("2914", "1", "2020-04-02 11:53:57", "2020-04-02 08:23:57", "", "isp-08", "", "inherit", "open", "closed", "", "isp-08-2", "", "", "2020-04-02 11:53:57", "2020-04-02 08:23:57", "", "0", "http://modelsite.test/wp-content/uploads/2020/04/isp-08.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("2915", "1", "2020-04-02 11:54:10", "2020-04-02 08:24:10", "[et_pb_section fb_built=\"1\" admin_label=\"Header\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#0f1533\" background_color_gradient_end=\"#1f133a\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-10.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"5vw||||false\" custom_padding=\"14vw||18vw||false|false\" bottom_divider_style=\"wave2\" bottom_divider_color=\"#ffffff\" bottom_divider_height=\"10vw\" bottom_divider_repeat=\"0.7x\" animation_style=\"slide\" animation_direction=\"bottom\" animation_intensity_slide=\"1%\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_last_edited=\"on|desktop\" animation_style=\"slide\" animation_direction=\"left\" animation_intensity_slide=\"10%\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" header_font=\"Poppins|900|on|on|||||\" header_font_size=\"6vw\" header_letter_spacing=\"0.1em\" header_line_height=\"1.2em\" header_2_font=\"Poppins|900|on|on|||||\" header_2_text_color=\"rgba(255,255,255,0.7)\" header_2_font_size=\"2vw\" header_2_letter_spacing=\"0.5em\" header_2_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" header_font_size_tablet=\"50px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|phone\" header_2_font_size_tablet=\"30px\" header_2_font_size_phone=\"20px\" header_2_font_size_last_edited=\"on|phone\" header_text_shadow_style=\"preset1\" header_text_shadow_vertical_length=\"0.3em\" header_text_shadow_blur_strength=\"0.5em\" header_text_shadow_color=\"rgba(0,0,0,0.15)\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h1>About Divi</h1>\n<p>&nbsp;</p>\n<h2>Internet Service Provider</h2>[/et_pb_text][et_pb_button button_text=\"All Internet & TV Offers\" button_alignment=\"center\" _builder_version=\"3.17.6\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"Poppins|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" bg_img_1=\"http://modelsite.test/wp-content/uploads/2020/04/isp-03.png\" background_size_1=\"contain\" background_position_1=\"bottom_right\" background_repeat_1=\"no-repeat\" padding_top_bottom_link_1=\"false\" padding_left_right_link_1=\"true\" padding_right_1=\"40px\" padding_bottom_1=\"80px\" padding_left_1=\"40px\" admin_label=\"About\" _builder_version=\"3.22\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" background_size=\"contain\" background_position=\"bottom_right\" custom_padding=\"|||\" padding_bottom__hover=\"80px\" padding_left__hover=\"40px\" padding_right__hover=\"40px\" bg_img__hover=\"http://modelsite.test/wp-content/uploads/2020/04/isp-03.png\" parallax__hover=\"off\" parallax_method__hover=\"on\" background_size__hover=\"contain\" background_position__hover=\"bottom_right\" background_repeat__hover=\"no-repeat\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"Poppins|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\" text_line_height__hover=\"1.7em\" text_line_height__hover_enabled=\"1.7em\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" max_width__hover=\"100%\" max_width__hover_enabled=\"100%\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" text_font_size__hover=\"14px\" text_font_size__hover_enabled=\"14px\" text_letter_spacing__hover=\"0px\" text_letter_spacing__hover_enabled=\"0px\" text_text_shadow_style__hover=\"none\" text_text_shadow_style__hover_enabled=\"none\" text_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" text_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" link_font_size__hover=\"14px\" link_font_size__hover_enabled=\"14px\" link_letter_spacing__hover=\"0px\" link_letter_spacing__hover_enabled=\"0px\" link_line_height__hover=\"1em\" link_line_height__hover_enabled=\"1em\" link_text_shadow_style__hover=\"none\" link_text_shadow_style__hover_enabled=\"none\" link_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" link_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" ul_font_size__hover=\"14px\" ul_font_size__hover_enabled=\"14px\" ul_letter_spacing__hover=\"0px\" ul_letter_spacing__hover_enabled=\"0px\" ul_line_height__hover=\"1em\" ul_line_height__hover_enabled=\"1em\" ul_text_shadow_style__hover=\"none\" ul_text_shadow_style__hover_enabled=\"none\" ul_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" ul_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" ol_font_size__hover=\"14px\" ol_font_size__hover_enabled=\"14px\" ol_letter_spacing__hover=\"0px\" ol_letter_spacing__hover_enabled=\"0px\" ol_line_height__hover=\"1em\" ol_line_height__hover_enabled=\"1em\" ol_text_shadow_style__hover=\"none\" ol_text_shadow_style__hover_enabled=\"none\" ol_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" ol_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" quote_font_size__hover=\"14px\" quote_font_size__hover_enabled=\"14px\" quote_letter_spacing__hover=\"0px\" quote_letter_spacing__hover_enabled=\"0px\" quote_line_height__hover=\"1em\" quote_line_height__hover_enabled=\"1em\" quote_text_shadow_style__hover=\"none\" quote_text_shadow_style__hover_enabled=\"none\" quote_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" quote_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_font_size__hover=\"30px\" header_font_size__hover_enabled=\"30px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" text_orientation__hover=\"left\" text_orientation__hover_enabled=\"left\" background_layout__hover=\"light\" background_layout__hover_enabled=\"light\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"]<h2>Your #1 Choice For Fiber Internet</h2>\n<p>Curabitur non nulla sit amet nisl tempus convallis quis ac lectus. Nulla porttitor accumsan tincidunt. Sed porttitor lectus nibh. Curabitur non nulla sit amet nisl tempus convallis quis ac lectus. Donec sollicitudin molestie malesuada. Vestibulum ac diam sit amet quam vehicula elementum sed sit amet dui. Donec sollicit Curabitur non nulla sit amet nisl tempus convallis quis ac lectus. Nulla porttitor accumsan tincidunt. Sed porttitor lectus nibh. Curabitur non nulla sit amet nisl tempus convallis quis ac lectus. Donec sollicitudin molestie malesuada. Vestibulum ac diam sit amet quam vehicula elementum sed sit amet du</p>[/et_pb_text][et_pb_button button_text=\"internet Plans\" button_alignment=\"left\" _builder_version=\"3.17.6\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"Poppins|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_row_inner _builder_version=\"3.25\" custom_padding=\"|40px|50px|40px||true\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\"][et_pb_column_inner saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"Poppins|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\"]<h2>Why Choose Divi</h2>[/et_pb_text][et_pb_blurb title=\"No Contract\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#a0cf00\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"3.17.6\" header_font=\"Poppins|700|on||||||\" header_font_size=\"16px\" header_line_height=\"2em\" custom_margin=\"||20px\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"Up to 175mbps\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#a0cf00\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"3.17.6\" header_font=\"Poppins|700|on||||||\" header_font_size=\"16px\" header_line_height=\"2em\" custom_margin=\"||20px\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"Hardware Included\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#a0cf00\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"3.17.6\" header_font=\"Poppins|700|on||||||\" header_font_size=\"16px\" header_line_height=\"2em\" custom_margin=\"||20px\" locked=\"off\"][/et_pb_blurb][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Features\" _builder_version=\"3.22\" background_color=\"#f2f5fa\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_padding=\"54px|0px|0|0px|false|false\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row _builder_version=\"3.25\" custom_margin=\"100px||100px||true\" custom_margin_tablet=\"40px||40px||true\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" column_structure=\"3_5,2_5\"][et_pb_column type=\"3_5\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/04/isp-01.png\" align_tablet=\"center\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"|||-7vw\" custom_margin_tablet=\"|||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\"][/et_pb_image][/et_pb_column][et_pb_column type=\"2_5\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"Poppins|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>Keeping People Connected All Over the World</h2>\n<h3></h3>\n<p>Curabitur non nulla sit amet nisl tempus convallis quis ac lectus. Nulla porttitor accumsan tincidunt. Sed porttitor lectus nibh. Curabitur non nulla sit amet nisl tempus convallis quis ac lectus. Donec sollicitudin molestie malesuada. Vestibulum ac diam sit amet quam vehicula elementum sed sit amet dui. Donec sollicit</p>[/et_pb_text][et_pb_button button_text=\"Get Started Today\" button_alignment=\"left\" _builder_version=\"3.17.6\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"Poppins|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Value\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(255,255,255,0)\" background_color_gradient_end=\"#ffffff\" background_color_gradient_type=\"radial\" background_color_gradient_start_position=\"50%\" background_color_gradient_overlays_image=\"on\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.jpg\" custom_padding=\"10vw|0px|10vw|0px|true|false\"][et_pb_row use_custom_gutter=\"on\" gutter_width=\"2\" padding_top_bottom_link_1=\"false\" padding_top_bottom_link_2=\"false\" padding_top_bottom_link_3=\"false\" padding_left_right_link_1=\"true\" padding_left_right_link_2=\"true\" padding_left_right_link_3=\"true\" _builder_version=\"3.25\" max_width=\"1160px\" custom_padding=\"0|0px|27px|0px|false|false\" use_custom_width=\"on\" custom_width_px=\"1160px\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\" max_width__hover=\"1080px\" max_width__hover_enabled=\"1080px\" column_structure=\"1_3,1_3,1_3\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-03.png\" background_size=\"contain\" background_position=\"bottom_right\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"Free Standard Installation\" use_icon=\"on\" font_icon=\"%%243%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#a0cf00\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"3.17.6\" header_font=\"Poppins|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>Sed porttitor lectus nibh. Curabitur arcu erat, accumsan id imperdiet et, porttitor at sem. Donec sollicitudin molestie malesuada. Vivamus suscipit tortor eget felis porttitor volutpat.</p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"18 Month Price Guarantee\" use_icon=\"on\" font_icon=\"%%171%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#a0cf00\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"3.17.6\" header_font=\"Poppins|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>Sed porttitor lectus nibh. Curabitur arcu erat, accumsan id imperdiet et, porttitor at sem. Donec sollicitudin molestie malesuada. Vivamus suscipit tortor eget felis porttitor volutpat.</p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-04.png\" background_size=\"contain\" background_position=\"top_right\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"Not Data Limits\" use_icon=\"on\" font_icon=\"%%231%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#a0cf00\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"3.17.6\" header_font=\"Poppins|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>Sed porttitor lectus nibh. Curabitur arcu erat, accumsan id imperdiet et, porttitor at sem. Donec sollicitudin molestie malesuada. Vivamus suscipit tortor eget felis porttitor volutpat.</p>[/et_pb_blurb][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" prev_background_color=\"#ffffff\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#0f1533\" background_color_gradient_end=\"#1f133a\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||5vw\" custom_padding=\"14vw||10vw\" top_divider_style=\"wave2\" top_divider_height=\"10vw\" top_divider_repeat=\"0.7x\" top_divider_flip=\"vertical\" animation_style=\"fade\" border_radii=\"on|30px|30px|30px|30px\" locked=\"off\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_last_edited=\"on|desktop\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" header_2_font=\"Poppins|900|on||||||\" header_2_font_size=\"5vw\" header_2_letter_spacing=\"2px\" header_2_line_height=\"1.4em\" header_3_font=\"Poppins|900|on|on|||||\" header_3_text_color=\"rgba(255,255,255,0.7)\" header_3_font_size=\"1.5vw\" header_3_letter_spacing=\"0.8em\" header_3_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_font_size__hover=\"30px\" header_font_size__hover_enabled=\"30px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h2>Get The Speeds You Want at the Price You Want</h2>\n<h3>TV & Internet</h3>[/et_pb_text][et_pb_button button_text=\"View All Plans\" button_alignment=\"center\" _builder_version=\"3.17.6\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"Poppins|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section]", "درباره ما", "", "inherit", "closed", "closed", "", "187-revision-v1", "", "", "2020-04-02 11:54:10", "2020-04-02 08:24:10", "", "187", "http://modelsite.test/187-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2917", "1", "2020-04-02 11:54:51", "2020-04-02 08:24:51", "", "tech-01", "", "inherit", "open", "closed", "", "tech-01", "", "", "2020-04-02 11:54:51", "2020-04-02 08:24:51", "", "0", "http://modelsite.test/wp-content/uploads/2020/04/tech-01.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("2918", "1", "2020-04-02 11:54:54", "2020-04-02 08:24:54", "", "tech-04", "", "inherit", "open", "closed", "", "tech-04", "", "", "2020-04-02 11:54:54", "2020-04-02 08:24:54", "", "0", "http://modelsite.test/wp-content/uploads/2020/04/tech-04.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("2919", "1", "2020-04-02 11:54:57", "2020-04-02 08:24:57", "", "tech-05", "", "inherit", "open", "closed", "", "tech-05", "", "", "2020-04-02 11:54:57", "2020-04-02 08:24:57", "", "0", "http://modelsite.test/wp-content/uploads/2020/04/tech-05.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("2920", "1", "2020-04-02 11:55:02", "2020-04-02 08:25:02", "", "business-03", "", "inherit", "open", "closed", "", "business-03", "", "", "2020-04-02 11:55:02", "2020-04-02 08:25:02", "", "0", "http://modelsite.test/wp-content/uploads/2020/04/business-03.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("2922", "1", "2020-04-02 11:55:52", "2020-04-02 08:25:52", "[et_pb_section fb_built=\"1\" admin_label=\"Header\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-05.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"5vw||||false\" custom_padding=\"6vw||10vw||false|false\" bottom_divider_style=\"wave2\" bottom_divider_color=\"#ffffff\" bottom_divider_height=\"10vw\" bottom_divider_repeat=\"0.7x\" animation_style=\"slide\" animation_direction=\"bottom\" animation_intensity_slide=\"1%\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_last_edited=\"on|desktop\" animation_style=\"slide\" animation_direction=\"left\" animation_intensity_slide=\"10%\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" header_font=\"Poppins|900|on|on|||||\" header_font_size=\"6vw\" header_letter_spacing=\"0.1em\" header_line_height=\"1.2em\" header_2_font=\"Poppins|900|on|on|||||\" header_2_text_color=\"rgba(255,255,255,0.7)\" header_2_font_size=\"2vw\" header_2_letter_spacing=\"0.5em\" header_2_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" header_font_size_tablet=\"50px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|phone\" header_2_font_size_tablet=\"30px\" header_2_font_size_phone=\"20px\" header_2_font_size_last_edited=\"on|phone\" header_text_shadow_style=\"preset1\" header_text_shadow_vertical_length=\"0.3em\" header_text_shadow_blur_strength=\"0.5em\" header_text_shadow_color=\"rgba(0,0,0,0.15)\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h1>Blog &amp; Resources</h1>[/et_pb_text][et_pb_signup mailchimp_list=\"elegantthemestest|26e9af0331\" layout=\"top_bottom\" first_name_field=\"off\" last_name_field=\"off\" _builder_version=\"3.23\" form_field_background_color=\"rgba(48,52,71,0.18)\" form_field_text_color=\"#ffffff\" form_field_font=\"Poppins|600|||||||\" form_field_line_height=\"2em\" use_background_color=\"off\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"Poppins|700||on|||||\" max_width=\"800px\" module_alignment=\"center\" border_radii_fields=\"on|15px|15px|15px|15px\" box_shadow_style_button=\"preset3\" box_shadow_vertical_button=\"20px\" box_shadow_blur_button=\"80px\" box_shadow_spread_button=\"-20px\"][/et_pb_signup][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Categories\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(242,245,250,0)\" background_color_gradient_end=\"#f2f5fa\" background_color_gradient_direction=\"90deg\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||60px\" custom_margin_tablet=\"||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|desktop\" custom_padding=\"0||0px||false|false\" border_radii=\"on|60px|60px|60px|60px\" locked=\"off\"][et_pb_row use_custom_gutter=\"on\" gutter_width=\"2\" _builder_version=\"3.25\" locked=\"off\" column_structure=\"1_6,1_6,1_6,1_6,1_6,1_6\"][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"Poppins|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#008a1c\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" box_shadow_color__hover_enabled=\"on\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\"]<p>Internet</p>[/et_pb_text][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"Poppins|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#a0cf00\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" locked=\"off\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" box_shadow_color__hover_enabled=\"on\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\"]<p>Promos</p>[/et_pb_text][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"Poppins|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#ffffff\" text_orientation=\"center\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" locked=\"off\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" box_shadow_color__hover_enabled=\"on\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\" background_layout__hover_enabled=\"on\" background_layout__hover=\"dark\"]<p>Tutorials</p>[/et_pb_text][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Blog\" _builder_version=\"3.22\"][et_pb_row _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_blog fullwidth=\"off\" posts_number=\"9\" _builder_version=\"3.17.6\" header_font=\"Poppins|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_line_height=\"2em\" meta_font=\"Poppins||||||||\" meta_text_color=\"#008a1c\" pagination_font=\"Poppins|700|on||||||\" pagination_text_color=\"#008a1c\" pagination_font_size=\"18px\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"][/et_pb_blog][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Videos\" _builder_version=\"3.22\" background_color=\"#f2f5fa\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_padding=\"54px|0px|0|0px|false|false\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row _builder_version=\"3.25\" custom_margin_tablet=\"40px||40px||true\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"Poppins|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2><strong>Help Videos</strong> </h2>\n<h3>Curabitur non nulla sit amet nisl tempus conva</h3>[/et_pb_text][et_pb_video_slider show_image_overlay=\"on\" play_icon_color=\"#000000\" _builder_version=\"3.17.6\"][et_pb_video_slider_item src=\"https://www.youtube.com/watch?v=FkQuawiGWUw\" image_src=\"http://modelsite.test/wp-content/uploads/2020/04/tech-01.jpg\" _builder_version=\"3.17.6\" show_image_overlay=\"on\"][/et_pb_video_slider_item][et_pb_video_slider_item src=\"https://www.youtube.com/watch?v=FkQuawiGWUw\" image_src=\"http://modelsite.test/wp-content/uploads/2020/04/tech-04.jpg\" _builder_version=\"3.17.6\" show_image_overlay=\"on\"][/et_pb_video_slider_item][et_pb_video_slider_item src=\"https://www.youtube.com/watch?v=FkQuawiGWUw\" image_src=\"http://modelsite.test/wp-content/uploads/2020/04/tech-05.jpg\" _builder_version=\"3.17.6\" show_image_overlay=\"on\"][/et_pb_video_slider_item][et_pb_video_slider_item src=\"https://www.youtube.com/watch?v=FkQuawiGWUw\" image_src=\"http://modelsite.test/wp-content/uploads/2020/04/business-03.jpg\" _builder_version=\"3.17.6\" show_image_overlay=\"on\"][/et_pb_video_slider_item][/et_pb_video_slider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonials\" _builder_version=\"3.22\"][et_pb_row padding_top_bottom_link_1=\"true\" padding_top_bottom_link_2=\"true\" padding_left_right_link_1=\"false\" padding_left_right_link_2=\"false\" _builder_version=\"3.25\" column_structure=\"2_5,3_5\"][et_pb_column type=\"2_5\" _builder_version=\"3.25\" custom_padding=\"60px|60px|60px|\" custom_padding_tablet=\"0px||0px||true\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px||0px||true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"Poppins|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>Frequently Asked Questions &amp; Popular Topics</h2>\n<h3>Curabitur non nulla sit amet nisl tempus convallis quis ac lectus</h3>[/et_pb_text][et_pb_button button_text=\"Ask a Question\" button_alignment=\"left\" _builder_version=\"3.17.6\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"Poppins|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\"][/et_pb_button][/et_pb_column][et_pb_column type=\"3_5\" _builder_version=\"3.25\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" background_size=\"initial\" background_position=\"bottom_right\" custom_padding=\"60px|60px|60px|\" custom_padding_tablet=\"40px|40px|40px|40px|true|true\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"40px|40px|40px|40px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_toggle title=\"Quisque velit nisi pretium ut?\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"3.17.6\" title_level=\"h2\" title_font=\"Poppins|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||0px|-30px\" border_radii=\"|15px|15px||\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>Quisque velit nisi, pretium ut lacinia in, elementum id enim. Sed porttitor lectus nibh. Sed porttitor lectus nibh. Nulla porttitor accumsan tincidunt. Sed porttitor lectus nibh. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus</p>[/et_pb_toggle][et_pb_toggle title=\"Elementum id enim. Sed porttitor lectus nibh? \" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"3.17.6\" title_level=\"h2\" title_font=\"Poppins|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||0px|-30px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>Quisque velit nisi, pretium ut lacinia in, elementum id enim. Sed porttitor lectus nibh. Sed porttitor lectus nibh. Nulla porttitor accumsan tincidunt. Sed porttitor lectus nibh. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus</p>[/et_pb_toggle][et_pb_toggle title=\"Sed porttitor lectus nibh?\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"3.17.6\" title_level=\"h2\" title_font=\"Poppins|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||0px|-30px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>Quisque velit nisi, pretium ut lacinia in, elementum id enim. Sed porttitor lectus nibh. Sed porttitor lectus nibh. Nulla porttitor accumsan tincidunt. Sed porttitor lectus nibh. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus</p>[/et_pb_toggle][et_pb_toggle title=\"Nulla porttitor accumsan tincidunt?\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"3.17.6\" title_level=\"h2\" title_font=\"Poppins|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||0px|-30px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>Quisque velit nisi, pretium ut lacinia in, elementum id enim. Sed porttitor lectus nibh. Sed porttitor lectus nibh. Nulla porttitor accumsan tincidunt. Sed porttitor lectus nibh. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus</p>[/et_pb_toggle][et_pb_toggle title=\"Sed porttitor lectus nibh?\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"3.17.6\" title_level=\"h2\" title_font=\"Poppins|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||0px|-30px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>Quisque velit nisi, pretium ut lacinia in, elementum id enim. Sed porttitor lectus nibh. Sed porttitor lectus nibh. Nulla porttitor accumsan tincidunt. Sed porttitor lectus nibh. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus</p>[/et_pb_toggle][et_pb_toggle title=\"Vivamus magna justo lacinia eget consectetur sed?\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"3.17.6\" title_level=\"h2\" title_font=\"Poppins|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||0px|-30px\" border_radii=\"|||15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>Quisque velit nisi, pretium ut lacinia in, elementum id enim. Sed porttitor lectus nibh. Sed porttitor lectus nibh. Nulla porttitor accumsan tincidunt. Sed porttitor lectus nibh. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus</p>[/et_pb_toggle][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" prev_background_color=\"#ffffff\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#0f1533\" background_color_gradient_end=\"#1f133a\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||5vw\" custom_padding=\"14vw||10vw\" top_divider_style=\"wave2\" top_divider_height=\"10vw\" top_divider_repeat=\"0.7x\" top_divider_flip=\"vertical\" animation_style=\"fade\" border_radii=\"on|30px|30px|30px|30px\" locked=\"off\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_last_edited=\"on|desktop\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" header_2_font=\"Poppins|900|on||||||\" header_2_font_size=\"5vw\" header_2_letter_spacing=\"2px\" header_2_line_height=\"1.4em\" header_3_font=\"Poppins|900|on|on|||||\" header_3_text_color=\"rgba(255,255,255,0.7)\" header_3_font_size=\"1.5vw\" header_3_letter_spacing=\"0.8em\" header_3_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_font_size__hover=\"30px\" header_font_size__hover_enabled=\"30px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h2>Get The Speeds You Want at the Price You Want</h2>\n<h3>TV & Internet</h3>[/et_pb_text][et_pb_button button_text=\"View All Plans\" button_alignment=\"center\" _builder_version=\"3.17.6\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"Poppins|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section]", "وبلاگ", "", "inherit", "closed", "closed", "", "267-revision-v1", "", "", "2020-04-02 11:55:52", "2020-04-02 08:25:52", "", "267", "http://modelsite.test/267-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2923", "1", "2020-04-02 11:56:21", "2020-04-02 08:26:21", "[et_pb_section fb_built=\"1\" _builder_version=\"4.4.2\" bottom_divider_style=\"asymmetric2\" bottom_divider_color=\"#dfab82\" hover_enabled=\"0\"][et_pb_row _builder_version=\"4.4.2\"][et_pb_column type=\"4_4\" _builder_version=\"4.4.2\"][dsm_gradient_text gradient_text=\"گالری نمونه کارها\" _builder_version=\"4.4.2\" header_text_color=\"#ff8675\" background_color_gradient_start=\"#ff8675\"][/dsm_gradient_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" _builder_version=\"4.4.2\" bottom_divider_color=\"#ff8675\"][et_pb_row _builder_version=\"4.4.2\"][et_pb_column type=\"4_4\" _builder_version=\"4.4.2\"][et_pb_gallery gallery_ids=\"2797,2783,2802,2782\" orientation=\"portrait\" hover_icon=\"%%16%%\" _builder_version=\"4.4.2\" hover_enabled=\"0\"][/et_pb_gallery][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" _builder_version=\"4.4.2\" bottom_divider_style=\"graph2\" bottom_divider_color=\"#dfab82\" hover_enabled=\"0\"][/et_pb_section]", "خدمات طرح دوم", "", "inherit", "closed", "closed", "", "2392-revision-v1", "", "", "2020-04-02 11:56:21", "2020-04-02 08:26:21", "", "2392", "http://modelsite.test/2392-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2924", "1", "2020-04-02 11:57:03", "2020-04-02 08:27:03", "[et_pb_section fb_built=\"1\" admin_label=\"Header\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-05.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"5vw||||false\" custom_padding=\"6vw||10vw||false|false\" bottom_divider_style=\"wave2\" bottom_divider_color=\"#ffffff\" bottom_divider_height=\"10vw\" bottom_divider_repeat=\"0.7x\" animation_style=\"slide\" animation_direction=\"bottom\" animation_intensity_slide=\"1%\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_last_edited=\"on|desktop\" animation_style=\"slide\" animation_direction=\"left\" animation_intensity_slide=\"10%\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" header_font=\"Poppins|900|on|on|||||\" header_font_size=\"6vw\" header_letter_spacing=\"0.1em\" header_line_height=\"1.2em\" header_2_font=\"Poppins|900|on|on|||||\" header_2_text_color=\"rgba(255,255,255,0.7)\" header_2_font_size=\"2vw\" header_2_letter_spacing=\"0.5em\" header_2_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" header_font_size_tablet=\"50px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|phone\" header_2_font_size_tablet=\"30px\" header_2_font_size_phone=\"20px\" header_2_font_size_last_edited=\"on|phone\" header_text_shadow_style=\"preset1\" header_text_shadow_vertical_length=\"0.3em\" header_text_shadow_blur_strength=\"0.5em\" header_text_shadow_color=\"rgba(0,0,0,0.15)\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h1>65<strong>MBPS</strong></h1>\n<p>&nbsp;</p>\n<h2><span style=\"color: rgba(0, 0, 0, 0.7);\">Basic Internet</span></h2>[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"About\" _builder_version=\"3.22\"][et_pb_row _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\" column_structure=\"1_2,1_2\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"3.23\" currency_frequency_text_color=\"#a0cf00\" price_text_color=\"rgba(0,0,0,0.75)\" subheader_text_color=\"#000000\" header_text_color=\"#000000\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"Poppins||||||||\" body_text_align=\"center\" subheader_font=\"Poppins|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"Poppins|800|on||||||\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#ffffff\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0f1533\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"Poppins|700||on|||||\" custom_margin=\"||\" animation_style=\"zoom\" animation_delay=\"100ms\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" border_color_all=\"#ffffff\" border_width_top=\"40px\" border_width_bottom=\"30px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" locked=\"off\"][et_pb_pricing_table title=\"Basic Internet\" subtitle=\"65mbps\" currency=\"$\" per=\"mo\" sum=\"85\" button_text=\"Sign Up\" _builder_version=\"3.17.6\" body_font=\"||||||||\"]<p>+ Donec rutrum congue</p>\n<p>+ Quisque velit nisi</p>\n<p>+ Pretium ut lacinia in</p>\n<p>+ Elementum id enim</p>\n<p>+ Pellentesque in ipsum id</p>[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"100px|||\" custom_padding_last_edited=\"on|tablet\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"Poppins|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" module_alignment=\"center\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>What Does 65mbps Get Me?</h2>\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vivamus suscipit tortor eget felis porttitor volutpat. Proin eget tortor risus. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Curabitur non nulla sit amentum id enim. </p>[/et_pb_text][et_pb_blurb title=\"Lacinia eget consectet\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#000000\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"3.17.6\" header_font=\"Poppins|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"Pellentesque in ipsum id\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#000000\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"3.17.6\" header_font=\"Poppins|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"Donec rutrum congue\n\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#000000\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"3.17.6\" header_font=\"Poppins|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" locked=\"off\"][/et_pb_blurb][et_pb_button button_text=\"Need More Help Choosing?\" button_alignment=\"left\" _builder_version=\"3.17.6\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"Poppins|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Details\" _builder_version=\"3.22\"][et_pb_row _builder_version=\"3.25\" custom_margin_tablet=\"40px||40px||true\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"Poppins|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" text_orientation=\"center\" max_width=\"700px\" module_alignment=\"center\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>What\'s Included</h2>[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row use_custom_gutter=\"on\" gutter_width=\"2\" padding_top_bottom_link_1=\"false\" padding_top_bottom_link_2=\"false\" padding_top_bottom_link_3=\"false\" padding_left_right_link_1=\"true\" padding_left_right_link_2=\"true\" padding_left_right_link_3=\"true\" _builder_version=\"3.25\" max_width=\"1160px\" custom_margin=\"||80px\" custom_padding=\"0|0px|27px|0px|false|false\" use_custom_width=\"on\" custom_width_px=\"1160px\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\" max_width__hover=\"1080px\" max_width__hover_enabled=\"1080px\" column_structure=\"1_3,1_3,1_3\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-03.png\" background_size=\"contain\" background_position=\"bottom_right\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"Free Standard Installation\" use_icon=\"on\" font_icon=\"%%243%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#a0cf00\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"3.17.6\" header_font=\"Poppins|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>Sed porttitor lectus nibh. Curabitur arcu erat, accumsan id imperdiet et, porttitor at sem. Donec sollicitudin molestie malesuada. Vivamus suscipit tortor eget felis porttitor volutpat.</p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"18 Month Price Guarantee\" use_icon=\"on\" font_icon=\"%%171%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#a0cf00\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"3.17.6\" header_font=\"Poppins|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>Sed porttitor lectus nibh. Curabitur arcu erat, accumsan id imperdiet et, p</p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-04.png\" background_size=\"contain\" background_position=\"top_right\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"Not Data Limits\" use_icon=\"on\" font_icon=\"%%231%%\" icon_color=\"#ffffff\" use_circle=\"on\" circle_color=\"#a0cf00\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"3.17.6\" header_font=\"Poppins|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>Sed porttitor lectus nibh. Curabitur arcu erat, accumsan id imperdiet et, po</p>[/et_pb_blurb][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" max_width=\"800px\" border_width_bottom=\"2px\" border_color_bottom=\"#f2f5fa\" use_custom_width=\"on\" custom_width_px=\"800px\" column_structure=\"1_2,1_2\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"Poppins|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|700|on||||||\" header_3_line_height=\"1.5em\" max_width=\"700px\" link_option_url=\"#\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" header_3_font_size_tablet=\"\" header_3_font_size_phone=\"26px\" header_3_font_size_last_edited=\"on|desktop\" locked=\"off\" header_3_text_color__hover_enabled=\"on\" header_3_text_color__hover=\"#008a1c\"]<h3>Package </h3>[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_toggle title=\"Basic Internet\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"3.17.6\" title_level=\"h2\" title_font=\"Poppins|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||\" custom_padding=\"0px|0px|0px|0px|true|true\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>Quisque velit nisi, pretium ut lacinia in, elementum id enim. Sed porttitor lectus nibh. Sed porttitor lectus nibh. Nulla porttitor accumsan tincidunt. Sed porttitor lectus nibh. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus</p>[/et_pb_toggle][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" max_width=\"800px\" border_width_bottom=\"2px\" border_color_bottom=\"#f2f5fa\" use_custom_width=\"on\" custom_width_px=\"800px\" column_structure=\"1_2,1_2\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"Poppins|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|700|on||||||\" header_3_line_height=\"1.5em\" max_width=\"700px\" link_option_url=\"#\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" header_3_font_size_tablet=\"\" header_3_font_size_phone=\"26px\" header_3_font_size_last_edited=\"on|desktop\" locked=\"off\" header_3_text_color__hover_enabled=\"on\" header_3_text_color__hover=\"#008a1c\"]<h3>Devices</h3>[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_toggle title=\"2-4\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"3.17.6\" title_level=\"h2\" title_font=\"Poppins|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||\" custom_padding=\"0px|0px|0px|0px|true|true\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>Quisque velit nisi, pretium ut lacinia in, elementum id enim. Sed porttitor lectus nibh. Sed porttitor lectus nibh. Nulla porttitor accumsan tincidunt. Sed porttitor lectus nibh. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus</p>[/et_pb_toggle][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" max_width=\"800px\" border_width_bottom=\"2px\" border_color_bottom=\"#f2f5fa\" use_custom_width=\"on\" custom_width_px=\"800px\" column_structure=\"1_2,1_2\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"Poppins|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|700|on||||||\" header_3_line_height=\"1.5em\" max_width=\"700px\" link_option_url=\"#\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" header_3_font_size_tablet=\"\" header_3_font_size_phone=\"26px\" header_3_font_size_last_edited=\"on|desktop\" locked=\"off\" header_3_text_color__hover_enabled=\"on\" header_3_text_color__hover=\"#008a1c\"]<h3>Bandwidth</h3>[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_toggle title=\"Up to 85mbps\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"3.17.6\" title_level=\"h2\" title_font=\"Poppins|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||\" custom_padding=\"0px|0px|0px|0px|true|true\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>Quisque velit nisi, pretium ut lacinia in, elementum id enim. Sed porttitor lectus nibh. Sed porttitor lectus nibh. Nulla porttitor accumsan tincidunt. Sed porttitor lectus nibh. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus</p>[/et_pb_toggle][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" max_width=\"800px\" border_width_bottom=\"2px\" border_color_bottom=\"#f2f5fa\" use_custom_width=\"on\" custom_width_px=\"800px\" column_structure=\"1_2,1_2\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"Poppins|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|700|on||||||\" header_3_line_height=\"1.5em\" max_width=\"700px\" link_option_url=\"#\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" header_3_font_size_tablet=\"\" header_3_font_size_phone=\"26px\" header_3_font_size_last_edited=\"on|desktop\" locked=\"off\" header_3_text_color__hover_enabled=\"on\" header_3_text_color__hover=\"#008a1c\"]<h3>Data Limit</h3>[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_toggle title=\"Unlimited\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"3.17.6\" title_level=\"h2\" title_font=\"Poppins|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||\" custom_padding=\"0px|0px|0px|0px|true|true\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>Quisque velit nisi, pretium ut lacinia in, elementum id enim. Sed porttitor lectus nibh. Sed porttitor lectus nibh. Nulla porttitor accumsan tincidunt. Sed porttitor lectus nibh. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus</p>[/et_pb_toggle][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" max_width=\"800px\" border_width_bottom=\"2px\" border_color_bottom=\"#f2f5fa\" use_custom_width=\"on\" custom_width_px=\"800px\" column_structure=\"1_2,1_2\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"Poppins|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|700|on||||||\" header_3_line_height=\"1.5em\" max_width=\"700px\" link_option_url=\"#\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" header_3_font_size_tablet=\"\" header_3_font_size_phone=\"26px\" header_3_font_size_last_edited=\"on|desktop\" locked=\"off\" header_3_text_color__hover_enabled=\"on\" header_3_text_color__hover=\"#008a1c\"]<h3>Coverage</h3>[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_toggle title=\"Nationwide\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"3.17.6\" title_level=\"h2\" title_font=\"Poppins|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||\" custom_padding=\"0px|0px|0px|0px|true|true\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>Quisque velit nisi, pretium ut lacinia in, elementum id enim. Sed porttitor lectus nibh. Sed porttitor lectus nibh. Nulla porttitor accumsan tincidunt. Sed porttitor lectus nibh. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus</p>[/et_pb_toggle][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" max_width=\"800px\" use_custom_width=\"on\" custom_width_px=\"800px\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"Poppins|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|700|on||||||\" header_3_line_height=\"1.5em\" link_option_url=\"#\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" header_3_font_size_tablet=\"\" header_3_font_size_phone=\"26px\" header_3_font_size_last_edited=\"on|desktop\" locked=\"off\" header_3_text_color__hover_enabled=\"on\" header_3_text_color__hover=\"#008a1c\"]<h3>Additional Info</h3>\n<p>Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus. Praesent sapien massa, convallis a pellentesque nec, egestas non nisi. Donec sollicitudin molestie malesuada. Curabitur arcu erat, accumsan id imperdiet et, porttitor at sem. Curabitur arcu erat, accumsan id imperdiet et, porttitor at sem. Sed porttitor lectus nibh. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Donec velit neque, auctor sit amet aliquam vel, ullamcorper sit amet ligula. Curabitur aliquet quam id dui posuere blandit. Cras ultricies ligula sed magna dictum porta.</p>\n<p>Sed porttitor lectus nibh. Quisque velit nisi, pretium ut lacinia in, elementum id enim. Curabitur aliquet quam id dui posuere blandit. Cras ultricies ligula sed magna dictum porta. Donec rutrum congue leo eget malesuada. Sed porttitor lectus nibh. Donec sollicitudin molestie malesuada. Sed porttitor lectus nibh. Vivamus suscipit tortor eget felis porttitor volutpat.</p>\n<p>Quisque velit nisi, pretium ut lacinia in, elementum id enim. Nulla porttitor accumsan tincidunt. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla quis lorem ut libero malesuada feugiat. Praesent sapien massa, convallis a pellentesque nec, egestas non nisi. Pellentesque in ipsum id orci porta dapibus. Mauris blandit aliquet elit, eget tincidunt nibh pulvinar a. Quisque velit nisi, pretium ut lacinia in, elementum id enim.</p>\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Proin eget tortor risus. Sed porttitor lectus nibh. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Donec velit neque, auctor sit amet aliquam vel, ullamcorper sit amet ligula. Nulla porttitor accumsan tincidunt. Vivamus suscipit tortor eget felis porttitor volutpat. Vestibulum ac diam sit amet quam vehicula elementum sed sit amet dui. Nulla quis lorem ut libero malesuada feugiat. Donec sollicitudin molestie malesuada.</p>[/et_pb_text][et_pb_button button_text=\"Sign Up Today\" button_alignment=\"left\" _builder_version=\"3.17.6\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"Poppins|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Related Products\" _builder_version=\"3.22\" background_color=\"#f2f5fa\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" border_radii=\"|30px|30px||\" locked=\"off\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\"][et_pb_row _builder_version=\"3.25\" custom_padding=\"||||false|false\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"Poppins|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" text_orientation=\"center\" max_width=\"700px\" module_alignment=\"center\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>Other Plans</h2>[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row use_custom_gutter=\"on\" gutter_width=\"2\" _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\" column_structure=\"1_3,1_3,1_3\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"40px|||\" custom_padding_tablet=\"0px||\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px||\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"3.23\" price_text_color=\"#a0cf00\" subheader_text_color=\"#000000\" header_text_color=\"#000000\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"Poppins||||||||\" body_text_align=\"center\" subheader_font=\"Poppins|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"Poppins|800|on||||||\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(255,255,255,0)\" background_color_gradient_end=\"#ffffff\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"Poppins|700||on|||||\" animation_style=\"slide\" animation_direction=\"right\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\"][et_pb_pricing_table title=\"Basic Internet\" subtitle=\"85mbps\" currency=\"$\" per=\"mo\" sum=\"35\" button_text=\"Sign Up\" _builder_version=\"3.17.6\" body_font=\"||||||||\"]<p>+ Donec rutrum congue</p>\n<p>+ Quisque velit nisi</p>\n<p>+ Pretium ut lacinia in</p>\n<p>- Elementum id enim</p>\n<p>- Pellentesque in ipsum id</p>[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"3.23\" currency_frequency_text_color=\"#a0cf00\" price_text_color=\"rgba(0,0,0,0.75)\" subheader_text_color=\"#000000\" header_text_color=\"#000000\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"Poppins||||||||\" body_text_align=\"center\" subheader_font=\"Poppins|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"Poppins|800|on||||||\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#ffffff\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0f1533\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"Poppins|700||on|||||\" custom_margin=\"||\" animation_style=\"zoom\" animation_delay=\"100ms\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" border_color_all=\"#ffffff\" border_width_top=\"40px\" border_width_bottom=\"30px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" locked=\"off\"][et_pb_pricing_table title=\"Pro Internet\" subtitle=\"120mbps\" currency=\"$\" per=\"mo\" sum=\"85\" button_text=\"Sign Up\" _builder_version=\"3.17.6\" body_font=\"||||||||\"]<p>+ Donec rutrum congue</p>\n<p>+ Quisque velit nisi</p>\n<p>+ Pretium ut lacinia in</p>\n<p>+ Elementum id enim</p>\n<p>+ Pellentesque in ipsum id</p>[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"40px|||\" custom_padding_tablet=\"0px||\" custom_padding_last_edited=\"on|desktop\" padding_tablet=\"0px||\" padding_last_edited=\"on|desktop\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"3.23\" price_text_color=\"#a0cf00\" subheader_text_color=\"#000000\" header_text_color=\"#000000\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"Poppins||||||||\" body_text_align=\"center\" subheader_font=\"Poppins|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"Poppins|800|on||||||\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(255,255,255,0)\" background_color_gradient_end=\"#ffffff\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"Poppins|700||on|||||\" animation_style=\"slide\" animation_direction=\"left\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" locked=\"off\"][et_pb_pricing_table title=\"Internet + TV\" subtitle=\"120mbps\" currency=\"$\" per=\"mo\" sum=\"120\" button_text=\"Sign Up\" _builder_version=\"3.23\" body_font=\"||||||||\" excluded_text_color=\"rgba(255,255,255,0.5)\" pricing_item_excluded_color=\"rgba(255,255,255,0.5)\"]<p>+ Donec rutrum congue</p>\n<p>+ Quisque velit nisi</p>\n<p>+ Pretium ut lacinia in</p>\n<p>+ Elementum id enim</p>\n<p>- Pellentesque in ipsum id</p>[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" prev_background_color=\"#f2f5fa\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#0f1533\" background_color_gradient_end=\"#1f133a\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||5vw\" custom_padding=\"14vw||10vw\" top_divider_style=\"wave2\" top_divider_height=\"10vw\" top_divider_repeat=\"0.7x\" top_divider_flip=\"vertical\" animation_style=\"fade\" border_radii=\"|||30px|30px\" locked=\"off\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_last_edited=\"on|desktop\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" header_2_font=\"Poppins|900|on||||||\" header_2_font_size=\"5vw\" header_2_letter_spacing=\"2px\" header_2_line_height=\"1.4em\" header_3_font=\"Poppins|900|on|on|||||\" header_3_text_color=\"rgba(255,255,255,0.7)\" header_3_font_size=\"1.5vw\" header_3_letter_spacing=\"0.8em\" header_3_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_font_size__hover=\"30px\" header_font_size__hover_enabled=\"30px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h2>Get The Speeds You Want at the Price You Want</h2>\n<h3>TV & Internet</h3>[/et_pb_text][et_pb_button button_text=\"View All Plans\" button_alignment=\"center\" _builder_version=\"3.17.6\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"Poppins|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section]", "خدمات طرح دوم", "", "inherit", "closed", "closed", "", "2392-revision-v1", "", "", "2020-04-02 11:57:03", "2020-04-02 08:27:03", "", "2392", "http://modelsite.test/2392-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2925", "1", "2020-04-02 12:01:35", "2020-04-02 08:31:35", "", "Internet provider logo", "", "inherit", "open", "closed", "", "internet-provider-logo", "", "", "2020-04-02 12:01:35", "2020-04-02 08:31:35", "", "0", "http://modelsite.test/wp-content/uploads/2020/04/Internet-provider-logo.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("2926", "1", "2020-04-02 12:01:36", "2020-04-02 08:31:36", "", "Internet provider1", "", "inherit", "open", "closed", "", "internet-provider1", "", "", "2020-04-02 12:01:36", "2020-04-02 08:31:36", "", "0", "http://modelsite.test/wp-content/uploads/2020/04/Internet-provider1.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("2927", "1", "2020-04-02 12:01:38", "2020-04-02 08:31:38", "", "Internet provider2", "", "inherit", "open", "closed", "", "internet-provider2", "", "", "2020-04-02 12:01:38", "2020-04-02 08:31:38", "", "0", "http://modelsite.test/wp-content/uploads/2020/04/Internet-provider2.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("2929", "1", "2020-04-02 12:05:32", "2020-04-02 08:35:32", "{\n    \"et_divi[accent_color]\": {\n        \"value\": \"#a0cf00\",\n        \"type\": \"option\",\n        \"user_id\": 1,\n        \"date_modified_gmt\": \"2020-04-02 08:34:50\"\n    },\n    \"et_divi[menu_link]\": {\n        \"value\": \"#a0cf00\",\n        \"type\": \"option\",\n        \"user_id\": 1,\n        \"date_modified_gmt\": \"2020-04-02 08:34:50\"\n    },\n    \"et_divi[menu_link_active]\": {\n        \"value\": \"#2fc900\",\n        \"type\": \"option\",\n        \"user_id\": 1,\n        \"date_modified_gmt\": \"2020-04-02 08:34:50\"\n    },\n    \"et_divi[primary_nav_dropdown_line_color]\": {\n        \"value\": \"#a0cf00\",\n        \"type\": \"option\",\n        \"user_id\": 1,\n        \"date_modified_gmt\": \"2020-04-02 08:34:50\"\n    },\n    \"et_divi[primary_nav_dropdown_link_color]\": {\n        \"value\": \"#a0cf00\",\n        \"type\": \"option\",\n        \"user_id\": 1,\n        \"date_modified_gmt\": \"2020-04-02 08:34:50\"\n    },\n    \"et_divi[secondary_nav_bg]\": {\n        \"value\": \"#a0cf00\",\n        \"type\": \"option\",\n        \"user_id\": 1,\n        \"date_modified_gmt\": \"2020-04-02 08:35:32\"\n    },\n    \"et_divi[secondary_nav_dropdown_bg]\": {\n        \"value\": \"#a0cf00\",\n        \"type\": \"option\",\n        \"user_id\": 1,\n        \"date_modified_gmt\": \"2020-04-02 08:35:32\"\n    },\n    \"et_divi[fixed_secondary_nav_bg]\": {\n        \"value\": \"#a0cf00\",\n        \"type\": \"option\",\n        \"user_id\": 1,\n        \"date_modified_gmt\": \"2020-04-02 08:35:32\"\n    },\n    \"et_divi[fixed_menu_link]\": {\n        \"value\": \"#a0cf00\",\n        \"type\": \"option\",\n        \"user_id\": 1,\n        \"date_modified_gmt\": \"2020-04-02 08:35:32\"\n    },\n    \"et_divi[fixed_menu_link_active]\": {\n        \"value\": \"#24d800\",\n        \"type\": \"option\",\n        \"user_id\": 1,\n        \"date_modified_gmt\": \"2020-04-02 08:35:32\"\n    },\n    \"et_divi[bottom_bar_background_color]\": {\n        \"value\": \"#a0cf00\",\n        \"type\": \"option\",\n        \"user_id\": 1,\n        \"date_modified_gmt\": \"2020-04-02 08:35:32\"\n    }\n}", "", "", "trash", "closed", "closed", "", "af2d7b70-ee59-4e1e-9676-989252f0355b", "", "", "2020-04-02 12:05:32", "2020-04-02 08:35:32", "", "0", "http://modelsite.test/?p=2929", "0", "customize_changeset", "", "0");
INSERT INTO `wp_posts` VALUES("2931", "1", "2020-04-02 12:40:16", "2020-04-02 09:10:16", "[et_pb_section fb_built=\"1\" admin_label=\"Header\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-05.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"5vw||||false\" custom_padding=\"10vw||14vw||false\" bottom_divider_style=\"wave2\" bottom_divider_color=\"#ffffff\" bottom_divider_height=\"10vw\" bottom_divider_repeat=\"0.7x\" animation_style=\"slide\" animation_direction=\"bottom\" animation_intensity_slide=\"1%\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_phone=\"\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" animation_style=\"slide\" animation_direction=\"left\" animation_intensity_slide=\"10%\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_font=\"|900|on|on|||||\" header_font_size=\"10vw\" header_letter_spacing=\"0.1em\" header_line_height=\"1.2em\" header_2_font=\"|900|on|on|||||\" header_2_text_color=\"rgba(255,255,255,0.7)\" header_2_font_size=\"44px\" header_2_letter_spacing=\"0em\" header_2_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" hover_enabled=\"0\" header_font_size_tablet=\"50px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|phone\" header_2_font_size_tablet=\"30px\" header_2_font_size_phone=\"20px\" header_2_font_size_last_edited=\"on|phone\" header_text_shadow_style=\"preset1\" header_text_shadow_color=\"rgba(0,0,0,0.15)\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h1>نهایت سرعت</h1>\n<p>&nbsp;</p>\n<h2><span color=\"rgba(0, 0, 0, 0.701960784313725)\" style=\"color: rgba(0, 0, 0, 0.7);\">35 هزارتومان </span>اینترنت ADSL</h2>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_font_size=\"18px\" text_line_height=\"2em\" text_orientation=\"center\" background_layout=\"dark\" max_width=\"800px\" module_alignment=\"center\" hover_enabled=\"0\" text_font_size_tablet=\"16px\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_button button_text=\"مشاهده تمام پلن های اینترنتی\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Login\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(242,245,250,0)\" background_color_gradient_end=\"#f2f5fa\" background_color_gradient_direction=\"90deg\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_padding=\"0|0px|0|0px|false|false\" border_radii=\"on|60px|60px|60px|60px\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" link_font=\"||||||||\" link_text_color=\"#0492ff\" text_orientation=\"center\" hover_enabled=\"0\" text_font_size=\"20px\" text_text_shadow_style=\"preset1\" text_text_shadow_color=\"#7cda24\"]<p>آماده اید ؟  جهت عضویت <a href=\"#\"><strong>اینجا را کلیک نمایید</strong></a></p>\n[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Value\" _builder_version=\"3.22\"][et_pb_row _builder_version=\"3.25\" custom_padding=\"||||false|false\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#0492ff\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>چرا انتخاب ما ؟</h2>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" padding_top_bottom_link_1=\"false\" padding_top_bottom_link_2=\"false\" padding_top_bottom_link_3=\"false\" padding_left_right_link_1=\"true\" padding_left_right_link_2=\"true\" padding_left_right_link_3=\"true\" _builder_version=\"3.25\" max_width=\"1160px\" custom_padding=\"0|0px|27px|0px|false|false\" use_custom_width=\"on\" custom_width_px=\"1160px\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\" max_width__hover=\"1080px\" max_width__hover_enabled=\"1080px\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-03.png\" background_size=\"contain\" background_position=\"bottom_right\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"دریافت سرعت واقعی\" use_icon=\"on\" font_icon=\"%%243%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"20 درصد تخفیف\" use_icon=\"on\" font_icon=\"%%171%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-04.png\" background_size=\"contain\" background_position=\"top_right\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"بدون محدودیت حجمی\" use_icon=\"on\" font_icon=\"%%231%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است </span></p>\n[/et_pb_blurb][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Features\" _builder_version=\"3.22\" background_color=\"#f2f5fa\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_padding=\"54px|0px|0|0px|false|false\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row column_structure=\"3_5,2_5\" _builder_version=\"3.25\" custom_margin=\"100px||100px||true\" custom_margin_tablet=\"40px||40px||true\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\"][et_pb_column type=\"3_5\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/04/isp-01.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"|||-7vw\" custom_margin_tablet=\"|||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\"][/et_pb_image][/et_pb_column][et_pb_column type=\"2_5\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>انتخاب شماره 1# کاربران برای اینترنت  فیبر نوری</h2>\n<h3></h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>\n[/et_pb_text][et_pb_blurb title=\"بدون قعطی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"2em\" custom_margin=\"||20px\" hover_enabled=\"0\"][/et_pb_blurb][et_pb_blurb title=\"سرعت تا 65 مگابایت\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"2em\" custom_margin=\"||20px\" hover_enabled=\"0\"][/et_pb_blurb][et_pb_blurb title=\"شامل مودم رایگان\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"2em\" custom_margin=\"||20px\" hover_enabled=\"0\"][/et_pb_blurb][et_pb_button button_text=\"مشاهده پلن های اینترنت\" button_alignment=\"left\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" custom_margin=\"100px||100px||true\" custom_margin_tablet=\"40px||40px||true\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"14px\" header_3_line_height=\"1.8em\" max_width=\"700px\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>داده نامحدود ،پشتیبانی شبانه روزی و سرویس پیامکی</h2>\n<h3>همه موارد را برای داشتن خطوط پیامکی موفق برای شما فراهم کرده ایم</h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد</span></p>\n[/et_pb_text][et_pb_button button_text=\"مشاهده پلن های پیامکی\" button_alignment=\"left\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/04/isp-02.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"|-7vw||\" custom_margin_tablet=\"|0vw||\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\" border_radii=\"on|30px|30px|30px|30px\"][/et_pb_image][/et_pb_column][/et_pb_row][et_pb_row custom_padding_last_edited=\"on|tablet\" _builder_version=\"4.4.2\" background_color=\"#ffffff\" max_width=\"80%\" module_alignment=\"right\" custom_margin=\"||\" custom_padding=\"60px|60px|||false|false\" custom_padding_tablet=\"|40px||40px\" custom_padding_phone=\"\" animation_style=\"slide\" animation_direction=\"right\" animation_intensity_slide=\"10%\" hover_enabled=\"0\" border_radii=\"|30px|||\" use_custom_width=\"on\" width_unit=\"off\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>محبوب ترین خدمات</h2>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد</span></p>\n[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Categories\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(242,245,250,0)\" background_color_gradient_end=\"#f2f5fa\" background_color_gradient_direction=\"90deg\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||60px\" custom_margin_tablet=\"||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|desktop\" custom_padding=\"0||0px||false|false\" border_radii=\"on|60px|60px|60px|60px\" locked=\"off\"][et_pb_row column_structure=\"1_6,1_6,1_6,1_6,1_6,1_6\" use_custom_gutter=\"on\" gutter_width=\"2\" _builder_version=\"3.25\" locked=\"off\"][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#ffffff\" text_orientation=\"center\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" locked=\"off\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" box_shadow_color__hover_enabled=\"on\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\" background_layout__hover_enabled=\"on\" background_layout__hover=\"dark\"]<p>پیامک</p>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"Poppins|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#a0cf00\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" locked=\"off\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" box_shadow_color__hover_enabled=\"on\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\"]<p>ADSL</p>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#008a1c\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" box_shadow_color__hover_enabled=\"on\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\"]<p>وایرلس</p>\n[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Pricing\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||||false\" custom_padding=\"80px||80px||true\" animation_style=\"slide\" animation_direction=\"bottom\" animation_intensity_slide=\"1%\" border_radii=\"on|30px|30px|30px|30px\" locked=\"off\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\"][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"40px|||\" custom_padding_tablet=\"0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px||\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#ffffff\" price_text_color=\"rgba(0,0,0,0.75)\" body_text_color=\"#ffffff\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"Poppins||||||||\" body_text_align=\"center\" subheader_font=\"Poppins|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"Poppins|800|on||||||\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(255,255,255,0)\" background_color_gradient_end=\"rgba(255,255,255,0.16)\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"Poppins|700||on|||||\" animation_style=\"slide\" animation_direction=\"right\" hover_enabled=\"0\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\"][et_pb_pricing_table title=\"اینترنت پایه\" subtitle=\"1 مگابایت\" currency=\"یک ساله \" per=\"هزارتومان\" sum=\"35\" button_text=\"#\" _builder_version=\"4.4.2\" body_font=\"||||||||\" excluded_text_color=\"rgba(255,255,255,0.5)\" hover_enabled=\"0\" pricing_item_excluded_color=\"rgba(255,255,255,0.5)\" header_font=\"||||||||\" header_level=\"h2\" subheader_font=\"|800|||||||\" price_font=\"|800|on||||||\" currency_frequency_font=\"|700|on||||||\" price_line_height=\"100px\" price_letter_spacing=\"0px\" currency_frequency_line_height=\"1em\"]<p>+ گرانتی سرعت</p>\n<p>+ گارنتی کیفیت</p>\n<p>+ نصب در محل</p>\n<p>- تنظیم مودم</p>\n<p>- پشتیبانی 24 ساعته</p>\n[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"3.23\" currency_frequency_text_color=\"#a0cf00\" price_text_color=\"rgba(0,0,0,0.75)\" subheader_text_color=\"#000000\" header_text_color=\"#000000\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"Poppins||||||||\" body_text_align=\"center\" subheader_font=\"Poppins|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"Poppins|800|on||||||\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#ffffff\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#008a1c\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"Poppins|700||on|||||\" custom_margin=\"0px||\" animation_style=\"zoom\" animation_delay=\"100ms\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" border_color_all=\"#ffffff\" border_width_top=\"40px\" border_width_bottom=\"30px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" locked=\"off\"][et_pb_pricing_table title=\"Pro Internet\" subtitle=\"120mbps\" currency=\"$\" per=\"mo\" sum=\"85\" button_text=\"Sign Up\" _builder_version=\"3.17.6\" body_font=\"||||||||\"]<p>+ Donec rutrum congue</p>\n<p>+ Quisque velit nisi</p>\n<p>+ Pretium ut lacinia in</p>\n<p>+ Elementum id enim</p>\n<p>+ Pellentesque in ipsum id</p>[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"40px|||\" custom_padding_tablet=\"0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|desktop\" padding_tablet=\"0px||\" padding_last_edited=\"on|desktop\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#ffffff\" price_text_color=\"rgba(0,0,0,0.75)\" body_text_color=\"#ffffff\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"Poppins||||||||\" body_text_align=\"center\" subheader_font=\"Poppins|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"|800|on||||||\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(255,255,255,0)\" background_color_gradient_end=\"rgba(255,255,255,0.16)\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"Poppins|700||on|||||\" animation_style=\"slide\" animation_direction=\"right\" hover_enabled=\"0\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" locked=\"off\"][et_pb_pricing_table title=\"اینترنت حرفه ای\" subtitle=\"120 مگابایت\" currency=\"یک ساله \" per=\"هزارتومان\" sum=\"900\" button_text=\"#\" _builder_version=\"4.4.2\" body_font=\"||||||||\" excluded_text_color=\"rgba(255,255,255,0.5)\" hover_enabled=\"0\" pricing_item_excluded_color=\"rgba(255,255,255,0.5)\" header_font=\"||||||||\" header_level=\"h2\" subheader_font=\"|800|||||||\" price_font=\"VAZIR FARSI||on||||||\" currency_frequency_font=\"|700|on||||||\" price_line_height=\"100px\" price_letter_spacing=\"0px\" currency_frequency_line_height=\"1em\"]<p>+ گرانتی سرعت</p>\n<p>+ گارنتی کیفیت</p>\n<p>+ نصب در محل</p>\n<p>- تنظیم مودم</p>\n<p>- پشتیبانی 24 ساعته</p>\n[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Blog\" _builder_version=\"3.22\"][et_pb_row _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"Poppins|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#0492ff\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>Our Blog</h2>[/et_pb_text][et_pb_blog fullwidth=\"off\" posts_number=\"3\" include_categories=\"70\" show_pagination=\"off\" _builder_version=\"3.17.6\" header_font=\"Poppins|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_line_height=\"2em\" meta_font=\"Poppins||||||||\" meta_text_color=\"#008a1c\" pagination_font=\"Poppins|700|on||||||\" pagination_text_color=\"#008a1c\" pagination_font_size=\"18px\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"][/et_pb_blog][et_pb_button button_text=\"Read More\" button_alignment=\"center\" _builder_version=\"3.17.6\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"Poppins|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonials\" _builder_version=\"3.22\"][et_pb_row column_structure=\"2_5,3_5\" padding_top_bottom_link_1=\"true\" padding_top_bottom_link_2=\"true\" padding_left_right_link_1=\"false\" padding_left_right_link_2=\"false\" _builder_version=\"3.25\" custom_padding=\"0||0||false|false\"][et_pb_column type=\"2_5\" _builder_version=\"3.25\" custom_padding=\"60px|60px|60px|\" custom_padding_tablet=\"0px||0px||true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px||0px||true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"Poppins|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>What People Are Saying About Divi</h2>\n<h3>Curabitur non nulla sit amet nisl tempus convallis quis ac lectus</h3>[/et_pb_text][/et_pb_column][et_pb_column type=\"3_5\" _builder_version=\"3.25\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/handyman_11.png\" background_size=\"initial\" background_position=\"bottom_right\" custom_padding=\"60px|60px|60px|\" custom_padding_tablet=\"40px|40px|40px|40px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"40px|40px|40px|40px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_testimonial author=\"Customer Since 2014\" quote_icon=\"off\" _builder_version=\"3.17.6\" body_font=\"Poppins||on||||||\" body_font_size=\"14px\" body_line_height=\"2em\" background_color=\"#ffffff\" custom_margin=\"|||-40px\" custom_margin_tablet=\"|||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|desktop\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0.15)\"]<p>\"Pellentesque in ipsum id orci porta dapibus. Nulla quis lorem ut libero malesuada feugiat. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus. Praesent sapien massa, convallis a pellentesque nec, egestas non nisi\"</p>[/et_pb_testimonial][et_pb_testimonial author=\"Customer Since 2015\" quote_icon=\"off\" _builder_version=\"3.17.6\" body_font=\"Poppins||on||||||\" body_font_size=\"14px\" body_line_height=\"2em\" background_color=\"#ffffff\" custom_margin=\"|||-40px\" custom_margin_tablet=\"|||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|desktop\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0.15)\"]<p>\"Praesent sapien massa, convallis a pellentesque nec, egestas non nisi. Nulla porttitor accumsan tincidunt. Curabitur non nulla sit amet nisl tempus convallis quis ac lectus. Curabitur non nulla sit amet nisl tempus convallis quis ac lectus. Curabitur arcu erat, accumsan id imperdiet et\"</p>[/et_pb_testimonial][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" prev_background_color=\"#ffffff\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#0f1533\" background_color_gradient_end=\"#1f133a\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||5vw\" custom_padding=\"14vw||10vw\" top_divider_style=\"wave2\" top_divider_height=\"10vw\" top_divider_repeat=\"0.7x\" top_divider_flip=\"vertical\" animation_style=\"fade\" border_radii=\"on|30px|30px|30px|30px\" locked=\"off\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_phone=\"\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" header_2_font=\"Poppins|900|on||||||\" header_2_font_size=\"5vw\" header_2_letter_spacing=\"2px\" header_2_line_height=\"1.4em\" header_3_font=\"Poppins|900|on|on|||||\" header_3_text_color=\"rgba(255,255,255,0.7)\" header_3_font_size=\"1.5vw\" header_3_letter_spacing=\"0.8em\" header_3_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_font_size__hover=\"30px\" header_font_size__hover_enabled=\"30px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h2>Get The Speeds You Want at the Price You Want</h2>\n<h3>TV & Internet</h3>[/et_pb_text][et_pb_button button_text=\"View All Plans\" button_alignment=\"center\" _builder_version=\"3.17.6\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"Poppins|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section]", "خانه", "", "inherit", "closed", "closed", "", "2-revision-v1", "", "", "2020-04-02 12:40:16", "2020-04-02 09:10:16", "", "2", "http://modelsite.test/2-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2933", "1", "2020-04-02 12:45:28", "2020-04-02 09:15:28", "[et_pb_section fb_built=\"1\" admin_label=\"Header\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-05.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"5vw||||false\" custom_padding=\"10vw||14vw||false\" bottom_divider_style=\"wave2\" bottom_divider_color=\"#ffffff\" bottom_divider_height=\"10vw\" bottom_divider_repeat=\"0.7x\" animation_style=\"slide\" animation_direction=\"bottom\" animation_intensity_slide=\"1%\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_phone=\"\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" animation_style=\"slide\" animation_direction=\"left\" animation_intensity_slide=\"10%\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_font=\"|900|on|on|||||\" header_font_size=\"10vw\" header_letter_spacing=\"0.1em\" header_line_height=\"1.2em\" header_2_font=\"|900|on|on|||||\" header_2_text_color=\"rgba(255,255,255,0.7)\" header_2_font_size=\"44px\" header_2_letter_spacing=\"0em\" header_2_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" header_font_size_tablet=\"50px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|phone\" header_2_font_size_tablet=\"30px\" header_2_font_size_phone=\"20px\" header_2_font_size_last_edited=\"on|phone\" header_text_shadow_style=\"preset1\" header_text_shadow_color=\"rgba(0,0,0,0.15)\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h1>نهایت سرعت</h1>\n<p>&nbsp;</p>\n<h2><span color=\"rgba(0, 0, 0, 0.701960784313725)\" style=\"color: rgba(0, 0, 0, 0.7);\">35 هزارتومان </span>اینترنت ADSL</h2>[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_font_size=\"18px\" text_line_height=\"2em\" text_orientation=\"center\" background_layout=\"dark\" max_width=\"800px\" module_alignment=\"center\" text_font_size_tablet=\"16px\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>[/et_pb_text][et_pb_button button_text=\"مشاهده تمام پلن های اینترنتی\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Login\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(242,245,250,0)\" background_color_gradient_end=\"#f2f5fa\" background_color_gradient_direction=\"90deg\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_padding=\"0|0px|0|0px|false|false\" border_radii=\"on|60px|60px|60px|60px\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_font_size=\"20px\" link_font=\"||||||||\" link_text_color=\"#0492ff\" text_orientation=\"center\" text_text_shadow_style=\"preset1\" text_text_shadow_color=\"#7cda24\"]<p>آماده اید ؟  جهت عضویت <a href=\"#\"><strong>اینجا را کلیک نمایید</strong></a></p>[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Value\" _builder_version=\"3.22\"][et_pb_row _builder_version=\"3.25\" custom_padding=\"||||false|false\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#0492ff\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>چرا انتخاب ما ؟</h2>[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" padding_top_bottom_link_1=\"false\" padding_top_bottom_link_2=\"false\" padding_top_bottom_link_3=\"false\" padding_left_right_link_1=\"true\" padding_left_right_link_2=\"true\" padding_left_right_link_3=\"true\" _builder_version=\"3.25\" max_width=\"1160px\" custom_padding=\"0|0px|27px|0px|false|false\" use_custom_width=\"on\" custom_width_px=\"1160px\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\" max_width__hover=\"1080px\" max_width__hover_enabled=\"1080px\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-03.png\" background_size=\"contain\" background_position=\"bottom_right\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"دریافت سرعت واقعی\" use_icon=\"on\" font_icon=\"%%243%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"20 درصد تخفیف\" use_icon=\"on\" font_icon=\"%%171%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-04.png\" background_size=\"contain\" background_position=\"top_right\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"بدون محدودیت حجمی\" use_icon=\"on\" font_icon=\"%%231%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است </span></p>[/et_pb_blurb][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Features\" _builder_version=\"3.22\" background_color=\"#f2f5fa\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_padding=\"54px|0px|0|0px|false|false\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row column_structure=\"3_5,2_5\" _builder_version=\"3.25\" custom_margin=\"100px||100px||true\" custom_margin_tablet=\"40px||40px||true\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\"][et_pb_column type=\"3_5\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/04/isp-01.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"|||-7vw\" custom_margin_tablet=\"|||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\"][/et_pb_image][/et_pb_column][et_pb_column type=\"2_5\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>انتخاب شماره 1# کاربران برای اینترنت  فیبر نوری</h2>\n<h3></h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>[/et_pb_text][et_pb_blurb title=\"بدون قعطی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"2em\" custom_margin=\"||20px\"][/et_pb_blurb][et_pb_blurb title=\"سرعت تا 65 مگابایت\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"2em\" custom_margin=\"||20px\"][/et_pb_blurb][et_pb_blurb title=\"شامل مودم رایگان\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"2em\" custom_margin=\"||20px\"][/et_pb_blurb][et_pb_button button_text=\"مشاهده پلن های اینترنت\" button_alignment=\"left\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" custom_margin=\"100px||100px||true\" custom_margin_tablet=\"40px||40px||true\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"14px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>داده نامحدود ،پشتیبانی شبانه روزی و سرویس پیامکی</h2>\n<h3>همه موارد را برای داشتن خطوط پیامکی موفق برای شما فراهم کرده ایم</h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد</span></p>[/et_pb_text][et_pb_button button_text=\"مشاهده پلن های پیامکی\" button_alignment=\"left\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/04/isp-02.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"|-7vw||\" custom_margin_tablet=\"|0vw||\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\" border_radii=\"on|30px|30px|30px|30px\"][/et_pb_image][/et_pb_column][/et_pb_row][et_pb_row custom_padding_last_edited=\"on|tablet\" _builder_version=\"4.4.2\" background_color=\"#ffffff\" max_width=\"80%\" module_alignment=\"right\" custom_margin=\"||\" custom_padding=\"60px|60px|||false|false\" custom_padding_tablet=\"|40px||40px\" custom_padding_phone=\"\" animation_style=\"slide\" animation_direction=\"right\" animation_intensity_slide=\"10%\" border_radii=\"|30px|||\" use_custom_width=\"on\" width_unit=\"off\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>محبوب ترین خدمات</h2>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد</span></p>[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Categories\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(242,245,250,0)\" background_color_gradient_end=\"#f2f5fa\" background_color_gradient_direction=\"90deg\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||60px\" custom_margin_tablet=\"||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|desktop\" custom_padding=\"0||0px||false|false\" border_radii=\"on|60px|60px|60px|60px\" locked=\"off\"][et_pb_row column_structure=\"1_6,1_6,1_6,1_6,1_6,1_6\" use_custom_gutter=\"on\" gutter_width=\"2\" _builder_version=\"3.25\" locked=\"off\"][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#ffffff\" text_orientation=\"center\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" locked=\"off\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" box_shadow_color__hover_enabled=\"on\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\" background_layout__hover_enabled=\"on\" background_layout__hover=\"dark\"]<p>پیامک</p>[/et_pb_text][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"Poppins|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#a0cf00\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" locked=\"off\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" box_shadow_color__hover_enabled=\"on\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\"]<p>ADSL</p>[/et_pb_text][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#008a1c\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" box_shadow_color__hover_enabled=\"on\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\"]<p>وایرلس</p>[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Pricing\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||||false\" custom_padding=\"80px||80px||true\" animation_style=\"slide\" animation_direction=\"bottom\" animation_intensity_slide=\"1%\" border_radii=\"on|30px|30px|30px|30px\" locked=\"off\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\"][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"40px|||\" custom_padding_tablet=\"0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px||\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#ffffff\" price_text_color=\"rgba(0,0,0,0.75)\" body_text_color=\"#ffffff\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"Poppins||||||||\" body_text_align=\"center\" subheader_font=\"|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"||on||||||\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(255,255,255,0)\" background_color_gradient_end=\"rgba(255,255,255,0.16)\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"Poppins|700||on|||||\" animation_style=\"slide\" animation_direction=\"right\" hover_enabled=\"0\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" price_font_size=\"50px\"][et_pb_pricing_table title=\"اینترنت پایه\" subtitle=\"1 مگابایت\" currency=\"یک ساله \" per=\"هزارتومان\" sum=\"35\" button_text=\"#\" _builder_version=\"4.4.2\" header_level=\"h2\" header_font=\"||||||||\" body_font=\"||||||||\" subheader_font=\"|800|||||||\" price_font=\"|800|on||||||\" price_letter_spacing=\"0px\" price_line_height=\"100px\" currency_frequency_font=\"|700|on||||||\" currency_frequency_line_height=\"1em\" excluded_text_color=\"rgba(255,255,255,0.5)\" pricing_item_excluded_color=\"rgba(255,255,255,0.5)\"]<p>+ گرانتی سرعت</p>\n<p>+ گارنتی کیفیت</p>\n<p>+ نصب در محل</p>\n<p>- تنظیم مودم</p>\n<p>- پشتیبانی 24 ساعته</p>[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#a0cf00\" price_text_color=\"rgba(0,0,0,0.75)\" subheader_text_color=\"#000000\" header_text_color=\"#000000\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"Poppins||||||||\" body_text_align=\"center\" subheader_font=\"Poppins|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"|800|on||||||\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#ffffff\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#008a1c\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"Poppins|700||on|||||\" custom_margin=\"0px||\" animation_style=\"zoom\" animation_delay=\"100ms\" hover_enabled=\"0\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" border_color_all=\"#ffffff\" border_width_top=\"40px\" border_width_bottom=\"30px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" locked=\"off\"][et_pb_pricing_table title=\"سرویس محبوب\" subtitle=\"65 مگابایت\" currency=\"سالانه\" per=\"هزارتومان\" sum=\"99\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" body_font=\"VAZIR FARSI||||||||\" hover_enabled=\"0\" header_font=\"||||||||\" header_level=\"h2\" subheader_font=\"VAZIR FARSI|800|||||||\" price_font=\"VAZIR FARSI|800|on||||||\" price_line_height=\"100px\" price_font_size=\"50px\"]<p>+ سرعت دانلود تا 65 مگابایت</p>\n<p>+ دانلود نامحدود</p>\n<p>+ پشتیبانی شبانه روزی</p>\n<p>+ مودم رایگان</p>\n<p>+ نصب رایگان</p>\n[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"40px|||\" custom_padding_tablet=\"0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|desktop\" padding_tablet=\"0px||\" padding_last_edited=\"on|desktop\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#ffffff\" price_text_color=\"rgba(0,0,0,0.75)\" body_text_color=\"#ffffff\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"Poppins||||||||\" body_text_align=\"center\" subheader_font=\"|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"||on||||||\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(255,255,255,0)\" background_color_gradient_end=\"rgba(255,255,255,0.16)\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"Poppins|700||on|||||\" animation_style=\"slide\" animation_direction=\"right\" hover_enabled=\"0\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" locked=\"off\" price_font_size=\"50px\" price_letter_spacing_last_edited=\"on|desktop\"][et_pb_pricing_table title=\"اینترنت حرفه ای\" subtitle=\"120 مگابایت\" currency=\"یک ساله \" per=\"هزارتومان\" sum=\"900\" button_text=\"#\" _builder_version=\"4.4.2\" header_level=\"h2\" header_font=\"||||||||\" body_font=\"||||||||\" subheader_font=\"|800|||||||\" price_font=\"VAZIR FARSI||on||||||\" price_letter_spacing=\"0px\" price_line_height=\"100px\" currency_frequency_font=\"|700|on||||||\" currency_frequency_line_height=\"1em\" excluded_text_color=\"rgba(255,255,255,0.5)\" pricing_item_excluded_color=\"rgba(255,255,255,0.5)\"]<p>+ گرانتی سرعت</p>\n<p>+ گارنتی کیفیت</p>\n<p>+ نصب در محل</p>\n<p>- تنظیم مودم</p>\n<p>- پشتیبانی 24 ساعته</p>[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Blog\" _builder_version=\"3.22\"][et_pb_row _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"Poppins|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#0492ff\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>Our Blog</h2>[/et_pb_text][et_pb_blog fullwidth=\"off\" posts_number=\"3\" include_categories=\"70\" show_pagination=\"off\" _builder_version=\"3.17.6\" header_font=\"Poppins|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_line_height=\"2em\" meta_font=\"Poppins||||||||\" meta_text_color=\"#008a1c\" pagination_font=\"Poppins|700|on||||||\" pagination_text_color=\"#008a1c\" pagination_font_size=\"18px\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"][/et_pb_blog][et_pb_button button_text=\"Read More\" button_alignment=\"center\" _builder_version=\"3.17.6\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"Poppins|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonials\" _builder_version=\"3.22\"][et_pb_row column_structure=\"2_5,3_5\" padding_top_bottom_link_1=\"true\" padding_top_bottom_link_2=\"true\" padding_left_right_link_1=\"false\" padding_left_right_link_2=\"false\" _builder_version=\"3.25\" custom_padding=\"0||0||false|false\"][et_pb_column type=\"2_5\" _builder_version=\"3.25\" custom_padding=\"60px|60px|60px|\" custom_padding_tablet=\"0px||0px||true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px||0px||true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"Poppins|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>What People Are Saying About Divi</h2>\n<h3>Curabitur non nulla sit amet nisl tempus convallis quis ac lectus</h3>[/et_pb_text][/et_pb_column][et_pb_column type=\"3_5\" _builder_version=\"3.25\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/handyman_11.png\" background_size=\"initial\" background_position=\"bottom_right\" custom_padding=\"60px|60px|60px|\" custom_padding_tablet=\"40px|40px|40px|40px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"40px|40px|40px|40px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_testimonial author=\"Customer Since 2014\" quote_icon=\"off\" _builder_version=\"3.17.6\" body_font=\"Poppins||on||||||\" body_font_size=\"14px\" body_line_height=\"2em\" background_color=\"#ffffff\" custom_margin=\"|||-40px\" custom_margin_tablet=\"|||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|desktop\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0.15)\"]<p>\"Pellentesque in ipsum id orci porta dapibus. Nulla quis lorem ut libero malesuada feugiat. Vivamus magna justo, lacinia eget consectetur sed, convallis at tellus. Praesent sapien massa, convallis a pellentesque nec, egestas non nisi\"</p>[/et_pb_testimonial][et_pb_testimonial author=\"Customer Since 2015\" quote_icon=\"off\" _builder_version=\"3.17.6\" body_font=\"Poppins||on||||||\" body_font_size=\"14px\" body_line_height=\"2em\" background_color=\"#ffffff\" custom_margin=\"|||-40px\" custom_margin_tablet=\"|||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|desktop\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0.15)\"]<p>\"Praesent sapien massa, convallis a pellentesque nec, egestas non nisi. Nulla porttitor accumsan tincidunt. Curabitur non nulla sit amet nisl tempus convallis quis ac lectus. Curabitur non nulla sit amet nisl tempus convallis quis ac lectus. Curabitur arcu erat, accumsan id imperdiet et\"</p>[/et_pb_testimonial][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" prev_background_color=\"#ffffff\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#0f1533\" background_color_gradient_end=\"#1f133a\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||5vw\" custom_padding=\"14vw||10vw\" top_divider_style=\"wave2\" top_divider_height=\"10vw\" top_divider_repeat=\"0.7x\" top_divider_flip=\"vertical\" animation_style=\"fade\" border_radii=\"on|30px|30px|30px|30px\" locked=\"off\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_phone=\"\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" header_2_font=\"Poppins|900|on||||||\" header_2_font_size=\"5vw\" header_2_letter_spacing=\"2px\" header_2_line_height=\"1.4em\" header_3_font=\"Poppins|900|on|on|||||\" header_3_text_color=\"rgba(255,255,255,0.7)\" header_3_font_size=\"1.5vw\" header_3_letter_spacing=\"0.8em\" header_3_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_font_size__hover=\"30px\" header_font_size__hover_enabled=\"30px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h2>Get The Speeds You Want at the Price You Want</h2>\n<h3>TV & Internet</h3>[/et_pb_text][et_pb_button button_text=\"View All Plans\" button_alignment=\"center\" _builder_version=\"3.17.6\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"Poppins|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section]", "خانه", "", "inherit", "closed", "closed", "", "2-revision-v1", "", "", "2020-04-02 12:45:28", "2020-04-02 09:15:28", "", "2", "http://modelsite.test/2-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2935", "1", "2020-04-02 12:49:42", "2020-04-02 09:19:42", "[et_pb_section fb_built=\"1\" admin_label=\"Header\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-05.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"5vw||||false\" custom_padding=\"10vw||14vw||false\" bottom_divider_style=\"wave2\" bottom_divider_color=\"#ffffff\" bottom_divider_height=\"10vw\" bottom_divider_repeat=\"0.7x\" animation_style=\"slide\" animation_direction=\"bottom\" animation_intensity_slide=\"1%\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_phone=\"\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" animation_style=\"slide\" animation_direction=\"left\" animation_intensity_slide=\"10%\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_font=\"|900|on|on|||||\" header_font_size=\"10vw\" header_letter_spacing=\"0.1em\" header_line_height=\"1.2em\" header_2_font=\"|900|on|on|||||\" header_2_text_color=\"rgba(255,255,255,0.7)\" header_2_font_size=\"44px\" header_2_letter_spacing=\"0em\" header_2_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" header_font_size_tablet=\"50px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|phone\" header_2_font_size_tablet=\"30px\" header_2_font_size_phone=\"20px\" header_2_font_size_last_edited=\"on|phone\" header_text_shadow_style=\"preset1\" header_text_shadow_color=\"rgba(0,0,0,0.15)\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h1>نهایت سرعت</h1>\n<p>&nbsp;</p>\n<h2><span color=\"rgba(0, 0, 0, 0.701960784313725)\" style=\"color: rgba(0, 0, 0, 0.7);\">35 هزارتومان </span>اینترنت ADSL</h2>[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_font_size=\"18px\" text_line_height=\"2em\" text_orientation=\"center\" background_layout=\"dark\" max_width=\"800px\" module_alignment=\"center\" text_font_size_tablet=\"16px\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>[/et_pb_text][et_pb_button button_text=\"مشاهده تمام پلن های اینترنتی\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Login\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(242,245,250,0)\" background_color_gradient_end=\"#f2f5fa\" background_color_gradient_direction=\"90deg\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_padding=\"0|0px|0|0px|false|false\" border_radii=\"on|60px|60px|60px|60px\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_font_size=\"20px\" link_font=\"||||||||\" link_text_color=\"#0492ff\" text_orientation=\"center\" text_text_shadow_style=\"preset1\" text_text_shadow_color=\"#7cda24\"]<p>آماده اید ؟  جهت عضویت <a href=\"#\"><strong>اینجا را کلیک نمایید</strong></a></p>[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Value\" _builder_version=\"3.22\"][et_pb_row _builder_version=\"3.25\" custom_padding=\"||||false|false\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#0492ff\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>چرا انتخاب ما ؟</h2>[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" padding_top_bottom_link_1=\"false\" padding_top_bottom_link_2=\"false\" padding_top_bottom_link_3=\"false\" padding_left_right_link_1=\"true\" padding_left_right_link_2=\"true\" padding_left_right_link_3=\"true\" _builder_version=\"3.25\" max_width=\"1160px\" custom_padding=\"0|0px|27px|0px|false|false\" use_custom_width=\"on\" custom_width_px=\"1160px\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\" max_width__hover=\"1080px\" max_width__hover_enabled=\"1080px\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-03.png\" background_size=\"contain\" background_position=\"bottom_right\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"دریافت سرعت واقعی\" use_icon=\"on\" font_icon=\"%%243%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"20 درصد تخفیف\" use_icon=\"on\" font_icon=\"%%171%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-04.png\" background_size=\"contain\" background_position=\"top_right\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"بدون محدودیت حجمی\" use_icon=\"on\" font_icon=\"%%231%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است </span></p>[/et_pb_blurb][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Features\" _builder_version=\"3.22\" background_color=\"#f2f5fa\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_padding=\"54px|0px|0|0px|false|false\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row column_structure=\"3_5,2_5\" _builder_version=\"3.25\" custom_margin=\"100px||100px||true\" custom_margin_tablet=\"40px||40px||true\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\"][et_pb_column type=\"3_5\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/04/isp-01.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"|||-7vw\" custom_margin_tablet=\"|||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\"][/et_pb_image][/et_pb_column][et_pb_column type=\"2_5\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>انتخاب شماره 1# کاربران برای اینترنت  فیبر نوری</h2>\n<h3></h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>[/et_pb_text][et_pb_blurb title=\"بدون قعطی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"2em\" custom_margin=\"||20px\"][/et_pb_blurb][et_pb_blurb title=\"سرعت تا 65 مگابایت\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"2em\" custom_margin=\"||20px\"][/et_pb_blurb][et_pb_blurb title=\"شامل مودم رایگان\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"2em\" custom_margin=\"||20px\"][/et_pb_blurb][et_pb_button button_text=\"مشاهده پلن های اینترنت\" button_alignment=\"left\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" custom_margin=\"100px||100px||true\" custom_margin_tablet=\"40px||40px||true\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"14px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>داده نامحدود ،پشتیبانی شبانه روزی و سرویس پیامکی</h2>\n<h3>همه موارد را برای داشتن خطوط پیامکی موفق برای شما فراهم کرده ایم</h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد</span></p>[/et_pb_text][et_pb_button button_text=\"مشاهده پلن های پیامکی\" button_alignment=\"left\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/04/isp-02.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"|-7vw||\" custom_margin_tablet=\"|0vw||\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\" border_radii=\"on|30px|30px|30px|30px\"][/et_pb_image][/et_pb_column][/et_pb_row][et_pb_row custom_padding_last_edited=\"on|tablet\" _builder_version=\"4.4.2\" background_color=\"#ffffff\" max_width=\"80%\" module_alignment=\"right\" custom_margin=\"||\" custom_padding=\"60px|60px|||false|false\" custom_padding_tablet=\"|40px||40px\" custom_padding_phone=\"\" animation_style=\"slide\" animation_direction=\"right\" animation_intensity_slide=\"10%\" border_radii=\"|30px|||\" use_custom_width=\"on\" width_unit=\"off\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>محبوب ترین خدمات</h2>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد</span></p>[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Categories\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(242,245,250,0)\" background_color_gradient_end=\"#f2f5fa\" background_color_gradient_direction=\"90deg\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||60px\" custom_margin_tablet=\"||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|desktop\" custom_padding=\"0||0px||false|false\" border_radii=\"on|60px|60px|60px|60px\" locked=\"off\"][et_pb_row column_structure=\"1_6,1_6,1_6,1_6,1_6,1_6\" use_custom_gutter=\"on\" gutter_width=\"2\" _builder_version=\"3.25\" locked=\"off\"][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#ffffff\" text_orientation=\"center\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" locked=\"off\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" box_shadow_color__hover_enabled=\"on\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\" background_layout__hover_enabled=\"on\" background_layout__hover=\"dark\"]<p>پیامک</p>[/et_pb_text][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"Poppins|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#a0cf00\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" locked=\"off\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" box_shadow_color__hover_enabled=\"on\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\"]<p>ADSL</p>[/et_pb_text][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#008a1c\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" box_shadow_color__hover_enabled=\"on\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\"]<p>وایرلس</p>[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Pricing\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||||false\" custom_padding=\"80px||80px||true\" animation_style=\"slide\" animation_direction=\"bottom\" animation_intensity_slide=\"1%\" border_radii=\"on|30px|30px|30px|30px\" locked=\"off\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\"][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"40px|||\" custom_padding_tablet=\"0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px||\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#ffffff\" price_text_color=\"rgba(0,0,0,0.75)\" body_text_color=\"#ffffff\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"Poppins||||||||\" body_text_align=\"center\" subheader_font=\"|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"||on||||||\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(255,255,255,0)\" background_color_gradient_end=\"rgba(255,255,255,0.16)\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"Poppins|700||on|||||\" animation_style=\"slide\" animation_direction=\"right\" hover_enabled=\"0\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" price_font_size=\"50px\"][et_pb_pricing_table title=\"اینترنت پایه\" subtitle=\"1 مگابایت\" currency=\"یک ساله \" per=\"هزارتومان\" sum=\"35\" button_text=\"#\" _builder_version=\"4.4.2\" header_level=\"h2\" header_font=\"||||||||\" body_font=\"||||||||\" subheader_font=\"|800|||||||\" price_font=\"|800|on||||||\" price_letter_spacing=\"0px\" price_line_height=\"100px\" currency_frequency_font=\"|700|on||||||\" currency_frequency_line_height=\"1em\" excluded_text_color=\"rgba(255,255,255,0.5)\" pricing_item_excluded_color=\"rgba(255,255,255,0.5)\"]<p>+ گرانتی سرعت</p>\n<p>+ گارنتی کیفیت</p>\n<p>+ نصب در محل</p>\n<p>- تنظیم مودم</p>\n<p>- پشتیبانی 24 ساعته</p>[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#a0cf00\" price_text_color=\"rgba(0,0,0,0.75)\" subheader_text_color=\"#000000\" header_text_color=\"#000000\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"Poppins||||||||\" body_text_align=\"center\" subheader_font=\"Poppins|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"|800|on||||||\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#ffffff\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#008a1c\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"Poppins|700||on|||||\" custom_margin=\"0px||\" animation_style=\"zoom\" animation_delay=\"100ms\" hover_enabled=\"0\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" border_color_all=\"#ffffff\" border_width_top=\"40px\" border_width_bottom=\"30px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" locked=\"off\"][et_pb_pricing_table title=\"سرویس محبوب\" subtitle=\"65 مگابایت\" currency=\"سالانه\" per=\"هزارتومان\" sum=\"99\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" body_font=\"VAZIR FARSI||||||||\" hover_enabled=\"0\" header_font=\"||||||||\" header_level=\"h2\" subheader_font=\"VAZIR FARSI|800|||||||\" price_font=\"VAZIR FARSI|800|on||||||\" price_line_height=\"100px\" price_font_size=\"50px\"]<p>+ سرعت دانلود تا 65 مگابایت</p>\n<p>+ دانلود نامحدود</p>\n<p>+ پشتیبانی شبانه روزی</p>\n<p>+ مودم رایگان</p>\n<p>+ نصب رایگان</p>\n[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"40px|||\" custom_padding_tablet=\"0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|desktop\" padding_tablet=\"0px||\" padding_last_edited=\"on|desktop\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#ffffff\" price_text_color=\"rgba(0,0,0,0.75)\" body_text_color=\"#ffffff\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"Poppins||||||||\" body_text_align=\"center\" subheader_font=\"|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"||on||||||\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(255,255,255,0)\" background_color_gradient_end=\"rgba(255,255,255,0.16)\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"Poppins|700||on|||||\" animation_style=\"slide\" animation_direction=\"right\" hover_enabled=\"0\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" locked=\"off\" price_font_size=\"50px\" price_letter_spacing_last_edited=\"on|desktop\"][et_pb_pricing_table title=\"اینترنت حرفه ای\" subtitle=\"120 مگابایت\" currency=\"یک ساله \" per=\"هزارتومان\" sum=\"900\" button_text=\"#\" _builder_version=\"4.4.2\" header_level=\"h2\" header_font=\"||||||||\" body_font=\"||||||||\" subheader_font=\"|800|||||||\" price_font=\"VAZIR FARSI||on||||||\" price_letter_spacing=\"0px\" price_line_height=\"100px\" currency_frequency_font=\"|700|on||||||\" currency_frequency_line_height=\"1em\" excluded_text_color=\"rgba(255,255,255,0.5)\" pricing_item_excluded_color=\"rgba(255,255,255,0.5)\"]<p>+ گرانتی سرعت</p>\n<p>+ گارنتی کیفیت</p>\n<p>+ نصب در محل</p>\n<p>- تنظیم مودم</p>\n<p>- پشتیبانی 24 ساعته</p>[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Blog\" _builder_version=\"3.22\"][et_pb_row _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#0492ff\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>آخرین مقالات از وبلاگ ما</h2>\n[/et_pb_text][et_pb_blog fullwidth=\"off\" posts_number=\"3\" include_categories=\"70\" show_pagination=\"off\" _builder_version=\"3.17.6\" header_font=\"Poppins|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_line_height=\"2em\" meta_font=\"Poppins||||||||\" meta_text_color=\"#008a1c\" pagination_font=\"Poppins|700|on||||||\" pagination_text_color=\"#008a1c\" pagination_font_size=\"18px\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"][/et_pb_blog][et_pb_button button_text=\"رفتن به وبلاگ\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonials\" _builder_version=\"3.22\"][et_pb_row column_structure=\"2_5,3_5\" padding_top_bottom_link_1=\"true\" padding_top_bottom_link_2=\"true\" padding_left_right_link_1=\"false\" padding_left_right_link_2=\"false\" _builder_version=\"3.25\" custom_padding=\"0||0||false|false\"][et_pb_column type=\"2_5\" _builder_version=\"3.25\" custom_padding=\"60px|60px|60px|\" custom_padding_tablet=\"0px||0px||true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px||0px||true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>مشتریان در مورد ما چه می گویند ؟</h2>\n<h3>بهترین شرکت خدمات اینترنتی از دید مشتریان در سال های اخیر</h3>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"3_5\" _builder_version=\"3.25\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/handyman_11.png\" background_size=\"initial\" background_position=\"bottom_right\" custom_padding=\"60px|60px|60px|\" custom_padding_tablet=\"40px|40px|40px|40px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"40px|40px|40px|40px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_testimonial author=\"مشتری از سال 1390\" quote_icon=\"off\" _builder_version=\"4.4.2\" body_font=\"||on||||||\" body_font_size=\"14px\" body_line_height=\"2em\" background_color=\"#ffffff\" custom_margin=\"|||-40px\" custom_margin_tablet=\"|||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|desktop\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0.15)\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span>\"</p>\n[/et_pb_testimonial][et_pb_testimonial author=\"مشتری جدید\" quote_icon=\"off\" _builder_version=\"4.4.2\" body_font=\"||on||||||\" body_font_size=\"14px\" body_line_height=\"2em\" background_color=\"#ffffff\" custom_margin=\"|||-40px\" custom_margin_tablet=\"|||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|desktop\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0.15)\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span>\"</p>\n[/et_pb_testimonial][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" prev_background_color=\"#ffffff\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#0f1533\" background_color_gradient_end=\"#1f133a\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||5vw\" custom_padding=\"14vw||10vw\" top_divider_style=\"wave2\" top_divider_height=\"10vw\" top_divider_repeat=\"0.7x\" top_divider_flip=\"vertical\" animation_style=\"fade\" border_radii=\"on|30px|30px|30px|30px\" locked=\"off\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_phone=\"\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_2_font=\"|900|on||||||\" header_2_font_size=\"4vw\" header_2_letter_spacing=\"2px\" header_2_line_height=\"1.4em\" header_3_font=\"|900|on|on|||||\" header_3_text_color=\"rgba(255,255,255,0.7)\" header_3_font_size=\"1.5vw\" header_3_letter_spacing=\"0.4em\" header_3_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" hover_enabled=\"0\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_font_size__hover=\"30px\" header_font_size__hover_enabled=\"30px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h2>سرعت مورد نظر خود را با قیمتی که می خواهید دریافت کنید</h2>\n<h3>سرویس های ADSL  و سرویس های پیامکی</h3>\n[/et_pb_text][et_pb_button button_text=\"مشاهده تمام سرویس های ما\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section]", "خانه", "", "inherit", "closed", "closed", "", "2-revision-v1", "", "", "2020-04-02 12:49:42", "2020-04-02 09:19:42", "", "2", "http://modelsite.test/2-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2937", "1", "2020-04-02 12:51:59", "2020-04-02 09:21:59", "[et_pb_section fb_built=\"1\" admin_label=\"Header\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-05.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"5vw||||false\" custom_padding=\"10vw||14vw||false\" bottom_divider_style=\"wave2\" bottom_divider_color=\"#ffffff\" bottom_divider_height=\"10vw\" bottom_divider_repeat=\"0.7x\" animation_style=\"slide\" animation_direction=\"bottom\" animation_intensity_slide=\"1%\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_phone=\"\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" animation_style=\"slide\" animation_direction=\"left\" animation_intensity_slide=\"10%\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_font=\"|900|on|on|||||\" header_font_size=\"10vw\" header_letter_spacing=\"0.1em\" header_line_height=\"1.2em\" header_2_font=\"|900|on|on|||||\" header_2_text_color=\"rgba(255,255,255,0.7)\" header_2_font_size=\"44px\" header_2_letter_spacing=\"0em\" header_2_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" header_font_size_tablet=\"50px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|phone\" header_2_font_size_tablet=\"30px\" header_2_font_size_phone=\"20px\" header_2_font_size_last_edited=\"on|phone\" header_text_shadow_style=\"preset1\" header_text_shadow_color=\"rgba(0,0,0,0.15)\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h1>نهایت سرعت</h1>\n<p>&nbsp;</p>\n<h2><span color=\"rgba(0, 0, 0, 0.701960784313725)\" style=\"color: rgba(0, 0, 0, 0.7);\">35 هزارتومان </span>اینترنت ADSL</h2>[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_font_size=\"18px\" text_line_height=\"2em\" text_orientation=\"center\" background_layout=\"dark\" max_width=\"800px\" module_alignment=\"center\" text_font_size_tablet=\"16px\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>[/et_pb_text][et_pb_button button_text=\"مشاهده تمام پلن های اینترنتی\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Login\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(242,245,250,0)\" background_color_gradient_end=\"#f2f5fa\" background_color_gradient_direction=\"90deg\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_padding=\"0|0px|0|0px|false|false\" border_radii=\"on|60px|60px|60px|60px\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_font_size=\"20px\" link_font=\"||||||||\" link_text_color=\"#0492ff\" text_orientation=\"center\" text_text_shadow_style=\"preset1\" text_text_shadow_color=\"#7cda24\"]<p>آماده اید ؟  جهت عضویت <a href=\"#\"><strong>اینجا را کلیک نمایید</strong></a></p>[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Value\" _builder_version=\"3.22\"][et_pb_row _builder_version=\"3.25\" custom_padding=\"||||false|false\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#0492ff\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>چرا انتخاب ما ؟</h2>[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" padding_top_bottom_link_1=\"false\" padding_top_bottom_link_2=\"false\" padding_top_bottom_link_3=\"false\" padding_left_right_link_1=\"true\" padding_left_right_link_2=\"true\" padding_left_right_link_3=\"true\" _builder_version=\"3.25\" max_width=\"1160px\" custom_padding=\"0|0px|27px|0px|false|false\" use_custom_width=\"on\" custom_width_px=\"1160px\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\" max_width__hover=\"1080px\" max_width__hover_enabled=\"1080px\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-03.png\" background_size=\"contain\" background_position=\"bottom_right\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"دریافت سرعت واقعی\" use_icon=\"on\" font_icon=\"%%243%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"20 درصد تخفیف\" use_icon=\"on\" font_icon=\"%%171%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-04.png\" background_size=\"contain\" background_position=\"top_right\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"بدون محدودیت حجمی\" use_icon=\"on\" font_icon=\"%%231%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است </span></p>[/et_pb_blurb][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Features\" _builder_version=\"3.22\" background_color=\"#f2f5fa\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_padding=\"54px|0px|0|0px|false|false\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row column_structure=\"3_5,2_5\" _builder_version=\"3.25\" custom_margin=\"100px||100px||true\" custom_margin_tablet=\"40px||40px||true\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\"][et_pb_column type=\"3_5\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/04/isp-01.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"|||-7vw\" custom_margin_tablet=\"|||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\"][/et_pb_image][/et_pb_column][et_pb_column type=\"2_5\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>انتخاب شماره 1# کاربران برای اینترنت  فیبر نوری</h2>\n<h3></h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>[/et_pb_text][et_pb_blurb title=\"بدون قعطی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"2em\" custom_margin=\"||20px\"][/et_pb_blurb][et_pb_blurb title=\"سرعت تا 65 مگابایت\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"2em\" custom_margin=\"||20px\"][/et_pb_blurb][et_pb_blurb title=\"شامل مودم رایگان\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"2em\" custom_margin=\"||20px\"][/et_pb_blurb][et_pb_button button_text=\"مشاهده پلن های اینترنت\" button_alignment=\"left\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" custom_margin=\"100px||100px||true\" custom_margin_tablet=\"40px||40px||true\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"14px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>داده نامحدود ،پشتیبانی شبانه روزی و سرویس پیامکی</h2>\n<h3>همه موارد را برای داشتن خطوط پیامکی موفق برای شما فراهم کرده ایم</h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد</span></p>[/et_pb_text][et_pb_button button_text=\"مشاهده پلن های پیامکی\" button_alignment=\"left\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/04/isp-02.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"|-7vw||\" custom_margin_tablet=\"|0vw||\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\" border_radii=\"on|30px|30px|30px|30px\"][/et_pb_image][/et_pb_column][/et_pb_row][et_pb_row custom_padding_last_edited=\"on|tablet\" _builder_version=\"4.4.2\" background_color=\"#ffffff\" max_width=\"80%\" module_alignment=\"right\" custom_margin=\"||\" custom_padding=\"60px|60px|||false|false\" custom_padding_tablet=\"|40px||40px\" custom_padding_phone=\"\" animation_style=\"slide\" animation_direction=\"right\" animation_intensity_slide=\"10%\" border_radii=\"|30px|||\" use_custom_width=\"on\" width_unit=\"off\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>محبوب ترین خدمات</h2>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد</span></p>[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Categories\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(242,245,250,0)\" background_color_gradient_end=\"#f2f5fa\" background_color_gradient_direction=\"90deg\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||60px\" custom_margin_tablet=\"||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|desktop\" custom_padding=\"0||0px||false|false\" border_radii=\"on|60px|60px|60px|60px\" locked=\"off\"][et_pb_row column_structure=\"1_6,1_6,1_6,1_6,1_6,1_6\" use_custom_gutter=\"on\" gutter_width=\"2\" _builder_version=\"3.25\" locked=\"off\"][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#ffffff\" text_orientation=\"center\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" locked=\"off\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" box_shadow_color__hover_enabled=\"on\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\" background_layout__hover_enabled=\"on\" background_layout__hover=\"dark\"]<p>پیامک</p>[/et_pb_text][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"Poppins|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#a0cf00\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" locked=\"off\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" box_shadow_color__hover_enabled=\"on\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\"]<p>ADSL</p>[/et_pb_text][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#008a1c\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" box_shadow_color__hover_enabled=\"on\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\"]<p>وایرلس</p>[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Pricing\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||||false\" custom_padding=\"80px||80px||true\" animation_style=\"slide\" animation_direction=\"bottom\" animation_intensity_slide=\"1%\" border_radii=\"on|30px|30px|30px|30px\" locked=\"off\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\"][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"40px|||\" custom_padding_tablet=\"0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px||\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#ffffff\" price_text_color=\"rgba(0,0,0,0.75)\" body_text_color=\"#ffffff\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"||||||||\" body_text_align=\"center\" subheader_font=\"|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"||on||||||\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(255,255,255,0)\" background_color_gradient_end=\"rgba(255,255,255,0.16)\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"Poppins|700||on|||||\" animation_style=\"slide\" animation_direction=\"right\" hover_enabled=\"0\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" price_font_size=\"50px\"][et_pb_pricing_table title=\"اینترنت پایه\" subtitle=\"1 مگابایت\" currency=\"یک ساله \" per=\"هزارتومان\" sum=\"35\" button_text=\"#\" _builder_version=\"4.4.2\" header_level=\"h2\" header_font=\"||||||||\" body_font=\"VAZIR FARSI||||||||\" subheader_font=\"|800|||||||\" price_font=\"|800|on||||||\" price_letter_spacing=\"0px\" price_line_height=\"100px\" currency_frequency_font=\"|700|on||||||\" currency_frequency_line_height=\"1em\" excluded_text_color=\"rgba(255,255,255,0.5)\" hover_enabled=\"0\" pricing_item_excluded_color=\"rgba(255,255,255,0.5)\"]<p>+ گارانتی سرعت</p>\n<p>+ گارنتی کیفیت</p>\n<p>+ نصب در محل</p>\n<p>- تنظیم مودم</p>\n<p>- پشتیبانی 24 ساعته</p>\n[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#a0cf00\" price_text_color=\"rgba(0,0,0,0.75)\" subheader_text_color=\"#000000\" header_text_color=\"#000000\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"Poppins||||||||\" body_text_align=\"center\" subheader_font=\"Poppins|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"|800|on||||||\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#ffffff\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#008a1c\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"Poppins|700||on|||||\" custom_margin=\"0px||\" animation_style=\"zoom\" animation_delay=\"100ms\" hover_enabled=\"0\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" border_color_all=\"#ffffff\" border_width_top=\"40px\" border_width_bottom=\"30px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" locked=\"off\"][et_pb_pricing_table title=\"سرویس محبوب\" subtitle=\"65 مگابایت\" currency=\"سالانه\" per=\"هزارتومان\" sum=\"99\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" body_font=\"VAZIR FARSI||||||||\" hover_enabled=\"0\" header_font=\"||||||||\" header_level=\"h2\" subheader_font=\"VAZIR FARSI|800|||||||\" price_font=\"VAZIR FARSI|800|on||||||\" price_line_height=\"100px\" price_font_size=\"50px\"]<p>+ سرعت دانلود تا 65 مگابایت</p>\n<p>+ دانلود نامحدود</p>\n<p>+ پشتیبانی شبانه روزی</p>\n<p>+ مودم رایگان</p>\n<p>+ نصب رایگان</p>\n[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"40px|||\" custom_padding_tablet=\"0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|desktop\" padding_tablet=\"0px||\" padding_last_edited=\"on|desktop\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#ffffff\" price_text_color=\"rgba(0,0,0,0.75)\" body_text_color=\"#ffffff\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"||||||||\" body_text_align=\"center\" subheader_font=\"|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"||on||||||\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(255,255,255,0)\" background_color_gradient_end=\"rgba(255,255,255,0.16)\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"Poppins|700||on|||||\" animation_style=\"slide\" animation_direction=\"right\" hover_enabled=\"0\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" locked=\"off\" price_font_size=\"50px\" price_letter_spacing_last_edited=\"on|desktop\"][et_pb_pricing_table title=\"اینترنت حرفه ای\" subtitle=\"120 مگابایت\" currency=\"یک ساله \" per=\"هزارتومان\" sum=\"900\" button_text=\"#\" _builder_version=\"4.4.2\" header_level=\"h2\" header_font=\"||||||||\" body_font=\"VAZIR FARSI||||||||\" subheader_font=\"|800|||||||\" price_font=\"VAZIR FARSI||on||||||\" price_letter_spacing=\"0px\" price_line_height=\"100px\" currency_frequency_font=\"|700|on||||||\" currency_frequency_line_height=\"1em\" excluded_text_color=\"rgba(255,255,255,0.5)\" hover_enabled=\"0\" pricing_item_excluded_color=\"rgba(255,255,255,0.5)\"]<p>+ گارانتی سرعت</p>\n<p>+ گارنتی کیفیت</p>\n<p>+ نصب در محل</p>\n<p>- تنظیم مودم</p>\n<p>- پشتیبانی 24 ساعته</p>\n[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Blog\" _builder_version=\"3.22\"][et_pb_row _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#0492ff\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>آخرین مقالات از وبلاگ ما</h2>\n[/et_pb_text][et_pb_blog fullwidth=\"off\" posts_number=\"3\" include_categories=\"70\" show_pagination=\"off\" _builder_version=\"3.17.6\" header_font=\"Poppins|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_line_height=\"2em\" meta_font=\"Poppins||||||||\" meta_text_color=\"#008a1c\" pagination_font=\"Poppins|700|on||||||\" pagination_text_color=\"#008a1c\" pagination_font_size=\"18px\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"][/et_pb_blog][et_pb_button button_text=\"رفتن به وبلاگ\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonials\" _builder_version=\"3.22\"][et_pb_row column_structure=\"2_5,3_5\" padding_top_bottom_link_1=\"true\" padding_top_bottom_link_2=\"true\" padding_left_right_link_1=\"false\" padding_left_right_link_2=\"false\" _builder_version=\"3.25\" custom_padding=\"0||0||false|false\"][et_pb_column type=\"2_5\" _builder_version=\"3.25\" custom_padding=\"60px|60px|60px|\" custom_padding_tablet=\"0px||0px||true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px||0px||true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>مشتریان در مورد ما چه می گویند ؟</h2>\n<h3>بهترین شرکت خدمات اینترنتی از دید مشتریان در سال های اخیر</h3>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"3_5\" _builder_version=\"3.25\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/handyman_11.png\" background_size=\"initial\" background_position=\"bottom_right\" custom_padding=\"60px|60px|60px|\" custom_padding_tablet=\"40px|40px|40px|40px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"40px|40px|40px|40px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_testimonial author=\"مشتری از سال 1390\" quote_icon=\"off\" _builder_version=\"4.4.2\" body_font=\"||on||||||\" body_font_size=\"14px\" body_line_height=\"2em\" background_color=\"#ffffff\" custom_margin=\"|||-40px\" custom_margin_tablet=\"|||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|desktop\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0.15)\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span>\"</p>\n[/et_pb_testimonial][et_pb_testimonial author=\"مشتری جدید\" quote_icon=\"off\" _builder_version=\"4.4.2\" body_font=\"||on||||||\" body_font_size=\"14px\" body_line_height=\"2em\" background_color=\"#ffffff\" custom_margin=\"|||-40px\" custom_margin_tablet=\"|||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|desktop\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0.15)\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span>\"</p>\n[/et_pb_testimonial][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" prev_background_color=\"#ffffff\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#0f1533\" background_color_gradient_end=\"#1f133a\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||5vw\" custom_padding=\"14vw||10vw\" top_divider_style=\"wave2\" top_divider_height=\"10vw\" top_divider_repeat=\"0.7x\" top_divider_flip=\"vertical\" animation_style=\"fade\" border_radii=\"on|30px|30px|30px|30px\" locked=\"off\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_phone=\"\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_2_font=\"|900|on||||||\" header_2_font_size=\"4vw\" header_2_letter_spacing=\"2px\" header_2_line_height=\"1.4em\" header_3_font=\"|900|on|on|||||\" header_3_text_color=\"rgba(255,255,255,0.7)\" header_3_font_size=\"1.5vw\" header_3_letter_spacing=\"0.4em\" header_3_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" hover_enabled=\"0\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_font_size__hover=\"30px\" header_font_size__hover_enabled=\"30px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h2>سرعت مورد نظر خود را با قیمتی که می خواهید دریافت کنید</h2>\n<h3>سرویس های ADSL  و سرویس های پیامکی</h3>\n[/et_pb_text][et_pb_button button_text=\"مشاهده تمام سرویس های ما\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section]", "خانه", "", "inherit", "closed", "closed", "", "2-revision-v1", "", "", "2020-04-02 12:51:59", "2020-04-02 09:21:59", "", "2", "http://modelsite.test/2-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2939", "1", "2020-04-02 13:02:01", "2020-04-02 09:32:01", "[et_pb_section fb_built=\"1\" admin_label=\"Header\" _builder_version=\"4.4.2\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-05.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"5vw||||false\" custom_padding=\"10vw||14vw||false\" bottom_divider_style=\"wave2\" bottom_divider_color=\"#ffffff\" bottom_divider_height=\"10vw\" bottom_divider_repeat=\"0.7x\" animation_style=\"slide\" animation_direction=\"bottom\" animation_intensity_slide=\"1%\" hover_enabled=\"0\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_phone=\"\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" animation_style=\"slide\" animation_direction=\"left\" animation_intensity_slide=\"10%\" hover_enabled=\"0\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_font=\"|900|on|on|||||\" header_font_size=\"10vw\" header_letter_spacing=\"0.1em\" header_line_height=\"1.2em\" header_2_font=\"|900|on|on|||||\" header_2_text_color=\"rgba(255,255,255,0.7)\" header_2_font_size=\"44px\" header_2_letter_spacing=\"0em\" header_2_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" header_font_size_tablet=\"50px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|phone\" header_2_font_size_tablet=\"30px\" header_2_font_size_phone=\"20px\" header_2_font_size_last_edited=\"on|phone\" header_text_shadow_style=\"preset1\" header_text_shadow_color=\"rgba(0,0,0,0.15)\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h1>نهایت سرعت</h1>\n<p>&nbsp;</p>\n<h2><span color=\"rgba(0, 0, 0, 0.701960784313725)\" style=\"color: rgba(0, 0, 0, 0.7);\">35 هزارتومان </span>اینترنت ADSL</h2>[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_font_size=\"18px\" text_line_height=\"2em\" text_orientation=\"center\" background_layout=\"dark\" max_width=\"800px\" module_alignment=\"center\" text_font_size_tablet=\"16px\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>[/et_pb_text][et_pb_button button_text=\"مشاهده تمام پلن های اینترنتی\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#0c71c3\" button_bg_enable_color__hover=\"on\" button_text_color__hover_enabled=\"on|hover\" button_text_color__hover=\"#ffffff\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Login\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(242,245,250,0)\" background_color_gradient_end=\"#f2f5fa\" background_color_gradient_direction=\"90deg\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_padding=\"0|0px|0|0px|false|false\" border_radii=\"on|60px|60px|60px|60px\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_font_size=\"20px\" link_font=\"||||||||\" link_text_color=\"#0492ff\" text_orientation=\"center\" hover_enabled=\"0\" text_text_shadow_style=\"preset1\" text_text_shadow_color=\"#7cda24\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate_linked__hover=\"off\" transform_translate__hover=\"-50px|0px\"]<p>آماده اید ؟  جهت عضویت <a href=\"#\"><strong>اینجا را کلیک نمایید</strong></a></p>[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Value\" _builder_version=\"3.22\"][et_pb_row _builder_version=\"3.25\" custom_padding=\"||||false|false\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#0492ff\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>چرا انتخاب ما ؟</h2>[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" padding_top_bottom_link_1=\"false\" padding_top_bottom_link_2=\"false\" padding_top_bottom_link_3=\"false\" padding_left_right_link_1=\"true\" padding_left_right_link_2=\"true\" padding_left_right_link_3=\"true\" _builder_version=\"3.25\" max_width=\"1160px\" custom_padding=\"0|0px|27px|0px|false|false\" use_custom_width=\"on\" custom_width_px=\"1160px\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\" max_width__hover=\"1080px\" max_width__hover_enabled=\"1080px\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-03.png\" background_size=\"contain\" background_position=\"bottom_right\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"دریافت سرعت واقعی\" use_icon=\"on\" font_icon=\"%%243%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|desktop\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate=\"0deg|330deg|0deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"20 درصد تخفیف\" use_icon=\"on\" font_icon=\"%%171%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"0deg|0deg|330deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-04.png\" background_size=\"contain\" background_position=\"top_right\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"بدون محدودیت حجمی\" use_icon=\"on\" font_icon=\"%%231%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"330deg|0deg|0deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است </span></p>[/et_pb_blurb][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Features\" _builder_version=\"3.22\" background_color=\"#f2f5fa\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_padding=\"54px|0px|0|0px|false|false\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row column_structure=\"3_5,2_5\" _builder_version=\"3.25\" custom_margin=\"100px||100px||true\" custom_margin_tablet=\"40px||40px||true\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\"][et_pb_column type=\"3_5\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/04/isp-01.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"|||-7vw\" custom_margin_tablet=\"|||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\"][/et_pb_image][/et_pb_column][et_pb_column type=\"2_5\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>انتخاب شماره 1# کاربران برای اینترنت  فیبر نوری</h2>\n<h3></h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>[/et_pb_text][et_pb_blurb title=\"بدون قعطی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"2em\" custom_margin=\"||20px\"][/et_pb_blurb][et_pb_blurb title=\"سرعت تا 65 مگابایت\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"2em\" custom_margin=\"||20px\"][/et_pb_blurb][et_pb_blurb title=\"شامل مودم رایگان\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"2em\" custom_margin=\"||20px\"][/et_pb_blurb][et_pb_button button_text=\"مشاهده پلن های اینترنت\" button_alignment=\"left\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#7cda24\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" custom_margin=\"100px||100px||true\" custom_margin_tablet=\"40px||40px||true\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"14px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>داده نامحدود ،پشتیبانی شبانه روزی و سرویس پیامکی</h2>\n<h3>همه موارد را برای داشتن خطوط پیامکی موفق برای شما فراهم کرده ایم</h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد</span></p>[/et_pb_text][et_pb_button button_text=\"مشاهده پلن های پیامکی\" button_alignment=\"left\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#7cda24\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/04/isp-02.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"|-7vw||\" custom_margin_tablet=\"|0vw||\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\" border_radii=\"on|30px|30px|30px|30px\"][/et_pb_image][/et_pb_column][/et_pb_row][et_pb_row custom_padding_last_edited=\"on|tablet\" _builder_version=\"4.4.2\" background_color=\"#ffffff\" max_width=\"80%\" module_alignment=\"right\" custom_margin=\"||\" custom_padding=\"60px|60px|||false|false\" custom_padding_tablet=\"|40px||40px\" custom_padding_phone=\"\" animation_style=\"slide\" animation_direction=\"right\" animation_intensity_slide=\"10%\" border_radii=\"|30px|||\" use_custom_width=\"on\" width_unit=\"off\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>محبوب ترین خدمات</h2>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد</span></p>[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Categories\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(242,245,250,0)\" background_color_gradient_end=\"#f2f5fa\" background_color_gradient_direction=\"90deg\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||60px\" custom_margin_tablet=\"||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|desktop\" custom_padding=\"0||0px||false|false\" border_radii=\"on|60px|60px|60px|60px\" locked=\"off\"][et_pb_row column_structure=\"1_6,1_6,1_6,1_6,1_6,1_6\" use_custom_gutter=\"on\" gutter_width=\"2\" _builder_version=\"3.25\" locked=\"off\"][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#ffffff\" text_orientation=\"center\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" locked=\"off\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" box_shadow_color__hover_enabled=\"on\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\" background_layout__hover_enabled=\"on\" background_layout__hover=\"dark\"]<p>پیامک</p>[/et_pb_text][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"Poppins|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#a0cf00\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" locked=\"off\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" box_shadow_color__hover_enabled=\"on\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\"]<p>ADSL</p>[/et_pb_text][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#008a1c\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" box_shadow_color__hover_enabled=\"on\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\"]<p>وایرلس</p>[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Pricing\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||||false\" custom_padding=\"80px||80px||true\" animation_style=\"slide\" animation_direction=\"bottom\" animation_intensity_slide=\"1%\" border_radii=\"on|30px|30px|30px|30px\" locked=\"off\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\"][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"40px|||\" custom_padding_tablet=\"0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px||\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#ffffff\" price_text_color=\"rgba(0,0,0,0.75)\" body_text_color=\"#ffffff\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"||||||||\" body_text_align=\"center\" subheader_font=\"|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"||on||||||\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(255,255,255,0)\" background_color_gradient_end=\"rgba(255,255,255,0.16)\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" animation_style=\"slide\" animation_direction=\"right\" hover_enabled=\"0\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" price_font_size=\"50px\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate_linked__hover=\"off\" transform_translate__hover=\"0px|-70px\"][et_pb_pricing_table title=\"اینترنت پایه\" subtitle=\"1 مگابایت\" currency=\"یک ساله \" per=\"هزارتومان\" sum=\"35\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" header_level=\"h2\" header_font=\"||||||||\" body_font=\"VAZIR FARSI||||||||\" subheader_font=\"|800|||||||\" price_font=\"|800|on||||||\" price_letter_spacing=\"0px\" price_line_height=\"100px\" currency_frequency_font=\"|700|on||||||\" currency_frequency_line_height=\"1em\" excluded_text_color=\"rgba(255,255,255,0.5)\" hover_enabled=\"0\" pricing_item_excluded_color=\"rgba(255,255,255,0.5)\" button_url=\"#\" custom_button=\"on\" button_font=\"VAZIR FARSI||||||||\"]<p>+ گارانتی سرعت</p>\n<p>+ گارنتی کیفیت</p>\n<p>+ نصب در محل</p>\n<p>- تنظیم مودم</p>\n<p>- پشتیبانی 24 ساعته</p>\n[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#a0cf00\" price_text_color=\"rgba(0,0,0,0.75)\" subheader_text_color=\"#000000\" header_text_color=\"#000000\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"Poppins||||||||\" body_text_align=\"center\" subheader_font=\"Poppins|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"|800|on||||||\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#ffffff\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#008a1c\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" custom_margin=\"0px||\" animation_style=\"zoom\" animation_delay=\"100ms\" hover_enabled=\"0\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" border_color_all=\"#ffffff\" border_width_top=\"40px\" border_width_bottom=\"30px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" locked=\"off\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate_linked__hover=\"off\" transform_translate__hover=\"0px|-70px\"][et_pb_pricing_table title=\"سرویس محبوب\" subtitle=\"65 مگابایت\" currency=\"سالانه\" per=\"هزارتومان\" sum=\"99\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" body_font=\"VAZIR FARSI||||||||\" hover_enabled=\"0\" header_font=\"||||||||\" header_level=\"h2\" subheader_font=\"VAZIR FARSI|800|||||||\" price_font=\"VAZIR FARSI|800|on||||||\" price_line_height=\"100px\" price_font_size=\"50px\" button_url=\"#\" custom_button=\"on\" button_font=\"VAZIR FARSI||||||||\"]<p>+ سرعت دانلود تا 65 مگابایت</p>\n<p>+ دانلود نامحدود</p>\n<p>+ پشتیبانی شبانه روزی</p>\n<p>+ مودم رایگان</p>\n<p>+ نصب رایگان</p>\n[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"40px|||\" custom_padding_tablet=\"0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|desktop\" padding_tablet=\"0px||\" padding_last_edited=\"on|desktop\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#ffffff\" price_text_color=\"rgba(0,0,0,0.75)\" body_text_color=\"#ffffff\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"||||||||\" body_text_align=\"center\" subheader_font=\"|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"||on||||||\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(255,255,255,0)\" background_color_gradient_end=\"rgba(255,255,255,0.16)\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" animation_style=\"slide\" animation_direction=\"right\" hover_enabled=\"0\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" locked=\"off\" price_font_size=\"50px\" price_letter_spacing_last_edited=\"on|desktop\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate_linked__hover=\"off\" transform_translate__hover=\"0px|-70px\"][et_pb_pricing_table title=\"اینترنت حرفه ای\" subtitle=\"120 مگابایت\" currency=\"یک ساله \" per=\"هزارتومان\" sum=\"900\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" header_level=\"h2\" header_font=\"||||||||\" body_font=\"VAZIR FARSI||||||||\" subheader_font=\"|800|||||||\" price_font=\"VAZIR FARSI||on||||||\" price_letter_spacing=\"0px\" price_line_height=\"100px\" currency_frequency_font=\"|700|on||||||\" currency_frequency_line_height=\"1em\" excluded_text_color=\"rgba(255,255,255,0.5)\" hover_enabled=\"0\" pricing_item_excluded_color=\"rgba(255,255,255,0.5)\" button_url=\"#\" custom_button=\"on\" button_font=\"VAZIR FARSI||||||||\"]<p>+ گارانتی سرعت</p>\n<p>+ گارنتی کیفیت</p>\n<p>+ نصب در محل</p>\n<p>- تنظیم مودم</p>\n<p>- پشتیبانی 24 ساعته</p>\n[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Blog\" _builder_version=\"3.22\"][et_pb_row _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#0492ff\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>آخرین مقالات از وبلاگ ما</h2>\n[/et_pb_text][et_pb_blog fullwidth=\"off\" posts_number=\"3\" include_categories=\"70\" show_pagination=\"off\" _builder_version=\"3.17.6\" header_font=\"Poppins|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_line_height=\"2em\" meta_font=\"Poppins||||||||\" meta_text_color=\"#008a1c\" pagination_font=\"Poppins|700|on||||||\" pagination_text_color=\"#008a1c\" pagination_font_size=\"18px\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"][/et_pb_blog][et_pb_button button_text=\"رفتن به وبلاگ\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#7cda24\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonials\" _builder_version=\"3.22\"][et_pb_row column_structure=\"2_5,3_5\" padding_top_bottom_link_1=\"true\" padding_top_bottom_link_2=\"true\" padding_left_right_link_1=\"false\" padding_left_right_link_2=\"false\" _builder_version=\"3.25\" custom_padding=\"0||0||false|false\"][et_pb_column type=\"2_5\" _builder_version=\"3.25\" custom_padding=\"60px|60px|60px|\" custom_padding_tablet=\"0px||0px||true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px||0px||true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>مشتریان در مورد ما چه می گویند ؟</h2>\n<h3>بهترین شرکت خدمات اینترنتی از دید مشتریان در سال های اخیر</h3>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"3_5\" _builder_version=\"3.25\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/handyman_11.png\" background_size=\"initial\" background_position=\"bottom_right\" custom_padding=\"60px|60px|60px|\" custom_padding_tablet=\"40px|40px|40px|40px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"40px|40px|40px|40px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_testimonial author=\"مشتری از سال 1390\" quote_icon=\"off\" _builder_version=\"4.4.2\" body_font=\"||on||||||\" body_font_size=\"14px\" body_line_height=\"2em\" background_color=\"#ffffff\" custom_margin=\"|||-40px\" custom_margin_tablet=\"|||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|desktop\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0.15)\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span>\"</p>\n[/et_pb_testimonial][et_pb_testimonial author=\"مشتری جدید\" quote_icon=\"off\" _builder_version=\"4.4.2\" body_font=\"||on||||||\" body_font_size=\"14px\" body_line_height=\"2em\" background_color=\"#ffffff\" custom_margin=\"|||-40px\" custom_margin_tablet=\"|||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|desktop\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0.15)\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span>\"</p>\n[/et_pb_testimonial][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" prev_background_color=\"#ffffff\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#0f1533\" background_color_gradient_end=\"#1f133a\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||5vw\" custom_padding=\"14vw||10vw\" top_divider_style=\"wave2\" top_divider_height=\"10vw\" top_divider_repeat=\"0.7x\" top_divider_flip=\"vertical\" animation_style=\"fade\" border_radii=\"on|30px|30px|30px|30px\" locked=\"off\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_phone=\"\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_2_font=\"|900|on||||||\" header_2_font_size=\"4vw\" header_2_letter_spacing=\"2px\" header_2_line_height=\"1.4em\" header_3_font=\"|900|on|on|||||\" header_3_text_color=\"rgba(255,255,255,0.7)\" header_3_font_size=\"1.5vw\" header_3_letter_spacing=\"0.4em\" header_3_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" hover_enabled=\"0\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_font_size__hover=\"30px\" header_font_size__hover_enabled=\"30px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h2>سرعت مورد نظر خود را با قیمتی که می خواهید دریافت کنید</h2>\n<h3>سرویس های ADSL  و سرویس های پیامکی</h3>\n[/et_pb_text][et_pb_button button_text=\"مشاهده تمام سرویس های ما\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#7cda24\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section]", "خانه", "", "inherit", "closed", "closed", "", "2-revision-v1", "", "", "2020-04-02 13:02:01", "2020-04-02 09:32:01", "", "2", "http://modelsite.test/2-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2941", "1", "2020-04-02 13:05:52", "2020-04-02 09:35:52", "[et_pb_section fb_built=\"1\" admin_label=\"Header\" _builder_version=\"4.4.2\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-05.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"5vw||||false\" custom_padding=\"10vw||14vw||false\" bottom_divider_style=\"wave2\" bottom_divider_color=\"#ffffff\" bottom_divider_height=\"10vw\" bottom_divider_repeat=\"0.7x\" animation_style=\"slide\" animation_direction=\"bottom\" animation_intensity_slide=\"1%\" hover_enabled=\"0\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_phone=\"\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" animation_style=\"slide\" animation_direction=\"left\" animation_intensity_slide=\"10%\" hover_enabled=\"0\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_font=\"|900|on|on|||||\" header_font_size=\"10vw\" header_letter_spacing=\"0.1em\" header_line_height=\"1.2em\" header_2_font=\"|900|on|on|||||\" header_2_text_color=\"rgba(255,255,255,0.7)\" header_2_font_size=\"44px\" header_2_letter_spacing=\"0em\" header_2_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" header_font_size_tablet=\"50px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|phone\" header_2_font_size_tablet=\"30px\" header_2_font_size_phone=\"20px\" header_2_font_size_last_edited=\"on|phone\" header_text_shadow_style=\"preset1\" header_text_shadow_color=\"rgba(0,0,0,0.15)\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h1>نهایت سرعت</h1>\n<p>&nbsp;</p>\n<h2><span color=\"rgba(0, 0, 0, 0.701960784313725)\" style=\"color: rgba(0, 0, 0, 0.7);\">35 هزارتومان </span>اینترنت ADSL</h2>[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_font_size=\"18px\" text_line_height=\"2em\" text_orientation=\"center\" background_layout=\"dark\" max_width=\"800px\" module_alignment=\"center\" text_font_size_tablet=\"16px\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>[/et_pb_text][et_pb_button button_text=\"مشاهده تمام پلن های اینترنتی\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#0c71c3\" button_bg_enable_color__hover=\"on\" button_text_color__hover_enabled=\"on|hover\" button_text_color__hover=\"#ffffff\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Login\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(242,245,250,0)\" background_color_gradient_end=\"#f2f5fa\" background_color_gradient_direction=\"90deg\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_padding=\"0|0px|0|0px|false|false\" border_radii=\"on|60px|60px|60px|60px\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_font_size=\"20px\" link_font=\"||||||||\" link_text_color=\"#0492ff\" text_orientation=\"center\" hover_enabled=\"0\" text_text_shadow_style=\"preset1\" text_text_shadow_color=\"#7cda24\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate_linked__hover=\"off\" transform_translate__hover=\"-50px|0px\"]<p>آماده اید ؟  جهت عضویت <a href=\"#\"><strong>اینجا را کلیک نمایید</strong></a></p>[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Value\" _builder_version=\"3.22\"][et_pb_row _builder_version=\"3.25\" custom_padding=\"||||false|false\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#0492ff\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>چرا انتخاب ما ؟</h2>[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" padding_top_bottom_link_1=\"false\" padding_top_bottom_link_2=\"false\" padding_top_bottom_link_3=\"false\" padding_left_right_link_1=\"true\" padding_left_right_link_2=\"true\" padding_left_right_link_3=\"true\" _builder_version=\"3.25\" max_width=\"1160px\" custom_padding=\"0|0px|27px|0px|false|false\" use_custom_width=\"on\" custom_width_px=\"1160px\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\" max_width__hover=\"1080px\" max_width__hover_enabled=\"1080px\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-03.png\" background_size=\"contain\" background_position=\"bottom_right\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"دریافت سرعت واقعی\" use_icon=\"on\" font_icon=\"%%243%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|hover\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"0deg|330deg|0deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"20 درصد تخفیف\" use_icon=\"on\" font_icon=\"%%171%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"0deg|0deg|330deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-04.png\" background_size=\"contain\" background_position=\"top_right\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"بدون محدودیت حجمی\" use_icon=\"on\" font_icon=\"%%231%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"330deg|0deg|0deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است </span></p>[/et_pb_blurb][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Features\" _builder_version=\"3.22\" background_color=\"#f2f5fa\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_padding=\"54px|0px|0|0px|false|false\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row column_structure=\"3_5,2_5\" _builder_version=\"3.25\" custom_margin=\"100px||100px||true\" custom_margin_tablet=\"40px||40px||true\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\"][et_pb_column type=\"3_5\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/04/isp-01.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"|||-7vw\" custom_margin_tablet=\"|||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\"][/et_pb_image][/et_pb_column][et_pb_column type=\"2_5\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>انتخاب شماره 1# کاربران برای اینترنت  فیبر نوری</h2>\n<h3></h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>[/et_pb_text][et_pb_blurb title=\"بدون قعطی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"2em\" custom_margin=\"||20px\"][/et_pb_blurb][et_pb_blurb title=\"سرعت تا 65 مگابایت\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"2em\" custom_margin=\"||20px\"][/et_pb_blurb][et_pb_blurb title=\"شامل مودم رایگان\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"2em\" custom_margin=\"||20px\"][/et_pb_blurb][et_pb_button button_text=\"مشاهده پلن های اینترنت\" button_alignment=\"left\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#7cda24\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" custom_margin=\"100px||100px||true\" custom_margin_tablet=\"40px||40px||true\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"14px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>داده نامحدود ،پشتیبانی شبانه روزی و سرویس پیامکی</h2>\n<h3>همه موارد را برای داشتن خطوط پیامکی موفق برای شما فراهم کرده ایم</h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد</span></p>[/et_pb_text][et_pb_button button_text=\"مشاهده پلن های پیامکی\" button_alignment=\"left\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#7cda24\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/04/isp-02.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"|-7vw||\" custom_margin_tablet=\"|0vw||\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\" border_radii=\"on|30px|30px|30px|30px\"][/et_pb_image][/et_pb_column][/et_pb_row][et_pb_row custom_padding_last_edited=\"on|tablet\" _builder_version=\"4.4.2\" background_color=\"#ffffff\" max_width=\"80%\" module_alignment=\"right\" custom_margin=\"||\" custom_padding=\"60px|60px|||false|false\" custom_padding_tablet=\"|40px||40px\" custom_padding_phone=\"\" animation_style=\"slide\" animation_direction=\"right\" animation_intensity_slide=\"10%\" border_radii=\"|30px|||\" use_custom_width=\"on\" width_unit=\"off\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>محبوب ترین خدمات</h2>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد</span></p>[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Categories\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(242,245,250,0)\" background_color_gradient_end=\"#f2f5fa\" background_color_gradient_direction=\"90deg\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||60px\" custom_margin_tablet=\"||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|desktop\" custom_padding=\"0||0px||false|false\" border_radii=\"on|60px|60px|60px|60px\" locked=\"off\"][et_pb_row column_structure=\"1_6,1_6,1_6,1_6,1_6,1_6\" use_custom_gutter=\"on\" gutter_width=\"2\" _builder_version=\"3.25\" locked=\"off\"][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#ffffff\" text_orientation=\"center\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" locked=\"off\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" box_shadow_color__hover_enabled=\"on\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\" background_layout__hover_enabled=\"on\" background_layout__hover=\"dark\"]<p>پیامک</p>[/et_pb_text][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"Poppins|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#a0cf00\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" locked=\"off\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" box_shadow_color__hover_enabled=\"on\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\"]<p>ADSL</p>[/et_pb_text][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#008a1c\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" box_shadow_color__hover_enabled=\"on\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\"]<p>وایرلس</p>[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Pricing\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||||false\" custom_padding=\"80px||80px||true\" animation_style=\"slide\" animation_direction=\"bottom\" animation_intensity_slide=\"1%\" border_radii=\"on|30px|30px|30px|30px\" locked=\"off\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\"][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"40px|||\" custom_padding_tablet=\"0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px||\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#ffffff\" price_text_color=\"rgba(0,0,0,0.75)\" body_text_color=\"#ffffff\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"||||||||\" body_text_align=\"center\" subheader_font=\"|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"||on||||||\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(255,255,255,0)\" background_color_gradient_end=\"rgba(255,255,255,0.16)\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" animation_style=\"slide\" animation_direction=\"right\" hover_enabled=\"0\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" price_font_size=\"50px\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate_linked__hover=\"off\" transform_translate__hover=\"0px|-70px\"][et_pb_pricing_table title=\"اینترنت پایه\" subtitle=\"1 مگابایت\" currency=\"یک ساله \" per=\"هزارتومان\" sum=\"35\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" header_level=\"h2\" header_font=\"||||||||\" body_font=\"VAZIR FARSI||||||||\" subheader_font=\"|800|||||||\" price_font=\"|800|on||||||\" price_letter_spacing=\"0px\" price_line_height=\"100px\" currency_frequency_font=\"|700|on||||||\" currency_frequency_line_height=\"1em\" excluded_text_color=\"rgba(255,255,255,0.5)\" hover_enabled=\"0\" pricing_item_excluded_color=\"rgba(255,255,255,0.5)\" button_url=\"#\" custom_button=\"on\" button_font=\"VAZIR FARSI||||||||\"]<p>+ گارانتی سرعت</p>\n<p>+ گارنتی کیفیت</p>\n<p>+ نصب در محل</p>\n<p>- تنظیم مودم</p>\n<p>- پشتیبانی 24 ساعته</p>\n[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#a0cf00\" price_text_color=\"rgba(0,0,0,0.75)\" subheader_text_color=\"#000000\" header_text_color=\"#000000\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"Poppins||||||||\" body_text_align=\"center\" subheader_font=\"Poppins|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"|800|on||||||\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#ffffff\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#008a1c\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" custom_margin=\"0px||\" animation_style=\"zoom\" animation_delay=\"100ms\" hover_enabled=\"0\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" border_color_all=\"#ffffff\" border_width_top=\"40px\" border_width_bottom=\"30px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" locked=\"off\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate_linked__hover=\"off\" transform_translate__hover=\"0px|-70px\"][et_pb_pricing_table title=\"سرویس محبوب\" subtitle=\"65 مگابایت\" currency=\"سالانه\" per=\"هزارتومان\" sum=\"99\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" body_font=\"VAZIR FARSI||||||||\" hover_enabled=\"0\" header_font=\"||||||||\" header_level=\"h2\" subheader_font=\"VAZIR FARSI|800|||||||\" price_font=\"VAZIR FARSI|800|on||||||\" price_line_height=\"100px\" price_font_size=\"50px\" button_url=\"#\" custom_button=\"on\" button_font=\"VAZIR FARSI||||||||\"]<p>+ سرعت دانلود تا 65 مگابایت</p>\n<p>+ دانلود نامحدود</p>\n<p>+ پشتیبانی شبانه روزی</p>\n<p>+ مودم رایگان</p>\n<p>+ نصب رایگان</p>\n[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"40px|||\" custom_padding_tablet=\"0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|desktop\" padding_tablet=\"0px||\" padding_last_edited=\"on|desktop\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#ffffff\" price_text_color=\"rgba(0,0,0,0.75)\" body_text_color=\"#ffffff\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"||||||||\" body_text_align=\"center\" subheader_font=\"|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"||on||||||\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(255,255,255,0)\" background_color_gradient_end=\"rgba(255,255,255,0.16)\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" animation_style=\"slide\" animation_direction=\"right\" hover_enabled=\"0\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" locked=\"off\" price_font_size=\"50px\" price_letter_spacing_last_edited=\"on|desktop\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate_linked__hover=\"off\" transform_translate__hover=\"0px|-70px\"][et_pb_pricing_table title=\"اینترنت حرفه ای\" subtitle=\"120 مگابایت\" currency=\"یک ساله \" per=\"هزارتومان\" sum=\"900\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" header_level=\"h2\" header_font=\"||||||||\" body_font=\"VAZIR FARSI||||||||\" subheader_font=\"|800|||||||\" price_font=\"VAZIR FARSI||on||||||\" price_letter_spacing=\"0px\" price_line_height=\"100px\" currency_frequency_font=\"|700|on||||||\" currency_frequency_line_height=\"1em\" excluded_text_color=\"rgba(255,255,255,0.5)\" hover_enabled=\"0\" pricing_item_excluded_color=\"rgba(255,255,255,0.5)\" button_url=\"#\" custom_button=\"on\" button_font=\"VAZIR FARSI||||||||\"]<p>+ گارانتی سرعت</p>\n<p>+ گارنتی کیفیت</p>\n<p>+ نصب در محل</p>\n<p>- تنظیم مودم</p>\n<p>- پشتیبانی 24 ساعته</p>\n[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Blog\" _builder_version=\"3.22\"][et_pb_row _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#0492ff\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>آخرین مقالات از وبلاگ ما</h2>\n[/et_pb_text][et_pb_blog fullwidth=\"off\" posts_number=\"3\" include_categories=\"70\" show_pagination=\"off\" _builder_version=\"3.17.6\" header_font=\"Poppins|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_line_height=\"2em\" meta_font=\"Poppins||||||||\" meta_text_color=\"#008a1c\" pagination_font=\"Poppins|700|on||||||\" pagination_text_color=\"#008a1c\" pagination_font_size=\"18px\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"][/et_pb_blog][et_pb_button button_text=\"رفتن به وبلاگ\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#7cda24\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonials\" _builder_version=\"3.22\"][et_pb_row column_structure=\"2_5,3_5\" padding_top_bottom_link_1=\"true\" padding_top_bottom_link_2=\"true\" padding_left_right_link_1=\"false\" padding_left_right_link_2=\"false\" _builder_version=\"3.25\" custom_padding=\"0||0||false|false\"][et_pb_column type=\"2_5\" _builder_version=\"3.25\" custom_padding=\"60px|60px|60px|\" custom_padding_tablet=\"0px||0px||true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px||0px||true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>مشتریان در مورد ما چه می گویند ؟</h2>\n<h3>بهترین شرکت خدمات اینترنتی از دید مشتریان در سال های اخیر</h3>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"3_5\" _builder_version=\"3.25\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/handyman_11.png\" background_size=\"initial\" background_position=\"bottom_right\" custom_padding=\"60px|60px|60px|\" custom_padding_tablet=\"40px|40px|40px|40px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"40px|40px|40px|40px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_testimonial author=\"مشتری از سال 1390\" quote_icon=\"off\" _builder_version=\"4.4.2\" body_font=\"||on||||||\" body_font_size=\"14px\" body_line_height=\"2em\" background_color=\"#ffffff\" custom_margin=\"|||-40px\" custom_margin_tablet=\"|||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|desktop\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0.15)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate_linked__hover=\"off\" transform_translate__hover=\"-50px|0px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span>\"</p>\n[/et_pb_testimonial][et_pb_testimonial author=\"مشتری جدید\" quote_icon=\"off\" _builder_version=\"4.4.2\" body_font=\"||on||||||\" body_font_size=\"14px\" body_line_height=\"2em\" background_color=\"#ffffff\" custom_margin=\"|||-40px\" custom_margin_tablet=\"|||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|desktop\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0.15)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate_linked__hover=\"off\" transform_translate__hover=\"-50px|0px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span>\"</p>\n[/et_pb_testimonial][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" prev_background_color=\"#ffffff\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#0f1533\" background_color_gradient_end=\"#1f133a\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||5vw\" custom_padding=\"14vw||10vw\" top_divider_style=\"wave2\" top_divider_height=\"10vw\" top_divider_repeat=\"0.7x\" top_divider_flip=\"vertical\" animation_style=\"fade\" border_radii=\"on|30px|30px|30px|30px\" locked=\"off\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_phone=\"\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_2_font=\"|900|on||||||\" header_2_font_size=\"3vw\" header_2_letter_spacing=\"2px\" header_2_line_height=\"1.4em\" header_3_font=\"|900|on|on|||||\" header_3_text_color=\"rgba(255,255,255,0.7)\" header_3_font_size=\"1.5vw\" header_3_letter_spacing=\"0.4em\" header_3_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" hover_enabled=\"0\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_font_size__hover=\"30px\" header_font_size__hover_enabled=\"30px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h2>سرعت مورد نظر خود را با قیمتی که می خواهید دریافت کنید</h2>\n<h3>سرویس های ADSL  و سرویس های پیامکی</h3>\n[/et_pb_text][et_pb_button button_text=\"مشاهده تمام سرویس های ما\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#7cda24\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section]", "خانه", "", "inherit", "closed", "closed", "", "2-revision-v1", "", "", "2020-04-02 13:05:52", "2020-04-02 09:35:52", "", "2", "http://modelsite.test/2-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2943", "1", "2020-04-02 13:07:32", "2020-04-02 09:37:32", "[et_pb_section fb_built=\"1\" admin_label=\"Header\" _builder_version=\"4.4.2\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-05.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"5vw||||false\" custom_padding=\"10vw||14vw||false\" bottom_divider_style=\"wave2\" bottom_divider_color=\"#ffffff\" bottom_divider_height=\"10vw\" bottom_divider_repeat=\"0.7x\" animation_style=\"slide\" animation_direction=\"bottom\" animation_intensity_slide=\"1%\" hover_enabled=\"0\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_phone=\"\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" animation_style=\"slide\" animation_direction=\"left\" animation_intensity_slide=\"10%\" hover_enabled=\"0\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_font=\"|900|on|on|||||\" header_font_size=\"10vw\" header_letter_spacing=\"0.1em\" header_line_height=\"1.2em\" header_2_font=\"|900|on|on|||||\" header_2_text_color=\"rgba(255,255,255,0.7)\" header_2_font_size=\"44px\" header_2_letter_spacing=\"0em\" header_2_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" header_font_size_tablet=\"50px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|phone\" header_2_font_size_tablet=\"30px\" header_2_font_size_phone=\"20px\" header_2_font_size_last_edited=\"on|phone\" header_text_shadow_style=\"preset1\" header_text_shadow_color=\"rgba(0,0,0,0.15)\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h1>نهایت سرعت</h1>\n<p>&nbsp;</p>\n<h2><span color=\"rgba(0, 0, 0, 0.701960784313725)\" style=\"color: rgba(0, 0, 0, 0.7);\">35 هزارتومان </span>اینترنت ADSL</h2>[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_font_size=\"18px\" text_line_height=\"2em\" text_orientation=\"center\" background_layout=\"dark\" max_width=\"800px\" module_alignment=\"center\" text_font_size_tablet=\"16px\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>[/et_pb_text][et_pb_button button_text=\"مشاهده تمام پلن های اینترنتی\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#0c71c3\" button_bg_enable_color__hover=\"on\" button_text_color__hover_enabled=\"on|hover\" button_text_color__hover=\"#ffffff\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Login\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(242,245,250,0)\" background_color_gradient_end=\"#f2f5fa\" background_color_gradient_direction=\"90deg\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_padding=\"0|0px|0|0px|false|false\" border_radii=\"on|60px|60px|60px|60px\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_font_size=\"20px\" link_font=\"||||||||\" link_text_color=\"#0492ff\" text_orientation=\"center\" hover_enabled=\"0\" text_text_shadow_style=\"preset1\" text_text_shadow_color=\"#7cda24\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate_linked__hover=\"off\" transform_translate__hover=\"-50px|0px\" content__hover_enabled=\"on|hover\" content__hover=\"<p><a href=%22#%22><strong>کلیک نمایید</strong></a></p>\n\"]<p>آماده اید ؟  جهت عضویت <a href=\"#\"><strong>اینجا را کلیک نمایید</strong></a></p>[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Value\" _builder_version=\"3.22\"][et_pb_row _builder_version=\"3.25\" custom_padding=\"||||false|false\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#0492ff\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>چرا انتخاب ما ؟</h2>[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" padding_top_bottom_link_1=\"false\" padding_top_bottom_link_2=\"false\" padding_top_bottom_link_3=\"false\" padding_left_right_link_1=\"true\" padding_left_right_link_2=\"true\" padding_left_right_link_3=\"true\" _builder_version=\"3.25\" max_width=\"1160px\" custom_padding=\"0|0px|27px|0px|false|false\" use_custom_width=\"on\" custom_width_px=\"1160px\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\" max_width__hover=\"1080px\" max_width__hover_enabled=\"1080px\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-03.png\" background_size=\"contain\" background_position=\"bottom_right\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"دریافت سرعت واقعی\" use_icon=\"on\" font_icon=\"%%243%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|hover\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"0deg|330deg|0deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"20 درصد تخفیف\" use_icon=\"on\" font_icon=\"%%171%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"0deg|0deg|330deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-04.png\" background_size=\"contain\" background_position=\"top_right\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"بدون محدودیت حجمی\" use_icon=\"on\" font_icon=\"%%231%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"330deg|0deg|0deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است </span></p>[/et_pb_blurb][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Features\" _builder_version=\"3.22\" background_color=\"#f2f5fa\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_padding=\"54px|0px|0|0px|false|false\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row column_structure=\"3_5,2_5\" _builder_version=\"3.25\" custom_margin=\"100px||100px||true\" custom_margin_tablet=\"40px||40px||true\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\"][et_pb_column type=\"3_5\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/04/isp-01.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"|||-7vw\" custom_margin_tablet=\"|||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\"][/et_pb_image][/et_pb_column][et_pb_column type=\"2_5\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>انتخاب شماره 1# کاربران برای اینترنت  فیبر نوری</h2>\n<h3></h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>[/et_pb_text][et_pb_blurb title=\"بدون قعطی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"2em\" custom_margin=\"||20px\"][/et_pb_blurb][et_pb_blurb title=\"سرعت تا 65 مگابایت\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"2em\" custom_margin=\"||20px\"][/et_pb_blurb][et_pb_blurb title=\"شامل مودم رایگان\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"2em\" custom_margin=\"||20px\"][/et_pb_blurb][et_pb_button button_text=\"مشاهده پلن های اینترنت\" button_alignment=\"left\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#7cda24\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" custom_margin=\"100px||100px||true\" custom_margin_tablet=\"40px||40px||true\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"14px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>داده نامحدود ،پشتیبانی شبانه روزی و سرویس پیامکی</h2>\n<h3>همه موارد را برای داشتن خطوط پیامکی موفق برای شما فراهم کرده ایم</h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد</span></p>[/et_pb_text][et_pb_button button_text=\"مشاهده پلن های پیامکی\" button_alignment=\"left\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#7cda24\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/04/isp-02.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"|-7vw||\" custom_margin_tablet=\"|0vw||\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\" border_radii=\"on|30px|30px|30px|30px\"][/et_pb_image][/et_pb_column][/et_pb_row][et_pb_row custom_padding_last_edited=\"on|tablet\" _builder_version=\"4.4.2\" background_color=\"#ffffff\" max_width=\"80%\" module_alignment=\"right\" custom_margin=\"||\" custom_padding=\"60px|60px|||false|false\" custom_padding_tablet=\"|40px||40px\" custom_padding_phone=\"\" animation_style=\"slide\" animation_direction=\"right\" animation_intensity_slide=\"10%\" border_radii=\"|30px|||\" use_custom_width=\"on\" width_unit=\"off\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>محبوب ترین خدمات</h2>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد</span></p>[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Categories\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(242,245,250,0)\" background_color_gradient_end=\"#f2f5fa\" background_color_gradient_direction=\"90deg\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||60px\" custom_margin_tablet=\"||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|desktop\" custom_padding=\"0||0px||false|false\" border_radii=\"on|60px|60px|60px|60px\" locked=\"off\"][et_pb_row column_structure=\"1_6,1_6,1_6,1_6,1_6,1_6\" use_custom_gutter=\"on\" gutter_width=\"2\" _builder_version=\"3.25\" locked=\"off\"][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#ffffff\" text_orientation=\"center\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" locked=\"off\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" box_shadow_color__hover_enabled=\"on\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\" background_layout__hover_enabled=\"on\" background_layout__hover=\"dark\"]<p>پیامک</p>[/et_pb_text][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"Poppins|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#a0cf00\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" locked=\"off\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" box_shadow_color__hover_enabled=\"on\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\"]<p>ADSL</p>[/et_pb_text][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#008a1c\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" box_shadow_color__hover_enabled=\"on\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\"]<p>وایرلس</p>[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Pricing\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||||false\" custom_padding=\"80px||80px||true\" animation_style=\"slide\" animation_direction=\"bottom\" animation_intensity_slide=\"1%\" border_radii=\"on|30px|30px|30px|30px\" locked=\"off\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\"][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"40px|||\" custom_padding_tablet=\"0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px||\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#ffffff\" price_text_color=\"rgba(0,0,0,0.75)\" body_text_color=\"#ffffff\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"||||||||\" body_text_align=\"center\" subheader_font=\"|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"||on||||||\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(255,255,255,0)\" background_color_gradient_end=\"rgba(255,255,255,0.16)\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" animation_style=\"slide\" animation_direction=\"right\" hover_enabled=\"0\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" price_font_size=\"50px\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate_linked__hover=\"off\" transform_translate__hover=\"0px|-70px\"][et_pb_pricing_table title=\"اینترنت پایه\" subtitle=\"1 مگابایت\" currency=\"یک ساله \" per=\"هزارتومان\" sum=\"35\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" header_level=\"h2\" header_font=\"||||||||\" body_font=\"VAZIR FARSI||||||||\" subheader_font=\"|800|||||||\" price_font=\"|800|on||||||\" price_letter_spacing=\"0px\" price_line_height=\"100px\" currency_frequency_font=\"|700|on||||||\" currency_frequency_line_height=\"1em\" excluded_text_color=\"rgba(255,255,255,0.5)\" hover_enabled=\"0\" pricing_item_excluded_color=\"rgba(255,255,255,0.5)\" button_url=\"#\" custom_button=\"on\" button_font=\"VAZIR FARSI||||||||\"]<p>+ گارانتی سرعت</p>\n<p>+ گارنتی کیفیت</p>\n<p>+ نصب در محل</p>\n<p>- تنظیم مودم</p>\n<p>- پشتیبانی 24 ساعته</p>\n[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#a0cf00\" price_text_color=\"rgba(0,0,0,0.75)\" subheader_text_color=\"#000000\" header_text_color=\"#000000\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"Poppins||||||||\" body_text_align=\"center\" subheader_font=\"Poppins|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"|800|on||||||\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#ffffff\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#008a1c\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" custom_margin=\"0px||\" animation_style=\"zoom\" animation_delay=\"100ms\" hover_enabled=\"0\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" border_color_all=\"#ffffff\" border_width_top=\"40px\" border_width_bottom=\"30px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" locked=\"off\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate_linked__hover=\"off\" transform_translate__hover=\"0px|-70px\"][et_pb_pricing_table title=\"سرویس محبوب\" subtitle=\"65 مگابایت\" currency=\"سالانه\" per=\"هزارتومان\" sum=\"99\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" body_font=\"VAZIR FARSI||||||||\" hover_enabled=\"0\" header_font=\"||||||||\" header_level=\"h2\" subheader_font=\"VAZIR FARSI|800|||||||\" price_font=\"VAZIR FARSI|800|on||||||\" price_line_height=\"100px\" price_font_size=\"50px\" button_url=\"#\" custom_button=\"on\" button_font=\"VAZIR FARSI||||||||\"]<p>+ سرعت دانلود تا 65 مگابایت</p>\n<p>+ دانلود نامحدود</p>\n<p>+ پشتیبانی شبانه روزی</p>\n<p>+ مودم رایگان</p>\n<p>+ نصب رایگان</p>\n[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"40px|||\" custom_padding_tablet=\"0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|desktop\" padding_tablet=\"0px||\" padding_last_edited=\"on|desktop\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#ffffff\" price_text_color=\"rgba(0,0,0,0.75)\" body_text_color=\"#ffffff\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"||||||||\" body_text_align=\"center\" subheader_font=\"|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"||on||||||\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(255,255,255,0)\" background_color_gradient_end=\"rgba(255,255,255,0.16)\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" animation_style=\"slide\" animation_direction=\"right\" hover_enabled=\"0\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" locked=\"off\" price_font_size=\"50px\" price_letter_spacing_last_edited=\"on|desktop\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate_linked__hover=\"off\" transform_translate__hover=\"0px|-70px\"][et_pb_pricing_table title=\"اینترنت حرفه ای\" subtitle=\"120 مگابایت\" currency=\"یک ساله \" per=\"هزارتومان\" sum=\"900\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" header_level=\"h2\" header_font=\"||||||||\" body_font=\"VAZIR FARSI||||||||\" subheader_font=\"|800|||||||\" price_font=\"VAZIR FARSI||on||||||\" price_letter_spacing=\"0px\" price_line_height=\"100px\" currency_frequency_font=\"|700|on||||||\" currency_frequency_line_height=\"1em\" excluded_text_color=\"rgba(255,255,255,0.5)\" hover_enabled=\"0\" pricing_item_excluded_color=\"rgba(255,255,255,0.5)\" button_url=\"#\" custom_button=\"on\" button_font=\"VAZIR FARSI||||||||\"]<p>+ گارانتی سرعت</p>\n<p>+ گارنتی کیفیت</p>\n<p>+ نصب در محل</p>\n<p>- تنظیم مودم</p>\n<p>- پشتیبانی 24 ساعته</p>\n[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Blog\" _builder_version=\"3.22\"][et_pb_row _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#0492ff\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>آخرین مقالات از وبلاگ ما</h2>\n[/et_pb_text][et_pb_blog fullwidth=\"off\" posts_number=\"3\" include_categories=\"70\" show_pagination=\"off\" _builder_version=\"3.17.6\" header_font=\"Poppins|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_line_height=\"2em\" meta_font=\"Poppins||||||||\" meta_text_color=\"#008a1c\" pagination_font=\"Poppins|700|on||||||\" pagination_text_color=\"#008a1c\" pagination_font_size=\"18px\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"][/et_pb_blog][et_pb_button button_text=\"رفتن به وبلاگ\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#7cda24\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonials\" _builder_version=\"3.22\"][et_pb_row column_structure=\"2_5,3_5\" padding_top_bottom_link_1=\"true\" padding_top_bottom_link_2=\"true\" padding_left_right_link_1=\"false\" padding_left_right_link_2=\"false\" _builder_version=\"3.25\" custom_padding=\"0||0||false|false\"][et_pb_column type=\"2_5\" _builder_version=\"3.25\" custom_padding=\"60px|60px|60px|\" custom_padding_tablet=\"0px||0px||true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px||0px||true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>مشتریان در مورد ما چه می گویند ؟</h2>\n<h3>بهترین شرکت خدمات اینترنتی از دید مشتریان در سال های اخیر</h3>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"3_5\" _builder_version=\"3.25\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/handyman_11.png\" background_size=\"initial\" background_position=\"bottom_right\" custom_padding=\"60px|60px|60px|\" custom_padding_tablet=\"40px|40px|40px|40px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"40px|40px|40px|40px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_testimonial author=\"مشتری از سال 1390\" quote_icon=\"off\" _builder_version=\"4.4.2\" body_font=\"||on||||||\" body_font_size=\"14px\" body_line_height=\"2em\" background_color=\"#ffffff\" custom_margin=\"|||-40px\" custom_margin_tablet=\"|||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|desktop\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0.15)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate_linked__hover=\"off\" transform_translate__hover=\"-50px|0px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span>\"</p>\n[/et_pb_testimonial][et_pb_testimonial author=\"مشتری جدید\" quote_icon=\"off\" _builder_version=\"4.4.2\" body_font=\"||on||||||\" body_font_size=\"14px\" body_line_height=\"2em\" background_color=\"#ffffff\" custom_margin=\"|||-40px\" custom_margin_tablet=\"|||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|desktop\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0.15)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate_linked__hover=\"off\" transform_translate__hover=\"-50px|0px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span>\"</p>\n[/et_pb_testimonial][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" prev_background_color=\"#ffffff\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#0f1533\" background_color_gradient_end=\"#1f133a\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||5vw\" custom_padding=\"14vw||10vw\" top_divider_style=\"wave2\" top_divider_height=\"10vw\" top_divider_repeat=\"0.7x\" top_divider_flip=\"vertical\" animation_style=\"fade\" border_radii=\"on|30px|30px|30px|30px\" locked=\"off\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_phone=\"\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_2_font=\"|900|on||||||\" header_2_font_size=\"3vw\" header_2_letter_spacing=\"2px\" header_2_line_height=\"1.4em\" header_3_font=\"|900|on|on|||||\" header_3_text_color=\"rgba(255,255,255,0.7)\" header_3_font_size=\"1.5vw\" header_3_letter_spacing=\"0.4em\" header_3_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" hover_enabled=\"0\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_font_size__hover=\"30px\" header_font_size__hover_enabled=\"30px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h2>سرعت مورد نظر خود را با قیمتی که می خواهید دریافت کنید</h2>\n<h3>سرویس های ADSL  و سرویس های پیامکی</h3>\n[/et_pb_text][et_pb_button button_text=\"مشاهده تمام سرویس های ما\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#7cda24\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section]", "خانه", "", "inherit", "closed", "closed", "", "2-revision-v1", "", "", "2020-04-02 13:07:32", "2020-04-02 09:37:32", "", "2", "http://modelsite.test/2-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2946", "1", "2020-04-02 13:14:22", "2020-04-02 09:44:22", "[et_pb_section fb_built=\"1\" admin_label=\"Header\" _builder_version=\"4.4.2\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/Concentric-circles-animated-2.gif\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"5vw||||false\" custom_padding=\"10vw||14vw||false\" bottom_divider_style=\"wave2\" bottom_divider_color=\"#ffffff\" bottom_divider_height=\"10vw\" bottom_divider_repeat=\"0.7x\" animation_style=\"slide\" animation_direction=\"bottom\" animation_intensity_slide=\"1%\" hover_enabled=\"0\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_phone=\"\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" animation_style=\"slide\" animation_direction=\"left\" animation_intensity_slide=\"10%\" hover_enabled=\"0\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_font=\"|900|on|on|||||\" header_font_size=\"10vw\" header_letter_spacing=\"0.1em\" header_line_height=\"1.2em\" header_2_font=\"|900|on|on|||||\" header_2_text_color=\"rgba(255,255,255,0.7)\" header_2_font_size=\"44px\" header_2_letter_spacing=\"0em\" header_2_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" header_font_size_tablet=\"50px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|phone\" header_2_font_size_tablet=\"30px\" header_2_font_size_phone=\"20px\" header_2_font_size_last_edited=\"on|phone\" header_text_shadow_style=\"preset1\" header_text_shadow_color=\"rgba(0,0,0,0.15)\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h1>نهایت سرعت</h1>\n<p>&nbsp;</p>\n<h2><span color=\"rgba(0, 0, 0, 0.701960784313725)\" style=\"color: rgba(0, 0, 0, 0.7);\">35 هزارتومان </span>اینترنت ADSL</h2>[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_font_size=\"18px\" text_line_height=\"2em\" text_orientation=\"center\" background_layout=\"dark\" max_width=\"800px\" module_alignment=\"center\" text_font_size_tablet=\"16px\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>[/et_pb_text][et_pb_button button_text=\"مشاهده تمام پلن های اینترنتی\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#0c71c3\" button_bg_enable_color__hover=\"on\" button_text_color__hover_enabled=\"on|hover\" button_text_color__hover=\"#ffffff\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Login\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(242,245,250,0)\" background_color_gradient_end=\"#f2f5fa\" background_color_gradient_direction=\"90deg\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_padding=\"0|0px|0|0px|false|false\" border_radii=\"on|60px|60px|60px|60px\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_font_size=\"20px\" link_font=\"||||||||\" link_text_color=\"#0492ff\" text_orientation=\"center\" hover_enabled=\"0\" text_text_shadow_style=\"preset1\" text_text_shadow_color=\"#7cda24\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate_linked__hover=\"off\" transform_translate__hover=\"-50px|0px\" content__hover_enabled=\"on|hover\" content__hover=\"<p><a href=%22#%22><strong>کلیک نمایید</strong></a></p>\n\"]<p>آماده اید ؟  جهت عضویت <a href=\"#\"><strong>اینجا را کلیک نمایید</strong></a></p>[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Value\" _builder_version=\"3.22\"][et_pb_row _builder_version=\"3.25\" custom_padding=\"||||false|false\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#0492ff\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>چرا انتخاب ما ؟</h2>[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" padding_top_bottom_link_1=\"false\" padding_top_bottom_link_2=\"false\" padding_top_bottom_link_3=\"false\" padding_left_right_link_1=\"true\" padding_left_right_link_2=\"true\" padding_left_right_link_3=\"true\" _builder_version=\"3.25\" max_width=\"1160px\" custom_padding=\"0|0px|27px|0px|false|false\" use_custom_width=\"on\" custom_width_px=\"1160px\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\" max_width__hover=\"1080px\" max_width__hover_enabled=\"1080px\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-03.png\" background_size=\"contain\" background_position=\"bottom_right\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"دریافت سرعت واقعی\" use_icon=\"on\" font_icon=\"%%243%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|hover\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"0deg|330deg|0deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"20 درصد تخفیف\" use_icon=\"on\" font_icon=\"%%171%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"0deg|0deg|330deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-04.png\" background_size=\"contain\" background_position=\"top_right\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"بدون محدودیت حجمی\" use_icon=\"on\" font_icon=\"%%231%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"330deg|0deg|0deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است </span></p>[/et_pb_blurb][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Features\" _builder_version=\"3.22\" background_color=\"#f2f5fa\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_padding=\"54px|0px|0|0px|false|false\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row column_structure=\"3_5,2_5\" _builder_version=\"3.25\" custom_margin=\"100px||100px||true\" custom_margin_tablet=\"40px||40px||true\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\"][et_pb_column type=\"3_5\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/04/isp-01.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"|||-7vw\" custom_margin_tablet=\"|||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\"][/et_pb_image][/et_pb_column][et_pb_column type=\"2_5\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>انتخاب شماره 1# کاربران برای اینترنت  فیبر نوری</h2>\n<h3></h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>[/et_pb_text][et_pb_blurb title=\"بدون قعطی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"2em\" custom_margin=\"||20px\"][/et_pb_blurb][et_pb_blurb title=\"سرعت تا 65 مگابایت\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"2em\" custom_margin=\"||20px\"][/et_pb_blurb][et_pb_blurb title=\"شامل مودم رایگان\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"2em\" custom_margin=\"||20px\"][/et_pb_blurb][et_pb_button button_text=\"مشاهده پلن های اینترنت\" button_alignment=\"left\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#7cda24\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" custom_margin=\"100px||100px||true\" custom_margin_tablet=\"40px||40px||true\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"14px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>داده نامحدود ،پشتیبانی شبانه روزی و سرویس پیامکی</h2>\n<h3>همه موارد را برای داشتن خطوط پیامکی موفق برای شما فراهم کرده ایم</h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد</span></p>[/et_pb_text][et_pb_button button_text=\"مشاهده پلن های پیامکی\" button_alignment=\"left\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#7cda24\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/04/isp-02.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"|-7vw||\" custom_margin_tablet=\"|0vw||\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\" border_radii=\"on|30px|30px|30px|30px\"][/et_pb_image][/et_pb_column][/et_pb_row][et_pb_row custom_padding_last_edited=\"on|tablet\" _builder_version=\"4.4.2\" background_color=\"#ffffff\" max_width=\"80%\" module_alignment=\"right\" custom_margin=\"||\" custom_padding=\"60px|60px|||false|false\" custom_padding_tablet=\"|40px||40px\" custom_padding_phone=\"\" animation_style=\"slide\" animation_direction=\"right\" animation_intensity_slide=\"10%\" border_radii=\"|30px|||\" use_custom_width=\"on\" width_unit=\"off\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>محبوب ترین خدمات</h2>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد</span></p>[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Categories\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(242,245,250,0)\" background_color_gradient_end=\"#f2f5fa\" background_color_gradient_direction=\"90deg\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||60px\" custom_margin_tablet=\"||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|desktop\" custom_padding=\"0||0px||false|false\" border_radii=\"on|60px|60px|60px|60px\" locked=\"off\"][et_pb_row column_structure=\"1_6,1_6,1_6,1_6,1_6,1_6\" use_custom_gutter=\"on\" gutter_width=\"2\" _builder_version=\"3.25\" locked=\"off\"][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#ffffff\" text_orientation=\"center\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" locked=\"off\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" box_shadow_color__hover_enabled=\"on\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\" background_layout__hover_enabled=\"on\" background_layout__hover=\"dark\"]<p>پیامک</p>[/et_pb_text][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"Poppins|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#a0cf00\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" locked=\"off\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" box_shadow_color__hover_enabled=\"on\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\"]<p>ADSL</p>[/et_pb_text][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#008a1c\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" box_shadow_color__hover_enabled=\"on\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\"]<p>وایرلس</p>[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Pricing\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||||false\" custom_padding=\"80px||80px||true\" animation_style=\"slide\" animation_direction=\"bottom\" animation_intensity_slide=\"1%\" border_radii=\"on|30px|30px|30px|30px\" locked=\"off\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\"][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"40px|||\" custom_padding_tablet=\"0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px||\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#ffffff\" price_text_color=\"rgba(0,0,0,0.75)\" body_text_color=\"#ffffff\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"||||||||\" body_text_align=\"center\" subheader_font=\"|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"||on||||||\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(255,255,255,0)\" background_color_gradient_end=\"rgba(255,255,255,0.16)\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" animation_style=\"slide\" animation_direction=\"right\" hover_enabled=\"0\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" price_font_size=\"50px\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate_linked__hover=\"off\" transform_translate__hover=\"0px|-70px\"][et_pb_pricing_table title=\"اینترنت پایه\" subtitle=\"1 مگابایت\" currency=\"یک ساله \" per=\"هزارتومان\" sum=\"35\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" header_level=\"h2\" header_font=\"||||||||\" body_font=\"VAZIR FARSI||||||||\" subheader_font=\"|800|||||||\" price_font=\"|800|on||||||\" price_letter_spacing=\"0px\" price_line_height=\"100px\" currency_frequency_font=\"|700|on||||||\" currency_frequency_line_height=\"1em\" excluded_text_color=\"rgba(255,255,255,0.5)\" hover_enabled=\"0\" pricing_item_excluded_color=\"rgba(255,255,255,0.5)\" button_url=\"#\" custom_button=\"on\" button_font=\"VAZIR FARSI||||||||\"]<p>+ گارانتی سرعت</p>\n<p>+ گارنتی کیفیت</p>\n<p>+ نصب در محل</p>\n<p>- تنظیم مودم</p>\n<p>- پشتیبانی 24 ساعته</p>\n[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#a0cf00\" price_text_color=\"rgba(0,0,0,0.75)\" subheader_text_color=\"#000000\" header_text_color=\"#000000\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"Poppins||||||||\" body_text_align=\"center\" subheader_font=\"Poppins|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"|800|on||||||\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#ffffff\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#008a1c\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" custom_margin=\"0px||\" animation_style=\"zoom\" animation_delay=\"100ms\" hover_enabled=\"0\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" border_color_all=\"#ffffff\" border_width_top=\"40px\" border_width_bottom=\"30px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" locked=\"off\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate_linked__hover=\"off\" transform_translate__hover=\"0px|-70px\"][et_pb_pricing_table title=\"سرویس محبوب\" subtitle=\"65 مگابایت\" currency=\"سالانه\" per=\"هزارتومان\" sum=\"99\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" body_font=\"VAZIR FARSI||||||||\" hover_enabled=\"0\" header_font=\"||||||||\" header_level=\"h2\" subheader_font=\"VAZIR FARSI|800|||||||\" price_font=\"VAZIR FARSI|800|on||||||\" price_line_height=\"100px\" price_font_size=\"50px\" button_url=\"#\" custom_button=\"on\" button_font=\"VAZIR FARSI||||||||\"]<p>+ سرعت دانلود تا 65 مگابایت</p>\n<p>+ دانلود نامحدود</p>\n<p>+ پشتیبانی شبانه روزی</p>\n<p>+ مودم رایگان</p>\n<p>+ نصب رایگان</p>\n[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"40px|||\" custom_padding_tablet=\"0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|desktop\" padding_tablet=\"0px||\" padding_last_edited=\"on|desktop\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#ffffff\" price_text_color=\"rgba(0,0,0,0.75)\" body_text_color=\"#ffffff\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"||||||||\" body_text_align=\"center\" subheader_font=\"|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"||on||||||\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(255,255,255,0)\" background_color_gradient_end=\"rgba(255,255,255,0.16)\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" animation_style=\"slide\" animation_direction=\"right\" hover_enabled=\"0\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" locked=\"off\" price_font_size=\"50px\" price_letter_spacing_last_edited=\"on|desktop\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate_linked__hover=\"off\" transform_translate__hover=\"0px|-70px\"][et_pb_pricing_table title=\"اینترنت حرفه ای\" subtitle=\"120 مگابایت\" currency=\"یک ساله \" per=\"هزارتومان\" sum=\"900\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" header_level=\"h2\" header_font=\"||||||||\" body_font=\"VAZIR FARSI||||||||\" subheader_font=\"|800|||||||\" price_font=\"VAZIR FARSI||on||||||\" price_letter_spacing=\"0px\" price_line_height=\"100px\" currency_frequency_font=\"|700|on||||||\" currency_frequency_line_height=\"1em\" excluded_text_color=\"rgba(255,255,255,0.5)\" hover_enabled=\"0\" pricing_item_excluded_color=\"rgba(255,255,255,0.5)\" button_url=\"#\" custom_button=\"on\" button_font=\"VAZIR FARSI||||||||\"]<p>+ گارانتی سرعت</p>\n<p>+ گارنتی کیفیت</p>\n<p>+ نصب در محل</p>\n<p>- تنظیم مودم</p>\n<p>- پشتیبانی 24 ساعته</p>\n[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Blog\" _builder_version=\"3.22\"][et_pb_row _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#0492ff\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>آخرین مقالات از وبلاگ ما</h2>\n[/et_pb_text][et_pb_blog fullwidth=\"off\" posts_number=\"3\" include_categories=\"70\" show_pagination=\"off\" _builder_version=\"3.17.6\" header_font=\"Poppins|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_line_height=\"2em\" meta_font=\"Poppins||||||||\" meta_text_color=\"#008a1c\" pagination_font=\"Poppins|700|on||||||\" pagination_text_color=\"#008a1c\" pagination_font_size=\"18px\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"][/et_pb_blog][et_pb_button button_text=\"رفتن به وبلاگ\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#7cda24\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonials\" _builder_version=\"3.22\"][et_pb_row column_structure=\"2_5,3_5\" padding_top_bottom_link_1=\"true\" padding_top_bottom_link_2=\"true\" padding_left_right_link_1=\"false\" padding_left_right_link_2=\"false\" _builder_version=\"3.25\" custom_padding=\"0||0||false|false\"][et_pb_column type=\"2_5\" _builder_version=\"3.25\" custom_padding=\"60px|60px|60px|\" custom_padding_tablet=\"0px||0px||true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px||0px||true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>مشتریان در مورد ما چه می گویند ؟</h2>\n<h3>بهترین شرکت خدمات اینترنتی از دید مشتریان در سال های اخیر</h3>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"3_5\" _builder_version=\"3.25\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/handyman_11.png\" background_size=\"initial\" background_position=\"bottom_right\" custom_padding=\"60px|60px|60px|\" custom_padding_tablet=\"40px|40px|40px|40px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"40px|40px|40px|40px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_testimonial author=\"مشتری از سال 1390\" quote_icon=\"off\" _builder_version=\"4.4.2\" body_font=\"||on||||||\" body_font_size=\"14px\" body_line_height=\"2em\" background_color=\"#ffffff\" custom_margin=\"|||-40px\" custom_margin_tablet=\"|||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|desktop\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0.15)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate_linked__hover=\"off\" transform_translate__hover=\"-50px|0px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span>\"</p>\n[/et_pb_testimonial][et_pb_testimonial author=\"مشتری جدید\" quote_icon=\"off\" _builder_version=\"4.4.2\" body_font=\"||on||||||\" body_font_size=\"14px\" body_line_height=\"2em\" background_color=\"#ffffff\" custom_margin=\"|||-40px\" custom_margin_tablet=\"|||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|desktop\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0.15)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate_linked__hover=\"off\" transform_translate__hover=\"-50px|0px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span>\"</p>\n[/et_pb_testimonial][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" prev_background_color=\"#ffffff\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#0f1533\" background_color_gradient_end=\"#1f133a\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||5vw\" custom_padding=\"14vw||10vw\" top_divider_style=\"wave2\" top_divider_height=\"10vw\" top_divider_repeat=\"0.7x\" top_divider_flip=\"vertical\" animation_style=\"fade\" border_radii=\"on|30px|30px|30px|30px\" locked=\"off\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_phone=\"\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_2_font=\"|900|on||||||\" header_2_font_size=\"3vw\" header_2_letter_spacing=\"2px\" header_2_line_height=\"1.4em\" header_3_font=\"|900|on|on|||||\" header_3_text_color=\"rgba(255,255,255,0.7)\" header_3_font_size=\"1.5vw\" header_3_letter_spacing=\"0.4em\" header_3_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" hover_enabled=\"0\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_font_size__hover=\"30px\" header_font_size__hover_enabled=\"30px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h2>سرعت مورد نظر خود را با قیمتی که می خواهید دریافت کنید</h2>\n<h3>سرویس های ADSL  و سرویس های پیامکی</h3>\n[/et_pb_text][et_pb_button button_text=\"مشاهده تمام سرویس های ما\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#7cda24\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section]", "خانه", "", "inherit", "closed", "closed", "", "2-revision-v1", "", "", "2020-04-02 13:14:22", "2020-04-02 09:44:22", "", "2", "http://modelsite.test/2-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2950", "1", "2020-04-02 13:17:21", "2020-04-02 09:47:21", "[et_pb_section fb_built=\"1\" admin_label=\"Header\" _builder_version=\"4.4.2\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/09b24e31234507.564a1d23c07b4.gif\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"5vw||||false\" custom_padding=\"10vw||14vw||false\" bottom_divider_style=\"wave2\" bottom_divider_color=\"#ffffff\" bottom_divider_height=\"10vw\" bottom_divider_repeat=\"0.7x\" animation_style=\"slide\" animation_direction=\"bottom\" animation_intensity_slide=\"1%\" hover_enabled=\"0\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_phone=\"\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" animation_style=\"slide\" animation_direction=\"left\" animation_intensity_slide=\"10%\" hover_enabled=\"0\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_font=\"|900|on|on|||||\" header_font_size=\"10vw\" header_letter_spacing=\"0.1em\" header_line_height=\"1.2em\" header_2_font=\"|900|on|on|||||\" header_2_text_color=\"rgba(255,255,255,0.7)\" header_2_font_size=\"44px\" header_2_letter_spacing=\"0em\" header_2_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" header_font_size_tablet=\"50px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|phone\" header_2_font_size_tablet=\"30px\" header_2_font_size_phone=\"20px\" header_2_font_size_last_edited=\"on|phone\" header_text_shadow_style=\"preset1\" header_text_shadow_color=\"rgba(0,0,0,0.15)\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h1>نهایت سرعت</h1>\n<p>&nbsp;</p>\n<h2><span color=\"rgba(0, 0, 0, 0.701960784313725)\" style=\"color: rgba(0, 0, 0, 0.7);\">35 هزارتومان </span>اینترنت ADSL</h2>[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_font_size=\"18px\" text_line_height=\"2em\" text_orientation=\"center\" background_layout=\"dark\" max_width=\"800px\" module_alignment=\"center\" text_font_size_tablet=\"16px\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>[/et_pb_text][et_pb_button button_text=\"مشاهده تمام پلن های اینترنتی\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#0c71c3\" button_bg_enable_color__hover=\"on\" button_text_color__hover_enabled=\"on|hover\" button_text_color__hover=\"#ffffff\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Login\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(242,245,250,0)\" background_color_gradient_end=\"#f2f5fa\" background_color_gradient_direction=\"90deg\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_padding=\"0|0px|0|0px|false|false\" border_radii=\"on|60px|60px|60px|60px\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_font_size=\"20px\" link_font=\"||||||||\" link_text_color=\"#0492ff\" text_orientation=\"center\" hover_enabled=\"0\" text_text_shadow_style=\"preset1\" text_text_shadow_color=\"#7cda24\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate_linked__hover=\"off\" transform_translate__hover=\"-50px|0px\" content__hover_enabled=\"on|hover\" content__hover=\"<p><a href=%22#%22><strong>کلیک نمایید</strong></a></p>\n\"]<p>آماده اید ؟  جهت عضویت <a href=\"#\"><strong>اینجا را کلیک نمایید</strong></a></p>[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Value\" _builder_version=\"3.22\"][et_pb_row _builder_version=\"3.25\" custom_padding=\"||||false|false\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#0492ff\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>چرا انتخاب ما ؟</h2>[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" padding_top_bottom_link_1=\"false\" padding_top_bottom_link_2=\"false\" padding_top_bottom_link_3=\"false\" padding_left_right_link_1=\"true\" padding_left_right_link_2=\"true\" padding_left_right_link_3=\"true\" _builder_version=\"3.25\" max_width=\"1160px\" custom_padding=\"0|0px|27px|0px|false|false\" use_custom_width=\"on\" custom_width_px=\"1160px\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\" max_width__hover=\"1080px\" max_width__hover_enabled=\"1080px\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-03.png\" background_size=\"contain\" background_position=\"bottom_right\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"دریافت سرعت واقعی\" use_icon=\"on\" font_icon=\"%%243%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|hover\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"0deg|330deg|0deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"20 درصد تخفیف\" use_icon=\"on\" font_icon=\"%%171%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"0deg|0deg|330deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-04.png\" background_size=\"contain\" background_position=\"top_right\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"بدون محدودیت حجمی\" use_icon=\"on\" font_icon=\"%%231%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"330deg|0deg|0deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است </span></p>[/et_pb_blurb][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Features\" _builder_version=\"3.22\" background_color=\"#f2f5fa\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_padding=\"54px|0px|0|0px|false|false\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row column_structure=\"3_5,2_5\" _builder_version=\"3.25\" custom_margin=\"100px||100px||true\" custom_margin_tablet=\"40px||40px||true\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\"][et_pb_column type=\"3_5\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/04/isp-01.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"|||-7vw\" custom_margin_tablet=\"|||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\"][/et_pb_image][/et_pb_column][et_pb_column type=\"2_5\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>انتخاب شماره 1# کاربران برای اینترنت  فیبر نوری</h2>\n<h3></h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>[/et_pb_text][et_pb_blurb title=\"بدون قعطی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"2em\" custom_margin=\"||20px\"][/et_pb_blurb][et_pb_blurb title=\"سرعت تا 65 مگابایت\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"2em\" custom_margin=\"||20px\"][/et_pb_blurb][et_pb_blurb title=\"شامل مودم رایگان\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"2em\" custom_margin=\"||20px\"][/et_pb_blurb][et_pb_button button_text=\"مشاهده پلن های اینترنت\" button_alignment=\"left\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#7cda24\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" custom_margin=\"100px||100px||true\" custom_margin_tablet=\"40px||40px||true\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"14px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>داده نامحدود ،پشتیبانی شبانه روزی و سرویس پیامکی</h2>\n<h3>همه موارد را برای داشتن خطوط پیامکی موفق برای شما فراهم کرده ایم</h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد</span></p>[/et_pb_text][et_pb_button button_text=\"مشاهده پلن های پیامکی\" button_alignment=\"left\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#7cda24\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/04/isp-02.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"|-7vw||\" custom_margin_tablet=\"|0vw||\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\" border_radii=\"on|30px|30px|30px|30px\"][/et_pb_image][/et_pb_column][/et_pb_row][et_pb_row custom_padding_last_edited=\"on|tablet\" _builder_version=\"4.4.2\" background_color=\"#ffffff\" max_width=\"80%\" module_alignment=\"right\" custom_margin=\"||\" custom_padding=\"60px|60px|||false|false\" custom_padding_tablet=\"|40px||40px\" custom_padding_phone=\"\" animation_style=\"slide\" animation_direction=\"right\" animation_intensity_slide=\"10%\" border_radii=\"|30px|||\" use_custom_width=\"on\" width_unit=\"off\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>محبوب ترین خدمات</h2>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد</span></p>[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Categories\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(242,245,250,0)\" background_color_gradient_end=\"#f2f5fa\" background_color_gradient_direction=\"90deg\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||60px\" custom_margin_tablet=\"||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|desktop\" custom_padding=\"0||0px||false|false\" border_radii=\"on|60px|60px|60px|60px\" locked=\"off\"][et_pb_row column_structure=\"1_6,1_6,1_6,1_6,1_6,1_6\" use_custom_gutter=\"on\" gutter_width=\"2\" _builder_version=\"3.25\" locked=\"off\"][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#ffffff\" text_orientation=\"center\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" locked=\"off\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" box_shadow_color__hover_enabled=\"on\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\" background_layout__hover_enabled=\"on\" background_layout__hover=\"dark\"]<p>پیامک</p>[/et_pb_text][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"Poppins|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#a0cf00\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" locked=\"off\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" box_shadow_color__hover_enabled=\"on\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\"]<p>ADSL</p>[/et_pb_text][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#008a1c\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" box_shadow_color__hover_enabled=\"on\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\"]<p>وایرلس</p>[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Pricing\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||||false\" custom_padding=\"80px||80px||true\" animation_style=\"slide\" animation_direction=\"bottom\" animation_intensity_slide=\"1%\" border_radii=\"on|30px|30px|30px|30px\" locked=\"off\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\"][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"40px|||\" custom_padding_tablet=\"0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px||\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#ffffff\" price_text_color=\"rgba(0,0,0,0.75)\" body_text_color=\"#ffffff\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"||||||||\" body_text_align=\"center\" subheader_font=\"|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"||on||||||\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(255,255,255,0)\" background_color_gradient_end=\"rgba(255,255,255,0.16)\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" animation_style=\"slide\" animation_direction=\"right\" hover_enabled=\"0\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" price_font_size=\"50px\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate_linked__hover=\"off\" transform_translate__hover=\"0px|-70px\"][et_pb_pricing_table title=\"اینترنت پایه\" subtitle=\"1 مگابایت\" currency=\"یک ساله \" per=\"هزارتومان\" sum=\"35\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" header_level=\"h2\" header_font=\"||||||||\" body_font=\"VAZIR FARSI||||||||\" subheader_font=\"|800|||||||\" price_font=\"|800|on||||||\" price_letter_spacing=\"0px\" price_line_height=\"100px\" currency_frequency_font=\"|700|on||||||\" currency_frequency_line_height=\"1em\" excluded_text_color=\"rgba(255,255,255,0.5)\" hover_enabled=\"0\" pricing_item_excluded_color=\"rgba(255,255,255,0.5)\" button_url=\"#\" custom_button=\"on\" button_font=\"VAZIR FARSI||||||||\"]<p>+ گارانتی سرعت</p>\n<p>+ گارنتی کیفیت</p>\n<p>+ نصب در محل</p>\n<p>- تنظیم مودم</p>\n<p>- پشتیبانی 24 ساعته</p>\n[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#a0cf00\" price_text_color=\"rgba(0,0,0,0.75)\" subheader_text_color=\"#000000\" header_text_color=\"#000000\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"Poppins||||||||\" body_text_align=\"center\" subheader_font=\"Poppins|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"|800|on||||||\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#ffffff\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#008a1c\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" custom_margin=\"0px||\" animation_style=\"zoom\" animation_delay=\"100ms\" hover_enabled=\"0\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" border_color_all=\"#ffffff\" border_width_top=\"40px\" border_width_bottom=\"30px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" locked=\"off\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate_linked__hover=\"off\" transform_translate__hover=\"0px|-70px\"][et_pb_pricing_table title=\"سرویس محبوب\" subtitle=\"65 مگابایت\" currency=\"سالانه\" per=\"هزارتومان\" sum=\"99\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" body_font=\"VAZIR FARSI||||||||\" hover_enabled=\"0\" header_font=\"||||||||\" header_level=\"h2\" subheader_font=\"VAZIR FARSI|800|||||||\" price_font=\"VAZIR FARSI|800|on||||||\" price_line_height=\"100px\" price_font_size=\"50px\" button_url=\"#\" custom_button=\"on\" button_font=\"VAZIR FARSI||||||||\"]<p>+ سرعت دانلود تا 65 مگابایت</p>\n<p>+ دانلود نامحدود</p>\n<p>+ پشتیبانی شبانه روزی</p>\n<p>+ مودم رایگان</p>\n<p>+ نصب رایگان</p>\n[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"40px|||\" custom_padding_tablet=\"0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|desktop\" padding_tablet=\"0px||\" padding_last_edited=\"on|desktop\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#ffffff\" price_text_color=\"rgba(0,0,0,0.75)\" body_text_color=\"#ffffff\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"||||||||\" body_text_align=\"center\" subheader_font=\"|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"||on||||||\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(255,255,255,0)\" background_color_gradient_end=\"rgba(255,255,255,0.16)\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" animation_style=\"slide\" animation_direction=\"right\" hover_enabled=\"0\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" locked=\"off\" price_font_size=\"50px\" price_letter_spacing_last_edited=\"on|desktop\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate_linked__hover=\"off\" transform_translate__hover=\"0px|-70px\"][et_pb_pricing_table title=\"اینترنت حرفه ای\" subtitle=\"120 مگابایت\" currency=\"یک ساله \" per=\"هزارتومان\" sum=\"900\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" header_level=\"h2\" header_font=\"||||||||\" body_font=\"VAZIR FARSI||||||||\" subheader_font=\"|800|||||||\" price_font=\"VAZIR FARSI||on||||||\" price_letter_spacing=\"0px\" price_line_height=\"100px\" currency_frequency_font=\"|700|on||||||\" currency_frequency_line_height=\"1em\" excluded_text_color=\"rgba(255,255,255,0.5)\" hover_enabled=\"0\" pricing_item_excluded_color=\"rgba(255,255,255,0.5)\" button_url=\"#\" custom_button=\"on\" button_font=\"VAZIR FARSI||||||||\"]<p>+ گارانتی سرعت</p>\n<p>+ گارنتی کیفیت</p>\n<p>+ نصب در محل</p>\n<p>- تنظیم مودم</p>\n<p>- پشتیبانی 24 ساعته</p>\n[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Blog\" _builder_version=\"3.22\"][et_pb_row _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#0492ff\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>آخرین مقالات از وبلاگ ما</h2>\n[/et_pb_text][et_pb_blog fullwidth=\"off\" posts_number=\"3\" include_categories=\"70\" show_pagination=\"off\" _builder_version=\"3.17.6\" header_font=\"Poppins|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_line_height=\"2em\" meta_font=\"Poppins||||||||\" meta_text_color=\"#008a1c\" pagination_font=\"Poppins|700|on||||||\" pagination_text_color=\"#008a1c\" pagination_font_size=\"18px\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"][/et_pb_blog][et_pb_button button_text=\"رفتن به وبلاگ\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#7cda24\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonials\" _builder_version=\"3.22\"][et_pb_row column_structure=\"2_5,3_5\" padding_top_bottom_link_1=\"true\" padding_top_bottom_link_2=\"true\" padding_left_right_link_1=\"false\" padding_left_right_link_2=\"false\" _builder_version=\"3.25\" custom_padding=\"0||0||false|false\"][et_pb_column type=\"2_5\" _builder_version=\"3.25\" custom_padding=\"60px|60px|60px|\" custom_padding_tablet=\"0px||0px||true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px||0px||true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>مشتریان در مورد ما چه می گویند ؟</h2>\n<h3>بهترین شرکت خدمات اینترنتی از دید مشتریان در سال های اخیر</h3>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"3_5\" _builder_version=\"3.25\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/handyman_11.png\" background_size=\"initial\" background_position=\"bottom_right\" custom_padding=\"60px|60px|60px|\" custom_padding_tablet=\"40px|40px|40px|40px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"40px|40px|40px|40px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_testimonial author=\"مشتری از سال 1390\" quote_icon=\"off\" _builder_version=\"4.4.2\" body_font=\"||on||||||\" body_font_size=\"14px\" body_line_height=\"2em\" background_color=\"#ffffff\" custom_margin=\"|||-40px\" custom_margin_tablet=\"|||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|desktop\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0.15)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate_linked__hover=\"off\" transform_translate__hover=\"-50px|0px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span>\"</p>\n[/et_pb_testimonial][et_pb_testimonial author=\"مشتری جدید\" quote_icon=\"off\" _builder_version=\"4.4.2\" body_font=\"||on||||||\" body_font_size=\"14px\" body_line_height=\"2em\" background_color=\"#ffffff\" custom_margin=\"|||-40px\" custom_margin_tablet=\"|||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|desktop\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0.15)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate_linked__hover=\"off\" transform_translate__hover=\"-50px|0px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span>\"</p>\n[/et_pb_testimonial][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" prev_background_color=\"#ffffff\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#0f1533\" background_color_gradient_end=\"#1f133a\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||5vw\" custom_padding=\"14vw||10vw\" top_divider_style=\"wave2\" top_divider_height=\"10vw\" top_divider_repeat=\"0.7x\" top_divider_flip=\"vertical\" animation_style=\"fade\" border_radii=\"on|30px|30px|30px|30px\" locked=\"off\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_phone=\"\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_2_font=\"|900|on||||||\" header_2_font_size=\"3vw\" header_2_letter_spacing=\"2px\" header_2_line_height=\"1.4em\" header_3_font=\"|900|on|on|||||\" header_3_text_color=\"rgba(255,255,255,0.7)\" header_3_font_size=\"1.5vw\" header_3_letter_spacing=\"0.4em\" header_3_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" hover_enabled=\"0\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_font_size__hover=\"30px\" header_font_size__hover_enabled=\"30px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h2>سرعت مورد نظر خود را با قیمتی که می خواهید دریافت کنید</h2>\n<h3>سرویس های ADSL  و سرویس های پیامکی</h3>\n[/et_pb_text][et_pb_button button_text=\"مشاهده تمام سرویس های ما\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#7cda24\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section]", "خانه", "", "inherit", "closed", "closed", "", "2-revision-v1", "", "", "2020-04-02 13:17:21", "2020-04-02 09:47:21", "", "2", "http://modelsite.test/2-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2952", "1", "2020-04-02 13:18:13", "2020-04-02 09:48:13", "[et_pb_section fb_built=\"1\" admin_label=\"Header\" _builder_version=\"4.4.2\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/09b24e31234507.564a1d23c07b4.gif\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"5vw||||false\" custom_padding=\"10vw||14vw||false\" bottom_divider_style=\"wave2\" bottom_divider_color=\"#ffffff\" bottom_divider_height=\"10vw\" bottom_divider_repeat=\"0.7x\" animation_style=\"slide\" animation_direction=\"bottom\" animation_intensity_slide=\"1%\" hover_enabled=\"0\" border_radii=\"on|30px|30px|30px|30px\" background_size=\"contain\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_phone=\"\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" animation_style=\"slide\" animation_direction=\"left\" animation_intensity_slide=\"10%\" hover_enabled=\"0\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_font=\"|900|on|on|||||\" header_font_size=\"10vw\" header_letter_spacing=\"0.1em\" header_line_height=\"1.2em\" header_2_font=\"|900|on|on|||||\" header_2_text_color=\"rgba(255,255,255,0.7)\" header_2_font_size=\"44px\" header_2_letter_spacing=\"0em\" header_2_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" header_font_size_tablet=\"50px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|phone\" header_2_font_size_tablet=\"30px\" header_2_font_size_phone=\"20px\" header_2_font_size_last_edited=\"on|phone\" header_text_shadow_style=\"preset1\" header_text_shadow_color=\"rgba(0,0,0,0.15)\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h1>نهایت سرعت</h1>\n<p>&nbsp;</p>\n<h2><span color=\"rgba(0, 0, 0, 0.701960784313725)\" style=\"color: rgba(0, 0, 0, 0.7);\">35 هزارتومان </span>اینترنت ADSL</h2>[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_font_size=\"18px\" text_line_height=\"2em\" text_orientation=\"center\" background_layout=\"dark\" max_width=\"800px\" module_alignment=\"center\" text_font_size_tablet=\"16px\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>[/et_pb_text][et_pb_button button_text=\"مشاهده تمام پلن های اینترنتی\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#0c71c3\" button_bg_enable_color__hover=\"on\" button_text_color__hover_enabled=\"on|hover\" button_text_color__hover=\"#ffffff\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Login\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(242,245,250,0)\" background_color_gradient_end=\"#f2f5fa\" background_color_gradient_direction=\"90deg\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_padding=\"0|0px|0|0px|false|false\" border_radii=\"on|60px|60px|60px|60px\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_font_size=\"20px\" link_font=\"||||||||\" link_text_color=\"#0492ff\" text_orientation=\"center\" hover_enabled=\"0\" text_text_shadow_style=\"preset1\" text_text_shadow_color=\"#7cda24\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate_linked__hover=\"off\" transform_translate__hover=\"-50px|0px\" content__hover_enabled=\"on|hover\" content__hover=\"<p><a href=%22#%22><strong>کلیک نمایید</strong></a></p>\n\"]<p>آماده اید ؟  جهت عضویت <a href=\"#\"><strong>اینجا را کلیک نمایید</strong></a></p>[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Value\" _builder_version=\"3.22\"][et_pb_row _builder_version=\"3.25\" custom_padding=\"||||false|false\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#0492ff\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>چرا انتخاب ما ؟</h2>[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" padding_top_bottom_link_1=\"false\" padding_top_bottom_link_2=\"false\" padding_top_bottom_link_3=\"false\" padding_left_right_link_1=\"true\" padding_left_right_link_2=\"true\" padding_left_right_link_3=\"true\" _builder_version=\"3.25\" max_width=\"1160px\" custom_padding=\"0|0px|27px|0px|false|false\" use_custom_width=\"on\" custom_width_px=\"1160px\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\" max_width__hover=\"1080px\" max_width__hover_enabled=\"1080px\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-03.png\" background_size=\"contain\" background_position=\"bottom_right\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"دریافت سرعت واقعی\" use_icon=\"on\" font_icon=\"%%243%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|hover\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"0deg|330deg|0deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"20 درصد تخفیف\" use_icon=\"on\" font_icon=\"%%171%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"0deg|0deg|330deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-04.png\" background_size=\"contain\" background_position=\"top_right\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"بدون محدودیت حجمی\" use_icon=\"on\" font_icon=\"%%231%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"330deg|0deg|0deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است </span></p>[/et_pb_blurb][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Features\" _builder_version=\"3.22\" background_color=\"#f2f5fa\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_padding=\"54px|0px|0|0px|false|false\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row column_structure=\"3_5,2_5\" _builder_version=\"3.25\" custom_margin=\"100px||100px||true\" custom_margin_tablet=\"40px||40px||true\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\"][et_pb_column type=\"3_5\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/04/isp-01.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"|||-7vw\" custom_margin_tablet=\"|||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\"][/et_pb_image][/et_pb_column][et_pb_column type=\"2_5\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>انتخاب شماره 1# کاربران برای اینترنت  فیبر نوری</h2>\n<h3></h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>[/et_pb_text][et_pb_blurb title=\"بدون قعطی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"2em\" custom_margin=\"||20px\"][/et_pb_blurb][et_pb_blurb title=\"سرعت تا 65 مگابایت\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"2em\" custom_margin=\"||20px\"][/et_pb_blurb][et_pb_blurb title=\"شامل مودم رایگان\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"2em\" custom_margin=\"||20px\"][/et_pb_blurb][et_pb_button button_text=\"مشاهده پلن های اینترنت\" button_alignment=\"left\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#7cda24\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" custom_margin=\"100px||100px||true\" custom_margin_tablet=\"40px||40px||true\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"14px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>داده نامحدود ،پشتیبانی شبانه روزی و سرویس پیامکی</h2>\n<h3>همه موارد را برای داشتن خطوط پیامکی موفق برای شما فراهم کرده ایم</h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد</span></p>[/et_pb_text][et_pb_button button_text=\"مشاهده پلن های پیامکی\" button_alignment=\"left\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#7cda24\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/04/isp-02.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"|-7vw||\" custom_margin_tablet=\"|0vw||\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\" border_radii=\"on|30px|30px|30px|30px\"][/et_pb_image][/et_pb_column][/et_pb_row][et_pb_row custom_padding_last_edited=\"on|tablet\" _builder_version=\"4.4.2\" background_color=\"#ffffff\" max_width=\"80%\" module_alignment=\"right\" custom_margin=\"||\" custom_padding=\"60px|60px|||false|false\" custom_padding_tablet=\"|40px||40px\" custom_padding_phone=\"\" animation_style=\"slide\" animation_direction=\"right\" animation_intensity_slide=\"10%\" border_radii=\"|30px|||\" use_custom_width=\"on\" width_unit=\"off\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>محبوب ترین خدمات</h2>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد</span></p>[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Categories\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(242,245,250,0)\" background_color_gradient_end=\"#f2f5fa\" background_color_gradient_direction=\"90deg\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||60px\" custom_margin_tablet=\"||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|desktop\" custom_padding=\"0||0px||false|false\" border_radii=\"on|60px|60px|60px|60px\" locked=\"off\"][et_pb_row column_structure=\"1_6,1_6,1_6,1_6,1_6,1_6\" use_custom_gutter=\"on\" gutter_width=\"2\" _builder_version=\"3.25\" locked=\"off\"][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#ffffff\" text_orientation=\"center\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" locked=\"off\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" box_shadow_color__hover_enabled=\"on\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\" background_layout__hover_enabled=\"on\" background_layout__hover=\"dark\"]<p>پیامک</p>[/et_pb_text][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"Poppins|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#a0cf00\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" locked=\"off\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" box_shadow_color__hover_enabled=\"on\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\"]<p>ADSL</p>[/et_pb_text][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#008a1c\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" box_shadow_color__hover_enabled=\"on\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\"]<p>وایرلس</p>[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Pricing\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||||false\" custom_padding=\"80px||80px||true\" animation_style=\"slide\" animation_direction=\"bottom\" animation_intensity_slide=\"1%\" border_radii=\"on|30px|30px|30px|30px\" locked=\"off\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\"][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"40px|||\" custom_padding_tablet=\"0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px||\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#ffffff\" price_text_color=\"rgba(0,0,0,0.75)\" body_text_color=\"#ffffff\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"||||||||\" body_text_align=\"center\" subheader_font=\"|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"||on||||||\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(255,255,255,0)\" background_color_gradient_end=\"rgba(255,255,255,0.16)\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" animation_style=\"slide\" animation_direction=\"right\" hover_enabled=\"0\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" price_font_size=\"50px\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate_linked__hover=\"off\" transform_translate__hover=\"0px|-70px\"][et_pb_pricing_table title=\"اینترنت پایه\" subtitle=\"1 مگابایت\" currency=\"یک ساله \" per=\"هزارتومان\" sum=\"35\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" header_level=\"h2\" header_font=\"||||||||\" body_font=\"VAZIR FARSI||||||||\" subheader_font=\"|800|||||||\" price_font=\"|800|on||||||\" price_letter_spacing=\"0px\" price_line_height=\"100px\" currency_frequency_font=\"|700|on||||||\" currency_frequency_line_height=\"1em\" excluded_text_color=\"rgba(255,255,255,0.5)\" hover_enabled=\"0\" pricing_item_excluded_color=\"rgba(255,255,255,0.5)\" button_url=\"#\" custom_button=\"on\" button_font=\"VAZIR FARSI||||||||\"]<p>+ گارانتی سرعت</p>\n<p>+ گارنتی کیفیت</p>\n<p>+ نصب در محل</p>\n<p>- تنظیم مودم</p>\n<p>- پشتیبانی 24 ساعته</p>\n[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#a0cf00\" price_text_color=\"rgba(0,0,0,0.75)\" subheader_text_color=\"#000000\" header_text_color=\"#000000\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"Poppins||||||||\" body_text_align=\"center\" subheader_font=\"Poppins|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"|800|on||||||\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#ffffff\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#008a1c\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" custom_margin=\"0px||\" animation_style=\"zoom\" animation_delay=\"100ms\" hover_enabled=\"0\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" border_color_all=\"#ffffff\" border_width_top=\"40px\" border_width_bottom=\"30px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" locked=\"off\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate_linked__hover=\"off\" transform_translate__hover=\"0px|-70px\"][et_pb_pricing_table title=\"سرویس محبوب\" subtitle=\"65 مگابایت\" currency=\"سالانه\" per=\"هزارتومان\" sum=\"99\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" body_font=\"VAZIR FARSI||||||||\" hover_enabled=\"0\" header_font=\"||||||||\" header_level=\"h2\" subheader_font=\"VAZIR FARSI|800|||||||\" price_font=\"VAZIR FARSI|800|on||||||\" price_line_height=\"100px\" price_font_size=\"50px\" button_url=\"#\" custom_button=\"on\" button_font=\"VAZIR FARSI||||||||\"]<p>+ سرعت دانلود تا 65 مگابایت</p>\n<p>+ دانلود نامحدود</p>\n<p>+ پشتیبانی شبانه روزی</p>\n<p>+ مودم رایگان</p>\n<p>+ نصب رایگان</p>\n[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"40px|||\" custom_padding_tablet=\"0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|desktop\" padding_tablet=\"0px||\" padding_last_edited=\"on|desktop\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#ffffff\" price_text_color=\"rgba(0,0,0,0.75)\" body_text_color=\"#ffffff\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"||||||||\" body_text_align=\"center\" subheader_font=\"|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"||on||||||\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(255,255,255,0)\" background_color_gradient_end=\"rgba(255,255,255,0.16)\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" animation_style=\"slide\" animation_direction=\"right\" hover_enabled=\"0\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" locked=\"off\" price_font_size=\"50px\" price_letter_spacing_last_edited=\"on|desktop\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate_linked__hover=\"off\" transform_translate__hover=\"0px|-70px\"][et_pb_pricing_table title=\"اینترنت حرفه ای\" subtitle=\"120 مگابایت\" currency=\"یک ساله \" per=\"هزارتومان\" sum=\"900\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" header_level=\"h2\" header_font=\"||||||||\" body_font=\"VAZIR FARSI||||||||\" subheader_font=\"|800|||||||\" price_font=\"VAZIR FARSI||on||||||\" price_letter_spacing=\"0px\" price_line_height=\"100px\" currency_frequency_font=\"|700|on||||||\" currency_frequency_line_height=\"1em\" excluded_text_color=\"rgba(255,255,255,0.5)\" hover_enabled=\"0\" pricing_item_excluded_color=\"rgba(255,255,255,0.5)\" button_url=\"#\" custom_button=\"on\" button_font=\"VAZIR FARSI||||||||\"]<p>+ گارانتی سرعت</p>\n<p>+ گارنتی کیفیت</p>\n<p>+ نصب در محل</p>\n<p>- تنظیم مودم</p>\n<p>- پشتیبانی 24 ساعته</p>\n[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Blog\" _builder_version=\"3.22\"][et_pb_row _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#0492ff\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>آخرین مقالات از وبلاگ ما</h2>\n[/et_pb_text][et_pb_blog fullwidth=\"off\" posts_number=\"3\" include_categories=\"70\" show_pagination=\"off\" _builder_version=\"3.17.6\" header_font=\"Poppins|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_line_height=\"2em\" meta_font=\"Poppins||||||||\" meta_text_color=\"#008a1c\" pagination_font=\"Poppins|700|on||||||\" pagination_text_color=\"#008a1c\" pagination_font_size=\"18px\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"][/et_pb_blog][et_pb_button button_text=\"رفتن به وبلاگ\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#7cda24\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonials\" _builder_version=\"3.22\"][et_pb_row column_structure=\"2_5,3_5\" padding_top_bottom_link_1=\"true\" padding_top_bottom_link_2=\"true\" padding_left_right_link_1=\"false\" padding_left_right_link_2=\"false\" _builder_version=\"3.25\" custom_padding=\"0||0||false|false\"][et_pb_column type=\"2_5\" _builder_version=\"3.25\" custom_padding=\"60px|60px|60px|\" custom_padding_tablet=\"0px||0px||true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px||0px||true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>مشتریان در مورد ما چه می گویند ؟</h2>\n<h3>بهترین شرکت خدمات اینترنتی از دید مشتریان در سال های اخیر</h3>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"3_5\" _builder_version=\"3.25\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/handyman_11.png\" background_size=\"initial\" background_position=\"bottom_right\" custom_padding=\"60px|60px|60px|\" custom_padding_tablet=\"40px|40px|40px|40px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"40px|40px|40px|40px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_testimonial author=\"مشتری از سال 1390\" quote_icon=\"off\" _builder_version=\"4.4.2\" body_font=\"||on||||||\" body_font_size=\"14px\" body_line_height=\"2em\" background_color=\"#ffffff\" custom_margin=\"|||-40px\" custom_margin_tablet=\"|||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|desktop\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0.15)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate_linked__hover=\"off\" transform_translate__hover=\"-50px|0px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span>\"</p>\n[/et_pb_testimonial][et_pb_testimonial author=\"مشتری جدید\" quote_icon=\"off\" _builder_version=\"4.4.2\" body_font=\"||on||||||\" body_font_size=\"14px\" body_line_height=\"2em\" background_color=\"#ffffff\" custom_margin=\"|||-40px\" custom_margin_tablet=\"|||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|desktop\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0.15)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate_linked__hover=\"off\" transform_translate__hover=\"-50px|0px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span>\"</p>\n[/et_pb_testimonial][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" prev_background_color=\"#ffffff\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#0f1533\" background_color_gradient_end=\"#1f133a\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||5vw\" custom_padding=\"14vw||10vw\" top_divider_style=\"wave2\" top_divider_height=\"10vw\" top_divider_repeat=\"0.7x\" top_divider_flip=\"vertical\" animation_style=\"fade\" border_radii=\"on|30px|30px|30px|30px\" locked=\"off\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_phone=\"\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_2_font=\"|900|on||||||\" header_2_font_size=\"3vw\" header_2_letter_spacing=\"2px\" header_2_line_height=\"1.4em\" header_3_font=\"|900|on|on|||||\" header_3_text_color=\"rgba(255,255,255,0.7)\" header_3_font_size=\"1.5vw\" header_3_letter_spacing=\"0.4em\" header_3_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" hover_enabled=\"0\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_font_size__hover=\"30px\" header_font_size__hover_enabled=\"30px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h2>سرعت مورد نظر خود را با قیمتی که می خواهید دریافت کنید</h2>\n<h3>سرویس های ADSL  و سرویس های پیامکی</h3>\n[/et_pb_text][et_pb_button button_text=\"مشاهده تمام سرویس های ما\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#7cda24\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section]", "خانه", "", "inherit", "closed", "closed", "", "2-revision-v1", "", "", "2020-04-02 13:18:13", "2020-04-02 09:48:13", "", "2", "http://modelsite.test/2-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2956", "1", "2020-04-02 13:26:37", "2020-04-02 09:56:37", "[et_pb_section fb_built=\"1\" admin_label=\"Header\" _builder_version=\"4.4.2\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-05.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"5vw||||false\" custom_padding=\"10vw||14vw||false\" bottom_divider_style=\"wave2\" bottom_divider_color=\"#ffffff\" bottom_divider_height=\"10vw\" bottom_divider_repeat=\"0.7x\" animation_style=\"slide\" animation_direction=\"bottom\" animation_intensity_slide=\"1%\" hover_enabled=\"0\" border_radii=\"on|30px|30px|30px|30px\" parallax_method=\"off\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_phone=\"\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" animation_style=\"slide\" animation_direction=\"left\" animation_intensity_slide=\"10%\" hover_enabled=\"0\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_font=\"|900|on|on|||||\" header_font_size=\"10vw\" header_letter_spacing=\"0.1em\" header_line_height=\"1.2em\" header_2_font=\"|900|on|on|||||\" header_2_text_color=\"rgba(255,255,255,0.7)\" header_2_font_size=\"44px\" header_2_letter_spacing=\"0em\" header_2_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" header_font_size_tablet=\"50px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|phone\" header_2_font_size_tablet=\"30px\" header_2_font_size_phone=\"20px\" header_2_font_size_last_edited=\"on|phone\" header_text_shadow_style=\"preset1\" header_text_shadow_color=\"rgba(0,0,0,0.15)\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h1>نهایت سرعت</h1>\n<p>&nbsp;</p>\n<h2><span color=\"rgba(0, 0, 0, 0.701960784313725)\" style=\"color: rgba(0, 0, 0, 0.7);\">35 هزارتومان </span>اینترنت ADSL</h2>[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_font_size=\"18px\" text_line_height=\"2em\" text_orientation=\"center\" background_layout=\"dark\" max_width=\"800px\" module_alignment=\"center\" text_font_size_tablet=\"16px\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>[/et_pb_text][et_pb_button button_text=\"مشاهده تمام پلن های اینترنتی\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#0c71c3\" button_bg_enable_color__hover=\"on\" button_text_color__hover_enabled=\"on|hover\" button_text_color__hover=\"#ffffff\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Login\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(242,245,250,0)\" background_color_gradient_end=\"#f2f5fa\" background_color_gradient_direction=\"90deg\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_padding=\"0|0px|0|0px|false|false\" border_radii=\"on|60px|60px|60px|60px\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_font_size=\"20px\" link_font=\"||||||||\" link_text_color=\"#0492ff\" text_orientation=\"center\" hover_enabled=\"0\" text_text_shadow_style=\"preset1\" text_text_shadow_color=\"#7cda24\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate_linked__hover=\"off\" transform_translate__hover=\"-50px|0px\" content__hover_enabled=\"on|hover\" content__hover=\"<p><a href=%22#%22><strong>کلیک نمایید</strong></a></p>\n\"]<p>آماده اید ؟  جهت عضویت <a href=\"#\"><strong>اینجا را کلیک نمایید</strong></a></p>[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Value\" _builder_version=\"3.22\"][et_pb_row _builder_version=\"3.25\" custom_padding=\"||||false|false\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#0492ff\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>چرا انتخاب ما ؟</h2>[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" padding_top_bottom_link_1=\"false\" padding_top_bottom_link_2=\"false\" padding_top_bottom_link_3=\"false\" padding_left_right_link_1=\"true\" padding_left_right_link_2=\"true\" padding_left_right_link_3=\"true\" _builder_version=\"3.25\" max_width=\"1160px\" custom_padding=\"0|0px|27px|0px|false|false\" use_custom_width=\"on\" custom_width_px=\"1160px\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\" max_width__hover=\"1080px\" max_width__hover_enabled=\"1080px\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-03.png\" background_size=\"contain\" background_position=\"bottom_right\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"دریافت سرعت واقعی\" use_icon=\"on\" font_icon=\"%%243%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|hover\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"0deg|330deg|0deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"20 درصد تخفیف\" use_icon=\"on\" font_icon=\"%%171%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"0deg|0deg|330deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-04.png\" background_size=\"contain\" background_position=\"top_right\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"بدون محدودیت حجمی\" use_icon=\"on\" font_icon=\"%%231%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"330deg|0deg|0deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است </span></p>[/et_pb_blurb][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Features\" _builder_version=\"3.22\" background_color=\"#f2f5fa\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_padding=\"54px|0px|0|0px|false|false\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row column_structure=\"3_5,2_5\" _builder_version=\"3.25\" custom_margin=\"100px||100px||true\" custom_margin_tablet=\"40px||40px||true\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\"][et_pb_column type=\"3_5\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/04/isp-01.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"|||-7vw\" custom_margin_tablet=\"|||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\"][/et_pb_image][/et_pb_column][et_pb_column type=\"2_5\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>انتخاب شماره 1# کاربران برای اینترنت  فیبر نوری</h2>\n<h3></h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>[/et_pb_text][et_pb_blurb title=\"بدون قعطی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"2em\" custom_margin=\"||20px\"][/et_pb_blurb][et_pb_blurb title=\"سرعت تا 65 مگابایت\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"2em\" custom_margin=\"||20px\"][/et_pb_blurb][et_pb_blurb title=\"شامل مودم رایگان\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"2em\" custom_margin=\"||20px\"][/et_pb_blurb][et_pb_button button_text=\"مشاهده پلن های اینترنت\" button_alignment=\"left\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#7cda24\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" custom_margin=\"100px||100px||true\" custom_margin_tablet=\"40px||40px||true\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"14px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>داده نامحدود ،پشتیبانی شبانه روزی و سرویس پیامکی</h2>\n<h3>همه موارد را برای داشتن خطوط پیامکی موفق برای شما فراهم کرده ایم</h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد</span></p>[/et_pb_text][et_pb_button button_text=\"مشاهده پلن های پیامکی\" button_alignment=\"left\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#7cda24\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/04/isp-02.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"|-7vw||\" custom_margin_tablet=\"|0vw||\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\" border_radii=\"on|30px|30px|30px|30px\"][/et_pb_image][/et_pb_column][/et_pb_row][et_pb_row custom_padding_last_edited=\"on|tablet\" _builder_version=\"4.4.2\" background_color=\"#ffffff\" max_width=\"80%\" module_alignment=\"right\" custom_margin=\"||\" custom_padding=\"60px|60px|||false|false\" custom_padding_tablet=\"|40px||40px\" custom_padding_phone=\"\" animation_style=\"slide\" animation_direction=\"right\" animation_intensity_slide=\"10%\" border_radii=\"|30px|||\" use_custom_width=\"on\" width_unit=\"off\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>محبوب ترین خدمات</h2>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد</span></p>[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Categories\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(242,245,250,0)\" background_color_gradient_end=\"#f2f5fa\" background_color_gradient_direction=\"90deg\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||60px\" custom_margin_tablet=\"||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|desktop\" custom_padding=\"0||0px||false|false\" border_radii=\"on|60px|60px|60px|60px\" locked=\"off\"][et_pb_row column_structure=\"1_6,1_6,1_6,1_6,1_6,1_6\" use_custom_gutter=\"on\" gutter_width=\"2\" _builder_version=\"3.25\" locked=\"off\"][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#ffffff\" text_orientation=\"center\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" locked=\"off\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" box_shadow_color__hover_enabled=\"on\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\" background_layout__hover_enabled=\"on\" background_layout__hover=\"dark\"]<p>پیامک</p>[/et_pb_text][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"Poppins|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#a0cf00\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" locked=\"off\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" box_shadow_color__hover_enabled=\"on\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\"]<p>ADSL</p>[/et_pb_text][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#008a1c\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" box_shadow_color__hover_enabled=\"on\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\"]<p>وایرلس</p>[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Pricing\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||||false\" custom_padding=\"80px||80px||true\" animation_style=\"slide\" animation_direction=\"bottom\" animation_intensity_slide=\"1%\" border_radii=\"on|30px|30px|30px|30px\" locked=\"off\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\"][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"40px|||\" custom_padding_tablet=\"0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px||\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#ffffff\" price_text_color=\"rgba(0,0,0,0.75)\" body_text_color=\"#ffffff\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"||||||||\" body_text_align=\"center\" subheader_font=\"|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"||on||||||\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(255,255,255,0)\" background_color_gradient_end=\"rgba(255,255,255,0.16)\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" animation_style=\"slide\" animation_direction=\"right\" hover_enabled=\"0\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" price_font_size=\"50px\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate_linked__hover=\"off\" transform_translate__hover=\"0px|-70px\"][et_pb_pricing_table title=\"اینترنت پایه\" subtitle=\"1 مگابایت\" currency=\"یک ساله \" per=\"هزارتومان\" sum=\"35\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" header_level=\"h2\" header_font=\"||||||||\" body_font=\"VAZIR FARSI||||||||\" subheader_font=\"|800|||||||\" price_font=\"|800|on||||||\" price_letter_spacing=\"0px\" price_line_height=\"100px\" currency_frequency_font=\"|700|on||||||\" currency_frequency_line_height=\"1em\" excluded_text_color=\"rgba(255,255,255,0.5)\" hover_enabled=\"0\" pricing_item_excluded_color=\"rgba(255,255,255,0.5)\" button_url=\"#\" custom_button=\"on\" button_font=\"VAZIR FARSI||||||||\"]<p>+ گارانتی سرعت</p>\n<p>+ گارنتی کیفیت</p>\n<p>+ نصب در محل</p>\n<p>- تنظیم مودم</p>\n<p>- پشتیبانی 24 ساعته</p>\n[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#a0cf00\" price_text_color=\"rgba(0,0,0,0.75)\" subheader_text_color=\"#000000\" header_text_color=\"#000000\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"Poppins||||||||\" body_text_align=\"center\" subheader_font=\"Poppins|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"|800|on||||||\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#ffffff\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#008a1c\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" custom_margin=\"0px||\" animation_style=\"zoom\" animation_delay=\"100ms\" hover_enabled=\"0\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" border_color_all=\"#ffffff\" border_width_top=\"40px\" border_width_bottom=\"30px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" locked=\"off\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate_linked__hover=\"off\" transform_translate__hover=\"0px|-70px\"][et_pb_pricing_table title=\"سرویس محبوب\" subtitle=\"65 مگابایت\" currency=\"سالانه\" per=\"هزارتومان\" sum=\"99\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" body_font=\"VAZIR FARSI||||||||\" hover_enabled=\"0\" header_font=\"||||||||\" header_level=\"h2\" subheader_font=\"VAZIR FARSI|800|||||||\" price_font=\"VAZIR FARSI|800|on||||||\" price_line_height=\"100px\" price_font_size=\"50px\" button_url=\"#\" custom_button=\"on\" button_font=\"VAZIR FARSI||||||||\"]<p>+ سرعت دانلود تا 65 مگابایت</p>\n<p>+ دانلود نامحدود</p>\n<p>+ پشتیبانی شبانه روزی</p>\n<p>+ مودم رایگان</p>\n<p>+ نصب رایگان</p>\n[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"40px|||\" custom_padding_tablet=\"0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|desktop\" padding_tablet=\"0px||\" padding_last_edited=\"on|desktop\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#ffffff\" price_text_color=\"rgba(0,0,0,0.75)\" body_text_color=\"#ffffff\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"||||||||\" body_text_align=\"center\" subheader_font=\"|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"||on||||||\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(255,255,255,0)\" background_color_gradient_end=\"rgba(255,255,255,0.16)\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" animation_style=\"slide\" animation_direction=\"right\" hover_enabled=\"0\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" locked=\"off\" price_font_size=\"50px\" price_letter_spacing_last_edited=\"on|desktop\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate_linked__hover=\"off\" transform_translate__hover=\"0px|-70px\"][et_pb_pricing_table title=\"اینترنت حرفه ای\" subtitle=\"120 مگابایت\" currency=\"یک ساله \" per=\"هزارتومان\" sum=\"900\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" header_level=\"h2\" header_font=\"||||||||\" body_font=\"VAZIR FARSI||||||||\" subheader_font=\"|800|||||||\" price_font=\"VAZIR FARSI||on||||||\" price_letter_spacing=\"0px\" price_line_height=\"100px\" currency_frequency_font=\"|700|on||||||\" currency_frequency_line_height=\"1em\" excluded_text_color=\"rgba(255,255,255,0.5)\" hover_enabled=\"0\" pricing_item_excluded_color=\"rgba(255,255,255,0.5)\" button_url=\"#\" custom_button=\"on\" button_font=\"VAZIR FARSI||||||||\"]<p>+ گارانتی سرعت</p>\n<p>+ گارنتی کیفیت</p>\n<p>+ نصب در محل</p>\n<p>- تنظیم مودم</p>\n<p>- پشتیبانی 24 ساعته</p>\n[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Blog\" _builder_version=\"3.22\"][et_pb_row _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#0492ff\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>آخرین مقالات از وبلاگ ما</h2>\n[/et_pb_text][et_pb_blog fullwidth=\"off\" posts_number=\"3\" include_categories=\"70\" show_pagination=\"off\" _builder_version=\"3.17.6\" header_font=\"Poppins|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_line_height=\"2em\" meta_font=\"Poppins||||||||\" meta_text_color=\"#008a1c\" pagination_font=\"Poppins|700|on||||||\" pagination_text_color=\"#008a1c\" pagination_font_size=\"18px\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"][/et_pb_blog][et_pb_button button_text=\"رفتن به وبلاگ\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#7cda24\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonials\" _builder_version=\"3.22\"][et_pb_row column_structure=\"2_5,3_5\" padding_top_bottom_link_1=\"true\" padding_top_bottom_link_2=\"true\" padding_left_right_link_1=\"false\" padding_left_right_link_2=\"false\" _builder_version=\"3.25\" custom_padding=\"0||0||false|false\"][et_pb_column type=\"2_5\" _builder_version=\"3.25\" custom_padding=\"60px|60px|60px|\" custom_padding_tablet=\"0px||0px||true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px||0px||true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>مشتریان در مورد ما چه می گویند ؟</h2>\n<h3>بهترین شرکت خدمات اینترنتی از دید مشتریان در سال های اخیر</h3>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"3_5\" _builder_version=\"3.25\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/handyman_11.png\" background_size=\"initial\" background_position=\"bottom_right\" custom_padding=\"60px|60px|60px|\" custom_padding_tablet=\"40px|40px|40px|40px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"40px|40px|40px|40px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_testimonial author=\"مشتری از سال 1390\" quote_icon=\"off\" _builder_version=\"4.4.2\" body_font=\"||on||||||\" body_font_size=\"14px\" body_line_height=\"2em\" background_color=\"#ffffff\" custom_margin=\"|||-40px\" custom_margin_tablet=\"|||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|desktop\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0.15)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate_linked__hover=\"off\" transform_translate__hover=\"-50px|0px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span>\"</p>\n[/et_pb_testimonial][et_pb_testimonial author=\"مشتری جدید\" quote_icon=\"off\" _builder_version=\"4.4.2\" body_font=\"||on||||||\" body_font_size=\"14px\" body_line_height=\"2em\" background_color=\"#ffffff\" custom_margin=\"|||-40px\" custom_margin_tablet=\"|||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|desktop\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0.15)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate_linked__hover=\"off\" transform_translate__hover=\"-50px|0px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span>\"</p>\n[/et_pb_testimonial][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" prev_background_color=\"#ffffff\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#0f1533\" background_color_gradient_end=\"#1f133a\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||5vw\" custom_padding=\"14vw||10vw\" top_divider_style=\"wave2\" top_divider_height=\"10vw\" top_divider_repeat=\"0.7x\" top_divider_flip=\"vertical\" animation_style=\"fade\" border_radii=\"on|30px|30px|30px|30px\" locked=\"off\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_phone=\"\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_2_font=\"|900|on||||||\" header_2_font_size=\"3vw\" header_2_letter_spacing=\"2px\" header_2_line_height=\"1.4em\" header_3_font=\"|900|on|on|||||\" header_3_text_color=\"rgba(255,255,255,0.7)\" header_3_font_size=\"1.5vw\" header_3_letter_spacing=\"0.4em\" header_3_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" hover_enabled=\"0\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_font_size__hover=\"30px\" header_font_size__hover_enabled=\"30px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h2>سرعت مورد نظر خود را با قیمتی که می خواهید دریافت کنید</h2>\n<h3>سرویس های ADSL  و سرویس های پیامکی</h3>\n[/et_pb_text][et_pb_button button_text=\"مشاهده تمام سرویس های ما\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#7cda24\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section]", "خانه", "", "inherit", "closed", "closed", "", "2-revision-v1", "", "", "2020-04-02 13:26:37", "2020-04-02 09:56:37", "", "2", "http://modelsite.test/2-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2958", "1", "2020-04-02 13:28:47", "2020-04-02 09:58:47", "[et_pb_section fb_built=\"1\" admin_label=\"Header\" _builder_version=\"4.4.2\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-05.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"5vw||||false\" custom_padding=\"10vw||14vw||false\" bottom_divider_style=\"wave2\" bottom_divider_color=\"#ffffff\" bottom_divider_height=\"10vw\" bottom_divider_repeat=\"0.7x\" animation_style=\"slide\" animation_direction=\"bottom\" animation_intensity_slide=\"1%\" hover_enabled=\"0\" border_radii=\"on|30px|30px|30px|30px\" parallax_method=\"off\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_phone=\"\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" animation_style=\"slide\" animation_direction=\"left\" animation_intensity_slide=\"10%\" hover_enabled=\"0\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_font=\"|900|on|on|||||\" header_font_size=\"10vw\" header_letter_spacing=\"0.1em\" header_line_height=\"1.2em\" header_2_font=\"|900|on|on|||||\" header_2_text_color=\"rgba(255,255,255,0.7)\" header_2_font_size=\"44px\" header_2_letter_spacing=\"0em\" header_2_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" header_font_size_tablet=\"50px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|phone\" header_2_font_size_tablet=\"30px\" header_2_font_size_phone=\"20px\" header_2_font_size_last_edited=\"on|phone\" header_text_shadow_style=\"preset1\" header_text_shadow_color=\"rgba(0,0,0,0.15)\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h1>نهایت سرعت</h1>\n<p>&nbsp;</p>\n<h2><span color=\"rgba(0, 0, 0, 0.701960784313725)\" style=\"color: rgba(0, 0, 0, 0.7);\">35 هزارتومان </span>اینترنت ADSL</h2>[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_font_size=\"18px\" text_line_height=\"2em\" text_orientation=\"center\" background_layout=\"dark\" max_width=\"800px\" module_alignment=\"center\" text_font_size_tablet=\"16px\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>[/et_pb_text][et_pb_button button_text=\"مشاهده تمام پلن های اینترنتی\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#0c71c3\" button_bg_enable_color__hover=\"on\" button_text_color__hover_enabled=\"on|hover\" button_text_color__hover=\"#ffffff\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Login\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(242,245,250,0)\" background_color_gradient_end=\"#f2f5fa\" background_color_gradient_direction=\"90deg\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_padding=\"0|0px|0|0px|false|false\" border_radii=\"on|60px|60px|60px|60px\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_font_size=\"20px\" link_font=\"||||||||\" link_text_color=\"#0492ff\" text_orientation=\"center\" hover_enabled=\"0\" text_text_shadow_style=\"preset1\" text_text_shadow_color=\"#7cda24\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate_linked__hover=\"off\" transform_translate__hover=\"-50px|0px\" content__hover_enabled=\"on|hover\" content__hover=\"<p><a href=%22#%22><strong>کلیک نمایید</strong></a></p>\n\"]<p>آماده اید ؟  جهت عضویت <a href=\"#\"><strong>اینجا را کلیک نمایید</strong></a></p>[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Value\" _builder_version=\"3.22\"][et_pb_row _builder_version=\"3.25\" custom_padding=\"||||false|false\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#0492ff\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>چرا انتخاب ما ؟</h2>[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" padding_top_bottom_link_1=\"false\" padding_top_bottom_link_2=\"false\" padding_top_bottom_link_3=\"false\" padding_left_right_link_1=\"true\" padding_left_right_link_2=\"true\" padding_left_right_link_3=\"true\" _builder_version=\"3.25\" max_width=\"1160px\" custom_padding=\"0|0px|27px|0px|false|false\" use_custom_width=\"on\" custom_width_px=\"1160px\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\" max_width__hover=\"1080px\" max_width__hover_enabled=\"1080px\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-03.png\" background_size=\"contain\" background_position=\"bottom_right\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"دریافت سرعت واقعی\" use_icon=\"on\" font_icon=\"%%243%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|hover\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"0deg|330deg|0deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"20 درصد تخفیف\" use_icon=\"on\" font_icon=\"%%171%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"0deg|0deg|330deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-04.png\" background_size=\"contain\" background_position=\"top_right\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"بدون محدودیت حجمی\" use_icon=\"on\" font_icon=\"%%231%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"330deg|0deg|0deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است </span></p>[/et_pb_blurb][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Features\" _builder_version=\"3.22\" background_color=\"#f2f5fa\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_padding=\"54px|0px|0|0px|false|false\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row column_structure=\"3_5,2_5\" _builder_version=\"3.25\" custom_margin=\"100px||100px||true\" custom_margin_tablet=\"40px||40px||true\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\"][et_pb_column type=\"3_5\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/04/isp-01.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"|||-7vw\" custom_margin_tablet=\"|||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\"][/et_pb_image][/et_pb_column][et_pb_column type=\"2_5\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>انتخاب شماره 1# کاربران برای اینترنت  فیبر نوری</h2>\n<h3></h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>[/et_pb_text][et_pb_blurb title=\"بدون قعطی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"2em\" custom_margin=\"||20px\"][/et_pb_blurb][et_pb_blurb title=\"سرعت تا 65 مگابایت\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"2em\" custom_margin=\"||20px\"][/et_pb_blurb][et_pb_blurb title=\"شامل مودم رایگان\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"2em\" custom_margin=\"||20px\"][/et_pb_blurb][et_pb_button button_text=\"مشاهده پلن های اینترنت\" button_alignment=\"left\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#7cda24\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" custom_margin=\"100px||100px||true\" custom_margin_tablet=\"40px||40px||true\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"14px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>داده نامحدود ،پشتیبانی شبانه روزی و سرویس پیامکی</h2>\n<h3>همه موارد را برای داشتن خطوط پیامکی موفق برای شما فراهم کرده ایم</h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد</span></p>[/et_pb_text][et_pb_button button_text=\"مشاهده پلن های پیامکی\" button_alignment=\"left\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#7cda24\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/04/isp-02.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"|-7vw||\" custom_margin_tablet=\"|0vw||\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\" border_radii=\"on|30px|30px|30px|30px\"][/et_pb_image][/et_pb_column][/et_pb_row][et_pb_row custom_padding_last_edited=\"on|tablet\" _builder_version=\"4.4.2\" background_color=\"#ffffff\" max_width=\"80%\" module_alignment=\"right\" custom_margin=\"||\" custom_padding=\"60px|60px|||false|false\" custom_padding_tablet=\"|40px||40px\" custom_padding_phone=\"\" animation_style=\"slide\" animation_direction=\"right\" animation_intensity_slide=\"10%\" border_radii=\"|30px|||\" use_custom_width=\"on\" width_unit=\"off\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>محبوب ترین خدمات</h2>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد</span></p>[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Categories\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(242,245,250,0)\" background_color_gradient_end=\"#f2f5fa\" background_color_gradient_direction=\"90deg\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||60px\" custom_margin_tablet=\"||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|desktop\" custom_padding=\"0||0px||false|false\" border_radii=\"on|60px|60px|60px|60px\" locked=\"off\"][et_pb_row column_structure=\"1_6,1_6,1_6,1_6,1_6,1_6\" use_custom_gutter=\"on\" gutter_width=\"2\" _builder_version=\"3.25\" locked=\"off\"][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#ffffff\" text_orientation=\"center\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" locked=\"off\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" box_shadow_color__hover_enabled=\"on\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\" background_layout__hover_enabled=\"on\" background_layout__hover=\"dark\"]<p>پیامک</p>[/et_pb_text][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"Poppins|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#a0cf00\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" locked=\"off\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" box_shadow_color__hover_enabled=\"on\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\"]<p>ADSL</p>[/et_pb_text][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#008a1c\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" box_shadow_color__hover_enabled=\"on\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\"]<p>وایرلس</p>[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Pricing\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||||false\" custom_padding=\"80px||80px||true\" animation_style=\"slide\" animation_direction=\"bottom\" animation_intensity_slide=\"1%\" border_radii=\"on|30px|30px|30px|30px\" locked=\"off\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\"][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"40px|||\" custom_padding_tablet=\"0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px||\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#ffffff\" price_text_color=\"rgba(0,0,0,0.75)\" body_text_color=\"#ffffff\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"||||||||\" body_text_align=\"center\" subheader_font=\"|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"||on||||||\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(255,255,255,0)\" background_color_gradient_end=\"rgba(255,255,255,0.16)\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" animation_style=\"slide\" animation_direction=\"right\" hover_enabled=\"0\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" price_font_size=\"50px\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate_linked__hover=\"off\" transform_translate__hover=\"0px|-70px\"][et_pb_pricing_table title=\"اینترنت پایه\" subtitle=\"1 مگابایت\" currency=\"یک ساله \" per=\"هزارتومان\" sum=\"35\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" header_level=\"h2\" header_font=\"||||||||\" body_font=\"VAZIR FARSI||||||||\" subheader_font=\"|800|||||||\" price_font=\"|800|on||||||\" price_letter_spacing=\"0px\" price_line_height=\"100px\" currency_frequency_font=\"|700|on||||||\" currency_frequency_line_height=\"1em\" excluded_text_color=\"rgba(255,255,255,0.5)\" hover_enabled=\"0\" pricing_item_excluded_color=\"rgba(255,255,255,0.5)\" button_url=\"#\" custom_button=\"on\" button_font=\"VAZIR FARSI||||||||\"]<p>+ گارانتی سرعت</p>\n<p>+ گارنتی کیفیت</p>\n<p>+ نصب در محل</p>\n<p>- تنظیم مودم</p>\n<p>- پشتیبانی 24 ساعته</p>\n[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#a0cf00\" price_text_color=\"rgba(0,0,0,0.75)\" subheader_text_color=\"#000000\" header_text_color=\"#000000\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"Poppins||||||||\" body_text_align=\"center\" subheader_font=\"Poppins|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"|800|on||||||\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#ffffff\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#008a1c\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" custom_margin=\"0px||\" animation_style=\"zoom\" animation_delay=\"100ms\" hover_enabled=\"0\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" border_color_all=\"#ffffff\" border_width_top=\"40px\" border_width_bottom=\"30px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" locked=\"off\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate_linked__hover=\"off\" transform_translate__hover=\"0px|-70px\"][et_pb_pricing_table title=\"سرویس محبوب\" subtitle=\"65 مگابایت\" currency=\"سالانه\" per=\"هزارتومان\" sum=\"99\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" body_font=\"VAZIR FARSI||||||||\" hover_enabled=\"0\" header_font=\"||||||||\" header_level=\"h2\" subheader_font=\"VAZIR FARSI|800|||||||\" price_font=\"VAZIR FARSI|800|on||||||\" price_line_height=\"100px\" price_font_size=\"50px\" button_url=\"#\" custom_button=\"on\" button_font=\"VAZIR FARSI||||||||\"]<p>+ سرعت دانلود تا 65 مگابایت</p>\n<p>+ دانلود نامحدود</p>\n<p>+ پشتیبانی شبانه روزی</p>\n<p>+ مودم رایگان</p>\n<p>+ نصب رایگان</p>\n[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"40px|||\" custom_padding_tablet=\"0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|desktop\" padding_tablet=\"0px||\" padding_last_edited=\"on|desktop\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#ffffff\" price_text_color=\"rgba(0,0,0,0.75)\" body_text_color=\"#ffffff\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"||||||||\" body_text_align=\"center\" subheader_font=\"|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"||on||||||\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(255,255,255,0)\" background_color_gradient_end=\"rgba(255,255,255,0.16)\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" animation_style=\"slide\" animation_direction=\"right\" hover_enabled=\"0\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" locked=\"off\" price_font_size=\"50px\" price_letter_spacing_last_edited=\"on|desktop\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate_linked__hover=\"off\" transform_translate__hover=\"0px|-70px\"][et_pb_pricing_table title=\"اینترنت حرفه ای\" subtitle=\"120 مگابایت\" currency=\"یک ساله \" per=\"هزارتومان\" sum=\"900\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" header_level=\"h2\" header_font=\"||||||||\" body_font=\"VAZIR FARSI||||||||\" subheader_font=\"|800|||||||\" price_font=\"VAZIR FARSI||on||||||\" price_letter_spacing=\"0px\" price_line_height=\"100px\" currency_frequency_font=\"|700|on||||||\" currency_frequency_line_height=\"1em\" excluded_text_color=\"rgba(255,255,255,0.5)\" hover_enabled=\"0\" pricing_item_excluded_color=\"rgba(255,255,255,0.5)\" button_url=\"#\" custom_button=\"on\" button_font=\"VAZIR FARSI||||||||\"]<p>+ گارانتی سرعت</p>\n<p>+ گارنتی کیفیت</p>\n<p>+ نصب در محل</p>\n<p>- تنظیم مودم</p>\n<p>- پشتیبانی 24 ساعته</p>\n[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Blog\" _builder_version=\"3.22\"][et_pb_row _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#0492ff\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>آخرین مقالات از وبلاگ ما</h2>\n[/et_pb_text][et_pb_blog fullwidth=\"off\" posts_number=\"3\" include_categories=\"70\" show_pagination=\"off\" _builder_version=\"3.17.6\" header_font=\"Poppins|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_line_height=\"2em\" meta_font=\"Poppins||||||||\" meta_text_color=\"#008a1c\" pagination_font=\"Poppins|700|on||||||\" pagination_text_color=\"#008a1c\" pagination_font_size=\"18px\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"][/et_pb_blog][et_pb_button button_text=\"رفتن به وبلاگ\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#7cda24\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonials\" _builder_version=\"3.22\"][et_pb_row column_structure=\"2_5,3_5\" padding_top_bottom_link_1=\"true\" padding_top_bottom_link_2=\"true\" padding_left_right_link_1=\"false\" padding_left_right_link_2=\"false\" _builder_version=\"3.25\" custom_padding=\"0||0||false|false\"][et_pb_column type=\"2_5\" _builder_version=\"3.25\" custom_padding=\"60px|60px|60px|\" custom_padding_tablet=\"0px||0px||true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px||0px||true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>مشتریان در مورد ما چه می گویند ؟</h2>\n<h3>بهترین شرکت خدمات اینترنتی از دید مشتریان در سال های اخیر</h3>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"3_5\" _builder_version=\"3.25\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/handyman_11.png\" background_size=\"initial\" background_position=\"bottom_right\" custom_padding=\"60px|60px|60px|\" custom_padding_tablet=\"40px|40px|40px|40px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"40px|40px|40px|40px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_testimonial author=\"مشتری از سال 1390\" quote_icon=\"off\" _builder_version=\"4.4.2\" body_font=\"||on||||||\" body_font_size=\"14px\" body_line_height=\"2em\" background_color=\"#ffffff\" custom_margin=\"|||-40px\" custom_margin_tablet=\"|||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|desktop\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0.15)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate_linked__hover=\"off\" transform_translate__hover=\"-50px|0px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span>\"</p>\n[/et_pb_testimonial][et_pb_testimonial author=\"مشتری جدید\" quote_icon=\"off\" _builder_version=\"4.4.2\" body_font=\"||on||||||\" body_font_size=\"14px\" body_line_height=\"2em\" background_color=\"#ffffff\" custom_margin=\"|||-40px\" custom_margin_tablet=\"|||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|desktop\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0.15)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate_linked__hover=\"off\" transform_translate__hover=\"-50px|0px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span>\"</p>\n[/et_pb_testimonial][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" prev_background_color=\"#ffffff\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#0f1533\" background_color_gradient_end=\"#1f133a\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||5vw\" custom_padding=\"14vw||10vw\" top_divider_style=\"wave2\" top_divider_height=\"10vw\" top_divider_repeat=\"0.7x\" top_divider_flip=\"vertical\" animation_style=\"fade\" border_radii=\"on|30px|30px|30px|30px\" locked=\"off\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_phone=\"\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_2_font=\"|900|on||||||\" header_2_font_size=\"3.5vw\" header_2_letter_spacing=\"2px\" header_2_line_height=\"1.4em\" header_3_font=\"|900|on|on|||||\" header_3_text_color=\"rgba(255,255,255,0.7)\" header_3_font_size=\"1.5vw\" header_3_letter_spacing=\"0.4em\" header_3_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" hover_enabled=\"0\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_font_size__hover=\"30px\" header_font_size__hover_enabled=\"30px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h2>سرعت مورد نظر خود را با قیمتی که می خواهید دریافت کنید</h2>\n<h3>سرویس های ADSL  و سرویس های پیامکی</h3>\n[/et_pb_text][et_pb_button button_text=\"مشاهده تمام سرویس های ما\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#7cda24\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section]", "خانه", "", "inherit", "closed", "closed", "", "2-revision-v1", "", "", "2020-04-02 13:28:47", "2020-04-02 09:58:47", "", "2", "http://modelsite.test/2-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2961", "1", "2020-04-02 13:37:53", "2020-04-02 10:07:53", "[et_pb_section fb_built=\"1\" admin_label=\"Header\" _builder_version=\"4.4.2\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-05.png\" parallax=\"on\" parallax_method=\"off\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"5vw||||false\" custom_padding=\"10vw||14vw||false\" bottom_divider_style=\"wave2\" bottom_divider_color=\"#ffffff\" bottom_divider_height=\"10vw\" bottom_divider_repeat=\"0.7x\" animation_style=\"slide\" animation_direction=\"bottom\" animation_intensity_slide=\"1%\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_phone=\"\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" animation_style=\"slide\" animation_direction=\"left\" animation_intensity_slide=\"10%\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_font=\"|900|on|on|||||\" header_font_size=\"10vw\" header_letter_spacing=\"0.1em\" header_line_height=\"1.2em\" header_2_font=\"|900|on|on|||||\" header_2_text_color=\"rgba(255,255,255,0.7)\" header_2_font_size=\"44px\" header_2_letter_spacing=\"0em\" header_2_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" header_font_size_tablet=\"50px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|phone\" header_2_font_size_tablet=\"30px\" header_2_font_size_phone=\"20px\" header_2_font_size_last_edited=\"on|phone\" header_text_shadow_style=\"preset1\" header_text_shadow_color=\"rgba(0,0,0,0.15)\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h1>نهایت سرعت</h1>\n<p>&nbsp;</p>\n<h2><span color=\"rgba(0, 0, 0, 0.701960784313725)\" style=\"color: rgba(0, 0, 0, 0.7);\">35 هزارتومان </span>اینترنت ADSL</h2>[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_font_size=\"18px\" text_line_height=\"2em\" text_orientation=\"center\" background_layout=\"dark\" max_width=\"800px\" module_alignment=\"center\" text_font_size_tablet=\"16px\" text_font_size_phone=\"14px\" text_font_size_last_edited=\"on|phone\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>[/et_pb_text][et_pb_button button_text=\"مشاهده تمام پلن های اینترنتی\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#0c71c3\" button_bg_enable_color__hover=\"on\" button_text_color__hover_enabled=\"on|hover\" button_text_color__hover=\"#ffffff\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Login\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(242,245,250,0)\" background_color_gradient_end=\"#f2f5fa\" background_color_gradient_direction=\"90deg\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_padding=\"0|0px|0|0px|false|false\" border_radii=\"on|60px|60px|60px|60px\"][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_font_size=\"20px\" link_font=\"||||||||\" link_text_color=\"#0492ff\" transform_translate_linked__hover=\"off\" text_orientation=\"center\" text_text_shadow_style=\"preset1\" text_text_shadow_color=\"#7cda24\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate__hover=\"-50px|0px\" content__hover_enabled=\"on|hover\" content__hover=\"<p><a href=%22#%22><strong>کلیک نمایید</strong></a></p>\n\"]<p>آماده اید ؟  جهت عضویت <a href=\"#\"><strong>اینجا را کلیک نمایید</strong></a></p>[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Value\" _builder_version=\"3.22\"][et_pb_row _builder_version=\"3.25\" custom_padding=\"||||false|false\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"40px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#0492ff\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>چرا انتخاب ما ؟</h2>[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" padding_top_bottom_link_1=\"false\" padding_top_bottom_link_2=\"false\" padding_top_bottom_link_3=\"false\" padding_left_right_link_1=\"true\" padding_left_right_link_2=\"true\" padding_left_right_link_3=\"true\" _builder_version=\"3.25\" max_width=\"1160px\" custom_padding=\"0|0px|27px|0px|false|false\" use_custom_width=\"on\" custom_width_px=\"1160px\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\" max_width__hover=\"1080px\" max_width__hover_enabled=\"1080px\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-03.png\" background_size=\"contain\" background_position=\"bottom_right\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"دریافت سرعت واقعی\" use_icon=\"on\" font_icon=\"%%243%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|hover\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"0deg|330deg|0deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"20 درصد تخفیف\" use_icon=\"on\" font_icon=\"%%171%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"0deg|0deg|330deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-04.png\" background_size=\"contain\" background_position=\"top_right\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"بدون محدودیت حجمی\" use_icon=\"on\" font_icon=\"%%231%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"330deg|0deg|0deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است </span></p>[/et_pb_blurb][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Features\" _builder_version=\"3.22\" background_color=\"#f2f5fa\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_padding=\"54px|0px|0|0px|false|false\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row column_structure=\"3_5,2_5\" _builder_version=\"3.25\" custom_margin=\"100px||100px||true\" custom_margin_tablet=\"40px||40px||true\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\"][et_pb_column type=\"3_5\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/04/isp-01.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"|||-7vw\" custom_margin_tablet=\"|||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\"][/et_pb_image][/et_pb_column][et_pb_column type=\"2_5\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>انتخاب شماره 1# کاربران برای اینترنت  فیبر نوری</h2>\n<h3></h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span></p>[/et_pb_text][et_pb_blurb title=\"بدون قعطی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"2em\" custom_margin=\"||20px\"][/et_pb_blurb][et_pb_blurb title=\"سرعت تا 65 مگابایت\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"2em\" custom_margin=\"||20px\"][/et_pb_blurb][et_pb_blurb title=\"شامل مودم رایگان\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"2em\" custom_margin=\"||20px\"][/et_pb_blurb][et_pb_button button_text=\"مشاهده پلن های اینترنت\" button_alignment=\"left\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#7cda24\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" custom_margin=\"100px||100px||true\" custom_margin_tablet=\"40px||40px||true\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"14px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>داده نامحدود ،پشتیبانی شبانه روزی و سرویس پیامکی</h2>\n<h3>همه موارد را برای داشتن خطوط پیامکی موفق برای شما فراهم کرده ایم</h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد</span></p>[/et_pb_text][et_pb_button button_text=\"مشاهده پلن های پیامکی\" button_alignment=\"left\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#7cda24\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/04/isp-02.jpg\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"|-7vw||\" custom_margin_tablet=\"|0vw||\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\" border_radii=\"on|30px|30px|30px|30px\"][/et_pb_image][/et_pb_column][/et_pb_row][et_pb_row custom_padding_last_edited=\"on|tablet\" _builder_version=\"4.4.2\" background_color=\"#ffffff\" max_width=\"80%\" module_alignment=\"right\" custom_margin=\"||\" custom_padding=\"60px|60px|||false|false\" custom_padding_tablet=\"|40px||40px\" custom_padding_phone=\"\" animation_style=\"slide\" animation_direction=\"right\" animation_intensity_slide=\"10%\" border_radii=\"|30px|||\" use_custom_width=\"on\" width_unit=\"off\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>محبوب ترین خدمات</h2>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد</span></p>[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Categories\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(242,245,250,0)\" background_color_gradient_end=\"#f2f5fa\" background_color_gradient_direction=\"90deg\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||60px\" custom_margin_tablet=\"||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|desktop\" custom_padding=\"0||0px||false|false\" border_radii=\"on|60px|60px|60px|60px\" locked=\"off\"][et_pb_row column_structure=\"1_6,1_6,1_6,1_6,1_6,1_6\" use_custom_gutter=\"on\" gutter_width=\"2\" _builder_version=\"3.25\" locked=\"off\"][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#ffffff\" text_orientation=\"center\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" locked=\"off\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" box_shadow_color__hover_enabled=\"on\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\" background_layout__hover_enabled=\"on\" background_layout__hover=\"dark\"]<p>پیامک</p>[/et_pb_text][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"Poppins|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#a0cf00\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" locked=\"off\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" box_shadow_color__hover_enabled=\"on\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\"]<p>ADSL</p>[/et_pb_text][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#008a1c\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" box_shadow_color__hover_enabled=\"on\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\"]<p>وایرلس</p>[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Pricing\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||||false\" custom_padding=\"80px||80px||true\" animation_style=\"slide\" animation_direction=\"bottom\" animation_intensity_slide=\"1%\" border_radii=\"on|30px|30px|30px|30px\" locked=\"off\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\"][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"40px|||\" custom_padding_tablet=\"0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px||\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#ffffff\" price_text_color=\"rgba(0,0,0,0.75)\" body_text_color=\"#ffffff\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"||||||||\" body_text_align=\"center\" subheader_font=\"|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"||on||||||\" price_font_size=\"50px\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(255,255,255,0)\" background_color_gradient_end=\"rgba(255,255,255,0.16)\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" transform_translate_linked__hover=\"off\" animation_style=\"slide\" animation_direction=\"right\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate__hover=\"0px|-70px\"][et_pb_pricing_table title=\"اینترنت پایه\" subtitle=\"1 مگابایت\" currency=\"یک ساله \" per=\"هزارتومان\" sum=\"35\" button_url=\"#\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" header_level=\"h2\" header_font=\"||||||||\" body_font=\"VAZIR FARSI||||||||\" subheader_font=\"|800|||||||\" price_font=\"|800|on||||||\" price_letter_spacing=\"0px\" price_line_height=\"100px\" currency_frequency_font=\"|700|on||||||\" currency_frequency_line_height=\"1em\" excluded_text_color=\"rgba(255,255,255,0.5)\" custom_button=\"on\" button_font=\"VAZIR FARSI||||||||\" pricing_item_excluded_color=\"rgba(255,255,255,0.5)\"]<p>+ گارانتی سرعت</p>\n<p>+ گارنتی کیفیت</p>\n<p>+ نصب در محل</p>\n<p>- تنظیم مودم</p>\n<p>- پشتیبانی 24 ساعته</p>[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#a0cf00\" price_text_color=\"rgba(0,0,0,0.75)\" subheader_text_color=\"#000000\" header_text_color=\"#000000\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"Poppins||||||||\" body_text_align=\"center\" subheader_font=\"Poppins|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"|800|on||||||\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#ffffff\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#008a1c\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" transform_translate_linked__hover=\"off\" custom_margin=\"0px||\" animation_style=\"zoom\" animation_delay=\"100ms\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" border_color_all=\"#ffffff\" border_width_top=\"40px\" border_width_bottom=\"30px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" locked=\"off\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate__hover=\"0px|-70px\"][et_pb_pricing_table title=\"سرویس محبوب\" subtitle=\"65 مگابایت\" currency=\"سالانه\" per=\"هزارتومان\" sum=\"99\" button_url=\"#\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" header_level=\"h2\" header_font=\"||||||||\" body_font=\"VAZIR FARSI||||||||\" subheader_font=\"VAZIR FARSI|800|||||||\" price_font=\"VAZIR FARSI|800|on||||||\" price_font_size=\"50px\" price_line_height=\"100px\" custom_button=\"on\" button_font=\"VAZIR FARSI||||||||\"]<p>+ سرعت دانلود تا 65 مگابایت</p>\n<p>+ دانلود نامحدود</p>\n<p>+ پشتیبانی شبانه روزی</p>\n<p>+ مودم رایگان</p>\n<p>+ نصب رایگان</p>[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"40px|||\" custom_padding_tablet=\"0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|desktop\" padding_tablet=\"0px||\" padding_last_edited=\"on|desktop\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#ffffff\" price_text_color=\"rgba(0,0,0,0.75)\" body_text_color=\"#ffffff\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"||||||||\" body_text_align=\"center\" subheader_font=\"|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"||on||||||\" price_font_size=\"50px\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(255,255,255,0)\" background_color_gradient_end=\"rgba(255,255,255,0.16)\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" transform_translate_linked__hover=\"off\" animation_style=\"slide\" animation_direction=\"right\" price_letter_spacing_tablet=\"\" price_letter_spacing_phone=\"\" price_letter_spacing_last_edited=\"on|desktop\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" locked=\"off\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate__hover=\"0px|-70px\"][et_pb_pricing_table title=\"اینترنت حرفه ای\" subtitle=\"120 مگابایت\" currency=\"یک ساله \" per=\"هزارتومان\" sum=\"900\" button_url=\"#\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" header_level=\"h2\" header_font=\"||||||||\" body_font=\"VAZIR FARSI||||||||\" subheader_font=\"|800|||||||\" price_font=\"VAZIR FARSI||on||||||\" price_letter_spacing=\"0px\" price_line_height=\"100px\" currency_frequency_font=\"|700|on||||||\" currency_frequency_line_height=\"1em\" excluded_text_color=\"rgba(255,255,255,0.5)\" custom_button=\"on\" button_font=\"VAZIR FARSI||||||||\" pricing_item_excluded_color=\"rgba(255,255,255,0.5)\"]<p>+ گارانتی سرعت</p>\n<p>+ گارنتی کیفیت</p>\n<p>+ نصب در محل</p>\n<p>- تنظیم مودم</p>\n<p>- پشتیبانی 24 ساعته</p>[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Blog\" _builder_version=\"3.22\"][et_pb_row _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#0492ff\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>آخرین مقالات از وبلاگ ما</h2>[/et_pb_text][et_pb_blog fullwidth=\"off\" posts_number=\"3\" include_categories=\"70\" show_pagination=\"off\" _builder_version=\"4.4.2\" header_font=\"Poppins|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_line_height=\"2em\" meta_font=\"Poppins||||||||\" meta_text_color=\"#008a1c\" pagination_font=\"Poppins|700|on||||||\" pagination_text_color=\"#008a1c\" pagination_font_size=\"18px\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" show_categories=\"off\" use_overlay=\"on\" hover_icon=\"%%10%%\" hover_overlay_color=\"rgba(124,218,36,0.59)\" transform_styles__hover_enabled=\"off|hover\" transform_scale__hover_enabled=\"off|hover\" transform_translate__hover_enabled=\"off|hover\" transform_rotate__hover_enabled=\"off|hover\" transform_skew__hover_enabled=\"off|hover\" transform_origin__hover_enabled=\"off|hover\" transform_translate__hover=\"30px|30px\" animation_style=\"zoom\"][/et_pb_blog][et_pb_button button_text=\"رفتن به وبلاگ\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#7cda24\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonials\" _builder_version=\"3.22\"][et_pb_row column_structure=\"2_5,3_5\" padding_top_bottom_link_1=\"true\" padding_top_bottom_link_2=\"true\" padding_left_right_link_1=\"false\" padding_left_right_link_2=\"false\" _builder_version=\"3.25\" custom_padding=\"0||0||false|false\"][et_pb_column type=\"2_5\" _builder_version=\"3.25\" custom_padding=\"60px|60px|60px|\" custom_padding_tablet=\"0px||0px||true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px||0px||true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>مشتریان در مورد ما چه می گویند ؟</h2>\n<h3>بهترین شرکت خدمات اینترنتی از دید مشتریان در سال های اخیر</h3>[/et_pb_text][/et_pb_column][et_pb_column type=\"3_5\" _builder_version=\"3.25\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/handyman_11.png\" background_size=\"initial\" background_position=\"bottom_right\" custom_padding=\"60px|60px|60px|\" custom_padding_tablet=\"40px|40px|40px|40px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"40px|40px|40px|40px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_testimonial author=\"مشتری از سال 1390\" quote_icon=\"off\" _builder_version=\"4.4.2\" body_font=\"||on||||||\" body_font_size=\"14px\" body_line_height=\"2em\" background_color=\"#ffffff\" transform_translate_linked__hover=\"off\" custom_margin=\"|||-40px\" custom_margin_tablet=\"|||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|desktop\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0.15)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate__hover=\"-50px|0px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span>\"</p>[/et_pb_testimonial][et_pb_testimonial author=\"مشتری جدید\" quote_icon=\"off\" _builder_version=\"4.4.2\" body_font=\"||on||||||\" body_font_size=\"14px\" body_line_height=\"2em\" background_color=\"#ffffff\" transform_translate_linked__hover=\"off\" custom_margin=\"|||-40px\" custom_margin_tablet=\"|||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|desktop\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0.15)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate__hover=\"-50px|0px\"]<p>\"<span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</span>\"</p>[/et_pb_testimonial][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" prev_background_color=\"#ffffff\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#0f1533\" background_color_gradient_end=\"#1f133a\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||5vw\" custom_padding=\"14vw||10vw\" top_divider_style=\"wave2\" top_divider_height=\"10vw\" top_divider_repeat=\"0.7x\" top_divider_flip=\"vertical\" animation_style=\"fade\" border_radii=\"on|30px|30px|30px|30px\" locked=\"off\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_phone=\"\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_2_font=\"|900|on||||||\" header_2_font_size=\"3.5vw\" header_2_letter_spacing=\"2px\" header_2_line_height=\"1.4em\" header_3_font=\"|900|on|on|||||\" header_3_text_color=\"rgba(255,255,255,0.7)\" header_3_font_size=\"1.5vw\" header_3_letter_spacing=\"0.4em\" header_3_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_font_size__hover=\"30px\" header_font_size__hover_enabled=\"30px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h2>سرعت مورد نظر خود را با قیمتی که می خواهید دریافت کنید</h2>\n<h3>سرویس های ADSL  و سرویس های پیامکی</h3>[/et_pb_text][et_pb_button button_text=\"مشاهده تمام سرویس های ما\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#7cda24\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section]", "خانه", "", "inherit", "closed", "closed", "", "2-revision-v1", "", "", "2020-04-02 13:37:53", "2020-04-02 10:07:53", "", "2", "http://modelsite.test/2-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2963", "1", "2020-04-02 16:33:38", "2020-04-02 13:03:38", "[et_pb_section fb_built=\"1\" admin_label=\"Header\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-05.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"5vw||||false\" custom_padding=\"6vw||10vw||false|false\" bottom_divider_style=\"wave2\" bottom_divider_color=\"#ffffff\" bottom_divider_height=\"10vw\" bottom_divider_repeat=\"0.7x\" animation_style=\"slide\" animation_direction=\"bottom\" animation_intensity_slide=\"1%\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_phone=\"\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" animation_style=\"slide\" animation_direction=\"left\" animation_intensity_slide=\"10%\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_font=\"|900|on|on|||||\" header_font_size=\"6vw\" header_letter_spacing=\"0.1em\" header_line_height=\"1.2em\" header_2_font=\"|900|on|on|||||\" header_2_text_color=\"rgba(255,255,255,0.7)\" header_2_font_size=\"3vw\" header_2_letter_spacing=\"0em\" header_2_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" hover_enabled=\"0\" header_font_size_tablet=\"50px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|phone\" header_2_font_size_tablet=\"30px\" header_2_font_size_phone=\"20px\" header_2_font_size_last_edited=\"on|phone\" header_text_shadow_style=\"preset1\" header_text_shadow_vertical_length=\"0.3em\" header_text_shadow_blur_strength=\"0.5em\" header_text_shadow_color=\"rgba(0,0,0,0.15)\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h1>پلان های اینترنت</h1>\n<p>&nbsp;</p>\n<h2><span color=\"rgba(0, 0, 0, 0.701960784313725)\" style=\"color: rgba(0, 0, 0, 0.7);\">شروع از 35 هزارتومان / سالانه</span></h2>\n[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Features\" _builder_version=\"3.22\"][et_pb_row _builder_version=\"3.25\" custom_padding=\"||||false|false\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#0492ff\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" text_orientation=\"center\" max_width=\"700px\" module_alignment=\"center\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>تمامی سرویس ها شامل:</h2>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" padding_top_bottom_link_1=\"false\" padding_top_bottom_link_2=\"false\" padding_top_bottom_link_3=\"false\" padding_left_right_link_1=\"true\" padding_left_right_link_2=\"true\" padding_left_right_link_3=\"true\" _builder_version=\"3.25\" max_width=\"1160px\" custom_padding=\"0|0px|27px|0px|false|false\" use_custom_width=\"on\" custom_width_px=\"1160px\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\" max_width__hover=\"1080px\" max_width__hover_enabled=\"1080px\" locked=\"off\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-03.png\" background_size=\"contain\" background_position=\"bottom_right\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"دریافت سرعت واقعی\" use_icon=\"on\" font_icon=\"%%243%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|hover\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"0deg|42deg|0deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"20 درصد تخفیف\" use_icon=\"on\" font_icon=\"%%171%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"0deg|0deg|25deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-04.png\" background_size=\"contain\" background_position=\"top_right\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"بدون محدودیت حجمی\" use_icon=\"on\" font_icon=\"%%231%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"330deg|0deg|0deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است </span></p>[/et_pb_blurb][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Pricing\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#0f1533\" background_color_gradient_end=\"#1f133a\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||40px||false\" custom_padding=\"80px||80px||true\" animation_style=\"slide\" animation_direction=\"bottom\" animation_intensity_slide=\"1%\" border_radii=\"on|30px|30px|30px|30px\" locked=\"off\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\"][et_pb_row _builder_version=\"3.25\" custom_padding=\"||||false|false\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_2_font=\"Poppins|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#0492ff\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" text_orientation=\"center\" background_layout=\"dark\" max_width=\"700px\" module_alignment=\"center\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>Internet Plans</h2>\r[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\" locked=\"off\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"40px|||\" custom_padding_tablet=\"0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px||\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#ffffff\" price_text_color=\"rgba(0,0,0,0.75)\" body_text_color=\"#ffffff\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"||||||||\" body_text_align=\"center\" subheader_font=\"|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"||on||||||\" price_font_size=\"50px\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(255,255,255,0)\" background_color_gradient_end=\"rgba(255,255,255,0.16)\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" transform_translate_linked__hover=\"off\" animation_style=\"slide\" animation_direction=\"right\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate__hover=\"0px|-70px\"][et_pb_pricing_table title=\"اینترنت پایه\" subtitle=\"1 مگابایت\" currency=\"یک ساله \" per=\"هزارتومان\" sum=\"35\" button_url=\"#\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" header_level=\"h2\" header_font=\"||||||||\" body_font=\"VAZIR FARSI||||||||\" subheader_font=\"|800|||||||\" price_font=\"|800|on||||||\" price_letter_spacing=\"0px\" price_line_height=\"100px\" currency_frequency_font=\"|700|on||||||\" currency_frequency_line_height=\"1em\" excluded_text_color=\"rgba(255,255,255,0.5)\" custom_button=\"on\" button_font=\"VAZIR FARSI||||||||\" pricing_item_excluded_color=\"rgba(255,255,255,0.5)\"]<p>+ گارانتی سرعت</p>\n<p>+ گارنتی کیفیت</p>\n<p>+ نصب در محل</p>\n<p>- تنظیم مودم</p>\n<p>- پشتیبانی 24 ساعته</p>[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#994ceb\" price_text_color=\"rgba(0,0,0,0.75)\" subheader_text_color=\"#ffffff\" header_text_color=\"#ffffff\" header_font=\"||||||||\" header_font_size=\"14px\" body_font=\"Poppins||||||||\" body_text_align=\"center\" subheader_font=\"|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"|800|on||||||\" currency_frequency_font=\"|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#ffffff\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#8a006e\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" transform_translate_linked__hover=\"off\" custom_margin=\"0px||\" animation_style=\"zoom\" animation_delay=\"100ms\" hover_enabled=\"0\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" border_color_all=\"#ffffff\" border_width_top=\"40px\" border_width_bottom=\"30px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" locked=\"off\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate__hover=\"0px|-70px\" featured_table_header_background_color=\"#ffffff\" featured_table_header_text_color=\"#ffffff\" button_bg_enable_color=\"on\"][et_pb_pricing_table title=\"سرویس محبوب\" subtitle=\"65 مگابایت\" currency=\"سالانه\" per=\"هزارتومان\" sum=\"99\" button_url=\"#\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" header_level=\"h2\" header_font=\"||||||||\" body_font=\"VAZIR FARSI||||||||\" subheader_font=\"VAZIR FARSI|800|||||||\" price_font=\"VAZIR FARSI|800|on||||||\" price_font_size=\"50px\" price_line_height=\"100px\" custom_button=\"on\" button_font=\"VAZIR FARSI||||||||\"]<p>+ سرعت دانلود تا 65 مگابایت</p>\n<p>+ دانلود نامحدود</p>\n<p>+ پشتیبانی شبانه روزی</p>\n<p>+ مودم رایگان</p>\n<p>+ نصب رایگان</p>[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"40px|||\" custom_padding_tablet=\"0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|desktop\" padding_tablet=\"0px||\" padding_last_edited=\"on|desktop\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#ffffff\" price_text_color=\"rgba(0,0,0,0.75)\" body_text_color=\"#ffffff\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"||||||||\" body_text_align=\"center\" subheader_font=\"|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"||on||||||\" price_font_size=\"50px\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(255,255,255,0)\" background_color_gradient_end=\"rgba(255,255,255,0.16)\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" transform_translate_linked__hover=\"off\" animation_style=\"slide\" animation_direction=\"right\" price_letter_spacing_tablet=\"\" price_letter_spacing_phone=\"\" price_letter_spacing_last_edited=\"on|desktop\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" locked=\"off\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate__hover=\"0px|-70px\"][et_pb_pricing_table title=\"اینترنت حرفه ای\" subtitle=\"120 مگابایت\" currency=\"یک ساله \" per=\"هزارتومان\" sum=\"900\" button_url=\"#\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" header_level=\"h2\" header_font=\"||||||||\" body_font=\"VAZIR FARSI||||||||\" subheader_font=\"|800|||||||\" price_font=\"VAZIR FARSI||on||||||\" price_letter_spacing=\"0px\" price_line_height=\"100px\" currency_frequency_font=\"|700|on||||||\" currency_frequency_line_height=\"1em\" excluded_text_color=\"rgba(255,255,255,0.5)\" custom_button=\"on\" button_font=\"VAZIR FARSI||||||||\" pricing_item_excluded_color=\"rgba(255,255,255,0.5)\"]<p>+ گارانتی سرعت</p>\n<p>+ گارنتی کیفیت</p>\n<p>+ نصب در محل</p>\n<p>- تنظیم مودم</p>\n<p>- پشتیبانی 24 ساعته</p>[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Info & Bundles\" _builder_version=\"3.22\" background_color=\"#f2f5fa\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row _builder_version=\"3.25\" custom_margin_tablet=\"40px||40px||true\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" text_orientation=\"center\" max_width=\"700px\" module_alignment=\"center\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>کدام سرویس برای شما مناسب است؟</h2>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_4,1_4,1_4,1_4\" _builder_version=\"3.25\"][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_circle_counter title=\"عادی\" number=\"60mbps\" percent_sign=\"off\" bar_bg_color=\"rgba(48,52,71,0.51)\" _builder_version=\"4.4.2\" title_level=\"h4\" title_font=\"Poppins|700|on||||||\" title_font_size=\"16px\" title_line_height=\"2em\" number_font=\"|700|on||||||\" number_text_color=\"#000000\" number_font_size=\"28px\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\" hover_enabled=\"0\"][/et_pb_circle_counter][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"rgba(48,52,71,0.51)\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" hover_enabled=\"0\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"rgba(48,52,71,0.51)\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" hover_enabled=\"0\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"rgba(48,52,71,0.51)\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" hover_enabled=\"0\" locked=\"off\"][/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_circle_counter title=\"بازی آنلاین\" number=\"85mbps\" percent_sign=\"off\" bar_bg_color=\"#303447\" _builder_version=\"4.4.2\" title_level=\"h4\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"2em\" number_font=\"|700|on||||||\" number_text_color=\"#000000\" number_font_size=\"28px\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\" hover_enabled=\"0\" locked=\"off\"][/et_pb_circle_counter][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#000000\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" hover_enabled=\"0\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#000000\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" hover_enabled=\"0\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#000000\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" hover_enabled=\"0\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#000000\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" hover_enabled=\"0\" locked=\"off\"][/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_circle_counter title=\"چند کاربره\" number=\"120mbps\" percent_sign=\"off\" bar_bg_color=\"#008a1c\" _builder_version=\"4.4.2\" title_level=\"h4\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"2em\" number_font=\"|700|on||||||\" number_text_color=\"#000000\" number_font_size=\"28px\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\" hover_enabled=\"0\" locked=\"off\"][/et_pb_circle_counter][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#008a1c\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" hover_enabled=\"0\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#008a1c\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" hover_enabled=\"0\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#008a1c\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" hover_enabled=\"0\" locked=\"off\"][/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_circle_counter title=\"بهترین برای تجاری ها\" number=\"120mbps\" percent_sign=\"off\" _builder_version=\"4.4.2\" title_level=\"h4\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"2em\" number_font=\"|700|on||||||\" number_text_color=\"#000000\" number_font_size=\"28px\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\" hover_enabled=\"0\" locked=\"off\"][/et_pb_circle_counter][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" hover_enabled=\"0\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" hover_enabled=\"0\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" hover_enabled=\"0\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" hover_enabled=\"0\" locked=\"off\"][/et_pb_blurb][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_button button_text=\"برای انتخاب بیشتر به راهنمایی نیاز دارید؟  1234-021\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" custom_margin=\"100px||\" custom_margin_tablet=\"0px||\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" text_orientation=\"center\" max_width=\"700px\" module_alignment=\"center\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>با بسته های پیامکی بیشتر درآمد کسب کنید</h2>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد</span>.</p>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"3_5,2_5\" _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"3_5\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/04/isp-11.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" module_alignment=\"center\" custom_margin=\"|||-7vw\" custom_margin_tablet=\"|||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\"][/et_pb_image][/et_pb_column][et_pb_column type=\"2_5\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"قیمت ارزانتر\" url=\"#\" use_icon=\"on\" font_icon=\"%%155%%\" use_circle=\"on\" circle_color=\"#ffffff\" icon_placement=\"left\" use_icon_font_size=\"on\" icon_font_size=\"22px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" background_color=\"#303447\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"20px|20px|20px|20px|true|true\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" background__hover_enabled=\"on\" background_color__hover=\"#008a1c\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][et_pb_blurb title=\"سازگار با تمام گوشی ها\" url=\"#\" use_icon=\"on\" font_icon=\"%%104%%\" use_circle=\"on\" circle_color=\"#ffffff\" icon_placement=\"left\" use_icon_font_size=\"on\" icon_font_size=\"22px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" background_color=\"#303447\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"20px|20px|20px|20px|true|true\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" background__hover_enabled=\"on\" background_color__hover=\"#008a1c\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][et_pb_blurb title=\"ارسال به شماره های مسدود\" url=\"#\" use_icon=\"on\" font_icon=\"%%70%%\" use_circle=\"on\" circle_color=\"#ffffff\" icon_placement=\"left\" use_icon_font_size=\"on\" icon_font_size=\"22px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" background_color=\"#303447\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"20px|20px|20px|20px|true|true\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" background__hover_enabled=\"on\" background_color__hover=\"#008a1c\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_button button_text=\"بسته پیشنهادی خود را ایجاد کنید 1234-021\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"FAQ\" _builder_version=\"3.22\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" max_width__hover=\"100%\" max_width__hover_enabled=\"100%\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" inner_shadow__hover=\"off\" inner_shadow__hover_enabled=\"off\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_row _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>سوالات متداول</h2>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_toggle title=\"سوال دلخواه را وارد کنید ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||20px\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>جواب دلخواه این سوال را هم اینجا وارد کنید .</p>\n[/et_pb_toggle][et_pb_toggle title=\"سوال دلخواه را وارد کنید ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||20px\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>جواب دلخواه این سوال را هم اینجا وارد کنید .</p>\n[/et_pb_toggle][et_pb_toggle title=\"سوال دلخواه را وارد کنید ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||20px\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>جواب دلخواه این سوال را هم اینجا وارد کنید .</p>\n[/et_pb_toggle][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_toggle title=\"آیا دانلود شبانه رایگان دارید ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||20px\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>سرویس ها نامحدود هستند و نیازی به شبانه رایگان ندارید </p>\n[/et_pb_toggle][et_pb_toggle title=\"سوال دلخواه را وارد کنید ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||20px\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>جواب دلخواه این سوال را هم اینجا وارد کنید .</p>\n[/et_pb_toggle][et_pb_toggle title=\"سوال دلخواه را وارد کنید ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||20px\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>جواب دلخواه این سوال را هم اینجا وارد کنید .</p>\n[/et_pb_toggle][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_button button_text=\"سوال دیگری دارید پیام بفرستید\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" prev_background_color=\"#ffffff\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#0f1533\" background_color_gradient_end=\"#1f133a\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||5vw\" custom_padding=\"14vw||10vw\" top_divider_style=\"wave2\" top_divider_height=\"10vw\" top_divider_repeat=\"0.7x\" top_divider_flip=\"vertical\" animation_style=\"fade\" border_radii=\"on|30px|30px|30px|30px\" locked=\"off\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_phone=\"\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_2_font=\"|900|on||||||\" header_2_font_size=\"3.5vw\" header_2_letter_spacing=\"2px\" header_2_line_height=\"1.4em\" header_3_font=\"|900|on|on|||||\" header_3_text_color=\"rgba(255,255,255,0.7)\" header_3_font_size=\"1.5vw\" header_3_letter_spacing=\"0.4em\" header_3_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_font_size__hover=\"30px\" header_font_size__hover_enabled=\"30px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h2>سرعت مورد نظر خود را با قیمتی که می خواهید دریافت کنید</h2>\n<h3>سرویس های ADSL  و سرویس های پیامکی</h3>[/et_pb_text][et_pb_button button_text=\"مشاهده تمام سرویس های ما\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#7cda24\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section]", "خدمات", "", "inherit", "closed", "closed", "", "899-revision-v1", "", "", "2020-04-02 16:33:38", "2020-04-02 13:03:38", "", "899", "http://modelsite.test/899-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2965", "1", "2020-04-02 16:38:13", "2020-04-02 13:08:13", "[et_pb_section fb_built=\"1\" admin_label=\"Header\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-05.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"5vw||||false\" custom_padding=\"6vw||10vw||false|false\" bottom_divider_style=\"wave2\" bottom_divider_color=\"#ffffff\" bottom_divider_height=\"10vw\" bottom_divider_repeat=\"0.7x\" animation_style=\"slide\" animation_direction=\"bottom\" animation_intensity_slide=\"1%\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_phone=\"\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" animation_style=\"slide\" animation_direction=\"left\" animation_intensity_slide=\"10%\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_font=\"|900|on|on|||||\" header_font_size=\"6vw\" header_letter_spacing=\"0.1em\" header_line_height=\"1.2em\" header_2_font=\"|900|on|on|||||\" header_2_text_color=\"rgba(255,255,255,0.7)\" header_2_font_size=\"3vw\" header_2_letter_spacing=\"0em\" header_2_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" hover_enabled=\"0\" header_font_size_tablet=\"50px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|phone\" header_2_font_size_tablet=\"30px\" header_2_font_size_phone=\"20px\" header_2_font_size_last_edited=\"on|phone\" header_text_shadow_style=\"preset1\" header_text_shadow_vertical_length=\"0.3em\" header_text_shadow_blur_strength=\"0.5em\" header_text_shadow_color=\"rgba(0,0,0,0.15)\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h1>پلان های اینترنت</h1>\n<p>&nbsp;</p>\n<h2><span color=\"rgba(0, 0, 0, 0.701960784313725)\" style=\"color: rgba(0, 0, 0, 0.7);\">شروع از 35 هزارتومان / سالانه</span></h2>\n[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Features\" _builder_version=\"3.22\"][et_pb_row _builder_version=\"3.25\" custom_padding=\"||||false|false\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#0492ff\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" text_orientation=\"center\" max_width=\"700px\" module_alignment=\"center\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>تمامی سرویس ها شامل:</h2>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" padding_top_bottom_link_1=\"false\" padding_top_bottom_link_2=\"false\" padding_top_bottom_link_3=\"false\" padding_left_right_link_1=\"true\" padding_left_right_link_2=\"true\" padding_left_right_link_3=\"true\" _builder_version=\"3.25\" max_width=\"1160px\" custom_padding=\"0|0px|27px|0px|false|false\" use_custom_width=\"on\" custom_width_px=\"1160px\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\" max_width__hover=\"1080px\" max_width__hover_enabled=\"1080px\" locked=\"off\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-03.png\" background_size=\"contain\" background_position=\"bottom_right\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"دریافت سرعت واقعی\" use_icon=\"on\" font_icon=\"%%243%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|hover\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"0deg|42deg|0deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"20 درصد تخفیف\" use_icon=\"on\" font_icon=\"%%171%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"0deg|0deg|25deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-04.png\" background_size=\"contain\" background_position=\"top_right\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"بدون محدودیت حجمی\" use_icon=\"on\" font_icon=\"%%231%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"330deg|0deg|0deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است </span></p>[/et_pb_blurb][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Pricing\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#0f1533\" background_color_gradient_end=\"#1f133a\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||40px||false\" custom_padding=\"80px||80px||true\" animation_style=\"slide\" animation_direction=\"bottom\" animation_intensity_slide=\"1%\" border_radii=\"on|30px|30px|30px|30px\" locked=\"off\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\"][et_pb_row _builder_version=\"3.25\" custom_padding=\"||||false|false\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"3.27.4\" text_font=\"||||||||\" text_line_height=\"2em\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_2_font=\"Poppins|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#0492ff\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" text_orientation=\"center\" background_layout=\"dark\" max_width=\"700px\" module_alignment=\"center\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>Internet Plans</h2>\r[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\" locked=\"off\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"40px|||\" custom_padding_tablet=\"0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px||\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#ffffff\" price_text_color=\"rgba(0,0,0,0.75)\" body_text_color=\"#ffffff\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"||||||||\" body_text_align=\"center\" subheader_font=\"|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"||on||||||\" price_font_size=\"50px\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(255,255,255,0)\" background_color_gradient_end=\"rgba(255,255,255,0.16)\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" transform_translate_linked__hover=\"off\" animation_style=\"slide\" animation_direction=\"right\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate__hover=\"0px|-70px\"][et_pb_pricing_table title=\"اینترنت پایه\" subtitle=\"1 مگابایت\" currency=\"یک ساله \" per=\"هزارتومان\" sum=\"35\" button_url=\"#\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" header_level=\"h2\" header_font=\"||||||||\" body_font=\"VAZIR FARSI||||||||\" subheader_font=\"|800|||||||\" price_font=\"|800|on||||||\" price_letter_spacing=\"0px\" price_line_height=\"100px\" currency_frequency_font=\"|700|on||||||\" currency_frequency_line_height=\"1em\" excluded_text_color=\"rgba(255,255,255,0.5)\" custom_button=\"on\" button_font=\"VAZIR FARSI||||||||\" pricing_item_excluded_color=\"rgba(255,255,255,0.5)\"]<p>+ گارانتی سرعت</p>\n<p>+ گارنتی کیفیت</p>\n<p>+ نصب در محل</p>\n<p>- تنظیم مودم</p>\n<p>- پشتیبانی 24 ساعته</p>[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#994ceb\" price_text_color=\"rgba(0,0,0,0.75)\" subheader_text_color=\"#ffffff\" header_text_color=\"#ffffff\" header_font=\"||||||||\" header_font_size=\"14px\" body_font=\"Poppins||||||||\" body_text_align=\"center\" subheader_font=\"|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"|800|on||||||\" currency_frequency_font=\"|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#ffffff\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#8a006e\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" transform_translate_linked__hover=\"off\" custom_margin=\"0px||\" animation_style=\"zoom\" animation_delay=\"100ms\" hover_enabled=\"0\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" border_color_all=\"#ffffff\" border_width_top=\"40px\" border_width_bottom=\"30px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" locked=\"off\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate__hover=\"0px|-70px\" featured_table_header_background_color=\"#ffffff\" featured_table_header_text_color=\"#ffffff\" button_bg_enable_color=\"on\"][et_pb_pricing_table title=\"سرویس محبوب\" subtitle=\"65 مگابایت\" currency=\"سالانه\" per=\"هزارتومان\" sum=\"99\" button_url=\"#\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" header_level=\"h2\" header_font=\"||||||||\" body_font=\"VAZIR FARSI||||||||\" subheader_font=\"VAZIR FARSI|800|||||||\" price_font=\"VAZIR FARSI|800|on||||||\" price_font_size=\"50px\" price_line_height=\"100px\" custom_button=\"on\" button_font=\"VAZIR FARSI||||||||\"]<p>+ سرعت دانلود تا 65 مگابایت</p>\n<p>+ دانلود نامحدود</p>\n<p>+ پشتیبانی شبانه روزی</p>\n<p>+ مودم رایگان</p>\n<p>+ نصب رایگان</p>[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"40px|||\" custom_padding_tablet=\"0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|desktop\" padding_tablet=\"0px||\" padding_last_edited=\"on|desktop\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#ffffff\" price_text_color=\"rgba(0,0,0,0.75)\" body_text_color=\"#ffffff\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"||||||||\" body_text_align=\"center\" subheader_font=\"|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"||on||||||\" price_font_size=\"50px\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(255,255,255,0)\" background_color_gradient_end=\"rgba(255,255,255,0.16)\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" transform_translate_linked__hover=\"off\" animation_style=\"slide\" animation_direction=\"right\" price_letter_spacing_tablet=\"\" price_letter_spacing_phone=\"\" price_letter_spacing_last_edited=\"on|desktop\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" locked=\"off\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate__hover=\"0px|-70px\"][et_pb_pricing_table title=\"اینترنت حرفه ای\" subtitle=\"120 مگابایت\" currency=\"یک ساله \" per=\"هزارتومان\" sum=\"900\" button_url=\"#\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" header_level=\"h2\" header_font=\"||||||||\" body_font=\"VAZIR FARSI||||||||\" subheader_font=\"|800|||||||\" price_font=\"VAZIR FARSI||on||||||\" price_letter_spacing=\"0px\" price_line_height=\"100px\" currency_frequency_font=\"|700|on||||||\" currency_frequency_line_height=\"1em\" excluded_text_color=\"rgba(255,255,255,0.5)\" custom_button=\"on\" button_font=\"VAZIR FARSI||||||||\" pricing_item_excluded_color=\"rgba(255,255,255,0.5)\"]<p>+ گارانتی سرعت</p>\n<p>+ گارنتی کیفیت</p>\n<p>+ نصب در محل</p>\n<p>- تنظیم مودم</p>\n<p>- پشتیبانی 24 ساعته</p>[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Info & Bundles\" _builder_version=\"3.22\" background_color=\"#f2f5fa\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row _builder_version=\"3.25\" custom_margin_tablet=\"40px||40px||true\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" text_orientation=\"center\" max_width=\"700px\" module_alignment=\"center\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>کدام سرویس برای شما مناسب است؟</h2>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_4,1_4,1_4,1_4\" _builder_version=\"3.25\"][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_circle_counter title=\"عادی\" number=\"60mbps\" percent_sign=\"off\" bar_bg_color=\"rgba(48,52,71,0.51)\" _builder_version=\"4.4.2\" title_level=\"h4\" title_font=\"Poppins|700|on||||||\" title_font_size=\"16px\" title_line_height=\"2em\" number_font=\"|700|on||||||\" number_text_color=\"#000000\" number_font_size=\"28px\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\" hover_enabled=\"0\"][/et_pb_circle_counter][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"rgba(48,52,71,0.51)\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" hover_enabled=\"0\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"rgba(48,52,71,0.51)\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" hover_enabled=\"0\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"rgba(48,52,71,0.51)\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" hover_enabled=\"0\" locked=\"off\"][/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_circle_counter title=\"بازی آنلاین\" number=\"85mbps\" percent_sign=\"off\" bar_bg_color=\"#303447\" _builder_version=\"4.4.2\" title_level=\"h4\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"2em\" number_font=\"|700|on||||||\" number_text_color=\"#000000\" number_font_size=\"28px\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\" hover_enabled=\"0\" locked=\"off\"][/et_pb_circle_counter][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#000000\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" hover_enabled=\"0\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#000000\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" hover_enabled=\"0\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#000000\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" hover_enabled=\"0\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#000000\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" hover_enabled=\"0\" locked=\"off\"][/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_circle_counter title=\"چند کاربره\" number=\"120mbps\" percent_sign=\"off\" bar_bg_color=\"#008a1c\" _builder_version=\"4.4.2\" title_level=\"h4\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"2em\" number_font=\"|700|on||||||\" number_text_color=\"#000000\" number_font_size=\"28px\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\" hover_enabled=\"0\" locked=\"off\"][/et_pb_circle_counter][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#008a1c\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" hover_enabled=\"0\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#008a1c\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" hover_enabled=\"0\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#008a1c\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" hover_enabled=\"0\" locked=\"off\"][/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_circle_counter title=\"بهترین برای تجاری ها\" number=\"120mbps\" percent_sign=\"off\" _builder_version=\"4.4.2\" title_level=\"h4\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"2em\" number_font=\"|700|on||||||\" number_text_color=\"#000000\" number_font_size=\"28px\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\" hover_enabled=\"0\" locked=\"off\" background__hover_enabled=\"on|hover\" use_background_color_gradient__hover=\"off\" background_color_gradient_start__hover=\"#a0cf00\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_type__hover=\"radial\"][/et_pb_circle_counter][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" hover_enabled=\"0\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" hover_enabled=\"0\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" hover_enabled=\"0\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" hover_enabled=\"0\" locked=\"off\"][/et_pb_blurb][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_button button_text=\"برای انتخاب بیشتر به راهنمایی نیاز دارید؟  1234-021\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover=\"#7cda24\" button_bg_color__hover_enabled=\"on|hover\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" custom_margin=\"100px||\" custom_margin_tablet=\"0px||\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" text_orientation=\"center\" max_width=\"700px\" module_alignment=\"center\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>با بسته های پیامکی بیشتر درآمد کسب کنید</h2>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد</span>.</p>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"3_5,2_5\" _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"3_5\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/04/isp-11.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" module_alignment=\"center\" custom_margin=\"|||-7vw\" custom_margin_tablet=\"|||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\"][/et_pb_image][/et_pb_column][et_pb_column type=\"2_5\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"قیمت ارزانتر\" url=\"#\" use_icon=\"on\" font_icon=\"%%155%%\" use_circle=\"on\" circle_color=\"#ffffff\" icon_placement=\"left\" use_icon_font_size=\"on\" icon_font_size=\"22px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" background_color=\"#303447\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"20px|20px|20px|20px|true|true\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" background__hover_enabled=\"on\" background_color__hover=\"#008a1c\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][et_pb_blurb title=\"سازگار با تمام گوشی ها\" url=\"#\" use_icon=\"on\" font_icon=\"%%104%%\" use_circle=\"on\" circle_color=\"#ffffff\" icon_placement=\"left\" use_icon_font_size=\"on\" icon_font_size=\"22px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" background_color=\"#303447\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"20px|20px|20px|20px|true|true\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" background__hover_enabled=\"on\" background_color__hover=\"#008a1c\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][et_pb_blurb title=\"ارسال به شماره های مسدود\" url=\"#\" use_icon=\"on\" font_icon=\"%%70%%\" use_circle=\"on\" circle_color=\"#ffffff\" icon_placement=\"left\" use_icon_font_size=\"on\" icon_font_size=\"22px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" background_color=\"#303447\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"20px|20px|20px|20px|true|true\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" background__hover_enabled=\"on\" background_color__hover=\"#008a1c\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_button button_text=\"بسته پیشنهادی خود را ایجاد کنید 1234-021\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover=\"#7cda24\" button_bg_color__hover_enabled=\"on|hover\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"FAQ\" _builder_version=\"3.22\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" max_width__hover=\"100%\" max_width__hover_enabled=\"100%\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" inner_shadow__hover=\"off\" inner_shadow__hover_enabled=\"off\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_row _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>سوالات متداول</h2>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_toggle title=\"سوال دلخواه را وارد کنید ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||20px\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>جواب دلخواه این سوال را هم اینجا وارد کنید .</p>\n[/et_pb_toggle][et_pb_toggle title=\"سوال دلخواه را وارد کنید ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||20px\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>جواب دلخواه این سوال را هم اینجا وارد کنید .</p>\n[/et_pb_toggle][et_pb_toggle title=\"سوال دلخواه را وارد کنید ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||20px\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>جواب دلخواه این سوال را هم اینجا وارد کنید .</p>\n[/et_pb_toggle][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_toggle title=\"آیا دانلود شبانه رایگان دارید ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||20px\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>سرویس ها نامحدود هستند و نیازی به شبانه رایگان ندارید </p>\n[/et_pb_toggle][et_pb_toggle title=\"سوال دلخواه را وارد کنید ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||20px\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>جواب دلخواه این سوال را هم اینجا وارد کنید .</p>\n[/et_pb_toggle][et_pb_toggle title=\"سوال دلخواه را وارد کنید ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||20px\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>جواب دلخواه این سوال را هم اینجا وارد کنید .</p>\n[/et_pb_toggle][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_button button_text=\"سوال دیگری دارید پیام بفرستید\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover=\"#7cda24\" button_bg_color__hover_enabled=\"on|hover\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" prev_background_color=\"#ffffff\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#0f1533\" background_color_gradient_end=\"#1f133a\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||5vw\" custom_padding=\"14vw||10vw\" top_divider_style=\"wave2\" top_divider_height=\"10vw\" top_divider_repeat=\"0.7x\" top_divider_flip=\"vertical\" animation_style=\"fade\" border_radii=\"on|30px|30px|30px|30px\" locked=\"off\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_phone=\"\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_2_font=\"|900|on||||||\" header_2_font_size=\"3.5vw\" header_2_letter_spacing=\"2px\" header_2_line_height=\"1.4em\" header_3_font=\"|900|on|on|||||\" header_3_text_color=\"rgba(255,255,255,0.7)\" header_3_font_size=\"1.5vw\" header_3_letter_spacing=\"0.4em\" header_3_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_font_size__hover=\"30px\" header_font_size__hover_enabled=\"30px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h2>سرعت مورد نظر خود را با قیمتی که می خواهید دریافت کنید</h2>\n<h3>سرویس های ADSL  و سرویس های پیامکی</h3>[/et_pb_text][et_pb_button button_text=\"مشاهده تمام سرویس های ما\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#7cda24\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section]", "خدمات", "", "inherit", "closed", "closed", "", "899-revision-v1", "", "", "2020-04-02 16:38:13", "2020-04-02 13:08:13", "", "899", "http://modelsite.test/899-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2967", "1", "2020-04-02 16:42:22", "2020-04-02 13:12:22", "[et_pb_section fb_built=\"1\" admin_label=\"Header\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-05.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"5vw||||false\" custom_padding=\"6vw||10vw||false|false\" bottom_divider_style=\"wave2\" bottom_divider_color=\"#ffffff\" bottom_divider_height=\"10vw\" bottom_divider_repeat=\"0.7x\" animation_style=\"slide\" animation_direction=\"bottom\" animation_intensity_slide=\"1%\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_phone=\"\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" animation_style=\"slide\" animation_direction=\"left\" animation_intensity_slide=\"10%\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_font=\"|900|on|on|||||\" header_font_size=\"6vw\" header_letter_spacing=\"0.1em\" header_line_height=\"1.2em\" header_2_font=\"|900|on|on|||||\" header_2_text_color=\"rgba(255,255,255,0.7)\" header_2_font_size=\"3vw\" header_2_letter_spacing=\"0em\" header_2_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" hover_enabled=\"0\" header_font_size_tablet=\"50px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|phone\" header_2_font_size_tablet=\"30px\" header_2_font_size_phone=\"20px\" header_2_font_size_last_edited=\"on|phone\" header_text_shadow_style=\"preset1\" header_text_shadow_vertical_length=\"0.3em\" header_text_shadow_blur_strength=\"0.5em\" header_text_shadow_color=\"rgba(0,0,0,0.15)\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h1>پلان های اینترنت</h1>\n<p>&nbsp;</p>\n<h2><span color=\"rgba(0, 0, 0, 0.701960784313725)\" style=\"color: rgba(0, 0, 0, 0.7);\">شروع از 35 هزارتومان / سالانه</span></h2>\n[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Features\" _builder_version=\"3.22\"][et_pb_row _builder_version=\"3.25\" custom_padding=\"||||false|false\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#0492ff\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" text_orientation=\"center\" max_width=\"700px\" module_alignment=\"center\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>تمامی سرویس ها شامل:</h2>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" padding_top_bottom_link_1=\"false\" padding_top_bottom_link_2=\"false\" padding_top_bottom_link_3=\"false\" padding_left_right_link_1=\"true\" padding_left_right_link_2=\"true\" padding_left_right_link_3=\"true\" _builder_version=\"3.25\" max_width=\"1160px\" custom_padding=\"0|0px|27px|0px|false|false\" use_custom_width=\"on\" custom_width_px=\"1160px\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\" max_width__hover=\"1080px\" max_width__hover_enabled=\"1080px\" locked=\"off\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-03.png\" background_size=\"contain\" background_position=\"bottom_right\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"دریافت سرعت واقعی\" use_icon=\"on\" font_icon=\"%%243%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|hover\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"0deg|42deg|0deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"20 درصد تخفیف\" use_icon=\"on\" font_icon=\"%%171%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"0deg|0deg|25deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-04.png\" background_size=\"contain\" background_position=\"top_right\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"بدون محدودیت حجمی\" use_icon=\"on\" font_icon=\"%%231%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"330deg|0deg|0deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است </span></p>[/et_pb_blurb][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Pricing\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#0f1533\" background_color_gradient_end=\"#1f133a\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||40px||false\" custom_padding=\"80px||80px||true\" animation_style=\"slide\" animation_direction=\"bottom\" animation_intensity_slide=\"1%\" border_radii=\"on|30px|30px|30px|30px\" locked=\"off\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\"][et_pb_row _builder_version=\"3.25\" custom_padding=\"||||false|false\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#0492ff\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" text_orientation=\"center\" background_layout=\"dark\" max_width=\"700px\" module_alignment=\"center\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>سرویس های اینترنت</h2>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\" locked=\"off\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"40px|||\" custom_padding_tablet=\"0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px||\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#ffffff\" price_text_color=\"rgba(0,0,0,0.75)\" body_text_color=\"#ffffff\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"||||||||\" body_text_align=\"center\" subheader_font=\"|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"||on||||||\" price_font_size=\"50px\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(255,255,255,0)\" background_color_gradient_end=\"rgba(255,255,255,0.16)\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" transform_translate_linked__hover=\"off\" animation_style=\"slide\" animation_direction=\"right\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate__hover=\"0px|-70px\"][et_pb_pricing_table title=\"اینترنت پایه\" subtitle=\"1 مگابایت\" currency=\"یک ساله \" per=\"هزارتومان\" sum=\"35\" button_url=\"#\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" header_level=\"h2\" header_font=\"||||||||\" body_font=\"VAZIR FARSI||||||||\" subheader_font=\"|800|||||||\" price_font=\"|800|on||||||\" price_letter_spacing=\"0px\" price_line_height=\"100px\" currency_frequency_font=\"|700|on||||||\" currency_frequency_line_height=\"1em\" excluded_text_color=\"rgba(255,255,255,0.5)\" custom_button=\"on\" button_font=\"VAZIR FARSI||||||||\" pricing_item_excluded_color=\"rgba(255,255,255,0.5)\"]<p>+ گارانتی سرعت</p>\n<p>+ گارنتی کیفیت</p>\n<p>+ نصب در محل</p>\n<p>- تنظیم مودم</p>\n<p>- پشتیبانی 24 ساعته</p>[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#994ceb\" price_text_color=\"rgba(0,0,0,0.75)\" subheader_text_color=\"#ffffff\" header_text_color=\"#ffffff\" header_font=\"||||||||\" header_font_size=\"14px\" body_font=\"Poppins||||||||\" body_text_align=\"center\" subheader_font=\"|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"|800|on||||||\" currency_frequency_font=\"|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#ffffff\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#8a006e\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" transform_translate_linked__hover=\"off\" custom_margin=\"0px||\" animation_style=\"zoom\" animation_delay=\"100ms\" hover_enabled=\"0\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" border_color_all=\"#ffffff\" border_width_top=\"40px\" border_width_bottom=\"30px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" locked=\"off\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate__hover=\"0px|-70px\" featured_table_header_background_color=\"#ffffff\" featured_table_header_text_color=\"#ffffff\" button_bg_enable_color=\"on\"][et_pb_pricing_table title=\"سرویس محبوب\" subtitle=\"65 مگابایت\" currency=\"سالانه\" per=\"هزارتومان\" sum=\"99\" button_url=\"#\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" header_level=\"h2\" header_font=\"||||||||\" body_font=\"VAZIR FARSI||||||||\" subheader_font=\"VAZIR FARSI|800|||||||\" price_font=\"VAZIR FARSI|800|on||||||\" price_font_size=\"50px\" price_line_height=\"100px\" custom_button=\"on\" button_font=\"VAZIR FARSI||||||||\"]<p>+ سرعت دانلود تا 65 مگابایت</p>\n<p>+ دانلود نامحدود</p>\n<p>+ پشتیبانی شبانه روزی</p>\n<p>+ مودم رایگان</p>\n<p>+ نصب رایگان</p>[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"40px|||\" custom_padding_tablet=\"0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|desktop\" padding_tablet=\"0px||\" padding_last_edited=\"on|desktop\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#ffffff\" price_text_color=\"rgba(0,0,0,0.75)\" body_text_color=\"#ffffff\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"||||||||\" body_text_align=\"center\" subheader_font=\"|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"||on||||||\" price_font_size=\"50px\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(255,255,255,0)\" background_color_gradient_end=\"rgba(255,255,255,0.16)\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" transform_translate_linked__hover=\"off\" animation_style=\"slide\" animation_direction=\"right\" price_letter_spacing_tablet=\"\" price_letter_spacing_phone=\"\" price_letter_spacing_last_edited=\"on|desktop\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" locked=\"off\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate__hover=\"0px|-70px\"][et_pb_pricing_table title=\"اینترنت حرفه ای\" subtitle=\"120 مگابایت\" currency=\"یک ساله \" per=\"هزارتومان\" sum=\"900\" button_url=\"#\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" header_level=\"h2\" header_font=\"||||||||\" body_font=\"VAZIR FARSI||||||||\" subheader_font=\"|800|||||||\" price_font=\"VAZIR FARSI||on||||||\" price_letter_spacing=\"0px\" price_line_height=\"100px\" currency_frequency_font=\"|700|on||||||\" currency_frequency_line_height=\"1em\" excluded_text_color=\"rgba(255,255,255,0.5)\" custom_button=\"on\" button_font=\"VAZIR FARSI||||||||\" pricing_item_excluded_color=\"rgba(255,255,255,0.5)\"]<p>+ گارانتی سرعت</p>\n<p>+ گارنتی کیفیت</p>\n<p>+ نصب در محل</p>\n<p>- تنظیم مودم</p>\n<p>- پشتیبانی 24 ساعته</p>[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Info & Bundles\" _builder_version=\"3.22\" background_color=\"#f2f5fa\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row _builder_version=\"3.25\" custom_margin_tablet=\"40px||40px||true\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" text_orientation=\"center\" max_width=\"700px\" module_alignment=\"center\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>کدام سرویس برای شما مناسب است؟</h2>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_4,1_4,1_4,1_4\" _builder_version=\"3.25\"][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_circle_counter title=\"عادی\" number=\"60mbps\" percent_sign=\"off\" bar_bg_color=\"rgba(48,52,71,0.51)\" _builder_version=\"4.4.2\" title_level=\"h4\" title_font=\"Poppins|700|on||||||\" title_font_size=\"16px\" title_line_height=\"2em\" number_font=\"|700|on||||||\" number_text_color=\"#000000\" number_font_size=\"28px\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\" hover_enabled=\"0\"][/et_pb_circle_counter][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"rgba(48,52,71,0.51)\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" hover_enabled=\"0\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"rgba(48,52,71,0.51)\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" hover_enabled=\"0\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"rgba(48,52,71,0.51)\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" hover_enabled=\"0\" locked=\"off\"][/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_circle_counter title=\"بازی آنلاین\" number=\"85mbps\" percent_sign=\"off\" bar_bg_color=\"#303447\" _builder_version=\"4.4.2\" title_level=\"h4\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"2em\" number_font=\"|700|on||||||\" number_text_color=\"#000000\" number_font_size=\"28px\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\" hover_enabled=\"0\" locked=\"off\"][/et_pb_circle_counter][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#000000\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" hover_enabled=\"0\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#000000\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" hover_enabled=\"0\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#000000\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" hover_enabled=\"0\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#000000\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" hover_enabled=\"0\" locked=\"off\"][/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_circle_counter title=\"چند کاربره\" number=\"120mbps\" percent_sign=\"off\" bar_bg_color=\"#008a1c\" _builder_version=\"4.4.2\" title_level=\"h4\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"2em\" number_font=\"|700|on||||||\" number_text_color=\"#000000\" number_font_size=\"28px\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\" hover_enabled=\"0\" locked=\"off\"][/et_pb_circle_counter][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#008a1c\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" hover_enabled=\"0\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#008a1c\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" hover_enabled=\"0\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#008a1c\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" hover_enabled=\"0\" locked=\"off\"][/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_circle_counter title=\"بهترین برای تجاری ها\" number=\"120mbps\" percent_sign=\"off\" _builder_version=\"4.4.2\" title_level=\"h4\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"2em\" number_font=\"|700|on||||||\" number_text_color=\"#000000\" number_font_size=\"28px\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\" hover_enabled=\"0\" locked=\"off\" background__hover_enabled=\"on|hover\" use_background_color_gradient__hover=\"off\" background_color_gradient_start__hover=\"#a0cf00\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_type__hover=\"radial\"][/et_pb_circle_counter][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" hover_enabled=\"0\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" hover_enabled=\"0\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" hover_enabled=\"0\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" hover_enabled=\"0\" locked=\"off\"][/et_pb_blurb][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_button button_text=\"برای انتخاب بیشتر به راهنمایی نیاز دارید؟  1234-021\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover=\"#7cda24\" button_bg_color__hover_enabled=\"on|hover\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" custom_margin=\"100px||\" custom_margin_tablet=\"0px||\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" text_orientation=\"center\" max_width=\"700px\" module_alignment=\"center\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>با بسته های پیامکی بیشتر درآمد کسب کنید</h2>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد</span>.</p>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"3_5,2_5\" _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"3_5\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/04/isp-11.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" module_alignment=\"center\" custom_margin=\"|||-7vw\" custom_margin_tablet=\"|||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\"][/et_pb_image][/et_pb_column][et_pb_column type=\"2_5\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"قیمت ارزانتر\" url=\"#\" use_icon=\"on\" font_icon=\"%%155%%\" use_circle=\"on\" circle_color=\"#ffffff\" icon_placement=\"left\" use_icon_font_size=\"on\" icon_font_size=\"22px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" background_color=\"#303447\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"20px|20px|20px|20px|true|true\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" background__hover_enabled=\"on\" background_color__hover=\"#008a1c\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][et_pb_blurb title=\"سازگار با تمام گوشی ها\" url=\"#\" use_icon=\"on\" font_icon=\"%%104%%\" use_circle=\"on\" circle_color=\"#ffffff\" icon_placement=\"left\" use_icon_font_size=\"on\" icon_font_size=\"22px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" background_color=\"#303447\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"20px|20px|20px|20px|true|true\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" background__hover_enabled=\"on\" background_color__hover=\"#008a1c\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][et_pb_blurb title=\"ارسال به شماره های مسدود\" url=\"#\" use_icon=\"on\" font_icon=\"%%70%%\" use_circle=\"on\" circle_color=\"#ffffff\" icon_placement=\"left\" use_icon_font_size=\"on\" icon_font_size=\"22px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" background_color=\"#303447\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"20px|20px|20px|20px|true|true\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" background__hover_enabled=\"on\" background_color__hover=\"#008a1c\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>\n[/et_pb_blurb][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_button button_text=\"بسته پیشنهادی خود را ایجاد کنید 1234-021\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover=\"#7cda24\" button_bg_color__hover_enabled=\"on|hover\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"FAQ\" _builder_version=\"3.22\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" max_width__hover=\"100%\" max_width__hover_enabled=\"100%\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" inner_shadow__hover=\"off\" inner_shadow__hover_enabled=\"off\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_row _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>سوالات متداول</h2>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_toggle title=\"سوال دلخواه را وارد کنید ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||20px\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>جواب دلخواه این سوال را هم اینجا وارد کنید .</p>\n[/et_pb_toggle][et_pb_toggle title=\"سوال دلخواه را وارد کنید ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||20px\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>جواب دلخواه این سوال را هم اینجا وارد کنید .</p>\n[/et_pb_toggle][et_pb_toggle title=\"سوال دلخواه را وارد کنید ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||20px\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>جواب دلخواه این سوال را هم اینجا وارد کنید .</p>\n[/et_pb_toggle][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_toggle title=\"آیا دانلود شبانه رایگان دارید ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||20px\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>سرویس ها نامحدود هستند و نیازی به شبانه رایگان ندارید </p>\n[/et_pb_toggle][et_pb_toggle title=\"سوال دلخواه را وارد کنید ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||20px\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>جواب دلخواه این سوال را هم اینجا وارد کنید .</p>\n[/et_pb_toggle][et_pb_toggle title=\"سوال دلخواه را وارد کنید ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||20px\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>جواب دلخواه این سوال را هم اینجا وارد کنید .</p>\n[/et_pb_toggle][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_button button_text=\"سوال دیگری دارید پیام بفرستید\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover=\"#7cda24\" button_bg_color__hover_enabled=\"on|hover\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" prev_background_color=\"#ffffff\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#0f1533\" background_color_gradient_end=\"#1f133a\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||5vw\" custom_padding=\"14vw||10vw\" top_divider_style=\"wave2\" top_divider_height=\"10vw\" top_divider_repeat=\"0.7x\" top_divider_flip=\"vertical\" animation_style=\"fade\" border_radii=\"on|30px|30px|30px|30px\" locked=\"off\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_phone=\"\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_2_font=\"|900|on||||||\" header_2_font_size=\"3.5vw\" header_2_letter_spacing=\"2px\" header_2_line_height=\"1.4em\" header_3_font=\"|900|on|on|||||\" header_3_text_color=\"rgba(255,255,255,0.7)\" header_3_font_size=\"1.5vw\" header_3_letter_spacing=\"0.4em\" header_3_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_font_size__hover=\"30px\" header_font_size__hover_enabled=\"30px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h2>سرعت مورد نظر خود را با قیمتی که می خواهید دریافت کنید</h2>\n<h3>سرویس های ADSL  و سرویس های پیامکی</h3>[/et_pb_text][et_pb_button button_text=\"مشاهده تمام سرویس های ما\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#7cda24\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section]", "خدمات", "", "inherit", "closed", "closed", "", "899-revision-v1", "", "", "2020-04-02 16:42:22", "2020-04-02 13:12:22", "", "899", "http://modelsite.test/899-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2970", "1", "2020-04-02 17:01:15", "2020-04-02 13:31:15", "[et_pb_section fb_built=\"1\" admin_label=\"Header\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-05.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"5vw||||false\" custom_padding=\"6vw||10vw||false|false\" bottom_divider_style=\"wave2\" bottom_divider_color=\"#ffffff\" bottom_divider_height=\"10vw\" bottom_divider_repeat=\"0.7x\" animation_style=\"slide\" animation_direction=\"bottom\" animation_intensity_slide=\"1%\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_phone=\"\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" animation_style=\"slide\" animation_direction=\"left\" animation_intensity_slide=\"10%\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_font=\"|900|on|on|||||\" header_font_size=\"4vw\" header_letter_spacing=\"0.1em\" header_line_height=\"1.2em\" header_2_font=\"|900|on|on|||||\" header_2_text_color=\"rgba(255,255,255,0.7)\" header_2_font_size=\"4vw\" header_2_letter_spacing=\"0em\" header_2_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" hover_enabled=\"0\" header_font_size_tablet=\"50px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|phone\" header_2_font_size_tablet=\"30px\" header_2_font_size_phone=\"20px\" header_2_font_size_last_edited=\"on|phone\" header_text_shadow_style=\"preset1\" header_text_shadow_vertical_length=\"0.3em\" header_text_shadow_blur_strength=\"0.5em\" header_text_shadow_color=\"rgba(0,0,0,0.15)\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h1>65 مگابایت بر ثانیه</h1>\n<p>&nbsp;</p>\n<h2><span style=\"color: rgba(0, 0, 0, 0.7);\">اینترنت پایه</span></h2>\n[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"About\" _builder_version=\"3.22\"][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#a0cf00\" price_text_color=\"rgba(0,0,0,0.75)\" subheader_text_color=\"#000000\" header_text_color=\"#000000\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"Poppins||||||||\" body_text_align=\"center\" subheader_font=\"Poppins|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"Poppins|800|on||||||\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#ffffff\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0f1533\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" custom_margin=\"||\" animation_style=\"zoom\" animation_delay=\"100ms\" hover_enabled=\"0\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" border_color_all=\"#ffffff\" border_width_top=\"40px\" border_width_bottom=\"30px\" box_shadow_style=\"preset6\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" locked=\"off\" filter_hue_rotate__hover_enabled=\"off|desktop\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_scale__hover=\"105%|105%\"][et_pb_pricing_table title=\"اینترنت پایه\" subtitle=\"65mbps\" currency=\"ماهانه\" per=\"هزارتومان\" sum=\"10\" button_text=\"سفارش سرویس\" _builder_version=\"4.4.2\" body_font=\"VAZIR FARSI||||||||\" hover_enabled=\"0\" header_font=\"||||||||\" header_level=\"h2\" subheader_font=\"|800|||||||\" price_font=\"|800|on||||||\" price_line_height=\"100px\" price_text_shadow_style=\"preset3\" currency_frequency_font=\"VAZIR FARSI|700|on||||||\" button_url=\"#\" custom_button=\"on\" button_bg_color=\"#004fe8\" button_bg_enable_color=\"on\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#a0cf00\" button_bg_enable_color__hover=\"on\"]<p>+ 20 گیگابایت ترافیک ماهانه</p>\n<p>+ از ساعت 1 شب تا 7 صبح نیمه بها</p>\n<p>+ جمعه ها ترافیک رایگان </p>\n<p>+ ویژگی دیگر</p>\n<p>+ ویژگی دلخواه</p>\n[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"100px|||\" custom_padding_tablet=\"\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" module_alignment=\"center\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>چرا سرویس 65 مگابیت بر ثانیه رو انتخاب کنم ؟</h2>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span></p>\n[/et_pb_text][et_pb_blurb title=\"عنوان ویژگی خاص\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#000000\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" hover_enabled=\"0\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی خاص\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#000000\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" hover_enabled=\"0\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی خاص\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#000000\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" hover_enabled=\"0\" locked=\"off\"][/et_pb_blurb][et_pb_button button_text=\"برای انتخاب مردد هستید ؟ 1234-021\" button_alignment=\"left\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Details\" _builder_version=\"3.22\"][et_pb_row _builder_version=\"3.25\" custom_margin_tablet=\"40px||40px||true\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"32px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" text_orientation=\"center\" max_width=\"700px\" module_alignment=\"center\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>شامل چه مواردی این سرویس می باشد</h2>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" padding_top_bottom_link_1=\"false\" padding_top_bottom_link_2=\"false\" padding_top_bottom_link_3=\"false\" padding_left_right_link_1=\"true\" padding_left_right_link_2=\"true\" padding_left_right_link_3=\"true\" _builder_version=\"3.25\" max_width=\"1160px\" custom_padding=\"0|0px|27px|0px|false|false\" use_custom_width=\"on\" custom_width_px=\"1160px\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\" max_width__hover=\"1080px\" max_width__hover_enabled=\"1080px\" locked=\"off\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-03.png\" background_size=\"contain\" background_position=\"bottom_right\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"دریافت سرعت واقعی\" use_icon=\"on\" font_icon=\"%%243%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|hover\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"0deg|42deg|0deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"20 درصد تخفیف\" use_icon=\"on\" font_icon=\"%%171%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"0deg|0deg|25deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-04.png\" background_size=\"contain\" background_position=\"top_right\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"بدون محدودیت حجمی\" use_icon=\"on\" font_icon=\"%%231%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"18deg|0deg|0deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است </span></p>[/et_pb_blurb][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" max_width=\"800px\" border_width_bottom=\"2px\" border_color_bottom=\"#f2f5fa\" use_custom_width=\"on\" custom_width_px=\"800px\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"Poppins|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"|700|on||||||\" header_3_line_height=\"1.5em\" max_width=\"700px\" link_option_url=\"#\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" header_3_font_size_tablet=\"\" header_3_font_size_phone=\"26px\" header_3_font_size_last_edited=\"on|desktop\" locked=\"off\" header_3_text_color__hover_enabled=\"on\" header_3_text_color__hover=\"#008a1c\"]<h3>نوع بسته</h3>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_toggle title=\"اینترنت پایه\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||\" custom_padding=\"0px|0px|0px|0px|true|true\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_toggle][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" max_width=\"800px\" border_width_bottom=\"2px\" border_color_bottom=\"#f2f5fa\" use_custom_width=\"on\" custom_width_px=\"800px\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"|700|on||||||\" header_3_line_height=\"1.5em\" max_width=\"700px\" link_option_url=\"#\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" header_3_font_size_tablet=\"\" header_3_font_size_phone=\"26px\" header_3_font_size_last_edited=\"on|desktop\" locked=\"off\" header_3_text_color__hover_enabled=\"on\" header_3_text_color__hover=\"#008a1c\"]<h3>مناسب برای تعداد کاربر</h3>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_toggle title=\"2-4\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||\" custom_padding=\"0px|0px|0px|0px|true|true\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_toggle][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" max_width=\"800px\" border_width_bottom=\"2px\" border_color_bottom=\"#f2f5fa\" use_custom_width=\"on\" custom_width_px=\"800px\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"Poppins|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"|700|on||||||\" header_3_line_height=\"1.5em\" max_width=\"700px\" link_option_url=\"#\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" header_3_font_size_tablet=\"\" header_3_font_size_phone=\"26px\" header_3_font_size_last_edited=\"on|desktop\" locked=\"off\" header_3_text_color__hover_enabled=\"on\" header_3_text_color__hover=\"#008a1c\"]<h3>پهنای دانلود</h3>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_toggle title=\"تا 65 مگابیت بر ثانیه\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||\" custom_padding=\"0px|0px|0px|0px|true|true\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_toggle][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" max_width=\"800px\" border_width_bottom=\"2px\" border_color_bottom=\"#f2f5fa\" use_custom_width=\"on\" custom_width_px=\"800px\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"Poppins|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"|700|on||||||\" header_3_line_height=\"1.5em\" max_width=\"700px\" link_option_url=\"#\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" header_3_font_size_tablet=\"\" header_3_font_size_phone=\"26px\" header_3_font_size_last_edited=\"on|desktop\" locked=\"off\" header_3_text_color__hover_enabled=\"on\" header_3_text_color__hover=\"#008a1c\"]<h3>میزان دانلود</h3>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_toggle title=\"نامحدود\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||\" custom_padding=\"0px|0px|0px|0px|true|true\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_toggle][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" max_width=\"800px\" border_width_bottom=\"2px\" border_color_bottom=\"#f2f5fa\" use_custom_width=\"on\" custom_width_px=\"800px\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"Poppins|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"|700|on||||||\" header_3_line_height=\"1.5em\" max_width=\"700px\" link_option_url=\"#\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" header_3_font_size_tablet=\"\" header_3_font_size_phone=\"26px\" header_3_font_size_last_edited=\"on|desktop\" locked=\"off\" header_3_text_color__hover_enabled=\"on\" header_3_text_color__hover=\"#008a1c\"]<h3>منطقه پوشش</h3>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_toggle title=\"در سراسر کشور\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||\" custom_padding=\"0px|0px|0px|0px|true|true\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_toggle][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" max_width=\"800px\" use_custom_width=\"on\" custom_width_px=\"800px\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"Poppins|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"|700|on||||||\" header_3_line_height=\"1.5em\" link_option_url=\"#\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" header_3_font_size_tablet=\"\" header_3_font_size_phone=\"26px\" header_3_font_size_last_edited=\"on|desktop\" locked=\"off\" header_3_text_color__hover_enabled=\"on\" header_3_text_color__hover=\"#008a1c\"]<h3>اطلاعات اضافی</h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ، و با استفاده از طراحان گرافیک است، چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است، و برای شرایط فعلی تکنولوژی مورد نیاز، و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد، کتابهای زیادی در شصت و سه درصد گذشته حال و آینده، شناخت فراوان جامعه و متخصصان را می طلبد، تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی، و فرهنگ پیشرو در زبان فارسی ایجاد کرد، در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها، و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی، و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد.</span></p>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ، و با استفاده از طراحان گرافیک است، چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است، و برای شرایط فعلی تکنولوژی مورد نیاز، و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد، کتابهای زیادی در شصت و سه درصد گذشته حال و آینده، شناخت فراوان جامعه و متخصصان را می طلبد، تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی، و فرهنگ پیشرو در زبان فارسی ایجاد کرد، در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها، و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی، و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد.</span></p>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ، و با استفاده از طراحان گرافیک است، چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است، و برای شرایط فعلی تکنولوژی مورد نیاز، و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد، کتابهای زیادی در شصت و سه درصد گذشته حال و آینده، شناخت فراوان جامعه و متخصصان را می طلبد، تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی، و فرهنگ پیشرو در زبان فارسی ایجاد کرد، در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها، و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی، و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد.</span></p>\n[/et_pb_text][et_pb_button button_text=\"امروز عضو شوید\" button_alignment=\"left\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Related Products\" _builder_version=\"3.22\" background_color=\"#f2f5fa\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" border_radii=\"|30px|30px||\" locked=\"off\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\"][et_pb_row _builder_version=\"3.25\" custom_padding=\"||||false|false\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" text_orientation=\"center\" max_width=\"700px\" module_alignment=\"center\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>دیگر سرویس ها</h2>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\" locked=\"off\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"40px|||\" custom_padding_tablet=\"0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px||\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_pricing_tables _builder_version=\"4.4.2\" center_list_items=\"on\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate__hover=\"0px|-70px\" header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" currency_frequency_text_color=\"#a0cf00\" price_text_color=\"rgba(0,0,0,0.75)\" body_text_color=\"#a0cf00\" header_font=\"||||||||\" header_font_size=\"14px\" body_font=\"||||||||\" body_text_align=\"center\" subheader_font=\"|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"||on||||||\" price_font_size=\"50px\" currency_frequency_font=\"|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(255,255,255,0)\" background_color_gradient_end=\"rgba(255,255,255,0.16)\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" animation_style=\"slide\" animation_direction=\"right\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" featured_table_header_background_color=\"#a0cf00\" header_text_color=\"#a0cf00\" subheader_text_color=\"#a0cf00\" price_letter_spacing_last_edited=\"on|desktop\" excluded_text_color=\"#004fe8\" price_line_height=\"100px\" hover_enabled=\"0\"][et_pb_pricing_table title=\"اینترنت پایه\" subtitle=\"1 مگابایت\" currency=\"یک ساله \" per=\"هزارتومان\" sum=\"35\" button_url=\"#\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" hover_enabled=\"0\" pricing_item_excluded_color=\"rgba(255,255,255,0.5)\"]<p>+ گارانتی سرعت</p>\n<p>+ گارنتی کیفیت</p>\n<p>+ نصب در محل</p>\n<p>- تنظیم مودم</p>\n<p>- پشتیبانی 24 ساعته</p>[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#a0cf00\" price_text_color=\"rgba(0,0,0,0.75)\" subheader_text_color=\"#000000\" header_text_color=\"#000000\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"Poppins||||||||\" body_text_align=\"center\" subheader_font=\"Poppins|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"|800|on||||||\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#ffffff\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#008a1c\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" transform_translate_linked__hover=\"off\" custom_margin=\"0px||\" animation_style=\"zoom\" animation_delay=\"100ms\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" border_color_all=\"#ffffff\" border_width_top=\"40px\" border_width_bottom=\"30px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" locked=\"off\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate__hover=\"0px|-70px\"][et_pb_pricing_table title=\"سرویس محبوب\" subtitle=\"65 مگابایت\" currency=\"سالانه\" per=\"هزارتومان\" sum=\"99\" button_url=\"#\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" header_level=\"h2\" header_font=\"||||||||\" body_font=\"VAZIR FARSI||||||||\" subheader_font=\"VAZIR FARSI|800|||||||\" price_font=\"VAZIR FARSI|800|on||||||\" price_font_size=\"50px\" price_line_height=\"100px\" custom_button=\"on\" button_font=\"VAZIR FARSI||||||||\"]<p>+ سرعت دانلود تا 65 مگابایت</p>\n<p>+ دانلود نامحدود</p>\n<p>+ پشتیبانی شبانه روزی</p>\n<p>+ مودم رایگان</p>\n<p>+ نصب رایگان</p>[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"40px|||\" custom_padding_tablet=\"0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|desktop\" padding_tablet=\"0px||\" padding_last_edited=\"on|desktop\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#a0cf00\" price_text_color=\"rgba(0,0,0,0.75)\" body_text_color=\"#a0cf00\" header_font=\"||||||||\" header_font_size=\"14px\" body_font=\"||||||||\" body_text_align=\"center\" subheader_font=\"|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"||on||||||\" price_font_size=\"50px\" currency_frequency_font=\"|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(255,255,255,0)\" background_color_gradient_end=\"rgba(255,255,255,0.16)\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" transform_translate_linked__hover=\"off\" animation_style=\"slide\" animation_direction=\"right\" hover_enabled=\"0\" price_letter_spacing_tablet=\"\" price_letter_spacing_phone=\"\" price_letter_spacing_last_edited=\"on|desktop\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" locked=\"off\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate__hover=\"0px|-70px\" featured_table_header_background_color=\"#a0cf00\" header_text_color=\"#a0cf00\" subheader_text_color=\"#a0cf00\"][et_pb_pricing_table title=\"اینترنت حرفه ای\" subtitle=\"120 مگابایت\" currency=\"یک ساله \" per=\"هزارتومان\" sum=\"900\" button_url=\"#\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" header_level=\"h2\" header_font=\"||||||||\" body_font=\"VAZIR FARSI||||||||\" subheader_font=\"|800|||||||\" price_font=\"VAZIR FARSI||on||||||\" price_letter_spacing=\"0px\" price_line_height=\"100px\" currency_frequency_font=\"|700|on||||||\" currency_frequency_line_height=\"1em\" excluded_text_color=\"#004fe8\" custom_button=\"on\" button_font=\"VAZIR FARSI||||||||\" hover_enabled=\"0\" pricing_item_excluded_color=\"rgba(255,255,255,0.5)\" body_text_color=\"#a0cf00\" bullet_color=\"#a0cf00\"]<p>+ گارانتی سرعت</p>\n<p>+ گارنتی کیفیت</p>\n<p>+ نصب در محل</p>\n<p>- تنظیم مودم</p>\n<p>- پشتیبانی 24 ساعته</p>[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" prev_background_color=\"#ffffff\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#0f1533\" background_color_gradient_end=\"#1f133a\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||5vw\" custom_padding=\"14vw||10vw\" top_divider_style=\"wave2\" top_divider_height=\"10vw\" top_divider_repeat=\"0.7x\" top_divider_flip=\"vertical\" animation_style=\"fade\" border_radii=\"on|30px|30px|30px|30px\" locked=\"off\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_phone=\"\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_2_font=\"|900|on||||||\" header_2_font_size=\"3.5vw\" header_2_letter_spacing=\"2px\" header_2_line_height=\"1.4em\" header_3_font=\"|900|on|on|||||\" header_3_text_color=\"rgba(255,255,255,0.7)\" header_3_font_size=\"1.5vw\" header_3_letter_spacing=\"0.4em\" header_3_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_font_size__hover=\"30px\" header_font_size__hover_enabled=\"30px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h2>سرعت مورد نظر خود را با قیمتی که می خواهید دریافت کنید</h2>\n<h3>سرویس های ADSL  و سرویس های پیامکی</h3>[/et_pb_text][et_pb_button button_text=\"مشاهده تمام سرویس های ما\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#7cda24\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section]", "خدمات طرح دوم", "", "inherit", "closed", "closed", "", "2392-revision-v1", "", "", "2020-04-02 17:01:15", "2020-04-02 13:31:15", "", "2392", "http://modelsite.test/2392-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2972", "1", "2020-04-02 17:01:58", "2020-04-02 13:31:58", "[et_pb_section fb_built=\"1\" admin_label=\"Header\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-05.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"5vw||||false\" custom_padding=\"6vw||10vw||false|false\" bottom_divider_style=\"wave2\" bottom_divider_color=\"#ffffff\" bottom_divider_height=\"10vw\" bottom_divider_repeat=\"0.7x\" animation_style=\"slide\" animation_direction=\"bottom\" animation_intensity_slide=\"1%\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_phone=\"\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" animation_style=\"slide\" animation_direction=\"left\" animation_intensity_slide=\"10%\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_font=\"|900|on|on|||||\" header_font_size=\"4vw\" header_letter_spacing=\"0.1em\" header_line_height=\"1.2em\" header_2_font=\"|900|on|on|||||\" header_2_text_color=\"rgba(255,255,255,0.7)\" header_2_font_size=\"4vw\" header_2_letter_spacing=\"0em\" header_2_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" hover_enabled=\"0\" header_font_size_tablet=\"50px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|phone\" header_2_font_size_tablet=\"30px\" header_2_font_size_phone=\"20px\" header_2_font_size_last_edited=\"on|phone\" header_text_shadow_style=\"preset1\" header_text_shadow_vertical_length=\"0.3em\" header_text_shadow_blur_strength=\"0.5em\" header_text_shadow_color=\"rgba(0,0,0,0.15)\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h1>65 مگابایت بر ثانیه</h1>\n<p>&nbsp;</p>\n<h2><span style=\"color: rgba(0, 0, 0, 0.7);\">اینترنت پایه</span></h2>\n[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"About\" _builder_version=\"3.22\"][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#a0cf00\" price_text_color=\"rgba(0,0,0,0.75)\" subheader_text_color=\"#000000\" header_text_color=\"#000000\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"Poppins||||||||\" body_text_align=\"center\" subheader_font=\"Poppins|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"Poppins|800|on||||||\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#ffffff\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0f1533\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" custom_margin=\"||\" animation_style=\"zoom\" animation_delay=\"100ms\" hover_enabled=\"0\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" border_color_all=\"#ffffff\" border_width_top=\"40px\" border_width_bottom=\"30px\" box_shadow_style=\"preset6\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" locked=\"off\" filter_hue_rotate__hover_enabled=\"off|desktop\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_scale__hover=\"105%|105%\"][et_pb_pricing_table title=\"اینترنت پایه\" subtitle=\"65mbps\" currency=\"ماهانه\" per=\"هزارتومان\" sum=\"10\" button_text=\"سفارش سرویس\" _builder_version=\"4.4.2\" body_font=\"VAZIR FARSI||||||||\" hover_enabled=\"0\" header_font=\"||||||||\" header_level=\"h2\" subheader_font=\"|800|||||||\" price_font=\"|800|on||||||\" price_line_height=\"100px\" price_text_shadow_style=\"preset3\" currency_frequency_font=\"VAZIR FARSI|700|on||||||\" button_url=\"#\" custom_button=\"on\" button_bg_color=\"#004fe8\" button_bg_enable_color=\"on\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#a0cf00\" button_bg_enable_color__hover=\"on\"]<p>+ 20 گیگابایت ترافیک ماهانه</p>\n<p>+ از ساعت 1 شب تا 7 صبح نیمه بها</p>\n<p>+ جمعه ها ترافیک رایگان </p>\n<p>+ ویژگی دیگر</p>\n<p>+ ویژگی دلخواه</p>\n[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"100px|||\" custom_padding_tablet=\"\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" module_alignment=\"center\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>چرا سرویس 65 مگابیت بر ثانیه رو انتخاب کنم ؟</h2>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span></p>\n[/et_pb_text][et_pb_blurb title=\"عنوان ویژگی خاص\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#000000\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" hover_enabled=\"0\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی خاص\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#000000\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" hover_enabled=\"0\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی خاص\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#000000\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" hover_enabled=\"0\" locked=\"off\"][/et_pb_blurb][et_pb_button button_text=\"برای انتخاب مردد هستید ؟ 1234-021\" button_alignment=\"right\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover=\"#7cda24\" button_bg_color__hover_enabled=\"on|hover\" hover_enabled=\"0\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Details\" _builder_version=\"3.22\"][et_pb_row _builder_version=\"3.25\" custom_margin_tablet=\"40px||40px||true\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"32px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" text_orientation=\"center\" max_width=\"700px\" module_alignment=\"center\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>شامل چه مواردی این سرویس می باشد</h2>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" padding_top_bottom_link_1=\"false\" padding_top_bottom_link_2=\"false\" padding_top_bottom_link_3=\"false\" padding_left_right_link_1=\"true\" padding_left_right_link_2=\"true\" padding_left_right_link_3=\"true\" _builder_version=\"3.25\" max_width=\"1160px\" custom_padding=\"0|0px|27px|0px|false|false\" use_custom_width=\"on\" custom_width_px=\"1160px\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\" max_width__hover=\"1080px\" max_width__hover_enabled=\"1080px\" locked=\"off\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-03.png\" background_size=\"contain\" background_position=\"bottom_right\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"دریافت سرعت واقعی\" use_icon=\"on\" font_icon=\"%%243%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|hover\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"0deg|42deg|0deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"20 درصد تخفیف\" use_icon=\"on\" font_icon=\"%%171%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"0deg|0deg|25deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-04.png\" background_size=\"contain\" background_position=\"top_right\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"بدون محدودیت حجمی\" use_icon=\"on\" font_icon=\"%%231%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"18deg|0deg|0deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است </span></p>[/et_pb_blurb][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" max_width=\"800px\" border_width_bottom=\"2px\" border_color_bottom=\"#f2f5fa\" use_custom_width=\"on\" custom_width_px=\"800px\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"Poppins|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"|700|on||||||\" header_3_line_height=\"1.5em\" max_width=\"700px\" link_option_url=\"#\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" header_3_font_size_tablet=\"\" header_3_font_size_phone=\"26px\" header_3_font_size_last_edited=\"on|desktop\" locked=\"off\" header_3_text_color__hover_enabled=\"on\" header_3_text_color__hover=\"#008a1c\"]<h3>نوع بسته</h3>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_toggle title=\"اینترنت پایه\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||\" custom_padding=\"0px|0px|0px|0px|true|true\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_toggle][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" max_width=\"800px\" border_width_bottom=\"2px\" border_color_bottom=\"#f2f5fa\" use_custom_width=\"on\" custom_width_px=\"800px\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"|700|on||||||\" header_3_line_height=\"1.5em\" max_width=\"700px\" link_option_url=\"#\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" header_3_font_size_tablet=\"\" header_3_font_size_phone=\"26px\" header_3_font_size_last_edited=\"on|desktop\" locked=\"off\" header_3_text_color__hover_enabled=\"on\" header_3_text_color__hover=\"#008a1c\"]<h3>مناسب برای تعداد کاربر</h3>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_toggle title=\"2-4\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||\" custom_padding=\"0px|0px|0px|0px|true|true\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_toggle][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" max_width=\"800px\" border_width_bottom=\"2px\" border_color_bottom=\"#f2f5fa\" use_custom_width=\"on\" custom_width_px=\"800px\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"Poppins|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"|700|on||||||\" header_3_line_height=\"1.5em\" max_width=\"700px\" link_option_url=\"#\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" header_3_font_size_tablet=\"\" header_3_font_size_phone=\"26px\" header_3_font_size_last_edited=\"on|desktop\" locked=\"off\" header_3_text_color__hover_enabled=\"on\" header_3_text_color__hover=\"#008a1c\"]<h3>پهنای دانلود</h3>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_toggle title=\"تا 65 مگابیت بر ثانیه\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||\" custom_padding=\"0px|0px|0px|0px|true|true\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_toggle][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" max_width=\"800px\" border_width_bottom=\"2px\" border_color_bottom=\"#f2f5fa\" use_custom_width=\"on\" custom_width_px=\"800px\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"Poppins|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"|700|on||||||\" header_3_line_height=\"1.5em\" max_width=\"700px\" link_option_url=\"#\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" header_3_font_size_tablet=\"\" header_3_font_size_phone=\"26px\" header_3_font_size_last_edited=\"on|desktop\" locked=\"off\" header_3_text_color__hover_enabled=\"on\" header_3_text_color__hover=\"#008a1c\"]<h3>میزان دانلود</h3>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_toggle title=\"نامحدود\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||\" custom_padding=\"0px|0px|0px|0px|true|true\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_toggle][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" max_width=\"800px\" border_width_bottom=\"2px\" border_color_bottom=\"#f2f5fa\" use_custom_width=\"on\" custom_width_px=\"800px\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"Poppins|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"|700|on||||||\" header_3_line_height=\"1.5em\" max_width=\"700px\" link_option_url=\"#\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" header_3_font_size_tablet=\"\" header_3_font_size_phone=\"26px\" header_3_font_size_last_edited=\"on|desktop\" locked=\"off\" header_3_text_color__hover_enabled=\"on\" header_3_text_color__hover=\"#008a1c\"]<h3>منطقه پوشش</h3>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_toggle title=\"در سراسر کشور\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||\" custom_padding=\"0px|0px|0px|0px|true|true\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_toggle][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" max_width=\"800px\" use_custom_width=\"on\" custom_width_px=\"800px\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"Poppins|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"|700|on||||||\" header_3_line_height=\"1.5em\" link_option_url=\"#\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" header_3_font_size_tablet=\"\" header_3_font_size_phone=\"26px\" header_3_font_size_last_edited=\"on|desktop\" locked=\"off\" header_3_text_color__hover_enabled=\"on\" header_3_text_color__hover=\"#008a1c\"]<h3>اطلاعات اضافی</h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ، و با استفاده از طراحان گرافیک است، چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است، و برای شرایط فعلی تکنولوژی مورد نیاز، و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد، کتابهای زیادی در شصت و سه درصد گذشته حال و آینده، شناخت فراوان جامعه و متخصصان را می طلبد، تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی، و فرهنگ پیشرو در زبان فارسی ایجاد کرد، در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها، و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی، و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد.</span></p>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ، و با استفاده از طراحان گرافیک است، چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است، و برای شرایط فعلی تکنولوژی مورد نیاز، و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد، کتابهای زیادی در شصت و سه درصد گذشته حال و آینده، شناخت فراوان جامعه و متخصصان را می طلبد، تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی، و فرهنگ پیشرو در زبان فارسی ایجاد کرد، در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها، و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی، و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد.</span></p>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ، و با استفاده از طراحان گرافیک است، چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است، و برای شرایط فعلی تکنولوژی مورد نیاز، و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد، کتابهای زیادی در شصت و سه درصد گذشته حال و آینده، شناخت فراوان جامعه و متخصصان را می طلبد، تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی، و فرهنگ پیشرو در زبان فارسی ایجاد کرد، در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها، و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی، و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد.</span></p>\n[/et_pb_text][et_pb_button button_text=\"امروز عضو شوید\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover=\"#7cda24\" button_bg_color__hover_enabled=\"on|hover\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Related Products\" _builder_version=\"3.22\" background_color=\"#f2f5fa\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" border_radii=\"|30px|30px||\" locked=\"off\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\"][et_pb_row _builder_version=\"3.25\" custom_padding=\"||||false|false\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" text_orientation=\"center\" max_width=\"700px\" module_alignment=\"center\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>دیگر سرویس ها</h2>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\" locked=\"off\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"40px|||\" custom_padding_tablet=\"0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px||\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_pricing_tables _builder_version=\"4.4.2\" center_list_items=\"on\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate__hover=\"0px|-70px\" header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" currency_frequency_text_color=\"#a0cf00\" price_text_color=\"rgba(0,0,0,0.75)\" body_text_color=\"#a0cf00\" header_font=\"||||||||\" header_font_size=\"14px\" body_font=\"||||||||\" body_text_align=\"center\" subheader_font=\"|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"||on||||||\" price_font_size=\"50px\" currency_frequency_font=\"|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(255,255,255,0)\" background_color_gradient_end=\"rgba(255,255,255,0.16)\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" animation_style=\"slide\" animation_direction=\"right\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" featured_table_header_background_color=\"#a0cf00\" header_text_color=\"#a0cf00\" subheader_text_color=\"#a0cf00\" price_letter_spacing_last_edited=\"on|desktop\" excluded_text_color=\"#004fe8\" price_line_height=\"100px\" hover_enabled=\"0\"][et_pb_pricing_table title=\"اینترنت پایه\" subtitle=\"1 مگابایت\" currency=\"یک ساله \" per=\"هزارتومان\" sum=\"35\" button_url=\"#\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" hover_enabled=\"0\" pricing_item_excluded_color=\"rgba(255,255,255,0.5)\"]<p>+ گارانتی سرعت</p>\n<p>+ گارنتی کیفیت</p>\n<p>+ نصب در محل</p>\n<p>- تنظیم مودم</p>\n<p>- پشتیبانی 24 ساعته</p>[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#a0cf00\" price_text_color=\"rgba(0,0,0,0.75)\" subheader_text_color=\"#000000\" header_text_color=\"#000000\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"Poppins||||||||\" body_text_align=\"center\" subheader_font=\"Poppins|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"|800|on||||||\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#ffffff\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#008a1c\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" transform_translate_linked__hover=\"off\" custom_margin=\"0px||\" animation_style=\"zoom\" animation_delay=\"100ms\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" border_color_all=\"#ffffff\" border_width_top=\"40px\" border_width_bottom=\"30px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" locked=\"off\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate__hover=\"0px|-70px\"][et_pb_pricing_table title=\"سرویس محبوب\" subtitle=\"65 مگابایت\" currency=\"سالانه\" per=\"هزارتومان\" sum=\"99\" button_url=\"#\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" header_level=\"h2\" header_font=\"||||||||\" body_font=\"VAZIR FARSI||||||||\" subheader_font=\"VAZIR FARSI|800|||||||\" price_font=\"VAZIR FARSI|800|on||||||\" price_font_size=\"50px\" price_line_height=\"100px\" custom_button=\"on\" button_font=\"VAZIR FARSI||||||||\"]<p>+ سرعت دانلود تا 65 مگابایت</p>\n<p>+ دانلود نامحدود</p>\n<p>+ پشتیبانی شبانه روزی</p>\n<p>+ مودم رایگان</p>\n<p>+ نصب رایگان</p>[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"40px|||\" custom_padding_tablet=\"0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|desktop\" padding_tablet=\"0px||\" padding_last_edited=\"on|desktop\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#a0cf00\" price_text_color=\"rgba(0,0,0,0.75)\" body_text_color=\"#a0cf00\" header_font=\"||||||||\" header_font_size=\"14px\" body_font=\"||||||||\" body_text_align=\"center\" subheader_font=\"|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"||on||||||\" price_font_size=\"50px\" currency_frequency_font=\"|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(255,255,255,0)\" background_color_gradient_end=\"rgba(255,255,255,0.16)\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" transform_translate_linked__hover=\"off\" animation_style=\"slide\" animation_direction=\"right\" hover_enabled=\"0\" price_letter_spacing_tablet=\"\" price_letter_spacing_phone=\"\" price_letter_spacing_last_edited=\"on|desktop\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" locked=\"off\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate__hover=\"0px|-70px\" featured_table_header_background_color=\"#a0cf00\" header_text_color=\"#a0cf00\" subheader_text_color=\"#a0cf00\"][et_pb_pricing_table title=\"اینترنت حرفه ای\" subtitle=\"120 مگابایت\" currency=\"یک ساله \" per=\"هزارتومان\" sum=\"900\" button_url=\"#\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" header_level=\"h2\" header_font=\"||||||||\" body_font=\"VAZIR FARSI||||||||\" subheader_font=\"|800|||||||\" price_font=\"VAZIR FARSI||on||||||\" price_letter_spacing=\"0px\" price_line_height=\"100px\" currency_frequency_font=\"|700|on||||||\" currency_frequency_line_height=\"1em\" excluded_text_color=\"#004fe8\" custom_button=\"on\" button_font=\"VAZIR FARSI||||||||\" hover_enabled=\"0\" pricing_item_excluded_color=\"rgba(255,255,255,0.5)\" body_text_color=\"#a0cf00\" bullet_color=\"#a0cf00\"]<p>+ گارانتی سرعت</p>\n<p>+ گارنتی کیفیت</p>\n<p>+ نصب در محل</p>\n<p>- تنظیم مودم</p>\n<p>- پشتیبانی 24 ساعته</p>[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" prev_background_color=\"#ffffff\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#0f1533\" background_color_gradient_end=\"#1f133a\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||5vw\" custom_padding=\"14vw||10vw\" top_divider_style=\"wave2\" top_divider_height=\"10vw\" top_divider_repeat=\"0.7x\" top_divider_flip=\"vertical\" animation_style=\"fade\" border_radii=\"on|30px|30px|30px|30px\" locked=\"off\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_phone=\"\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_2_font=\"|900|on||||||\" header_2_font_size=\"3.5vw\" header_2_letter_spacing=\"2px\" header_2_line_height=\"1.4em\" header_3_font=\"|900|on|on|||||\" header_3_text_color=\"rgba(255,255,255,0.7)\" header_3_font_size=\"1.5vw\" header_3_letter_spacing=\"0.4em\" header_3_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_font_size__hover=\"30px\" header_font_size__hover_enabled=\"30px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h2>سرعت مورد نظر خود را با قیمتی که می خواهید دریافت کنید</h2>\n<h3>سرویس های ADSL  و سرویس های پیامکی</h3>[/et_pb_text][et_pb_button button_text=\"مشاهده تمام سرویس های ما\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#7cda24\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section]", "خدمات طرح دوم", "", "inherit", "closed", "closed", "", "2392-revision-v1", "", "", "2020-04-02 17:01:58", "2020-04-02 13:31:58", "", "2392", "http://modelsite.test/2392-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2975", "1", "2020-04-02 17:15:09", "2020-04-02 13:45:09", "[et_pb_section fb_built=\"1\" admin_label=\"Header\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-05.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"5vw||||false\" custom_padding=\"6vw||10vw||false|false\" bottom_divider_style=\"wave2\" bottom_divider_color=\"#ffffff\" bottom_divider_height=\"10vw\" bottom_divider_repeat=\"0.7x\" animation_style=\"slide\" animation_direction=\"bottom\" animation_intensity_slide=\"1%\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_phone=\"\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" animation_style=\"slide\" animation_direction=\"left\" animation_intensity_slide=\"10%\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_font=\"|900|on|on|||||\" header_font_size=\"7vw\" header_letter_spacing=\"0em\" header_line_height=\"1.2em\" header_2_font=\"|900|on|on|||||\" header_2_text_color=\"rgba(255,255,255,0.7)\" header_2_font_size=\"4vw\" header_2_letter_spacing=\"0.1em\" header_2_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" hover_enabled=\"0\" header_font_size_tablet=\"50px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|phone\" header_2_font_size_tablet=\"30px\" header_2_font_size_phone=\"20px\" header_2_font_size_last_edited=\"on|phone\" header_text_shadow_style=\"preset1\" header_text_shadow_vertical_length=\"0.3em\" header_text_shadow_blur_strength=\"0.5em\" header_text_shadow_color=\"rgba(0,0,0,0.15)\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h1>ارتباط با ما</h1>\n<p>&nbsp;</p>\n<h2><span color=\"rgba(0, 0, 0, 0.701960784313725)\" style=\"color: rgba(0, 0, 0, 0.7);\">پشتیبانی 24/7</span></h2>\n[/et_pb_text][et_pb_search show_button=\"off\" placeholder=\"جستجو در مقالات .....\" button_color=\"#ffffff\" placeholder_color=\"#ffffff\" _builder_version=\"4.4.2\" button_font=\"VAZIR FARSI||||||||\" form_field_font=\"Poppins|600|||||||\" form_field_font_size=\"16px\" form_field_line_height=\"2em\" background_color=\"rgba(48,52,71,0.18)\" max_width=\"700px\" module_alignment=\"center\" custom_padding=\"14px||14px||true|false\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" input_font=\"Poppins|600|||||||\" input_font_size=\"16px\" input_line_height=\"2em\"][/et_pb_search][et_pb_button button_text=\"چت زنده\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Categories\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(242,245,250,0)\" background_color_gradient_end=\"#f2f5fa\" background_color_gradient_direction=\"90deg\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin_tablet=\"||0px\" custom_margin_last_edited=\"off|desktop\" custom_padding=\"0||0px||false|false\" border_radii=\"on|60px|60px|60px|60px\" locked=\"off\"][et_pb_row column_structure=\"1_4,1_4,1_4,1_4\" use_custom_gutter=\"on\" gutter_width=\"2\" _builder_version=\"3.25\" locked=\"off\"][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#a0cf00\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" locked=\"off\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" box_shadow_color__hover_enabled=\"on\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\"]<p>بیزینس ها</p>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#008a1c\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" box_shadow_color__hover_enabled=\"on\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\"]<p>منازل</p>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#ffffff\" text_orientation=\"center\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" locked=\"off\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" box_shadow_color__hover_enabled=\"on\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\" background_layout__hover_enabled=\"on\" background_layout__hover=\"dark\"]<p>همه مشاغل</p>\n[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Contact Info\" _builder_version=\"3.22\"][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"چت زنده\" use_icon=\"on\" font_icon=\"%%221%%\" use_circle=\"on\" circle_color=\"#ffffff\" icon_placement=\"left\" use_icon_font_size=\"on\" icon_font_size=\"22px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" background_color=\"#303447\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"20px|20px|20px|20px|true|true\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" background__hover_enabled=\"on\" background_color__hover=\"#008a1c\"]<p>24 ساعته </p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"ساعات کاری\" use_icon=\"on\" font_icon=\"%%128%%\" use_circle=\"on\" circle_color=\"#ffffff\" icon_placement=\"left\" use_icon_font_size=\"on\" icon_font_size=\"22px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" background_color=\"#303447\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"20px|20px|20px|20px|true|true\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" background__hover_enabled=\"on\" background_color__hover=\"#008a1c\"]<p>اداری 7 صبح تا 7 شب </p>\n<p>فنی 24 ساعته</p>\n[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"پشتیبانی\" use_icon=\"on\" font_icon=\"%%264%%\" use_circle=\"on\" circle_color=\"#ffffff\" icon_placement=\"left\" use_icon_font_size=\"on\" icon_font_size=\"22px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" background_color=\"#303447\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"20px|20px|20px|20px|true|true\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" background__hover_enabled=\"on\" background_color__hover=\"#008a1c\"]<p>(125) 462-2351  اداری<br /> (125) 462-1351  فنی</p>\n[/et_pb_blurb][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Call to Actions\" _builder_version=\"3.22\" custom_padding=\"0|0px|54px|0px|false|false\"][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_cta title=\"به پشتیبانی قبل از خرید نیاز دارید ؟\" button_url=\"#\" button_text=\"چت کنید\" _builder_version=\"4.4.2\" header_level=\"h3\" header_font=\"|700|on||||||\" header_font_size=\"26px\" header_line_height=\"1.5em\" body_font=\"|500|||||||\" body_text_color=\"#008a1c\" body_line_height=\"1.8em\" background_color=\"#ffffff\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" text_orientation=\"left\" background_layout=\"light\" hover_enabled=\"0\" header_font_size_tablet=\"\" header_font_size_phone=\"26px\" header_font_size_last_edited=\"on|phone\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" box_shadow_style_button=\"preset3\" box_shadow_vertical_button=\"20px\" box_shadow_blur_button=\"80px\" box_shadow_spread_button=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#a0cf00\" button_bg_enable_color__hover=\"on\"]<p>شماره تماس: (135) 624-1231</p>\n[/et_pb_cta][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_cta title=\"به پشتیبانی پس از خرید نیاز دارید ؟\" button_url=\"#\" button_text=\"تیکت بزنید\" _builder_version=\"4.4.2\" header_level=\"h3\" header_font=\"|700|on||||||\" header_font_size=\"26px\" header_line_height=\"1.5em\" body_font=\"|500|||||||\" body_text_color=\"#008a1c\" body_line_height=\"1.8em\" background_color=\"#ffffff\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" text_orientation=\"left\" background_layout=\"light\" hover_enabled=\"0\" header_font_size_tablet=\"\" header_font_size_phone=\"26px\" header_font_size_last_edited=\"on|phone\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" box_shadow_style_button=\"preset3\" box_shadow_vertical_button=\"20px\" box_shadow_blur_button=\"80px\" box_shadow_spread_button=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#a0cf00\" button_bg_enable_color__hover=\"on\"]<p>شماره تماس: (135) 624-1231</p>\n[/et_pb_cta][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"FAQ\" _builder_version=\"3.22\" background_color=\"#f2f5fa\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_padding=\"0|0px|0|0px|false|false\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row custom_padding_last_edited=\"on|tablet\" _builder_version=\"3.25\" background_color=\"#ffffff\" max_width=\"80%\" module_alignment=\"left\" custom_margin=\"||\" custom_padding=\"60px|||60px|false|false\" custom_padding_tablet=\"|40px||40px\" custom_padding_phone=\"\" animation_style=\"slide\" animation_direction=\"left\" animation_intensity_slide=\"10%\" border_radii=\"|||30px|\" use_custom_width=\"on\" width_unit=\"off\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2> مقالات راهنما</h2>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"3_5,2_5\" _builder_version=\"3.25\" custom_margin=\"100px||100px||true\" custom_margin_tablet=\"40px||40px||true\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\"][et_pb_column type=\"3_5\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"Poppins|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"|700|on||||||\" header_3_line_height=\"1.5em\" max_width=\"700px\" link_option_url=\"#\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" header_3_font_size_tablet=\"\" header_3_font_size_phone=\"26px\" header_3_font_size_last_edited=\"on|desktop\" locked=\"off\" header_3_text_color__hover_enabled=\"on\" header_3_text_color__hover=\"#008a1c\"]<h3>دستور نصب</h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span></p>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"Poppins|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"|700|on||||||\" header_3_line_height=\"1.5em\" max_width=\"700px\" link_option_url=\"#\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" header_3_font_size_tablet=\"\" header_3_font_size_phone=\"26px\" header_3_font_size_last_edited=\"on|desktop\" locked=\"off\" header_3_text_color__hover_enabled=\"on\" header_3_text_color__hover=\"#008a1c\"]<h3>تست سرعت</h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span></p>\n[/et_pb_text][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"Poppins|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"|700|on||||||\" header_3_line_height=\"1.5em\" max_width=\"700px\" link_option_url=\"#\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" header_3_font_size_tablet=\"\" header_3_font_size_phone=\"26px\" header_3_font_size_last_edited=\"on|desktop\" locked=\"off\" header_3_text_color__hover_enabled=\"on\" header_3_text_color__hover=\"#008a1c\"]<h3>مدیریت اکانت</h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span></p>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"2_5\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_toggle title=\"نحوه تنظیم مودم چگونه است ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||20px\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span></p>\n[/et_pb_toggle][et_pb_toggle title=\"سوال دلخواه ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||20px\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span></p>\n[/et_pb_toggle][et_pb_toggle title=\"سوال دلخواه ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||20px\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span></p>\n[/et_pb_toggle][et_pb_toggle title=\"سوال دلخواه ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||20px\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span></p>\n[/et_pb_toggle][et_pb_toggle title=\"سوال دلخواه ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||20px\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span></p>\n[/et_pb_toggle][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" _builder_version=\"3.22\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\"][et_pb_row _builder_version=\"3.25\" width=\"100%\" max_width=\"100%\" custom_padding=\"0|0px|0|0px|true|false\" border_radii=\"on|30px|30px|30px|30px\" use_custom_width=\"on\" width_unit=\"off\" custom_width_percent=\"100%\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][dsm_embed_google_map _builder_version=\"4.4.2\" address=\"برج میلاد\" hover_enabled=\"0\"][/dsm_embed_google_map][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Blog\" _builder_version=\"3.22\"][et_pb_row _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#0492ff\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>منابع بیشتر</h2>\n[/et_pb_text][et_pb_blog fullwidth=\"off\" posts_number=\"3\" show_pagination=\"off\" _builder_version=\"3.17.6\" header_font=\"Poppins|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_line_height=\"2em\" meta_font=\"Poppins||||||||\" meta_text_color=\"#008a1c\" pagination_font=\"Poppins|700|on||||||\" pagination_text_color=\"#008a1c\" pagination_font_size=\"18px\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"][/et_pb_blog][et_pb_button button_text=\"رفتن به وبلاگ\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#a0cf00\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" prev_background_color=\"#ffffff\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#0f1533\" background_color_gradient_end=\"#1f133a\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||5vw\" custom_padding=\"14vw||10vw\" top_divider_style=\"wave2\" top_divider_height=\"10vw\" top_divider_repeat=\"0.7x\" top_divider_flip=\"vertical\" animation_style=\"fade\" border_radii=\"on|30px|30px|30px|30px\" locked=\"off\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_phone=\"\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_2_font=\"|900|on||||||\" header_2_font_size=\"3.5vw\" header_2_letter_spacing=\"2px\" header_2_line_height=\"1.4em\" header_3_font=\"|900|on|on|||||\" header_3_text_color=\"rgba(255,255,255,0.7)\" header_3_font_size=\"1.5vw\" header_3_letter_spacing=\"0.4em\" header_3_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_font_size__hover=\"30px\" header_font_size__hover_enabled=\"30px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h2>سرعت مورد نظر خود را با قیمتی که می خواهید دریافت کنید</h2>\n<h3>سرویس های ADSL  و سرویس های پیامکی</h3>[/et_pb_text][et_pb_button button_text=\"مشاهده تمام سرویس های ما\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#7cda24\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section]", "تماس با ما", "", "inherit", "closed", "closed", "", "195-revision-v1", "", "", "2020-04-02 17:15:09", "2020-04-02 13:45:09", "", "195", "http://modelsite.test/195-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2978", "1", "2020-04-02 17:22:21", "2020-04-02 13:52:21", "[et_pb_section fb_built=\"1\" admin_label=\"Header\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#0f1533\" background_color_gradient_end=\"#1f133a\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-10.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"5vw||||false\" custom_padding=\"14vw||18vw||false|false\" bottom_divider_style=\"wave2\" bottom_divider_color=\"#ffffff\" bottom_divider_height=\"10vw\" bottom_divider_repeat=\"0.7x\" animation_style=\"slide\" animation_direction=\"bottom\" animation_intensity_slide=\"1%\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_phone=\"\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" animation_style=\"slide\" animation_direction=\"left\" animation_intensity_slide=\"10%\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_font=\"|900|on|on|||||\" header_font_size=\"6vw\" header_letter_spacing=\"0.1em\" header_line_height=\"1.2em\" header_2_font=\"|900|on|on|||||\" header_2_text_color=\"rgba(255,255,255,0.7)\" header_2_font_size=\"3vw\" header_2_letter_spacing=\"0.1em\" header_2_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" hover_enabled=\"0\" header_font_size_tablet=\"50px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|phone\" header_2_font_size_tablet=\"30px\" header_2_font_size_phone=\"20px\" header_2_font_size_last_edited=\"on|phone\" header_text_shadow_style=\"preset1\" header_text_shadow_vertical_length=\"0.3em\" header_text_shadow_blur_strength=\"0.5em\" header_text_shadow_color=\"rgba(0,0,0,0.15)\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h1>درباره شرکت</h1>\n<p>&nbsp;</p>\n<h2>ارائه دهنده سرویس های ADSL</h2>\n[/et_pb_text][et_pb_button button_text=\"مشاهده تمام خدمات شرکت\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#0c71c3\" button_bg_enable_color__hover=\"on\" button_text_color__hover_enabled=\"on|hover\" button_text_color__hover=\"#ffffff\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" specialty=\"on\" bg_img_1=\"http://modelsite.test/wp-content/uploads/2020/04/isp-03.png\" background_size_1=\"contain\" background_position_1=\"bottom_right\" background_repeat_1=\"no-repeat\" padding_top_bottom_link_1=\"false\" padding_left_right_link_1=\"true\" padding_right_1=\"40px\" padding_bottom_1=\"80px\" padding_left_1=\"40px\" admin_label=\"About\" _builder_version=\"3.22\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" background_size=\"contain\" background_position=\"bottom_right\" custom_padding=\"|||\" padding_bottom__hover=\"80px\" padding_left__hover=\"40px\" padding_right__hover=\"40px\" bg_img__hover=\"http://modelsite.test/wp-content/uploads/2020/04/isp-03.png\" parallax__hover=\"off\" parallax_method__hover=\"on\" background_size__hover=\"contain\" background_position__hover=\"bottom_right\" background_repeat__hover=\"no-repeat\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\" text_line_height__hover=\"1.7em\" text_line_height__hover_enabled=\"1.7em\" header_2_font_size__hover=\"26px\" header_2_font_size__hover_enabled=\"26px\" header_2_line_height__hover=\"1em\" header_2_line_height__hover_enabled=\"1em\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" max_width__hover=\"100%\" max_width__hover_enabled=\"100%\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" text_font_size__hover=\"14px\" text_font_size__hover_enabled=\"14px\" text_letter_spacing__hover=\"0px\" text_letter_spacing__hover_enabled=\"0px\" text_text_shadow_style__hover=\"none\" text_text_shadow_style__hover_enabled=\"none\" text_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" text_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" link_font_size__hover=\"14px\" link_font_size__hover_enabled=\"14px\" link_letter_spacing__hover=\"0px\" link_letter_spacing__hover_enabled=\"0px\" link_line_height__hover=\"1em\" link_line_height__hover_enabled=\"1em\" link_text_shadow_style__hover=\"none\" link_text_shadow_style__hover_enabled=\"none\" link_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" link_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" ul_font_size__hover=\"14px\" ul_font_size__hover_enabled=\"14px\" ul_letter_spacing__hover=\"0px\" ul_letter_spacing__hover_enabled=\"0px\" ul_line_height__hover=\"1em\" ul_line_height__hover_enabled=\"1em\" ul_text_shadow_style__hover=\"none\" ul_text_shadow_style__hover_enabled=\"none\" ul_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" ul_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" ol_font_size__hover=\"14px\" ol_font_size__hover_enabled=\"14px\" ol_letter_spacing__hover=\"0px\" ol_letter_spacing__hover_enabled=\"0px\" ol_line_height__hover=\"1em\" ol_line_height__hover_enabled=\"1em\" ol_text_shadow_style__hover=\"none\" ol_text_shadow_style__hover_enabled=\"none\" ol_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" ol_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" quote_font_size__hover=\"14px\" quote_font_size__hover_enabled=\"14px\" quote_letter_spacing__hover=\"0px\" quote_letter_spacing__hover_enabled=\"0px\" quote_line_height__hover=\"1em\" quote_line_height__hover_enabled=\"1em\" quote_text_shadow_style__hover=\"none\" quote_text_shadow_style__hover_enabled=\"none\" quote_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" quote_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_font_size__hover=\"30px\" header_font_size__hover_enabled=\"30px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_2_letter_spacing__hover=\"0px\" header_2_letter_spacing__hover_enabled=\"0px\" header_2_text_shadow_style__hover=\"none\" header_2_text_shadow_style__hover_enabled=\"none\" header_2_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_2_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" text_orientation__hover=\"left\" text_orientation__hover_enabled=\"left\" background_layout__hover=\"light\" background_layout__hover_enabled=\"light\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"]<h2>انتخاب 1 # کاربران هستیم</h2>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ، و با استفاده از طراحان گرافیک است، چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است، و برای شرایط فعلی تکنولوژی مورد نیاز، و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد، کتابهای زیادی در شصت و سه درصد گذشته حال و آینده، شناخت فراوان جامعه و متخصصان را می طلبد، تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی، و فرهنگ پیشرو در زبان فارسی ایجاد کرد، در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها، و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی، و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد.</span></p>\n[/et_pb_text][et_pb_button button_text=\"پلن های اینترنتی ما\" button_alignment=\"left\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#7cda24\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][et_pb_column type=\"1_2\" specialty_columns=\"2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_row_inner _builder_version=\"3.25\" custom_padding=\"|40px|50px|40px||true\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\"][et_pb_column_inner saved_specialty_column_type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" parallax__hover=\"off\" parallax_method__hover=\"on\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\"]<h2>چرا شرکت ما</h2>\n[/et_pb_text][et_pb_blurb title=\"بدون قطعی نت\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"2em\" custom_margin=\"||20px\" hover_enabled=\"0\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"سرعت دهی تا 125 مگا بیت بر ثانیه\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"2em\" custom_margin=\"||20px\" hover_enabled=\"0\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"تجهیزات سخت افزاری به روز\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"2em\" custom_margin=\"||20px\" hover_enabled=\"0\" locked=\"off\"][/et_pb_blurb][/et_pb_column_inner][/et_pb_row_inner][/et_pb_column][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Features\" _builder_version=\"3.22\" background_color=\"#f2f5fa\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_padding=\"54px|0px|0|0px|false|false\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row column_structure=\"3_5,2_5\" _builder_version=\"3.25\" custom_margin=\"100px||100px||true\" custom_margin_tablet=\"40px||40px||true\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" locked=\"off\"][et_pb_column type=\"3_5\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/04/isp-01.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" custom_margin=\"|||-7vw\" custom_margin_tablet=\"|||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\"][/et_pb_image][/et_pb_column][et_pb_column type=\"2_5\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>داستان ما</h2>\n<h3></h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ، و با استفاده از طراحان گرافیک است، چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است، و برای شرایط فعلی تکنولوژی مورد نیاز، و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد، کتابهای زیادی در شصت و سه درصد گذشته حال و آینده، شناخت فراوان جامعه و متخصصان را می طلبد، تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی، و فرهنگ پیشرو در زبان فارسی ایجاد کرد، در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها، و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی، و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد.</span></p>\n[/et_pb_text][et_pb_button button_text=\"مشاهده پلن های اینترنت\" button_alignment=\"left\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#7cda24\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Value\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(255,255,255,0)\" background_color_gradient_end=\"#ffffff\" background_color_gradient_type=\"radial\" background_color_gradient_start_position=\"50%\" background_color_gradient_overlays_image=\"on\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.jpg\" custom_padding=\"10vw|0px|10vw|0px|true|false\"][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" padding_top_bottom_link_1=\"false\" padding_top_bottom_link_2=\"false\" padding_top_bottom_link_3=\"false\" padding_left_right_link_1=\"true\" padding_left_right_link_2=\"true\" padding_left_right_link_3=\"true\" _builder_version=\"3.25\" max_width=\"1160px\" custom_padding=\"0|0px|27px|0px|false|false\" use_custom_width=\"on\" custom_width_px=\"1160px\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\" max_width__hover=\"1080px\" max_width__hover_enabled=\"1080px\" locked=\"off\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-03.png\" background_size=\"contain\" background_position=\"bottom_right\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"دریافت سرعت واقعی\" use_icon=\"on\" font_icon=\"%%243%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|desktop\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|hover\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"0deg|330deg|0deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"20 درصد تخفیف\" use_icon=\"on\" font_icon=\"%%171%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"0deg|0deg|330deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-04.png\" background_size=\"contain\" background_position=\"top_right\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"بدون محدودیت حجمی\" use_icon=\"on\" font_icon=\"%%231%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"330deg|0deg|0deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است </span></p>[/et_pb_blurb][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" prev_background_color=\"#ffffff\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#0f1533\" background_color_gradient_end=\"#1f133a\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||5vw\" custom_padding=\"14vw||10vw\" top_divider_style=\"wave2\" top_divider_height=\"10vw\" top_divider_repeat=\"0.7x\" top_divider_flip=\"vertical\" animation_style=\"fade\" border_radii=\"on|30px|30px|30px|30px\" locked=\"off\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_phone=\"\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_2_font=\"|900|on||||||\" header_2_font_size=\"3.5vw\" header_2_letter_spacing=\"2px\" header_2_line_height=\"1.4em\" header_3_font=\"|900|on|on|||||\" header_3_text_color=\"rgba(255,255,255,0.7)\" header_3_font_size=\"1.5vw\" header_3_letter_spacing=\"0.4em\" header_3_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_font_size__hover=\"30px\" header_font_size__hover_enabled=\"30px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h2>سرعت مورد نظر خود را با قیمتی که می خواهید دریافت کنید</h2>\n<h3>سرویس های ADSL  و سرویس های پیامکی</h3>[/et_pb_text][et_pb_button button_text=\"مشاهده تمام سرویس های ما\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#7cda24\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section]", "درباره ما", "", "inherit", "closed", "closed", "", "187-revision-v1", "", "", "2020-04-02 17:22:21", "2020-04-02 13:52:21", "", "187", "http://modelsite.test/187-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2983", "1", "2020-04-02 17:30:50", "2020-04-02 14:00:50", "[et_pb_section fb_built=\"1\" admin_label=\"Header\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-05.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"5vw||||false\" custom_padding=\"6vw||10vw||false|false\" bottom_divider_style=\"wave2\" bottom_divider_color=\"#ffffff\" bottom_divider_height=\"10vw\" bottom_divider_repeat=\"0.7x\" animation_style=\"slide\" animation_direction=\"bottom\" animation_intensity_slide=\"1%\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_phone=\"\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" animation_style=\"slide\" animation_direction=\"left\" animation_intensity_slide=\"10%\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_font=\"|900|on|on|||||\" header_font_size=\"6vw\" header_letter_spacing=\"0.1em\" header_line_height=\"1.2em\" header_2_font=\"Poppins|900|on|on|||||\" header_2_text_color=\"rgba(255,255,255,0.7)\" header_2_font_size=\"2vw\" header_2_letter_spacing=\"0.5em\" header_2_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" hover_enabled=\"0\" header_font_size_tablet=\"50px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|phone\" header_2_font_size_tablet=\"30px\" header_2_font_size_phone=\"20px\" header_2_font_size_last_edited=\"on|phone\" header_text_shadow_style=\"preset1\" header_text_shadow_vertical_length=\"0.3em\" header_text_shadow_blur_strength=\"0.5em\" header_text_shadow_color=\"rgba(0,0,0,0.15)\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h1>وبلاگ و مقالات</h1>\n[/et_pb_text][et_pb_signup mailchimp_list=\"elegantthemestest|26e9af0331\" layout=\"top_bottom\" first_name_field=\"off\" last_name_field=\"off\" _builder_version=\"4.4.2\" form_field_background_color=\"rgba(48,52,71,0.18)\" form_field_text_color=\"#ffffff\" form_field_font=\"Poppins|600|||||||\" form_field_line_height=\"2em\" use_background_color=\"off\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" max_width=\"800px\" module_alignment=\"center\" hover_enabled=\"0\" border_radii_fields=\"on|15px|15px|15px|15px\" box_shadow_style_button=\"preset3\" box_shadow_vertical_button=\"20px\" box_shadow_blur_button=\"80px\" box_shadow_spread_button=\"-20px\" button_text=\"اشتراک خبرنامه ایمیلی\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#004fe8\" button_bg_enable_color__hover=\"on\" button_text_color__hover_enabled=\"on|hover\" button_text_color__hover=\"#dadada\"][/et_pb_signup][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Categories\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(242,245,250,0)\" background_color_gradient_end=\"#f2f5fa\" background_color_gradient_direction=\"90deg\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||60px\" custom_margin_tablet=\"||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|desktop\" custom_padding=\"0||0px||false|false\" border_radii=\"on|60px|60px|60px|60px\" locked=\"off\"][et_pb_row column_structure=\"1_6,1_6,1_6,1_6,1_6,1_6\" use_custom_gutter=\"on\" gutter_width=\"2\" _builder_version=\"3.25\" locked=\"off\"][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#a0cf00\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" locked=\"off\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" box_shadow_color__hover_enabled=\"on\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\"]<p>تخفیف ها</p>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#ffffff\" text_orientation=\"center\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" locked=\"off\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" box_shadow_color__hover_enabled=\"on\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\" background_layout__hover_enabled=\"on\" background_layout__hover=\"dark\"]<p>آموزش ها</p>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#008a1c\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" box_shadow_color__hover_enabled=\"on\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\"]<p>اینترنت</p>\n[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Blog\" _builder_version=\"3.22\"][et_pb_row _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_blog fullwidth=\"off\" posts_number=\"9\" _builder_version=\"3.17.6\" header_font=\"Poppins|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_line_height=\"2em\" meta_font=\"Poppins||||||||\" meta_text_color=\"#008a1c\" pagination_font=\"Poppins|700|on||||||\" pagination_text_color=\"#008a1c\" pagination_font_size=\"18px\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"][/et_pb_blog][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Videos\" _builder_version=\"3.22\" background_color=\"#f2f5fa\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_padding=\"54px|0px|0|0px|false|false\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row _builder_version=\"3.25\" custom_margin_tablet=\"40px||40px||true\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2><strong>فیلم های کمک آموزشی</strong></h2>\n<h3>نحوه پیکربندی مودم ، تغییر رمز وای فا و .....</h3>\n[/et_pb_text][et_pb_video_slider show_image_overlay=\"on\" play_icon_color=\"#000000\" _builder_version=\"4.4.2\" hover_enabled=\"0\"][et_pb_video_slider_item src=\"#\" image_src=\"http://modelsite.test/wp-content/uploads/2020/04/tech-01.jpg\" _builder_version=\"4.4.2\" hover_enabled=\"0\" show_image_overlay=\"on\"][/et_pb_video_slider_item][et_pb_video_slider_item src=\"#\" image_src=\"http://modelsite.test/wp-content/uploads/2020/04/tech-04.jpg\" _builder_version=\"4.4.2\" hover_enabled=\"0\" show_image_overlay=\"on\"][/et_pb_video_slider_item][et_pb_video_slider_item src=\"#\" image_src=\"http://modelsite.test/wp-content/uploads/2020/04/tech-05.jpg\" _builder_version=\"4.4.2\" hover_enabled=\"0\" show_image_overlay=\"on\"][/et_pb_video_slider_item][/et_pb_video_slider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonials\" _builder_version=\"3.22\"][et_pb_row column_structure=\"2_5,3_5\" padding_top_bottom_link_1=\"true\" padding_top_bottom_link_2=\"true\" padding_left_right_link_1=\"false\" padding_left_right_link_2=\"false\" _builder_version=\"3.25\"][et_pb_column type=\"2_5\" _builder_version=\"3.25\" custom_padding=\"60px|60px|60px|\" custom_padding_tablet=\"0px||0px||true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px||0px||true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>پرسش و پاسخ های متداول</h2>\n<h3>سوالات خود را ابتدا از این بخش جوابشان را پیدا کنید </h3>\n[/et_pb_text][et_pb_button button_text=\"سوال دیگری داری ؟\" button_alignment=\"left\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#37d73c\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][et_pb_column type=\"3_5\" _builder_version=\"3.25\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" background_size=\"initial\" background_position=\"bottom_right\" custom_padding=\"60px|60px|60px|\" custom_padding_tablet=\"40px|40px|40px|40px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"40px|40px|40px|40px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_toggle title=\"منظور از پهنای باند چیست ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||0px|-30px\" hover_enabled=\"0\" border_radii=\"|15px|15px||\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>منظور از پهنای باند مجموع داده ای می باشید که شما دانلود و آپلود می کنید .</p>\n[/et_pb_toggle][et_pb_toggle title=\"سوال دلخواه دیگر را وارد کنید ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||0px|-30px\" hover_enabled=\"0\" border_radii=\"|15px|15px||\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>جوابش هم اینجا وارد کنید .</p>\n[/et_pb_toggle][et_pb_toggle title=\"سوال دلخواه دیگر را وارد کنید ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||0px|-30px\" hover_enabled=\"0\" border_radii=\"|15px|15px||\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>جوابش هم اینجا وارد کنید .</p>\n[/et_pb_toggle][et_pb_toggle title=\"سوال دلخواه دیگر را وارد کنید ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||0px|-30px\" hover_enabled=\"0\" border_radii=\"|15px|15px||\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>جوابش هم اینجا وارد کنید .</p>\n[/et_pb_toggle][et_pb_toggle title=\"سوال دلخواه دیگر را وارد کنید ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||0px|-30px\" hover_enabled=\"0\" border_radii=\"|15px|15px||\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>جوابش هم اینجا وارد کنید .</p>\n[/et_pb_toggle][et_pb_toggle title=\"سوال دلخواه دیگر را وارد کنید ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||0px|-30px\" hover_enabled=\"0\" border_radii=\"|15px|15px||\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>جوابش هم اینجا وارد کنید .</p>\n[/et_pb_toggle][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" prev_background_color=\"#ffffff\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#0f1533\" background_color_gradient_end=\"#1f133a\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||5vw\" custom_padding=\"14vw||10vw\" top_divider_style=\"wave2\" top_divider_height=\"10vw\" top_divider_repeat=\"0.7x\" top_divider_flip=\"vertical\" animation_style=\"fade\" border_radii=\"on|30px|30px|30px|30px\" locked=\"off\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_phone=\"\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_2_font=\"|900|on||||||\" header_2_font_size=\"3.5vw\" header_2_letter_spacing=\"2px\" header_2_line_height=\"1.4em\" header_3_font=\"|900|on|on|||||\" header_3_text_color=\"rgba(255,255,255,0.7)\" header_3_font_size=\"1.5vw\" header_3_letter_spacing=\"0.4em\" header_3_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_font_size__hover=\"30px\" header_font_size__hover_enabled=\"30px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h2>سرعت مورد نظر خود را با قیمتی که می خواهید دریافت کنید</h2>\n<h3>سرویس های ADSL  و سرویس های پیامکی</h3>[/et_pb_text][et_pb_button button_text=\"مشاهده تمام سرویس های ما\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#7cda24\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section]", "وبلاگ", "", "inherit", "closed", "closed", "", "267-revision-v1", "", "", "2020-04-02 17:30:50", "2020-04-02 14:00:50", "", "267", "http://modelsite.test/267-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2985", "1", "2020-04-02 17:31:49", "2020-04-02 14:01:49", "[et_pb_section fb_built=\"1\" admin_label=\"Header\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-05.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"5vw||||false\" custom_padding=\"6vw||10vw||false|false\" bottom_divider_style=\"wave2\" bottom_divider_color=\"#ffffff\" bottom_divider_height=\"10vw\" bottom_divider_repeat=\"0.7x\" animation_style=\"slide\" animation_direction=\"bottom\" animation_intensity_slide=\"1%\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_phone=\"\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" animation_style=\"slide\" animation_direction=\"left\" animation_intensity_slide=\"10%\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_font=\"|900|on|on|||||\" header_font_size=\"6vw\" header_letter_spacing=\"0.1em\" header_line_height=\"1.2em\" header_2_font=\"Poppins|900|on|on|||||\" header_2_text_color=\"rgba(255,255,255,0.7)\" header_2_font_size=\"2vw\" header_2_letter_spacing=\"0.5em\" header_2_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" hover_enabled=\"0\" header_font_size_tablet=\"50px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|phone\" header_2_font_size_tablet=\"30px\" header_2_font_size_phone=\"20px\" header_2_font_size_last_edited=\"on|phone\" header_text_shadow_style=\"preset1\" header_text_shadow_vertical_length=\"0.3em\" header_text_shadow_blur_strength=\"0.5em\" header_text_shadow_color=\"rgba(0,0,0,0.15)\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h1>وبلاگ و مقالات</h1>\n[/et_pb_text][et_pb_signup mailchimp_list=\"elegantthemestest|26e9af0331\" layout=\"top_bottom\" first_name_field=\"off\" last_name_field=\"off\" _builder_version=\"4.4.2\" form_field_background_color=\"rgba(48,52,71,0.18)\" form_field_text_color=\"#ffffff\" form_field_font=\"Poppins|600|||||||\" form_field_line_height=\"2em\" use_background_color=\"off\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" max_width=\"800px\" module_alignment=\"center\" hover_enabled=\"0\" border_radii_fields=\"on|15px|15px|15px|15px\" box_shadow_style_button=\"preset3\" box_shadow_vertical_button=\"20px\" box_shadow_blur_button=\"80px\" box_shadow_spread_button=\"-20px\" button_text=\"اشتراک خبرنامه ایمیلی\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#004fe8\" button_bg_enable_color__hover=\"on\" button_text_color__hover_enabled=\"on|hover\" button_text_color__hover=\"#dadada\"][/et_pb_signup][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Categories\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(242,245,250,0)\" background_color_gradient_end=\"#f2f5fa\" background_color_gradient_direction=\"90deg\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||60px\" custom_margin_tablet=\"||0px\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|desktop\" custom_padding=\"0||0px||false|false\" border_radii=\"on|60px|60px|60px|60px\" locked=\"off\"][et_pb_row column_structure=\"1_6,1_6,1_6,1_6,1_6,1_6\" use_custom_gutter=\"on\" gutter_width=\"2\" _builder_version=\"3.25\" locked=\"off\"][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#a0cf00\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" locked=\"off\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" box_shadow_color__hover_enabled=\"on\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\"]<p>تخفیف ها</p>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#ffffff\" text_orientation=\"center\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" locked=\"off\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" box_shadow_color__hover_enabled=\"on\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\" background_layout__hover_enabled=\"on\" background_layout__hover=\"dark\"]<p>آموزش ها</p>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_6\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"|700|||||||\" text_letter_spacing=\"1px\" text_line_height=\"2em\" background_color=\"#008a1c\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"12px|20px|12px|20px|true|true\" animation_style=\"zoom\" link_option_url=\"#\" hover_enabled=\"0\" box_shadow_style=\"preset1\" box_shadow_vertical=\"12px\" box_shadow_blur=\"50px\" box_shadow_color=\"rgba(0,0,0,0)\" box_shadow_color__hover_enabled=\"on\" box_shadow_color__hover=\"rgba(0,0,0,0.15)\" background__hover_enabled=\"on\" background_color__hover=\"#0492ff\"]<p>اینترنت</p>\n[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Blog\" _builder_version=\"3.22\"][et_pb_row _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_blog fullwidth=\"off\" posts_number=\"9\" _builder_version=\"4.4.2\" header_font=\"Poppins|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_line_height=\"2em\" meta_font=\"Poppins||||||||\" meta_text_color=\"#008a1c\" pagination_font=\"Poppins|700|on||||||\" pagination_text_color=\"#008a1c\" pagination_font_size=\"18px\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" border_radii_image__hover_enabled=\"on|hover\" border_radii_image__hover=\"on|150px|150px|150px|150px\"][/et_pb_blog][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Videos\" _builder_version=\"3.22\" background_color=\"#f2f5fa\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_padding=\"54px|0px|0|0px|false|false\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row _builder_version=\"3.25\" custom_margin_tablet=\"40px||40px||true\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2><strong>فیلم های کمک آموزشی</strong></h2>\n<h3>نحوه پیکربندی مودم ، تغییر رمز وای فا و .....</h3>\n[/et_pb_text][et_pb_video_slider show_image_overlay=\"on\" play_icon_color=\"#000000\" _builder_version=\"4.4.2\" hover_enabled=\"0\"][et_pb_video_slider_item src=\"#\" image_src=\"http://modelsite.test/wp-content/uploads/2020/04/tech-01.jpg\" _builder_version=\"4.4.2\" hover_enabled=\"0\" show_image_overlay=\"on\"][/et_pb_video_slider_item][et_pb_video_slider_item src=\"#\" image_src=\"http://modelsite.test/wp-content/uploads/2020/04/tech-04.jpg\" _builder_version=\"4.4.2\" hover_enabled=\"0\" show_image_overlay=\"on\"][/et_pb_video_slider_item][et_pb_video_slider_item src=\"#\" image_src=\"http://modelsite.test/wp-content/uploads/2020/04/tech-05.jpg\" _builder_version=\"4.4.2\" hover_enabled=\"0\" show_image_overlay=\"on\"][/et_pb_video_slider_item][/et_pb_video_slider][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Testimonials\" _builder_version=\"3.22\"][et_pb_row column_structure=\"2_5,3_5\" padding_top_bottom_link_1=\"true\" padding_top_bottom_link_2=\"true\" padding_left_right_link_1=\"false\" padding_left_right_link_2=\"false\" _builder_version=\"3.25\"][et_pb_column type=\"2_5\" _builder_version=\"3.25\" custom_padding=\"60px|60px|60px|\" custom_padding_tablet=\"0px||0px||true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px||0px||true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>پرسش و پاسخ های متداول</h2>\n<h3>سوالات خود را ابتدا از این بخش جوابشان را پیدا کنید </h3>\n[/et_pb_text][et_pb_button button_text=\"سوال دیگری داری ؟\" button_alignment=\"left\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" hover_enabled=\"0\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#37d73c\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][et_pb_column type=\"3_5\" _builder_version=\"3.25\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" background_size=\"initial\" background_position=\"bottom_right\" custom_padding=\"60px|60px|60px|\" custom_padding_tablet=\"40px|40px|40px|40px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"40px|40px|40px|40px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_toggle title=\"منظور از پهنای باند چیست ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||0px|-30px\" hover_enabled=\"0\" border_radii=\"|15px|15px||\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>منظور از پهنای باند مجموع داده ای می باشید که شما دانلود و آپلود می کنید .</p>\n[/et_pb_toggle][et_pb_toggle title=\"سوال دلخواه دیگر را وارد کنید ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||0px|-30px\" hover_enabled=\"0\" border_radii=\"|15px|15px||\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>جوابش هم اینجا وارد کنید .</p>\n[/et_pb_toggle][et_pb_toggle title=\"سوال دلخواه دیگر را وارد کنید ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||0px|-30px\" hover_enabled=\"0\" border_radii=\"|15px|15px||\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>جوابش هم اینجا وارد کنید .</p>\n[/et_pb_toggle][et_pb_toggle title=\"سوال دلخواه دیگر را وارد کنید ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||0px|-30px\" hover_enabled=\"0\" border_radii=\"|15px|15px||\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>جوابش هم اینجا وارد کنید .</p>\n[/et_pb_toggle][et_pb_toggle title=\"سوال دلخواه دیگر را وارد کنید ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||0px|-30px\" hover_enabled=\"0\" border_radii=\"|15px|15px||\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>جوابش هم اینجا وارد کنید .</p>\n[/et_pb_toggle][et_pb_toggle title=\"سوال دلخواه دیگر را وارد کنید ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||0px|-30px\" hover_enabled=\"0\" border_radii=\"|15px|15px||\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>جوابش هم اینجا وارد کنید .</p>\n[/et_pb_toggle][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" prev_background_color=\"#ffffff\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#0f1533\" background_color_gradient_end=\"#1f133a\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||5vw\" custom_padding=\"14vw||10vw\" top_divider_style=\"wave2\" top_divider_height=\"10vw\" top_divider_repeat=\"0.7x\" top_divider_flip=\"vertical\" animation_style=\"fade\" border_radii=\"on|30px|30px|30px|30px\" locked=\"off\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_phone=\"\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_2_font=\"|900|on||||||\" header_2_font_size=\"3.5vw\" header_2_letter_spacing=\"2px\" header_2_line_height=\"1.4em\" header_3_font=\"|900|on|on|||||\" header_3_text_color=\"rgba(255,255,255,0.7)\" header_3_font_size=\"1.5vw\" header_3_letter_spacing=\"0.4em\" header_3_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_font_size__hover=\"30px\" header_font_size__hover_enabled=\"30px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h2>سرعت مورد نظر خود را با قیمتی که می خواهید دریافت کنید</h2>\n<h3>سرویس های ADSL  و سرویس های پیامکی</h3>[/et_pb_text][et_pb_button button_text=\"مشاهده تمام سرویس های ما\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#7cda24\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section]", "وبلاگ", "", "inherit", "closed", "closed", "", "267-revision-v1", "", "", "2020-04-02 17:31:49", "2020-04-02 14:01:49", "", "267", "http://modelsite.test/267-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2987", "1", "2020-04-02 17:33:10", "2020-04-02 14:03:10", "[et_pb_section fb_built=\"1\" admin_label=\"Header\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-05.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"5vw||||false\" custom_padding=\"6vw||10vw||false|false\" bottom_divider_style=\"wave2\" bottom_divider_color=\"#ffffff\" bottom_divider_height=\"10vw\" bottom_divider_repeat=\"0.7x\" animation_style=\"slide\" animation_direction=\"bottom\" animation_intensity_slide=\"1%\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_phone=\"\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" animation_style=\"slide\" animation_direction=\"left\" animation_intensity_slide=\"10%\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_font=\"|900|on|on|||||\" header_font_size=\"4vw\" header_letter_spacing=\"0.1em\" header_line_height=\"1.2em\" header_2_font=\"|900|on|on|||||\" header_2_text_color=\"rgba(255,255,255,0.7)\" header_2_font_size=\"4vw\" header_2_letter_spacing=\"0em\" header_2_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" hover_enabled=\"0\" header_font_size_tablet=\"50px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|phone\" header_2_font_size_tablet=\"30px\" header_2_font_size_phone=\"20px\" header_2_font_size_last_edited=\"on|phone\" header_text_shadow_style=\"preset1\" header_text_shadow_vertical_length=\"0.3em\" header_text_shadow_blur_strength=\"0.5em\" header_text_shadow_color=\"rgba(0,0,0,0.15)\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h1>65 مگابایت بر ثانیه</h1>\n<p>&nbsp;</p>\n<h2><span style=\"color: rgba(0, 0, 0, 0.7);\">اینترنت پایه</span></h2>\n[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"About\" _builder_version=\"3.22\"][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#a0cf00\" price_text_color=\"rgba(0,0,0,0.75)\" subheader_text_color=\"#000000\" header_text_color=\"#000000\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"Poppins||||||||\" body_text_align=\"center\" subheader_font=\"Poppins|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"Poppins|800|on||||||\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#ffffff\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0f1533\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" custom_margin=\"||\" animation_style=\"zoom\" animation_delay=\"100ms\" hover_enabled=\"0\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" border_color_all=\"#ffffff\" border_width_top=\"40px\" border_width_bottom=\"30px\" box_shadow_style=\"preset6\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" locked=\"off\" filter_hue_rotate__hover_enabled=\"off|desktop\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_scale__hover=\"105%|105%\"][et_pb_pricing_table title=\"اینترنت پایه\" subtitle=\"65mbps\" currency=\"ماهانه\" per=\"هزارتومان\" sum=\"10\" button_text=\"سفارش سرویس\" _builder_version=\"4.4.2\" body_font=\"VAZIR FARSI||||||||\" hover_enabled=\"0\" header_font=\"||||||||\" header_level=\"h2\" subheader_font=\"|800|||||||\" price_font=\"|800|on||||||\" price_line_height=\"100px\" price_text_shadow_style=\"preset3\" currency_frequency_font=\"VAZIR FARSI|700|on||||||\" button_url=\"#\" custom_button=\"on\" button_bg_color=\"#004fe8\" button_bg_enable_color=\"on\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#a0cf00\" button_bg_enable_color__hover=\"on\"]<p>+ 20 گیگابایت ترافیک ماهانه</p>\n<p>+ از ساعت 1 شب تا 7 صبح نیمه بها</p>\n<p>+ جمعه ها ترافیک رایگان </p>\n<p>+ ویژگی دیگر</p>\n<p>+ ویژگی دلخواه</p>\n[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"100px|||\" custom_padding_tablet=\"\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" module_alignment=\"center\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>چرا سرویس 65 مگابیت بر ثانیه رو انتخاب کنم ؟</h2>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد</span></p>\n[/et_pb_text][et_pb_blurb title=\"عنوان ویژگی خاص\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#000000\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" hover_enabled=\"0\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی خاص\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#000000\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" hover_enabled=\"0\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی خاص\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#000000\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" hover_enabled=\"0\" locked=\"off\"][/et_pb_blurb][et_pb_button button_text=\"برای انتخاب مردد هستید ؟ 1234-021\" button_alignment=\"right\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover=\"#7cda24\" button_bg_color__hover_enabled=\"on|hover\" hover_enabled=\"0\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Details\" _builder_version=\"3.22\"][et_pb_row _builder_version=\"3.25\" custom_margin_tablet=\"40px||40px||true\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"32px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" text_orientation=\"center\" max_width=\"700px\" module_alignment=\"center\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>شامل چه مواردی این سرویس می باشد</h2>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" padding_top_bottom_link_1=\"false\" padding_top_bottom_link_2=\"false\" padding_top_bottom_link_3=\"false\" padding_left_right_link_1=\"true\" padding_left_right_link_2=\"true\" padding_left_right_link_3=\"true\" _builder_version=\"3.25\" max_width=\"1160px\" custom_padding=\"0|0px|27px|0px|false|false\" use_custom_width=\"on\" custom_width_px=\"1160px\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\" max_width__hover=\"1080px\" max_width__hover_enabled=\"1080px\" locked=\"off\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-03.png\" background_size=\"contain\" background_position=\"bottom_right\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"دریافت سرعت واقعی\" use_icon=\"on\" font_icon=\"%%243%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|hover\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"0deg|42deg|0deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"20 درصد تخفیف\" use_icon=\"on\" font_icon=\"%%171%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"0deg|0deg|25deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-04.png\" background_size=\"contain\" background_position=\"top_right\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"بدون محدودیت حجمی\" use_icon=\"on\" font_icon=\"%%231%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" hover_enabled=\"0\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"18deg|0deg|0deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است </span></p>[/et_pb_blurb][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" max_width=\"800px\" border_width_bottom=\"2px\" border_color_bottom=\"#f2f5fa\" use_custom_width=\"on\" custom_width_px=\"800px\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"Poppins|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"|700|on||||||\" header_3_line_height=\"1.5em\" max_width=\"700px\" link_option_url=\"#\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" header_3_font_size_tablet=\"\" header_3_font_size_phone=\"26px\" header_3_font_size_last_edited=\"on|desktop\" locked=\"off\" header_3_text_color__hover_enabled=\"on\" header_3_text_color__hover=\"#008a1c\"]<h3>نوع بسته</h3>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_toggle title=\"اینترنت پایه\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||\" custom_padding=\"0px|0px|0px|0px|true|true\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_toggle][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" max_width=\"800px\" border_width_bottom=\"2px\" border_color_bottom=\"#f2f5fa\" use_custom_width=\"on\" custom_width_px=\"800px\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"|700|on||||||\" header_3_line_height=\"1.5em\" max_width=\"700px\" link_option_url=\"#\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" header_3_font_size_tablet=\"\" header_3_font_size_phone=\"26px\" header_3_font_size_last_edited=\"on|desktop\" locked=\"off\" header_3_text_color__hover_enabled=\"on\" header_3_text_color__hover=\"#008a1c\"]<h3>مناسب برای تعداد کاربر</h3>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_toggle title=\"2-4\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||\" custom_padding=\"0px|0px|0px|0px|true|true\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_toggle][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" max_width=\"800px\" border_width_bottom=\"2px\" border_color_bottom=\"#f2f5fa\" use_custom_width=\"on\" custom_width_px=\"800px\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"Poppins|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"|700|on||||||\" header_3_line_height=\"1.5em\" max_width=\"700px\" link_option_url=\"#\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" header_3_font_size_tablet=\"\" header_3_font_size_phone=\"26px\" header_3_font_size_last_edited=\"on|desktop\" locked=\"off\" header_3_text_color__hover_enabled=\"on\" header_3_text_color__hover=\"#008a1c\"]<h3>پهنای دانلود</h3>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_toggle title=\"تا 65 مگابیت بر ثانیه\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||\" custom_padding=\"0px|0px|0px|0px|true|true\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_toggle][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" max_width=\"800px\" border_width_bottom=\"2px\" border_color_bottom=\"#f2f5fa\" use_custom_width=\"on\" custom_width_px=\"800px\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"Poppins|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"|700|on||||||\" header_3_line_height=\"1.5em\" max_width=\"700px\" link_option_url=\"#\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" header_3_font_size_tablet=\"\" header_3_font_size_phone=\"26px\" header_3_font_size_last_edited=\"on|desktop\" locked=\"off\" header_3_text_color__hover_enabled=\"on\" header_3_text_color__hover=\"#008a1c\"]<h3>میزان دانلود</h3>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_toggle title=\"نامحدود\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||\" custom_padding=\"0px|0px|0px|0px|true|true\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_toggle][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" max_width=\"800px\" border_width_bottom=\"2px\" border_color_bottom=\"#f2f5fa\" use_custom_width=\"on\" custom_width_px=\"800px\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"Poppins|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"|700|on||||||\" header_3_line_height=\"1.5em\" max_width=\"700px\" link_option_url=\"#\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" header_3_font_size_tablet=\"\" header_3_font_size_phone=\"26px\" header_3_font_size_last_edited=\"on|desktop\" locked=\"off\" header_3_text_color__hover_enabled=\"on\" header_3_text_color__hover=\"#008a1c\"]<h3>منطقه پوشش</h3>\n[/et_pb_text][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_toggle title=\"در سراسر کشور\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||\" custom_padding=\"0px|0px|0px|0px|true|true\" hover_enabled=\"0\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است</span></p>\n[/et_pb_toggle][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" max_width=\"800px\" use_custom_width=\"on\" custom_width_px=\"800px\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"Poppins|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"|700|on||||||\" header_3_line_height=\"1.5em\" link_option_url=\"#\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" header_3_font_size_tablet=\"\" header_3_font_size_phone=\"26px\" header_3_font_size_last_edited=\"on|desktop\" locked=\"off\" header_3_text_color__hover_enabled=\"on\" header_3_text_color__hover=\"#008a1c\"]<h3>اطلاعات اضافی</h3>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ، و با استفاده از طراحان گرافیک است، چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است، و برای شرایط فعلی تکنولوژی مورد نیاز، و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد، کتابهای زیادی در شصت و سه درصد گذشته حال و آینده، شناخت فراوان جامعه و متخصصان را می طلبد، تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی، و فرهنگ پیشرو در زبان فارسی ایجاد کرد، در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها، و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی، و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد.</span></p>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ، و با استفاده از طراحان گرافیک است، چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است، و برای شرایط فعلی تکنولوژی مورد نیاز، و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد، کتابهای زیادی در شصت و سه درصد گذشته حال و آینده، شناخت فراوان جامعه و متخصصان را می طلبد، تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی، و فرهنگ پیشرو در زبان فارسی ایجاد کرد، در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها، و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی، و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد.</span></p>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ، و با استفاده از طراحان گرافیک است، چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است، و برای شرایط فعلی تکنولوژی مورد نیاز، و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد، کتابهای زیادی در شصت و سه درصد گذشته حال و آینده، شناخت فراوان جامعه و متخصصان را می طلبد، تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی، و فرهنگ پیشرو در زبان فارسی ایجاد کرد، در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها، و شرایط سخت تایپ به پایان رسد و زمان مورد نیاز شامل حروفچینی دستاوردهای اصلی، و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد.</span></p>\n[/et_pb_text][et_pb_button button_text=\"امروز عضو شوید\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover=\"#7cda24\" button_bg_color__hover_enabled=\"on|hover\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Related Products\" _builder_version=\"3.22\" background_color=\"#f2f5fa\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" border_radii=\"|30px|30px||\" locked=\"off\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\"][et_pb_row _builder_version=\"3.25\" custom_padding=\"||||false|false\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" text_orientation=\"center\" max_width=\"700px\" module_alignment=\"center\" hover_enabled=\"0\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>دیگر سرویس ها</h2>\n[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\" locked=\"off\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"40px|||\" custom_padding_tablet=\"0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px||\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_pricing_tables _builder_version=\"4.4.2\" center_list_items=\"on\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate__hover=\"0px|-70px\" header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" currency_frequency_text_color=\"#a0cf00\" price_text_color=\"rgba(0,0,0,0.75)\" body_text_color=\"#a0cf00\" header_font=\"||||||||\" header_font_size=\"14px\" body_font=\"||||||||\" body_text_align=\"center\" subheader_font=\"|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"||on||||||\" price_font_size=\"50px\" currency_frequency_font=\"|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(255,255,255,0)\" background_color_gradient_end=\"rgba(255,255,255,0.16)\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" animation_style=\"slide\" animation_direction=\"right\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" featured_table_header_background_color=\"#a0cf00\" header_text_color=\"#a0cf00\" subheader_text_color=\"#a0cf00\" price_letter_spacing_last_edited=\"on|desktop\" excluded_text_color=\"#004fe8\" price_line_height=\"100px\" hover_enabled=\"0\"][et_pb_pricing_table title=\"اینترنت پایه\" subtitle=\"1 مگابایت\" currency=\"یک ساله \" per=\"هزارتومان\" sum=\"35\" button_url=\"#\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" hover_enabled=\"0\" pricing_item_excluded_color=\"rgba(255,255,255,0.5)\"]<p>+ گارانتی سرعت</p>\n<p>+ گارنتی کیفیت</p>\n<p>+ نصب در محل</p>\n<p>- تنظیم مودم</p>\n<p>- پشتیبانی 24 ساعته</p>[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#a0cf00\" price_text_color=\"rgba(0,0,0,0.75)\" subheader_text_color=\"#000000\" header_text_color=\"#000000\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"Poppins||||||||\" body_text_align=\"center\" subheader_font=\"Poppins|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"|800|on||||||\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#ffffff\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#008a1c\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" transform_translate_linked__hover=\"off\" custom_margin=\"0px||\" animation_style=\"zoom\" animation_delay=\"100ms\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" border_color_all=\"#ffffff\" border_width_top=\"40px\" border_width_bottom=\"30px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" locked=\"off\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate__hover=\"0px|-70px\"][et_pb_pricing_table title=\"سرویس محبوب\" subtitle=\"65 مگابایت\" currency=\"سالانه\" per=\"هزارتومان\" sum=\"99\" button_url=\"#\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" header_level=\"h2\" header_font=\"||||||||\" body_font=\"VAZIR FARSI||||||||\" subheader_font=\"VAZIR FARSI|800|||||||\" price_font=\"VAZIR FARSI|800|on||||||\" price_font_size=\"50px\" price_line_height=\"100px\" custom_button=\"on\" button_font=\"VAZIR FARSI||||||||\"]<p>+ سرعت دانلود تا 65 مگابایت</p>\n<p>+ دانلود نامحدود</p>\n<p>+ پشتیبانی شبانه روزی</p>\n<p>+ مودم رایگان</p>\n<p>+ نصب رایگان</p>[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"40px|||\" custom_padding_tablet=\"0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|desktop\" padding_tablet=\"0px||\" padding_last_edited=\"on|desktop\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#a0cf00\" price_text_color=\"rgba(0,0,0,0.75)\" body_text_color=\"#a0cf00\" header_font=\"||||||||\" header_font_size=\"14px\" body_font=\"||||||||\" body_text_align=\"center\" subheader_font=\"|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"||on||||||\" price_font_size=\"50px\" currency_frequency_font=\"|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(255,255,255,0)\" background_color_gradient_end=\"rgba(255,255,255,0.16)\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" transform_translate_linked__hover=\"off\" animation_style=\"slide\" animation_direction=\"right\" hover_enabled=\"0\" price_letter_spacing_tablet=\"\" price_letter_spacing_phone=\"\" price_letter_spacing_last_edited=\"on|desktop\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" locked=\"off\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate__hover=\"0px|-70px\" featured_table_header_background_color=\"#a0cf00\" header_text_color=\"#a0cf00\" subheader_text_color=\"#a0cf00\"][et_pb_pricing_table title=\"اینترنت حرفه ای\" subtitle=\"120 مگابایت\" currency=\"یک ساله \" per=\"هزارتومان\" sum=\"900\" button_url=\"#\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" header_level=\"h2\" header_font=\"||||||||\" body_font=\"VAZIR FARSI||||||||\" subheader_font=\"|800|||||||\" price_font=\"VAZIR FARSI||on||||||\" price_letter_spacing=\"0px\" price_line_height=\"100px\" currency_frequency_font=\"|700|on||||||\" currency_frequency_line_height=\"1em\" excluded_text_color=\"#004fe8\" custom_button=\"on\" button_font=\"VAZIR FARSI||||||||\" hover_enabled=\"0\" pricing_item_excluded_color=\"rgba(255,255,255,0.5)\" body_text_color=\"#a0cf00\" bullet_color=\"#a0cf00\"]<p>+ گارانتی سرعت</p>\n<p>+ گارنتی کیفیت</p>\n<p>+ نصب در محل</p>\n<p>- تنظیم مودم</p>\n<p>- پشتیبانی 24 ساعته</p>[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" prev_background_color=\"#ffffff\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#0f1533\" background_color_gradient_end=\"#1f133a\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||5vw\" custom_padding=\"14vw||10vw\" top_divider_style=\"wave2\" top_divider_height=\"10vw\" top_divider_repeat=\"0.7x\" top_divider_flip=\"vertical\" animation_style=\"fade\" border_radii=\"on|30px|30px|30px|30px\" locked=\"off\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_phone=\"\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_2_font=\"|900|on||||||\" header_2_font_size=\"3.5vw\" header_2_letter_spacing=\"2px\" header_2_line_height=\"1.4em\" header_3_font=\"|900|on|on|||||\" header_3_text_color=\"rgba(255,255,255,0.7)\" header_3_font_size=\"1.5vw\" header_3_letter_spacing=\"0.4em\" header_3_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_font_size__hover=\"30px\" header_font_size__hover_enabled=\"30px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h2>سرعت مورد نظر خود را با قیمتی که می خواهید دریافت کنید</h2>\n<h3>سرویس های ADSL  و سرویس های پیامکی</h3>[/et_pb_text][et_pb_button button_text=\"مشاهده تمام سرویس های ما\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#7cda24\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section]", "تک سرویس", "", "inherit", "closed", "closed", "", "2392-revision-v1", "", "", "2020-04-02 17:33:10", "2020-04-02 14:03:10", "", "2392", "http://modelsite.test/2392-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2989", "1", "2020-04-02 17:42:56", "2020-04-02 14:12:56", "[et_pb_section fb_built=\"1\" admin_label=\"Header\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-05.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"5vw||||false\" custom_padding=\"6vw||10vw||false|false\" bottom_divider_style=\"wave2\" bottom_divider_color=\"#ffffff\" bottom_divider_height=\"10vw\" bottom_divider_repeat=\"0.7x\" animation_style=\"slide\" animation_direction=\"bottom\" animation_intensity_slide=\"1%\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_phone=\"\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" animation_style=\"slide\" animation_direction=\"left\" animation_intensity_slide=\"10%\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_font=\"|900|on|on|||||\" header_font_size=\"6vw\" header_letter_spacing=\"0.1em\" header_line_height=\"1.2em\" header_2_font=\"|900|on|on|||||\" header_2_text_color=\"rgba(255,255,255,0.7)\" header_2_font_size=\"3vw\" header_2_letter_spacing=\"0em\" header_2_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" header_font_size_tablet=\"50px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|phone\" header_2_font_size_tablet=\"30px\" header_2_font_size_phone=\"20px\" header_2_font_size_last_edited=\"on|phone\" header_text_shadow_style=\"preset1\" header_text_shadow_vertical_length=\"0.3em\" header_text_shadow_blur_strength=\"0.5em\" header_text_shadow_color=\"rgba(0,0,0,0.15)\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h1>پلان های اینترنت</h1>\n<p>&nbsp;</p>\n<h2><span color=\"rgba(0, 0, 0, 0.701960784313725)\" style=\"color: rgba(0, 0, 0, 0.7);\">شروع از 35 هزارتومان / سالانه</span></h2>[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Features\" _builder_version=\"3.22\"][et_pb_row _builder_version=\"3.25\" custom_padding=\"||||false|false\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#0492ff\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" text_orientation=\"center\" max_width=\"700px\" module_alignment=\"center\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>تمامی سرویس ها شامل:</h2>[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" padding_top_bottom_link_1=\"false\" padding_top_bottom_link_2=\"false\" padding_top_bottom_link_3=\"false\" padding_left_right_link_1=\"true\" padding_left_right_link_2=\"true\" padding_left_right_link_3=\"true\" _builder_version=\"3.25\" max_width=\"1160px\" custom_padding=\"0|0px|27px|0px|false|false\" use_custom_width=\"on\" custom_width_px=\"1160px\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\" max_width__hover=\"1080px\" max_width__hover_enabled=\"1080px\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-03.png\" background_size=\"contain\" background_position=\"bottom_right\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"دریافت سرعت واقعی\" use_icon=\"on\" font_icon=\"%%243%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|hover\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"0deg|42deg|0deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"20 درصد تخفیف\" use_icon=\"on\" font_icon=\"%%171%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"0deg|0deg|25deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-04.png\" background_size=\"contain\" background_position=\"top_right\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"بدون محدودیت حجمی\" use_icon=\"on\" font_icon=\"%%231%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"330deg|0deg|0deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است </span></p>[/et_pb_blurb][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Pricing\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#0f1533\" background_color_gradient_end=\"#1f133a\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||40px||false\" custom_padding=\"80px||80px||true\" animation_style=\"slide\" animation_direction=\"bottom\" animation_intensity_slide=\"1%\" border_radii=\"on|30px|30px|30px|30px\" locked=\"off\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\"][et_pb_row _builder_version=\"3.25\" custom_padding=\"||||false|false\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#0492ff\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" text_orientation=\"center\" background_layout=\"dark\" max_width=\"700px\" module_alignment=\"center\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>سرویس های اینترنت</h2>[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"40px|||\" custom_padding_tablet=\"0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px||\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#ffffff\" price_text_color=\"rgba(0,0,0,0.75)\" body_text_color=\"#ffffff\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"||||||||\" body_text_align=\"center\" subheader_font=\"|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"||on||||||\" price_font_size=\"50px\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(255,255,255,0)\" background_color_gradient_end=\"rgba(255,255,255,0.16)\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" transform_translate_linked__hover=\"off\" animation_style=\"slide\" animation_direction=\"right\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate__hover=\"0px|-70px\"][et_pb_pricing_table title=\"اینترنت پایه\" subtitle=\"1 مگابایت\" currency=\"یک ساله \" per=\"هزارتومان\" sum=\"35\" button_url=\"#\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" header_level=\"h2\" header_font=\"||||||||\" body_font=\"VAZIR FARSI||||||||\" subheader_font=\"|800|||||||\" price_font=\"|800|on||||||\" price_letter_spacing=\"0px\" price_line_height=\"100px\" currency_frequency_font=\"|700|on||||||\" currency_frequency_line_height=\"1em\" excluded_text_color=\"rgba(255,255,255,0.5)\" custom_button=\"on\" button_font=\"VAZIR FARSI||||||||\" pricing_item_excluded_color=\"rgba(255,255,255,0.5)\"]<p>+ گارانتی سرعت</p>\n<p>+ گارنتی کیفیت</p>\n<p>+ نصب در محل</p>\n<p>- تنظیم مودم</p>\n<p>- پشتیبانی 24 ساعته</p>[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_pricing_tables featured_table_header_background_color=\"#ffffff\" featured_table_header_text_color=\"#ffffff\" header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#994ceb\" price_text_color=\"rgba(0,0,0,0.75)\" subheader_text_color=\"#ffffff\" header_text_color=\"#ffffff\" header_font=\"||||||||\" header_font_size=\"14px\" body_font=\"Poppins||||||||\" body_text_align=\"center\" subheader_font=\"|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"|800|on||||||\" currency_frequency_font=\"|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#ffffff\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#8a006e\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" transform_translate_linked__hover=\"off\" custom_margin=\"0px||\" animation_style=\"zoom\" animation_delay=\"100ms\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" border_color_all=\"#ffffff\" border_width_top=\"40px\" border_width_bottom=\"30px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" locked=\"off\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate__hover=\"0px|-70px\"][et_pb_pricing_table title=\"سرویس محبوب\" subtitle=\"65 مگابایت\" currency=\"سالانه\" per=\"هزارتومان\" sum=\"99\" button_url=\"#\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" header_level=\"h2\" header_font=\"||||||||\" body_font=\"VAZIR FARSI||||||||\" subheader_font=\"VAZIR FARSI|800|||||||\" price_font=\"VAZIR FARSI|800|on||||||\" price_font_size=\"50px\" price_line_height=\"100px\" custom_button=\"on\" button_font=\"VAZIR FARSI||||||||\"]<p>+ سرعت دانلود تا 65 مگابایت</p>\n<p>+ دانلود نامحدود</p>\n<p>+ پشتیبانی شبانه روزی</p>\n<p>+ مودم رایگان</p>\n<p>+ نصب رایگان</p>[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"40px|||\" custom_padding_tablet=\"0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|desktop\" padding_tablet=\"0px||\" padding_last_edited=\"on|desktop\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#ffffff\" price_text_color=\"rgba(0,0,0,0.75)\" body_text_color=\"#ffffff\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"||||||||\" body_text_align=\"center\" subheader_font=\"|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"||on||||||\" price_font_size=\"50px\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(255,255,255,0)\" background_color_gradient_end=\"rgba(255,255,255,0.16)\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" transform_translate_linked__hover=\"off\" animation_style=\"slide\" animation_direction=\"right\" price_letter_spacing_tablet=\"\" price_letter_spacing_phone=\"\" price_letter_spacing_last_edited=\"on|desktop\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" locked=\"off\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate__hover=\"0px|-70px\"][et_pb_pricing_table title=\"اینترنت حرفه ای\" subtitle=\"120 مگابایت\" currency=\"یک ساله \" per=\"هزارتومان\" sum=\"900\" button_url=\"#\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" header_level=\"h2\" header_font=\"||||||||\" body_font=\"VAZIR FARSI||||||||\" subheader_font=\"|800|||||||\" price_font=\"VAZIR FARSI||on||||||\" price_letter_spacing=\"0px\" price_line_height=\"100px\" currency_frequency_font=\"|700|on||||||\" currency_frequency_line_height=\"1em\" excluded_text_color=\"rgba(255,255,255,0.5)\" custom_button=\"on\" button_font=\"VAZIR FARSI||||||||\" pricing_item_excluded_color=\"rgba(255,255,255,0.5)\"]<p>+ گارانتی سرعت</p>\n<p>+ گارنتی کیفیت</p>\n<p>+ نصب در محل</p>\n<p>- تنظیم مودم</p>\n<p>- پشتیبانی 24 ساعته</p>[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Info & Bundles\" _builder_version=\"3.22\" background_color=\"#f2f5fa\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row _builder_version=\"3.25\" custom_margin_tablet=\"40px||40px||true\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" text_orientation=\"center\" max_width=\"700px\" module_alignment=\"center\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>کدام سرویس برای شما مناسب است؟</h2>[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_4,1_4,1_4,1_4\" _builder_version=\"3.25\"][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_circle_counter title=\"عادی\" number=\"60mbps\" percent_sign=\"off\" bar_bg_color=\"rgba(48,52,71,0.51)\" _builder_version=\"4.4.2\" title_level=\"h4\" title_font=\"Poppins|700|on||||||\" title_font_size=\"16px\" title_line_height=\"2em\" number_font=\"|700|on||||||\" number_text_color=\"#000000\" number_font_size=\"28px\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\"][/et_pb_circle_counter][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"rgba(48,52,71,0.51)\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"rgba(48,52,71,0.51)\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"rgba(48,52,71,0.51)\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" locked=\"off\"][/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_circle_counter title=\"بازی آنلاین\" number=\"85mbps\" percent_sign=\"off\" bar_bg_color=\"#303447\" _builder_version=\"4.4.2\" title_level=\"h4\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"2em\" number_font=\"|700|on||||||\" number_text_color=\"#000000\" number_font_size=\"28px\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\" locked=\"off\"][/et_pb_circle_counter][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#000000\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#000000\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#000000\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#000000\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" locked=\"off\"][/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_circle_counter title=\"چند کاربره\" number=\"120mbps\" percent_sign=\"off\" bar_bg_color=\"#008a1c\" _builder_version=\"4.4.2\" title_level=\"h4\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"2em\" number_font=\"|700|on||||||\" number_text_color=\"#000000\" number_font_size=\"28px\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\" locked=\"off\"][/et_pb_circle_counter][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#008a1c\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#008a1c\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#008a1c\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" locked=\"off\"][/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_circle_counter title=\"بهترین برای تجاری ها\" number=\"120mbps\" percent_sign=\"off\" _builder_version=\"4.4.2\" title_level=\"h4\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"2em\" number_font=\"|700|on||||||\" number_text_color=\"#000000\" number_font_size=\"28px\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\" locked=\"off\" background__hover_enabled=\"on|hover\" use_background_color_gradient__hover=\"off\" background_color_gradient_start__hover=\"#a0cf00\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_type__hover=\"radial\"][/et_pb_circle_counter][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" locked=\"off\"][/et_pb_blurb][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_button button_text=\"برای انتخاب بیشتر به راهنمایی نیاز دارید؟  1234-021\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover=\"#7cda24\" button_bg_color__hover_enabled=\"on|hover\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" custom_margin=\"100px||\" custom_margin_tablet=\"0px||\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" text_orientation=\"center\" max_width=\"700px\" module_alignment=\"center\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>با بسته های پیامکی بیشتر درآمد کسب کنید</h2>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد</span>.</p>[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"3_5,2_5\" _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"3_5\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/04/isp-11.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" module_alignment=\"center\" custom_margin=\"|||-7vw\" custom_margin_tablet=\"|||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\"][/et_pb_image][/et_pb_column][et_pb_column type=\"2_5\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"قیمت ارزانتر\" url=\"#\" use_icon=\"on\" font_icon=\"%%155%%\" use_circle=\"on\" circle_color=\"#ffffff\" icon_placement=\"left\" use_icon_font_size=\"on\" icon_font_size=\"22px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" background_color=\"#303447\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"20px|20px|20px|20px|true|true\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" background__hover_enabled=\"on\" background_color__hover=\"#008a1c\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][et_pb_blurb title=\"سازگار با تمام گوشی ها\" url=\"#\" use_icon=\"on\" font_icon=\"%%104%%\" use_circle=\"on\" circle_color=\"#ffffff\" icon_placement=\"left\" use_icon_font_size=\"on\" icon_font_size=\"22px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" background_color=\"#303447\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"20px|20px|20px|20px|true|true\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" background__hover_enabled=\"on\" background_color__hover=\"#008a1c\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][et_pb_blurb title=\"ارسال به شماره های مسدود\" url=\"#\" use_icon=\"on\" font_icon=\"%%70%%\" use_circle=\"on\" circle_color=\"#ffffff\" icon_placement=\"left\" use_icon_font_size=\"on\" icon_font_size=\"22px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" background_color=\"#303447\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"20px|20px|20px|20px|true|true\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" background__hover_enabled=\"on\" background_color__hover=\"#008a1c\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_button button_text=\"بسته پیشنهادی خود را ایجاد کنید 1234-021\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover=\"#7cda24\" button_bg_color__hover_enabled=\"on|hover\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" fullwidth=\"on\" _builder_version=\"4.4.2\"][et_pb_fullwidth_header title=\"سرویس های برتر اینترنتی و پیامکی\" button_one_text=\"021-1234\" _builder_version=\"4.4.2\" text_shadow_style=\"preset3\" title_font=\"VAZIR FARSI||||||||\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/Internet-provider1.png\" parallax=\"on\" parallax_method=\"on\" text_orientation=\"right\" header_fullscreen=\"on\" title_text_color=\"#dadada\" hover_enabled=\"0\"]<p>جهت سفارش سرویس های انبوه و دریافت تخفیفات ویژه با ما در تماس باشید </p>\n[/et_pb_fullwidth_header][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"FAQ\" _builder_version=\"3.22\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" max_width__hover=\"100%\" max_width__hover_enabled=\"100%\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" inner_shadow__hover=\"off\" inner_shadow__hover_enabled=\"off\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_row _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>سوالات متداول</h2>[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_toggle title=\"سوال دلخواه را وارد کنید ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||20px\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>جواب دلخواه این سوال را هم اینجا وارد کنید .</p>[/et_pb_toggle][et_pb_toggle title=\"سوال دلخواه را وارد کنید ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||20px\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>جواب دلخواه این سوال را هم اینجا وارد کنید .</p>[/et_pb_toggle][et_pb_toggle title=\"سوال دلخواه را وارد کنید ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||20px\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>جواب دلخواه این سوال را هم اینجا وارد کنید .</p>[/et_pb_toggle][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_toggle title=\"آیا دانلود شبانه رایگان دارید ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||20px\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>سرویس ها نامحدود هستند و نیازی به شبانه رایگان ندارید </p>[/et_pb_toggle][et_pb_toggle title=\"سوال دلخواه را وارد کنید ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||20px\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>جواب دلخواه این سوال را هم اینجا وارد کنید .</p>[/et_pb_toggle][et_pb_toggle title=\"سوال دلخواه را وارد کنید ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||20px\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>جواب دلخواه این سوال را هم اینجا وارد کنید .</p>[/et_pb_toggle][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_button button_text=\"سوال دیگری دارید پیام بفرستید\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover=\"#7cda24\" button_bg_color__hover_enabled=\"on|hover\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" prev_background_color=\"#ffffff\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#0f1533\" background_color_gradient_end=\"#1f133a\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||5vw\" custom_padding=\"14vw||10vw\" top_divider_style=\"wave2\" top_divider_height=\"10vw\" top_divider_repeat=\"0.7x\" top_divider_flip=\"vertical\" animation_style=\"fade\" border_radii=\"on|30px|30px|30px|30px\" locked=\"off\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_phone=\"\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_2_font=\"|900|on||||||\" header_2_font_size=\"3.5vw\" header_2_letter_spacing=\"2px\" header_2_line_height=\"1.4em\" header_3_font=\"|900|on|on|||||\" header_3_text_color=\"rgba(255,255,255,0.7)\" header_3_font_size=\"1.5vw\" header_3_letter_spacing=\"0.4em\" header_3_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_font_size__hover=\"30px\" header_font_size__hover_enabled=\"30px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h2>سرعت مورد نظر خود را با قیمتی که می خواهید دریافت کنید</h2>\n<h3>سرویس های ADSL  و سرویس های پیامکی</h3>[/et_pb_text][et_pb_button button_text=\"مشاهده تمام سرویس های ما\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#7cda24\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section]", "خدمات", "", "inherit", "closed", "closed", "", "899-revision-v1", "", "", "2020-04-02 17:42:56", "2020-04-02 14:12:56", "", "899", "http://modelsite.test/899-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2991", "1", "2020-04-02 17:43:57", "2020-04-02 14:13:57", "[et_pb_section fb_built=\"1\" admin_label=\"Header\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#008a1c\" background_color_gradient_end=\"#a0cf00\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-05.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"5vw||||false\" custom_padding=\"6vw||10vw||false|false\" bottom_divider_style=\"wave2\" bottom_divider_color=\"#ffffff\" bottom_divider_height=\"10vw\" bottom_divider_repeat=\"0.7x\" animation_style=\"slide\" animation_direction=\"bottom\" animation_intensity_slide=\"1%\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_phone=\"\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" animation_style=\"slide\" animation_direction=\"left\" animation_intensity_slide=\"10%\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_font=\"|900|on|on|||||\" header_font_size=\"6vw\" header_letter_spacing=\"0.1em\" header_line_height=\"1.2em\" header_2_font=\"|900|on|on|||||\" header_2_text_color=\"rgba(255,255,255,0.7)\" header_2_font_size=\"3vw\" header_2_letter_spacing=\"0em\" header_2_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" header_font_size_tablet=\"50px\" header_font_size_phone=\"30px\" header_font_size_last_edited=\"on|phone\" header_2_font_size_tablet=\"30px\" header_2_font_size_phone=\"20px\" header_2_font_size_last_edited=\"on|phone\" header_text_shadow_style=\"preset1\" header_text_shadow_vertical_length=\"0.3em\" header_text_shadow_blur_strength=\"0.5em\" header_text_shadow_color=\"rgba(0,0,0,0.15)\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h1>پلان های اینترنت</h1>\n<p>&nbsp;</p>\n<h2><span color=\"rgba(0, 0, 0, 0.701960784313725)\" style=\"color: rgba(0, 0, 0, 0.7);\">شروع از 35 هزارتومان / سالانه</span></h2>[/et_pb_text][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Features\" _builder_version=\"3.22\"][et_pb_row _builder_version=\"3.25\" custom_padding=\"||||false|false\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#0492ff\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" text_orientation=\"center\" max_width=\"700px\" module_alignment=\"center\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>تمامی سرویس ها شامل:</h2>[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" padding_top_bottom_link_1=\"false\" padding_top_bottom_link_2=\"false\" padding_top_bottom_link_3=\"false\" padding_left_right_link_1=\"true\" padding_left_right_link_2=\"true\" padding_left_right_link_3=\"true\" _builder_version=\"3.25\" max_width=\"1160px\" custom_padding=\"0|0px|27px|0px|false|false\" use_custom_width=\"on\" custom_width_px=\"1160px\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\" max_width__hover=\"1080px\" max_width__hover_enabled=\"1080px\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-03.png\" background_size=\"contain\" background_position=\"bottom_right\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"دریافت سرعت واقعی\" use_icon=\"on\" font_icon=\"%%243%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|hover\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"0deg|42deg|0deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"20 درصد تخفیف\" use_icon=\"on\" font_icon=\"%%171%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"0deg|0deg|25deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-04.png\" background_size=\"contain\" background_position=\"top_right\" custom_padding=\"80px|40px|80px|40px\" custom_padding_tablet=\"0px|0px|0px|0px|true|true\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px|0px|0px|0px|true|true\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"بدون محدودیت حجمی\" use_icon=\"on\" font_icon=\"%%231%%\" icon_color=\"#ffffff\" use_circle=\"on\" use_icon_font_size=\"on\" icon_font_size=\"32px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" text_orientation=\"center\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_rotate__hover=\"330deg|0deg|0deg\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است </span></p>[/et_pb_blurb][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Pricing\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#0f1533\" background_color_gradient_end=\"#1f133a\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||40px||false\" custom_padding=\"80px||80px||true\" animation_style=\"slide\" animation_direction=\"bottom\" animation_intensity_slide=\"1%\" border_radii=\"on|30px|30px|30px|30px\" locked=\"off\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\"][et_pb_row _builder_version=\"3.25\" custom_padding=\"||||false|false\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" ul_font=\"||||||||\" ol_font=\"||||||||\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#0492ff\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" header_4_font=\"||||||||\" header_5_font=\"||||||||\" header_6_font=\"||||||||\" text_orientation=\"center\" background_layout=\"dark\" max_width=\"700px\" module_alignment=\"center\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>سرویس های اینترنت</h2>[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_3,1_3,1_3\" use_custom_gutter=\"on\" gutter_width=\"2\" _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"40px|||\" custom_padding_tablet=\"0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|tablet\" padding_tablet=\"0px||\" padding_last_edited=\"on|tablet\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#ffffff\" price_text_color=\"rgba(0,0,0,0.75)\" body_text_color=\"#ffffff\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"||||||||\" body_text_align=\"center\" subheader_font=\"|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"||on||||||\" price_font_size=\"50px\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(255,255,255,0)\" background_color_gradient_end=\"rgba(255,255,255,0.16)\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" transform_translate_linked__hover=\"off\" animation_style=\"slide\" animation_direction=\"right\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate__hover=\"0px|-70px\"][et_pb_pricing_table title=\"اینترنت پایه\" subtitle=\"1 مگابایت\" currency=\"یک ساله \" per=\"هزارتومان\" sum=\"35\" button_url=\"#\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" header_level=\"h2\" header_font=\"||||||||\" body_font=\"VAZIR FARSI||||||||\" subheader_font=\"|800|||||||\" price_font=\"|800|on||||||\" price_letter_spacing=\"0px\" price_line_height=\"100px\" currency_frequency_font=\"|700|on||||||\" currency_frequency_line_height=\"1em\" excluded_text_color=\"rgba(255,255,255,0.5)\" custom_button=\"on\" button_font=\"VAZIR FARSI||||||||\" pricing_item_excluded_color=\"rgba(255,255,255,0.5)\"]<p>+ گارانتی سرعت</p>\n<p>+ گارنتی کیفیت</p>\n<p>+ نصب در محل</p>\n<p>- تنظیم مودم</p>\n<p>- پشتیبانی 24 ساعته</p>[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_pricing_tables featured_table_header_background_color=\"#ffffff\" featured_table_header_text_color=\"#ffffff\" header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#994ceb\" price_text_color=\"rgba(0,0,0,0.75)\" subheader_text_color=\"#ffffff\" header_text_color=\"#ffffff\" header_font=\"||||||||\" header_font_size=\"14px\" body_font=\"Poppins||||||||\" body_text_align=\"center\" subheader_font=\"|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"|800|on||||||\" currency_frequency_font=\"|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#ffffff\" background_color_gradient_end=\"#ffffff\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#8a006e\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" transform_translate_linked__hover=\"off\" custom_margin=\"0px||\" animation_style=\"zoom\" animation_delay=\"100ms\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" border_color_all=\"#ffffff\" border_width_top=\"40px\" border_width_bottom=\"30px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" locked=\"off\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate__hover=\"0px|-70px\"][et_pb_pricing_table title=\"سرویس محبوب\" subtitle=\"65 مگابایت\" currency=\"سالانه\" per=\"هزارتومان\" sum=\"99\" button_url=\"#\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" header_level=\"h2\" header_font=\"||||||||\" body_font=\"VAZIR FARSI||||||||\" subheader_font=\"VAZIR FARSI|800|||||||\" price_font=\"VAZIR FARSI|800|on||||||\" price_font_size=\"50px\" price_line_height=\"100px\" custom_button=\"on\" button_font=\"VAZIR FARSI||||||||\"]<p>+ سرعت دانلود تا 65 مگابایت</p>\n<p>+ دانلود نامحدود</p>\n<p>+ پشتیبانی شبانه روزی</p>\n<p>+ مودم رایگان</p>\n<p>+ نصب رایگان</p>[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][et_pb_column type=\"1_3\" _builder_version=\"3.25\" custom_padding=\"40px|||\" custom_padding_tablet=\"0px||\" custom_padding_phone=\"\" custom_padding_last_edited=\"on|desktop\" padding_tablet=\"0px||\" padding_last_edited=\"on|desktop\" custom_padding__hover=\"|||\"][et_pb_pricing_tables header_background_color=\"rgba(0,0,0,0)\" show_bullet=\"off\" _builder_version=\"4.4.2\" currency_frequency_text_color=\"#ffffff\" price_text_color=\"rgba(0,0,0,0.75)\" body_text_color=\"#ffffff\" header_font=\"Poppins||||||||\" header_font_size=\"14px\" body_font=\"||||||||\" body_text_align=\"center\" subheader_font=\"|800|||||||\" subheader_font_size=\"26px\" subheader_line_height=\"2em\" price_font=\"||on||||||\" price_font_size=\"50px\" currency_frequency_font=\"Poppins|700|on||||||\" background_color=\"rgba(0,0,0,0)\" use_background_color_gradient=\"on\" background_color_gradient_start=\"rgba(255,255,255,0)\" background_color_gradient_end=\"rgba(255,255,255,0.16)\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#000000\" button_bg_color=\"#ffffff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" transform_translate_linked__hover=\"off\" animation_style=\"slide\" animation_direction=\"right\" price_letter_spacing_tablet=\"\" price_letter_spacing_phone=\"\" price_letter_spacing_last_edited=\"on|desktop\" custom_css_pricing_top=\"border: none;||\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.14)\" center_list_items=\"on\" locked=\"off\" transform_styles__hover_enabled=\"on|hover\" transform_scale__hover_enabled=\"on|hover\" transform_translate__hover_enabled=\"on|desktop\" transform_rotate__hover_enabled=\"on|desktop\" transform_skew__hover_enabled=\"on|desktop\" transform_origin__hover_enabled=\"on|desktop\" transform_translate__hover=\"0px|-70px\"][et_pb_pricing_table title=\"اینترنت حرفه ای\" subtitle=\"120 مگابایت\" currency=\"یک ساله \" per=\"هزارتومان\" sum=\"900\" button_url=\"#\" button_text=\"خرید سرویس\" _builder_version=\"4.4.2\" header_level=\"h2\" header_font=\"||||||||\" body_font=\"VAZIR FARSI||||||||\" subheader_font=\"|800|||||||\" price_font=\"VAZIR FARSI||on||||||\" price_letter_spacing=\"0px\" price_line_height=\"100px\" currency_frequency_font=\"|700|on||||||\" currency_frequency_line_height=\"1em\" excluded_text_color=\"rgba(255,255,255,0.5)\" custom_button=\"on\" button_font=\"VAZIR FARSI||||||||\" pricing_item_excluded_color=\"rgba(255,255,255,0.5)\"]<p>+ گارانتی سرعت</p>\n<p>+ گارنتی کیفیت</p>\n<p>+ نصب در محل</p>\n<p>- تنظیم مودم</p>\n<p>- پشتیبانی 24 ساعته</p>[/et_pb_pricing_table][/et_pb_pricing_tables][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"Info & Bundles\" _builder_version=\"3.22\" background_color=\"#f2f5fa\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" border_radii=\"on|30px|30px|30px|30px\"][et_pb_row _builder_version=\"3.25\" custom_margin_tablet=\"40px||40px||true\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" text_orientation=\"center\" max_width=\"700px\" module_alignment=\"center\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>کدام سرویس برای شما مناسب است؟</h2>[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_4,1_4,1_4,1_4\" _builder_version=\"3.25\"][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_circle_counter title=\"عادی\" number=\"60mbps\" percent_sign=\"off\" bar_bg_color=\"rgba(48,52,71,0.51)\" _builder_version=\"4.4.2\" title_level=\"h4\" title_font=\"Poppins|700|on||||||\" title_font_size=\"16px\" title_line_height=\"2em\" number_font=\"|700|on||||||\" number_text_color=\"#000000\" number_font_size=\"28px\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\"][/et_pb_circle_counter][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"rgba(48,52,71,0.51)\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"rgba(48,52,71,0.51)\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"rgba(48,52,71,0.51)\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" locked=\"off\"][/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_circle_counter title=\"بازی آنلاین\" number=\"85mbps\" percent_sign=\"off\" bar_bg_color=\"#303447\" _builder_version=\"4.4.2\" title_level=\"h4\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"2em\" number_font=\"|700|on||||||\" number_text_color=\"#000000\" number_font_size=\"28px\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\" locked=\"off\"][/et_pb_circle_counter][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#000000\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#000000\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#000000\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#000000\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" locked=\"off\"][/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_circle_counter title=\"چند کاربره\" number=\"120mbps\" percent_sign=\"off\" bar_bg_color=\"#008a1c\" _builder_version=\"4.4.2\" title_level=\"h4\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"2em\" number_font=\"|700|on||||||\" number_text_color=\"#000000\" number_font_size=\"28px\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\" locked=\"off\"][/et_pb_circle_counter][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#008a1c\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#008a1c\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_color=\"#008a1c\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" locked=\"off\"][/et_pb_blurb][/et_pb_column][et_pb_column type=\"1_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_circle_counter title=\"بهترین برای تجاری ها\" number=\"120mbps\" percent_sign=\"off\" _builder_version=\"4.4.2\" title_level=\"h4\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"2em\" number_font=\"|700|on||||||\" number_text_color=\"#000000\" number_font_size=\"28px\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\" locked=\"off\" background__hover_enabled=\"on|hover\" use_background_color_gradient__hover=\"off\" background_color_gradient_start__hover=\"#a0cf00\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_type__hover=\"radial\"][/et_pb_circle_counter][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" locked=\"off\"][/et_pb_blurb][et_pb_blurb title=\"عنوان ویژگی\" use_icon=\"on\" font_icon=\"%%202%%\" icon_placement=\"left\" content_max_width=\"1100px\" use_icon_font_size=\"on\" icon_font_size=\"24px\" _builder_version=\"4.4.2\" header_font=\"|500|||||||\" header_font_size=\"14px\" header_line_height=\"1.6em\" custom_margin=\"||20px\" locked=\"off\"][/et_pb_blurb][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_button button_text=\"برای انتخاب بیشتر به راهنمایی نیاز دارید؟  1234-021\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover=\"#7cda24\" button_bg_color__hover_enabled=\"on|hover\"][/et_pb_button][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" custom_margin=\"100px||\" custom_margin_tablet=\"0px||\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" text_orientation=\"center\" max_width=\"700px\" module_alignment=\"center\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\" locked=\"off\"]<h2>با بسته های پیامکی بیشتر درآمد کسب کنید</h2>\n<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد کتابهای زیادی در شصت و سه درصد گذشته حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد</span>.</p>[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"3_5,2_5\" _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"3_5\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_image src=\"http://modelsite.test/wp-content/uploads/2020/04/isp-11.png\" align_tablet=\"center\" align_phone=\"\" align_last_edited=\"on|desktop\" _builder_version=\"3.23\" module_alignment=\"center\" custom_margin=\"|||-7vw\" custom_margin_tablet=\"|||0vw\" custom_margin_phone=\"\" custom_margin_last_edited=\"on|tablet\" animation_style=\"zoom\" animation_intensity_zoom=\"10%\"][/et_pb_image][/et_pb_column][et_pb_column type=\"2_5\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_blurb title=\"قیمت ارزانتر\" url=\"#\" use_icon=\"on\" font_icon=\"%%155%%\" use_circle=\"on\" circle_color=\"#ffffff\" icon_placement=\"left\" use_icon_font_size=\"on\" icon_font_size=\"22px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" background_color=\"#303447\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"20px|20px|20px|20px|true|true\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" background__hover_enabled=\"on\" background_color__hover=\"#008a1c\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][et_pb_blurb title=\"سازگار با تمام گوشی ها\" url=\"#\" use_icon=\"on\" font_icon=\"%%104%%\" use_circle=\"on\" circle_color=\"#ffffff\" icon_placement=\"left\" use_icon_font_size=\"on\" icon_font_size=\"22px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" background_color=\"#303447\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"20px|20px|20px|20px|true|true\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" background__hover_enabled=\"on\" background_color__hover=\"#008a1c\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][et_pb_blurb title=\"ارسال به شماره های مسدود\" url=\"#\" use_icon=\"on\" font_icon=\"%%70%%\" use_circle=\"on\" circle_color=\"#ffffff\" icon_placement=\"left\" use_icon_font_size=\"on\" icon_font_size=\"22px\" _builder_version=\"4.4.2\" header_font=\"|700|on||||||\" header_font_size=\"16px\" header_line_height=\"1.4em\" body_font=\"||||||||\" body_font_size=\"14px\" body_line_height=\"2em\" background_color=\"#303447\" text_orientation=\"center\" background_layout=\"dark\" custom_padding=\"20px|20px|20px|20px|true|true\" border_radii=\"on|15px|15px|15px|15px\" box_shadow_style=\"preset3\" box_shadow_vertical=\"40px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" box_shadow_color=\"rgba(0,46,117,0.12)\" locked=\"off\" header_font_size__hover=\"22px\" header_font_size__hover_enabled=\"22px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_line_height__hover=\"1em\" header_line_height__hover_enabled=\"1em\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" background__hover_enabled=\"on\" background_color__hover=\"#008a1c\"]<p><span>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</span></p>[/et_pb_blurb][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_button button_text=\"بسته پیشنهادی خود را ایجاد کنید 1234-021\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover=\"#7cda24\" button_bg_color__hover_enabled=\"on|hover\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" fullwidth=\"on\" _builder_version=\"4.4.2\"][et_pb_fullwidth_header title=\"سرویس های برتر اینترنتی و پیامکی\" button_one_text=\"021-1234\" _builder_version=\"4.4.2\" text_shadow_style=\"preset3\" title_font=\"VAZIR FARSI||||||||\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/Internet-provider1.png\" parallax=\"on\" parallax_method=\"on\" text_orientation=\"right\" header_fullscreen=\"on\" title_text_color=\"#dadada\" hover_enabled=\"0\" box_shadow_style=\"preset4\" custom_margin=\"50px||||false|false\" border_radii=\"on|50px|50px|50px|50px\"]<p>جهت سفارش سرویس های انبوه و دریافت تخفیفات ویژه با ما در تماس باشید </p>\n[/et_pb_fullwidth_header][/et_pb_section][et_pb_section fb_built=\"1\" admin_label=\"FAQ\" _builder_version=\"3.22\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" max_width__hover=\"100%\" max_width__hover_enabled=\"100%\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" inner_shadow__hover=\"off\" inner_shadow__hover_enabled=\"off\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_row _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" locked=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" text_line_height=\"2em\" header_font=\"||||||||\" header_2_font=\"|700|on||||||\" header_2_font_size=\"36px\" header_2_line_height=\"1.5em\" header_3_font=\"Poppins|500|||||||\" header_3_text_color=\"#008a1c\" header_3_font_size=\"16px\" header_3_line_height=\"1.8em\" max_width=\"700px\" header_2_font_size_tablet=\"\" header_2_font_size_phone=\"26px\" header_2_font_size_last_edited=\"on|phone\"]<h2>سوالات متداول</h2>[/et_pb_text][/et_pb_column][/et_pb_row][et_pb_row column_structure=\"1_2,1_2\" _builder_version=\"3.25\" custom_width_px__hover=\"1080px\" custom_width_px__hover_enabled=\"1080px\" custom_width_percent__hover=\"80%\" custom_width_percent__hover_enabled=\"80%\" gutter_width__hover=\"3\" gutter_width__hover_enabled=\"3\" parallax_1__hover=\"off\" parallax_1__hover_enabled=\"off\" parallax_2__hover=\"off\" parallax_2__hover_enabled=\"off\" parallax_3__hover=\"off\" parallax_3__hover_enabled=\"off\" parallax_4__hover=\"off\" parallax_4__hover_enabled=\"off\" parallax_5__hover=\"off\" parallax_5__hover_enabled=\"off\" parallax_6__hover=\"off\" parallax_6__hover_enabled=\"off\" parallax_method_1__hover=\"on\" parallax_method_1__hover_enabled=\"on\" parallax_method_2__hover=\"on\" parallax_method_2__hover_enabled=\"on\" parallax_method_3__hover=\"on\" parallax_method_3__hover_enabled=\"on\" parallax_method_4__hover=\"on\" parallax_method_4__hover_enabled=\"on\" parallax_method_5__hover=\"on\" parallax_method_5__hover_enabled=\"on\" parallax_method_6__hover=\"on\" parallax_method_6__hover_enabled=\"on\" use_background_color_gradient__hover=\"off\" use_background_color_gradient__hover_enabled=\"off\" background_color_gradient_start__hover=\"#2b87da\" background_color_gradient_start__hover_enabled=\"#2b87da\" background_color_gradient_end__hover=\"#29c4a9\" background_color_gradient_end__hover_enabled=\"#29c4a9\" background_color_gradient_type__hover=\"linear\" background_color_gradient_type__hover_enabled=\"linear\" background_color_gradient_direction__hover=\"180deg\" background_color_gradient_direction__hover_enabled=\"180deg\" background_color_gradient_direction_radial__hover=\"center\" background_color_gradient_direction_radial__hover_enabled=\"center\" background_color_gradient_start_position__hover=\"0%\" background_color_gradient_start_position__hover_enabled=\"0%\" background_color_gradient_end_position__hover=\"100%\" background_color_gradient_end_position__hover_enabled=\"100%\" background_color_gradient_overlays_image__hover=\"off\" background_color_gradient_overlays_image__hover_enabled=\"off\" parallax__hover=\"off\" parallax__hover_enabled=\"off\" parallax_method__hover=\"on\" parallax_method__hover_enabled=\"on\" background_size__hover=\"cover\" background_size__hover_enabled=\"cover\" background_position__hover=\"center\" background_position__hover_enabled=\"center\" background_repeat__hover=\"no-repeat\" background_repeat__hover_enabled=\"no-repeat\" background_blend__hover=\"normal\" background_blend__hover_enabled=\"normal\" allow_player_pause__hover=\"off\" allow_player_pause__hover_enabled=\"off\" background_video_pause_outside_viewport__hover=\"on\" background_video_pause_outside_viewport__hover_enabled=\"on\" make_fullwidth__hover=\"off\" make_fullwidth__hover_enabled=\"off\" use_custom_width__hover=\"off\" use_custom_width__hover_enabled=\"off\" width_unit__hover=\"on\" width_unit__hover_enabled=\"on\" use_custom_gutter__hover=\"off\" use_custom_gutter__hover_enabled=\"off\" make_equal__hover=\"off\" make_equal__hover_enabled=\"off\" border_radii__hover=\"on||||\" border_radii__hover_enabled=\"on||||\" box_shadow_style__hover=\"none\" box_shadow_style__hover_enabled=\"none\" box_shadow_color__hover=\"rgba(0,0,0,0.3)\" box_shadow_color__hover_enabled=\"rgba(0,0,0,0.3)\" filter_hue_rotate__hover=\"0deg\" filter_hue_rotate__hover_enabled=\"0deg\" filter_saturate__hover=\"100%\" filter_saturate__hover_enabled=\"100%\" filter_brightness__hover=\"100%\" filter_brightness__hover_enabled=\"100%\" filter_contrast__hover=\"100%\" filter_contrast__hover_enabled=\"100%\" filter_invert__hover=\"0%\" filter_invert__hover_enabled=\"0%\" filter_sepia__hover=\"0%\" filter_sepia__hover_enabled=\"0%\" filter_opacity__hover=\"100%\" filter_opacity__hover_enabled=\"100%\" filter_blur__hover=\"0px\" filter_blur__hover_enabled=\"0px\" mix_blend_mode__hover=\"normal\" mix_blend_mode__hover_enabled=\"normal\" animation_style__hover=\"none\" animation_style__hover_enabled=\"none\" animation_repeat__hover=\"once\" animation_repeat__hover_enabled=\"once\" animation_direction__hover=\"center\" animation_direction__hover_enabled=\"center\" animation_duration__hover=\"1000ms\" animation_duration__hover_enabled=\"1000ms\" animation_delay__hover=\"0ms\" animation_delay__hover_enabled=\"0ms\" animation_intensity_slide__hover=\"50%\" animation_intensity_slide__hover_enabled=\"50%\" animation_intensity_zoom__hover=\"50%\" animation_intensity_zoom__hover_enabled=\"50%\" animation_intensity_flip__hover=\"50%\" animation_intensity_flip__hover_enabled=\"50%\" animation_intensity_fold__hover=\"50%\" animation_intensity_fold__hover_enabled=\"50%\" animation_intensity_roll__hover=\"50%\" animation_intensity_roll__hover_enabled=\"50%\" animation_starting_opacity__hover=\"0%\" animation_starting_opacity__hover_enabled=\"0%\" animation_speed_curve__hover=\"ease-in-out\" animation_speed_curve__hover_enabled=\"ease-in-out\" hover_transition_duration__hover=\"300ms\" hover_transition_duration__hover_enabled=\"300ms\" hover_transition_delay__hover=\"0ms\" hover_transition_delay__hover_enabled=\"0ms\" hover_transition_speed_curve__hover=\"ease\" hover_transition_speed_curve__hover_enabled=\"ease\"][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_toggle title=\"سوال دلخواه را وارد کنید ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||20px\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>جواب دلخواه این سوال را هم اینجا وارد کنید .</p>[/et_pb_toggle][et_pb_toggle title=\"سوال دلخواه را وارد کنید ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||20px\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>جواب دلخواه این سوال را هم اینجا وارد کنید .</p>[/et_pb_toggle][et_pb_toggle title=\"سوال دلخواه را وارد کنید ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||20px\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>جواب دلخواه این سوال را هم اینجا وارد کنید .</p>[/et_pb_toggle][/et_pb_column][et_pb_column type=\"1_2\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_toggle title=\"آیا دانلود شبانه رایگان دارید ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||20px\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>سرویس ها نامحدود هستند و نیازی به شبانه رایگان ندارید </p>[/et_pb_toggle][et_pb_toggle title=\"سوال دلخواه را وارد کنید ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||20px\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>جواب دلخواه این سوال را هم اینجا وارد کنید .</p>[/et_pb_toggle][et_pb_toggle title=\"سوال دلخواه را وارد کنید ؟\" open_toggle_background_color=\"#ffffff\" closed_toggle_background_color=\"#ffffff\" icon_color=\"#0492ff\" _builder_version=\"4.4.2\" title_level=\"h2\" title_font=\"|700|on||||||\" title_font_size=\"16px\" title_line_height=\"1.6em\" body_font=\"||||||||\" body_line_height=\"2em\" custom_margin=\"||20px\" border_radii=\"on|15px|15px|15px|15px\" border_width_all=\"0px\" locked=\"off\" title_font_size__hover=\"22px\" title_font_size__hover_enabled=\"22px\" title_letter_spacing__hover=\"0px\" title_letter_spacing__hover_enabled=\"0px\" title_line_height__hover=\"1em\" title_line_height__hover_enabled=\"1em\" title_text_shadow_style__hover=\"none\" title_text_shadow_style__hover_enabled=\"none\" title_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" title_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<p>جواب دلخواه این سوال را هم اینجا وارد کنید .</p>[/et_pb_toggle][/et_pb_column][/et_pb_row][et_pb_row _builder_version=\"3.25\" locked=\"off\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_button button_text=\"سوال دیگری دارید پیام بفرستید\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover=\"#7cda24\" button_bg_color__hover_enabled=\"on|hover\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section][et_pb_section fb_built=\"1\" prev_background_color=\"#ffffff\" admin_label=\"Footer\" _builder_version=\"3.22\" use_background_color_gradient=\"on\" background_color_gradient_start=\"#0f1533\" background_color_gradient_end=\"#1f133a\" background_color_gradient_direction=\"147deg\" background_image=\"http://modelsite.test/wp-content/uploads/2020/04/isp-08.png\" parallax=\"on\" max_width=\"90%\" max_width_tablet=\"\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" module_alignment=\"center\" custom_margin=\"||5vw\" custom_padding=\"14vw||10vw\" top_divider_style=\"wave2\" top_divider_height=\"10vw\" top_divider_repeat=\"0.7x\" top_divider_flip=\"vertical\" animation_style=\"fade\" border_radii=\"on|30px|30px|30px|30px\" locked=\"off\"][et_pb_row module_class=\" et_pb_row_fullwidth\" _builder_version=\"3.25\" width=\"89%\" width_tablet=\"80%\" width_phone=\"\" width_last_edited=\"on|desktop\" max_width=\"89%\" max_width_tablet=\"80%\" max_width_phone=\"\" max_width_last_edited=\"on|desktop\" make_fullwidth=\"on\"][et_pb_column type=\"4_4\" _builder_version=\"3.25\" custom_padding=\"|||\" custom_padding__hover=\"|||\"][et_pb_text _builder_version=\"4.4.2\" text_font=\"||||||||\" header_2_font=\"|900|on||||||\" header_2_font_size=\"3.5vw\" header_2_letter_spacing=\"2px\" header_2_line_height=\"1.4em\" header_3_font=\"|900|on|on|||||\" header_3_text_color=\"rgba(255,255,255,0.7)\" header_3_font_size=\"1.5vw\" header_3_letter_spacing=\"0.4em\" header_3_line_height=\"1.4em\" text_orientation=\"center\" background_layout=\"dark\" header_3_font_size__hover=\"22px\" header_3_font_size__hover_enabled=\"22px\" header_3_letter_spacing__hover=\"0px\" header_3_letter_spacing__hover_enabled=\"0px\" header_3_line_height__hover=\"1em\" header_3_line_height__hover_enabled=\"1em\" header_3_text_shadow_style__hover=\"none\" header_3_text_shadow_style__hover_enabled=\"none\" header_3_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_3_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_4_font_size__hover=\"18px\" header_4_font_size__hover_enabled=\"18px\" header_4_letter_spacing__hover=\"0px\" header_4_letter_spacing__hover_enabled=\"0px\" header_4_line_height__hover=\"1em\" header_4_line_height__hover_enabled=\"1em\" header_4_text_shadow_style__hover=\"none\" header_4_text_shadow_style__hover_enabled=\"none\" header_4_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_4_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_5_font_size__hover=\"16px\" header_5_font_size__hover_enabled=\"16px\" header_5_letter_spacing__hover=\"0px\" header_5_letter_spacing__hover_enabled=\"0px\" header_5_line_height__hover=\"1em\" header_5_line_height__hover_enabled=\"1em\" header_5_text_shadow_style__hover=\"none\" header_5_text_shadow_style__hover_enabled=\"none\" header_5_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_5_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_6_font_size__hover=\"14px\" header_6_font_size__hover_enabled=\"14px\" header_6_letter_spacing__hover=\"0px\" header_6_letter_spacing__hover_enabled=\"0px\" header_6_line_height__hover=\"1em\" header_6_line_height__hover_enabled=\"1em\" header_6_text_shadow_style__hover=\"none\" header_6_text_shadow_style__hover_enabled=\"none\" header_6_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_6_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\" header_font_size__hover=\"30px\" header_font_size__hover_enabled=\"30px\" header_letter_spacing__hover=\"0px\" header_letter_spacing__hover_enabled=\"0px\" header_text_shadow_style__hover=\"none\" header_text_shadow_style__hover_enabled=\"none\" header_text_shadow_color__hover=\"rgba(0,0,0,0.4)\" header_text_shadow_color__hover_enabled=\"rgba(0,0,0,0.4)\"]<h2>سرعت مورد نظر خود را با قیمتی که می خواهید دریافت کنید</h2>\n<h3>سرویس های ADSL  و سرویس های پیامکی</h3>[/et_pb_text][et_pb_button button_text=\"مشاهده تمام سرویس های ما\" button_alignment=\"center\" _builder_version=\"4.4.2\" custom_button=\"on\" button_text_size=\"15px\" button_text_color=\"#ffffff\" button_bg_color=\"#0492ff\" button_border_width=\"16px\" button_border_color=\"rgba(0,0,0,0)\" button_border_radius=\"100px\" button_letter_spacing=\"2px\" button_font=\"|700||on|||||\" box_shadow_style=\"preset3\" box_shadow_vertical=\"20px\" box_shadow_blur=\"80px\" box_shadow_spread=\"-20px\" locked=\"off\" button_bg_color__hover_enabled=\"on|hover\" button_bg_color__hover=\"#7cda24\" button_bg_enable_color__hover=\"on\"][/et_pb_button][/et_pb_column][/et_pb_row][/et_pb_section]", "خدمات", "", "inherit", "closed", "closed", "", "899-revision-v1", "", "", "2020-04-02 17:43:57", "2020-04-02 14:13:57", "", "899", "http://modelsite.test/899-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("2993", "1", "2020-04-02 17:45:31", "2020-04-02 14:15:31", "[]", "", "", "trash", "closed", "closed", "", "e734c1b8-67bd-4dba-bd41-5d7cb6a9ed72", "", "", "2020-04-02 17:45:31", "2020-04-02 14:15:31", "", "0", "http://modelsite.test/e734c1b8-67bd-4dba-bd41-5d7cb6a9ed72/", "0", "customize_changeset", "", "0");
INSERT INTO `wp_posts` VALUES("2994", "1", "2020-04-03 13:40:26", "2020-04-03 10:10:26", "{\n    \"et_divi[mobile_menu_link]\": {\n        \"value\": \"#a0cf00\",\n        \"type\": \"option\",\n        \"user_id\": 1,\n        \"date_modified_gmt\": \"2020-04-03 10:10:26\"\n    }\n}", "", "", "trash", "closed", "closed", "", "000a9c0c-2f37-4016-9850-bb160b5a7740", "", "", "2020-04-03 13:40:26", "2020-04-03 10:10:26", "", "0", "http://modelsite.test/000a9c0c-2f37-4016-9850-bb160b5a7740/", "0", "customize_changeset", "", "0");

/* INSERT TABLE DATA: wp_term_relationships */
INSERT INTO `wp_term_relationships` VALUES("8", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("8", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("8", "4", "0");
INSERT INTO `wp_term_relationships` VALUES("167", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("167", "4", "0");
INSERT INTO `wp_term_relationships` VALUES("169", "4", "0");
INSERT INTO `wp_term_relationships` VALUES("171", "4", "0");
INSERT INTO `wp_term_relationships` VALUES("173", "4", "0");
INSERT INTO `wp_term_relationships` VALUES("175", "4", "0");
INSERT INTO `wp_term_relationships` VALUES("257", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("258", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("260", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("281", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("572", "6", "0");
INSERT INTO `wp_term_relationships` VALUES("573", "6", "0");
INSERT INTO `wp_term_relationships` VALUES("574", "6", "0");
INSERT INTO `wp_term_relationships` VALUES("955", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("2449", "5", "0");

/* INSERT TABLE DATA: wp_term_taxonomy */
INSERT INTO `wp_term_taxonomy` VALUES("1", "1", "category", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("2", "2", "post_tag", "", "0", "2");
INSERT INTO `wp_term_taxonomy` VALUES("3", "3", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("4", "4", "category", "", "0", "6");
INSERT INTO `wp_term_taxonomy` VALUES("5", "5", "nav_menu", "", "0", "6");
INSERT INTO `wp_term_taxonomy` VALUES("6", "6", "nav_menu", "", "0", "3");
INSERT INTO `wp_term_taxonomy` VALUES("7", "7", "scope", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("8", "8", "layout_type", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("9", "9", "module_width", "", "0", "0");

/* INSERT TABLE DATA: wp_terms */
INSERT INTO `wp_terms` VALUES("1", "دسته‌بندی نشده", "%d8%af%d8%b3%d8%aa%d9%87%e2%80%8c%d8%a8%d9%86%d8%af%db%8c-%d9%86%d8%b4%d8%af%d9%87", "0");
INSERT INTO `wp_terms` VALUES("2", "تست برچسب وبلاگ", "%d8%aa%d8%b3%d8%aa-%d8%a8%d8%b1%da%86%d8%b3%d8%a8-%d9%88%d8%a8%d9%84%d8%a7%da%af", "0");
INSERT INTO `wp_terms` VALUES("3", "تست دوم برچسب وبلاگ", "%d8%aa%d8%b3%d8%aa-%d8%af%d9%88%d9%85-%d8%a8%d8%b1%da%86%d8%b3%d8%a8-%d9%88%d8%a8%d9%84%d8%a7%da%af", "0");
INSERT INTO `wp_terms` VALUES("4", "دسته وبلاگ", "%d8%af%d8%b3%d8%aa%d9%87-%d9%88%d8%a8%d9%84%d8%a7%da%af", "0");
INSERT INTO `wp_terms` VALUES("5", "فهرست منوی اصلی", "%d9%81%d9%87%d8%b1%d8%b3%d8%aa-%d9%85%d9%86%d9%88%db%8c-%d8%a7%d8%b5%d9%84%db%8c", "0");
INSERT INTO `wp_terms` VALUES("6", "منوی بالا", "%d9%85%d9%86%d9%88%db%8c-%d8%a8%d8%a7%d9%84%d8%a7", "0");
INSERT INTO `wp_terms` VALUES("7", "not_global", "not_global", "0");
INSERT INTO `wp_terms` VALUES("8", "module", "module", "0");
INSERT INTO `wp_terms` VALUES("9", "regular", "regular", "0");

/* INSERT TABLE DATA: wp_usermeta */
INSERT INTO `wp_usermeta` VALUES("1", "1", "nickname", "مدل سایت");
INSERT INTO `wp_usermeta` VALUES("2", "1", "first_name", "");
INSERT INTO `wp_usermeta` VALUES("3", "1", "last_name", "");
INSERT INTO `wp_usermeta` VALUES("4", "1", "description", "");
INSERT INTO `wp_usermeta` VALUES("5", "1", "rich_editing", "true");
INSERT INTO `wp_usermeta` VALUES("6", "1", "syntax_highlighting", "true");
INSERT INTO `wp_usermeta` VALUES("7", "1", "comment_shortcuts", "false");
INSERT INTO `wp_usermeta` VALUES("8", "1", "admin_color", "fresh");
INSERT INTO `wp_usermeta` VALUES("9", "1", "use_ssl", "0");
INSERT INTO `wp_usermeta` VALUES("10", "1", "show_admin_bar_front", "true");
INSERT INTO `wp_usermeta` VALUES("11", "1", "locale", "");
INSERT INTO `wp_usermeta` VALUES("12", "1", "wp_capabilities", "a:1:{s:13:\"administrator\";b:1;}");
INSERT INTO `wp_usermeta` VALUES("13", "1", "wp_user_level", "10");
INSERT INTO `wp_usermeta` VALUES("14", "1", "dismissed_wp_pointers", "text_widget_custom_html");
INSERT INTO `wp_usermeta` VALUES("15", "1", "show_welcome_panel", "1");
INSERT INTO `wp_usermeta` VALUES("16", "1", "session_tokens", "a:3:{s:64:\"7e4a0afda42397ab5448a71aafdb19886a0c06c3efd3cab820c8150d95f9dae6\";a:4:{s:10:\"expiration\";i:1585983162;s:2:\"ip\";s:9:\"127.0.0.1\";s:2:\"ua\";s:115:\"Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/80.0.3987.162 Safari/537.36\";s:5:\"login\";i:1585810362;}s:64:\"99a8e0b0b143e51c72a7f16c86ad3fdb8945b83b0a1133fe5884b66e9d17ee60\";a:4:{s:10:\"expiration\";i:1586004271;s:2:\"ip\";s:9:\"127.0.0.1\";s:2:\"ua\";s:115:\"Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/80.0.3987.162 Safari/537.36\";s:5:\"login\";i:1585831471;}s:64:\"6c24f46be02364f4211c3679f081b2d1886c2dcf2e71025ba6e9e11e56b4e999\";a:4:{s:10:\"expiration\";i:1586080255;s:2:\"ip\";s:9:\"127.0.0.1\";s:2:\"ua\";s:115:\"Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/80.0.3987.162 Safari/537.36\";s:5:\"login\";i:1585907455;}}");
INSERT INTO `wp_usermeta` VALUES("17", "1", "wp_dashboard_quick_press_last_post_id", "2760");
INSERT INTO `wp_usermeta` VALUES("18", "1", "community-events-location", "a:1:{s:2:\"ip\";s:9:\"127.0.0.0\";}");
INSERT INTO `wp_usermeta` VALUES("19", "1", "wp_user-settings", "imgsize=&libraryContent=browse&editor=tinymce");
INSERT INTO `wp_usermeta` VALUES("20", "1", "wp_user-settings-time", "1584704106");
INSERT INTO `wp_usermeta` VALUES("21", "1", "managenav-menuscolumnshidden", "a:5:{i:0;s:11:\"link-target\";i:1;s:11:\"css-classes\";i:2;s:3:\"xfn\";i:3;s:11:\"description\";i:4;s:15:\"title-attribute\";}");
INSERT INTO `wp_usermeta` VALUES("22", "1", "metaboxhidden_nav-menus", "a:5:{i:0;s:21:\"add-post-type-project\";i:1;s:12:\"add-post_tag\";i:2;s:15:\"add-post_format\";i:3;s:20:\"add-project_category\";i:4;s:15:\"add-project_tag\";}");
INSERT INTO `wp_usermeta` VALUES("23", "1", "nav_menu_recently_edited", "5");
INSERT INTO `wp_usermeta` VALUES("24", "1", "wp_r_tru_u_x", "a:2:{s:2:\"id\";s:0:\"\";s:7:\"expires\";i:86400;}");
INSERT INTO `wp_usermeta` VALUES("25", "1", "closedpostboxes_post", "a:1:{i:0;s:30:\"et_settings_meta_box_gutenberg\";}");
INSERT INTO `wp_usermeta` VALUES("26", "1", "metaboxhidden_post", "a:0:{}");

/* INSERT TABLE DATA: wp_users */
INSERT INTO `wp_users` VALUES("1", "admintest", "$P$BUPp9Jv6sMTg8Ff9c05AsRcy48Yc0U0", "admintest", "motekef@gmail.com", "", "2020-03-05 09:52:59", "", "0", "مدل سایت");

SET FOREIGN_KEY_CHECKS = 1; 

/* Duplicator WordPress Timestamp: 2020-04-03 10:11:26*/
/* DUPLICATOR_MYSQLDUMP_EOF */
